/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/telemetry/common/telemetry","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/platform/window/electron-main/window","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/severity","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],ae=function(x){for(var e=[],n=0,r=x.length;n<r;n++)e[n]=oe[x[n]];return e};define(oe[138],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=n,e.$ib=r,e.$jb=S,e.$kb=D,e.$lb=A,e.$mb=I,e.$nb=b,e.$pb=h,e.$qb=f,e.$rb=g,e.$sb=w,e.$tb=l;function n(p,y){const $=r(p,y);if($!==-1)return p[$]}function r(p,y,$=p.length-1){for(let m=$;m>=0;m--){const v=p[m];if(y(v))return m}return-1}function S(p,y){const $=D(p,y);return $===-1?void 0:p[$]}function D(p,y,$=0,m=p.length){let v=$,k=m;for(;v<k;){const t=Math.floor((v+k)/2);y(p[t])?v=t+1:k=t}return v-1}function A(p,y){const $=I(p,y);return $===p.length?void 0:p[$]}function I(p,y,$=0,m=p.length){let v=$,k=m;for(;v<k;){const t=Math.floor((v+k)/2);y(p[t])?k=t:v=t+1}return v}function b(p,y,$=0,m=p.length){const v=I(p,y,$,m);return v===p.length?-1:v}class a{static{this.assertInvariants=!1}constructor(y){this.e=y,this.c=0}findLastMonotonous(y){if(a.assertInvariants){if(this.d){for(const m of this.e)if(this.d(m)&&!y(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=y}const $=D(this.e,y,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$ob=a;function h(p,y){if(p.length===0)return;let $=p[0];for(let m=1;m<p.length;m++){const v=p[m];y(v,$)>0&&($=v)}return $}function f(p,y){if(p.length===0)return;let $=p[0];for(let m=1;m<p.length;m++){const v=p[m];y(v,$)>=0&&($=v)}return $}function g(p,y){return h(p,($,m)=>-y($,m))}function w(p,y){if(p.length===0)return-1;let $=0;for(let m=1;m<p.length;m++){const v=p[m];y(v,p[$])>0&&($=m)}return $}function l(p,y){for(const $ of p){const m=y($);if(m!==void 0)return m}}}),define(oe[39],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(oe[139],ae([0,1]),function(x,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=r,e.$L=S,e.$M=D,e.$N=A;function r(b,a){const h=Object.create(null);for(const f of b){const g=a(f);let w=h[g];w||(w=h[g]=[]),w.push(f)}return h}function S(b,a){const h=[],f=[];for(const g of b)a.has(g)||h.push(g);for(const g of a)b.has(g)||f.push(g);return{removed:h,added:f}}function D(b,a){const h=[],f=[];for(const[g,w]of b)a.has(g)||h.push(w);for(const[g,w]of a)b.has(g)||f.push(w);return{removed:h,added:f}}function A(b,a){const h=new Set;for(const f of a)b.has(f)&&h.add(f);return h}class I{static{n=Symbol.toStringTag}constructor(a,h){this.b=h,this.a=new Map,this[n]="SetWithKey";for(const f of a)this.add(f)}get size(){return this.a.size}add(a){const h=this.b(a);return this.a.set(h,a),this}delete(a){return this.a.delete(this.b(a))}has(a){return this.a.has(this.b(a))}*entries(){for(const a of this.a.values())yield[a,a]}keys(){return this.values()}*values(){for(const a of this.a.values())yield a}clear(){this.a.clear()}forEach(a,h){this.a.forEach(f=>a.call(h,f,f,this))}[Symbol.iterator](){return this.values()}}e.$O=I}),define(oe[140],ae([0,1,39]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ku=e.$ju=e.$iu=e.$hu=void 0;function r(b,a){const h=Math.pow(10,a);return Math.round(b*h)/h}class S{constructor(a,h,f,g=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=r(Math.max(Math.min(1,g),0),3)}static equals(a,h){return a.r===h.r&&a.g===h.g&&a.b===h.b&&a.a===h.a}}e.$hu=S;class D{constructor(a,h,f,g){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=r(Math.max(Math.min(1,h),0),3),this.l=r(Math.max(Math.min(1,f),0),3),this.a=r(Math.max(Math.min(1,g),0),3)}static equals(a,h){return a.h===h.h&&a.s===h.s&&a.l===h.l&&a.a===h.a}static fromRGBA(a){const h=a.r/255,f=a.g/255,g=a.b/255,w=a.a,l=Math.max(h,f,g),p=Math.min(h,f,g);let y=0,$=0;const m=(p+l)/2,v=l-p;if(v>0){switch($=Math.min(m<=.5?v/(2*m):v/(2-2*m),1),l){case h:y=(f-g)/v+(f<g?6:0);break;case f:y=(g-h)/v+2;break;case g:y=(h-f)/v+4;break}y*=60,y=Math.round(y)}return new D(y,$,m,w)}static i(a,h,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?a+(h-a)*6*f:f<1/2?h:f<2/3?a+(h-a)*(2/3-f)*6:a}static toRGBA(a){const h=a.h/360,{s:f,l:g,a:w}=a;let l,p,y;if(f===0)l=p=y=g;else{const $=g<.5?g*(1+f):g+f-g*f,m=2*g-$;l=D.i(m,$,h+1/3),p=D.i(m,$,h),y=D.i(m,$,h-1/3)}return new S(Math.round(l*255),Math.round(p*255),Math.round(y*255),w)}}e.$iu=D;class A{constructor(a,h,f,g){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=r(Math.max(Math.min(1,h),0),3),this.v=r(Math.max(Math.min(1,f),0),3),this.a=r(Math.max(Math.min(1,g),0),3)}static equals(a,h){return a.h===h.h&&a.s===h.s&&a.v===h.v&&a.a===h.a}static fromRGBA(a){const h=a.r/255,f=a.g/255,g=a.b/255,w=Math.max(h,f,g),l=Math.min(h,f,g),p=w-l,y=w===0?0:p/w;let $;return p===0?$=0:w===h?$=((f-g)/p%6+6)%6:w===f?$=(g-h)/p+2:$=(h-f)/p+4,new A(Math.round($*60),y,w,a.a)}static toRGBA(a){const{h,s:f,v:g,a:w}=a,l=g*f,p=l*(1-Math.abs(h/60%2-1)),y=g-l;let[$,m,v]=[0,0,0];return h<60?($=l,m=p):h<120?($=p,m=l):h<180?(m=l,v=p):h<240?(m=p,v=l):h<300?($=p,v=l):h<=360&&($=l,v=p),$=Math.round(($+y)*255),m=Math.round((m+y)*255),v=Math.round((v+y)*255),new S($,m,v,w)}}e.$ju=A;class I{static fromHex(a){return I.Format.CSS.parseHex(a)||I.red}static equals(a,h){return!a&&!h?!0:!a||!h?!1:a.equals(h)}get hsla(){return this.i?this.i:D.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:A.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof S)this.rgba=a;else if(a instanceof D)this.i=a,this.rgba=D.toRGBA(a);else if(a instanceof A)this.j=a,this.rgba=A.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&S.equals(this.rgba,a.rgba)&&D.equals(this.hsla,a.hsla)&&A.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=I.k(this.rgba.r),h=I.k(this.rgba.g),f=I.k(this.rgba.b),g=.2126*a+.7152*h+.0722*f;return r(g,4)}static k(a){const h=a/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(a){const h=this.getRelativeLuminance(),f=a.getRelativeLuminance();return h>f?(h+.05)/(f+.05):(f+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const h=this.getRelativeLuminance(),f=a.getRelativeLuminance();return h>f}isDarkerThan(a){const h=this.getRelativeLuminance(),f=a.getRelativeLuminance();return h<f}lighten(a){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:h,g:f,b:g,a:w}=this.rgba;return new I(new S(h,f,g,w*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new S(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const h=a.rgba,f=this.rgba.a,g=h.a,w=f+g*(1-f);if(w<1e-6)return I.transparent;const l=this.rgba.r*f/w+h.r*g*(1-f)/w,p=this.rgba.g*f/w+h.g*g*(1-f)/w,y=this.rgba.b*f/w+h.b*g*(1-f)/w;return new I(new S(l,p,y,w))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:h,g:f,b:g,a:w}=this.rgba;return new I(new S(a.rgba.r-w*(a.rgba.r-h),a.rgba.g-w*(a.rgba.g-f),a.rgba.b-w*(a.rgba.b-g),1))}flatten(...a){const h=a.reduceRight((f,g)=>I.o(g,f));return I.o(this,h)}static o(a,h){const f=1-a.rgba.a;return new I(new S(f*h.rgba.r+a.rgba.a*a.rgba.r,f*h.rgba.g+a.rgba.a*a.rgba.g,f*h.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(a,h,f){if(a.isLighterThan(h))return a;f=f||.5;const g=a.getRelativeLuminance(),w=h.getRelativeLuminance();return f=f*(w-g)/w,a.lighten(f)}static getDarkerColor(a,h,f){if(a.isDarkerThan(h))return a;f=f||.5;const g=a.getRelativeLuminance(),w=h.getRelativeLuminance();return f=f*(g-w)/g,a.darken(f)}static{this.white=new I(new S(255,255,255,1))}static{this.black=new I(new S(0,0,0,1))}static{this.red=new I(new S(255,0,0,1))}static{this.blue=new I(new S(0,0,255,1))}static{this.green=new I(new S(0,255,0,1))}static{this.cyan=new I(new S(0,255,255,1))}static{this.lightgrey=new I(new S(211,211,211,1))}static{this.transparent=new I(new S(0,0,0,0))}}e.$ku=I,function(b){let a;(function(h){let f;(function(g){function w(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:b.Format.CSS.formatRGBA(i)}g.formatRGB=w;function l(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}g.formatRGBA=l;function p(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(i)}g.formatHSL=p;function y(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}g.formatHSLA=y;function $(i){const c=i.toString(16);return c.length!==2?"0"+c:c}function m(i){return`#${$(i.rgba.r)}${$(i.rgba.g)}${$(i.rgba.b)}`}g.formatHex=m;function v(i,c=!1){return c&&i.rgba.a===1?b.Format.CSS.formatHex(i):`#${$(i.rgba.r)}${$(i.rgba.g)}${$(i.rgba.b)}${$(Math.round(i.rgba.a*255))}`}g.formatHexA=v;function k(i){return i.isOpaque()?b.Format.CSS.formatHex(i):b.Format.CSS.formatRGBA(i)}g.format=k;function t(i){const c=i.length;if(c===0||i.charCodeAt(0)!==n.CharCode.Hash)return null;if(c===7){const s=16*o(i.charCodeAt(1))+o(i.charCodeAt(2)),u=16*o(i.charCodeAt(3))+o(i.charCodeAt(4)),d=16*o(i.charCodeAt(5))+o(i.charCodeAt(6));return new b(new S(s,u,d,1))}if(c===9){const s=16*o(i.charCodeAt(1))+o(i.charCodeAt(2)),u=16*o(i.charCodeAt(3))+o(i.charCodeAt(4)),d=16*o(i.charCodeAt(5))+o(i.charCodeAt(6)),P=16*o(i.charCodeAt(7))+o(i.charCodeAt(8));return new b(new S(s,u,d,P/255))}if(c===4){const s=o(i.charCodeAt(1)),u=o(i.charCodeAt(2)),d=o(i.charCodeAt(3));return new b(new S(16*s+s,16*u+u,16*d+d))}if(c===5){const s=o(i.charCodeAt(1)),u=o(i.charCodeAt(2)),d=o(i.charCodeAt(3)),P=o(i.charCodeAt(4));return new b(new S(16*s+s,16*u+u,16*d+d,(16*P+P)/255))}return null}g.parseHex=t;function o(i){switch(i){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(f=h.CSS||(h.CSS={}))})(a=b.Format||(b.Format={}))}(I||(e.$ku=I={}))}),define(oe[52],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=r,e.$$h=S,e.$_h=D;function n(A){return(I,b,a)=>{let h=null,f=null;if(typeof a.value=="function"?(h="value",f=a.value):typeof a.get=="function"&&(h="get",f=a.get),!f)throw new Error("not supported");a[h]=A(f,b)}}function r(A,I,b){let a=null,h=null;if(typeof b.value=="function"?(a="value",h=b.value,h.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(a="get",h=b.get),!h)throw new Error("not supported");const f=`$memoize$${I}`;b[a]=function(...g){return this.hasOwnProperty(f)||Object.defineProperty(this,f,{configurable:!1,enumerable:!1,writable:!1,value:h.apply(this,g)}),this[f]}}function S(A,I,b){return n((a,h)=>{const f=`$debounce$${h}`,g=`$debounce$result$${h}`;return function(...w){this[g]||(this[g]=b?b():void 0),clearTimeout(this[f]),I&&(this[g]=I(this[g],...w),w=[this[g]]),this[f]=setTimeout(()=>{a.apply(this,w),this[g]=b?b():void 0},A)}})}function D(A,I,b){return n((a,h)=>{const f=`$throttle$timer$${h}`,g=`$throttle$result$${h}`,w=`$throttle$lastRun$${h}`,l=`$throttle$pending$${h}`;return function(...p){if(this[g]||(this[g]=b?b():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),I&&(this[g]=I(this[g],...p)),this[l])return;const y=this[w]+A;y<=Date.now()?(this[w]=Date.now(),a.apply(this,[this[g]]),this[g]=b?b():void 0):(this[l]=!0,this[f]=setTimeout(()=>{this[l]=!1,this[w]=Date.now(),a.apply(this,[this[g]]),this[g]=b?b():void 0},y-Date.now()))}})}}),define(oe[16],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=r,e.$2=S,e.$3=D,e.$4=A,e.$5=I,e.$6=a,e.$8=f,e.$9=g,e.$0=w,e.$_=p;class n{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?v.isErrorNoTelemetry(o)?new v(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(i=>{i(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.$Y=n,e.$Z=new n;function r(t){e.$Z.setUnexpectedErrorHandler(t)}function S(t){if(!t||typeof t!="object")return!1;const o=t;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}function D(t){a(t)||e.$Z.onUnexpectedError(t)}function A(t){a(t)||e.$Z.onUnexpectedExternalError(t)}function I(t){if(t instanceof Error){const{name:o,message:i}=t,c=t.stacktrace||t.stack;return{$isError:!0,name:o,message:i,stack:c,noTelemetry:v.isErrorNoTelemetry(t)}}return t}const b="Canceled";function a(t){return t instanceof h?!0:t instanceof Error&&t.name===b&&t.message===b}class h extends Error{constructor(){super(b),this.name=this.message}}e.$7=h;function f(){const t=new Error(b);return t.name=t.message,t}function g(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}function w(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}class l extends TypeError{constructor(o){super(o?`${o} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=l;function p(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}class y extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.$ab=y;class $ extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.$bb=$;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=m;class v extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof v)return o;const i=new v;return i.message=o.message,i.stack=o.stack,i}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.$db=v;class k extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}e.$eb=k}),define(oe[22],ae([0,1,16,138]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=S,e.$vb=D,e.$wb=A,e.$xb=I,e.$yb=b,e.$zb=a,e.$Ab=h,e.$Bb=f,e.$Cb=g,e.$Db=w,e.$Eb=l,e.$Fb=p,e.$Gb=y,e.top=$,e.$Ib=m,e.$Jb=k,e.$Kb=t,e.$Lb=o,e.$Mb=i,e.$Nb=c,e.$Ob=s,e.$Pb=u,e.$Qb=d,e.$Rb=P,e.$Sb=E,e.$Tb=O,e.$Ub=T,e.$Vb=L,e.$Wb=R,e.$Xb=M,e.$Yb=B,e.$Zb=C,e.$1b=z,e.$2b=ne,e.$3b=Q,e.$4b=ce,e.$5b=K,e.$6b=ee,e.$7b=H,e.$8b=V,e.$9b=le,e.$_b=se;function S(W,q=0){return W[W.length-(1+q)]}function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}function A(W,q,Y=(X,Z)=>X===Z){if(W===q)return!0;if(!W||!q||W.length!==q.length)return!1;for(let X=0,Z=W.length;X<Z;X++)if(!Y(W[X],q[X]))return!1;return!0}function I(W,q){const Y=W.length-1;q<Y&&(W[q]=W[Y]),W.pop()}function b(W,q,Y){return a(W.length,X=>Y(W[X],q))}function a(W,q){let Y=0,X=W-1;for(;Y<=X;){const Z=(Y+X)/2|0,ie=q(Z);if(ie<0)Y=Z+1;else if(ie>0)X=Z-1;else return Z}return-(Y+1)}function h(W,q,Y){if(W=W|0,W>=q.length)throw new TypeError("invalid index");const X=q[Math.floor(q.length*Math.random())],Z=[],ie=[],de=[];for(const me of q){const we=Y(me,X);we<0?Z.push(me):we>0?ie.push(me):de.push(me)}return W<Z.length?h(W,Z,Y):W<Z.length+de.length?de[0]:h(W-(Z.length+de.length),ie,Y)}function f(W,q){const Y=[];let X;for(const Z of W.slice(0).sort(q))!X||q(X[0],Z)!==0?(X=[Z],Y.push(X)):X.push(Z);return Y}function*g(W,q){let Y,X;for(const Z of W)X!==void 0&&q(X,Z)?Y.push(Z):(Y&&(yield Y),Y=[Z]),X=Z;Y&&(yield Y)}function w(W,q){for(let Y=0;Y<=W.length;Y++)q(Y===0?void 0:W[Y-1],Y===W.length?void 0:W[Y])}function l(W,q){for(let Y=0;Y<W.length;Y++)q(Y===0?void 0:W[Y-1],W[Y],Y+1===W.length?void 0:W[Y+1])}function p(W,q,Y){const X=[];function Z(me,we,Ie){if(we===0&&Ie.length===0)return;const ke=X[X.length-1];ke&&ke.start+ke.deleteCount===me?(ke.deleteCount+=we,ke.toInsert.push(...Ie)):X.push({start:me,deleteCount:we,toInsert:Ie})}let ie=0,de=0;for(;;){if(ie===W.length){Z(ie,0,q.slice(de));break}if(de===q.length){Z(ie,W.length-ie,[]);break}const me=W[ie],we=q[de],Ie=Y(me,we);Ie===0?(ie+=1,de+=1):Ie<0?(Z(ie,1,[]),ie+=1):Ie>0&&(Z(ie,0,[we]),de+=1)}return X}function y(W,q,Y){const X=p(W,q,Y),Z=[],ie=[];for(const de of X)Z.push(...W.slice(de.start,de.start+de.deleteCount)),ie.push(...de.toInsert);return{removed:Z,added:ie}}function $(W,q,Y){if(Y===0)return[];const X=W.slice(0,Y).sort(q);return v(W,q,X,Y,W.length),X}function m(W,q,Y,X,Z){return Y===0?Promise.resolve([]):new Promise((ie,de)=>{(async()=>{const me=W.length,we=W.slice(0,Y).sort(q);for(let Ie=Y,ke=Math.min(Y+X,me);Ie<me;Ie=ke,ke=Math.min(ke+X,me)){if(Ie>Y&&await new Promise(Pe=>setTimeout(Pe)),Z&&Z.isCancellationRequested)throw new n.$7;v(W,q,we,Ie,ke)}return we})().then(ie,de)})}function v(W,q,Y,X,Z){for(const ie=Y.length;X<Z;X++){const de=W[X];if(q(de,Y[ie-1])<0){Y.pop();const me=(0,r.$mb)(Y,we=>q(de,we)<0);Y.splice(me,0,de)}}}function k(W){return W.filter(q=>!!q)}function t(W){let q=0;for(let Y=0;Y<W.length;Y++)W[Y]&&(W[q]=W[Y],q+=1);W.length=q}function o(W,q,Y){W.splice(Y,0,W.splice(q,1)[0])}function i(W){return!Array.isArray(W)||W.length===0}function c(W){return Array.isArray(W)&&W.length>0}function s(W,q=Y=>Y){const Y=new Set;return W.filter(X=>{const Z=q(X);return Y.has(Z)?!1:(Y.add(Z),!0)})}function u(W){const q=new Set;return Y=>{const X=W(Y);return q.has(X)?!1:(q.add(X),!0)}}function d(W,q){return W.length>0?W[0]:q}function P(W,q){return W.length>0?W[W.length-1]:q}function E(W,q,Y=(X,Z)=>X===Z){let X=0;for(let Z=0,ie=Math.min(W.length,q.length);Z<ie&&Y(W[Z],q[Z]);Z++)X++;return X}function O(W,q){let Y=typeof q=="number"?W:0;typeof q=="number"?Y=W:(Y=0,q=W);const X=[];if(Y<=q)for(let Z=Y;Z<q;Z++)X.push(Z);else for(let Z=Y;Z>q;Z--)X.push(Z);return X}function T(W,q,Y){return W.reduce((X,Z)=>(X[q(Z)]=Y?Y(Z):Z,X),Object.create(null))}function L(W,q){return W.push(q),()=>R(W,q)}function R(W,q){const Y=W.indexOf(q);if(Y>-1)return W.splice(Y,1),q}function M(W,q,Y){const X=W.slice(0,q),Z=W.slice(q);return X.concat(Y,Z)}function B(W,q){let Y;if(typeof q=="number"){let X=q;Y=()=>{const Z=Math.sin(X++)*179426549;return Z-Math.floor(Z)}}else Y=Math.random;for(let X=W.length-1;X>0;X-=1){const Z=Math.floor(Y()*(X+1)),ie=W[X];W[X]=W[Z],W[Z]=ie}}function C(W,q){const Y=W.indexOf(q);Y>-1&&(W.splice(Y,1),W.unshift(q))}function z(W,q){const Y=W.indexOf(q);Y>-1&&(W.splice(Y,1),W.push(q))}function ne(W,q){for(const Y of q)W.push(Y)}function Q(W,q){return Array.isArray(W)?W.map(q):q(W)}function ce(W){return Array.isArray(W)?W:[W]}function K(W){return W[Math.floor(Math.random()*W.length)]}function ee(W,q,Y){const X=j(W,q),Z=W.length,ie=Y.length;W.length=Z+ie;for(let de=Z-1;de>=X;de--)W[de+ie]=W[de];for(let de=0;de<ie;de++)W[de+X]=Y[de]}function H(W,q,Y,X){const Z=j(W,q);let ie=W.splice(Z,Y);return ie===void 0&&(ie=[]),ee(W,Z,X),ie}function j(W,q){return q<0?Math.max(q+W.length,0):Math.min(q,W.length)}var U;(function(W){function q(ie){return ie<0}W.isLessThan=q;function Y(ie){return ie<=0}W.isLessThanOrEqual=Y;function X(ie){return ie>0}W.isGreaterThan=X;function Z(ie){return ie===0}W.isNeitherLessOrGreaterThan=Z,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(U||(e.CompareResult=U={}));function V(W,q){return(Y,X)=>q(W(Y),W(X))}function le(...W){return(q,Y)=>{for(const X of W){const Z=X(q,Y);if(!U.isNeitherLessOrGreaterThan(Z))return Z}return U.neitherLessOrGreaterThan}}const G=(W,q)=>W-q;e.$0b=G;const he=(W,q)=>(0,e.$0b)(W?1:0,q?1:0);e.$$b=he;function se(W){return(q,Y)=>-W(q,Y)}class _{constructor(q){this.g=q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(q){let Y=this.c;for(;Y<this.g.length&&q(this.g[Y]);)Y++;const X=Y===this.c?null:this.g.slice(this.c,Y);return this.c=Y,X}takeFromEndWhile(q){let Y=this.d;for(;Y>=0&&q(this.g[Y]);)Y--;const X=Y===this.d?null:this.g.slice(Y+1,this.d+1);return this.d=Y,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const q=this.g[this.c];return this.c++,q}removeLast(){const q=this.g[this.d];return this.d--,q}takeCount(q){const Y=this.g.slice(this.c,this.c+q);return this.c+=q,Y}}e.$ac=_;class F{static{this.empty=new F(q=>{})}constructor(q){this.iterate=q}forEach(q){this.iterate(Y=>(q(Y),!0))}toArray(){const q=[];return this.iterate(Y=>(q.push(Y),!0)),q}filter(q){return new F(Y=>this.iterate(X=>q(X)?Y(X):!0))}map(q){return new F(Y=>this.iterate(X=>Y(q(X))))}some(q){let Y=!1;return this.iterate(X=>(Y=q(X),!Y)),Y}findFirst(q){let Y;return this.iterate(X=>q(X)?(Y=X,!1):!0),Y}findLast(q){let Y;return this.iterate(X=>(q(X)&&(Y=X),!0)),Y}findLastMaxBy(q){let Y,X=!0;return this.iterate(Z=>((X||U.isGreaterThan(q(Z,Y)))&&(X=!1,Y=Z),!0)),Y}}e.$bc=F;class N{constructor(q){this.c=q}static createSortPermutation(q,Y){const X=Array.from(q.keys()).sort((Z,ie)=>Y(q[Z],q[ie]));return new N(X)}apply(q){return q.map((Y,X)=>q[this.c[X]])}inverse(){const q=this.c.slice();for(let Y=0;Y<this.c.length;Y++)q[this.c[Y]]=Y;return new N(q)}}e.$cc=N}),define(oe[141],ae([0,1,16]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$gd=S,e.$hd=D,e.$id=A,e.$jd=I,e.$kd=b;function r(a,h){if(!a)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}function S(a,h="Unreachable"){throw new Error(h)}function D(a,h="unexpected state"){if(!a)throw new n.$eb(`Assertion Failed: ${h}`)}function A(a){a||(0,n.$3)(new n.$eb("Soft Assertion Failed"))}function I(a){if(!a()){debugger;a(),(0,n.$3)(new n.$eb("Assertion Failed"))}}function b(a,h){let f=0;for(;f<a.length-1;){const g=a[f],w=a[f+1];if(!h(g,w))return!1;f++}return!0}}),define(oe[90],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=n;function n(r,S){const D=this;let A=!1,I;return function(){if(A)return I;if(A=!0,S)try{I=r.apply(D,arguments)}finally{S()}else I=r.apply(D,arguments);return I}}}),define(oe[76],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(r){function S(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}r.is=S;const D=Object.freeze([]);function A(){return D}r.empty=A;function*I(i){yield i}r.single=I;function b(i){return S(i)?i:I(i)}r.wrap=b;function a(i){return i||D}r.from=a;function*h(i){for(let c=i.length-1;c>=0;c--)yield i[c]}r.reverse=h;function f(i){return!i||i[Symbol.iterator]().next().done===!0}r.isEmpty=f;function g(i){return i[Symbol.iterator]().next().value}r.first=g;function w(i,c){let s=0;for(const u of i)if(c(u,s++))return!0;return!1}r.some=w;function l(i,c){for(const s of i)if(c(s))return s}r.find=l;function*p(i,c){for(const s of i)c(s)&&(yield s)}r.filter=p;function*y(i,c){let s=0;for(const u of i)yield c(u,s++)}r.map=y;function*$(i,c){let s=0;for(const u of i)yield*c(u,s++)}r.flatMap=$;function*m(...i){for(const c of i)yield*c}r.concat=m;function v(i,c,s){let u=s;for(const d of i)u=c(u,d);return u}r.reduce=v;function*k(i,c,s=i.length){for(c<0&&(c+=i.length),s<0?s+=i.length:s>i.length&&(s=i.length);c<s;c++)yield i[c]}r.slice=k;function t(i,c=Number.POSITIVE_INFINITY){const s=[];if(c===0)return[s,i];const u=i[Symbol.iterator]();for(let d=0;d<c;d++){const P=u.next();if(P.done)return[s,r.empty()];s.push(P.value)}return[s,{[Symbol.iterator](){return u}}]}r.consume=t;async function o(i){const c=[];for await(const s of i)c.push(s);return Promise.resolve(c)}r.asyncToArray=o})(n||(e.Iterable=n={}))}),define(oe[43],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Vn=A,e.$Wn=f,e.$Xn=g,e.$Yn=w,e.$Zn=l,e.$1n=p,e.$2n=y,e.$3n=$,e.$4n=m,e.$5n=v,e.$6n=k;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var r;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function A(t,o=!1){let i=0;const c=t.length;let s="",u=0,d=r.Unknown,P=n.None;function E(C){let z=0,ne=0;for(;z<C;){const Q=t.charCodeAt(i);if(Q>=h._0&&Q<=h._9)ne=ne*16+Q-h._0;else if(Q>=h.A&&Q<=h.F)ne=ne*16+Q-h.A+10;else if(Q>=h.a&&Q<=h.f)ne=ne*16+Q-h.a+10;else break;i++,z++}return z<C&&(ne=-1),ne}function O(C){i=C,s="",u=0,d=r.Unknown,P=n.None}function T(){const C=i;if(t.charCodeAt(i)===h._0)i++;else for(i++;i<t.length&&a(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===h.dot)if(i++,i<t.length&&a(t.charCodeAt(i)))for(i++;i<t.length&&a(t.charCodeAt(i));)i++;else return P=n.UnexpectedEndOfNumber,t.substring(C,i);let z=i;if(i<t.length&&(t.charCodeAt(i)===h.E||t.charCodeAt(i)===h.e))if(i++,(i<t.length&&t.charCodeAt(i)===h.plus||t.charCodeAt(i)===h.minus)&&i++,i<t.length&&a(t.charCodeAt(i))){for(i++;i<t.length&&a(t.charCodeAt(i));)i++;z=i}else P=n.UnexpectedEndOfNumber;return t.substring(C,z)}function L(){let C="",z=i;for(;;){if(i>=c){C+=t.substring(z,i),P=n.UnexpectedEndOfString;break}const ne=t.charCodeAt(i);if(ne===h.doubleQuote){C+=t.substring(z,i),i++;break}if(ne===h.backslash){if(C+=t.substring(z,i),i++,i>=c){P=n.UnexpectedEndOfString;break}switch(t.charCodeAt(i++)){case h.doubleQuote:C+='"';break;case h.backslash:C+="\\";break;case h.slash:C+="/";break;case h.b:C+="\b";break;case h.f:C+="\f";break;case h.n:C+=`
`;break;case h.r:C+="\r";break;case h.t:C+="	";break;case h.u:{const ce=E(4);ce>=0?C+=String.fromCharCode(ce):P=n.InvalidUnicode;break}default:P=n.InvalidEscapeCharacter}z=i;continue}if(ne>=0&&ne<=31)if(b(ne)){C+=t.substring(z,i),P=n.UnexpectedEndOfString;break}else P=n.InvalidCharacter;i++}return C}function R(){if(s="",P=n.None,u=i,i>=c)return u=c,d=r.EOF;let C=t.charCodeAt(i);if(I(C)){do i++,s+=String.fromCharCode(C),C=t.charCodeAt(i);while(I(C));return d=r.Trivia}if(b(C))return i++,s+=String.fromCharCode(C),C===h.carriageReturn&&t.charCodeAt(i)===h.lineFeed&&(i++,s+=`
`),d=r.LineBreakTrivia;switch(C){case h.openBrace:return i++,d=r.OpenBraceToken;case h.closeBrace:return i++,d=r.CloseBraceToken;case h.openBracket:return i++,d=r.OpenBracketToken;case h.closeBracket:return i++,d=r.CloseBracketToken;case h.colon:return i++,d=r.ColonToken;case h.comma:return i++,d=r.CommaToken;case h.doubleQuote:return i++,s=L(),d=r.StringLiteral;case h.slash:{const z=i-1;if(t.charCodeAt(i+1)===h.slash){for(i+=2;i<c&&!b(t.charCodeAt(i));)i++;return s=t.substring(z,i),d=r.LineCommentTrivia}if(t.charCodeAt(i+1)===h.asterisk){i+=2;const ne=c-1;let Q=!1;for(;i<ne;){if(t.charCodeAt(i)===h.asterisk&&t.charCodeAt(i+1)===h.slash){i+=2,Q=!0;break}i++}return Q||(i++,P=n.UnexpectedEndOfComment),s=t.substring(z,i),d=r.BlockCommentTrivia}return s+=String.fromCharCode(C),i++,d=r.Unknown}case h.minus:if(s+=String.fromCharCode(C),i++,i===c||!a(t.charCodeAt(i)))return d=r.Unknown;case h._0:case h._1:case h._2:case h._3:case h._4:case h._5:case h._6:case h._7:case h._8:case h._9:return s+=T(),d=r.NumericLiteral;default:for(;i<c&&M(C);)i++,C=t.charCodeAt(i);if(u!==i){switch(s=t.substring(u,i),s){case"true":return d=r.TrueKeyword;case"false":return d=r.FalseKeyword;case"null":return d=r.NullKeyword}return d=r.Unknown}return s+=String.fromCharCode(C),i++,d=r.Unknown}}function M(C){if(I(C)||b(C))return!1;switch(C){case h.closeBrace:case h.closeBracket:case h.openBrace:case h.openBracket:case h.doubleQuote:case h.colon:case h.comma:case h.slash:return!1}return!0}function B(){let C;do C=R();while(C>=r.LineCommentTrivia&&C<=r.Trivia);return C}return{setPosition:O,getPosition:()=>i,scan:o?B:R,getToken:()=>d,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>i-u,getTokenError:()=>P}}function I(t){return t===h.space||t===h.tab||t===h.verticalTab||t===h.formFeed||t===h.nonBreakingSpace||t===h.ogham||t>=h.enQuad&&t<=h.zeroWidthSpace||t===h.narrowNoBreakSpace||t===h.mathematicalSpace||t===h.ideographicSpace||t===h.byteOrderMark}function b(t){return t===h.lineFeed||t===h.carriageReturn||t===h.lineSeparator||t===h.paragraphSeparator}function a(t){return t>=h._0&&t<=h._9}var h;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(h||(h={}));function f(t,o){const i=[],c=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function P(E,O,T,L){u.value=E,u.offset=O,u.length=T,u.type=L,u.colonOffset=void 0,s=u}try{v(t,{onObjectBegin:(E,O)=>{if(o<=E)throw c;s=void 0,d=o>E,i.push("")},onObjectProperty:(E,O,T)=>{if(o<O||(P(E,O,T,"property"),i[i.length-1]=E,o<=O+T))throw c},onObjectEnd:(E,O)=>{if(o<=E)throw c;s=void 0,i.pop()},onArrayBegin:(E,O)=>{if(o<=E)throw c;s=void 0,i.push(0)},onArrayEnd:(E,O)=>{if(o<=E)throw c;s=void 0,i.pop()},onLiteralValue:(E,O,T)=>{if(o<O||(P(E,O,T,k(E)),o<=O+T))throw c},onSeparator:(E,O,T)=>{if(o<=O)throw c;if(E===":"&&s&&s.type==="property")s.colonOffset=O,d=!1,s=void 0;else if(E===","){const L=i[i.length-1];typeof L=="number"?i[i.length-1]=L+1:(d=!0,i[i.length-1]=""),s=void 0}}})}catch(E){if(E!==c)throw E}return{path:i,previousNode:s,isAtPropertyKey:d,matches:E=>{let O=0;for(let T=0;O<E.length&&T<i.length;T++)if(E[O]===i[T]||E[O]==="*")O++;else if(E[O]!=="**")return!1;return O===E.length}}}function g(t,o=[],i=D.DEFAULT){let c=null,s=[];const u=[];function d(E){Array.isArray(s)?s.push(E):c!==null&&(s[c]=E)}return v(t,{onObjectBegin:()=>{const E={};d(E),u.push(s),s=E,c=null},onObjectProperty:E=>{c=E},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const E=[];d(E),u.push(s),s=E,c=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:d,onError:(E,O,T)=>{o.push({error:E,offset:O,length:T})}},i),s[0]}function w(t,o=[],i=D.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(E){c.type==="property"&&(c.length=E-c.offset,c=c.parent)}function u(E){return c.children.push(E),E}v(t,{onObjectBegin:E=>{c=u({type:"object",offset:E,length:-1,parent:c,children:[]})},onObjectProperty:(E,O,T)=>{c=u({type:"property",offset:O,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:E,offset:O,length:T,parent:c})},onObjectEnd:(E,O)=>{c.length=E+O-c.offset,c=c.parent,s(E+O)},onArrayBegin:(E,O)=>{c=u({type:"array",offset:E,length:-1,parent:c,children:[]})},onArrayEnd:(E,O)=>{c.length=E+O-c.offset,c=c.parent,s(E+O)},onLiteralValue:(E,O,T)=>{u({type:k(E),offset:O,length:T,parent:c,value:E}),s(O+T)},onSeparator:(E,O,T)=>{c.type==="property"&&(E===":"?c.colonOffset=O:E===","&&s(O))},onError:(E,O,T)=>{o.push({error:E,offset:O,length:T})}},i);const P=c.children[0];return P&&delete P.parent,P}function l(t,o){if(!t)return;let i=t;for(const c of o)if(typeof c=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const u of i.children)if(Array.isArray(u.children)&&u.children[0].value===c){i=u.children[1],s=!0;break}if(!s)return}else{const s=c;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}function p(t){if(!t.parent||!t.parent.children)return[];const o=p(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;o.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&o.push(i)}return o}function y(t){switch(t.type){case"array":return t.children.map(y);case"object":{const o=Object.create(null);for(const i of t.children){const c=i.children[1];c&&(o[i.children[0].value]=y(c))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,o,i=!1){return o>=t.offset&&o<t.offset+t.length||i&&o===t.offset+t.length}function m(t,o,i=!1){if($(t,o,i)){const c=t.children;if(Array.isArray(c))for(let s=0;s<c.length&&c[s].offset<=o;s++){const u=m(c[s],o,i);if(u)return u}return t}}function v(t,o,i=D.DEFAULT){const c=A(t,!1);function s(V){return V?()=>V(c.getTokenOffset(),c.getTokenLength()):()=>!0}function u(V){return V?le=>V(le,c.getTokenOffset(),c.getTokenLength()):()=>!0}const d=s(o.onObjectBegin),P=u(o.onObjectProperty),E=s(o.onObjectEnd),O=s(o.onArrayBegin),T=s(o.onArrayEnd),L=u(o.onLiteralValue),R=u(o.onSeparator),M=s(o.onComment),B=u(o.onError),C=i&&i.disallowComments,z=i&&i.allowTrailingComma;function ne(){for(;;){const V=c.scan();switch(c.getTokenError()){case n.InvalidUnicode:Q(S.InvalidUnicode);break;case n.InvalidEscapeCharacter:Q(S.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:Q(S.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:C||Q(S.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:Q(S.UnexpectedEndOfString);break;case n.InvalidCharacter:Q(S.InvalidCharacter);break}switch(V){case r.LineCommentTrivia:case r.BlockCommentTrivia:C?Q(S.InvalidCommentToken):M();break;case r.Unknown:Q(S.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return V}}}function Q(V,le=[],G=[]){if(B(V),le.length+G.length>0){let he=c.getToken();for(;he!==r.EOF;){if(le.indexOf(he)!==-1){ne();break}else if(G.indexOf(he)!==-1)break;he=ne()}}}function ce(V){const le=c.getTokenValue();return V?L(le):P(le),ne(),!0}function K(){switch(c.getToken()){case r.NumericLiteral:{let V=0;try{V=JSON.parse(c.getTokenValue()),typeof V!="number"&&(Q(S.InvalidNumberFormat),V=0)}catch{Q(S.InvalidNumberFormat)}L(V);break}case r.NullKeyword:L(null);break;case r.TrueKeyword:L(!0);break;case r.FalseKeyword:L(!1);break;default:return!1}return ne(),!0}function ee(){return c.getToken()!==r.StringLiteral?(Q(S.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(ce(!1),c.getToken()===r.ColonToken?(R(":"),ne(),U()||Q(S.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):Q(S.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function H(){d(),ne();let V=!1;for(;c.getToken()!==r.CloseBraceToken&&c.getToken()!==r.EOF;){if(c.getToken()===r.CommaToken){if(V||Q(S.ValueExpected,[],[]),R(","),ne(),c.getToken()===r.CloseBraceToken&&z)break}else V&&Q(S.CommaExpected,[],[]);ee()||Q(S.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),V=!0}return E(),c.getToken()!==r.CloseBraceToken?Q(S.CloseBraceExpected,[r.CloseBraceToken],[]):ne(),!0}function j(){O(),ne();let V=!1;for(;c.getToken()!==r.CloseBracketToken&&c.getToken()!==r.EOF;){if(c.getToken()===r.CommaToken){if(V||Q(S.ValueExpected,[],[]),R(","),ne(),c.getToken()===r.CloseBracketToken&&z)break}else V&&Q(S.CommaExpected,[],[]);U()||Q(S.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),V=!0}return T(),c.getToken()!==r.CloseBracketToken?Q(S.CloseBracketExpected,[r.CloseBracketToken],[]):ne(),!0}function U(){switch(c.getToken()){case r.OpenBracketToken:return j();case r.OpenBraceToken:return H();case r.StringLiteral:return ce(!0);default:return K()}}return ne(),c.getToken()===r.EOF?i.allowEmptyContent?!0:(Q(S.ValueExpected,[],[]),!1):U()?(c.getToken()!==r.EOF&&Q(S.EndOfFileExpected,[],[]),!0):(Q(S.ValueExpected,[],[]),!1)}function k(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(oe[142],ae([0,1,43]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=r,e.$8n=S,e.$9n=I,e.$0n=b;function r(a,h,f){let g,w,l,p,y;if(h){for(p=h.offset,y=p+h.length,l=p;l>0&&!b(a,l-1);)l--;let P=y;for(;P<a.length&&!b(a,P);)P++;w=a.substring(l,P),g=A(w,f)}else w=a,g=0,l=0,p=0,y=a.length;const $=I(f,a);let m=!1,v=0,k;f.insertSpaces?k=D(" ",f.tabSize||4):k="	";const t=(0,n.$Vn)(w,!1);let o=!1;function i(){return $+D(k,g+v)}function c(){let P=t.scan();for(m=!1;P===n.SyntaxKind.Trivia||P===n.SyntaxKind.LineBreakTrivia;)m=m||P===n.SyntaxKind.LineBreakTrivia,P=t.scan();return o=P===n.SyntaxKind.Unknown||t.getTokenError()!==n.ScanError.None,P}const s=[];function u(P,E,O){!o&&E<y&&O>p&&a.substring(E,O)!==P&&s.push({offset:E,length:O-E,content:P})}let d=c();if(d!==n.SyntaxKind.EOF){const P=t.getTokenOffset()+l,E=D(k,g);u(E,l,P)}for(;d!==n.SyntaxKind.EOF;){let P=t.getTokenOffset()+t.getTokenLength()+l,E=c(),O="";for(;!m&&(E===n.SyntaxKind.LineCommentTrivia||E===n.SyntaxKind.BlockCommentTrivia);){const L=t.getTokenOffset()+l;u(" ",P,L),P=t.getTokenOffset()+t.getTokenLength()+l,O=E===n.SyntaxKind.LineCommentTrivia?i():"",E=c()}if(E===n.SyntaxKind.CloseBraceToken)d!==n.SyntaxKind.OpenBraceToken&&(v--,O=i());else if(E===n.SyntaxKind.CloseBracketToken)d!==n.SyntaxKind.OpenBracketToken&&(v--,O=i());else{switch(d){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:v++,O=i();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:O=i();break;case n.SyntaxKind.BlockCommentTrivia:m?O=i():O=" ";break;case n.SyntaxKind.ColonToken:O=" ";break;case n.SyntaxKind.StringLiteral:if(E===n.SyntaxKind.ColonToken){O="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:E===n.SyntaxKind.LineCommentTrivia||E===n.SyntaxKind.BlockCommentTrivia?O=" ":E!==n.SyntaxKind.CommaToken&&E!==n.SyntaxKind.EOF&&(o=!0);break;case n.SyntaxKind.Unknown:o=!0;break}m&&(E===n.SyntaxKind.LineCommentTrivia||E===n.SyntaxKind.BlockCommentTrivia)&&(O=i())}const T=t.getTokenOffset()+l;u(O,P,T),d=E}return s}function S(a,h){const f=JSON.stringify(a,void 0,h.insertSpaces?h.tabSize||4:"	");return h.eol!==void 0?f.replace(/\r\n|\r|\n/g,h.eol):f}function D(a,h){let f="";for(let g=0;g<h;g++)f+=a;return f}function A(a,h){let f=0,g=0;const w=h.tabSize||4;for(;f<a.length;){const l=a.charAt(f);if(l===" ")g++;else if(l==="	")g+=w;else break;f++}return Math.floor(g/w)}function I(a,h){for(let f=0;f<h.length;f++){const g=h.charAt(f);if(g==="\r")return f+1<h.length&&h.charAt(f+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return a&&a.eol||`
`}function b(a,h){return`\r
`.indexOf(a.charAt(h))!==-1}}),define(oe[108],ae([0,1,43,142]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=S,e.$_n=D,e.$ao=A,e.$bo=I,e.$co=b;function S(a,h,f){return D(a,h,void 0,f)}function D(a,h,f,g,w){const l=h.slice(),p=[],y=(0,n.$Yn)(a,p);let $,m;for(;l.length>0&&(m=l.pop(),$=(0,n.$Zn)(y,l),$===void 0&&f!==void 0);)typeof m=="string"?f={[m]:f}:f=[f];if($)if($.type==="object"&&typeof m=="string"&&Array.isArray($.children)){const v=(0,n.$Zn)($,[m]);if(v!==void 0)if(f===void 0){if(!v.parent)throw new Error("Malformed AST");const k=$.children.indexOf(v.parent);let t,o=v.parent.offset+v.parent.length;if(k>0){const i=$.children[k-1];t=i.offset+i.length}else t=$.offset+1,$.children.length>1&&(o=$.children[1].offset);return A(a,{offset:t,length:o-t,content:""},g)}else return A(a,{offset:v.offset,length:v.length,content:JSON.stringify(f)},g);else{if(f===void 0)return[];const k=`${JSON.stringify(m)}: ${JSON.stringify(f)}`,t=w?w($.children.map(i=>i.children[0].value)):$.children.length;let o;if(t>0){const i=$.children[t-1];o={offset:i.offset+i.length,length:0,content:","+k}}else $.children.length===0?o={offset:$.offset+1,length:0,content:k}:o={offset:$.offset+1,length:0,content:k+","};return A(a,o,g)}}else if($.type==="array"&&typeof m=="number"&&Array.isArray($.children))if(f!==void 0){const v=`${JSON.stringify(f)}`;let k;if($.children.length===0||m===0)k={offset:$.offset+1,length:0,content:$.children.length===0?v:v+","};else{const t=m===-1||m>$.children.length?$.children.length:m,o=$.children[t-1];k={offset:o.offset+o.length,length:0,content:","+v}}return A(a,k,g)}else{const v=m,k=$.children[v];let t;if($.children.length===1)t={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===v){const o=$.children[v-1],i=o.offset+o.length,c=$.offset+$.length;t={offset:i,length:c-2-i,content:""}}else t={offset:k.offset,length:$.children[v+1].offset-k.offset,content:""};return A(a,t,g)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${$.type}`);else return f===void 0?[]:A(a,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(f)},g)}function A(a,h,f){let g=I(a,h),w=h.offset,l=h.offset+h.content.length;if(h.length===0||h.content.length===0){for(;w>0&&!(0,r.$0n)(g,w-1);)w--;for(;l<g.length&&!(0,r.$0n)(g,l);)l++}const p=(0,r.$7n)(g,{offset:w,length:l-w},f);for(let $=p.length-1;$>=0;$--){const m=p[$];g=I(g,m),w=Math.min(w,m.offset),l=Math.max(l,m.offset+m.length),l+=m.content.length-m.length}const y=a.length-(g.length-l)-w;return[{offset:w,length:y,content:g.substring(w,l)}]}function I(a,h){return a.substring(0,h.offset)+h.content+a.substring(h.offset+h.length)}function b(a,h){const f=h.slice(0).sort((w,l)=>{const p=w.offset-l.offset;return p===0?w.length-l.length:p});let g=a.length;for(let w=f.length-1;w>=0;w--){const l=f[w];if(l.offset+l.length<=g)a=I(a,l);else throw new Error("Overlapping edit");g=l.offset}return a}}),function(){function x(e,n,r,S){const D=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function A(b){return b.replace(D,function(a,h,f,g,w,l){if(g)return"";if(w){const p=w.length;return w[p-1]===`
`?w[p-2]==="\r"?`\r
`:`
`:""}else return l?a.substring(1):a})}function I(b){const a=A(b);try{return JSON.parse(a)}catch{const f=a.replace(/,\s*([}\]])/g,"$1");return JSON.parse(f)}}return{stripComments:A,parse:I}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return x()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[65],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class n{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=n}),define(oe[109],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(D){this.element=D,this.next=n.Undefined,this.prev=n.Undefined}}class r{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let D=this.a;for(;D!==n.Undefined;){const A=D.next;D.prev=n.Undefined,D.next=n.Undefined,D=A}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,A){const I=new n(D);if(this.a===n.Undefined)this.a=I,this.b=I;else if(A){const a=this.b;this.b=I,I.prev=a,a.next=I}else{const a=this.a;this.a=I,I.next=a,a.prev=I}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(I))}}shift(){if(this.a!==n.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==n.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==n.Undefined&&D.next!==n.Undefined){const A=D.prev;A.next=D.next,D.next.prev=A}else D.prev===n.Undefined&&D.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):D.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):D.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==n.Undefined;)yield D.element,D=D.next}}e.$7c=r}),define(oe[32],ae([0,1]),function(x,e){"use strict";var n,r,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.Touch=e.$Dc=e.$Cc=void 0,e.$zc=D,e.$Ac=A,e.$Bc=I,e.$Kc=k;function D(t,o,i){let c=t.get(o);return c===void 0&&(c=i,t.set(o,c)),c}function A(t){const o=[];return t.forEach((i,c)=>{o.push(`${c} => ${i}`)}),`Map(${t.size}) {${o.join(", ")}}`}function I(t){const o=[];return t.forEach(i=>{o.push(i)}),`Set(${t.size}) {${o.join(", ")}}`}class b{constructor(o,i){this.uri=o,this.value=i}}function a(t){return Array.isArray(t)}class h{static{this.c=o=>o.toString()}constructor(o,i){if(this[n]="ResourceMap",o instanceof h)this.d=new Map(o.d),this.e=i??h.c;else if(a(o)){this.d=new Map,this.e=i??h.c;for(const[c,s]of o)this.set(c,s)}else this.d=new Map,this.e=o??h.c}set(o,i){return this.d.set(this.e(o),new b(o,i)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,i){typeof i<"u"&&(o=o.bind(i));for(const[c,s]of this.d)o(s.value,s.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}e.$Cc=h;class f{constructor(o,i){this[r]="ResourceSet",!o||typeof o=="function"?this.c=new h(o):(this.c=new h(i),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,i){this.c.forEach((c,s)=>o.call(i,s,s,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Dc=f;var g;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class w{constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,i=g.None){const c=this.c.get(o);if(c)return i!==g.None&&this.m(c,i),c.value}set(o,i,c=g.None){let s=this.c.get(o);if(s)s.value=i,c!==g.None&&this.m(s,c);else{switch(s={key:o,value:i,next:void 0,previous:void 0},c){case g.None:this.k(s);break;case g.AsOld:this.j(s);break;case g.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(o,s),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const i=this.c.get(o);if(i)return this.c.delete(o),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.l(o),this.f--,o.value}forEach(o,i){const c=this.g;let s=this.d;for(;s;){if(i?o.bind(i)(s.value,s.key,this):o(s.value,s.key,this),this.g!==c)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const o=this,i=this.g;let c=this.d;const s={[Symbol.iterator](){return s},next(){if(o.g!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:c.key,done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return s}values(){const o=this,i=this.g;let c=this.d;const s={[Symbol.iterator](){return s},next(){if(o.g!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:c.value,done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return s}entries(){const o=this,i=this.g;let c=this.d;const s={[Symbol.iterator](){return s},next(){if(o.g!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const u={value:[c.key,c.value],done:!1};return c=c.next,u}else return{value:void 0,done:!0}}};return s}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let i=this.d,c=this.size;for(;i&&c>o;)this.c.delete(i.key),i=i.next,c--;this.d=i,this.f=c,i&&(i.previous=void 0),this.g++}i(o){if(o>=this.size)return;if(o===0){this.clear();return}let i=this.e,c=this.size;for(;i&&c>o;)this.c.delete(i.key),i=i.previous,c--;this.e=i,this.f=c,i&&(i.next=void 0),this.g++}j(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}k(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}l(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const i=o.next,c=o.previous;if(!i||!c)throw new Error("Invalid list");i.previous=c,c.next=i}o.next=void 0,o.previous=void 0,this.g++}m(o,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==g.AsOld&&i!==g.AsNew)){if(i===g.AsOld){if(o===this.d)return;const c=o.next,s=o.previous;o===this.e?(s.next=void 0,this.e=s):(c.previous=s,s.next=c),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(i===g.AsNew){if(o===this.e)return;const c=o.next,s=o.previous;o===this.d?(c.previous=void 0,this.d=c):(c.previous=s,s.next=c),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((i,c)=>{o.push([c,i])}),o}fromJSON(o){this.clear();for(const[i,c]of o)this.set(i,c)}}e.$Ec=w;class l extends w{constructor(o,i=1){super(),this.n=o,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(o){this.n=o,this.p()}get ratio(){return this.o}set ratio(o){this.o=Math.min(Math.max(0,o),1),this.p()}get(o,i=g.AsNew){return super.get(o,i)}peek(o){return super.get(o,g.None)}set(o,i){return super.set(o,i,g.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class p extends l{constructor(o,i=1){super(o,i)}q(o){this.h(o)}set(o,i){return super.set(o,i),this.p(),this}}e.$Fc=p;class y extends l{constructor(o,i=1){super(o,i)}q(o){this.i(o)}set(o,i){return this.n<=this.size&&!this.has(o)&&this.q(Math.round(this.n*this.o)-1),super.set(o,i),this}}e.$Gc=y;class ${constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let i=this.c.get(o)||0;return i===0?!1:(i--,i===0?this.c.delete(o):this.c.set(o,i),!0)}has(o){return this.c.has(o)}}e.$Hc=$;class m{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[i,c]of o)this.set(i,c)}clear(){this.c.clear(),this.d.clear()}set(o,i){this.c.set(o,i),this.d.set(i,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const i=this.c.get(o);return i===void 0?!1:(this.c.delete(o),this.d.delete(i),!0)}forEach(o,i){this.c.forEach((c,s)=>{o.call(i,c,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Ic=m;class v{constructor(){this.c=new Map}add(o,i){let c=this.c.get(o);c||(c=new Set,this.c.set(o,c)),c.add(i)}delete(o,i){const c=this.c.get(o);c&&(c.delete(i),c.size===0&&this.c.delete(o))}forEach(o,i){const c=this.c.get(o);c&&c.forEach(i)}get(o){const i=this.c.get(o);return i||new Set}}e.$Jc=v;function k(t,o){if(t===o)return!0;if(t.size!==o.size)return!1;for(const[i,c]of t)if(!o.has(i)||o.get(i)!==c)return!1;for(const[i]of o)if(!t.has(i))return!1;return!0}}),define(oe[2],ae([0,1,22,139,32,90,76]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Lc=void 0,e.$Mc=h,e.$Nc=f,e.$Oc=g,e.$Pc=p,e.$Qc=y,e.$Rc=$,e.$Sc=m,e.$Tc=v,e.$Uc=k,e.$5c=O;const I=!1;let b=null;class a{constructor(){this.b=new Map}static{this.a=0}c(R){let M=this.b.get(R);return M||(M={parent:null,source:null,isSingleton:!1,value:R,idx:a.a++},this.b.set(R,M)),M}trackDisposable(R){const M=this.c(R);M.source||(M.source=new Error().stack)}setParent(R,M){const B=this.c(R);B.parent=M}markAsDisposed(R){this.b.delete(R)}markAsSingleton(R){this.c(R).isSingleton=!0}f(R,M){const B=M.get(R);if(B)return B;const C=R.parent?this.f(this.c(R.parent),M):R;return M.set(R,C),C}getTrackedDisposables(){const R=new Map;return[...this.b.entries()].filter(([,B])=>B.source!==null&&!this.f(B,R).isSingleton).flatMap(([B])=>B)}computeLeakingDisposables(R=10,M){let B;if(M)B=M;else{const ce=new Map,K=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,ce).isSingleton);if(K.length===0)return;const ee=new Set(K.map(H=>H.value));if(B=K.filter(H=>!(H.parent&&ee.has(H.parent))),B.length===0)throw new Error("There are cyclic diposable chains!")}if(!B)return;function C(ce){function K(H,j){for(;H.length>0&&j.some(U=>typeof U=="string"?U===H[0]:H[0].match(U));)H.shift()}const ee=ce.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return K(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const z=new S.$Jc;for(const ce of B){const K=C(ce);for(let ee=0;ee<=K.length;ee++)z.add(K.slice(0,ee).join(`
`),ce)}B.sort((0,n.$8b)(ce=>ce.idx,n.$0b));let ne="",Q=0;for(const ce of B.slice(0,R)){Q++;const K=C(ce),ee=[];for(let H=0;H<K.length;H++){let j=K[H];j=`(shared with ${z.get(K.slice(0,H+1).join(`
`)).size}/${B.length} leaks) at ${j}`;const V=z.get(K.slice(0,H).join(`
`)),le=(0,r.$K)([...V].map(G=>C(G)[H]),G=>G);delete le[K[H]];for(const[G,he]of Object.entries(le))ee.unshift(`    - stacktraces of ${he.length} other leaks continue with ${G}`);ee.unshift(j)}ne+=`


==================== Leaking disposable ${Q}/${B.length}: ${ce.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return B.length>R&&(ne+=`


... and ${B.length-R} more leaking disposables

`),{leaks:B,details:ne}}}e.$Lc=a;function h(L){b=L}if(I){const L="__is_disposable_tracked__";h(new class{trackDisposable(R){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[L]||console.log(M)},3e3)}setParent(R,M){if(R&&R!==o.None)try{R[L]=!0}catch{}}markAsDisposed(R){if(R&&R!==o.None)try{R[L]=!0}catch{}}markAsSingleton(R){}})}function f(L){return b?.trackDisposable(L),L}function g(L){b?.markAsDisposed(L)}function w(L,R){b?.setParent(L,R)}function l(L,R){if(b)for(const M of L)b.setParent(M,R)}function p(L){return b?.markAsSingleton(L),L}function y(L){return typeof L=="object"&&L!==null&&typeof L.dispose=="function"&&L.dispose.length===0}function $(L){if(A.Iterable.is(L)){const R=[];for(const M of L)if(M)try{M.dispose()}catch(B){R.push(B)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}function m(L){for(const R of L)y(R)&&R.dispose();return[]}function v(...L){const R=k(()=>$(L));return l(L,R),R}function k(L){const R=f({dispose:(0,D.$fb)(()=>{g(R),L()})});return R}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,f(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return w(R,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(R),R.dispose()}}deleteAndLeak(R){R&&this.f.has(R)&&(this.f.delete(R),w(R,null))}}e.$Vc=t;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,f(this),w(this.q,this)}dispose(){g(this),this.q.dispose()}B(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(R)}}e.$Wc=o;class i{constructor(){this.b=!1,f(this)}get value(){return this.b?void 0:this.a}set value(R){this.b||R===this.a||(this.a?.dispose(),R&&w(R,this),this.a=R)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const R=this.a;return this.a=void 0,R&&w(R,null),R}}e.$Xc=i;class c{constructor(R){this.a=new i,this.b=!1,this.a.value=R}get value(){return this.a.value}set value(R){this.b||R===this.a.value||(this.a.value=R)}dispose(){this.b=!0,this.a.dispose()}}e.$Yc=c;class s{constructor(R){this.b=R,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Zc=s;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,f(this)}set(R){let M=R;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,g(this))},this}}e.$1c=u;class d{constructor(){this.a=new Map}acquire(R,...M){let B=this.a.get(R);B||(B={counter:0,object:this.b(R,...M)},this.a.set(R,B));const{object:C}=B,z=(0,D.$fb)(()=>{--B.counter===0&&(this.c(R,B.object),this.a.delete(R))});return B.counter++,{object:C,dispose:z}}}e.$2c=d;class P{constructor(R){this.a=R}async acquire(R,...M){const B=this.a.acquire(R,...M);try{return{object:await B.object,dispose:()=>B.dispose()}}catch(C){throw B.dispose(),C}}}e.$3c=P;class E{constructor(R){this.object=R}dispose(){}}e.$4c=E;function O(L){const R=new t;try{L(R)}finally{R.dispose()}}class T{constructor(){this.a=new Map,this.b=!1,f(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(R){return this.a.has(R)}get size(){return this.a.size}get(R){return this.a.get(R)}set(R,M,B=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),B||this.a.get(R)?.dispose(),this.a.set(R,M)}deleteAndDispose(R){this.a.get(R)?.dispose(),this.a.delete(R)}deleteAndLeak(R){const M=this.a.get(R);return this.a.delete(R),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$6c=T}),define(oe[91],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(oe[77],ae([0,1,32]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0,e.$mm=S,e.$nm=A;const r=new n.$Fc(1e4);function S(a){return b(a,"NFC",r)}const D=new n.$Fc(1e4);function A(a){return b(a,"NFD",D)}const I=/[^\u0000-\u0080]/;function b(a,h,f){if(!a)return a;const g=f.get(a);if(g)return g;let w;return I.test(a)?w=a.normalize(h):w=a,f.set(a,w),w}e.$om=function(){const a=/[\u0300-\u036f]/g;return function(h){return A(h).replace(a,"")}}()}),define(oe[143],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=n,e.rot=r,e.$Pm=I;function n(b,a,h){return Math.min(Math.max(b,a),h)}function r(b,a){return(a+b%a)%a}class S{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=S;class D{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=D;class A{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const h=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=h,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=A;function I(b,a,h,f,g,w,l,p){const y=l-h,$=p-f,m=g-h,v=w-f,k=b-h,t=a-f,o=y*y+$*$,i=y*m+$*v,c=y*k+$*t,s=m*m+v*v,u=m*k+v*t,d=1/(o*s-i*i),P=(s*c-i*u)*d,E=(o*u-i*c)*d;return P>=0&&E>=0&&P+E<1}}),function(){function x(S){const D=[];typeof S=="number"&&D.push("code/timeOrigin",S);function A(b){D.push(b,Date.now())}function I(){const b=[];for(let a=0;a<D.length;a+=2)b.push({name:D[a],startTime:D[a+1]});return b}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const A of performance.getEntriesByType("mark"))D.push({name:A.name,startTime:Math.round(S+A.startTime)});return D}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function n(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=n(r))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var r in n)(typeof exports=="object"?exports:x)[r]=n[r]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function n(r){if(e[r])return e[r].exports;var S=e[r]={i:r,l:!1,exports:{}};return x[r].call(S.exports,S,S.exports,n),S.l=!0,S.exports}return n.m=x,n.c=e,n.d=function(r,S,D){n.o(r,S)||Object.defineProperty(r,S,{enumerable:!0,get:D})},n.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},n.t=function(r,S){if(1&S&&(r=n(r)),8&S||4&S&&typeof r=="object"&&r&&r.__esModule)return r;var D=Object.create(null);if(n.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:r}),2&S&&typeof r!="string")for(var A in r)n.d(D,A,function(I){return r[I]}.bind(null,A));return D},n.n=function(r){var S=r&&r.__esModule?function(){return r.default}:function(){return r};return n.d(S,"a",S),S},n.o=function(r,S){return Object.prototype.hasOwnProperty.call(r,S)},n.p="",n(n.s=0)}([function(x,e,n){(function(r){var S;e=x.exports=he,S=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],b=e.src=[],a=0,h=a++;b[h]="0|[1-9]\\d*";var f=a++;b[f]="[0-9]+";var g=a++;b[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=a++;b[w]="("+b[h]+")\\.("+b[h]+")\\.("+b[h]+")";var l=a++;b[l]="("+b[f]+")\\.("+b[f]+")\\.("+b[f]+")";var p=a++;b[p]="(?:"+b[h]+"|"+b[g]+")";var y=a++;b[y]="(?:"+b[f]+"|"+b[g]+")";var $=a++;b[$]="(?:-("+b[p]+"(?:\\."+b[p]+")*))";var m=a++;b[m]="(?:-?("+b[y]+"(?:\\."+b[y]+")*))";var v=a++;b[v]="[0-9A-Za-z-]+";var k=a++;b[k]="(?:\\+("+b[v]+"(?:\\."+b[v]+")*))";var t=a++,o="v?"+b[w]+b[$]+"?"+b[k]+"?";b[t]="^"+o+"$";var i="[v=\\s]*"+b[l]+b[m]+"?"+b[k]+"?",c=a++;b[c]="^"+i+"$";var s=a++;b[s]="((?:<|>)?=?)";var u=a++;b[u]=b[f]+"|x|X|\\*";var d=a++;b[d]=b[h]+"|x|X|\\*";var P=a++;b[P]="[v=\\s]*("+b[d]+")(?:\\.("+b[d]+")(?:\\.("+b[d]+")(?:"+b[$]+")?"+b[k]+"?)?)?";var E=a++;b[E]="[v=\\s]*("+b[u]+")(?:\\.("+b[u]+")(?:\\.("+b[u]+")(?:"+b[m]+")?"+b[k]+"?)?)?";var O=a++;b[O]="^"+b[s]+"\\s*"+b[P]+"$";var T=a++;b[T]="^"+b[s]+"\\s*"+b[E]+"$";var L=a++;b[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=a++;b[R]="(?:~>?)";var M=a++;b[M]="(\\s*)"+b[R]+"\\s+",I[M]=new RegExp(b[M],"g");var B=a++;b[B]="^"+b[R]+b[P]+"$";var C=a++;b[C]="^"+b[R]+b[E]+"$";var z=a++;b[z]="(?:\\^)";var ne=a++;b[ne]="(\\s*)"+b[z]+"\\s+",I[ne]=new RegExp(b[ne],"g");var Q=a++;b[Q]="^"+b[z]+b[P]+"$";var ce=a++;b[ce]="^"+b[z]+b[E]+"$";var K=a++;b[K]="^"+b[s]+"\\s*("+i+")$|^$";var ee=a++;b[ee]="^"+b[s]+"\\s*("+o+")$|^$";var H=a++;b[H]="(\\s*)"+b[s]+"\\s*("+i+"|"+b[P]+")",I[H]=new RegExp(b[H],"g");var j=a++;b[j]="^\\s*("+b[P]+")\\s+-\\s+("+b[P]+")\\s*$";var U=a++;b[U]="^\\s*("+b[E]+")\\s+-\\s+("+b[E]+")\\s*$";var V=a++;b[V]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)S(le,b[le]),I[le]||(I[le]=new RegExp(b[le]));function G(J,ue){if(J instanceof he)return J;if(typeof J!="string"||J.length>D||!(ue?I[c]:I[t]).test(J))return null;try{return new he(J,ue)}catch{return null}}function he(J,ue){if(J instanceof he){if(J.loose===ue)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof he))return new he(J,ue);S("SemVer",J,ue),this.loose=ue;var fe=J.trim().match(ue?I[c]:I[t]);if(!fe)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ae=+be;if(Ae>=0&&Ae<A)return Ae}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=G,e.valid=function(J,ue){var fe=G(J,ue);return fe?fe.version:null},e.clean=function(J,ue){var fe=G(J.trim().replace(/^[=v]+/,""),ue);return fe?fe.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(J){return S("SemVer.compare",this.version,this.loose,J),J instanceof he||(J=new he(J,this.loose)),this.compareMain(J)||this.comparePre(J)},he.prototype.compareMain=function(J){return J instanceof he||(J=new he(J,this.loose)),_(this.major,J.major)||_(this.minor,J.minor)||_(this.patch,J.patch)},he.prototype.comparePre=function(J){if(J instanceof he||(J=new he(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var ue=0;do{var fe=this.prerelease[ue],be=J.prerelease[ue];if(S("prerelease compare",ue,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return _(fe,be)}while(++ue)},he.prototype.inc=function(J,ue){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,ue,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new he(J,fe).inc(ue,be).version}catch{return null}},e.diff=function(J,ue){if(q(J,ue))return null;var fe=G(J),be=G(ue);if(fe.prerelease.length||be.prerelease.length){for(var Ae in fe)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&fe[Ae]!==be[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in fe)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&fe[Ae]!==be[Ae])return Ae},e.compareIdentifiers=_;var se=/^[0-9]+$/;function _(J,ue){var fe=se.test(J),be=se.test(ue);return fe&&be&&(J=+J,ue=+ue),fe&&!be?-1:be&&!fe?1:J<ue?-1:J>ue?1:0}function F(J,ue,fe){return new he(J,fe).compare(new he(ue,fe))}function N(J,ue,fe){return F(J,ue,fe)>0}function W(J,ue,fe){return F(J,ue,fe)<0}function q(J,ue,fe){return F(J,ue,fe)===0}function Y(J,ue,fe){return F(J,ue,fe)!==0}function X(J,ue,fe){return F(J,ue,fe)>=0}function Z(J,ue,fe){return F(J,ue,fe)<=0}function ie(J,ue,fe,be){var Ae;switch(ue){case"===":typeof J=="object"&&(J=J.version),typeof fe=="object"&&(fe=fe.version),Ae=J===fe;break;case"!==":typeof J=="object"&&(J=J.version),typeof fe=="object"&&(fe=fe.version),Ae=J!==fe;break;case"":case"=":case"==":Ae=q(J,fe,be);break;case"!=":Ae=Y(J,fe,be);break;case">":Ae=N(J,fe,be);break;case">=":Ae=X(J,fe,be);break;case"<":Ae=W(J,fe,be);break;case"<=":Ae=Z(J,fe,be);break;default:throw new TypeError("Invalid operator: "+ue)}return Ae}function de(J,ue){if(J instanceof de){if(J.loose===ue)return J;J=J.value}if(!(this instanceof de))return new de(J,ue);S("comparator",J,ue),this.loose=ue,this.parse(J),this.semver===me?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(J,ue){return _(ue,J)},e.major=function(J,ue){return new he(J,ue).major},e.minor=function(J,ue){return new he(J,ue).minor},e.patch=function(J,ue){return new he(J,ue).patch},e.compare=F,e.compareLoose=function(J,ue){return F(J,ue,!0)},e.rcompare=function(J,ue,fe){return F(ue,J,fe)},e.sort=function(J,ue){return J.sort(function(fe,be){return e.compare(fe,be,ue)})},e.rsort=function(J,ue){return J.sort(function(fe,be){return e.rcompare(fe,be,ue)})},e.gt=N,e.lt=W,e.eq=q,e.neq=Y,e.gte=X,e.lte=Z,e.cmp=ie,e.Comparator=de;var me={};function we(J,ue){if(J instanceof we)return J.loose===ue?J:new we(J.raw,ue);if(J instanceof de)return new we(J.value,ue);if(!(this instanceof we))return new we(J,ue);if(this.loose=ue,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ie(J){return!J||J.toLowerCase()==="x"||J==="*"}function ke(J,ue,fe,be,Ae,We,Fe,Oe,Ue,Ve,Je,qe,Ye){return((ue=Ie(fe)?"":Ie(be)?">="+fe+".0.0":Ie(Ae)?">="+fe+"."+be+".0":">="+ue)+" "+(Oe=Ie(Ue)?"":Ie(Ve)?"<"+(+Ue+1)+".0.0":Ie(Je)?"<"+Ue+"."+(+Ve+1)+".0":qe?"<="+Ue+"."+Ve+"."+Je+"-"+qe:"<="+Oe)).trim()}function Pe(J,ue){for(var fe=0;fe<J.length;fe++)if(!J[fe].test(ue))return!1;if(ue.prerelease.length){for(fe=0;fe<J.length;fe++)if(S(J[fe].semver),J[fe].semver!==me&&J[fe].semver.prerelease.length>0){var be=J[fe].semver;if(be.major===ue.major&&be.minor===ue.minor&&be.patch===ue.patch)return!0}return!1}return!0}function De(J,ue,fe){try{ue=new we(ue,fe)}catch{return!1}return ue.test(J)}function $e(J,ue,fe,be){var Ae,We,Fe,Oe,Ue;switch(J=new he(J,be),ue=new we(ue,be),fe){case">":Ae=N,We=Z,Fe=W,Oe=">",Ue=">=";break;case"<":Ae=W,We=X,Fe=N,Oe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(De(J,ue,be))return!1;for(var Ve=0;Ve<ue.set.length;++Ve){var Je=ue.set[Ve],qe=null,Ye=null;if(Je.forEach(function(Xe){Xe.semver===me&&(Xe=new de(">=0.0.0")),qe=qe||Xe,Ye=Ye||Xe,Ae(Xe.semver,qe.semver,be)?qe=Xe:Fe(Xe.semver,Ye.semver,be)&&(Ye=Xe)}),qe.operator===Oe||qe.operator===Ue||(!Ye.operator||Ye.operator===Oe)&&We(J,Ye.semver)||Ye.operator===Ue&&Fe(J,Ye.semver))return!1}return!0}de.prototype.parse=function(J){var ue=this.loose?I[K]:I[ee],fe=J.match(ue);if(!fe)throw new TypeError("Invalid comparator: "+J);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new he(fe[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(J){return S("Comparator.test",J,this.loose),this.semver===me||(typeof J=="string"&&(J=new he(J,this.loose)),ie(J,this.operator,this.semver,this.loose))},de.prototype.intersects=function(J,ue){if(!(J instanceof de))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new we(J.value,ue),De(this.value,fe,ue);if(J.operator==="")return fe=new we(this.value,ue),De(J.semver,fe,ue);var be=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),We=this.semver.version===J.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Oe=ie(this.semver,"<",J.semver,ue)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ue=ie(this.semver,">",J.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return be||Ae||We&&Fe||Oe||Ue},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(J){var ue=this.loose;J=J.trim(),S("range",J,ue);var fe=ue?I[U]:I[j];J=J.replace(fe,ke),S("hyphen replace",J),J=J.replace(I[H],"$1$2$3"),S("comparator trim",J,I[H]),J=(J=(J=J.replace(I[M],"$1~")).replace(I[ne],"$1^")).split(/\s+/).join(" ");var be=ue?I[K]:I[ee],Ae=J.split(" ").map(function(We){return function(Fe,Oe){return S("comp",Fe),Fe=function(Ue,Ve){return Ue.trim().split(/\s+/).map(function(Je){return function(qe,Ye){S("caret",qe,Ye);var Xe=Ye?I[ce]:I[Q];return qe.replace(Xe,function(Ke,Ne,te,ge,pe){var ye;return S("caret",qe,Ke,Ne,te,ge,pe),Ie(Ne)?ye="":Ie(te)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Ie(ge)?ye=Ne==="0"?">="+Ne+"."+te+".0 <"+Ne+"."+(+te+1)+".0":">="+Ne+"."+te+".0 <"+(+Ne+1)+".0.0":pe?(S("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=Ne==="0"?te==="0"?">="+Ne+"."+te+"."+ge+pe+" <"+Ne+"."+te+"."+(+ge+1):">="+Ne+"."+te+"."+ge+pe+" <"+Ne+"."+(+te+1)+".0":">="+Ne+"."+te+"."+ge+pe+" <"+(+Ne+1)+".0.0"):(S("no pr"),ye=Ne==="0"?te==="0"?">="+Ne+"."+te+"."+ge+" <"+Ne+"."+te+"."+(+ge+1):">="+Ne+"."+te+"."+ge+" <"+Ne+"."+(+te+1)+".0":">="+Ne+"."+te+"."+ge+" <"+(+Ne+1)+".0.0"),S("caret return",ye),ye})}(Je,Ve)}).join(" ")}(Fe,Oe),S("caret",Fe),Fe=function(Ue,Ve){return Ue.trim().split(/\s+/).map(function(Je){return function(qe,Ye){var Xe=Ye?I[C]:I[B];return qe.replace(Xe,function(Ke,Ne,te,ge,pe){var ye;return S("tilde",qe,Ke,Ne,te,ge,pe),Ie(Ne)?ye="":Ie(te)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Ie(ge)?ye=">="+Ne+"."+te+".0 <"+Ne+"."+(+te+1)+".0":pe?(S("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=">="+Ne+"."+te+"."+ge+pe+" <"+Ne+"."+(+te+1)+".0"):ye=">="+Ne+"."+te+"."+ge+" <"+Ne+"."+(+te+1)+".0",S("tilde return",ye),ye})}(Je,Ve)}).join(" ")}(Fe,Oe),S("tildes",Fe),Fe=function(Ue,Ve){return S("replaceXRanges",Ue,Ve),Ue.split(/\s+/).map(function(Je){return function(qe,Ye){qe=qe.trim();var Xe=Ye?I[T]:I[O];return qe.replace(Xe,function(Ke,Ne,te,ge,pe,ye){S("xRange",qe,Ke,Ne,te,ge,pe,ye);var Me=Ie(te),Be=Me||Ie(ge),Qe=Be||Ie(pe);return Ne==="="&&Qe&&(Ne=""),Me?Ke=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&Qe?(Be&&(ge=0),Qe&&(pe=0),Ne===">"?(Ne=">=",Be?(te=+te+1,ge=0,pe=0):Qe&&(ge=+ge+1,pe=0)):Ne==="<="&&(Ne="<",Be?te=+te+1:ge=+ge+1),Ke=Ne+te+"."+ge+"."+pe):Be?Ke=">="+te+".0.0 <"+(+te+1)+".0.0":Qe&&(Ke=">="+te+"."+ge+".0 <"+te+"."+(+ge+1)+".0"),S("xRange return",Ke),Ke})}(Je,Ve)}).join(" ")}(Fe,Oe),S("xrange",Fe),Fe=function(Ue,Ve){return S("replaceStars",Ue,Ve),Ue.trim().replace(I[V],"")}(Fe,Oe),S("stars",Fe),Fe}(We,ue)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(We){return!!We.match(be)})),Ae=Ae.map(function(We){return new de(We,ue)})},we.prototype.intersects=function(J,ue){if(!(J instanceof we))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return J.set.some(function(Ae){return Ae.every(function(We){return be.intersects(We,ue)})})})})},e.toComparators=function(J,ue){return new we(J,ue).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},we.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new he(J,this.loose));for(var ue=0;ue<this.set.length;ue++)if(Pe(this.set[ue],J))return!0;return!1},e.satisfies=De,e.maxSatisfying=function(J,ue,fe){var be=null,Ae=null;try{var We=new we(ue,fe)}catch{return null}return J.forEach(function(Fe){We.test(Fe)&&(be&&Ae.compare(Fe)!==-1||(Ae=new he(be=Fe,fe)))}),be},e.minSatisfying=function(J,ue,fe){var be=null,Ae=null;try{var We=new we(ue,fe)}catch{return null}return J.forEach(function(Fe){We.test(Fe)&&(be&&Ae.compare(Fe)!==1||(Ae=new he(be=Fe,fe)))}),be},e.validRange=function(J,ue){try{return new we(J,ue).range||"*"}catch{return null}},e.ltr=function(J,ue,fe){return $e(J,ue,"<",fe)},e.gtr=function(J,ue,fe){return $e(J,ue,">",fe)},e.outside=$e,e.prerelease=function(J,ue){var fe=G(J,ue);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(J,ue,fe){return J=new we(J,fe),ue=new we(ue,fe),J.intersects(ue)},e.coerce=function(J){if(J instanceof he)return J;if(typeof J!="string")return null;var ue=J.match(I[L]);return ue==null?null:G((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,n(1))},function(x,e){var n,r,S=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(y){if(n===setTimeout)return setTimeout(y,0);if((n===D||!n)&&setTimeout)return n=setTimeout,setTimeout(y,0);try{return n(y,0)}catch{try{return n.call(null,y,0)}catch{return n.call(this,y,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:D}catch{n=D}try{r=typeof clearTimeout=="function"?clearTimeout:A}catch{r=A}})();var b,a=[],h=!1,f=-1;function g(){h&&b&&(h=!1,b.length?a=b.concat(a):f=-1,a.length&&w())}function w(){if(!h){var y=I(g);h=!0;for(var $=a.length;$;){for(b=a,a=[];++f<$;)b&&b[f].run();f=-1,$=a.length}b=null,h=!1,function(m){if(r===clearTimeout)return clearTimeout(m);if((r===A||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(m);try{r(m)}catch{try{return r.call(null,m)}catch{return r.call(this,m)}}}(y)}}function l(y,$){this.fun=y,this.array=$}function p(){}S.nextTick=function(y){var $=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)$[m-1]=arguments[m];a.push(new l(y,$)),a.length!==1||h||I(w)},l.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=p,S.addListener=p,S.once=p,S.off=p,S.removeListener=p,S.removeAllListeners=p,S.emit=p,S.prependListener=p,S.prependOnceListener=p,S.listeners=function(y){return[]},S.binding=function(y){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(y){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(oe[144],ae([0,1]),function(x,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;class r{constructor(I,b,a){this.level=I,this.key=b,this.value=a,this.forward=[]}}const S=void 0;class D{constructor(I,b=2**16){this.comparator=I,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(b)|0),this.e=new r(this.c,S,S)}get size(){return this.f}clear(){this.e=new r(this.c,S,S),this.f=0}has(I){return!!D.g(this,I,this.comparator)}get(I){return D.g(this,I,this.comparator)?.value}set(I,b){return D.h(this,I,b,this.comparator)&&(this.f+=1),this}delete(I){const b=D.k(this,I,this.comparator);return b&&(this.f-=1),b}forEach(I,b){let a=this.e.forward[0];for(;a;)I.call(b,a.value,a.key,this),a=a.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",b=this.e.forward[0];for(;b;)I+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return I}static g(I,b,a){let h=I.e;for(let f=I.d-1;f>=0;f--)for(;h.forward[f]&&a(h.forward[f].key,b)<0;)h=h.forward[f];if(h=h.forward[0],h&&a(h.key,b)===0)return h}static h(I,b,a,h){const f=[];let g=I.e;for(let w=I.d-1;w>=0;w--){for(;g.forward[w]&&h(g.forward[w].key,b)<0;)g=g.forward[w];f[w]=g}if(g=g.forward[0],g&&h(g.key,b)===0)return g.value=a,!1;{const w=D.j(I);if(w>I.d){for(let l=I.d;l<w;l++)f[l]=I.e;I.d=w}g=new r(w,b,a);for(let l=0;l<w;l++)g.forward[l]=f[l].forward[l],f[l].forward[l]=g;return!0}}static j(I,b=.5){let a=1;for(;Math.random()<b&&a<I.c;)a+=1;return a}static k(I,b,a){const h=[];let f=I.e;for(let g=I.d-1;g>=0;g--){for(;f.forward[g]&&a(f.forward[g].key,b)<0;)f=f.forward[g];h[g]=f}if(f=f.forward[0],!f||a(f.key,b)!==0)return!1;for(let g=0;g<I.d&&h[g].forward[g]===f;g++)h[g].forward[g]=f.forward[g];for(;I.d>0&&I.e.forward[I.d-1]===S;)I.d-=1;return!0}}e.$Qs=D}),define(oe[66],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(D){return new r(D)}constructor(D){this.c=n&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ge=r}),define(oe[3],ae([0,1,16,90,2,109,66]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$ie=e.Event=void 0,e.$je=w;const I=!1,b=!1,a=!1;var h;(function(C){C.None=()=>S.$Wc.None;function z(ke){if(a){const{onDidAddListener:Pe}=ke,De=p.create();let $e=0;ke.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),De.print()),Pe?.()}}}function ne(ke,Pe){return G(ke,()=>{},0,void 0,!0,void 0,Pe)}C.defer=ne;function Q(ke){return(Pe,De=null,$e)=>{let J=!1,ue;return ue=ke(fe=>{if(!J)return ue?ue.dispose():J=!0,Pe.call(De,fe)},null,$e),J&&ue.dispose(),ue}}C.once=Q;function ce(ke,Pe,De){return V(($e,J=null,ue)=>ke(fe=>$e.call(J,Pe(fe)),null,ue),De)}C.map=ce;function K(ke,Pe,De){return V(($e,J=null,ue)=>ke(fe=>{Pe(fe),$e.call(J,fe)},null,ue),De)}C.forEach=K;function ee(ke,Pe,De){return V(($e,J=null,ue)=>ke(fe=>Pe(fe)&&$e.call(J,fe),null,ue),De)}C.filter=ee;function H(ke){return ke}C.signal=H;function j(...ke){return(Pe,De=null,$e)=>{const J=(0,S.$Tc)(...ke.map(ue=>ue(fe=>Pe.call(De,fe))));return le(J,$e)}}C.any=j;function U(ke,Pe,De,$e){let J=De;return ce(ke,ue=>(J=Pe(J,ue),J),$e)}C.reduce=U;function V(ke,Pe){let De;const $e={onWillAddFirstListener(){De=ke(J.fire,J)},onDidRemoveLastListener(){De?.dispose()}};Pe||z($e);const J=new i($e);return Pe?.add(J),J.event}function le(ke,Pe){return Pe instanceof Array?Pe.push(ke):Pe&&Pe.add(ke),ke}function G(ke,Pe,De=100,$e=!1,J=!1,ue,fe){let be,Ae,We,Fe=0,Oe;const Ue={leakWarningThreshold:ue,onWillAddFirstListener(){be=ke(Je=>{Fe++,Ae=Pe(Ae,Je),$e&&!We&&(Ve.fire(Ae),Ae=void 0),Oe=()=>{const qe=Ae;Ae=void 0,We=void 0,(!$e||Fe>1)&&Ve.fire(qe),Fe=0},typeof De=="number"?(clearTimeout(We),We=setTimeout(Oe,De)):We===void 0&&(We=0,queueMicrotask(Oe))})},onWillRemoveListener(){J&&Fe>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,be.dispose()}};fe||z(Ue);const Ve=new i(Ue);return fe?.add(Ve),Ve.event}C.debounce=G;function he(ke,Pe=0,De){return C.debounce(ke,($e,J)=>$e?($e.push(J),$e):[J],Pe,void 0,!0,void 0,De)}C.accumulate=he;function se(ke,Pe=($e,J)=>$e===J,De){let $e=!0,J;return ee(ke,ue=>{const fe=$e||!Pe(ue,J);return $e=!1,J=ue,fe},De)}C.latch=se;function _(ke,Pe,De){return[C.filter(ke,Pe,De),C.filter(ke,$e=>!Pe($e),De)]}C.split=_;function F(ke,Pe=!1,De=[],$e){let J=De.slice(),ue=ke(Ae=>{J?J.push(Ae):be.fire(Ae)});$e&&$e.add(ue);const fe=()=>{J?.forEach(Ae=>be.fire(Ae)),J=null},be=new i({onWillAddFirstListener(){ue||(ue=ke(Ae=>be.fire(Ae)),$e&&$e.add(ue))},onDidAddFirstListener(){J&&(Pe?setTimeout(fe):fe())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return $e&&$e.add(be),be.event}C.buffer=F;function N(ke,Pe){return($e,J,ue)=>{const fe=Pe(new q);return ke(function(be){const Ae=fe.evaluate(be);Ae!==W&&$e.call(J,Ae)},void 0,ue)}}C.chain=N;const W=Symbol("HaltChainable");class q{constructor(){this.f=[]}map(Pe){return this.f.push(Pe),this}forEach(Pe){return this.f.push(De=>(Pe(De),De)),this}filter(Pe){return this.f.push(De=>Pe(De)?De:W),this}reduce(Pe,De){let $e=De;return this.f.push(J=>($e=Pe($e,J),$e)),this}latch(Pe=(De,$e)=>De===$e){let De=!0,$e;return this.f.push(J=>{const ue=De||!Pe(J,$e);return De=!1,$e=J,ue?J:W}),this}evaluate(Pe){for(const De of this.f)if(Pe=De(Pe),Pe===W)break;return Pe}}function Y(ke,Pe,De=$e=>$e){const $e=(...be)=>fe.fire(De(...be)),J=()=>ke.on(Pe,$e),ue=()=>ke.removeListener(Pe,$e),fe=new i({onWillAddFirstListener:J,onDidRemoveLastListener:ue});return fe.event}C.fromNodeEventEmitter=Y;function X(ke,Pe,De=$e=>$e){const $e=(...be)=>fe.fire(De(...be)),J=()=>ke.addEventListener(Pe,$e),ue=()=>ke.removeEventListener(Pe,$e),fe=new i({onWillAddFirstListener:J,onDidRemoveLastListener:ue});return fe.event}C.fromDOMEventEmitter=X;function Z(ke){return new Promise(Pe=>Q(ke)(Pe))}C.toPromise=Z;function ie(ke){const Pe=new i;return ke.then(De=>{Pe.fire(De)},()=>{Pe.fire(void 0)}).finally(()=>{Pe.dispose()}),Pe.event}C.fromPromise=ie;function de(ke,Pe,De){return Pe(De),ke($e=>Pe($e))}C.runAndSubscribe=de;class me{constructor(Pe,De){this._observable=Pe,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};De||z($e),this.emitter=new i($e),De&&De.add(this.emitter)}beginUpdate(Pe){this.f++}handlePossibleChange(Pe){}handleChange(Pe,De){this.g=!0}endUpdate(Pe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(ke,Pe){return new me(ke,Pe).emitter.event}C.fromObservable=we;function Ie(ke){return(Pe,De,$e)=>{let J=0,ue=!1;const fe={beginUpdate(){J++},endUpdate(){J--,J===0&&(ke.reportChanges(),ue&&(ue=!1,Pe.call(De)))},handlePossibleChange(){},handleChange(){ue=!0}};ke.addObserver(fe),ke.reportChanges();const be={dispose(){ke.removeObserver(fe)}};return $e instanceof S.$Vc?$e.add(be):Array.isArray($e)&&$e.push(be),be}}C.fromObservableLight=Ie})(h||(e.Event=h={}));class f{static{this.all=new Set}static{this.f=0}constructor(z){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${z}_${f.f++}`,f.all.add(this)}start(z){this.g=new A.$ge,this.listenerCount=z}stop(){if(this.g){const z=this.g.elapsed();this.durations.push(z),this.elapsedOverall+=z,this.invocationCount+=1,this.g=void 0}}}e.$ie=f;let g=-1;function w(C){const z=g;return g=C,{dispose(){g=z}}}class l{static{this.f=1}constructor(z,ne,Q=(l.f++).toString(16).padStart(3,"0")){this.j=z,this.threshold=ne,this.name=Q,this.h=0}dispose(){this.g?.clear()}check(z,ne){const Q=this.threshold;if(Q<=0||ne<Q)return;this.g||(this.g=new Map);const ce=this.g.get(z.value)||0;if(this.g.set(z.value,ce+1),this.h-=1,this.h<=0){this.h=Q*.5;const[K,ee]=this.getMostFrequentStack(),H=`[${this.name}] potential listener LEAK detected, having ${ne} listeners already. MOST frequent listener (${ee}):`;console.warn(H),console.warn(K);const j=new y(H,K);this.j(j)}return()=>{const K=this.g.get(z.value)||0;this.g.set(z.value,K-1)}}getMostFrequentStack(){if(!this.g)return;let z,ne=0;for(const[Q,ce]of this.g)(!z||ne<ce)&&(z=[Q,ce],ne=ce);return z}}class p{static create(){const z=new Error;return new p(z.stack??"")}constructor(z){this.value=z}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y extends Error{constructor(z,ne){super(z),this.name="ListenerLeakError",this.stack=ne}}e.$ke=y;class $ extends Error{constructor(z,ne){super(z),this.name="ListenerRefusalError",this.stack=ne}}e.$le=$;let m=0;class v{constructor(z){this.value=z,this.id=m++}}const k=2,t=(C,z)=>{if(C instanceof v)z(C);else for(let ne=0;ne<C.length;ne++){const Q=C[ne];Q&&z(Q)}};let o;if(I){const C=[];setInterval(()=>{C.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(C.join(`
`)),C.length=0)},3e3),o=new FinalizationRegistry(z=>{typeof z=="string"&&C.push(z)})}class i{constructor(z){this.z=0,this.f=z,this.g=g>0||this.f?.leakWarningThreshold?new l(z?.onListenerError??n.$3,this.f?.leakWarningThreshold??g):void 0,this.j=this.f?._profName?new f(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(b){const z=this.u;queueMicrotask(()=>{t(z,ne=>ne.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(z,ne,Q)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const U=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],V=new $(`${j}. HINT: Stack shows most frequent listener (${U[1]}-times)`,U[0]);return(this.f?.onListenerError||n.$3)(V),S.$Wc.None}if(this.m)return S.$Wc.None;ne&&(z=z.bind(ne));const ce=new v(z);let K,ee;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(ce.stack=p.create(),K=this.g.check(ce.stack,this.z+1)),b&&(ce.stack=ee??p.create()),this.u?this.u instanceof v?(this.w??=new s,this.u=[this.u,ce]):this.u.push(ce):(this.f?.onWillAddFirstListener?.(this),this.u=ce,this.f?.onDidAddFirstListener?.(this)),this.z++;const H=(0,S.$Uc)(()=>{o?.unregister(H),K?.(),this.A(ce)});if(Q instanceof S.$Vc?Q.add(H):Array.isArray(Q)&&Q.push(H),o){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),U=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);o.register(H,U?.[2]??j,H)}return H},this.q}A(z){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const ne=this.u,Q=ne.indexOf(z);if(Q===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,ne[Q]=void 0;const ce=this.w.current===this;if(this.z*k<=ne.length){let K=0;for(let ee=0;ee<ne.length;ee++)ne[ee]?ne[K++]=ne[ee]:ce&&(this.w.end--,K<this.w.i&&this.w.i--);ne.length=K}}B(z,ne){if(!z)return;const Q=this.f?.onListenerError||n.$3;if(!Q){z.value(ne);return}try{z.value(ne)}catch(ce){Q(ce)}}C(z){const ne=z.current.u;for(;z.i<z.end;)this.B(ne[z.i++],z.value);z.reset()}fire(z){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof v)this.B(this.u,z);else{const ne=this.w;ne.enqueue(this,z,this.u.length),this.C(ne)}this.j?.stop()}hasListeners(){return this.z>0}}e.$me=i;const c=()=>new s;e.$ne=c;class s{constructor(){this.i=-1,this.end=0}enqueue(z,ne,Q){this.i=0,this.end=Q,this.current=z,this.value=ne}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class u extends i{async fireAsync(z,ne,Q){if(this.u)for(this.h||(this.h=new D.$7c),t(this.u,ce=>this.h.push([ce.value,z]));this.h.size>0&&!ne.isCancellationRequested;){const[ce,K]=this.h.shift(),ee=[],H={...K,token:ne,waitUntil:j=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");Q&&(j=Q(j,ce)),ee.push(j)}};try{ce(H)}catch(j){(0,n.$3)(j);continue}Object.freeze(ee),await Promise.allSettled(ee).then(j=>{for(const U of j)U.status==="rejected"&&(0,n.$3)(U.reason)})}}}e.$oe=u;class d extends i{get isPaused(){return this.h!==0}constructor(z){super(z),this.h=0,this.s=new D.$7c,this.t=z?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const z=Array.from(this.s);this.s.clear(),super.fire(this.t(z))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(z){this.z&&(this.h!==0?this.s.push(z):super.fire(z))}}e.$pe=d;class P extends d{constructor(z){super(z),this.k=z.delay??100}fire(z){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(z)}}e.$qe=P;class E extends i{constructor(z){super(z),this.h=[],this.k=z?.merge}fire(z){this.hasListeners()&&(this.h.push(z),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ne=>super.fire(ne)),this.h=[]}))}}e.$re=E;class O{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(z){const ne={event:z,listener:null};this.h.push(ne),this.g&&this.m(ne);const Q=()=>{this.g&&this.o(ne);const ce=this.h.indexOf(ne);this.h.splice(ce,1)};return(0,S.$Uc)((0,r.$fb)(Q))}j(){this.g=!0,this.h.forEach(z=>this.m(z))}k(){this.g=!1,this.h.forEach(z=>this.o(z))}m(z){z.listener=z.event(ne=>this.f.fire(ne))}o(z){z.listener?.dispose(),z.listener=null}dispose(){this.f.dispose();for(const z of this.h)z.listener?.dispose();this.h=[]}}e.$se=O;class T{constructor(z,ne,Q,ce){this.f=new S.$Vc;const K=this.f.add(new O),ee=this.f.add(new S.$6c);function H(j){ee.set(j,K.add(ce(j)))}for(const j of z)H(j);this.f.add(ne(j=>{H(j)})),this.f.add(Q(j=>{ee.deleteAndDispose(j)})),this.event=K.event}dispose(){this.f.dispose()}}e.$te=T;class L{constructor(){this.f=[]}wrapEvent(z,ne,Q){return(ce,K,ee)=>z(H=>{const j=this.f[this.f.length-1];if(!ne){j?j.buffers.push(()=>ce.call(K,H)):ce.call(K,H);return}const U=j;if(!U){ce.call(K,ne(Q,H));return}U.items??=[],U.items.push(H),U.buffers.length===0&&j.buffers.push(()=>{U.reducedResult??=Q?U.items.reduce(ne,Q):U.items.reduce(ne),ce.call(K,U.reducedResult)})},void 0,ee)}bufferEvents(z){const ne={buffers:new Array};this.f.push(ne);const Q=z();return this.f.pop(),ne.buffers.forEach(ce=>ce()),Q}}e.$ue=L;class R{constructor(){this.f=!1,this.g=h.None,this.h=S.$Wc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(z){this.g=z,this.f&&(this.h.dispose(),this.h=z(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ve=R;class M{static const(z){return new B(z)}constructor(z){this.g=z,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(z){z!==this.g&&(this.g=z,this.f.fire(void 0))}}e.$we=M;class B{constructor(z){this.value=z,this.onDidChange=h.None}}}),define(oe[23],ae([0,1,3]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.CancellationToken=void 0,e.$ye=I;const r=Object.freeze(function(b,a){const h=setTimeout(b.bind(a),0);return{dispose(){clearTimeout(h)}}});var S;(function(b){function a(h){return h===b.None||h===b.Cancelled||h instanceof D?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}b.isCancellationToken=a,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(S||(e.CancellationToken=S={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new n.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=S.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=S.None}}e.$xe=A;function I(b){const a=new A;return b.add({dispose(){a.cancel()}}),a.token}}),define(oe[145],ae([0,1,23]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$af=e.$_e=e.$0e=void 0,e.$$e=S;class r{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new n.$xe,a=this.b(b.token);return this.a={promise:a,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$0e=r;function S(I){return I}class D{constructor(b,a){this.a=void 0,this.b=void 0,typeof b=="function"?(this.c=b,this.d=S):(this.c=a,this.d=b.getCacheKey)}get(b){const a=this.d(b);return this.b!==a&&(this.b=a,this.a=this.c(b)),this.a}}e.$_e=D;class A{get cachedValues(){return this.a}constructor(b,a){this.a=new Map,this.b=new Map,typeof b=="function"?(this.c=b,this.d=S):(this.c=a,this.d=b.getCacheKey)}get(b){const a=this.d(b);if(this.b.has(a))return this.b.get(a);const h=this.c(b);return this.a.set(b,h),this.b.set(a,h),h}}e.$af=A}),define(oe[67],ae([0,1,16,2]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=S,e.$Ae=D,e.$Be=A,e.$Ce=I,e.$De=a,e.$Ee=h,e.$Fe=f,e.$Ge=g,e.$He=w,e.$Ie=l,e.$Je=p,e.$Ke=y,e.$Le=$,e.$Me=m,e.$Ne=v;function S(k){const t=k;return t?typeof t.read=="function":!1}function D(k){const t=k;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function A(k){const t=k;return t?D(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function I(k,t){return new b(k,t)}class b{constructor(t,o){this.e=t,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(o=>o(t))}h(t){this.c.error.length===0?(0,n.$3)(t):this.c.error.slice(0).forEach(o=>o(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,o){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(t,o){if(this.a.destroyed)return;let i;switch(t){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const c=i.indexOf(o);c>=0&&i.splice(c,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(k,t){const o=[];let i;for(;(i=k.read())!==null;)o.push(i);return t(o)}function h(k,t,o){const i=[];let c;for(;(c=k.read())!==null&&i.length<o;)i.push(c);return c===null&&i.length>0?t(i):{read:()=>{if(i.length>0)return i.shift();if(typeof c<"u"){const s=c;return c=void 0,s}return k.read()}}}function f(k,t){return new Promise((o,i)=>{const c=[];g(k,{onData:s=>{t&&c.push(s)},onError:s=>{t?i(s):o(void 0)},onEnd:()=>{o(t?t(c):void 0)}})})}function g(k,t,o){k.on("error",i=>{o?.isCancellationRequested||t.onError(i)}),k.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),k.on("data",i=>{o?.isCancellationRequested||t.onData(i)})}function w(k,t){return new Promise((o,i)=>{const c=new r.$Vc,s=[],u=E=>{if(s.push(E),s.length>t)return c.dispose(),k.pause(),o({stream:k,buffer:s,ended:!1})},d=E=>(c.dispose(),i(E)),P=()=>(c.dispose(),o({stream:k,buffer:s,ended:!0}));c.add((0,r.$Uc)(()=>k.removeListener("error",d))),k.on("error",d),c.add((0,r.$Uc)(()=>k.removeListener("end",P))),k.on("end",P),c.add((0,r.$Uc)(()=>k.removeListener("data",u))),k.on("data",u)})}function l(k,t){const o=I(t);return o.end(k),o}function p(){const k=I(()=>{throw new Error("not supported")});return k.end(),k}function y(k){let t=!1;return{read:()=>t?null:(t=!0,k)}}function $(k,t,o){const i=I(o);return g(k,{onData:c=>i.write(t.data(c)),onError:c=>i.error(t.error?t.error(c):c),onEnd:()=>i.end()}),i}function m(k,t,o){let i=!1;return{read:()=>{const c=t.read();return i?c:(i=!0,c!==null?o([k,c]):k)}}}function v(k,t,o){let i=!1;const c=I(o);return g(t,{onData:s=>i?c.write(s):(i=!0,c.write(o([k,s]))),onError:s=>c.error(s),onEnd:()=>{i||(i=!0,c.write(k)),c.end()}}),c}});var Dt=this&&this.__createBinding||(Object.create?function(x,e,n,r){r===void 0&&(r=n);var S=Object.getOwnPropertyDescriptor(e,n);(!S||("get"in S?!e.__esModule:S.writable||S.configurable))&&(S={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(x,r,S)}:function(x,e,n,r){r===void 0&&(r=n),x[r]=e[n]}),Rt=this&&this.__setModuleDefault||(Object.create?function(x,e){Object.defineProperty(x,"default",{enumerable:!0,value:e})}:function(x,e){x.default=e}),Re=this&&this.__importStar||function(x){if(x&&x.__esModule)return x;var e={};if(x!=null)for(var n in x)n!=="default"&&Object.prototype.hasOwnProperty.call(x,n)&&Dt(e,x,n);return Rt(e,x),e};define(oe[17],ae([0,1,65,67]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=a,e.$Qe=h,e.$Re=f,e.$Se=g,e.$Te=w,e.$Ue=l,e.$Ve=p,e.$We=y,e.$Xe=$,e.$Ye=m,e.$Ze=v,e.$1e=k,e.$2e=t,e.$3e=o,e.$4e=i,e.$5e=c,e.$6e=s,e.$7e=u,e.$8e=d,e.$9e=O,r=Re(r);const S=typeof Buffer<"u",D=new n.$X(()=>new Uint8Array(256));let A,I;class b{static alloc(L){return S?new b(Buffer.allocUnsafe(L)):new b(new Uint8Array(L))}static wrap(L){return S&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new b(L)}static fromString(L,R){return!(R?.dontUseNodeBuffer||!1)&&S?new b(Buffer.from(L)):(A||(A=new TextEncoder),new b(A.encode(L)))}static fromByteArray(L){const R=b.alloc(L.length);for(let M=0,B=L.length;M<B;M++)R.buffer[M]=L[M];return R}static concat(L,R){if(typeof R>"u"){R=0;for(let C=0,z=L.length;C<z;C++)R+=L[C].byteLength}const M=b.alloc(R);let B=0;for(let C=0,z=L.length;C<z;C++){const ne=L[C];M.set(ne,B),B+=ne.byteLength}return M}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=b.alloc(this.byteLength);return L.set(this),L}toString(){return S?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(L,R){return new b(this.buffer.subarray(L,R))}set(L,R){if(L instanceof b)this.buffer.set(L.buffer,R);else if(L instanceof Uint8Array)this.buffer.set(L,R);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),R);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return g(this.buffer,L)}writeUInt32BE(L,R){w(this.buffer,L,R)}readUInt32LE(L){return l(this.buffer,L)}writeUInt32LE(L,R){p(this.buffer,L,R)}readUInt8(L){return y(this.buffer,L)}writeUInt8(L,R){$(this.buffer,L,R)}indexOf(L,R=0){return a(this.buffer,L instanceof b?L.buffer:L,R)}}e.$Oe=b;function a(T,L,R=0){const M=L.byteLength,B=T.byteLength;if(M===0)return 0;if(M===1)return T.indexOf(L[0]);if(M>B-R)return-1;const C=D.value;C.fill(L.length);for(let ce=0;ce<L.length;ce++)C[L[ce]]=L.length-ce-1;let z=R+L.length-1,ne=z,Q=-1;for(;z<B;)if(T[z]===L[ne]){if(ne===0){Q=z;break}z--,ne--}else z+=Math.max(L.length-ne,C[T[z]]),ne=L.length-1;return Q}function h(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0}function f(T,L,R){T[R+0]=L&255,L=L>>>8,T[R+1]=L&255}function g(T,L){return T[L]*2**24+T[L+1]*2**16+T[L+2]*2**8+T[L+3]}function w(T,L,R){T[R+3]=L,L=L>>>8,T[R+2]=L,L=L>>>8,T[R+1]=L,L=L>>>8,T[R]=L}function l(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0|T[L+2]<<16>>>0|T[L+3]<<24>>>0}function p(T,L,R){T[R+0]=L&255,L=L>>>8,T[R+1]=L&255,L=L>>>8,T[R+2]=L&255,L=L>>>8,T[R+3]=L&255}function y(T,L){return T[L]}function $(T,L,R){T[R]=L}function m(T){return r.$De(T,L=>b.concat(L))}function v(T){return r.$Ke(T)}function k(T){return r.$Fe(T,L=>b.concat(L))}async function t(T){return T.ended?b.concat(T.buffer):b.concat([...T.buffer,await k(T.stream)])}function o(T){return r.$Ie(T,L=>b.concat(L))}function i(T){return r.$Le(T,{data:L=>typeof L=="string"?b.fromString(L):b.wrap(L)},L=>b.concat(L))}function c(T){return r.$Ce(L=>b.concat(L),T)}function s(T,L){return r.$Me(T,L,R=>b.concat(R))}function u(T,L){return r.$Ne(T,L,R=>b.concat(R))}function d(T){let L=0,R=0,M=0;const B=new Uint8Array(Math.floor(T.length/4*3)),C=ne=>{switch(R){case 3:B[M++]=L|ne,R=0;break;case 2:B[M++]=L|ne>>>2,L=ne<<6,R=3;break;case 1:B[M++]=L|ne>>>4,L=ne<<4,R=2;break;default:L=ne<<2,R=1}};for(let ne=0;ne<T.length;ne++){const Q=T.charCodeAt(ne);if(Q>=65&&Q<=90)C(Q-65);else if(Q>=97&&Q<=122)C(Q-97+26);else if(Q>=48&&Q<=57)C(Q-48+52);else if(Q===43||Q===45)C(62);else if(Q===47||Q===95)C(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ne]}`)}}const z=M;for(;R>0;)C(0);return b.wrap(B).slice(0,z)}const P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:T},L=!0,R=!1){const M=R?E:P;let B="";const C=T.byteLength%3;let z=0;for(;z<T.byteLength-C;z+=3){const ne=T[z+0],Q=T[z+1],ce=T[z+2];B+=M[ne>>>2],B+=M[(ne<<4|Q>>>4)&63],B+=M[(Q<<2|ce>>>6)&63],B+=M[ce&63]}if(C===1){const ne=T[z+0];B+=M[ne>>>2],B+=M[ne<<4&63],L&&(B+="==")}else if(C===2){const ne=T[z+0],Q=T[z+1];B+=M[ne>>>2],B+=M[(ne<<4|Q>>>4)&63],B+=M[Q<<2&63],L&&(B+="=")}return B}}),define(oe[146],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(oe[12],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=n,e.$gg=r,e.$hg=S,e.$ig=D,e.$jg=A,e.$kg=I,e.$lg=b,e.$mg=a,e.$ng=h,e.$og=f,e.$pg=g,e.$qg=w,e.$rg=l,e.$sg=y,e.$tg=$,e.$ug=m,e.$vg=v,e.$wg=k;function n(t){return typeof t=="string"}function r(t){return Array.isArray(t)&&t.every(o=>n(o))}function S(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function D(t){const o=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof o}function A(t){return typeof t=="number"&&!isNaN(t)}function I(t){return!!t&&typeof t[Symbol.iterator]=="function"}function b(t){return t===!0||t===!1}function a(t){return typeof t>"u"}function h(t){return!f(t)}function f(t){return a(t)||t===null}function g(t,o){if(!t)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}function w(t){if(f(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function l(...t){const o=[];for(let i=0;i<t.length;i++){const c=t[i];if(f(c))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);o.push(c)}return o}const p=Object.prototype.hasOwnProperty;function y(t){if(!S(t))return!1;for(const o in t)if(p.call(t,o))return!1;return!0}function $(t){return typeof t=="function"}function m(...t){return t.length>0&&t.every($)}function v(t,o){const i=Math.min(t.length,o.length);for(let c=0;c<i;c++)k(t[c],o[c])}function k(t,o){if(n(o)){if(typeof t!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if($(o)){try{if(t instanceof o)return}catch{}if(!f(t)&&t.constructor===o||o.length===1&&o.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(oe[110],ae([0,1,12]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=S,e.$1j=D;const r=Object.create(null);function S(A,I){if((0,n.$fg)(I)){const b=r[I];if(b===void 0)throw new Error(`${A} references an unknown codicon: ${I}`);I=b}return r[A]=I,{id:A}}function D(){return r}}),define(oe[147],ae([0,1,110]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=void 0,e.$2j={add:(0,n.$Zj)("add",6e4),plus:(0,n.$Zj)("plus",6e4),gistNew:(0,n.$Zj)("gist-new",6e4),repoCreate:(0,n.$Zj)("repo-create",6e4),lightbulb:(0,n.$Zj)("lightbulb",60001),lightBulb:(0,n.$Zj)("light-bulb",60001),repo:(0,n.$Zj)("repo",60002),repoDelete:(0,n.$Zj)("repo-delete",60002),gistFork:(0,n.$Zj)("gist-fork",60003),repoForked:(0,n.$Zj)("repo-forked",60003),gitPullRequest:(0,n.$Zj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Zj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Zj)("record-keys",60005),keyboard:(0,n.$Zj)("keyboard",60005),tag:(0,n.$Zj)("tag",60006),gitPullRequestLabel:(0,n.$Zj)("git-pull-request-label",60006),tagAdd:(0,n.$Zj)("tag-add",60006),tagRemove:(0,n.$Zj)("tag-remove",60006),person:(0,n.$Zj)("person",60007),personFollow:(0,n.$Zj)("person-follow",60007),personOutline:(0,n.$Zj)("person-outline",60007),personFilled:(0,n.$Zj)("person-filled",60007),gitBranch:(0,n.$Zj)("git-branch",60008),gitBranchCreate:(0,n.$Zj)("git-branch-create",60008),gitBranchDelete:(0,n.$Zj)("git-branch-delete",60008),sourceControl:(0,n.$Zj)("source-control",60008),mirror:(0,n.$Zj)("mirror",60009),mirrorPublic:(0,n.$Zj)("mirror-public",60009),star:(0,n.$Zj)("star",60010),starAdd:(0,n.$Zj)("star-add",60010),starDelete:(0,n.$Zj)("star-delete",60010),starEmpty:(0,n.$Zj)("star-empty",60010),comment:(0,n.$Zj)("comment",60011),commentAdd:(0,n.$Zj)("comment-add",60011),alert:(0,n.$Zj)("alert",60012),warning:(0,n.$Zj)("warning",60012),search:(0,n.$Zj)("search",60013),searchSave:(0,n.$Zj)("search-save",60013),logOut:(0,n.$Zj)("log-out",60014),signOut:(0,n.$Zj)("sign-out",60014),logIn:(0,n.$Zj)("log-in",60015),signIn:(0,n.$Zj)("sign-in",60015),eye:(0,n.$Zj)("eye",60016),eyeUnwatch:(0,n.$Zj)("eye-unwatch",60016),eyeWatch:(0,n.$Zj)("eye-watch",60016),circleFilled:(0,n.$Zj)("circle-filled",60017),primitiveDot:(0,n.$Zj)("primitive-dot",60017),closeDirty:(0,n.$Zj)("close-dirty",60017),debugBreakpoint:(0,n.$Zj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Zj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Zj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Zj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Zj)("primitive-square",60018),edit:(0,n.$Zj)("edit",60019),pencil:(0,n.$Zj)("pencil",60019),info:(0,n.$Zj)("info",60020),issueOpened:(0,n.$Zj)("issue-opened",60020),gistPrivate:(0,n.$Zj)("gist-private",60021),gitForkPrivate:(0,n.$Zj)("git-fork-private",60021),lock:(0,n.$Zj)("lock",60021),mirrorPrivate:(0,n.$Zj)("mirror-private",60021),close:(0,n.$Zj)("close",60022),removeClose:(0,n.$Zj)("remove-close",60022),x:(0,n.$Zj)("x",60022),repoSync:(0,n.$Zj)("repo-sync",60023),sync:(0,n.$Zj)("sync",60023),clone:(0,n.$Zj)("clone",60024),desktopDownload:(0,n.$Zj)("desktop-download",60024),beaker:(0,n.$Zj)("beaker",60025),microscope:(0,n.$Zj)("microscope",60025),vm:(0,n.$Zj)("vm",60026),deviceDesktop:(0,n.$Zj)("device-desktop",60026),file:(0,n.$Zj)("file",60027),fileText:(0,n.$Zj)("file-text",60027),more:(0,n.$Zj)("more",60028),ellipsis:(0,n.$Zj)("ellipsis",60028),kebabHorizontal:(0,n.$Zj)("kebab-horizontal",60028),mailReply:(0,n.$Zj)("mail-reply",60029),reply:(0,n.$Zj)("reply",60029),organization:(0,n.$Zj)("organization",60030),organizationFilled:(0,n.$Zj)("organization-filled",60030),organizationOutline:(0,n.$Zj)("organization-outline",60030),newFile:(0,n.$Zj)("new-file",60031),fileAdd:(0,n.$Zj)("file-add",60031),newFolder:(0,n.$Zj)("new-folder",60032),fileDirectoryCreate:(0,n.$Zj)("file-directory-create",60032),trash:(0,n.$Zj)("trash",60033),trashcan:(0,n.$Zj)("trashcan",60033),history:(0,n.$Zj)("history",60034),clock:(0,n.$Zj)("clock",60034),folder:(0,n.$Zj)("folder",60035),fileDirectory:(0,n.$Zj)("file-directory",60035),symbolFolder:(0,n.$Zj)("symbol-folder",60035),logoGithub:(0,n.$Zj)("logo-github",60036),markGithub:(0,n.$Zj)("mark-github",60036),github:(0,n.$Zj)("github",60036),terminal:(0,n.$Zj)("terminal",60037),console:(0,n.$Zj)("console",60037),repl:(0,n.$Zj)("repl",60037),zap:(0,n.$Zj)("zap",60038),symbolEvent:(0,n.$Zj)("symbol-event",60038),error:(0,n.$Zj)("error",60039),stop:(0,n.$Zj)("stop",60039),variable:(0,n.$Zj)("variable",60040),symbolVariable:(0,n.$Zj)("symbol-variable",60040),array:(0,n.$Zj)("array",60042),symbolArray:(0,n.$Zj)("symbol-array",60042),symbolModule:(0,n.$Zj)("symbol-module",60043),symbolPackage:(0,n.$Zj)("symbol-package",60043),symbolNamespace:(0,n.$Zj)("symbol-namespace",60043),symbolObject:(0,n.$Zj)("symbol-object",60043),symbolMethod:(0,n.$Zj)("symbol-method",60044),symbolFunction:(0,n.$Zj)("symbol-function",60044),symbolConstructor:(0,n.$Zj)("symbol-constructor",60044),symbolBoolean:(0,n.$Zj)("symbol-boolean",60047),symbolNull:(0,n.$Zj)("symbol-null",60047),symbolNumeric:(0,n.$Zj)("symbol-numeric",60048),symbolNumber:(0,n.$Zj)("symbol-number",60048),symbolStructure:(0,n.$Zj)("symbol-structure",60049),symbolStruct:(0,n.$Zj)("symbol-struct",60049),symbolParameter:(0,n.$Zj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Zj)("symbol-type-parameter",60050),symbolKey:(0,n.$Zj)("symbol-key",60051),symbolText:(0,n.$Zj)("symbol-text",60051),symbolReference:(0,n.$Zj)("symbol-reference",60052),goToFile:(0,n.$Zj)("go-to-file",60052),symbolEnum:(0,n.$Zj)("symbol-enum",60053),symbolValue:(0,n.$Zj)("symbol-value",60053),symbolRuler:(0,n.$Zj)("symbol-ruler",60054),symbolUnit:(0,n.$Zj)("symbol-unit",60054),activateBreakpoints:(0,n.$Zj)("activate-breakpoints",60055),archive:(0,n.$Zj)("archive",60056),arrowBoth:(0,n.$Zj)("arrow-both",60057),arrowDown:(0,n.$Zj)("arrow-down",60058),arrowLeft:(0,n.$Zj)("arrow-left",60059),arrowRight:(0,n.$Zj)("arrow-right",60060),arrowSmallDown:(0,n.$Zj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Zj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Zj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Zj)("arrow-small-up",60064),arrowUp:(0,n.$Zj)("arrow-up",60065),bell:(0,n.$Zj)("bell",60066),bold:(0,n.$Zj)("bold",60067),book:(0,n.$Zj)("book",60068),bookmark:(0,n.$Zj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Zj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Zj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Zj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Zj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Zj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Zj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Zj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Zj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Zj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Zj)("briefcase",60076),broadcast:(0,n.$Zj)("broadcast",60077),browser:(0,n.$Zj)("browser",60078),bug:(0,n.$Zj)("bug",60079),calendar:(0,n.$Zj)("calendar",60080),caseSensitive:(0,n.$Zj)("case-sensitive",60081),check:(0,n.$Zj)("check",60082),checklist:(0,n.$Zj)("checklist",60083),chevronDown:(0,n.$Zj)("chevron-down",60084),chevronLeft:(0,n.$Zj)("chevron-left",60085),chevronRight:(0,n.$Zj)("chevron-right",60086),chevronUp:(0,n.$Zj)("chevron-up",60087),chromeClose:(0,n.$Zj)("chrome-close",60088),chromeMaximize:(0,n.$Zj)("chrome-maximize",60089),chromeMinimize:(0,n.$Zj)("chrome-minimize",60090),chromeRestore:(0,n.$Zj)("chrome-restore",60091),circleOutline:(0,n.$Zj)("circle-outline",60092),circle:(0,n.$Zj)("circle",60092),debugBreakpointUnverified:(0,n.$Zj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Zj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Zj)("circle-slash",60093),circuitBoard:(0,n.$Zj)("circuit-board",60094),clearAll:(0,n.$Zj)("clear-all",60095),clippy:(0,n.$Zj)("clippy",60096),closeAll:(0,n.$Zj)("close-all",60097),cloudDownload:(0,n.$Zj)("cloud-download",60098),cloudUpload:(0,n.$Zj)("cloud-upload",60099),code:(0,n.$Zj)("code",60100),collapseAll:(0,n.$Zj)("collapse-all",60101),colorMode:(0,n.$Zj)("color-mode",60102),commentDiscussion:(0,n.$Zj)("comment-discussion",60103),creditCard:(0,n.$Zj)("credit-card",60105),dash:(0,n.$Zj)("dash",60108),dashboard:(0,n.$Zj)("dashboard",60109),database:(0,n.$Zj)("database",60110),debugContinue:(0,n.$Zj)("debug-continue",60111),debugDisconnect:(0,n.$Zj)("debug-disconnect",60112),debugPause:(0,n.$Zj)("debug-pause",60113),debugRestart:(0,n.$Zj)("debug-restart",60114),debugStart:(0,n.$Zj)("debug-start",60115),debugStepInto:(0,n.$Zj)("debug-step-into",60116),debugStepOut:(0,n.$Zj)("debug-step-out",60117),debugStepOver:(0,n.$Zj)("debug-step-over",60118),debugStop:(0,n.$Zj)("debug-stop",60119),debug:(0,n.$Zj)("debug",60120),deviceCameraVideo:(0,n.$Zj)("device-camera-video",60121),deviceCamera:(0,n.$Zj)("device-camera",60122),deviceMobile:(0,n.$Zj)("device-mobile",60123),diffAdded:(0,n.$Zj)("diff-added",60124),diffIgnored:(0,n.$Zj)("diff-ignored",60125),diffModified:(0,n.$Zj)("diff-modified",60126),diffRemoved:(0,n.$Zj)("diff-removed",60127),diffRenamed:(0,n.$Zj)("diff-renamed",60128),diff:(0,n.$Zj)("diff",60129),diffSidebyside:(0,n.$Zj)("diff-sidebyside",60129),discard:(0,n.$Zj)("discard",60130),editorLayout:(0,n.$Zj)("editor-layout",60131),emptyWindow:(0,n.$Zj)("empty-window",60132),exclude:(0,n.$Zj)("exclude",60133),extensions:(0,n.$Zj)("extensions",60134),eyeClosed:(0,n.$Zj)("eye-closed",60135),fileBinary:(0,n.$Zj)("file-binary",60136),fileCode:(0,n.$Zj)("file-code",60137),fileMedia:(0,n.$Zj)("file-media",60138),filePdf:(0,n.$Zj)("file-pdf",60139),fileSubmodule:(0,n.$Zj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Zj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Zj)("file-symlink-file",60142),fileZip:(0,n.$Zj)("file-zip",60143),files:(0,n.$Zj)("files",60144),filter:(0,n.$Zj)("filter",60145),flame:(0,n.$Zj)("flame",60146),foldDown:(0,n.$Zj)("fold-down",60147),foldUp:(0,n.$Zj)("fold-up",60148),fold:(0,n.$Zj)("fold",60149),folderActive:(0,n.$Zj)("folder-active",60150),folderOpened:(0,n.$Zj)("folder-opened",60151),gear:(0,n.$Zj)("gear",60152),gift:(0,n.$Zj)("gift",60153),gistSecret:(0,n.$Zj)("gist-secret",60154),gist:(0,n.$Zj)("gist",60155),gitCommit:(0,n.$Zj)("git-commit",60156),gitCompare:(0,n.$Zj)("git-compare",60157),compareChanges:(0,n.$Zj)("compare-changes",60157),gitMerge:(0,n.$Zj)("git-merge",60158),githubAction:(0,n.$Zj)("github-action",60159),githubAlt:(0,n.$Zj)("github-alt",60160),globe:(0,n.$Zj)("globe",60161),grabber:(0,n.$Zj)("grabber",60162),graph:(0,n.$Zj)("graph",60163),gripper:(0,n.$Zj)("gripper",60164),heart:(0,n.$Zj)("heart",60165),home:(0,n.$Zj)("home",60166),horizontalRule:(0,n.$Zj)("horizontal-rule",60167),hubot:(0,n.$Zj)("hubot",60168),inbox:(0,n.$Zj)("inbox",60169),issueReopened:(0,n.$Zj)("issue-reopened",60171),issues:(0,n.$Zj)("issues",60172),italic:(0,n.$Zj)("italic",60173),jersey:(0,n.$Zj)("jersey",60174),json:(0,n.$Zj)("json",60175),kebabVertical:(0,n.$Zj)("kebab-vertical",60176),key:(0,n.$Zj)("key",60177),law:(0,n.$Zj)("law",60178),lightbulbAutofix:(0,n.$Zj)("lightbulb-autofix",60179),linkExternal:(0,n.$Zj)("link-external",60180),link:(0,n.$Zj)("link",60181),listOrdered:(0,n.$Zj)("list-ordered",60182),listUnordered:(0,n.$Zj)("list-unordered",60183),liveShare:(0,n.$Zj)("live-share",60184),loading:(0,n.$Zj)("loading",60185),location:(0,n.$Zj)("location",60186),mailRead:(0,n.$Zj)("mail-read",60187),mail:(0,n.$Zj)("mail",60188),markdown:(0,n.$Zj)("markdown",60189),megaphone:(0,n.$Zj)("megaphone",60190),mention:(0,n.$Zj)("mention",60191),milestone:(0,n.$Zj)("milestone",60192),gitPullRequestMilestone:(0,n.$Zj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Zj)("mortar-board",60193),move:(0,n.$Zj)("move",60194),multipleWindows:(0,n.$Zj)("multiple-windows",60195),mute:(0,n.$Zj)("mute",60196),noNewline:(0,n.$Zj)("no-newline",60197),note:(0,n.$Zj)("note",60198),octoface:(0,n.$Zj)("octoface",60199),openPreview:(0,n.$Zj)("open-preview",60200),package:(0,n.$Zj)("package",60201),paintcan:(0,n.$Zj)("paintcan",60202),pin:(0,n.$Zj)("pin",60203),play:(0,n.$Zj)("play",60204),run:(0,n.$Zj)("run",60204),plug:(0,n.$Zj)("plug",60205),preserveCase:(0,n.$Zj)("preserve-case",60206),preview:(0,n.$Zj)("preview",60207),project:(0,n.$Zj)("project",60208),pulse:(0,n.$Zj)("pulse",60209),question:(0,n.$Zj)("question",60210),quote:(0,n.$Zj)("quote",60211),radioTower:(0,n.$Zj)("radio-tower",60212),reactions:(0,n.$Zj)("reactions",60213),references:(0,n.$Zj)("references",60214),refresh:(0,n.$Zj)("refresh",60215),regex:(0,n.$Zj)("regex",60216),remoteExplorer:(0,n.$Zj)("remote-explorer",60217),remote:(0,n.$Zj)("remote",60218),remove:(0,n.$Zj)("remove",60219),replaceAll:(0,n.$Zj)("replace-all",60220),replace:(0,n.$Zj)("replace",60221),repoClone:(0,n.$Zj)("repo-clone",60222),repoForcePush:(0,n.$Zj)("repo-force-push",60223),repoPull:(0,n.$Zj)("repo-pull",60224),repoPush:(0,n.$Zj)("repo-push",60225),report:(0,n.$Zj)("report",60226),requestChanges:(0,n.$Zj)("request-changes",60227),rocket:(0,n.$Zj)("rocket",60228),rootFolderOpened:(0,n.$Zj)("root-folder-opened",60229),rootFolder:(0,n.$Zj)("root-folder",60230),rss:(0,n.$Zj)("rss",60231),ruby:(0,n.$Zj)("ruby",60232),saveAll:(0,n.$Zj)("save-all",60233),saveAs:(0,n.$Zj)("save-as",60234),save:(0,n.$Zj)("save",60235),screenFull:(0,n.$Zj)("screen-full",60236),screenNormal:(0,n.$Zj)("screen-normal",60237),searchStop:(0,n.$Zj)("search-stop",60238),server:(0,n.$Zj)("server",60240),settingsGear:(0,n.$Zj)("settings-gear",60241),settings:(0,n.$Zj)("settings",60242),shield:(0,n.$Zj)("shield",60243),smiley:(0,n.$Zj)("smiley",60244),sortPrecedence:(0,n.$Zj)("sort-precedence",60245),splitHorizontal:(0,n.$Zj)("split-horizontal",60246),splitVertical:(0,n.$Zj)("split-vertical",60247),squirrel:(0,n.$Zj)("squirrel",60248),starFull:(0,n.$Zj)("star-full",60249),starHalf:(0,n.$Zj)("star-half",60250),symbolClass:(0,n.$Zj)("symbol-class",60251),symbolColor:(0,n.$Zj)("symbol-color",60252),symbolConstant:(0,n.$Zj)("symbol-constant",60253),symbolEnumMember:(0,n.$Zj)("symbol-enum-member",60254),symbolField:(0,n.$Zj)("symbol-field",60255),symbolFile:(0,n.$Zj)("symbol-file",60256),symbolInterface:(0,n.$Zj)("symbol-interface",60257),symbolKeyword:(0,n.$Zj)("symbol-keyword",60258),symbolMisc:(0,n.$Zj)("symbol-misc",60259),symbolOperator:(0,n.$Zj)("symbol-operator",60260),symbolProperty:(0,n.$Zj)("symbol-property",60261),wrench:(0,n.$Zj)("wrench",60261),wrenchSubaction:(0,n.$Zj)("wrench-subaction",60261),symbolSnippet:(0,n.$Zj)("symbol-snippet",60262),tasklist:(0,n.$Zj)("tasklist",60263),telescope:(0,n.$Zj)("telescope",60264),textSize:(0,n.$Zj)("text-size",60265),threeBars:(0,n.$Zj)("three-bars",60266),thumbsdown:(0,n.$Zj)("thumbsdown",60267),thumbsup:(0,n.$Zj)("thumbsup",60268),tools:(0,n.$Zj)("tools",60269),triangleDown:(0,n.$Zj)("triangle-down",60270),triangleLeft:(0,n.$Zj)("triangle-left",60271),triangleRight:(0,n.$Zj)("triangle-right",60272),triangleUp:(0,n.$Zj)("triangle-up",60273),twitter:(0,n.$Zj)("twitter",60274),unfold:(0,n.$Zj)("unfold",60275),unlock:(0,n.$Zj)("unlock",60276),unmute:(0,n.$Zj)("unmute",60277),unverified:(0,n.$Zj)("unverified",60278),verified:(0,n.$Zj)("verified",60279),versions:(0,n.$Zj)("versions",60280),vmActive:(0,n.$Zj)("vm-active",60281),vmOutline:(0,n.$Zj)("vm-outline",60282),vmRunning:(0,n.$Zj)("vm-running",60283),watch:(0,n.$Zj)("watch",60284),whitespace:(0,n.$Zj)("whitespace",60285),wholeWord:(0,n.$Zj)("whole-word",60286),window:(0,n.$Zj)("window",60287),wordWrap:(0,n.$Zj)("word-wrap",60288),zoomIn:(0,n.$Zj)("zoom-in",60289),zoomOut:(0,n.$Zj)("zoom-out",60290),listFilter:(0,n.$Zj)("list-filter",60291),listFlat:(0,n.$Zj)("list-flat",60292),listSelection:(0,n.$Zj)("list-selection",60293),selection:(0,n.$Zj)("selection",60293),listTree:(0,n.$Zj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Zj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Zj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Zj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Zj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Zj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Zj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Zj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Zj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Zj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Zj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Zj)("symbol-string",60301),debugReverseContinue:(0,n.$Zj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Zj)("debug-step-back",60303),debugRestartFrame:(0,n.$Zj)("debug-restart-frame",60304),debugAlt:(0,n.$Zj)("debug-alt",60305),callIncoming:(0,n.$Zj)("call-incoming",60306),callOutgoing:(0,n.$Zj)("call-outgoing",60307),menu:(0,n.$Zj)("menu",60308),expandAll:(0,n.$Zj)("expand-all",60309),feedback:(0,n.$Zj)("feedback",60310),gitPullRequestReviewer:(0,n.$Zj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Zj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Zj)("ungroup-by-ref-type",60312),account:(0,n.$Zj)("account",60313),gitPullRequestAssignee:(0,n.$Zj)("git-pull-request-assignee",60313),bellDot:(0,n.$Zj)("bell-dot",60314),debugConsole:(0,n.$Zj)("debug-console",60315),library:(0,n.$Zj)("library",60316),output:(0,n.$Zj)("output",60317),runAll:(0,n.$Zj)("run-all",60318),syncIgnored:(0,n.$Zj)("sync-ignored",60319),pinned:(0,n.$Zj)("pinned",60320),githubInverted:(0,n.$Zj)("github-inverted",60321),serverProcess:(0,n.$Zj)("server-process",60322),serverEnvironment:(0,n.$Zj)("server-environment",60323),pass:(0,n.$Zj)("pass",60324),issueClosed:(0,n.$Zj)("issue-closed",60324),stopCircle:(0,n.$Zj)("stop-circle",60325),playCircle:(0,n.$Zj)("play-circle",60326),record:(0,n.$Zj)("record",60327),debugAltSmall:(0,n.$Zj)("debug-alt-small",60328),vmConnect:(0,n.$Zj)("vm-connect",60329),cloud:(0,n.$Zj)("cloud",60330),merge:(0,n.$Zj)("merge",60331),export:(0,n.$Zj)("export",60332),graphLeft:(0,n.$Zj)("graph-left",60333),magnet:(0,n.$Zj)("magnet",60334),notebook:(0,n.$Zj)("notebook",60335),redo:(0,n.$Zj)("redo",60336),checkAll:(0,n.$Zj)("check-all",60337),pinnedDirty:(0,n.$Zj)("pinned-dirty",60338),passFilled:(0,n.$Zj)("pass-filled",60339),circleLargeFilled:(0,n.$Zj)("circle-large-filled",60340),circleLarge:(0,n.$Zj)("circle-large",60341),circleLargeOutline:(0,n.$Zj)("circle-large-outline",60341),combine:(0,n.$Zj)("combine",60342),gather:(0,n.$Zj)("gather",60342),table:(0,n.$Zj)("table",60343),variableGroup:(0,n.$Zj)("variable-group",60344),typeHierarchy:(0,n.$Zj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Zj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Zj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Zj)("git-pull-request-create",60348),runAbove:(0,n.$Zj)("run-above",60349),runBelow:(0,n.$Zj)("run-below",60350),notebookTemplate:(0,n.$Zj)("notebook-template",60351),debugRerun:(0,n.$Zj)("debug-rerun",60352),workspaceTrusted:(0,n.$Zj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Zj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Zj)("workspace-unknown",60355),terminalCmd:(0,n.$Zj)("terminal-cmd",60356),terminalDebian:(0,n.$Zj)("terminal-debian",60357),terminalLinux:(0,n.$Zj)("terminal-linux",60358),terminalPowershell:(0,n.$Zj)("terminal-powershell",60359),terminalTmux:(0,n.$Zj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Zj)("terminal-ubuntu",60361),terminalBash:(0,n.$Zj)("terminal-bash",60362),arrowSwap:(0,n.$Zj)("arrow-swap",60363),copy:(0,n.$Zj)("copy",60364),personAdd:(0,n.$Zj)("person-add",60365),filterFilled:(0,n.$Zj)("filter-filled",60366),wand:(0,n.$Zj)("wand",60367),debugLineByLine:(0,n.$Zj)("debug-line-by-line",60368),inspect:(0,n.$Zj)("inspect",60369),layers:(0,n.$Zj)("layers",60370),layersDot:(0,n.$Zj)("layers-dot",60371),layersActive:(0,n.$Zj)("layers-active",60372),compass:(0,n.$Zj)("compass",60373),compassDot:(0,n.$Zj)("compass-dot",60374),compassActive:(0,n.$Zj)("compass-active",60375),azure:(0,n.$Zj)("azure",60376),issueDraft:(0,n.$Zj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Zj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Zj)("git-pull-request-draft",60379),debugAll:(0,n.$Zj)("debug-all",60380),debugCoverage:(0,n.$Zj)("debug-coverage",60381),runErrors:(0,n.$Zj)("run-errors",60382),folderLibrary:(0,n.$Zj)("folder-library",60383),debugContinueSmall:(0,n.$Zj)("debug-continue-small",60384),beakerStop:(0,n.$Zj)("beaker-stop",60385),graphLine:(0,n.$Zj)("graph-line",60386),graphScatter:(0,n.$Zj)("graph-scatter",60387),pieChart:(0,n.$Zj)("pie-chart",60388),bracket:(0,n.$Zj)("bracket",60175),bracketDot:(0,n.$Zj)("bracket-dot",60389),bracketError:(0,n.$Zj)("bracket-error",60390),lockSmall:(0,n.$Zj)("lock-small",60391),azureDevops:(0,n.$Zj)("azure-devops",60392),verifiedFilled:(0,n.$Zj)("verified-filled",60393),newline:(0,n.$Zj)("newline",60394),layout:(0,n.$Zj)("layout",60395),layoutActivitybarLeft:(0,n.$Zj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Zj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Zj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Zj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Zj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Zj)("layout-panel-right",60401),layoutPanel:(0,n.$Zj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Zj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Zj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Zj)("layout-statusbar",60405),layoutMenubar:(0,n.$Zj)("layout-menubar",60406),layoutCentered:(0,n.$Zj)("layout-centered",60407),target:(0,n.$Zj)("target",60408),indent:(0,n.$Zj)("indent",60409),recordSmall:(0,n.$Zj)("record-small",60410),errorSmall:(0,n.$Zj)("error-small",60411),terminalDecorationError:(0,n.$Zj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Zj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Zj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Zj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Zj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Zj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Zj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Zj)("layout-sidebar-left-off",60418),blank:(0,n.$Zj)("blank",60419),heartFilled:(0,n.$Zj)("heart-filled",60420),map:(0,n.$Zj)("map",60421),mapHorizontal:(0,n.$Zj)("map-horizontal",60421),foldHorizontal:(0,n.$Zj)("fold-horizontal",60421),mapFilled:(0,n.$Zj)("map-filled",60422),mapHorizontalFilled:(0,n.$Zj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Zj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Zj)("circle-small",60423),bellSlash:(0,n.$Zj)("bell-slash",60424),bellSlashDot:(0,n.$Zj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Zj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Zj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Zj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Zj)("search-fuzzy",60429),commentDraft:(0,n.$Zj)("comment-draft",60430),send:(0,n.$Zj)("send",60431),sparkle:(0,n.$Zj)("sparkle",60432),insert:(0,n.$Zj)("insert",60433),mic:(0,n.$Zj)("mic",60434),thumbsdownFilled:(0,n.$Zj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Zj)("thumbsup-filled",60436),coffee:(0,n.$Zj)("coffee",60437),snake:(0,n.$Zj)("snake",60438),game:(0,n.$Zj)("game",60439),vr:(0,n.$Zj)("vr",60440),chip:(0,n.$Zj)("chip",60441),piano:(0,n.$Zj)("piano",60442),music:(0,n.$Zj)("music",60443),micFilled:(0,n.$Zj)("mic-filled",60444),repoFetch:(0,n.$Zj)("repo-fetch",60445),copilot:(0,n.$Zj)("copilot",60446),lightbulbSparkle:(0,n.$Zj)("lightbulb-sparkle",60447),robot:(0,n.$Zj)("robot",60448),sparkleFilled:(0,n.$Zj)("sparkle-filled",60449),diffSingle:(0,n.$Zj)("diff-single",60450),diffMultiple:(0,n.$Zj)("diff-multiple",60451),surroundWith:(0,n.$Zj)("surround-with",60452),share:(0,n.$Zj)("share",60453),gitStash:(0,n.$Zj)("git-stash",60454),gitStashApply:(0,n.$Zj)("git-stash-apply",60455),gitStashPop:(0,n.$Zj)("git-stash-pop",60456),vscode:(0,n.$Zj)("vscode",60457),vscodeInsiders:(0,n.$Zj)("vscode-insiders",60458),codeOss:(0,n.$Zj)("code-oss",60459),runCoverage:(0,n.$Zj)("run-coverage",60460),runAllCoverage:(0,n.$Zj)("run-all-coverage",60461),coverage:(0,n.$Zj)("coverage",60462),githubProject:(0,n.$Zj)("github-project",60463),mapVertical:(0,n.$Zj)("map-vertical",60464),foldVertical:(0,n.$Zj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Zj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Zj)("fold-vertical-filled",60465),goToSearch:(0,n.$Zj)("go-to-search",60466),percentage:(0,n.$Zj)("percentage",60467),sortPercentage:(0,n.$Zj)("sort-percentage",60467),attach:(0,n.$Zj)("attach",60468)}}),define(oe[78],ae([0,1,110,147]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=void 0,e.$3j=S;function S(){return Object.values(e.$5j)}e.$4j={dialogError:(0,n.$Zj)("dialog-error","error"),dialogWarning:(0,n.$Zj)("dialog-warning","warning"),dialogInfo:(0,n.$Zj)("dialog-info","info"),dialogClose:(0,n.$Zj)("dialog-close","close"),treeItemExpanded:(0,n.$Zj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Zj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Zj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Zj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Zj)("tree-item-loading","loading"),menuSelection:(0,n.$Zj)("menu-selection","check"),menuSubmenu:(0,n.$Zj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Zj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Zj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Zj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Zj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Zj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Zj)("toolbar-more","more"),quickInputBack:(0,n.$Zj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Zj)("drop-down-button",60084),symbolCustomColor:(0,n.$Zj)("symbol-customcolor",60252),exportIcon:(0,n.$Zj)("export",60332),workspaceUnspecified:(0,n.$Zj)("workspace-unspecified",60355),newLine:(0,n.$Zj)("newline",60394),thumbsDownFilled:(0,n.$Zj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Zj)("thumbsup-filled",60436),gitFetch:(0,n.$Zj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Zj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Zj)("debug-breakpoint-pending",60377)},e.$5j={...r.$2j,...e.$4j}}),define(oe[35],ae([0,1,12]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=r,e.$eo=S,e.$fo=A,e.$go=b,e.$ho=a,e.$io=h,e.$jo=f,e.$ko=g,e.$lo=w,e.$mo=l,e.$no=p,e.$oo=y,e.$po=$;function r(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const v=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([k,t])=>{v[k]=t&&typeof t=="object"?r(t):t}),v}function S(m){if(!m||typeof m!="object")return m;const v=[m];for(;v.length>0;){const k=v.shift();Object.freeze(k);for(const t in k)if(D.call(k,t)){const o=k[t];typeof o=="object"&&!Object.isFrozen(o)&&!(0,n.$ig)(o)&&v.push(o)}}return m}const D=Object.prototype.hasOwnProperty;function A(m,v){return I(m,v,new Set)}function I(m,v,k){if((0,n.$og)(m))return m;const t=v(m);if(typeof t<"u")return t;if(Array.isArray(m)){const o=[];for(const i of m)o.push(I(i,v,k));return o}if((0,n.$hg)(m)){if(k.has(m))throw new Error("Cannot clone recursive data-structure");k.add(m);const o={};for(const i in m)D.call(m,i)&&(o[i]=I(m[i],v,k));return k.delete(m),o}return m}function b(m,v,k=!0){return(0,n.$hg)(m)?((0,n.$hg)(v)&&Object.keys(v).forEach(t=>{t in m?k&&((0,n.$hg)(m[t])&&(0,n.$hg)(v[t])?b(m[t],v[t],k):m[t]=v[t]):m[t]=v[t]}),m):v}function a(m,v){if(m===v)return!0;if(m==null||v===null||v===void 0||typeof m!=typeof v||typeof m!="object"||Array.isArray(m)!==Array.isArray(v))return!1;let k,t;if(Array.isArray(m)){if(m.length!==v.length)return!1;for(k=0;k<m.length;k++)if(!a(m[k],v[k]))return!1}else{const o=[];for(t in m)o.push(t);o.sort();const i=[];for(t in v)i.push(t);if(i.sort(),!a(o,i))return!1;for(k=0;k<o.length;k++)if(!a(m[o[k]],v[o[k]]))return!1}return!0}function h(m){const v=new Set;return JSON.stringify(m,(k,t)=>{if((0,n.$hg)(t)||Array.isArray(t)){if(v.has(t))return"[Circular]";v.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function f(m,v){const k=Object.create(null);return!m||!v||Object.keys(v).forEach(o=>{const i=m[o],c=v[o];a(i,c)||(k[o]=c)}),k}function g(m,v){const k=v.toLowerCase(),t=Object.keys(m).find(o=>o.toLowerCase()===k);return t?m[t]:m[v]}function w(m,v){const k=Object.create(null);for(const[t,o]of Object.entries(m))v(t,o)&&(k[t]=o);return k}function l(m){let v=[];for(;Object.prototype!==m;)v=v.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return v}function p(m){const v=[];for(const k of l(m))typeof m[k]=="function"&&v.push(k);return v}function y(m,v){const k=o=>function(){const i=Array.prototype.slice.call(arguments,0);return v(o,i)},t={};for(const o of m)t[o]=k(o);return t}function $(m,v){const k={};for(const[t,o]of Object.entries(m))k[t]=v(o,t);return k}}),define(oe[111],ae([0,1,78]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=S;var r;(function(A){function I(b){return b&&typeof b=="object"&&typeof b.id=="string"}A.isThemeColor=I})(r||(e.ThemeColor=r={}));function S(A){return{id:A}}var D;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(m){const v=I.exec(m.id);if(!v)return b(n.$5j.error);const[,k,t]=v,o=["codicon","codicon-"+k];return t&&o.push("codicon-modifier-"+t.substring(1)),o}A.asClassNameArray=b;function a(m){return b(m).join(" ")}A.asClassName=a;function h(m){return"."+b(m).join(".")}A.asCSSSelector=h;function f(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||r.isThemeColor(m.color))}A.isThemeIcon=f;const g=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function w(m){const v=g.exec(m);if(!v)return;const[,k]=v;return{id:k}}A.fromString=w;function l(m){return{id:m}}A.fromId=l;function p(m,v){let k=m.id;const t=k.lastIndexOf("~");return t!==-1&&(k=k.substring(0,t)),v&&(k=`${k}~${v}`),{id:k}}A.modify=p;function y(m){const v=m.id.lastIndexOf("~");if(v!==-1)return m.id.substring(v+1)}A.getModifier=y;function $(m,v){return m.id===v.id&&m.color?.id===v.color?.id}A.isEqual=$})(D||(e.ThemeIcon=D={}))}),define(oe[148],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$bf=r,e.$cf=S;var n;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function r(D){return D<0?0:D>n.MAX_UINT_8?n.MAX_UINT_8:D|0}function S(D){return D<0?0:D>n.MAX_UINT_32?n.MAX_UINT_32:D|0}}),define(oe[26],ae([0,1,145,39,65,148]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.GraphemeBreakType=e.$5f=e.$Wf=e.$Pf=e.$Of=void 0,e.$df=A,e.$ef=b,e.$ff=h,e.$gf=f,e.$hf=g,e.$if=w,e.$jf=l,e.$kf=p,e.$lf=y,e.$mf=$,e.$nf=m,e.$of=v,e.$pf=k,e.$qf=t,e.$rf=o,e.$sf=i,e.$tf=c,e.$uf=s,e.$vf=u,e.$wf=d,e.$xf=P,e.$yf=E,e.$zf=O,e.$Af=T,e.$Bf=L,e.$Cf=R,e.$Df=M,e.$Ef=B,e.$Ff=C,e.$Gf=z,e.$Hf=ne,e.$If=Q,e.$Jf=ce,e.$Kf=K,e.$Lf=ee,e.$Mf=H,e.$Nf=j,e.$Qf=G,e.$Rf=he,e.$Sf=se,e.$Tf=_,e.$Uf=W,e.$Vf=Y,e.$Xf=X,e.$Yf=Z,e.$Zf=ie,e.$1f=de,e.$2f=we,e.$3f=Ie,e.$4f=Pe,e.$6f=De,e.$7f=$e,e.$8f=J,e.$9f=ue,e.$0f=fe,e.$$f=be,e.$_f=Ae,e.$ag=We,e.$bg=Je;function A(te){return!te||typeof te!="string"?!0:te.trim().length===0}const I=/{(\d+)}/g;function b(te,...ge){return ge.length===0?te:te.replace(I,function(pe,ye){const Me=parseInt(ye,10);return isNaN(Me)||Me<0||Me>=ge.length?pe:ge[Me]})}const a=/{([^}]+)}/g;function h(te,ge){return Object.keys(ge).length===0?te:te.replace(a,(pe,ye)=>ge[ye]??pe)}function f(te){return te.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function g(te){return te.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function w(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(te,ge){let pe=0,ye=te.indexOf(ge);for(;ye!==-1;)pe++,ye=te.indexOf(ge,ye+ge.length);return pe}function p(te,ge,pe="\u2026"){return te.length<=ge?te:`${te.substr(0,ge)}${pe}`}function y(te,ge,pe="\u2026"){if(te.length<=ge)return te;const ye=Math.ceil(ge/2)-pe.length/2,Me=Math.floor(ge/2)-pe.length/2;return`${te.substr(0,ye)}${pe}${te.substr(te.length-Me)}`}function $(te,ge=" "){const pe=m(te,ge);return v(pe,ge)}function m(te,ge){if(!te||!ge)return te;const pe=ge.length;if(pe===0||te.length===0)return te;let ye=0;for(;te.indexOf(ge,ye)===ye;)ye=ye+pe;return te.substring(ye)}function v(te,ge){if(!te||!ge)return te;const pe=ge.length,ye=te.length;if(pe===0||ye===0)return te;let Me=ye,Be=-1;for(;Be=te.lastIndexOf(ge,Me-1),!(Be===-1||Be+pe!==Me);){if(Be===0)return"";Me=Be}return te.substring(0,Me)}function k(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(te){return te.replace(/\*/g,"")}function o(te,ge,pe={}){if(!te)throw new Error("Cannot create regex from empty string");ge||(te=w(te)),pe.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(te,ye)}function i(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}function c(te){return te.split(/\r\n|\r|\n/)}function s(te){const ge=[],pe=te.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ge.push(pe[2*ye]+(pe[2*ye+1]??""));return ge}function u(te){for(let ge=0,pe=te.length;ge<pe;ge++){const ye=te.charCodeAt(ge);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return ge}return-1}function d(te,ge=0,pe=te.length){for(let ye=ge;ye<pe;ye++){const Me=te.charCodeAt(ye);if(Me!==r.CharCode.Space&&Me!==r.CharCode.Tab)return te.substring(ge,ye)}return te.substring(ge,pe)}function P(te,ge=te.length-1){for(let pe=ge;pe>=0;pe--){const ye=te.charCodeAt(pe);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return pe}return-1}function E(te,ge,pe){const ye=[];let Me=0;for(const Be of te.matchAll(ge)){if(ye.push(te.slice(Me,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Me=Be.index+Be[0].length,ye.push(pe(Be[0],...Be.slice(1),Be.index,te,Be.groups))}return ye.push(te.slice(Me)),Promise.all(ye).then(Be=>Be.join(""))}function O(te,ge){return te<ge?-1:te>ge?1:0}function T(te,ge,pe=0,ye=te.length,Me=0,Be=ge.length){for(;pe<ye&&Me<Be;pe++,Me++){const rt=te.charCodeAt(pe),at=ge.charCodeAt(Me);if(rt<at)return-1;if(rt>at)return 1}const Qe=ye-pe,lt=Be-Me;return Qe<lt?-1:Qe>lt?1:0}function L(te,ge){return R(te,ge,0,te.length,0,ge.length)}function R(te,ge,pe=0,ye=te.length,Me=0,Be=ge.length){for(;pe<ye&&Me<Be;pe++,Me++){let rt=te.charCodeAt(pe),at=ge.charCodeAt(Me);if(rt===at)continue;if(rt>=128||at>=128)return T(te.toLowerCase(),ge.toLowerCase(),pe,ye,Me,Be);B(rt)&&(rt-=32),B(at)&&(at-=32);const tt=rt-at;if(tt!==0)return tt}const Qe=ye-pe,lt=Be-Me;return Qe<lt?-1:Qe>lt?1:0}function M(te){return te>=r.CharCode.Digit0&&te<=r.CharCode.Digit9}function B(te){return te>=r.CharCode.a&&te<=r.CharCode.z}function C(te){return te>=r.CharCode.A&&te<=r.CharCode.Z}function z(te,ge){return te.length===ge.length&&R(te,ge)===0}function ne(te,ge){const pe=ge.length;return ge.length>te.length?!1:R(te,ge,0,pe)===0}function Q(te,ge){const pe=Math.min(te.length,ge.length);let ye;for(ye=0;ye<pe;ye++)if(te.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return pe}function ce(te,ge){const pe=Math.min(te.length,ge.length);let ye;const Me=te.length-1,Be=ge.length-1;for(ye=0;ye<pe;ye++)if(te.charCodeAt(Me-ye)!==ge.charCodeAt(Be-ye))return ye;return pe}function K(te){return 55296<=te&&te<=56319}function ee(te){return 56320<=te&&te<=57343}function H(te,ge){return(te-55296<<10)+(ge-56320)+65536}function j(te,ge,pe){const ye=te.charCodeAt(pe);if(K(ye)&&pe+1<ge){const Me=te.charCodeAt(pe+1);if(ee(Me))return H(ye,Me)}return ye}function U(te,ge){const pe=te.charCodeAt(ge-1);if(ee(pe)&&ge>1){const ye=te.charCodeAt(ge-2);if(K(ye))return H(ye,pe)}return pe}class V{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=U(this.c,this.e);return this.e-=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=j(this.c,this.d,this.e);return this.e+=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Of=V;class le{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new V(ge,pe)}nextGraphemeLength(){const ge=Ue.getInstance(),pe=this.c,ye=pe.offset;let Me=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Be=pe.offset,Qe=ge.getGraphemeBreakType(pe.nextCodePoint());if(Fe(Me,Qe)){pe.setOffset(Be);break}Me=Qe}return pe.offset-ye}prevGraphemeLength(){const ge=Ue.getInstance(),pe=this.c,ye=pe.offset;let Me=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Be=pe.offset,Qe=ge.getGraphemeBreakType(pe.prevCodePoint());if(Fe(Qe,Me)){pe.setOffset(Be);break}Me=Qe}return ye-pe.offset}eol(){return this.c.eol()}}e.$Pf=le;function G(te,ge){return new le(te,ge).nextGraphemeLength()}function he(te,ge){return new le(te,ge).prevGraphemeLength()}function se(te,ge){ge>0&&ee(te.charCodeAt(ge))&&ge--;const pe=ge+G(te,ge);return[pe-he(te,pe),pe]}function _(te){const ge=new le(te);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let F;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(te){return F||(F=N()),F.test(te)}const q=/^[\t\n\r\x20-\x7E]*$/;function Y(te){return q.test(te)}e.$Wf=/[\u2028\u2029]/;function X(te){return e.$Wf.test(te)}function Z(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}function ie(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}function de(te,ge,pe=""){const ye=te.trimStart();if(ye.length<ge)return ye;const Me=/\b/g;let Be=0;for(;Me.test(ye)&&!(ye.length-Me.lastIndex<ge);)Be=Me.lastIndex,Me.lastIndex+=1;return Be===0?ye:pe+ye.substring(Be).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(te){let ge=0;for(const pe of te.matchAll(me))ge!==pe.index&&(yield{isCode:!1,str:te.substring(ge,pe.index)}),yield{isCode:!0,str:pe[0]},ge=pe.index+pe[0].length;ge!==te.length&&(yield{isCode:!1,str:te.substring(ge)})}function Ie(te){return te&&(te=te.replace(me,"")),te}const ke=/\\\[.*?\\\]/g;function Pe(te){return Ie(te).replace(ke,"")}e.$5f=String.fromCharCode(r.CharCode.UTF8_BOM);function De(te){return!!(te&&te.length>0&&te.charCodeAt(0)===r.CharCode.UTF8_BOM)}function $e(te){return De(te)?te.substr(1):te}function J(te,ge){if(!te||!ge||te.length<ge.length)return!1;const pe=ge.length,ye=te.toLowerCase();let Me=0,Be=-1;for(;Me<pe;){const Qe=ye.indexOf(ge[Me],Be+1);if(Qe<0)return!1;Be=Qe,Me++}return!0}function ue(te,ge=!1){return te?(ge&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}function fe(te){return te.charAt(0).toUpperCase()+te.slice(1)}function be(te,ge=1){if(ge===0)return"";let pe=-1;do pe=te.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?te:(te[pe-1]==="\r"&&pe--,te.substr(0,pe))}function Ae(te){const ge=r.CharCode.Z-r.CharCode.A+1;return te=te%(2*ge),te<ge?String.fromCharCode(r.CharCode.a+te):String.fromCharCode(r.CharCode.A+te-ge)}function We(te){return Ue.getInstance().getGraphemeBreakType(te)}function Fe(te,ge){return te===Oe.Other?ge!==Oe.Extend&&ge!==Oe.SpacingMark:te===Oe.CR&&ge===Oe.LF?!1:te===Oe.Control||te===Oe.CR||te===Oe.LF||ge===Oe.Control||ge===Oe.CR||ge===Oe.LF?!0:!(te===Oe.L&&(ge===Oe.L||ge===Oe.V||ge===Oe.LV||ge===Oe.LVT)||(te===Oe.LV||te===Oe.V)&&(ge===Oe.V||ge===Oe.T)||(te===Oe.LVT||te===Oe.T)&&ge===Oe.T||ge===Oe.Extend||ge===Oe.ZWJ||ge===Oe.SpacingMark||te===Oe.Prepend||te===Oe.ZWJ&&ge===Oe.Extended_Pictographic||te===Oe.Regional_Indicator&&ge===Oe.Regional_Indicator)}var Oe;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(e.GraphemeBreakType=Oe={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=Ve()}getGraphemeBreakType(ge){if(ge<32)return ge===r.CharCode.LineFeed?Oe.LF:ge===r.CharCode.CarriageReturn?Oe.CR:Oe.Control;if(ge<127)return Oe.Other;const pe=this.d,ye=pe.length/3;let Me=1;for(;Me<=ye;)if(ge<pe[3*Me])Me=2*Me;else if(ge>pe[3*Me+1])Me=2*Me+1;else return pe[3*Me+2];return Oe.Other}}function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(te,ge){if(te===0)return 0;const pe=qe(te,ge);if(pe!==void 0)return pe;const ye=new V(ge,te);return ye.prevCodePoint(),ye.offset}function qe(te,ge){const pe=new V(ge,te);let ye=pe.prevCodePoint();for(;Ye(ye)||ye===Xe.emojiVariantSelector||ye===Xe.enclosingKeyCap;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!ie(ye))return;let Me=pe.offset;return Me>0&&pe.prevCodePoint()===Xe.zwj&&(Me=pe.offset),Me}function Ye(te){return 127995<=te&&te<=127999}var Xe;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.$cg="\xA0";class Ke{static{this.c=new S.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$_e({getCacheKey:JSON.stringify},ge=>{function pe(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function Me(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Be=this.c.value;let Qe=ge.filter(tt=>!tt.startsWith("_")&&tt in Be);Qe.length===0&&(Qe=["_default"]);let lt;for(const tt of Qe){const ut=pe(Be[tt]);lt=Me(lt,ut)}const rt=pe(Be._common),at=ye(rt,lt);return new Ke(at)})}static getInstance(ge){return Ke.d.get(Array.from(ge))}static{this.e=new S.$X(()=>Object.keys(Ke.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ke.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$dg=Ke;class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(ge){return Ne.e().has(ge)}static containsInvisibleCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&Ne.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ne.e()}}e.$eg=Ne}),define(oe[46],ae([0,1,26]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=r,e.$uj=S,e.$vj=D,e.$wj=I,e.$yj=p,n=Re(n);function r($){return S($,0)}function S($,m){switch(typeof $){case"object":return $===null?D(349,m):Array.isArray($)?b($,m):a($,m);case"string":return I($,m);case"boolean":return A($,m);case"number":return D($,m);case"undefined":return D(937,m);default:return D(617,m)}}function D($,m){return(m<<5)-m+$|0}function A($,m){return D($?433:863,m)}function I($,m){m=D(149417,m);for(let v=0,k=$.length;v<k;v++)m=D($.charCodeAt(v),m);return m}function b($,m){return m=D(104579,m),$.reduce((v,k)=>S(k,v),m)}function a($,m){return m=D(181387,m),Object.keys($).sort().reduce((v,k)=>(v=I(k,v),S($[k],v)),m)}class h{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=S(m,this.g),this.g}}e.$xj=h;var f;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(f||(f={}));function g($,m,v=32){const k=v-m,t=~((1<<k)-1);return($<<m|(t&$)>>>k)>>>0}function w($,m=0,v=$.byteLength,k=0){for(let t=0;t<v;t++)$[m+t]=k}function l($,m,v="0"){for(;$.length<m;)$=v+$;return $}function p($,m=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(v=>v.toString(16).padStart(2,"0")).join(""):l(($>>>0).toString(16),m/4)}class y{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(f.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const v=m.length;if(v===0)return;const k=this.p;let t=this.r,o=this.u,i,c;for(o!==0?(i=o,c=-1,o=0):(i=m.charCodeAt(0),c=0);;){let s=i;if(n.$Kf(i))if(c+1<v){const u=m.charCodeAt(c+1);n.$Lf(u)?(c++,s=n.$Mf(i,u)):s=f.UNICODE_REPLACEMENT}else{o=i;break}else n.$Lf(i)&&(s=f.UNICODE_REPLACEMENT);if(t=this.w(k,t,s),c++,c<v)i=m.charCodeAt(c);else break}this.r=t,this.u=o}w(m,v,k){return k<128?m[v++]=k:k<2048?(m[v++]=192|(k&1984)>>>6,m[v++]=128|(k&63)>>>0):k<65536?(m[v++]=224|(k&61440)>>>12,m[v++]=128|(k&4032)>>>6,m[v++]=128|(k&63)>>>0):(m[v++]=240|(k&1835008)>>>18,m[v++]=128|(k&258048)>>>12,m[v++]=128|(k&4032)>>>6,m[v++]=128|(k&63)>>>0),v>=f.BLOCK_SIZE&&(this.y(),v-=f.BLOCK_SIZE,this.t+=f.BLOCK_SIZE,m[0]=m[f.BLOCK_SIZE+0],m[1]=m[f.BLOCK_SIZE+1],m[2]=m[f.BLOCK_SIZE+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,f.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=y.g,v=this.q;for(let P=0;P<64;P+=4)m.setUint32(P,v.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)m.setUint32(P,g(m.getUint32(P-12,!1)^m.getUint32(P-32,!1)^m.getUint32(P-56,!1)^m.getUint32(P-64,!1),1),!1);let k=this.h,t=this.l,o=this.m,i=this.n,c=this.o,s,u,d;for(let P=0;P<80;P++)P<20?(s=t&o|~t&i,u=1518500249):P<40?(s=t^o^i,u=1859775393):P<60?(s=t&o|t&i|o&i,u=2400959708):(s=t^o^i,u=3395469782),d=g(k,5)+s+c+u+m.getUint32(P*4,!1)&4294967295,c=i,i=o,o=g(t,30),t=k,k=d;this.h=this.h+k&4294967295,this.l=this.l+t&4294967295,this.m=this.m+o&4294967295,this.n=this.n+i&4294967295,this.o=this.o+c&4294967295}}e.$zj=y}),define(oe[79],ae([0,1,26]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=Re(n);var r;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(r||(r={})),function(S){const D="error",A="warning",I="warn",b="info",a="ignore";function h(g){return g?n.$Gf(D,g)?S.Error:n.$Gf(A,g)||n.$Gf(I,g)?S.Warning:n.$Gf(b,g)?S.Info:S.Ignore:S.Ignore}S.fromValue=h;function f(g){switch(g){case S.Error:return D;case S.Warning:return A;case S.Info:return b;default:return a}}S.toString=f}(r||(r={})),e.default=r}),define(oe[61],ae([0,1,22,39,26]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class D{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const p=l.charCodeAt(0),y=this.b.charCodeAt(this.c);return p-y}value(){return this.b[this.c]}}e.$Hi=D;class A{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,S.$Af)(l,this.b,0,l.length,this.c,this.d):(0,S.$Cf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=A;class I{constructor(l=!0,p=!0){this.f=l,this.g=p}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let p=l.length-1;p>=0;p--,this.c--){const y=this.b.charCodeAt(p);if(!(y===r.CharCode.Slash||this.f&&y===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===r.CharCode.Slash||this.f&&p===r.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,S.$Af)(l,this.b,0,l.length,this.d,this.e):(0,S.$Cf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=I;var b;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(b||(b={}));class a{constructor(l,p){this.f=l,this.g=p,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(b.Scheme),this.c.authority&&this.d.push(b.Authority),this.c.path&&(this.b=new I(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(b.Path)),this.g(l)||(this.c.query&&this.d.push(b.Query),this.c.fragment&&this.d.push(b.Fragment)),this.e=0,this}next(){return this.d[this.e]===b.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===b.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===b.Scheme)return(0,S.$Bf)(l,this.c.scheme);if(this.d[this.e]===b.Authority)return(0,S.$Bf)(l,this.c.authority);if(this.d[this.e]===b.Path)return this.b.cmp(l);if(this.d[this.e]===b.Query)return(0,S.$zf)(l,this.c.query);if(this.d[this.e]===b.Fragment)return(0,S.$zf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===b.Scheme)return this.c.scheme;if(this.d[this.e]===b.Authority)return this.c.authority;if(this.d[this.e]===b.Path)return this.b.value();if(this.d[this.e]===b.Query)return this.c.query;if(this.d[this.e]===b.Fragment)return this.c.fragment;throw new Error}}e.$Ki=a;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(f||(f={}));class g{static forUris(l=()=>!1,p=()=>!1){return new g(new a(l,p))}static forPaths(l=!1){return new g(new I(void 0,!l))}static forStrings(){return new g(new D)}static forConfigKeys(){return new g(new A)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,p){if(p){const y=p.slice(0);(0,n.$Yb)(y);for(const $ of y)this.set($,l)}else{const y=l.slice(0);(0,n.$Yb)(y);for(const $ of y)this.set($[0],$[1])}}set(l,p){const y=this.b.reset(l);let $;this.c||(this.c=new h,this.c.segment=y.value());const m=[];for($=this.c;;){const k=y.cmp($.segment);if(k>0)$.left||($.left=new h,$.left.segment=y.value()),m.push([f.Left,$]),$=$.left;else if(k<0)$.right||($.right=new h,$.right.segment=y.value()),m.push([f.Right,$]),$=$.right;else if(y.hasNext())y.next(),$.mid||($.mid=new h,$.mid.segment=y.value()),m.push([f.Mid,$]),$=$.mid;else break}const v=$.value;$.value=p,$.key=l;for(let k=m.length-1;k>=0;k--){const t=m[k][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const i=m[k][0],c=m[k+1][0];if(i===f.Right&&c===f.Right)m[k][1]=t.rotateLeft();else if(i===f.Left&&c===f.Left)m[k][1]=t.rotateRight();else if(i===f.Right&&c===f.Left)t.right=m[k+1][1]=m[k+1][1].rotateRight(),m[k][1]=t.rotateLeft();else if(i===f.Left&&c===f.Right)t.left=m[k+1][1]=m[k+1][1].rotateLeft(),m[k][1]=t.rotateRight();else throw new Error;if(k>0)switch(m[k-1][0]){case f.Left:m[k-1][1].left=m[k][1];break;case f.Right:m[k-1][1].right=m[k][1];break;case f.Mid:m[k-1][1].mid=m[k][1];break}else this.c=m[0][1]}}return v}get(l){return this.d(l)?.value}d(l){const p=this.b.reset(l);let y=this.c;for(;y;){const $=p.cmp(y.segment);if($>0)y=y.left;else if($<0)y=y.right;else if(p.hasNext())p.next(),y=y.mid;else break}return y}has(l){const p=this.d(l);return!(p?.value===void 0&&p?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,p){const y=this.b.reset(l),$=[];let m=this.c;for(;m;){const v=y.cmp(m.segment);if(v>0)$.push([f.Left,m]),m=m.left;else if(v<0)$.push([f.Right,m]),m=m.right;else if(y.hasNext())y.next(),$.push([f.Mid,m]),m=m.mid;else break}if(m){if(p?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const v=this.f(m.right);if(v.key){const{key:k,value:t,segment:o}=v;this.e(v.key,!1),m.key=k,m.value=t,m.segment=o}}else{const v=m.left??m.right;if($.length>0){const[k,t]=$[$.length-1];switch(k){case f.Left:t.left=v;break;case f.Mid:t.mid=v;break;case f.Right:t.right=v;break}}else this.c=v}for(let v=$.length-1;v>=0;v--){const k=$[v][1];k.updateHeight();const t=k.balanceFactor();if(t>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),$[v][1]=k.rotateLeft()):t<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),$[v][1]=k.rotateRight()),v>0)switch($[v-1][0]){case f.Left:$[v-1][1].left=$[v][1];break;case f.Right:$[v-1][1].right=$[v][1];break;case f.Mid:$[v-1][1].mid=$[v][1];break}else this.c=$[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const p=this.b.reset(l);let y=this.c,$;for(;y;){const m=p.cmp(y.segment);if(m>0)y=y.left;else if(m<0)y=y.right;else if(p.hasNext())p.next(),$=y.value||$,y=y.mid;else break}return y&&y.value||$}findSuperstr(l){return this.g(l,!1)}g(l,p){const y=this.b.reset(l);let $=this.c;for(;$;){const m=y.cmp($.segment);if(m>0)$=$.left;else if(m<0)$=$.right;else if(y.hasNext())y.next(),$=$.mid;else return $.mid?this.h($.mid):p?$.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[p,y]of this)l(y,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const p=[];return this.j(l,p),p[Symbol.iterator]()}j(l,p){l&&(l.left&&this.j(l.left,p),l.value&&p.push([l.key,l.value]),l.mid&&this.j(l.mid,p),l.right&&this.j(l.right,p))}_isBalanced(){const l=p=>{if(!p)return!0;const y=p.balanceFactor();return y<-1||y>1?!1:l(p.left)&&l(p.right)};return l(this.c)}}e.$Li=g}),define(oe[33],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=r;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(S){return n.test(S)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(I){for(let b=0;b<I.length;b++)I[b]=Math.floor(Math.random()*256);return I};const D=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){S(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let b=0,a="";return a+=A[D[b++]],a+=A[D[b++]],a+=A[D[b++]],a+=A[D[b++]],a+="-",a+=A[D[b++]],a+=A[D[b++]],a+="-",a+=A[D[b++]],a+=A[D[b++]],a+="-",a+=A[D[b++]],a+=A[D[b++]],a+="-",a+=A[D[b++]],a+=A[D[b++]],a+=A[D[b++]],a+=A[D[b++]],a+=A[D[b++]],a+=A[D[b++]],a}}()}),define(oe[149],ae([0,1,92,47,90]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xX=D,n=Re(n),r=Re(r);async function D(A,I){if(await new Promise((h,f)=>{const g=r.createReadStream(A),w=n.createHash("sha256");g.pipe(w);const l=(0,S.$fb)((p,y)=>{g.removeAllListeners(),w.removeAllListeners(),p?f(p):h(y)});g.once("error",l),g.once("end",l),w.once("error",l),w.once("data",p=>l(void 0,p.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(oe[150],ae([0,1,27]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=D;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function S(A){const I=A.replace(/\-/g,":").toLowerCase();return!r.has(I)}function D(){const A=(0,n.networkInterfaces)();for(const I in A){const b=A[I];if(b){for(const{mac:a}of b)if(S(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(oe[112],ae([0,1,93]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=r,e.$6g=D,n=Re(n);function r(I,b,a,h=1){let f=!1;return new Promise(g=>{const w=setTimeout(()=>{if(!f)return f=!0,g(0)},a);S(I,b,h,l=>{if(!f)return f=!0,clearTimeout(w),g(l)})})}function S(I,b,a,h){if(b===0)return h(0);const f=new n.Socket;f.once("connect",()=>(A(f),S(I+a,b-1,a,h))),f.once("data",()=>{}),f.once("error",g=>(A(f),g.code!=="ECONNREFUSED"?S(I+a,b-1,a,h):h(I))),f.connect(I,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(I,b,a,h="127.0.0.1"){let f=!1,g,w=1;const l=n.createServer({pauseOnConnect:!0});function p(y,$){f||(f=!0,l.removeAllListeners(),l.close(),g&&clearTimeout(g),$(y))}return new Promise(y=>{g=setTimeout(()=>{p(0,y)},a),l.on("listening",()=>{p(I,y)}),l.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&w<b?(I++,w++,l.listen(I,h)):p(0,y)}),l.on("close",()=>{p(0,y)}),l.listen(I,h)})}function A(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(b){console.error(b)}}}),function(){function x(){function e(){return process.uncHostAllowlist}function n(b){const a=new Set;if(Array.isArray(b))for(const h of b)typeof h=="string"&&a.add(h);return Array.from(a)}function r(){const b=e();return b?Array.from(b):[]}function S(b){if(process.platform!=="win32")return;const a=e();if(a)if(typeof b=="string")a.add(b.toLowerCase());else for(const h of n(b))S(h)}function D(b){if(typeof b!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let h;for(const f of a){if(b.indexOf(f)!==0)continue;const w=b.indexOf("\\",f.length);if(w===-1)continue;const l=b.substring(f.length,w);if(l){h=l;break}}return h}function A(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:S,getUNCHost:D,disableUNCAccessRestrictions:A,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return x()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=x():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[151],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DX=e.$CX=void 0,e.$CX="vscode:contextmenu",e.$DX="vscode:onCloseContextMenu"}),define(oe[152],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KX=void 0;class n{constructor(S,D){this.a=S,this.onMessage=D}send(S){try{this.a.send("vscode:message",S.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$KX=n}),define(oe[153],ae([11,10]),function(x,e){return x.create("vs/base/common/date",e)}),define(oe[154],ae([0,1,153]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=a,e.$2m=h,e.$3m=f;const r=60,S=r*60,D=S*24,A=D*7,I=D*30,b=D*365;function a(g,w,l,p){typeof g!="number"&&(g=g.getTime());const y=Math.round((new Date().getTime()-g)/1e3);if(y<-30)return(0,n.localize)(0,null,a(new Date().getTime()+y*1e3,!1));if(!p&&y<30)return(0,n.localize)(1,null);let $;return y<r?($=y,w?$===1?l?(0,n.localize)(2,null,$):(0,n.localize)(3,null,$):l?(0,n.localize)(4,null,$):(0,n.localize)(5,null,$):$===1?l?(0,n.localize)(6,null,$):(0,n.localize)(7,null,$):l?(0,n.localize)(8,null,$):(0,n.localize)(9,null,$)):y<S?($=Math.floor(y/r),w?$===1?l?(0,n.localize)(10,null,$):(0,n.localize)(11,null,$):l?(0,n.localize)(12,null,$):(0,n.localize)(13,null,$):$===1?l?(0,n.localize)(14,null,$):(0,n.localize)(15,null,$):l?(0,n.localize)(16,null,$):(0,n.localize)(17,null,$)):y<D?($=Math.floor(y/S),w?$===1?l?(0,n.localize)(18,null,$):(0,n.localize)(19,null,$):l?(0,n.localize)(20,null,$):(0,n.localize)(21,null,$):$===1?l?(0,n.localize)(22,null,$):(0,n.localize)(23,null,$):l?(0,n.localize)(24,null,$):(0,n.localize)(25,null,$)):y<A?($=Math.floor(y/D),w?$===1?(0,n.localize)(26,null,$):(0,n.localize)(27,null,$):$===1?(0,n.localize)(28,null,$):(0,n.localize)(29,null,$)):y<I?($=Math.floor(y/A),w?$===1?l?(0,n.localize)(30,null,$):(0,n.localize)(31,null,$):l?(0,n.localize)(32,null,$):(0,n.localize)(33,null,$):$===1?l?(0,n.localize)(34,null,$):(0,n.localize)(35,null,$):l?(0,n.localize)(36,null,$):(0,n.localize)(37,null,$)):y<b?($=Math.floor(y/I),w?$===1?l?(0,n.localize)(38,null,$):(0,n.localize)(39,null,$):l?(0,n.localize)(40,null,$):(0,n.localize)(41,null,$):$===1?l?(0,n.localize)(42,null,$):(0,n.localize)(43,null,$):l?(0,n.localize)(44,null,$):(0,n.localize)(45,null,$)):($=Math.floor(y/b),w?$===1?l?(0,n.localize)(46,null,$):(0,n.localize)(47,null,$):l?(0,n.localize)(48,null,$):(0,n.localize)(49,null,$):$===1?l?(0,n.localize)(50,null,$):(0,n.localize)(51,null,$):l?(0,n.localize)(52,null,$):(0,n.localize)(53,null,$))}function h(g,w){const l=Math.abs(g/1e3);return l<1?w?(0,n.localize)(54,null,g):(0,n.localize)(55,null,g):l<r?w?(0,n.localize)(56,null,Math.round(g)/1e3):(0,n.localize)(57,null,Math.round(g)/1e3):l<S?w?(0,n.localize)(58,null,Math.round(g/(1e3*r))):(0,n.localize)(59,null,Math.round(g/(1e3*r))):l<D?w?(0,n.localize)(60,null,Math.round(g/(1e3*S))):(0,n.localize)(61,null,Math.round(g/(1e3*S))):(0,n.localize)(62,null,Math.round(g/(1e3*D)))}function f(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(oe[155],ae([11,10]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(oe[53],ae([0,1,22,12,155]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=b,e.$rj=a,e.$sj=h,n=Re(n),r=Re(r),S=Re(S);function D(f,g){return g&&(f.stack||f.stacktrace)?S.localize(0,null,I(f),A(f.stack)||A(f.stacktrace)):I(f)}function A(f){return Array.isArray(f)?f.join(`
`):f}function I(f){return f.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${f.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?S.localize(1,null,f.message):f.message||S.localize(2,null)}function b(f=null,g=!1){if(!f)return S.localize(3,null);if(Array.isArray(f)){const w=n.$Jb(f),l=b(w[0],g);return w.length>1?S.localize(4,null,l,w.length):l}if(r.$fg(f))return f;if(f.detail){const w=f.detail;if(w.error)return D(w.error,g);if(w.exception)return D(w.exception,g)}return f.stack?D(f,g):f.message?f.message:S.localize(5,null)}function a(f){const g=f;return g instanceof Error&&Array.isArray(g.actions)}function h(f,g){let w;return typeof f=="string"?w=new Error(f):w=f,w.actions=g,w}}),define(oe[156],ae([11,10]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(oe[157],ae([0,1,156,43]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=S;function S(D){switch(D){case r.ParseErrorCode.InvalidSymbol:return(0,n.localize)(0,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(1,null);case r.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(2,null);case r.ParseErrorCode.ValueExpected:return(0,n.localize)(3,null);case r.ParseErrorCode.ColonExpected:return(0,n.localize)(4,null);case r.ParseErrorCode.CommaExpected:return(0,n.localize)(5,null);case r.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(6,null);case r.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(7,null);case r.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(8,null);default:return""}}}),define(oe[158],ae([11,10]),function(x,e){return x.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,158]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=i,e.$D=E,e.$J=O,n=Re(n),e.$g="en";let r=!1,S=!1,D=!1,A=!1,I=!1,b=!1,a=!1,h=!1,f=!1,g=!1,w,l=e.$g,p=e.$g,y,$;const m=globalThis;let v;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?v=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const k=typeof v?.versions?.electron=="string",t=k&&v?.type==="renderer";if(typeof v=="object"){r=v.platform==="win32",S=v.platform==="darwin",D=v.platform==="linux",A=D&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,a=k,f=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.$g,l=e.$g;const T=v.env.VSCODE_NLS_CONFIG;if(T)try{const L=JSON.parse(T),R=L.availableLanguages["*"];w=L.locale,p=L.osLocale,l=R||e.$g,y=L._translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!t?($=navigator.userAgent,r=$.indexOf("Windows")>=0,S=$.indexOf("Macintosh")>=0,h=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=$.indexOf("Linux")>=0,g=$?.indexOf("Mobi")>=0,b=!0,w=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,l=w,p=navigator.language):console.error("Unable to resolve platform.");var o;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(o||(e.Platform=o={}));function i(T){switch(T){case o.Web:return"Web";case o.Mac:return"Mac";case o.Linux:return"Linux";case o.Windows:return"Windows"}}let c=o.Web;S?c=o.Mac:r?c=o.Windows:D&&(c=o.Linux),e.$i=r,e.$j=S,e.$k=D,e.$l=A,e.$m=I,e.$n=a,e.$o=b,e.$p=b&&typeof m.importScripts=="function",e.$q=e.$p?m.origin:void 0,e.$r=h,e.$s=g,e.$t=f,e.$u=c,e.$v=$,e.$w=l;var s;(function(T){function L(){return e.$w}T.value=L;function R(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}T.isDefaultVariant=R;function M(){return e.$w==="en"}T.isDefault=M})(s||(e.Language=s={})),e.$x=w,e.$y=p,e.$z=y,e.$A=typeof m.postMessage=="function"&&!m.importScripts,e.$B=(()=>{if(e.$A){const T=[];m.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let M=0,B=T.length;M<B;M++){const C=T[M];if(C.id===R.data.vscodeScheduleAsyncWork){T.splice(M,1),C.callback();return}}});let L=0;return R=>{const M=++L;T.push({id:M,callback:R}),m.postMessage({vscodeScheduleAsyncWork:M},"*")}}return T=>setTimeout(T)})();var u;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=S||h?u.Macintosh:r?u.Windows:u.Linux;let d=!0,P=!1;function E(){if(!P){P=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,d=new Uint16Array(T.buffer)[0]===513}return d}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function O(T){return parseFloat(T)>=20}}),define(oe[36],ae([0,1,4]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gc=e.$fc=e.env=e.cwd=void 0;let r;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const D=S.process;r={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$fc=r.platform,e.$gc=r.arch}),define(oe[9],ae([0,1,36]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.sep=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=void 0,n=Re(n);const r=65,S=97,D=90,A=122,I=46,b=47,a=92,h=58,f=63;class g extends Error{constructor(i,c,s){let u;typeof c=="string"&&c.indexOf("not ")===0?(u="must not be",c=c.replace(/^not /,"")):u="must be";const d=i.indexOf(".")!==-1?"property":"argument";let P=`The "${i}" ${d} ${u} of type ${c}`;P+=`. Received type ${typeof s}`,super(P),this.code="ERR_INVALID_ARG_TYPE"}}function w(o,i){if(o===null||typeof o!="object")throw new g(i,"Object",o)}function l(o,i){if(typeof o!="string")throw new g(i,"string",o)}const p=n.$fc==="win32";function y(o){return o===b||o===a}function $(o){return o===b}function m(o){return o>=r&&o<=D||o>=S&&o<=A}function v(o,i,c,s){let u="",d=0,P=-1,E=0,O=0;for(let T=0;T<=o.length;++T){if(T<o.length)O=o.charCodeAt(T);else{if(s(O))break;O=b}if(s(O)){if(!(P===T-1||E===1))if(E===2){if(u.length<2||d!==2||u.charCodeAt(u.length-1)!==I||u.charCodeAt(u.length-2)!==I){if(u.length>2){const L=u.lastIndexOf(c);L===-1?(u="",d=0):(u=u.slice(0,L),d=u.length-1-u.lastIndexOf(c)),P=T,E=0;continue}else if(u.length!==0){u="",d=0,P=T,E=0;continue}}i&&(u+=u.length>0?`${c}..`:"..",d=2)}else u.length>0?u+=`${c}${o.slice(P+1,T)}`:u=o.slice(P+1,T),d=T-P-1;P=T,E=0}else O===I&&E!==-1?++E:E=-1}return u}function k(o,i){w(i,"pathObject");const c=i.dir||i.root,s=i.base||`${i.name||""}${i.ext||""}`;return c?c===i.root?`${c}${s}`:`${c}${o}${s}`:s}e.$hc={resolve(...o){let i="",c="",s=!1;for(let u=o.length-1;u>=-1;u--){let d;if(u>=0){if(d=o[u],l(d,"path"),d.length===0)continue}else i.length===0?d=n.cwd():(d=n.env[`=${i}`]||n.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==i.toLowerCase()&&d.charCodeAt(2)===a)&&(d=`${i}\\`));const P=d.length;let E=0,O="",T=!1;const L=d.charCodeAt(0);if(P===1)y(L)&&(E=1,T=!0);else if(y(L))if(T=!0,y(d.charCodeAt(1))){let R=2,M=R;for(;R<P&&!y(d.charCodeAt(R));)R++;if(R<P&&R!==M){const B=d.slice(M,R);for(M=R;R<P&&y(d.charCodeAt(R));)R++;if(R<P&&R!==M){for(M=R;R<P&&!y(d.charCodeAt(R));)R++;(R===P||R!==M)&&(O=`\\\\${B}\\${d.slice(M,R)}`,E=R)}}}else E=1;else m(L)&&d.charCodeAt(1)===h&&(O=d.slice(0,2),E=2,P>2&&y(d.charCodeAt(2))&&(T=!0,E=3));if(O.length>0)if(i.length>0){if(O.toLowerCase()!==i.toLowerCase())continue}else i=O;if(s){if(i.length>0)break}else if(c=`${d.slice(E)}\\${c}`,s=T,T&&i.length>0)break}return c=v(c,!s,"\\",y),s?`${i}\\${c}`:`${i}${c}`||"."},normalize(o){l(o,"path");const i=o.length;if(i===0)return".";let c=0,s,u=!1;const d=o.charCodeAt(0);if(i===1)return $(d)?"\\":o;if(y(d))if(u=!0,y(o.charCodeAt(1))){let E=2,O=E;for(;E<i&&!y(o.charCodeAt(E));)E++;if(E<i&&E!==O){const T=o.slice(O,E);for(O=E;E<i&&y(o.charCodeAt(E));)E++;if(E<i&&E!==O){for(O=E;E<i&&!y(o.charCodeAt(E));)E++;if(E===i)return`\\\\${T}\\${o.slice(O)}\\`;E!==O&&(s=`\\\\${T}\\${o.slice(O,E)}`,c=E)}}}else c=1;else m(d)&&o.charCodeAt(1)===h&&(s=o.slice(0,2),c=2,i>2&&y(o.charCodeAt(2))&&(u=!0,c=3));let P=c<i?v(o.slice(c),!u,"\\",y):"";return P.length===0&&!u&&(P="."),P.length>0&&y(o.charCodeAt(i-1))&&(P+="\\"),s===void 0?u?`\\${P}`:P:u?`${s}\\${P}`:`${s}${P}`},isAbsolute(o){l(o,"path");const i=o.length;if(i===0)return!1;const c=o.charCodeAt(0);return y(c)||i>2&&m(c)&&o.charCodeAt(1)===h&&y(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let i,c;for(let d=0;d<o.length;++d){const P=o[d];l(P,"path"),P.length>0&&(i===void 0?i=c=P:i+=`\\${P}`)}if(i===void 0)return".";let s=!0,u=0;if(typeof c=="string"&&y(c.charCodeAt(0))){++u;const d=c.length;d>1&&y(c.charCodeAt(1))&&(++u,d>2&&(y(c.charCodeAt(2))?++u:s=!1))}if(s){for(;u<i.length&&y(i.charCodeAt(u));)u++;u>=2&&(i=`\\${i.slice(u)}`)}return e.$hc.normalize(i)},relative(o,i){if(l(o,"from"),l(i,"to"),o===i)return"";const c=e.$hc.resolve(o),s=e.$hc.resolve(i);if(c===s||(o=c.toLowerCase(),i=s.toLowerCase(),o===i))return"";let u=0;for(;u<o.length&&o.charCodeAt(u)===a;)u++;let d=o.length;for(;d-1>u&&o.charCodeAt(d-1)===a;)d--;const P=d-u;let E=0;for(;E<i.length&&i.charCodeAt(E)===a;)E++;let O=i.length;for(;O-1>E&&i.charCodeAt(O-1)===a;)O--;const T=O-E,L=P<T?P:T;let R=-1,M=0;for(;M<L;M++){const C=o.charCodeAt(u+M);if(C!==i.charCodeAt(E+M))break;C===a&&(R=M)}if(M!==L){if(R===-1)return s}else{if(T>L){if(i.charCodeAt(E+M)===a)return s.slice(E+M+1);if(M===2)return s.slice(E+M)}P>L&&(o.charCodeAt(u+M)===a?R=M:M===2&&(R=3)),R===-1&&(R=0)}let B="";for(M=u+R+1;M<=d;++M)(M===d||o.charCodeAt(M)===a)&&(B+=B.length===0?"..":"\\..");return E+=R,B.length>0?`${B}${s.slice(E,O)}`:(s.charCodeAt(E)===a&&++E,s.slice(E,O))},toNamespacedPath(o){if(typeof o!="string"||o.length===0)return o;const i=e.$hc.resolve(o);if(i.length<=2)return o;if(i.charCodeAt(0)===a){if(i.charCodeAt(1)===a){const c=i.charCodeAt(2);if(c!==f&&c!==I)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(m(i.charCodeAt(0))&&i.charCodeAt(1)===h&&i.charCodeAt(2)===a)return`\\\\?\\${i}`;return o},dirname(o){l(o,"path");const i=o.length;if(i===0)return".";let c=-1,s=0;const u=o.charCodeAt(0);if(i===1)return y(u)?o:".";if(y(u)){if(c=s=1,y(o.charCodeAt(1))){let E=2,O=E;for(;E<i&&!y(o.charCodeAt(E));)E++;if(E<i&&E!==O){for(O=E;E<i&&y(o.charCodeAt(E));)E++;if(E<i&&E!==O){for(O=E;E<i&&!y(o.charCodeAt(E));)E++;if(E===i)return o;E!==O&&(c=s=E+1)}}}}else m(u)&&o.charCodeAt(1)===h&&(c=i>2&&y(o.charCodeAt(2))?3:2,s=c);let d=-1,P=!0;for(let E=i-1;E>=s;--E)if(y(o.charCodeAt(E))){if(!P){d=E;break}}else P=!1;if(d===-1){if(c===-1)return".";d=c}return o.slice(0,d)},basename(o,i){i!==void 0&&l(i,"ext"),l(o,"path");let c=0,s=-1,u=!0,d;if(o.length>=2&&m(o.charCodeAt(0))&&o.charCodeAt(1)===h&&(c=2),i!==void 0&&i.length>0&&i.length<=o.length){if(i===o)return"";let P=i.length-1,E=-1;for(d=o.length-1;d>=c;--d){const O=o.charCodeAt(d);if(y(O)){if(!u){c=d+1;break}}else E===-1&&(u=!1,E=d+1),P>=0&&(O===i.charCodeAt(P)?--P===-1&&(s=d):(P=-1,s=E))}return c===s?s=E:s===-1&&(s=o.length),o.slice(c,s)}for(d=o.length-1;d>=c;--d)if(y(o.charCodeAt(d))){if(!u){c=d+1;break}}else s===-1&&(u=!1,s=d+1);return s===-1?"":o.slice(c,s)},extname(o){l(o,"path");let i=0,c=-1,s=0,u=-1,d=!0,P=0;o.length>=2&&o.charCodeAt(1)===h&&m(o.charCodeAt(0))&&(i=s=2);for(let E=o.length-1;E>=i;--E){const O=o.charCodeAt(E);if(y(O)){if(!d){s=E+1;break}continue}u===-1&&(d=!1,u=E+1),O===I?c===-1?c=E:P!==1&&(P=1):c!==-1&&(P=-1)}return c===-1||u===-1||P===0||P===1&&c===u-1&&c===s+1?"":o.slice(c,u)},format:k.bind(null,"\\"),parse(o){l(o,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return i;const c=o.length;let s=0,u=o.charCodeAt(0);if(c===1)return y(u)?(i.root=i.dir=o,i):(i.base=i.name=o,i);if(y(u)){if(s=1,y(o.charCodeAt(1))){let R=2,M=R;for(;R<c&&!y(o.charCodeAt(R));)R++;if(R<c&&R!==M){for(M=R;R<c&&y(o.charCodeAt(R));)R++;if(R<c&&R!==M){for(M=R;R<c&&!y(o.charCodeAt(R));)R++;R===c?s=R:R!==M&&(s=R+1)}}}}else if(m(u)&&o.charCodeAt(1)===h){if(c<=2)return i.root=i.dir=o,i;if(s=2,y(o.charCodeAt(2))){if(c===3)return i.root=i.dir=o,i;s=3}}s>0&&(i.root=o.slice(0,s));let d=-1,P=s,E=-1,O=!0,T=o.length-1,L=0;for(;T>=s;--T){if(u=o.charCodeAt(T),y(u)){if(!O){P=T+1;break}continue}E===-1&&(O=!1,E=T+1),u===I?d===-1?d=T:L!==1&&(L=1):d!==-1&&(L=-1)}return E!==-1&&(d===-1||L===0||L===1&&d===E-1&&d===P+1?i.base=i.name=o.slice(P,E):(i.name=o.slice(P,d),i.base=o.slice(P,E),i.ext=o.slice(d,E))),P>0&&P!==s?i.dir=o.slice(0,P-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(p){const o=/\\/g;return()=>{const i=n.cwd().replace(o,"/");return i.slice(i.indexOf("/"))}}return()=>n.cwd()})();e.$ic={resolve(...o){let i="",c=!1;for(let s=o.length-1;s>=-1&&!c;s--){const u=s>=0?o[s]:t();l(u,"path"),u.length!==0&&(i=`${u}/${i}`,c=u.charCodeAt(0)===b)}return i=v(i,!c,"/",$),c?`/${i}`:i.length>0?i:"."},normalize(o){if(l(o,"path"),o.length===0)return".";const i=o.charCodeAt(0)===b,c=o.charCodeAt(o.length-1)===b;return o=v(o,!i,"/",$),o.length===0?i?"/":c?"./":".":(c&&(o+="/"),i?`/${o}`:o)},isAbsolute(o){return l(o,"path"),o.length>0&&o.charCodeAt(0)===b},join(...o){if(o.length===0)return".";let i;for(let c=0;c<o.length;++c){const s=o[c];l(s,"path"),s.length>0&&(i===void 0?i=s:i+=`/${s}`)}return i===void 0?".":e.$ic.normalize(i)},relative(o,i){if(l(o,"from"),l(i,"to"),o===i||(o=e.$ic.resolve(o),i=e.$ic.resolve(i),o===i))return"";const c=1,s=o.length,u=s-c,d=1,P=i.length-d,E=u<P?u:P;let O=-1,T=0;for(;T<E;T++){const R=o.charCodeAt(c+T);if(R!==i.charCodeAt(d+T))break;R===b&&(O=T)}if(T===E)if(P>E){if(i.charCodeAt(d+T)===b)return i.slice(d+T+1);if(T===0)return i.slice(d+T)}else u>E&&(o.charCodeAt(c+T)===b?O=T:T===0&&(O=0));let L="";for(T=c+O+1;T<=s;++T)(T===s||o.charCodeAt(T)===b)&&(L+=L.length===0?"..":"/..");return`${L}${i.slice(d+O)}`},toNamespacedPath(o){return o},dirname(o){if(l(o,"path"),o.length===0)return".";const i=o.charCodeAt(0)===b;let c=-1,s=!0;for(let u=o.length-1;u>=1;--u)if(o.charCodeAt(u)===b){if(!s){c=u;break}}else s=!1;return c===-1?i?"/":".":i&&c===1?"//":o.slice(0,c)},basename(o,i){i!==void 0&&l(i,"ext"),l(o,"path");let c=0,s=-1,u=!0,d;if(i!==void 0&&i.length>0&&i.length<=o.length){if(i===o)return"";let P=i.length-1,E=-1;for(d=o.length-1;d>=0;--d){const O=o.charCodeAt(d);if(O===b){if(!u){c=d+1;break}}else E===-1&&(u=!1,E=d+1),P>=0&&(O===i.charCodeAt(P)?--P===-1&&(s=d):(P=-1,s=E))}return c===s?s=E:s===-1&&(s=o.length),o.slice(c,s)}for(d=o.length-1;d>=0;--d)if(o.charCodeAt(d)===b){if(!u){c=d+1;break}}else s===-1&&(u=!1,s=d+1);return s===-1?"":o.slice(c,s)},extname(o){l(o,"path");let i=-1,c=0,s=-1,u=!0,d=0;for(let P=o.length-1;P>=0;--P){const E=o.charCodeAt(P);if(E===b){if(!u){c=P+1;break}continue}s===-1&&(u=!1,s=P+1),E===I?i===-1?i=P:d!==1&&(d=1):i!==-1&&(d=-1)}return i===-1||s===-1||d===0||d===1&&i===s-1&&i===c+1?"":o.slice(i,s)},format:k.bind(null,"/"),parse(o){l(o,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return i;const c=o.charCodeAt(0)===b;let s;c?(i.root="/",s=1):s=0;let u=-1,d=0,P=-1,E=!0,O=o.length-1,T=0;for(;O>=s;--O){const L=o.charCodeAt(O);if(L===b){if(!E){d=O+1;break}continue}P===-1&&(E=!1,P=O+1),L===I?u===-1?u=O:T!==1&&(T=1):u!==-1&&(T=-1)}if(P!==-1){const L=d===0&&c?1:d;u===-1||T===0||T===1&&u===P-1&&u===d+1?i.base=i.name=o.slice(L,P):(i.name=o.slice(L,u),i.base=o.slice(L,P),i.ext=o.slice(u,P))}return d>0?i.dir=o.slice(0,d-1):c&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$ic.win32=e.$hc.win32=e.$hc,e.$ic.posix=e.$hc.posix=e.$ic,e.$jc=p?e.$hc.normalize:e.$ic.normalize,e.$kc=p?e.$hc.isAbsolute:e.$ic.isAbsolute,e.$lc=p?e.$hc.join:e.$ic.join,e.$mc=p?e.$hc.resolve:e.$ic.resolve,e.$nc=p?e.$hc.relative:e.$ic.relative,e.$oc=p?e.$hc.dirname:e.$ic.dirname,e.$pc=p?e.$hc.basename:e.$ic.basename,e.$qc=p?e.$hc.extname:e.$ic.extname,e.$rc=p?e.$hc.format:e.$ic.format,e.$sc=p?e.$hc.parse:e.$ic.parse,e.$tc=p?e.$hc.toNamespacedPath:e.$ic.toNamespacedPath,e.sep=p?e.$hc.sep:e.$ic.sep,e.$vc=p?e.$hc.delimiter:e.$ic.delimiter}),define(oe[31],ae([0,1,39,9,4,26,12]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=I,e.$yg=b,e.$zg=a,e.$Ag=h,e.$Bg=f,e.$Cg=p,e.$Dg=y,e.$Eg=$,e.$Fg=m,e.$Gg=v,e.$Hg=k,e.$Ig=t,e.$Jg=o,e.$Kg=i,e.$Lg=c,e.$Mg=s,e.$Ng=P;function I(E){return E===n.CharCode.Slash||E===n.CharCode.Backslash}function b(E){return E.replace(/[\\/]/g,r.$ic.sep)}function a(E){return E.indexOf("/")===-1&&(E=b(E)),/^[a-zA-Z]:(\/|$)/.test(E)&&(E="/"+E),E}function h(E,O=r.$ic.sep){if(!E)return"";const T=E.length,L=E.charCodeAt(0);if(I(L)){if(I(E.charCodeAt(1))&&!I(E.charCodeAt(2))){let M=3;const B=M;for(;M<T&&!I(E.charCodeAt(M));M++);if(B!==M&&!I(E.charCodeAt(M+1))){for(M+=1;M<T;M++)if(I(E.charCodeAt(M)))return E.slice(0,M+1).replace(/[\\/]/g,O)}}return O}else if(m(L)&&E.charCodeAt(1)===n.CharCode.Colon)return I(E.charCodeAt(2))?E.slice(0,2)+O:E.slice(0,2);let R=E.indexOf("://");if(R!==-1){for(R+=3;R<T;R++)if(I(E.charCodeAt(R)))return E.slice(0,R+1)}return""}function f(E){if(!S.$i||!E||E.length<5)return!1;let O=E.charCodeAt(0);if(O!==n.CharCode.Backslash||(O=E.charCodeAt(1),O!==n.CharCode.Backslash))return!1;let T=2;const L=T;for(;T<E.length&&(O=E.charCodeAt(T),O!==n.CharCode.Backslash);T++);return!(L===T||(O=E.charCodeAt(T+1),isNaN(O)||O===n.CharCode.Backslash))}const g=/[\\/:\*\?"<>\|]/g,w=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(E,O=S.$i){const T=O?g:w;return!(!E||E.length===0||/^\s+$/.test(E)||(T.lastIndex=0,T.test(E))||O&&l.test(E)||E==="."||E===".."||O&&E[E.length-1]==="."||O&&E.length!==E.trim().length||E.length>255)}function y(E,O,T){const L=E===O;return!T||L?L:!E||!O?!1:(0,D.$Gf)(E,O)}function $(E,O,T,L=r.sep){if(E===O)return!0;if(!E||!O||O.length>E.length)return!1;if(T){if(!(0,D.$Hf)(E,O))return!1;if(O.length===E.length)return!0;let M=O.length;return O.charAt(O.length-1)===L&&M--,E.charAt(M)===L}return O.charAt(O.length-1)!==L&&(O+=L),E.indexOf(O)===0}function m(E){return E>=n.CharCode.A&&E<=n.CharCode.Z||E>=n.CharCode.a&&E<=n.CharCode.z}function v(E,O){return S.$i&&E.endsWith(":")&&(E+=r.sep),(0,r.$kc)(E)||(E=(0,r.$lc)(O,E)),E=(0,r.$jc)(E),k(E)}function k(E){return S.$i?(E=(0,D.$of)(E,r.sep),E.endsWith(":")&&(E+=r.sep)):(E=(0,D.$of)(E,r.sep),E||(E=r.sep)),E}function t(E){const O=(0,r.$jc)(E);return S.$i?E.length>3?!1:o(O)&&(E.length===2||O.charCodeAt(2)===n.CharCode.Backslash):O===r.$ic.sep}function o(E,O=S.$i){return O?m(E.charCodeAt(0))&&E.charCodeAt(1)===n.CharCode.Colon:!1}function i(E,O=S.$i){return o(E,O)?E[0]:void 0}function c(E,O,T){return O.length>E.length?-1:E===O?0:(T&&(E=E.toLowerCase(),O=O.toLowerCase()),E.indexOf(O))}function s(E){const O=E.split(":");let T,L,R;for(const M of O){const B=Number(M);(0,A.$jg)(B)?L===void 0?L=B:R===void 0&&(R=B):T=T?[T,M].join(":"):M}if(!T)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:T,line:L!==void 0?L:void 0,column:R!==void 0?R:L!==void 0?1:void 0}}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function P(E,O,T=8){let L="";for(let M=0;M<T;M++){let B;M===0&&S.$i&&!O&&(T===3||T===4)?B=d:B=u,L+=B.charAt(Math.floor(Math.random()*B.length))}let R;return O?R=`${O}-${L}`:R=L,E?(0,r.$lc)(E,R):R}}),define(oe[80],ae([0,1,4]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=D,e.$lm=A;var r;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(r||(e.Source=r={}));var S;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function D(I,...b){const a=b.reduce((g,w)=>(g[w]=!0,g),{}),h=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(g=>!a[g]).forEach(g=>{for(let w=0;w<h.length;w++)if(g.search(h[w])!==-1){delete I[g];break}})}function A(I){I&&(delete I.DEBUG,n.$j&&delete I.DYLD_LIBRARY_PATH,n.$k&&delete I.LD_PRELOAD)}}),define(oe[7],ae([0,1,39,91,9,4]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$xc=y,e.$yc=o,S=Re(S);const A=/^\w[\w\d+.-]*$/,I=/^\//,b=/^\/\//;function a(d,P){if(!d.scheme&&P)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!A.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!I.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(d,P){return!d&&!P?"file":d}function f(d,P){switch(d){case"https":case"http":case"file":P?P[0]!==w&&(P=w+P):P=w;break}return P}const g="",w="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(P){return P instanceof p?!0:P?typeof P.authority=="string"&&typeof P.fragment=="string"&&typeof P.path=="string"&&typeof P.query=="string"&&typeof P.scheme=="string"&&typeof P.fsPath=="string"&&typeof P.with=="function"&&typeof P.toString=="function":!1}constructor(P,E,O,T,L,R=!1){typeof P=="object"?(this.scheme=P.scheme||g,this.authority=P.authority||g,this.path=P.path||g,this.query=P.query||g,this.fragment=P.fragment||g):(this.scheme=h(P,R),this.authority=E||g,this.path=f(this.scheme,O||g),this.query=T||g,this.fragment=L||g,a(this,R))}get fsPath(){return o(this,!1)}with(P){if(!P)return this;let{scheme:E,authority:O,path:T,query:L,fragment:R}=P;return E===void 0?E=this.scheme:E===null&&(E=g),O===void 0?O=this.authority:O===null&&(O=g),T===void 0?T=this.path:T===null&&(T=g),L===void 0?L=this.query:L===null&&(L=g),R===void 0?R=this.fragment:R===null&&(R=g),E===this.scheme&&O===this.authority&&T===this.path&&L===this.query&&R===this.fragment?this:new m(E,O,T,L,R)}static parse(P,E=!1){const O=l.exec(P);return O?new m(O[2]||g,u(O[4]||g),u(O[5]||g),u(O[7]||g),u(O[9]||g),E):new m(g,g,g,g,g)}static file(P){let E=g;if(D.$i&&(P=P.replace(/\\/g,w)),P[0]===w&&P[1]===w){const O=P.indexOf(w,2);O===-1?(E=P.substring(2),P=w):(E=P.substring(2,O),P=P.substring(O)||w)}return new m("file",E,P,g,g)}static from(P,E){return new m(P.scheme,P.authority,P.path,P.query,P.fragment,E)}static joinPath(P,...E){if(!P.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let O;return D.$i&&P.scheme==="file"?O=p.file(S.$hc.join(o(P,!0),...E)).path:O=S.$ic.join(P.path,...E),P.with({path:O})}toString(P=!1){return i(this,P)}toJSON(){return this}static revive(P){if(P){if(P instanceof p)return P;{const E=new m(P);return E._formatted=P.external??null,E._fsPath=P._sep===$?P.fsPath??null:null,E}}else return P}}e.URI=p;function y(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}const $=D.$i?1:void 0;class m extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(P=!1){return P?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const P={$mid:r.MarshalledId.Uri};return this._fsPath&&(P.fsPath=this._fsPath,P._sep=$),this._formatted&&(P.external=this._formatted),this.path&&(P.path=this.path),this.scheme&&(P.scheme=this.scheme),this.authority&&(P.authority=this.authority),this.query&&(P.query=this.query),this.fragment&&(P.fragment=this.fragment),P}}const v={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function k(d,P,E){let O,T=-1;for(let L=0;L<d.length;L++){const R=d.charCodeAt(L);if(R>=n.CharCode.a&&R<=n.CharCode.z||R>=n.CharCode.A&&R<=n.CharCode.Z||R>=n.CharCode.Digit0&&R<=n.CharCode.Digit9||R===n.CharCode.Dash||R===n.CharCode.Period||R===n.CharCode.Underline||R===n.CharCode.Tilde||P&&R===n.CharCode.Slash||E&&R===n.CharCode.OpenSquareBracket||E&&R===n.CharCode.CloseSquareBracket||E&&R===n.CharCode.Colon)T!==-1&&(O+=encodeURIComponent(d.substring(T,L)),T=-1),O!==void 0&&(O+=d.charAt(L));else{O===void 0&&(O=d.substr(0,L));const M=v[R];M!==void 0?(T!==-1&&(O+=encodeURIComponent(d.substring(T,L)),T=-1),O+=M):T===-1&&(T=L)}}return T!==-1&&(O+=encodeURIComponent(d.substring(T))),O!==void 0?O:d}function t(d){let P;for(let E=0;E<d.length;E++){const O=d.charCodeAt(E);O===n.CharCode.Hash||O===n.CharCode.QuestionMark?(P===void 0&&(P=d.substr(0,E)),P+=v[O]):P!==void 0&&(P+=d[E])}return P!==void 0?P:d}function o(d,P){let E;return d.authority&&d.path.length>1&&d.scheme==="file"?E=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===n.CharCode.Slash&&(d.path.charCodeAt(1)>=n.CharCode.A&&d.path.charCodeAt(1)<=n.CharCode.Z||d.path.charCodeAt(1)>=n.CharCode.a&&d.path.charCodeAt(1)<=n.CharCode.z)&&d.path.charCodeAt(2)===n.CharCode.Colon?P?E=d.path.substr(1):E=d.path[1].toLowerCase()+d.path.substr(2):E=d.path,D.$i&&(E=E.replace(/\//g,"\\")),E}function i(d,P){const E=P?t:k;let O="",{scheme:T,authority:L,path:R,query:M,fragment:B}=d;if(T&&(O+=T,O+=":"),(L||T==="file")&&(O+=w,O+=w),L){let C=L.indexOf("@");if(C!==-1){const z=L.substr(0,C);L=L.substr(C+1),C=z.lastIndexOf(":"),C===-1?O+=E(z,!1,!1):(O+=E(z.substr(0,C),!1,!1),O+=":",O+=E(z.substr(C+1),!1,!0)),O+="@"}L=L.toLowerCase(),C=L.lastIndexOf(":"),C===-1?O+=E(L,!1,!0):(O+=E(L.substr(0,C),!1,!0),O+=L.substr(C))}if(R){if(R.length>=3&&R.charCodeAt(0)===n.CharCode.Slash&&R.charCodeAt(2)===n.CharCode.Colon){const C=R.charCodeAt(1);C>=n.CharCode.A&&C<=n.CharCode.Z&&(R=`/${String.fromCharCode(C+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===n.CharCode.Colon){const C=R.charCodeAt(0);C>=n.CharCode.A&&C<=n.CharCode.Z&&(R=`${String.fromCharCode(C+32)}:${R.substr(2)}`)}O+=E(R,!0,!1)}return M&&(O+="?",O+=E(M,!1,!1)),B&&(O+="#",O+=P?B:k(B,!1,!1)),O}function c(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+c(d.substr(3)):d}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(d){return d.match(s)?d.replace(s,P=>c(P)):d}}),define(oe[159],ae([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=r,e.$br=S,e.$cr=D,e.log=I;function r(a){const h=a;return h&&typeof h.type=="string"&&typeof h.severity=="string"}function S(a){const h=[];let f;try{const g=JSON.parse(a.arguments),w=g[g.length-1];w&&w.__$stack&&(g.pop(),f=w.__$stack),h.push(...g)}catch{h.push("Unable to log remote console arguments",a.arguments)}return{args:h,stack:f}}function D(a){if(typeof a!="string")return D(S(a).stack);const h=a;if(h){const f=A(h),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(g&&g.length===4)return{uri:n.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}function A(a){if(!a)return a;const h=a.indexOf(`
`);return h===-1?a:a.substring(0,h)}function I(a,h){const{args:f,stack:g}=S(a),w=typeof f[0]=="string"&&f.length===1;let l=A(g);l&&(l=`(${l.trim()})`);let p=[];if(typeof f[0]=="string"?l&&w?p=[`%c[${h}] %c${f[0]} %c${l}`,b("blue"),b(""),b("grey")]:p=[`%c[${h}] %c${f[0]}`,b("blue"),b(""),...f.slice(1)]:p=[`%c[${h}]%`,b("blue"),...f],l&&!w&&p.push(l),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,p)}function b(a){return`color: ${a}`}}),define(oe[81],ae([0,1,17,7,91]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=D,e.$bi=A,e.$ci=b;function D(a){return JSON.stringify(a,I)}function A(a){let h=JSON.parse(a);return h=b(h),h}function I(a,h){return h instanceof RegExp?{$mid:S.MarshalledId.Regexp,source:h.source,flags:h.flags}:h}function b(a,h=0){if(!a||h>200)return a;if(typeof a=="object"){switch(a.$mid){case S.MarshalledId.Uri:return r.URI.revive(a);case S.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case S.MarshalledId.Date:return new Date(a.source)}if(a instanceof n.$Oe||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let f=0;f<a.length;++f)a[f]=b(a[f],h+1);else for(const f in a)Object.hasOwnProperty.call(a,f)&&(a[f]=b(a[f],h+1))}return a}}),define(oe[13],ae([0,1,16,4,26,7,9]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=b,e.$Pg=a,e.$Tg=f,n=Re(n),r=Re(r),A=Re(A);var I;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(I||(e.Schemas=I={}));function b(l,p){return D.URI.isUri(l)?(0,S.$Gf)(l.scheme,p):(0,S.$Hf)(l,p+":")}function a(l,...p){return p.some(y=>b(l,y))}e.$Qg="vscode-tkn",e.$Rg="tkn";class h{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p,y){this.f=f(p,y)}getServerRootPath(){return this.f}get g(){return A.$ic.join(this.f,I.vscodeRemoteResource)}set(p,y,$){this.a[p]=y,this.b[p]=$}setConnectionToken(p,y){this.c[p]=y}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(t){return n.$3(t),p}const y=p.authority;let $=this.a[y];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const m=this.b[y],v=this.c[y];let k=`path=${encodeURIComponent(p.path)}`;return typeof v=="string"&&(k+=`&${e.$Rg}=${encodeURIComponent(v)}`),D.URI.from({scheme:r.$o?this.d:I.vscodeRemoteResource,authority:`${$}:${m}`,path:this.g,query:k})}}e.$Sg=new h;function f(l,p){return A.$ic.join(p??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class g{static{this.a=e.$Yg}asBrowserUri(p){const y=this.b(p,x);return this.uriToBrowserUri(y)}uriToBrowserUri(p){return p.scheme===I.vscodeRemote?e.$Sg.rewrite(p):p.scheme===I.file&&(r.$m||r.$q===`${I.vscodeFileResource}://${g.a}`)?p.with({scheme:I.vscodeFileResource,authority:p.authority||g.a,query:null,fragment:null}):p}asFileUri(p){const y=this.b(p,x);return this.uriToFileUri(y)}uriToFileUri(p){return p.scheme===I.vscodeFileResource?p.with({scheme:I.file,authority:p.authority!==g.a?p.authority:null,query:null,fragment:null}):p}b(p,y){return D.URI.isUri(p)?p:D.URI.parse(y.toUrl(p))}}e.$Zg=new g;var w;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const y="vscode-coi";function $(v){let k;typeof v=="string"?k=new URL(v).searchParams:v instanceof URL?k=v.searchParams:D.URI.isUri(v)&&(k=new URL(v.toString(!0)).searchParams);const t=k?.get(y);if(t)return p.get(t)}l.getHeadersFromQuery=$;function m(v,k,t){if(!globalThis.crossOriginIsolated)return;const o=k&&t?"3":t?"2":"1";v instanceof URLSearchParams?v.set(y,o):v[y]=o}l.addSearchParam=m})(w||(e.COI=w={}))}),define(oe[19],ae([0,1,39,31,13,9,4,26,7]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=a,e.$ph=f,e.$qh=w,r=Re(r),D=Re(D);function a(l){return(0,b.$yc)(l,!0)}class h{constructor(p){this.a=p}compare(p,y,$=!1){return p===y?0:(0,I.$zf)(this.getComparisonKey(p,$),this.getComparisonKey(y,$))}isEqual(p,y,$=!1){return p===y?!0:!p||!y?!1:this.getComparisonKey(p,$)===this.getComparisonKey(y,$)}getComparisonKey(p,y=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,y,$=!1){if(p.scheme===y.scheme){if(p.scheme===S.Schemas.file)return r.$Eg(a(p),a(y),this.a(p))&&p.query===y.query&&($||p.fragment===y.fragment);if((0,e.$lh)(p.authority,y.authority))return r.$Eg(p.path,y.path,this.a(p),"/")&&p.query===y.query&&($||p.fragment===y.fragment)}return!1}joinPath(p,...y){return b.URI.joinPath(p,...y)}basenameOrAuthority(p){return(0,e.$dh)(p)||p.authority}basename(p){return D.$ic.basename(p.path)}extname(p){return D.$ic.extname(p.path)}dirname(p){if(p.path.length===0)return p;let y;return p.scheme===S.Schemas.file?y=b.URI.file(D.$oc(a(p))).path:(y=D.$ic.dirname(p.path),p.authority&&y.length&&y.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${p.toString})) resulted in a relative path`),y="/")),p.with({path:y})}normalizePath(p){if(!p.path.length)return p;let y;return p.scheme===S.Schemas.file?y=b.URI.file(D.$jc(a(p))).path:y=D.$ic.normalize(p.path),p.with({path:y})}relativePath(p,y){if(p.scheme!==y.scheme||!(0,e.$lh)(p.authority,y.authority))return;if(p.scheme===S.Schemas.file){const v=D.$nc(a(p),a(y));return A.$i?r.$yg(v):v}let $=p.path||"/";const m=y.path||"/";if(this.a(p)){let v=0;for(const k=Math.min($.length,m.length);v<k&&!($.charCodeAt(v)!==m.charCodeAt(v)&&$.charAt(v).toLowerCase()!==m.charAt(v).toLowerCase());v++);$=m.substr(0,v)+$.substr(v)}return D.$ic.relative($,m)}resolvePath(p,y){if(p.scheme===S.Schemas.file){const $=b.URI.file(D.$mc(a(p),y));return p.with({authority:$.authority,path:$.path})}return y=r.$zg(y),p.with({path:D.$ic.resolve(p.path,y)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,y){return p===y||p!==void 0&&y!==void 0&&(0,I.$Gf)(p,y)}hasTrailingPathSeparator(p,y=D.sep){if(p.scheme===S.Schemas.file){const $=a(p);return $.length>r.$Ag($).length&&$[$.length-1]===y}else{const $=p.path;return $.length>1&&$.charCodeAt($.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,y=D.sep){return(0,e.$mh)(p,y)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,y=D.sep){let $=!1;if(p.scheme===S.Schemas.file){const m=a(p);$=m!==void 0&&m.length===r.$Ag(m).length&&m[m.length-1]===y}else{y="/";const m=p.path;$=m.length===1&&m.charCodeAt(m.length-1)===n.CharCode.Slash}return!$&&!(0,e.$mh)(p,y)?p.with({path:p.path+"/"}):p}}e.$8g=h,e.$9g=new h(()=>!1),e.$0g=new h(l=>l.scheme===S.Schemas.file?!A.$k:!0),e.$$g=new h(l=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function f(l,p){const y=[];for(let $=0;$<l.length;$++){const m=p(l[$]);l.some((v,k)=>k===$?!1:(0,e.$ah)(m,p(v)))||y.push(l[$])}return y}var g;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function p(y){const $=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(k=>{const[t,o]=k.split(":");t&&o&&$.set(t,o)});const v=y.path.substring(0,y.path.indexOf(";"));return v&&$.set(l.META_DATA_MIME,v),$}l.parseMetaData=p})(g||(e.DataUri=g={}));function w(l,p,y){if(p){let $=l.path;return $&&$[0]!==D.$ic.sep&&($=D.$ic.sep+$),l.with({scheme:y,authority:p,path:$})}return l.with({scheme:y})}}),define(oe[8],ae([0,1,23,16,3,2,19,4,146,65]),function(x,e,n,r,S,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=h,e.$sh=f,e.$th=g,e.$uh=w,e.$vh=l,e.$wh=p,e.$xh=y,e.$yh=$,e.$Gh=d,e.$Hh=P,e.$Ih=E,e.$Jh=O,e.$Kh=T,e.$Zh=j,e.$8h=q;function h(X){return!!X&&typeof X.then=="function"}function f(X){const Z=new n.$xe,ie=X(Z.token),de=new Promise((me,we)=>{const Ie=Z.token.onCancellationRequested(()=>{Ie.dispose(),we(new r.$7)});Promise.resolve(ie).then(ke=>{Ie.dispose(),Z.dispose(),me(ke)},ke=>{Ie.dispose(),Z.dispose(),we(ke)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(me,we){return de.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return de.finally(me)}}}function g(X,Z,ie){return new Promise((de,me)=>{const we=Z.onCancellationRequested(()=>{we.dispose(),de(ie)});X.then(de,me).finally(()=>we.dispose())})}function w(X,Z){return new Promise((ie,de)=>{const me=Z.onCancellationRequested(()=>{me.dispose(),de(new r.$7)});X.then(ie,de).finally(()=>me.dispose())})}async function l(X){let Z=-1;const ie=X.map((de,me)=>de.then(we=>(Z=me,we)));try{return await Promise.race(ie)}finally{X.forEach((de,me)=>{me!==Z&&de.cancel()})}}function p(X,Z,ie){let de;const me=setTimeout(()=>{de?.(void 0),ie?.()},Z);return Promise.race([X.finally(()=>clearTimeout(me)),new Promise(we=>de=we)])}function y(X){return new Promise((Z,ie)=>{const de=X();h(de)?de.then(Z,ie):Z(de)})}function $(){let X,Z;return{promise:new Promise((de,me)=>{X=de,Z=me}),resolve:X,reject:Z}}class m{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const ie=()=>{if(this.b=null,this.f)return;const de=this.queue(this.d);return this.d=null,de};this.b=new Promise(de=>{this.a.then(ie,ie).then(de)})}return new Promise((ie,de)=>{this.b.then(ie,de)})}return this.a=Z(),new Promise((ie,de)=>{this.a.then(me=>{this.a=null,ie(me)},me=>{this.a=null,de(me)})})}dispose(){this.f=!0}}e.$zh=m;class v{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$Ah=v;class k{constructor(){this.a=new Map}queue(Z,ie){const me=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(Z)===me&&this.a.delete(Z)});return this.a.set(Z,me),me}}e.$Bh=k;const t=(X,Z)=>{let ie=!0;const de=setTimeout(()=>{ie=!1,Z()},X);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(de),ie=!1}}},o=X=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,X())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class i{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,ie=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((me,we)=>{this.d=me,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const de=()=>{this.a=null,this.d?.(null)};return this.a=ie===b.$he?o(de):t(ie,de),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=i;class c{constructor(Z){this.a=new i(Z),this.b=new m}trigger(Z,ie){return this.a.trigger(()=>this.b.queue(Z),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=c;class s{constructor(){this.a=!1,this.b=new Promise((Z,ie)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=s;class u extends s{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Fh=u;function d(X,Z){return Z?new Promise((ie,de)=>{const me=setTimeout(()=>{we.dispose(),ie()},X),we=Z.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),de(new r.$7)})}):f(ie=>d(X,ie))}function P(X,Z=0,ie){const de=setTimeout(()=>{X(),ie&&me.dispose()},Z),me=(0,D.$Uc)(()=>{clearTimeout(de),ie?.deleteAndLeak(me)});return ie?.add(me),me}function E(X){const Z=[];let ie=0;const de=X.length;function me(){return ie<de?X[ie++]():null}function we(Ie){Ie!=null&&Z.push(Ie);const ke=me();return ke?ke.then(we):Promise.resolve(Z)}return Promise.resolve(null).then(we)}function O(X,Z=de=>!!de,ie=null){let de=0;const me=X.length,we=()=>{if(de>=me)return Promise.resolve(ie);const Ie=X[de++];return Promise.resolve(Ie()).then(Pe=>Z(Pe)?Promise.resolve(Pe):we())};return we()}function T(X,Z=de=>!!de,ie=null){if(X.length===0)return Promise.resolve(ie);let de=X.length;const me=()=>{de=-1;for(const we of X)we.cancel?.()};return new Promise((we,Ie)=>{for(const ke of X)ke.then(Pe=>{--de>=0&&Z(Pe)?(me(),we(Pe)):de===0&&we(ie)}).catch(Pe=>{--de>=0&&(me(),Ie(Pe))})})}class L{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new S.$me}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,de)=>{this.g.push({factory:Z,c:ie,e:de}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const ie=Z.factory();ie.then(Z.c,Z.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=L;class R extends L{constructor(){super(1)}}e.$Mh=R;class M{constructor(){this.a=new U,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Nh=M;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new G;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,ie=A.$9g){const de=ie.getComparisonKey(Z);return this.a.get(de)?.size??0}queueFor(Z,ie,de=A.$9g){const me=de.getComparisonKey(Z);let we=this.a.get(me);if(!we){we=new R;const Ie=this.f++,ke=S.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ie),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$6c),this.d.set(Ie,ke),this.a.set(me,we)}return we.queue(ie)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=B;class C{constructor(Z,ie){this.b=!1,this.a=-1,typeof Z=="function"&&typeof ie=="number"&&this.setIfNotSet(Z,ie)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,ie){if(this.b)throw new r.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},ie)}setIfNotSet(Z,ie){if(this.b)throw new r.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},ie))}}e.$Ph=C;class z{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,ie,de=globalThis){if(this.f)throw new r.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=de.setInterval(()=>{Z()},ie);this.d=(0,D.$Uc)(()=>{de.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=z;class ne{constructor(Z,ie){this.b=-1,this.a=Z,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=ne;class Q{constructor(Z,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=Z,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=Q;class ce extends ne{constructor(Z,ie){super(Z,ie),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Th=ce;class K extends D.$Wc{constructor(Z,ie){super(),this.g=Z,this.h=ie,this.a=[],this.b=this.B(new D.$Xc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of Z)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(X,Z)=>{(0,I.$B)(()=>{if(ie)return;const de=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$Wh=(X,Z,ie)=>{const de=X.requestIdleCallback(Z,typeof ie=="number"?{timeout:ie}:void 0);let me=!1;return{dispose(){me||(me=!0,X.cancelIdleCallback(de))}}},e.$Vh=X=>(0,e.$Wh)(globalThis,X)}();class ee{constructor(Z,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(de){this.l=de}finally{this.g=!0}},this.f=(0,e.$Wh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=ee;class H extends ee{constructor(Z){super(globalThis,Z)}}e.$Yh=H;async function j(X,Z,ie){let de;for(let me=0;me<ie;me++)try{return await X()}catch(we){de=we,await d(Z)}throw de}class U{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,ie,de){return this.a={taskId:Z,cancel:()=>de?.(),promise:ie},ie.then(()=>this.d(Z),()=>this.d(Z)),ie}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:ie,resolve:de,reject:me}=$();this.b={run:Z,promise:ie,promiseResolve:de,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=U;class V{constructor(Z,ie=()=>Date.now()){this.d=Z,this.f=ie,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$2h=V;var le;(function(X){X[X.Resolved=0]="Resolved",X[X.Rejected=1]="Rejected"})(le||(le={}));class G{get isRejected(){return this.d?.outcome===le.Rejected}get isResolved(){return this.d?.outcome===le.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===le.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,ie)=>{this.a=Z,this.b=ie})}complete(Z){return new Promise(ie=>{this.a(Z),this.d={outcome:le.Resolved,value:Z},ie()})}error(Z){return new Promise(ie=>{this.b(Z),this.d={outcome:le.Rejected,value:Z},ie()})}cancel(){return this.error(new r.$7)}}e.$3h=G;var he;(function(X){async function Z(de){let me;const we=await Promise.all(de.map(Ie=>Ie.then(ke=>ke,ke=>{me||(me=ke)})));if(typeof me<"u")throw me;return we}X.settled=Z;function ie(de){return new Promise(async(me,we)=>{try{await de(me,we)}catch(Ie){we(Ie)}})}X.withAsyncBody=ie})(he||(e.Promises=he={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new r.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=se;class _{constructor(Z){this.b=Z,this.a=new a.$X(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=_;var F;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(F||(F={}));class N{static fromArray(Z){return new N(ie=>{ie.emitMany(Z)})}static fromPromise(Z){return new N(async ie=>{ie.emitMany(await Z)})}static fromPromises(Z){return new N(async ie=>{await Promise.all(Z.map(async de=>ie.emitOne(await de)))})}static merge(Z){return new N(async ie=>{await Promise.all(Z.map(async de=>{for await(const me of de)ie.emitOne(me)}))})}static{this.EMPTY=N.fromArray([])}constructor(Z,ie){this.a=F.Initial,this.b=[],this.d=null,this.f=ie,this.g=new S.$me,queueMicrotask(async()=>{const de={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(Z(de)),this.k()}catch(me){this.l(me)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===F.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===F.DoneOK)return{done:!0,value:void 0};await S.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,ie){return new N(async de=>{for await(const me of Z)de.emitOne(ie(me))})}map(Z){return N.map(this,Z)}static filter(Z,ie){return new N(async de=>{for await(const me of Z)ie(me)&&de.emitOne(me)})}filter(Z){return N.filter(this,Z)}static coalesce(Z){return N.filter(Z,ie=>!!ie)}coalesce(){return N.coalesce(this)}static async toPromise(Z){const ie=[];for await(const de of Z)ie.push(de);return ie}toPromise(){return N.toPromise(this)}h(Z){this.a===F.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===F.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===F.Initial&&(this.a=F.DoneOK,this.g.fire())}l(Z){this.a===F.Initial&&(this.a=F.DoneError,this.d=Z,this.g.fire())}}e.$6h=N;class W extends N{constructor(Z,ie){super(ie),this.m=Z}cancel(){this.m.cancel()}}e.$7h=W;function q(X){const Z=new n.$xe,ie=X(Z.token);return new W(Z,async de=>{const me=Z.token.onCancellationRequested(()=>{me.dispose(),Z.dispose(),de.reject(new r.$7)});try{for await(const we of ie){if(Z.token.isCancellationRequested)return;de.emitOne(we)}me.dispose(),Z.dispose()}catch(we){me.dispose(),Z.dispose(),de.reject(we)}})}class Y{constructor(Z){this.a=new G,this.b=new N(me=>{if(ie){me.reject(ie);return}return de&&me.emitMany(de),this.d=we=>me.reject(we),this.f=we=>me.emitOne(we),this.a.p},Z);let ie,de;this.f=me=>{de||(de=[]),de.push(me)},this.d=me=>{ie||(ie=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$9h=Y}),define(oe[113],ae([0,1,22,8,39,31,32,9,4,26]),function(x,e,n,r,S,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=h,e.$xk=p,e.$yk=M,e.$zk=B,e.$Ak=C,e.$Bk=z,e.$Ck=ne,e.$Dk=ee;function h(){return Object.create(null)}e.$vk="**",e.$wk="/";const f="[/\\\\]",g="[^/\\\\]",w=/\//g;function l(H,j){switch(H){case 0:return"";case 1:return`${g}*?`;default:return`(?:${f}|${g}+${f}${j?`|${f}${g}+`:""})*?`}}function p(H,j){if(!H)return[];const U=[];let V=!1,le=!1,G="";for(const he of H){switch(he){case j:if(!V&&!le){U.push(G),G="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":le=!0;break;case"]":le=!1;break}G+=he}return G&&U.push(G),U}function y(H){if(!H)return"";let j="";const U=p(H,e.$wk);if(U.every(V=>V===e.$vk))j=".*";else{let V=!1;U.forEach((le,G)=>{if(le===e.$vk){if(V)return;j+=l(2,G===U.length-1)}else{let he=!1,se="",_=!1,F="";for(const N of le){if(N!=="}"&&he){se+=N;continue}if(_&&(N!=="]"||!F)){let W;N==="-"?W=N:(N==="^"||N==="!")&&!F?W="^":N===e.$wk?W="":W=(0,a.$if)(N),F+=W;continue}switch(N){case"{":he=!0;continue;case"[":_=!0;continue;case"}":{const q=`(?:${p(se,",").map(Y=>y(Y)).join("|")})`;j+=q,he=!1,se="";break}case"]":{j+="["+F+"]",_=!1,F="";break}case"?":j+=g;continue;case"*":j+=l(1);continue;default:j+=(0,a.$if)(N)}}G<U.length-1&&(U[G+1]!==e.$vk||G+2<U.length)&&(j+=f)}V=le===e.$vk})}return j}const $=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.$Fc(1e4),c=function(){return!1},s=function(){return null};function u(H,j){if(!H)return s;let U;typeof H!="string"?U=H.pattern:U=H,U=U.trim();const V=`${U}_${!!j.trimForExclusions}`;let le=i.get(V);if(le)return d(le,H);let G;return $.test(U)?le=E(U.substr(4),U):(G=m.exec(P(U,j)))?le=O(G[1],U):(j.trimForExclusions?k:v).test(U)?le=T(U,j):(G=t.exec(P(U,j)))?le=L(G[1].substr(1),U,!0):(G=o.exec(P(U,j)))?le=L(G[1],U,!1):le=R(U),i.set(V,le),d(le,H)}function d(H,j){if(typeof j=="string")return H;const U=function(V,le){return(0,D.$Eg)(V,j.base,!b.$k)?H((0,a.$nf)(V.substr(j.base.length),I.sep),le):null};return U.allBasenames=H.allBasenames,U.allPaths=H.allPaths,U.basenames=H.basenames,U.patterns=H.patterns,U}function P(H,j){return j.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function E(H,j){return function(U,V){return typeof U=="string"&&U.endsWith(H)?j:null}}function O(H,j){const U=`/${H}`,V=`\\${H}`,le=function(he,se){return typeof he!="string"?null:se?se===H?j:null:he===H||he.endsWith(U)||he.endsWith(V)?j:null},G=[H];return le.basenames=G,le.patterns=[j],le.allBasenames=G,le}function T(H,j){const U=K(H.slice(1,-1).split(",").map(se=>u(se,j)).filter(se=>se!==s),H),V=U.length;if(!V)return s;if(V===1)return U[0];const le=function(se,_){for(let F=0,N=U.length;F<N;F++)if(U[F](se,_))return H;return null},G=U.find(se=>!!se.allBasenames);G&&(le.allBasenames=G.allBasenames);const he=U.reduce((se,_)=>_.allPaths?se.concat(_.allPaths):se,[]);return he.length&&(le.allPaths=he),le}function L(H,j,U){const V=I.sep===I.$ic.sep,le=V?H:H.replace(w,I.sep),G=I.sep+le,he=I.$ic.sep+H;let se;return U?se=function(_,F){return typeof _=="string"&&(_===le||_.endsWith(G)||!V&&(_===H||_.endsWith(he)))?j:null}:se=function(_,F){return typeof _=="string"&&(_===le||!V&&_===H)?j:null},se.allPaths=[(U?"*/":"./")+H],se}function R(H){try{const j=new RegExp(`^${y(H)}$`);return function(U){return j.lastIndex=0,typeof U=="string"&&j.test(U)?H:null}}catch{return s}}function M(H,j,U){return!H||typeof j!="string"?!1:B(H)(j,void 0,U)}function B(H,j={}){if(!H)return c;if(typeof H=="string"||C(H)){const U=u(H,j);if(U===s)return c;const V=function(le,G){return!!U(le,G)};return U.allBasenames&&(V.allBasenames=U.allBasenames),U.allPaths&&(V.allPaths=U.allPaths),V}return Q(H,j)}function C(H){const j=H;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}function z(H){return H.allBasenames||[]}function ne(H){return H.allPaths||[]}function Q(H,j){const U=K(Object.getOwnPropertyNames(H).map(se=>ce(se,H[se],j)).filter(se=>se!==s)),V=U.length;if(!V)return s;if(!U.some(se=>!!se.requiresSiblings)){if(V===1)return U[0];const se=function(N,W){let q;for(let Y=0,X=U.length;Y<X;Y++){const Z=U[Y](N,W);if(typeof Z=="string")return Z;(0,r.$rh)(Z)&&(q||(q=[]),q.push(Z))}return q?(async()=>{for(const Y of q){const X=await Y;if(typeof X=="string")return X}return null})():null},_=U.find(N=>!!N.allBasenames);_&&(se.allBasenames=_.allBasenames);const F=U.reduce((N,W)=>W.allPaths?N.concat(W.allPaths):N,[]);return F.length&&(se.allPaths=F),se}const le=function(se,_,F){let N,W;for(let q=0,Y=U.length;q<Y;q++){const X=U[q];X.requiresSiblings&&F&&(_||(_=(0,I.$pc)(se)),N||(N=_.substr(0,_.length-(0,I.$qc)(se).length)));const Z=X(se,_,N,F);if(typeof Z=="string")return Z;(0,r.$rh)(Z)&&(W||(W=[]),W.push(Z))}return W?(async()=>{for(const q of W){const Y=await q;if(typeof Y=="string")return Y}return null})():null},G=U.find(se=>!!se.allBasenames);G&&(le.allBasenames=G.allBasenames);const he=U.reduce((se,_)=>_.allPaths?se.concat(_.allPaths):se,[]);return he.length&&(le.allPaths=he),le}function ce(H,j,U){if(j===!1)return s;const V=u(H,U);if(V===s)return s;if(typeof j=="boolean")return V;if(j){const le=j.when;if(typeof le=="string"){const G=(he,se,_,F)=>{if(!F||!V(he,se))return null;const N=le.replace("$(basename)",()=>_),W=F(N);return(0,r.$rh)(W)?W.then(q=>q?H:null):W?H:null};return G.requiresSiblings=!0,G}}return V}function K(H,j){const U=H.filter(se=>!!se.basenames);if(U.length<2)return H;const V=U.reduce((se,_)=>{const F=_.basenames;return F?se.concat(F):se},[]);let le;if(j){le=[];for(let se=0,_=V.length;se<_;se++)le.push(j)}else le=U.reduce((se,_)=>{const F=_.patterns;return F?se.concat(F):se},[]);const G=function(se,_){if(typeof se!="string")return null;if(!_){let N;for(N=se.length;N>0;N--){const W=se.charCodeAt(N-1);if(W===S.CharCode.Slash||W===S.CharCode.Backslash)break}_=se.substr(N)}const F=V.indexOf(_);return F!==-1?le[F]:null};G.basenames=V,G.patterns=le,G.allBasenames=V;const he=H.filter(se=>!se.basenames);return he.push(G),he}function ee(H,j){return(0,n.$wb)(H,j,(U,V)=>typeof U=="string"&&typeof V=="string"?U===V:typeof U!="string"&&typeof V!="string"?U.base===V.base&&U.pattern===V.pattern:!1)}}),define(oe[48],ae([0,1,22,31,9,4,19,26]),function(x,e,n,r,S,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vw=b,e.$Ww=h,e.$Xw=g,e.$Yw=w,e.$Zw=$,e.$1w=v,e.$2w=k,e.$3w=t,e.$4w=o,e.$5w=i;function b(s,u){const{os:d,tildify:P,relative:E}=u;if(E){const L=a(s,E,d);if(typeof L=="string")return L}let O=s.fsPath;if(d===D.OperatingSystem.Windows&&!D.$i?O=O.replace(/\//g,"\\"):d!==D.OperatingSystem.Windows&&D.$i&&(O=O.replace(/\\/g,"/")),d!==D.OperatingSystem.Windows&&P?.userHome){const L=P.userHome.fsPath;let R;s.scheme!==P.userHome.scheme&&s.path[0]===S.$ic.sep&&s.path[1]!==S.$ic.sep?R=P.userHome.with({path:s.path}).fsPath:R=O,O=g(R,L,d)}return(d===D.OperatingSystem.Windows?S.$hc:S.$ic).normalize(h(O,d===D.OperatingSystem.Windows))}function a(s,u,d){const P=d===D.OperatingSystem.Windows?S.$hc:S.$ic,E=d===D.OperatingSystem.Linux?A.$9g:A.$$g,O=u.getWorkspace(),T=(0,n.$Qb)(O.folders);if(!T)return;s.scheme!==T.uri.scheme&&s.path[0]===S.$ic.sep&&s.path[1]!==S.$ic.sep&&(s=T.uri.with({path:s.path}));const L=u.getWorkspaceFolder(s);if(!L)return;let R;if(E.isEqual(L.uri,s)?R="":R=E.relativePath(L.uri,s)??"",R&&(R=P.normalize(R)),O.folders.length>1&&!u.noPrefix){const M=L.name?L.name:E.basenameOrAuthority(L.uri);R=R?`${M} \u2022 ${R}`:M}return R}function h(s,u=D.$i){return(0,r.$Jg)(s,u)?s.charAt(0).toUpperCase()+s.slice(1):s}let f=Object.create(null);function g(s,u,d=D.OS){if(d===D.OperatingSystem.Windows||!s||!u)return s;let P=f.original===u?f.normalized:void 0;P||(P=u,D.$i&&(P=(0,r.$yg)(P)),P=`${(0,I.$of)(P,S.$ic.sep)}${S.$ic.sep}`,f={original:u,normalized:P});let E=s;return D.$i&&(E=(0,r.$yg)(E)),(d===D.OperatingSystem.Linux?E.startsWith(P):(0,I.$Hf)(E,P))?`~/${E.substr(P.length)}`:s}function w(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}const l="\u2026",p="\\\\",y="~";function $(s,u=S.sep){const d=new Array(s.length);let P=!1;for(let E=0;E<s.length;E++){const O=s[E];if(O===""){d[E]=`.${u}`;continue}if(!O){d[E]=O;continue}P=!0;let T="",L=O;L.indexOf(p)===0?(T=L.substr(0,L.indexOf(p)+p.length),L=L.substr(L.indexOf(p)+p.length)):L.indexOf(u)===0?(T=L.substr(0,L.indexOf(u)+u.length),L=L.substr(L.indexOf(u)+u.length)):L.indexOf(y)===0&&(T=L.substr(0,L.indexOf(y)+y.length),L=L.substr(L.indexOf(y)+y.length));const R=L.split(u);for(let M=1;P&&M<=R.length;M++)for(let B=R.length-M;P&&B>=0;B--){P=!1;let C=R.slice(B,B+M).join(u);for(let z=0;!P&&z<s.length;z++)if(z!==E&&s[z]&&s[z].indexOf(C)>-1){const ne=B+M===R.length,Q=B>0&&s[z].indexOf(u)>-1?u+C:C,ce=s[z].endsWith(Q);P=!ne||ce}if(!P){let z="";(R[0].endsWith(":")||T!=="")&&(B===1&&(B=0,M++,C=R[0]+u+C),B>0&&(z=R[0]+u),z=T+z),B>0&&(z=z+l+u),z=z+C,B+M<R.length&&(z=z+u+l),d[E]=z}}P&&(d[E]=O)}return d}var m;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function v(s,u=Object.create(null)){const d=[];let P=!1,E="";for(const O of s)if(O==="$"||P&&O==="{")E&&d.push({value:E,type:m.TEXT}),E="",P=!0;else if(O==="}"&&P){const T=u[E];if(typeof T=="string")T.length&&d.push({value:T,type:m.VARIABLE});else if(T){const L=d[d.length-1];(!L||L.type!==m.SEPARATOR)&&d.push({value:T.label,type:m.SEPARATOR})}E="",P=!1}else E+=O;return E&&!P&&d.push({value:E,type:m.TEXT}),d.filter((O,T)=>{if(O.type===m.SEPARATOR){const L=d[T-1],R=d[T+1];return[L,R].every(M=>M&&(M.type===m.VARIABLE||M.type===m.TEXT)&&M.value.length>0)}return!0}).map(O=>O.value).join("")}function k(s,u){return D.$j||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$j?"&":"&&"):s.replace(/&&|&/g,d=>d==="&"?"&&":"&")}function t(s,u){return D.$j||u?s.replace(/\(&&\w\)|&&/g,""):D.$i?s.replace(/&&|&/g,d=>d==="&"?"&&":"&"):s.replace(/&&/g,"_")}function o(s){return s.replace(/&/g,"&&")}function i(s){if(s.endsWith("]")){const u=s.lastIndexOf(" [",s.length-2);if(u!==-1){const d=c(s.substring(0,u)),P=s.substring(u);return{name:d.name+P,parentPath:d.parentPath}}}return c(s)}function c(s){const u=s.indexOf("/")!==-1?S.$ic:S.$hc,d=u.basename(s),P=u.dirname(s);return d.length?{name:d,parentPath:P}:{name:P,parentPath:""}}}),define(oe[160],ae([0,1,17,91,7]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=void 0,e.$Nn=b,e.$On=h,e.$Pn=f;function D(g){return g.toJSON()}class A{constructor(w){this.a=w}transformIncoming(w){const l=this.a.transformIncoming(w);return l===w?w:D(S.URI.from(l))}transformOutgoing(w){const l=this.a.transformOutgoing(w);return l===w?w:D(S.URI.from(l))}transformOutgoingURI(w){const l=this.a.transformOutgoing(w);return l===w?w:S.URI.from(l)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Ln=A,e.$Mn=new class{transformIncoming(g){return g}transformOutgoing(g){return g}transformOutgoingURI(g){return g}transformOutgoingScheme(g){return g}};function I(g,w,l){if(!g||l>200)return null;if(typeof g=="object"){if(g instanceof S.URI)return w.transformOutgoing(g);for(const p in g)if(Object.hasOwnProperty.call(g,p)){const y=I(g[p],w,l+1);y!==null&&(g[p]=y)}}return null}function b(g,w){const l=I(g,w,0);return l===null?g:l}function a(g,w,l,p){if(!g||p>200)return null;if(typeof g=="object"){if(g.$mid===r.MarshalledId.Uri)return l?S.URI.revive(w.transformIncoming(g)):w.transformIncoming(g);if(g instanceof n.$Oe)return null;for(const y in g)if(Object.hasOwnProperty.call(g,y)){const $=a(g[y],w,l,p+1);$!==null&&(g[y]=$)}}return null}function h(g,w){const l=a(g,w,!1,0);return l===null?g:l}function f(g,w){const l=a(g,w,!0,0);return l===null?g:l}}),define(oe[94],ae([0,1,27,61,33,150,4]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=void 0,e.$Sn=b,e.$Tn=f,e.$Un=g,S=Re(S),e.$Rn=new class{c(w){return this.a||(this.a=r.$Li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,l=0;const p=(0,n.networkInterfaces)();for(const y in p){const $=p[y];if($)for(const{mac:m,internal:v}of $)v||(l+=1,this.c(m.toUpperCase())&&(w+=1))}this.b=l>0?w/l:0}return this.b}};let I;async function b(w){return I||(I=(async()=>await a(w)||S.$2g())()),I}async function a(w){try{const l=await new Promise((y,$)=>{x(["crypto"],y,$)}).then(Re),p=(0,D.$Qn)();return l.createHash("sha256").update(p,"utf8").digest("hex")}catch(l){w(l);return}}const h="Software\\Microsoft\\SQMClient";async function f(w){if(A.$i){const l=await new Promise((p,y)=>{x(["@vscode/windows-registry"],p,y)}).then(Re);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",h,"MachineId")||""}catch(p){return w(p),""}}return""}async function g(w){try{return await(await new Promise((y,$)=>{x(["@vscode/deviceid"],y,$)}).then(Re)).getDeviceId()}catch(l){return w(l),""}}}),define(oe[21],ae([0,1,47,27,161,8,31,77,9,4,19,7]),function(x,e,n,r,S,D,A,I,b,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=y,e.readdirSync=v,e.whenDeleted=o,e.configureFlushOnWrite=d,e.writeFileSync=E,n=Re(n);var g;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function w(Q,ce=g.UNLINK,K){if((0,A.$Ig)(Q))throw new Error("rimraf - will refuse to recursively delete root");return ce===g.UNLINK?p(Q):l(Q,K)}async function l(Q,ce=(0,A.$Ng)((0,r.tmpdir)())){try{try{await n.promises.rename(Q,ce)}catch(K){return K.code==="ENOENT"?void 0:p(Q)}p(ce).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function p(Q){return n.promises.rm(Q,{recursive:!0,force:!0,maxRetries:3})}function y(Q){if((0,A.$Ig)(Q))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(Q,{recursive:!0,force:!0,maxRetries:3})}async function $(Q,ce){return k(await(ce?m(Q):n.promises.readdir(Q)))}async function m(Q){try{return await n.promises.readdir(Q,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const ce=[],K=await $(Q);for(const ee of K){let H=!1,j=!1,U=!1;try{const V=await e.Promises.lstat((0,b.$lc)(Q,ee));H=V.isFile(),j=V.isDirectory(),U=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}ce.push({name:ee,isFile:()=>H,isDirectory:()=>j,isSymbolicLink:()=>U})}return ce}function v(Q){return k(n.readdirSync(Q))}function k(Q){return Q.map(ce=>typeof ce=="string"?a.$j?(0,I.$mm)(ce):ce:(ce.name=a.$j?(0,I.$mm)(ce.name):ce.name,ce))}async function t(Q){const ce=await $(Q),K=[];for(const ee of ce)await i.existsDirectory((0,b.$lc)(Q,ee))&&K.push(ee);return K}function o(Q,ce=1e3){return new Promise(K=>{let ee=!1;const H=setInterval(()=>{ee||(ee=!0,n.access(Q,j=>{ee=!1,j&&(clearInterval(H),K(void 0))}))},ce)})}var i;(function(Q){async function ce(H){let j;try{if(j=await e.Promises.lstat(H),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(a.$i&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw V}throw U}}Q.stat=ce;async function K(H){try{const{stat:j,symbolicLink:U}=await Q.stat(H);return j.isFile()&&U?.dangling!==!0}catch{}return!1}Q.existsFile=K;async function ee(H){try{const{stat:j,symbolicLink:U}=await Q.stat(H);return j.isDirectory()&&U?.dangling!==!0}catch{}return!1}Q.existsDirectory=ee})(i||(e.SymlinkSupport=i={}));const c=new D.$Oh;function s(Q,ce,K){return c.queueFor(f.URI.file(Q),()=>{const ee=O(K);return new Promise((H,j)=>P(Q,ce,ee,U=>U?j(U):H()))},h.$0g)}let u=!0;function d(Q){u=Q}function P(Q,ce,K,ee){if(!u)return n.writeFile(Q,ce,{mode:K.mode,flag:K.flag},ee);n.open(Q,K.flag,K.mode,(H,j)=>{if(H)return ee(H);n.writeFile(j,ce,U=>{if(U)return n.close(j,()=>ee(U));n.fdatasync(j,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),d(!1)),n.close(j,le=>ee(le))))})})}function E(Q,ce,K){const ee=O(K);if(!u)return n.writeFileSync(Q,ce,{mode:ee.mode,flag:ee.flag});const H=n.openSync(Q,ee.flag,ee.mode);try{n.writeFileSync(H,ce);try{n.fdatasyncSync(H)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),d(!1)}}finally{n.closeSync(H)}}function O(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function T(Q,ce,K=6e4){if(Q!==ce)try{a.$i&&typeof K=="number"?await L(Q,ce,Date.now(),K):await n.promises.rename(Q,ce)}catch(ee){if(Q.toLowerCase()!==ce.toLowerCase()&&ee.code==="EXDEV"||Q.endsWith("."))await R(Q,ce,{preserveSymlinks:!1}),await w(Q,g.MOVE);else throw ee}}async function L(Q,ce,K,ee,H=0){try{return await n.promises.rename(Q,ce)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-K>=ee)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${j}`),j;if(H===0){let U=!1;try{const{stat:V}=await i.stat(ce);V.isFile()||(U=!0)}catch{}if(U)throw j}return await(0,D.$Gh)(Math.min(100,H*10)),L(Q,ce,K,ee,H+1)}}async function R(Q,ce,K){return B(Q,ce,{root:{source:Q,target:ce},options:K,handledSourcePaths:new Set})}const M=511;async function B(Q,ce,K){if(K.handledSourcePaths.has(Q))return;K.handledSourcePaths.add(Q);const{stat:ee,symbolicLink:H}=await i.stat(Q);if(H){if(K.options.preserveSymlinks)try{return await ne(Q,ce,K)}catch{}if(H.dangling)return}return ee.isDirectory()?C(Q,ce,ee.mode&M,K):z(Q,ce,ee.mode&M)}async function C(Q,ce,K,ee){await e.Promises.mkdir(ce,{recursive:!0,mode:K});const H=await $(Q);for(const j of H)await B((0,b.$lc)(Q,j),(0,b.$lc)(ce,j),ee)}async function z(Q,ce,K){await e.Promises.copyFile(Q,ce),await e.Promises.chmod(ce,K)}async function ne(Q,ce,K){let ee=await e.Promises.readlink(Q);(0,A.$Eg)(ee,K.root.source,!a.$k)&&(ee=(0,b.$lc)(K.root.target,ee.substr(K.root.source.length+1))),await e.Promises.symlink(ee,ce)}e.Promises=new class{get access(){return n.promises.access}get stat(){return n.promises.stat}get lstat(){return n.promises.lstat}get utimes(){return n.promises.utimes}get read(){return(Q,ce,K,ee,H)=>new Promise((j,U)=>{n.read(Q,ce,K,ee,H,(V,le,G)=>V?U(V):j({bytesRead:le,buffer:G}))})}get readFile(){return n.promises.readFile}get write(){return(Q,ce,K,ee,H)=>new Promise((j,U)=>{n.write(Q,ce,K,ee,H,(V,le,G)=>V?U(V):j({bytesWritten:le,buffer:G}))})}get appendFile(){return n.promises.appendFile}get fdatasync(){return(0,S.promisify)(n.fdatasync)}get truncate(){return n.promises.truncate}get copyFile(){return n.promises.copyFile}get open(){return(0,S.promisify)(n.open)}get close(){return(0,S.promisify)(n.close)}get symlink(){return n.promises.symlink}get readlink(){return n.promises.readlink}get chmod(){return n.promises.chmod}get mkdir(){return n.promises.mkdir}get unlink(){return n.promises.unlink}get rmdir(){return n.promises.rmdir}get realpath(){return(0,S.promisify)(n.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return w}get rename(){return T}get copy(){return R}}}),define(oe[114],ae([0,1,47,9,4,26,21]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=I,e.$jr=b,e.$kr=a,e.$lr=h,n=Re(n);function I(g){if(S.$k)return g;const w=(0,r.$oc)(g);if(g===w)return g;const l=((0,r.$pc)(g)||g).toLowerCase();try{const y=(0,A.readdirSync)(w).filter($=>$.toLowerCase()===l);if(y.length===1){const $=I(w);if($)return(0,r.$lc)($,y[0])}else if(y.length>1){const $=y.indexOf(l);if($>=0){const m=I(w);if(m)return(0,r.$lc)(m,y[$])}}}catch{}return null}async function b(g,w){if(S.$k)return g;const l=(0,r.$oc)(g);if(g===l)return g;const p=((0,r.$pc)(g)||g).toLowerCase();try{if(w?.isCancellationRequested)return null;const $=(await A.Promises.readdir(l)).filter(m=>m.toLowerCase()===p);if($.length===1){const m=await b(l,w);if(m)return(0,r.$lc)(m,$[0])}else if($.length>1){const m=$.indexOf(p);if(m>=0){const v=await b(l,w);if(v)return(0,r.$lc)(v,$[m])}}}catch{}return null}async function a(g){try{return await A.Promises.realpath(g)}catch{const l=f(g);return await A.Promises.access(l,n.constants.R_OK),l}}function h(g){try{return n.realpathSync(g)}catch{const l=f(g);return n.accessSync(l,n.constants.R_OK),l}}function f(g){return(0,D.$of)((0,r.$jc)(g),r.sep)}}),define(oe[115],ae([0,1,27,9,21]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=m,e.$wm=v,n=Re(n),r=Re(r),S=Re(S);const D=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var b;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(b||(b={}));let a;switch(process.arch){case"ia32":a=b.x86;break;case"arm":case"arm64":a=b.ARM;break;default:a=b.x64;break}let h;process.env.PROCESSOR_ARCHITEW6432?h=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?b.ARM:b.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?h=b.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?h=b.x86:h=b.x64;class f{constructor(t,o,i){this.exePath=t,this.displayName=o,this.a=i}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:k=!1}={}){return k?a===b.x64?process.env["ProgramFiles(x86)"]||null:h===b.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:k=!1,findPreview:t=!1}={}){const o=g({useAlternateBitness:k});if(!o)return null;const i=r.$lc(o,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(i))return null;let c=-1,s=null;for(const P of await S.Promises.readdir(i)){let E=-1;if(t){const T=P.indexOf("-");if(T<0)continue;const L=P.substring(0,T);if(!D.test(L)||P.substring(T+1)!=="preview")continue;E=parseInt(L,10)}else{if(!D.test(P))continue;E=parseInt(P,10)}if(E<=c)continue;const O=r.$lc(i,P,"pwsh.exe");await S.SymlinkSupport.existsFile(O)&&(s=O,c=E)}if(!s)return null;const u=o.includes("x86")?" (x86)":"",d=t?" Preview":"";return new f(s,`PowerShell${d}${u}`,!0)}async function l({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const t=r.$lc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:o,pwshMsixName:i}=k?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const c of await S.Promises.readdir(t))if(o.test(c)){const s=r.$lc(t,c,"pwsh.exe");return new f(s,i)}return null}function p(){const k=r.$lc(n.homedir(),".dotnet","tools","pwsh.exe");return new f(k,".NET Core PowerShell Global Tool")}function y(){const k=r.$lc(process.env.windir,a===b.x86&&h!==b.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new f(k,"Windows PowerShell",!0)}async function*$(){let k=await w();k&&(yield k),k=await w({useAlternateBitness:!0}),k&&(yield k),k=await l(),k&&(yield k),k=p(),k&&(yield k),k=await w({findPreview:!0}),k&&(yield k),k=await l({findPreview:!0}),k&&(yield k),k=await w({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=y(),k&&(yield k)}async function*m(){for await(const k of $())await k.exists()&&(yield k)}async function v(){for await(const k of m())return k;return null}}),define(oe[95],ae([0,1,9,4,36,80,12,21]),function(x,e,n,r,S,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=b,e.$ym=a,n=Re(n),r=Re(r),S=Re(S),A=Re(A),I=Re(I),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function b(f=S.env){return f.comspec||"cmd.exe"}function a(f){let g=[],w=!1;const l=function(p){if(w){g.push(p);return}(!f.send(p,$=>{if($&&console.error($),w=!1,g.length>0){const m=g.slice(0);g=[],m.forEach(v=>l(v))}})||r.$i)&&(w=!0)};return{send:l}}var h;(function(f){async function g(w,l,p){if(n.$kc(w))return w;if(l===void 0&&(l=S.cwd()),n.$oc(w)!=="."||(p===void 0&&A.$fg(S.env.PATH)&&(p=S.env.PATH.split(n.$vc)),p===void 0||p.length===0))return n.$lc(l,w);async function $(m){if(await I.Promises.exists(m)){let v;try{v=await I.Promises.stat(m)}catch(k){k.message.startsWith("EACCES")&&(v=await I.Promises.lstat(m))}return v?!v.isDirectory():!1}return!1}for(const m of p){let v;if(n.$kc(m)?v=n.$lc(m,w):v=n.$lc(l,m,w),await $(v))return v;let k=v+".com";if(await $(k)||(k=v+".exe",await $(k)))return k}return n.$lc(l,w)}f.findExecutable=g})(h||(e.win32=h={}))}),define(oe[116],ae([0,1,49,13]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=S;function S(A){return new Promise((I,b)=>{let a;const h=new Map;function f(w,l,p,y,$){const m=h.get(l);if(w===A||m){const v={name:g(p),cmd:p,pid:w,ppid:l,load:y,mem:$};h.set(w,v),w===A&&(a=v),m&&(m.children||(m.children=[]),m.children.push(v),m.children.length>1&&(m.children=m.children.sort((k,t)=>k.pid-t.pid)))}}function g(w){const l=/--utility-sub-type=network/i,p=/--crashes-directory/i,y=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,m=/--type=([a-zA-Z-]+)/;if(p.exec(w))return"electron-crash-reporter";if(y.exec(w))return"winpty-agent";if($.exec(w))return"conpty-agent";let v=m.exec(w);if(v&&v.length===2)return v[1]==="renderer"?"window":v[1]==="utility"?l.exec(w)?"utility-network-service":"utility-process":v[1]==="extensionHost"?"extension-host":v[1];const k=/[a-zA-Z-]+\.js/g;let t="";do v=k.exec(w),v&&(t+=v+" ");while(v);return t&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${t})`:w}if(process.platform==="win32"){const w=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,p)=>{x(["@vscode/windows-process-tree"],l,p)}).then(Re).then(l=>{l.getProcessList(A,p=>{if(!p){b(new Error(`Root process ${A} not found`));return}l.getProcessCpuUsage(p,y=>{const $=new Map;y.forEach(m=>{const v=w(m.commandLine||"");$.set(m.pid,{name:g(v),cmd:v,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),a=$.get(A),a?($.forEach(m=>{const v=$.get(m.ppid);v&&(v.children||(v.children=[]),v.children.push(m))}),$.forEach(m=>{m.children&&(m.children=m.children.sort((v,k)=>v.pid-k.pid))}),I(a)):b(new Error(`Root process ${A} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let w=function(){let l=[a];const p=[];for(;l.length;){const $=l.shift();$&&(p.push($.pid),$.children&&(l=l.concat($.children)))}let y=JSON.stringify(r.$Zg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);y+=" "+p.join(" "),(0,n.exec)(y,{},($,m,v)=>{if($||v)b($||new Error(v.toString()));else{const k=m.toString().split(`
`);for(let t=0;t<p.length;t++){const o=h.get(p[t]);o.load=parseFloat(k[t])}if(!a){b(new Error(`Root process ${A} not found`));return}I(a)}})};(0,n.exec)("which ps",{},(l,p,y)=>{if(l||y)if(process.platform!=="linux")b(l||new Error(y.toString()));else{const $=JSON.stringify(r.$Zg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)($,{},(m,v,k)=>{m||k?b(m||new Error(k.toString())):(D(v,f),w())})}else{const $=p.toString().trim();(0,n.exec)(`${$} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,k,t)=>{v||t&&!t.includes("screen size is bogus")?b(v||new Error(t.toString())):(D(k,f),process.platform==="linux"?w():a?I(a):b(new Error(`Root process ${A} not found`)))})}})}})}function D(A,I){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=A.toString().split(`
`);for(const h of a){const f=b.exec(h.trim());f&&f.length===6&&I(parseInt(f[1]),parseInt(f[2]),f[5],parseFloat(f[3]),parseFloat(f[4]))}}}),define(oe[117],ae([0,1,27,4,115,95]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=A,r=Re(r),D=Re(D);async function A(f,g){return f===r.OperatingSystem.Windows?r.$i?h():D.$xm(g):b(f,g)}let I=null;function b(f,g){if(r.$k&&f===r.OperatingSystem.Macintosh||r.$j&&f===r.OperatingSystem.Linux)return"/bin/bash";if(!I){let w;if(r.$i)w="/bin/bash";else{if(w=g.SHELL,!w)try{w=(0,n.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}I=w}return I}let a=null;async function h(){return a||(a=(await(0,S.$wm)()).exePath),a}});var Se=this&&this.__decorate||function(x,e,n,r){var S=arguments.length,D=S<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,n):r,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,e,n,r);else for(var I=x.length-1;I>=0;I--)(A=x[I])&&(D=(S<3?A(D):S>3?A(e,n,D):A(e,n))||D);return S>3&&D&&Object.defineProperty(e,n,D),D};define(oe[44],ae([0,1,22,8,17,23,52,16,3,2,81,26,12]),function(x,e,n,r,S,D,A,I,b,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=d,e.$gi=P,e.$li=M,e.$mi=B,f=Re(f);var w;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(w||(w={}));function l(H){switch(H){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var p;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(p||(p={}));function y(H){switch(H){case p.Initialize:return"init";case p.PromiseSuccess:return"reply:";case p.PromiseError:case p.PromiseErrorObj:return"replyErr:";case p.EventFire:return"event:"}}var $;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})($||($={}));function m(H){let j=0;for(let U=0;;U+=7){const V=H.read(1);if(j|=(V.buffer[0]&127)<<U,!(V.buffer[0]&128))return j}}const v=c(0);function k(H,j){if(j===0){H.write(v);return}let U=0;for(let le=j;le!==0;le=le>>>7)U++;const V=S.$Oe.alloc(U);for(let le=0;j!==0;le++)V.buffer[le]=j&127,j=j>>>7,j>0&&(V.buffer[le]|=128);H.write(V)}class t{constructor(j){this.b=j,this.a=0}read(j){const U=this.b.slice(this.a,this.a+j);return this.a+=U.byteLength,U}}e.$di=t;class o{constructor(){this.a=[]}get buffer(){return S.$Oe.concat(this.a)}write(j){this.a.push(j)}}e.$ei=o;var i;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(i||(i={}));function c(H){const j=S.$Oe.alloc(1);return j.writeUInt8(H,0),j}const s={Undefined:c(i.Undefined),String:c(i.String),Buffer:c(i.Buffer),VSBuffer:c(i.VSBuffer),Array:c(i.Array),Object:c(i.Object),Uint:c(i.Int)},u=typeof Buffer<"u";function d(H,j){if(typeof j>"u")H.write(s.Undefined);else if(typeof j=="string"){const U=S.$Oe.fromString(j);H.write(s.String),k(H,U.byteLength),H.write(U)}else if(u&&Buffer.isBuffer(j)){const U=S.$Oe.wrap(j);H.write(s.Buffer),k(H,U.byteLength),H.write(U)}else if(j instanceof S.$Oe)H.write(s.VSBuffer),k(H,j.byteLength),H.write(j);else if(Array.isArray(j)){H.write(s.Array),k(H,j.length);for(const U of j)d(H,U)}else if(typeof j=="number"&&(j|0)===j)H.write(s.Uint),k(H,j);else{const U=S.$Oe.fromString(JSON.stringify(j));H.write(s.Object),k(H,U.byteLength),H.write(U)}}function P(H){switch(H.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return H.read(m(H)).toString();case i.Buffer:return H.read(m(H)).buffer;case i.VSBuffer:return H.read(m(H));case i.Array:{const U=m(H),V=[];for(let le=0;le<U;le++)V.push(P(H));return V}case i.Object:return JSON.parse(H.read(m(H)).toString());case i.Int:return m(H)}}class E{constructor(j,U,V=null,le=1e3){this.h=j,this.j=U,this.k=V,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:p.Initialize})}registerChannel(j,U){this.b.set(j,U),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case p.Initialize:{const U=this.o([j.type]);this.k?.logOutgoing(U,0,O.OtherSide,y(j.type));return}case p.PromiseSuccess:case p.PromiseError:case p.EventFire:case p.PromiseErrorObj:{const U=this.o([j.type,j.id],j.data);this.k?.logOutgoing(U,j.id,O.OtherSide,y(j.type),j.data);return}}}o(j,U=void 0){const V=new o;return d(V,j),d(V,U),this.p(V.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const U=new t(j),V=P(U),le=P(U),G=V[0];switch(G){case w.Promise:return this.k?.logIncoming(j.byteLength,V[1],O.OtherSide,`${l(G)}: ${V[2]}.${V[3]}`,le),this.s({type:G,id:V[1],channelName:V[2],name:V[3],arg:le});case w.EventListen:return this.k?.logIncoming(j.byteLength,V[1],O.OtherSide,`${l(G)}: ${V[2]}.${V[3]}`,le),this.t({type:G,id:V[1],channelName:V[2],name:V[3],arg:le});case w.PromiseCancel:return this.k?.logIncoming(j.byteLength,V[1],O.OtherSide,`${l(G)}`),this.u({type:G,id:V[1]});case w.EventDispose:return this.k?.logIncoming(j.byteLength,V[1],O.OtherSide,`${l(G)}`),this.u({type:G,id:V[1]})}}s(j){const U=this.b.get(j.channelName);if(!U){this.v(j);return}const V=new D.$xe;let le;try{le=U.call(this.j,j.name,j.arg,V.token)}catch(se){le=Promise.reject(se)}const G=j.id;le.then(se=>{this.m({id:G,data:se,type:p.PromiseSuccess})},se=>{se instanceof Error?this.m({id:G,data:{message:se.message,name:se.name,stack:se.stack?se.stack.split(`
`):void 0},type:p.PromiseError}):this.m({id:G,data:se,type:p.PromiseErrorObj})}).finally(()=>{he.dispose(),this.d.delete(j.id)});const he=(0,a.$Uc)(()=>V.cancel());this.d.set(j.id,he)}t(j){const U=this.b.get(j.channelName);if(!U){this.v(j);return}const V=j.id,G=U.listen(this.j,j.name,j.arg)(he=>this.m({id:V,data:he,type:p.EventFire}));this.d.set(j.id,G)}u(j){const U=this.d.get(j.id);U&&(U.dispose(),this.d.delete(j.id))}v(j){let U=this.g.get(j.channelName);U||(U=[],this.g.set(j.channelName,U));const V=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===w.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:p.PromiseError})},this.l);U.push({request:j,timeoutTimer:V})}w(j){const U=this.g.get(j);if(U){for(const V of U)switch(clearTimeout(V.timeoutTimer),V.request.type){case w.Promise:this.s(V.request);break;case w.EventListen:this.t(V.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Rc)(this.d.values()),this.d.clear()}}e.$hi=E;var O;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(O||(e.RequestInitiator=O={}));class T{constructor(j,U=null){this.l=j,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=U}getChannel(j){const U=this;return{call(V,le,G){return U.a?Promise.reject(new I.$7):U.m(j,V,le,G)},listen(V,le){return U.a?b.Event.None:U.o(j,V,le)}}}m(j,U,V,le=D.CancellationToken.None){const G=this.g++,he=w.Promise,se={id:G,type:he,channelName:j,name:U,arg:V};if(le.isCancellationRequested)return Promise.reject(new I.$7);let _;return new Promise((N,W)=>{if(le.isCancellationRequested)return W(new I.$7);const q=()=>{const ie=de=>{switch(de.type){case p.PromiseSuccess:this.f.delete(G),N(de.data);break;case p.PromiseError:{this.f.delete(G);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,W(me);break}case p.PromiseErrorObj:this.f.delete(G),W(de.data);break}};this.f.set(G,ie),this.p(se)};let Y=null;this.b===$.Idle?q():(Y=(0,r.$sh)(ie=>this.u()),Y.then(()=>{Y=null,q()}));const X=()=>{Y?(Y.cancel(),Y=null):this.p({id:G,type:w.PromiseCancel}),W(new I.$7)},Z=le.onCancellationRequested(X);_=(0,a.$Tc)((0,a.$Uc)(X),Z),this.d.add(_)}).finally(()=>{_.dispose(),this.d.delete(_)})}o(j,U,V){const le=this.g++,G=w.EventListen,he={id:le,type:G,channelName:j,name:U,arg:V};let se=null;const _=new b.$me({onWillAddFirstListener:()=>{se=(0,r.$sh)(N=>this.u()),se.then(()=>{se=null,this.d.add(_),this.p(he)})},onDidRemoveLastListener:()=>{se?(se.cancel(),se=null):(this.d.delete(_),this.p({id:le,type:w.EventDispose}))}}),F=N=>_.fire(N.data);return this.f.set(le,F),_.event}p(j){switch(j.type){case w.Promise:case w.EventListen:{const U=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(U,j.id,O.LocalSide,`${l(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case w.PromiseCancel:case w.EventDispose:{const U=this.q([j.type,j.id]);this.j?.logOutgoing(U,j.id,O.LocalSide,l(j.type));return}}}q(j,U=void 0){const V=new o;return d(V,j),d(V,U),this.r(V.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const U=new t(j),V=P(U),le=P(U),G=V[0];switch(G){case p.Initialize:return this.j?.logIncoming(j.byteLength,0,O.LocalSide,y(G)),this.t({type:V[0]});case p.PromiseSuccess:case p.PromiseError:case p.EventFire:case p.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,V[1],O.LocalSide,y(G),le),this.t({type:V[0],id:V[1],data:le})}}t(j){if(j.type===p.Initialize){this.b=$.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Rc)(this.d.values()),this.d.clear()}}e.$ii=T,Se([A.$0h],T.prototype,"onDidInitializePromise",null);class L{get connections(){const j=[];return this.f.forEach(U=>j.push(U)),j}constructor(j,U,V){this.a=new Map,this.f=new Set,this.g=new b.$me,this.onDidAddConnection=this.g.event,this.h=new b.$me,this.onDidRemoveConnection=this.h.event,this.j=new a.$Vc,this.j.add(j(({protocol:le,onDidClientDisconnect:G})=>{const he=b.Event.once(le.onMessage);this.j.add(he(se=>{const _=new t(se),F=P(_),N=new E(le,F,U,V),W=new T(le,U);this.a.forEach((Y,X)=>N.registerChannel(X,Y));const q={channelServer:N,channelClient:W,ctx:F};this.f.add(q),this.g.fire(q),this.j.add(G(()=>{N.dispose(),W.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(j,U){const V=this;return{call(le,G,he){let se;if((0,g.$tg)(U)){const F=(0,n.$5b)(V.connections.filter(U));se=F?Promise.resolve(F):b.Event.toPromise(b.Event.filter(V.onDidAddConnection,U))}else se=U.routeCall(V,le,G);const _=se.then(F=>F.channelClient.getChannel(j));return M(_).call(le,G,he)},listen(le,G){if((0,g.$tg)(U))return V.k(j,U,le,G);const he=U.routeEvent(V,le,G).then(se=>se.channelClient.getChannel(j));return M(he).listen(le,G)}}}k(j,U,V,le){const G=this;let he;const se=new b.$me({onWillAddFirstListener:()=>{he=new a.$Vc;const _=new b.$se,F=new Map,N=q=>{const X=q.channelClient.getChannel(j).listen(V,le),Z=_.add(X);F.set(q,Z)},W=q=>{const Y=F.get(q);Y&&(Y.dispose(),F.delete(q))};G.connections.filter(U).forEach(N),b.Event.filter(G.onDidAddConnection,U)(N,void 0,he),G.onDidRemoveConnection(W,void 0,he),_.event(se.fire,se,he),he.add(_)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return se.event}registerChannel(j,U){this.a.set(j,U);for(const V of this.f)V.channelServer.registerChannel(j,U)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=L;class R{constructor(j,U,V=null){const le=new o;d(le,U),j.send(le.buffer),this.a=new T(j,V),this.d=new E(j,U,V)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,U){this.d.registerChannel(j,U)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=R;function M(H){return{call(j,U,V){return H.then(le=>le.call(j,U,V))},listen(j,U){const V=new b.$ve;return H.then(le=>V.input=le.listen(j,U)),V.event}}}function B(H){let j=!1;return{call(U,V,le){return j?H.call(U,V,le):(0,r.$Gh)(0).then(()=>j=!0).then(()=>H.call(U,V,le))},listen(U,V){if(j)return H.listen(U,V);const le=new b.$ve;return(0,r.$Gh)(0).then(()=>j=!0).then(()=>le.input=H.listen(U,V)),le.event}}}class C{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const U of j.connections)if(await Promise.resolve(this.a(U.ctx)))return Promise.resolve(U);return await b.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$ni=C;var z;(function(H){function j(G,he,se){const _=G,F=se&&se.disableMarshalling,N=new Map;for(const W in _)V(W)&&N.set(W,b.Event.buffer(_[W],!0,void 0,he));return new class{listen(W,q,Y){const X=N.get(q);if(X)return X;const Z=_[q];if(typeof Z=="function"){if(le(q))return Z.call(_,Y);if(V(q))return N.set(q,b.Event.buffer(_[q],!0,void 0,he)),N.get(q)}throw new I.$db(`Event not found: ${q}`)}call(W,q,Y){const X=_[q];if(typeof X=="function"){if(!F&&Array.isArray(Y))for(let ie=0;ie<Y.length;ie++)Y[ie]=(0,h.$ci)(Y[ie]);let Z=X.apply(_,Y);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new I.$db(`Method not found: ${q}`)}}}H.fromService=j;function U(G,he){const se=he&&he.disableMarshalling;return new Proxy({},{get(_,F){if(typeof F=="string")return he?.properties?.has(F)?he.properties.get(F):le(F)?function(N){return G.listen(F,N)}:V(F)?G.listen(F):async function(...N){let W;he&&!(0,g.$og)(he.context)?W=[he.context,...N]:W=N;const q=await G.call(F,W);return se?q:(0,h.$ci)(q)};throw new I.$db(`Property not found: ${String(F)}`)}})}H.toService=U;function V(G){return G[0]==="o"&&G[1]==="n"&&f.$Ff(G.charCodeAt(2))}function le(G){return/^onDynamic/.test(G)&&f.$Ff(G.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const j=H.toString();if(j!=="[object Object]")return j}return H}function ce(H){return Array.isArray(H)?H.map(Q):Q(H)}function K(H,j,U,V,le,G,he){he=ce(he);const se=ne[le],_=se[V%se.length];let F=[`%c[${H}]%c[${String(j).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(G)?(F=F.concat(he),F.push(")")):F.push(he),console.log.apply(console,F)}class ee{constructor(j,U){this.d=j,this.f=U,this.a=0,this.b=0}logOutgoing(j,U,V,le,G){this.b+=j,K(this.d,this.b,j,U,V,le,G)}logIncoming(j,U,V,le,G){this.a+=j,K(this.f,this.a,j,U,V,le,G)}}e.$oi=ee}),define(oe[162],ae([0,1,17,3,44]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IX=e.$HX=void 0;class D{constructor(b){this.a=b,this.onMessage=r.Event.fromDOMEventEmitter(this.a,"message",a=>a.data?n.$Oe.wrap(a.data):n.$Oe.alloc(0)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}e.$HX=D;class A extends S.$ki{constructor(b,a){const h=new D(b);super(h,a),this.b=h}dispose(){this.b.disconnect(),super.dispose()}}e.$IX=A}),define(oe[118],ae([0,1,17,3,2,44]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.ProtocolConstants=e.$pi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const u=new WeakMap;let d=0;function P(O,T){if(!u.has(O)){const L=String(++d);u.set(O,L)}return u.get(O)}function E(O,T,L,R){if(!s.enableDiagnostics)return;const M=P(O,T);if(R instanceof n.$Oe||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const B=n.$Oe.alloc(R.byteLength);B.set(R),s.records.push({timestamp:Date.now(),id:M,label:T,type:L,buff:B})}else s.records.push({timestamp:Date.now(),id:M,label:T,type:L,data:R})}s.traceSocketEvent=E})(I||(e.SocketDiagnostics=I={}));var b;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let a=null;function h(){return a||(a=n.$Oe.alloc(0)),a}class f{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(u){this.a.push(u),this.b+=u.byteLength}read(u){return this.c(u,!0)}peek(u){return this.c(u,!1)}c(u,d){if(u===0)return h();if(u>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===u){const T=this.a[0];return d&&(this.a.shift(),this.b-=u),T}if(this.a[0].byteLength>u){const T=this.a[0].slice(0,u);return d&&(this.a[0]=this.a[0].slice(u),this.b-=u),T}const P=n.$Oe.alloc(u);let E=0,O=0;for(;u>0;){const T=this.a[O];if(T.byteLength>u){const L=T.slice(0,u);P.set(L,E),E+=u,d&&(this.a[O]=T.slice(u),this.b-=u),u-=u}else P.set(T,E),E+=T.byteLength,d?(this.a.shift(),this.b-=T.byteLength):O++,u-=T.byteLength}return P}}e.$pi=f;var g;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(g||(g={}));function w(s){switch(s){case g.None:return"None";case g.Regular:return"Regular";case g.Control:return"Control";case g.Ack:return"Ack";case g.Disconnect:return"Disconnect";case g.ReplayRequest:return"ReplayRequest";case g.Pause:return"PauseWriting";case g.Resume:return"ResumeWriting";case g.KeepAlive:return"KeepAlive"}}var l;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class p{constructor(u,d,P,E){this.type=u,this.id=d,this.ack=P,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends S.$Wc{constructor(u){super(),this.f=this.B(new r.$me),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:g.None,id:0,ack:0},this.a=u,this.b=!1,this.c=new f,this.B(this.a.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(u){if(!(!u||u.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(u);this.c.byteLength>=this.g.readLen;){const d=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=d.readUInt32BE(9),this.g.messageType=d.readUInt8(0),this.g.id=d.readUInt32BE(1),this.g.ack=d.readUInt32BE(5),this.a.traceSocketEvent(A.ProtocolHeaderRead,{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const P=this.g.messageType,E=this.g.id,O=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=g.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(A.ProtocolMessageRead,d),this.f.fire(new p(P,E,O,d)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(u){this.k=null,this.a=!1,this.b=!1,this.c=u,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(u){if(this.a)return;u.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=n.$Oe.alloc(l.HeaderLength);d.writeUInt8(u.type,0),d.writeUInt32BE(u.id,1),d.writeUInt32BE(u.ack,5),d.writeUInt32BE(u.data.byteLength,9),this.c.traceSocketEvent(A.ProtocolHeaderWrite,{messageType:w(u.type),id:u.id,ack:u.ack,messageSize:u.data.byteLength}),this.c.traceSocketEvent(A.ProtocolMessageWrite,u.data),this.j(d,u.data)}g(u,d){const P=this.f===0;return this.d.push(u,d),this.f+=u.byteLength+d.byteLength,P}h(){const u=n.$Oe.concat(this.d,this.f);return this.d.length=0,this.f=0,u}j(u,d){this.g(u,d)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const u=this.h();this.c.traceSocketEvent(A.ProtocolWrite,{byteLength:u.byteLength}),this.c.write(u)}}class m extends S.$Wc{constructor(u){super(),this.f=new r.$me,this.onMessage=this.f.event,this.g=new r.$me,this.onDidDispose=this.g.event,this.a=u,this.b=this.B(new $(this.a)),this.c=this.B(new y(this.a)),this.B(this.c.onMessage(d=>{d.type===g.Regular&&this.f.fire(d.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(u){this.b.write(new p(g.Regular,0,0,u))}}e.$qi=m;class v extends D.$ki{static fromSocket(u,d){return new v(new m(u),d)}get onDidDispose(){return this.b.onDidDispose}constructor(u,d,P=null){super(u,d,P),this.b=u}dispose(){super.dispose();const u=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),u.end()}}e.$ri=v;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$me({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(u){this.b?this.d.length>0?this.d.push(u):this.a.fire(u):this.d.push(u)}flushBuffer(){this.d=[]}}e.$si=k;class t{constructor(u){this.data=u,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let u=0,d=this.a;for(;d;)d=d.next,u++;return u}peek(){return this.a?this.a.data:null}toArray(){const u=[];let d=0,P=this.a;for(;P;)u[d++]=P.data,P=P.next;return u}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(u){const d=new t(u);if(!this.a){this.a=d,this.b=d;return}this.b.next=d,this.b=d}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const u=Date.now();for(let d=0;d<i.a;d++)this.c[d]=u-1e3*d;setInterval(()=>{for(let d=i.a;d>=1;d--)this.c[d]=this.c[d-1];this.c[0]=Date.now()},1e3)}d(){const u=Date.now(),d=(1+i.a)*1e3;let P=0;for(let E=0;E<i.a;E++)u-this.c[E]<=d&&P++;return 1-P/i.a}hasHighLoad(){return this.d()>=.5}}class c{get unacknowledgedCount(){return this.c-this.d}constructor(u){this.u=new k,this.onControlMessage=this.u.event,this.v=new k,this.onMessage=this.v.event,this.w=new k,this.onDidDispose=this.w.event,this.x=new k,this.onSocketClose=this.x.event,this.y=new k,this.onSocketTimeout=this.y.event,this.s=u.loadEstimator??i.getInstance(),this.t=u.sendKeepAlive??!0,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new S.$Vc,this.o=u.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),u.initialChunk&&this.q.acceptChunk(u.initialChunk),this.t?this.l=setInterval(()=>{this.D()},l.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const u=new p(g.Disconnect,0,0,h());this.p.write(u),this.p.flush()}sendPause(){const u=new p(g.Pause,0,0,h());this.p.write(u)}sendResume(){const u=new p(g.Resume,0,0,h());this.p.write(u)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(u,d){this.a=!0,this.r.dispose(),this.r=new S.$Vc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=u,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(P=>this.z(P))),this.r.add(this.o.onClose(P=>this.x.fire(P))),this.q.acceptChunk(d)}endAcceptReconnection(){this.a=!1,this.h=this.g;const u=new p(g.Ack,0,this.h,h());this.p.write(u);const d=this.b.toArray();for(let P=0,E=d.length;P<E;P++)this.p.write(d[P]);this.B()}acceptDisconnect(){this.w.fire()}z(u){if(u.ack>this.d){this.d=u.ack;do{const d=this.b.peek();if(d&&d.id<=u.ack)this.b.pop();else break}while(!0)}switch(u.type){case g.None:break;case g.Regular:{if(u.id>this.g)if(u.id!==this.g+1){const d=Date.now();d-this.m>1e4&&(this.m=d,this.p.write(new p(g.ReplayRequest,0,0,h())))}else this.g=u.id,this.j=Date.now(),this.A(),this.v.fire(u.data);break}case g.Control:{this.u.fire(u.data);break}case g.Ack:break;case g.Disconnect:{this.w.fire();break}case g.ReplayRequest:{const d=this.b.toArray();for(let P=0,E=d.length;P<E;P++)this.p.write(d[P]);this.B();break}case g.Pause:{this.p.pause();break}case g.Resume:{this.p.resume();break}case g.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(u){const d=++this.c;this.h=this.g;const P=new p(g.Regular,d,this.h,u);this.b.push(P),this.a||(this.p.write(P),this.B())}sendControl(u){const d=new p(g.Control,0,0,u);this.p.write(d)}A(){if(this.g<=this.h||this.k)return;const u=Date.now()-this.j;if(u>=l.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},l.AcknowledgeTime-u+5)}B(){if(this.c<=this.d||this.f||this.a)return;const u=this.b.peek(),d=Date.now()-u.writtenTime,P=Date.now()-this.q.lastReadTime,E=Date.now()-this.n;if(d>=l.TimeoutTime&&P>=l.TimeoutTime&&E>=l.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:P});return}const O=Math.max(l.TimeoutTime-d,l.TimeoutTime-P,l.TimeoutTime-E,500);this.f=setTimeout(()=>{this.f=null,this.B()},O)}C(){if(this.g<=this.h)return;this.h=this.g;const u=new p(g.Ack,0,this.h,h());this.p.write(u)}D(){this.h=this.g;const u=new p(g.KeepAlive,0,this.h,h());this.p.write(u)}}e.$ti=c}),define(oe[37],ae([0,1,14,16,13]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EX=void 0;class D{constructor(){this.a=new WeakMap}on(I,b){const a=(h,...f)=>{this.b(I,h)&&b(h,...f)};return this.a.set(b,a),n.ipcMain.on(I,a),this}once(I,b){return n.ipcMain.once(I,(a,...h)=>{this.b(I,a)&&b(a,...h)}),this}handle(I,b){return n.ipcMain.handle(I,(a,...h)=>this.b(I,a)?b(a,...h):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return n.ipcMain.removeHandler(I),this}removeListener(I,b){const a=this.a.get(b);return a&&(n.ipcMain.removeListener(I,a),this.a.delete(b)),this}b(I,b){if(!I||!I.startsWith("vscode:"))return(0,r.$3)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const a=b.senderFrame,h=a.url;if(!h||h==="about:blank")return!0;let f="unknown";try{f=new URL(h).host}catch{return(0,r.$3)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${h}'.`),!1}return f!==S.$Yg?((0,r.$3)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${f}'.`),!1):a.parent!==null?((0,r.$3)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${f}' is not a main frame.`),!1):!0}}e.$EX=new D}),define(oe[163],ae([0,1,14,37,151]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FX=D;function D(){r.$EX.on(S.$CX,(I,b,a,h,f)=>{const g=A(I,h,a);g.popup({x:f?f.x:void 0,y:f?f.y:void 0,positioningItem:f?f.positioningItem:void 0,callback:()=>{g&&I.sender.send(S.$DX,b)}})})}function A(I,b,a){const h=new n.Menu;return a.forEach(f=>{let g;f.type==="separator"?g=new n.MenuItem({type:f.type}):Array.isArray(f.submenu)?g=new n.MenuItem({submenu:A(I,b,f.submenu),label:f.label}):g=new n.MenuItem({label:f.label,type:f.type,accelerator:f.accelerator,checked:f.checked,enabled:f.enabled,visible:f.visible,click:(w,l,p)=>I.sender.send(b,f.id,p)}),h.append(g)}),h}}),define(oe[164],ae([0,1,37,17,3,2,44,152]),function(x,e,n,r,S,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LX=void 0;function b(h,f){const g=S.Event.fromNodeEventEmitter(n.$EX,f,(l,p)=>({event:l,message:p})),w=S.Event.filter(g,({event:l})=>l.sender.id===h);return S.Event.map(w,({message:l})=>l&&r.$Oe.wrap(l))}class a extends A.$ji{static{this.b=new Map}static d(){const f=S.Event.fromNodeEventEmitter(n.$EX,"vscode:hello",({sender:g})=>g);return S.Event.map(f,g=>{const w=g.id;a.b.get(w)?.dispose();const p=new S.$me;a.b.set(w,(0,D.$Uc)(()=>p.fire()));const y=b(w,"vscode:message"),$=S.Event.any(S.Event.signal(b(w,"vscode:disconnect")),p.event);return{protocol:new I.$KX(g,y),onDidClientDisconnect:$}})}constructor(){super(a.d())}}e.$LX=a}),define(oe[119],ae([0,1,37,3,33,162]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MX=void 0,e.$NX=I;class A extends D.$IX{constructor(a,h){super({addEventListener:(f,g)=>a.addListener(f,g),removeEventListener:(f,g)=>a.removeListener(f,g),postMessage:f=>a.postMessage(f),start:()=>a.start(),close:()=>a.close()},h)}}e.$MX=A;async function I(b){if(b.isDestroyed()||b.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,S.$2g)();b.webContents.send("vscode:createMessageChannel",a);const h=r.Event.fromNodeEventEmitter(n.$EX,"vscode:createMessageChannelResult",(g,w)=>({nonce:w,port:g.ports[0]})),{port:f}=await r.Event.toPromise(r.Event.once(r.Event.filter(h,g=>g.nonce===a)));return f}}),define(oe[165],ae([0,1,49,8,17,23,159,16,3,2,35,95,80,44]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0,I=Re(I);class l extends w.$hi{constructor($){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",m=>S.$Oe.wrap(Buffer.from(m,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$er=l;class p{constructor($,m){this.i=$,this.j=m,this.c=new Set,this.g=new Map,this.h=new b.$me,this.onDidProcessExit=this.h.event;const v=m&&m.timeout?m.timeout:6e4;this.b=new r.$Ch(v),this.d=null,this.f=null}getChannel($){const m=this;return{call(v,k,t){return m.k($,v,k,t)},listen(v,k){return m.l($,v,k)}}}k($,m,v,k=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(I.$8());this.b.cancel();const t=this.n($),o=(0,r.$sh)(s=>t.call(m,v,s)),i=k.onCancellationRequested(()=>o.cancel()),c=(0,a.$Uc)(()=>o.cancel());return this.c.add(c),o.finally(()=>{i.dispose(),this.c.delete(c),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),o}l($,m,v){if(!this.b)return b.Event.None;this.b.cancel();let k;const t=new b.$me({onWillAddFirstListener:()=>{k=this.n($).listen(m,v)(t.fire,t),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,h.$do)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(d=>!/^--inspect(-brk)?=/.test(d)).filter(d=>!d.startsWith("--vscode-"))),(0,g.$lm)(m.env),this.d=(0,n.fork)(this.i,$,m);const v=new b.$me,t=b.Event.fromNodeEventEmitter(this.d,"message",d=>d)(d=>{if((0,A.$ar)(d)){(0,A.log)(d,`IPC Library: ${this.j.serverName}`);return}v.fire(S.$Oe.wrap(Buffer.from(d,"base64")))}),o=this.j.useQueue?(0,f.$ym)(this.d):this.d,i=d=>this.d&&this.d.connected&&o.send(d.buffer.toString("base64")),c=v.event,s={send:i,onMessage:c};this.f=new w.$ii(s);const u=()=>this.o();process.once("exit",u),this.d.on("error",d=>console.warn('IPC "'+this.j.serverName+'" errored with '+d)),this.d.on("exit",(d,P)=>{process.removeListener("exit",u),t.dispose(),this.c.forEach(E=>(0,a.$Rc)(E)),this.c.clear(),d!==0&&P!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+d+" and signal "+P),this.b?.cancel(),this.o(),this.h.fire({code:d,signal:P})})}return this.f}n($){let m=this.g.get($);return m||(m=this.m.getChannel($),this.g.set($,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$fr=p}),define(oe[120],ae([0,1,8,3,2,81,12]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=b;var I;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function b(g){const w=g;return w?.changed instanceof Map||w?.deleted instanceof Set}var a;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(a||(e.StorageState=a={}));class h extends S.$Wc{static{this.a=100}constructor(w,l=Object.create(null)){super(),this.r=w,this.s=l,this.b=this.B(new r.$pe),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new n.$Dh(h.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((l,p)=>this.w(p,l)),w.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w(w,l){if(this.c===a.Closed)return;let p=!1;(0,A.$og)(l)?p=this.f.delete(w):this.f.get(w)!==l&&(this.f.set(w,l),p=!0),p&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,l){const p=this.f.get(w);return(0,A.$og)(p)?l:p}getBoolean(w,l){const p=this.get(w);return(0,A.$og)(p)?l:p==="true"}getNumber(w,l){const p=this.get(w);return(0,A.$og)(p)?l:parseInt(p,10)}getObject(w,l){const p=this.get(w);return(0,A.$og)(p)?l:(0,D.$bi)(p)}async set(w,l,p=!1){if(this.c===a.Closed)return;if((0,A.$og)(l))return this.delete(w,p);const y=(0,A.$hg)(l)||Array.isArray(l)?(0,D.$ai)(l):String(l);if(this.f.get(w)!==y)return this.f.set(w,y),this.j.set(w,y),this.h.delete(w),this.b.fire({key:w,external:p}),this.D()}async delete(w,l=!1){if(!(this.c===a.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:l}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===a.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$bq=h;class f{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((l,p)=>this.a.set(p,l)),w.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$cq=f}),define(oe[166],ae([0,1,8,3,32,9,21]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0X=void 0;class I{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return r.Event.None}static{this.a=2e3}static{this.b=256}constructor(h,f=Object.create(null)){this.g=h,this.h=f,this.c=(0,D.$pc)(this.g),this.d=new b(this.h.logging),this.f=this.n(this.g)}async getItems(){const h=await this.f,f=new Map;return(await this.s(h,"SELECT * FROM ItemTable")).forEach(w=>f.set(w.key,w.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${f.size} rows`),f}async updateItems(h){const f=await this.f;return this.j(f,h)}j(h,f){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${f.insert?(0,S.$Ac)(f.insert):"0"}), delete(${f.delete?(0,S.$Bc)(f.delete):"0"})`),this.t(h,()=>{const g=f.insert,w=f.delete;if(g&&g.size>0){const l=[];l.push([]);let p=0;g.forEach((y,$)=>{let m=l[p];m.length>I.b&&(p++,m=[],l.push(m)),m.push($,y)}),l.forEach(y=>{this.u(h,`INSERT INTO ItemTable VALUES ${new Array(y.length/2).fill("(?,?)").join(",")}`,$=>$.run(y),()=>{const $=[];let m=0;return g.forEach((v,k)=>{$.push(k),m+=v.length}),`Keys: ${$.join(", ")} Length: ${m}`})})}if(w&&w.size){const l=[];l.push([]);let p=0;w.forEach(y=>{let $=l[p];$.length>I.b&&(p++,$=[],l.push($)),$.push(y)}),l.forEach(y=>{this.u(h,`DELETE FROM ItemTable WHERE key IN (${new Array(y.length).fill("?").join(",")})`,$=>$.run(y),()=>{const $=[];return w.forEach(m=>{$.push(m)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const h=await this.f;return this.q(h,"VACUUM")}async close(h){this.d.trace(`[storage ${this.c}] close()`);const f=await this.f;return this.k(f,h)}k(h,f){return new Promise((g,w)=>{h.db.close(l=>(l&&this.o(h,`[storage ${this.c}] close(): ${l}`),this.g===I.IN_MEMORY_PATH?g():!h.isErroneous&&!h.isInMemory?this.l().then(g,p=>(this.d.error(`[storage ${this.c}] backup(): ${p}`),g())):typeof f=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(p=>{const y=()=>this.k(p,void 0);return this.j(p,{insert:f()}).then(()=>y(),$=>(y(),Promise.reject($)))})).then(g,w):w(l||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const h=this.m(this.g);return A.Promises.copy(this.g,h,{preserveSymlinks:!1})}m(h){return`${h}.backup`}async checkIntegrity(h){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${h})`);const f=await this.f,g=await this.r(f,h?"PRAGMA integrity_check":"PRAGMA quick_check"),w=h?g.integrity_check:g.quick_check;return f.isErroneous?`${w} (last error: ${f.lastError})`:f.isInMemory?`${w} (in-memory!)`:w}async n(h,f=!0){this.d.trace(`[storage ${this.c}] open(${h}, retryOnBusy: ${f})`);try{return await this.p(h)}catch(g){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${g}`),g.code==="SQLITE_BUSY"&&f)return await(0,n.$Gh)(I.a),this.n(h,!1);try{await A.Promises.unlink(h);try{await A.Promises.rename(this.m(h),h,!1)}catch{}return await this.p(h)}catch(w){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${w}`),this.p(I.IN_MEMORY_PATH)}}}o(h,f){h.isErroneous=!0,h.lastError=f,this.d.error(f)}p(h){return new Promise((f,g)=>{new Promise((w,l)=>{x(["@vscode/sqlite3"],w,l)}).then(Re).then(w=>{const l={db:new(this.d.isTracing?w.verbose().Database:w.Database)(h,p=>p?l.db&&p.code!=="SQLITE_CANTOPEN"?l.db.close(()=>g(p)):g(p):this.q(l,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>f(l),y=>l.db.close(()=>g(y)))),isInMemory:h===I.IN_MEMORY_PATH};l.db.on("error",p=>this.o(l,`[storage ${this.c}] Error (event): ${p}`)),this.d.isTracing&&l.db.on("trace",p=>this.d.trace(`[storage ${this.c}] Trace (event): ${p}`))},g)})}q(h,f){return new Promise((g,w)=>{h.db.exec(f,l=>l?(this.o(h,`[storage ${this.c}] exec(): ${l}`),w(l)):g())})}r(h,f){return new Promise((g,w)=>{h.db.get(f,(l,p)=>l?(this.o(h,`[storage ${this.c}] get(): ${l}`),w(l)):g(p))})}s(h,f){return new Promise((g,w)=>{h.db.all(f,(l,p)=>l?(this.o(h,`[storage ${this.c}] all(): ${l}`),w(l)):g(p))})}t(h,f){return new Promise((g,w)=>{h.db.serialize(()=>{h.db.run("BEGIN TRANSACTION"),f(),h.db.run("END TRANSACTION",l=>l?(this.o(h,`[storage ${this.c}] transaction(): ${l}`),w(l)):g())})})}u(h,f,g,w){const l=h.db.prepare(f),p=y=>{this.o(h,`[storage ${this.c}] prepare(): ${y} (${f}). Details: ${w()}`)};l.on("error",p),g(l),l.finalize(y=>{y&&p(y),l.removeListener("error",p)})}}e.$0X=I;class b{static{this.a="VSCODE_TRACE_STORAGE"}constructor(h){h&&typeof h.logTrace=="function"&&process.env[b.a]&&(this.b=h.logTrace),h&&typeof h.logError=="function"&&(this.c=h.logError)}get isTracing(){return!!this.b}trace(h){this.b?.(h)}error(h){this.c?.(h)}}}),define(oe[167],ae([11,10]),function(x,e){return x.create("vs/code/electron-main/app",e)}),define(oe[168],ae([11,10]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[169],ae([11,10]),function(x,e){return x.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[170],ae([11,10]),function(x,e){return x.create("vs/platform/contextkey/common/scanner",e)}),define(oe[171],ae([11,10]),function(x,e){return x.create("vs/platform/dialogs/common/dialogs",e)}),define(oe[172],ae([11,10]),function(x,e){return x.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(oe[173],ae([11,10]),function(x,e){return x.create("vs/platform/environment/node/argv",e)}),define(oe[174],ae([11,10]),function(x,e){return x.create("vs/platform/environment/node/argvHelper",e)}),define(oe[175],ae([11,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[176],ae([11,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[177],ae([11,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[178],ae([11,10]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[179],ae([11,10]),function(x,e){return x.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(oe[180],ae([11,10]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(oe[181],ae([11,10]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(oe[182],ae([11,10]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(oe[183],ae([11,10]),function(x,e){return x.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(oe[184],ae([11,10]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[185],ae([11,10]),function(x,e){return x.create("vs/platform/issue/electron-main/issueMainService",e)}),define(oe[186],ae([11,10]),function(x,e){return x.create("vs/platform/log/common/log",e)}),define(oe[187],ae([11,10]),function(x,e){return x.create("vs/platform/menubar/electron-main/menubar",e)}),define(oe[188],ae([11,10]),function(x,e){return x.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(oe[189],ae([11,10]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(oe[190],ae([11,10]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(oe[191],ae([11,10]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[192],ae([11,10]),function(x,e){return x.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[193],ae([11,10]),function(x,e){return x.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[194],ae([11,10]),function(x,e){return x.create("vs/platform/update/common/update.config.contribution",e)}),define(oe[195],ae([11,10]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[196],ae([11,10]),function(x,e){return x.create("vs/platform/windows/electron-main/windowImpl",e)}),define(oe[197],ae([11,10]),function(x,e){return x.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(oe[198],ae([11,10]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(oe[199],ae([11,10]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(oe[200],ae([11,10]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(oe[201],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghb=n,e.$Hhb=r;function n(S){return S&&S.hasOwnProperty("folderUri")}function r(S){return S&&S.hasOwnProperty("workspace")}}),define(oe[202],ae([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=r,e.$vec=S,e.$wec=D;function r(A){return typeof A?.backupFolder=="string"}function S(A){let I=[];try{Array.isArray(A.workspaces)&&(I=A.workspaces.map(b=>({workspace:{id:b.id,configPath:n.URI.parse(b.configURIPath)},remoteAuthority:b.remoteAuthority})))}catch{}return I}function D(A){let I=[];try{Array.isArray(A.folders)&&(I=A.folders.map(b=>({folderUri:n.URI.parse(b.folderUri),remoteAuthority:b.remoteAuthority})))}catch{}return I}}),define(oe[203],ae([0,1,39,16,170]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var D;(function(h){h[h.LParen=0]="LParen",h[h.RParen=1]="RParen",h[h.Neg=2]="Neg",h[h.Eq=3]="Eq",h[h.NotEq=4]="NotEq",h[h.Lt=5]="Lt",h[h.LtEq=6]="LtEq",h[h.Gt=7]="Gt",h[h.GtEq=8]="GtEq",h[h.RegexOp=9]="RegexOp",h[h.RegexStr=10]="RegexStr",h[h.True=11]="True",h[h.False=12]="False",h[h.In=13]="In",h[h.Not=14]="Not",h[h.And=15]="And",h[h.Or=16]="Or",h[h.Str=17]="Str",h[h.QuotedStr=18]="QuotedStr",h[h.Error=19]="Error",h[h.EOF=20]="EOF"})(D||(e.TokenType=D={}));function A(...h){switch(h.length){case 1:return(0,S.localize)(0,null,h[0]);case 2:return(0,S.localize)(1,null,h[0],h[1]);case 3:return(0,S.localize)(2,null,h[0],h[1],h[2]);default:return}}const I=(0,S.localize)(3,null),b=(0,S.localize)(4,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(f){switch(f.type){case D.LParen:return"(";case D.RParen:return")";case D.Neg:return"!";case D.Eq:return f.isTripleEq?"===":"==";case D.NotEq:return f.isTripleEq?"!==":"!=";case D.Lt:return"<";case D.LtEq:return"<=";case D.Gt:return">=";case D.GtEq:return">=";case D.RegexOp:return"=~";case D.RegexStr:return f.lexeme;case D.True:return"true";case D.False:return"false";case D.In:return"in";case D.Not:return"not";case D.And:return"&&";case D.Or:return"||";case D.Str:return f.lexeme;case D.QuotedStr:return f.lexeme;case D.Error:return f.lexeme;case D.EOF:return"EOF";default:throw(0,r.$0)(`unhandled token type: ${JSON.stringify(f)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(f=>f.charCodeAt(0)))}static{this.b=new Map([["not",D.Not],["in",D.In],["false",D.False],["true",D.True]])}get errors(){return this.g}reset(f){return this.c=f,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(D.LParen);break;case n.CharCode.CloseParen:this.k(D.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const g=this.h(n.CharCode.Equals);this.f.push({type:D.NotEq,offset:this.d,isTripleEq:g})}else this.k(D.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const g=this.h(n.CharCode.Equals);this.f.push({type:D.Eq,offset:this.d,isTripleEq:g})}else this.h(n.CharCode.Tilde)?this.k(D.RegexOp):this.l(A("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?D.LtEq:D.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?D.GtEq:D.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(D.And):this.l(A("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(D.Or):this.l(A("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(D.EOF),Array.from(this.f)}h(f){return this.r()||this.c.charCodeAt(this.e)!==f?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(f){this.f.push({type:f,offset:this.d})}l(f){const g=this.d,w=this.c.substring(this.d,this.e),l={type:D.Error,offset:this.d,lexeme:w};this.g.push({offset:g,lexeme:w,additionalInfo:f}),this.f.push(l)}n(){this.m.lastIndex=this.d;const f=this.m.exec(this.c);if(f){this.e=this.d+f[0].length;const g=this.c.substring(this.d,this.e),w=a.b.get(g);w?this.k(w):this.f.push({type:D.Str,lexeme:g,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:D.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let f=this.e,g=!1,w=!1;for(;;){if(f>=this.c.length){this.e=f,this.l(b);return}const p=this.c.charCodeAt(f);if(g)g=!1;else if(p===n.CharCode.Slash&&!w){f++;break}else p===n.CharCode.OpenSquareBracket?w=!0:p===n.CharCode.Backslash?g=!0:p===n.CharCode.CloseSquareBracket&&(w=!1);f++}for(;f<this.c.length&&a.a.has(this.c.charCodeAt(f));)f++;this.e=f;const l=this.c.substring(this.d,this.e);this.f.push({type:D.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=a}),define(oe[204],ae([0,1,3,2]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=void 0;class S{constructor(){this.a=new n.$me,this.b=new n.$me,this.c=new n.$me,this.d=new n.$me}static{this.ChannelName="extensionhostdebugservice"}call(I,b,a){switch(b){case"close":return Promise.resolve(this.a.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(I,b,a){switch(b){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Wo=S;class D extends r.$Wc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,b,a){this.b.call("attach",[I,b,a])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,b){this.b.call("terminate",[I,b])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,b){return this.b.call("openExtensionDevelopmentHostWindow",[I,b])}}e.$Xo=D}),define(oe[205],ae([0,1,154,52,13,9,36,19,7]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$6m=h,e.$7m=f,e.$4m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,D.$oc)(S.$Zg.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return b.URI.file((0,D.$lc)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.b.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,I.$gh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$gh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,n.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$lc)(this.userDataPath,"logs",w)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$gh)(b.URI.file((0,D.$lc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$gh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$gh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$gh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=A.env.VSCODE_PORTABLE;return w?b.URI.file((0,D.$lc)(w,"argv.json")):(0,I.$gh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,D.$lc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,D.$mc)(w):(0,D.$jc)((0,D.$lc)(S.$Zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?b.URI.file((0,D.$mc)(w)):b.URI.file((0,D.$lc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,D.$mc)(w);const l=A.env.VSCODE_EXTENSIONS;if(l)return l;const p=A.env.VSCODE_PORTABLE;return p?(0,D.$lc)(p,"extensions"):(0,I.$gh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(l=>/^[^:/?#]+?:\/\//.test(l)?b.URI.parse(l):b.URI.file((0,D.$jc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?b.URI.parse(w):b.URI.file((0,D.$jc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return h(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$4m.test(w))}get extensionLogLevel(){const w=[];for(const l of this.args.log||[]){const p=e.$4m.exec(l);p&&p[1]&&p[2]&&w.push([p[1],p[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,I.$gh)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=A.env.VSCODE_PORTABLE;return w?b.URI.file((0,D.$lc)(w,"policy.json")):(0,I.$gh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,l,p){this.a=w,this.b=l,this.c=p,this.editSessionId=this.args.editSessionId}}e.$5m=a,Se([r.$0h],a.prototype,"appRoot",null),Se([r.$0h],a.prototype,"userHome",null),Se([r.$0h],a.prototype,"userDataPath",null),Se([r.$0h],a.prototype,"appSettingsHome",null),Se([r.$0h],a.prototype,"tmpDir",null),Se([r.$0h],a.prototype,"cacheHome",null),Se([r.$0h],a.prototype,"stateResource",null),Se([r.$0h],a.prototype,"userRoamingDataHome",null),Se([r.$0h],a.prototype,"userDataSyncHome",null),Se([r.$0h],a.prototype,"sync",null),Se([r.$0h],a.prototype,"machineSettingsResource",null),Se([r.$0h],a.prototype,"workspaceStorageHome",null),Se([r.$0h],a.prototype,"localHistoryHome",null),Se([r.$0h],a.prototype,"keyboardLayoutResource",null),Se([r.$0h],a.prototype,"argvResource",null),Se([r.$0h],a.prototype,"isExtensionDevelopment",null),Se([r.$0h],a.prototype,"untitledWorkspacesHome",null),Se([r.$0h],a.prototype,"builtinExtensionsPath",null),Se([r.$0h],a.prototype,"extensionsPath",null),Se([r.$0h],a.prototype,"extensionDevelopmentLocationURI",null),Se([r.$0h],a.prototype,"extensionDevelopmentKind",null),Se([r.$0h],a.prototype,"extensionTestsLocationURI",null),Se([r.$0h],a.prototype,"debugExtensionHost",null),Se([r.$0h],a.prototype,"logLevel",null),Se([r.$0h],a.prototype,"extensionLogLevel",null),Se([r.$0h],a.prototype,"serviceMachineIdResource",null),Se([r.$0h],a.prototype,"disableTelemetry",null),Se([r.$0h],a.prototype,"disableWorkspaceTrust",null),Se([r.$0h],a.prototype,"useInMemorySecretStorage",null),Se([r.$0h],a.prototype,"policyFile",null);function h(g,w){return f(g["inspect-extensions"],g["inspect-brk-extensions"],5870,w,g.debugId,g.extensionEnvironment)}function f(g,w,l,p,y,$){const v=Number(w||g)||(p?null:l),k=v?!!w:!1;let t;if($)try{t=JSON.parse($)}catch{}return{port:v,break:k,debugId:y,env:t}}});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[121],ae([0,1,317,4,173]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=void 0,e.$Cm=I,e.$Dm=a,e.$Em=w,e.$Fm=l,n=et(n);const D={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.$Am=["tunnel","serve-web"],e.$Bm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,S.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(p,y,$=A){const m=p.find(d=>d.length>0&&d[0]!=="-"),v={},k=["_"],t=[],o={};let i;for(const d in y){const P=y[d];P.type==="subcommand"?d===m&&(i=P):(P.alias&&(v[d]=P.alias),P.type==="string"||P.type==="string[]"?(k.push(d),P.deprecates&&k.push(...P.deprecates)):P.type==="boolean"&&(t.push(d),P.deprecates&&t.push(...P.deprecates)),P.global&&(o[d]=P))}if(i&&m){const d=o;for(const T in i.options)d[T]=i.options[T];const P=p.filter(T=>T!==m),E=$.getSubcommandReporter?$.getSubcommandReporter(m):void 0,O=I(P,d,E);return{[m]:O,_:[]}}const c=(0,n.default)(p,{string:k,boolean:t,alias:v}),s={},u=c;s._=c._.map(d=>String(d)).filter(d=>d.length>0),delete u._;for(const d in y){const P=y[d];if(P.type==="subcommand")continue;P.alias&&delete u[P.alias];let E=u[d];if(P.deprecates)for(const O of P.deprecates)u.hasOwnProperty(O)&&(E||(E=u[O],E&&$.onDeprecatedOption(O,P.deprecationMessage||(0,S.localize)(39,null,d))),delete u[O]);if(typeof E<"u"){if(P.type==="string[]"){if(Array.isArray(E)||(E=[E]),!P.allowEmptyValue){const O=E.filter(T=>T.length>0);O.length!==E.length&&($.onEmptyValue(d),E=O.length>0?O:void 0)}}else P.type==="string"&&(Array.isArray(E)?(E=E.pop(),$.onMultipleValues(d,E)):!E&&!P.allowEmptyValue&&($.onEmptyValue(d),E=void 0));s[d]=E,P.deprecationMessage&&$.onDeprecatedOption(d,P.deprecationMessage)}delete u[d]}for(const d in u)$.onUnknownOption(d);return s}function b(p,y){let $="";return y.args&&(Array.isArray(y.args)?$=` <${y.args.join("> <")}>`:$=` <${y.args}>`),y.alias?`-${y.alias} --${p}${$}`:`--${p}${$}`}function a(p,y){const $=[];for(const m in p){const v=p[m],k=b(m,v);$.push([k,v.description])}return h($,y)}function h(p,y){const m=p.reduce((t,o)=>Math.max(t,o[0].length),12)+2+1;if(y-m<25)return p.reduce((t,o)=>t.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);const v=y-m-1,k=[];for(const t of p){const o=t[0],i=g(t[1],v),c=f(m-o.length-2);k.push("  "+o+c+i[0]);for(let s=1;s<i.length;s++)k.push(f(m)+i[s])}return k}function f(p){return" ".repeat(p)}function g(p,y){const $=[];for(;p.length;){const m=p.length<y?p.length:p.lastIndexOf(" ",y),v=p.slice(0,m).trim();p=p.slice(m),$.push(v)}return $}function w(p,y,$,m,v){const k=process.stdout.isTTY&&process.stdout.columns||80,t=v?.noInputFiles!==!0?`[${(0,S.localize)(40,null)}...]`:"",o=[`${p} ${$}`];o.push(""),o.push(`${(0,S.localize)(41,null)}: ${y} [${(0,S.localize)(42,null)}]${t}`),o.push(""),v?.noPipe!==!0&&(r.$i?o.push((0,S.localize)(43,null,y)):o.push((0,S.localize)(44,null,y)),o.push(""));const i={},c=[];for(const s in m){const u=m[s];if(u.type==="subcommand")u.description&&c.push({command:s,description:u.description});else if(u.description&&u.cat){let d=i[u.cat];d||(i[u.cat]=d={}),d[s]=u}}for(const s in i){const u=s,d=i[u];d&&(o.push(D[u]),o.push(...a(d,k)),o.push(""))}return c.length&&(o.push((0,S.localize)(45,null)),o.push(...h(c.map(s=>[s.command,s.description]),k)),o.push("")),o.join(`
`)}function l(p,y){return`${p||(0,S.localize)(46,null)}
${y||(0,S.localize)(47,null)}
${process.arch}`}});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[68],ae([0,1,318,174,121]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=I,e.$Hm=b,e.$Im=a,e.$Jm=h,n=et(n);function D(f,g){const w=(v,k)=>{console.warn((0,r.localize)(0,null,v,k))},l=v=>{console.warn((0,r.localize)(1,null,v))},p=(v,k)=>{console.warn((0,r.localize)(2,null,v,k))},y=v=>({onUnknownOption:k=>{S.$Am.includes(v)||console.warn((0,r.localize)(3,null,k,v))},onMultipleValues:w,onEmptyValue:l,onDeprecatedOption:p,getSubcommandReporter:S.$Am.includes(v)?y:void 0}),$={onUnknownOption:v=>{console.warn((0,r.localize)(4,null,v))},onMultipleValues:w,onEmptyValue:l,onDeprecatedOption:p,getSubcommandReporter:y},m=(0,S.$Cm)(f,S.$Bm,g?$:void 0);return m.goto&&m._.forEach(v=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(v),(0,r.localize)(5,null))),m}function A(f){const g=f.findIndex(w=>!/^-/.test(w));if(g>-1)return[...f.slice(0,g),...f.slice(g+1)]}function I(f){let[,...g]=f;process.env.VSCODE_DEV&&(g=A(g)||[]);const w=!h(process.env);return D(g,w)}function b(f){let[,,...g]=f;return process.env.VSCODE_DEV&&(g=A(g)||[]),D(g,!0)}function a(f,...g){const w=f.indexOf("--");return w===-1?f.push(...g):f.splice(w,0,...g),f}function h(f){return f.VSCODE_CLI==="1"}}),function(){"use strict";function x(e,n,r){function S(A,I){const b=D(A,I),a=[b];return e.isAbsolute(b)||a.unshift(r),e.resolve(...a)}function D(A,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,I);const h=A["user-data-dir"];if(h)return h;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const f=process.env.USERPROFILE;if(typeof f!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(f,"AppData","Roaming")}break;case"darwin":a=e.join(n.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,I)}return{getUserDataPath:S}}if(typeof define=="function")define(oe[206],ae([122,27,36]),function(e,n,r){return x(e,n,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=x(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[96],ae([0,1,27,205,206]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$9m=A,e.$0m=I;class D extends r.$5m{constructor(a,h){super(a,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,S.getUserDataPath)(a,h.nameShort)},h)}}e.$8m=D;function A(b,a){return(0,r.$7m)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,a,b.extensionEnvironment)}function I(b,a){return(0,r.$7m)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,a,b.extensionEnvironment)}}),define(oe[207],ae([0,1,47,27,31]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=D;function D(A){const I=(0,S.$Ng)((0,r.tmpdir)());try{return(0,n.writeFileSync)(I,""),A&&console.log(`Marker file for --wait created: ${I}`),I}catch(b){A&&console.error(`Failed to create marker file for --wait: ${b}`);return}}}),define(oe[208],ae([0,1,12,176]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=S;function S(A,I,b,a){try{D(A,I,b,a)}catch(h){A.error(h?.message??h)}return I}function D(A,I,b,a){const h=(f,g,w)=>{const l=f[g];if((0,n.$fg)(l)){const p=l,y=p.length;if(y>1&&p[0]==="%"&&p[y-1]==="%"){const $=p.substr(1,y-2);let m=b[$];m===void 0&&a&&(m=a[$]);const v=typeof m=="string"?m:m?.message,k=a?.[$],t=typeof k=="string"?k:k?.message;if(!v){t||A.warn(`[${I.name}]: ${(0,r.localize)(0,null,$)}`);return}if(w&&(g==="title"||g==="category")&&t&&t!==v){const o={value:v,original:t};f[g]=o}else f[g]=v}}else if((0,n.$hg)(l))for(const p in l)l.hasOwnProperty(p)&&(p==="commands"?h(l,p,!0):h(l,p,w));else if(Array.isArray(l))for(let p=0;p<l.length;p++)h(l,p,w)};for(const f in I)I.hasOwnProperty(f)&&h(I,f)}}),define(oe[209],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTools.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts"},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(oe[82],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class n{constructor(S,D=[],A=!1){this.ctor=S,this.staticArguments=D,this.supportsDelayedInstantiation=A}}e.$Ci=n}),define(oe[210],ae([0,1,82]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=D,e.$Ps=A;const r=[];var S;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function D(I,b,a){b instanceof n.$Ci||(b=new n.$Ci(b,[],!!a)),r.push([I,b])}function A(){return r}}),define(oe[211],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class n{constructor(D,A){this.key=D,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$rr=n;class r{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const A of this.a.values())A.outgoing.size===0&&D.push(A);return D}insertEdge(D,A){const I=this.lookupOrInsertNode(D),b=this.lookupOrInsertNode(A);I.outgoing.set(b.key,b),b.incoming.set(I.key,I)}removeNode(D){const A=this.b(D);this.a.delete(A);for(const I of this.a.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(D){const A=this.b(D);let I=this.a.get(A);return I||(I=new n(A,D),this.a.set(A,I)),I}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[A,I]of this.a)D.push(`${A}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,A]of this.a){const I=new Set([D]),b=this.c(A,I);if(b)return b}}c(D,A){for(const[I,b]of D.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const a=this.c(b,A);if(a)return a;A.delete(I)}}}e.$sr=r}),define(oe[6],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=S,e.$Gi=D;var n;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(n||(e._util=n={})),e.$Ei=S("instantiationService");function r(A,I,b){I[n.DI_TARGET]===I?I[n.DI_DEPENDENCIES].push({id:A,index:b}):(I[n.DI_DEPENDENCIES]=[{id:A,index:b}],I[n.DI_TARGET]=I)}function S(A){if(n.serviceIds.has(A))return n.serviceIds.get(A);const I=function(b,a,h){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,b,h)};return I.toString=()=>A,n.serviceIds.set(A,I),I}function D(A){return A}}),define(oe[83],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0,e.$ofc=(0,n.$Fi)("auxiliaryWindowsMainService")}),define(oe[69],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0,e.$xec=(0,n.$Fi)("backupMainService")}),define(oe[18],ae([0,1,12,7,6]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=D,e.$bj=A,e.$cj=b,e.$dj=a,e.$ej=h,e.$fj=f,e.$gj=g,e.$hj=l,e.$ij=p,e.$jj=y,n=Re(n),e.$_i=(0,S.$Fi)("configurationService");function D($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof r.URI)}function A($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof r.URI)}var I;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function b($){switch($){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function a($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function h($,m){const v=Object.create(null);for(const k in $)f(v,k,$[k],m);return v}function f($,m,v,k){const t=m.split("."),o=t.pop();let i=$;for(let c=0;c<t.length;c++){const s=t[c];let u=i[s];switch(typeof u){case"undefined":u=i[s]=Object.create(null);break;case"object":if(u===null){k(`Ignoring ${m} as ${t.slice(0,c+1).join(".")} is null`);return}break;default:k(`Ignoring ${m} as ${t.slice(0,c+1).join(".")} is ${JSON.stringify(u)}`);return}i=u}if(typeof i=="object"&&i!==null)try{i[o]=v}catch{k(`Ignoring ${m} as ${t.join(".")} is ${JSON.stringify(i)}`)}else k(`Ignoring ${m} as ${t.join(".")} is ${JSON.stringify(i)}`)}function g($,m){const v=m.split(".");w($,v)}function w($,m){const v=m.shift();if(m.length===0){delete $[v];return}if(Object.keys($).indexOf(v)!==-1){const k=$[v];typeof k=="object"&&!Array.isArray(k)&&(w(k,m),Object.keys(k).length===0&&delete $[v])}}function l($,m,v){function k(i,c){let s=i;for(const u of c){if(typeof s!="object"||s===null)return;s=s[u]}return s}const t=m.split("."),o=k($,t);return typeof o>"u"?v:o}function p($,m,v){Object.keys(m).forEach(k=>{k!=="__proto__"&&(k in $?n.$hg($[k])&&n.$hg(m[k])?p($[k],m[k],v):v&&($[k]=m[k]):$[k]=m[k])})}function y($){return $.replace(/[\[\]]/g,"")}}),define(oe[123],ae([0,1,39,4,26,203,6,169,16]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=h,e.$Ej=c,e.$Fj=s,e.$Yj=G;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",r.$j),a.set("isLinux",r.$k),a.set("isWindows",r.$i),a.set("isWeb",r.$o),a.set("isMacNative",r.$j&&!r.$o),a.set("isEdge",r.$H),a.set("isFirefox",r.$F),a.set("isChrome",r.$E),a.set("isSafari",r.$G);function h(_,F){if(a.get(_)!==void 0)throw(0,b.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(_,F)}const f=Object.prototype.hasOwnProperty;var g;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(g||(e.ContextKeyExprType=g={}));const w={regexParsingWithErrorRecovery:!0},l=(0,I.localize)(0,null),p=(0,I.localize)(1,null),y=(0,I.localize)(2,null),$=(0,I.localize)(3,null),m=(0,I.localize)(4,null),v=(0,I.localize)(5,null),k=(0,I.localize)(6,null),t=(0,I.localize)(7,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(F=w){this.k=F,this.d=new D.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(F){if(F===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(F).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const W=this.D(),q=W.type===D.TokenType.Str?v:void 0;throw this.h.push({message:m,offset:W.offset,lexeme:D.$Aj.getLexeme(W),additionalInfo:q}),o.c}return N}catch(N){if(N!==o.c)throw N;return}}l(){return this.m()}m(){const F=[this.o()];for(;this.y(D.TokenType.Or);){const N=this.o();F.push(N)}return F.length===1?F[0]:i.or(...F)}o(){const F=[this.s()];for(;this.y(D.TokenType.And);){const N=this.s();F.push(N)}return F.length===1?F[0]:i.and(...F)}s(){if(this.y(D.TokenType.Neg)){const F=this.D();switch(F.type){case D.TokenType.True:return this.z(),d.INSTANCE;case D.TokenType.False:return this.z(),P.INSTANCE;case D.TokenType.LParen:{this.z();const N=this.l();return this.A(D.TokenType.RParen,$),N?.negate()}case D.TokenType.Str:return this.z(),M.create(F.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",F)}}return this.t()}t(){const F=this.D();switch(F.type){case D.TokenType.True:return this.z(),i.true();case D.TokenType.False:return this.z(),i.false();case D.TokenType.LParen:{this.z();const N=this.l();return this.A(D.TokenType.RParen,$),N}case D.TokenType.Str:{const N=F.lexeme;if(this.z(),this.y(D.TokenType.RegexOp)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==D.TokenType.RegexStr)throw this.B("REGEX",q);const Y=q.lexeme,X=Y.lastIndexOf("/"),Z=X===Y.length-1?void 0:this.w(Y.substring(X+1));let ie;try{ie=new RegExp(Y.substring(1,X),Z)}catch{throw this.B("REGEX",q)}return ce.create(N,ie)}switch(q.type){case D.TokenType.RegexStr:case D.TokenType.Error:{const Y=[q.lexeme];this.z();let X=this.D(),Z=0;for(let Ie=0;Ie<q.lexeme.length;Ie++)q.lexeme.charCodeAt(Ie)===n.CharCode.OpenParen?Z++:q.lexeme.charCodeAt(Ie)===n.CharCode.CloseParen&&Z--;for(;!this.E()&&X.type!==D.TokenType.And&&X.type!==D.TokenType.Or;){switch(X.type){case D.TokenType.LParen:Z++;break;case D.TokenType.RParen:Z--;break;case D.TokenType.RegexStr:case D.TokenType.QuotedStr:for(let Ie=0;Ie<X.lexeme.length;Ie++)X.lexeme.charCodeAt(Ie)===n.CharCode.OpenParen?Z++:q.lexeme.charCodeAt(Ie)===n.CharCode.CloseParen&&Z--}if(Z<0)break;Y.push(D.$Aj.getLexeme(X)),this.z(),X=this.D()}const ie=Y.join(""),de=ie.lastIndexOf("/"),me=de===ie.length-1?void 0:this.w(ie.substring(de+1));let we;try{we=new RegExp(ie.substring(1,de),me)}catch{throw this.B("REGEX",q)}return i.regex(N,we)}case D.TokenType.QuotedStr:{const Y=q.lexeme;this.z();let X=null;if(!(0,S.$df)(Y)){const Z=Y.indexOf("/"),ie=Y.lastIndexOf("/");if(Z!==ie&&Z>=0){const de=Y.slice(Z+1,ie),me=Y[ie+1]==="i"?"i":"";try{X=new RegExp(de,me)}catch{throw this.B("REGEX",q)}}}if(X===null)throw this.B("REGEX",q);return ce.create(N,X)}default:throw this.B("REGEX",this.D())}}if(this.y(D.TokenType.Not)){this.A(D.TokenType.In,y);const q=this.u();return i.notIn(N,q)}switch(this.D().type){case D.TokenType.Eq:{this.z();const q=this.u();if(this.x().type===D.TokenType.QuotedStr)return i.equals(N,q);switch(q){case"true":return i.has(N);case"false":return i.not(N);default:return i.equals(N,q)}}case D.TokenType.NotEq:{this.z();const q=this.u();if(this.x().type===D.TokenType.QuotedStr)return i.notEquals(N,q);switch(q){case"true":return i.not(N);case"false":return i.has(N);default:return i.notEquals(N,q)}}case D.TokenType.Lt:return this.z(),ne.create(N,this.u());case D.TokenType.LtEq:return this.z(),Q.create(N,this.u());case D.TokenType.Gt:return this.z(),C.create(N,this.u());case D.TokenType.GtEq:return this.z(),z.create(N,this.u());case D.TokenType.In:return this.z(),i.in(N,this.u());default:return i.has(N)}}case D.TokenType.EOF:throw this.h.push({message:k,offset:F.offset,lexeme:"",additionalInfo:t}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const F=this.D();switch(F.type){case D.TokenType.Str:case D.TokenType.QuotedStr:return this.z(),F.lexeme;case D.TokenType.True:return this.z(),"true";case D.TokenType.False:return this.z(),"false";case D.TokenType.In:return this.z(),"in";default:return""}}w(F){return F.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(F){return this.C(F)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(F,N){if(this.C(F))return this.z();throw this.B(N,this.D())}B(F,N,W){const q=(0,I.localize)(8,null,F,D.$Aj.getLexeme(N)),Y=N.offset,X=D.$Aj.getLexeme(N);return this.h.push({message:q,offset:Y,lexeme:X,additionalInfo:W}),o.c}C(F){return this.D().type===F}D(){return this.f[this.g]}E(){return this.D().type===D.TokenType.EOF}}e.$Cj=o;class i{static false(){return d.INSTANCE}static true(){return P.INSTANCE}static has(F){return E.create(F)}static equals(F,N){return O.create(F,N)}static notEquals(F,N){return R.create(F,N)}static regex(F,N){return ce.create(F,N)}static in(F,N){return T.create(F,N)}static notIn(F,N){return L.create(F,N)}static not(F){return M.create(F)}static and(...F){return H.create(F,null,!0)}static or(...F){return j.create(F,null,!0)}static greater(F,N){return C.create(F,N)}static greaterEquals(F,N){return z.create(F,N)}static smaller(F,N){return ne.create(F,N)}static smallerEquals(F,N){return Q.create(F,N)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(F){return F==null?void 0:this.c.parse(F)}}e.$Dj=i;function c(_){const F=new o({regexParsingWithErrorRecovery:!1});return _.map(N=>(F.parse(N),F.lexingErrors.length>0?F.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,I.localize)(9,null,W.additionalInfo):(0,I.localize)(10,null),offset:W.offset,length:W.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}function s(_,F){const N=_?_.substituteConstants():void 0,W=F?F.substituteConstants():void 0;return!N&&!W?!0:!N||!W?!1:N.equals(W)}function u(_,F){return _.cmp(F)}class d{static{this.INSTANCE=new d}constructor(){this.type=g.False}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return P.INSTANCE}}e.$Gj=d;class P{static{this.INSTANCE=new P}constructor(){this.type=g.True}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return d.INSTANCE}}e.$Hj=P;class E{static create(F,N=null){const W=a.get(F);return typeof W=="boolean"?W?P.INSTANCE:d.INSTANCE:new E(F,N)}constructor(F,N){this.key=F,this.c=N,this.type=g.Defined}cmp(F){return F.type!==this.type?this.type-F.type:V(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=a.get(this.key);return typeof F=="boolean"?F?P.INSTANCE:d.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Ij=E;class O{static create(F,N,W=null){if(typeof N=="boolean")return N?E.create(F,W):M.create(F,W);const q=a.get(F);return typeof q=="boolean"?N===(q?"true":"false")?P.INSTANCE:d.INSTANCE:new O(F,N,W)}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.Equals}cmp(F){return F.type!==this.type?this.type-F.type:le(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=a.get(this.c);if(typeof F=="boolean"){const N=F?"true":"false";return this.d===N?P.INSTANCE:d.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Jj=O;class T{static create(F,N){return new T(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=g.In,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:le(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const N=F.getValue(this.f),W=F.getValue(this.d);return Array.isArray(N)?N.includes(W):typeof W=="string"&&typeof N=="object"&&N!==null?f.call(N,W):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=L.create(this.d,this.f)),this.c}}e.$Kj=T;class L{static create(F,N){return new L(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=g.NotIn,this.c=T.create(F,N)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=L;class R{static create(F,N,W=null){if(typeof N=="boolean")return N?M.create(F,W):E.create(F,W);const q=a.get(F);return typeof q=="boolean"?N===(q?"true":"false")?d.INSTANCE:P.INSTANCE:new R(F,N,W)}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.NotEquals}cmp(F){return F.type!==this.type?this.type-F.type:le(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=a.get(this.c);if(typeof F=="boolean"){const N=F?"true":"false";return this.d===N?d.INSTANCE:P.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Mj=R;class M{static create(F,N=null){const W=a.get(F);return typeof W=="boolean"?W?d.INSTANCE:P.INSTANCE:new M(F,N)}constructor(F,N){this.c=F,this.d=N,this.type=g.Not}cmp(F){return F.type!==this.type?this.type-F.type:V(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=a.get(this.c);return typeof F=="boolean"?F?d.INSTANCE:P.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}e.$Nj=M;function B(_,F){if(typeof _=="string"){const N=parseFloat(_);isNaN(N)||(_=N)}return typeof _=="string"||typeof _=="number"?F(_):d.INSTANCE}class C{static create(F,N,W=null){return B(N,q=>new C(F,q,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.Greater}cmp(F){return F.type!==this.type?this.type-F.type:le(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Oj=C;class z{static create(F,N,W=null){return B(N,q=>new z(F,q,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.GreaterEquals}cmp(F){return F.type!==this.type?this.type-F.type:le(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Pj=z;class ne{static create(F,N,W=null){return B(N,q=>new ne(F,q,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.Smaller}cmp(F){return F.type!==this.type?this.type-F.type:le(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Qj=ne;class Q{static create(F,N,W=null){return B(N,q=>new Q(F,q,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.SmallerEquals}cmp(F){return F.type!==this.type?this.type-F.type:le(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Rj=Q;class ce{static create(F,N){return new ce(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=g.Regex,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const N=this.f?this.f.source:"",W=F.f?F.f.source:"";return N<W?-1:N>W?1:0}equals(F){if(F.type===this.type){const N=this.f?this.f.source:"",W=F.f?F.f.source:"";return this.d===F.d&&N===W}return!1}substituteConstants(){return this}evaluate(F){const N=F.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Sj=ce;class K{static create(F){return new K(F)}constructor(F){this.c=F,this.type=g.NotRegex}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(F){return new K(this.c.map(F))}negate(){return this.c}}e.$Tj=K;function ee(_){let F=null;for(let N=0,W=_.length;N<W;N++){const q=_[N].substituteConstants();if(_[N]!==q&&F===null){F=[];for(let Y=0;Y<N;Y++)F[Y]=_[Y]}F!==null&&(F[N]=q)}return F===null?_:F}class H{static create(F,N,W){return H.d(F,N,W)}constructor(F,N){this.expr=F,this.c=N,this.type=g.And}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const q=u(this.expr[N],F.expr[N]);if(q!==0)return q}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(F.expr[N]))return!1;return!0}return!1}substituteConstants(){const F=ee(this.expr);return F===this.expr?this:H.create(F,this.c,!1)}evaluate(F){for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].evaluate(F))return!1;return!0}static d(F,N,W){const q=[];let Y=!1;for(const X of F)if(X){if(X.type===g.True){Y=!0;continue}if(X.type===g.False)return d.INSTANCE;if(X.type===g.And){q.push(...X.expr);continue}q.push(X)}if(q.length===0&&Y)return P.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(u);for(let X=1;X<q.length;X++)q[X-1].equals(q[X])&&(q.splice(X,1),X--);if(q.length===1)return q[0];for(;q.length>1;){const X=q[q.length-1];if(X.type!==g.Or)break;q.pop();const Z=q.pop(),ie=q.length===0,de=j.create(X.expr.map(me=>H.create([me,Z],null,W)),null,ie);de&&(q.push(de),q.sort(u))}if(q.length===1)return q[0];if(W){for(let X=0;X<q.length;X++)for(let Z=X+1;Z<q.length;Z++)if(q[X].negate().equals(q[Z]))return d.INSTANCE;if(q.length===1)return q[0]}return new H(q,N)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const N of this.expr)F.push(...N.keys());return F}map(F){return new H(this.expr.map(N=>N.map(F)),null)}negate(){if(!this.c){const F=[];for(const N of this.expr)F.push(N.negate());this.c=j.create(F,this,!0)}return this.c}}e.$Uj=H;class j{static create(F,N,W){return j.d(F,N,W)}constructor(F,N){this.expr=F,this.c=N,this.type=g.Or}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const q=u(this.expr[N],F.expr[N]);if(q!==0)return q}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(F.expr[N]))return!1;return!0}return!1}substituteConstants(){const F=ee(this.expr);return F===this.expr?this:j.create(F,this.c,!1)}evaluate(F){for(let N=0,W=this.expr.length;N<W;N++)if(this.expr[N].evaluate(F))return!0;return!1}static d(F,N,W){let q=[],Y=!1;if(F){for(let X=0,Z=F.length;X<Z;X++){const ie=F[X];if(ie){if(ie.type===g.False){Y=!0;continue}if(ie.type===g.True)return P.INSTANCE;if(ie.type===g.Or){q=q.concat(ie.expr);continue}q.push(ie)}}if(q.length===0&&Y)return d.INSTANCE;q.sort(u)}if(q.length!==0){if(q.length===1)return q[0];for(let X=1;X<q.length;X++)q[X-1].equals(q[X])&&(q.splice(X,1),X--);if(q.length===1)return q[0];if(W){for(let X=0;X<q.length;X++)for(let Z=X+1;Z<q.length;Z++)if(q[X].negate().equals(q[Z]))return P.INSTANCE;if(q.length===1)return q[0]}return new j(q,N)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const N of this.expr)F.push(...N.keys());return F}map(F){return new j(this.expr.map(N=>N.map(F)),null)}negate(){if(!this.c){const F=[];for(const N of this.expr)F.push(N.negate());for(;F.length>1;){const N=F.shift(),W=F.shift(),q=[];for(const Y of se(N))for(const X of se(W))q.push(H.create([Y,X],null,!1));F.unshift(j.create(q,null,!1))}this.c=j.create(F,this,!0)}return this.c}}e.$Vj=j;class U extends E{static{this.d=[]}static all(){return U.d.values()}constructor(F,N,W){super(F,null),this.f=N,typeof W=="object"?U.d.push({...W,key:F}):W!==!0&&U.d.push({key:F,description:W,type:N!=null?typeof N:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return O.create(this.key,F)}notEqualsTo(F){return R.create(this.key,F)}}e.$Wj=U,e.$Xj=(0,A.$Fi)("contextKeyService");function V(_,F){return _<F?-1:_>F?1:0}function le(_,F,N,W){return _<N?-1:_>N?1:F<W?-1:F>W?1:0}function G(_,F){if(_.type===g.False||F.type===g.True)return!0;if(_.type===g.Or)return F.type===g.Or?he(_.expr,F.expr):!1;if(F.type===g.Or){for(const N of F.expr)if(G(_,N))return!0;return!1}if(_.type===g.And){if(F.type===g.And)return he(F.expr,_.expr);for(const N of _.expr)if(G(N,F))return!0;return!1}return _.equals(F)}function he(_,F){let N=0,W=0;for(;N<_.length&&W<F.length;){const q=_[N].cmp(F[W]);if(q<0)return!1;q===0&&N++,W++}return N===_.length}function se(_){return _.type===g.Or?_.expr:[_]}}),define(oe[97],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Sm=e.ID=void 0,e.$Tm=r,e.ID="diagnosticsService",e.$Sm=(0,n.$Fi)(e.ID);function r(D){return!!D.hostName&&!!D.errorMessage}class S{async getPerformanceInfo(A,I){return{}}async getSystemInfo(A,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,I){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.$Um=S});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[124],ae([0,1,19,79,171,6,48,4,35]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$8w=e.$7w=e.$6w=void 0,e.$9w=w,e.$0w=l,r=et(r),e.$6w=(0,D.$Fi)("dialogService");var a;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(a||(a={}));class h{a(y){return this.d(y,a.Confirmation)}b(y){return this.d(y,a.Prompt)}c(y){return this.d(y,a.Input)}d(y,$){const m=[];switch($){case a.Confirmation:{const v=y;v.primaryButton?m.push(v.primaryButton):m.push((0,S.localize)(0,null)),v.cancelButton?m.push(v.cancelButton):m.push((0,S.localize)(1,null));break}case a.Prompt:{const v=y;Array.isArray(v.buttons)&&v.buttons.length>0&&m.push(...v.buttons.map(k=>k.label)),v.cancelButton&&(v.cancelButton===!0?m.push((0,S.localize)(2,null)):typeof v.cancelButton=="string"?m.push(v.cancelButton):v.cancelButton.label?m.push(v.cancelButton.label):m.push((0,S.localize)(3,null))),m.length===0&&m.push((0,S.localize)(4,null));break}case a.Input:{const v=y;v.primaryButton?m.push(v.primaryButton):m.push((0,S.localize)(5,null)),v.cancelButton?m.push(v.cancelButton):m.push((0,S.localize)(6,null));break}}return m}e(y){if(typeof y=="string")return y;if(typeof y=="number")return y===r.default.Info?"info":y===r.default.Error?"error":y===r.default.Warning?"warning":"none"}f(y,$,m){const v=[...y.buttons??[]];y.cancelButton&&typeof y.cancelButton!="string"&&typeof y.cancelButton!="boolean"&&v.push(y.cancelButton);let k=v[$]?.run({checkboxChecked:m});return k instanceof Promise||(k=Promise.resolve(k)),{result:k,checkboxChecked:m}}}e.$7w=h,e.$8w=(0,D.$Fi)("fileDialogService");var f;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(f||(e.ConfirmResult=f={}));const g=10;function w(p){const y=[];return y.push(...p.slice(0,g).map($=>typeof $=="string"?$:(0,n.$dh)($))),p.length>g&&(p.length-g===1?y.push((0,S.localize)(7,null)):y.push((0,S.localize)(8,null,p.length-g))),y.push(""),y.join(`
`)}function l(p,y){const $=(0,b.$do)(p);let m=($.buttons??[]).map(o=>(0,A.$3w)(o)),v=(p.buttons||[]).map((o,i)=>i),k=0,t=$.cancelId??m.length-1;if(m.length>1){const o=typeof t=="number"?m[t]:void 0;if(I.$k||I.$j){if(typeof o=="string"&&m.length>1&&t!==1){m.splice(t,1),m.splice(1,0,o);const i=v[t];v.splice(t,1),v.splice(1,0,i),t=1}I.$k&&m.length>1&&(m=m.reverse(),v=v.reverse(),k=m.length-1,typeof o=="string"&&(t=k-1))}else if(I.$i&&typeof o=="string"&&m.length>1&&t!==m.length-1){m.splice(t,1),m.push(o);const i=v[t];v.splice(t,1),v.push(i),t=m.length-1}}return $.buttons=m,$.defaultId=k,$.cancelId=t,$.noLink=!0,$.title=$.title||y.nameLong,{options:$,buttonIndeces:v}}}),define(oe[98],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$nY=e.$mY=void 0,e.$oY=D,e.$pY=A,e.$mY=(0,n.$Fi)("encryptionService"),e.$nY=(0,n.$Fi)("encryptionMainService");var r;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(r||(e.PasswordStoreCLIOption=r={}));var S;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(S||(e.KnownStorageProvider=S={}));function D(I){return I===S.kwallet||I===S.kwallet5||I===S.kwallet6}function A(I){return I===S.gnomeAny||I===S.gnomeLibsecret||I===S.gnomeKeyring}}),define(oe[38],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,n.$Fi)("environmentService"),e.$Ni=(0,n.$Gi)(e.$Mi)}),define(oe[212],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=e.$dfc=void 0,e.$dfc=(0,n.$Fi)("extensionHostStarter"),e.$efc="extensionHostStarter"}),define(oe[213],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w9b=e.$v9b=void 0,e.$v9b=(0,n.$Fi)("externalTerminal"),e.$w9b="Terminal.app"}),define(oe[214],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0,e.$gfc=(0,n.$Fi)("externalTerminal")}),define(oe[215],ae([0,1,49,52,13,9,4,80,21,95,179,213]),function(x,e,n,r,S,D,A,I,b,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=e.$ifc=e.$hfc=void 0,n=Re(n),D=Re(D),A=Re(A),b=Re(b),a=Re(a),h=Re(h);const g=h.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:l.getDefaultTerminalWindows(),linux:await y.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class l extends w{static{this.b="cmd.exe"}openTerminal(t,o){return this.spawnTerminal(n,t,a.$xm(),o)}spawnTerminal(t,o,i,c){const s=o.windowsExec||l.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const u=D.$pc(s,".exe").toLowerCase();if(u==="cmder")return t.spawn(s,c?[c]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return s.indexOf(" ")>=0&&d.push('""'),d.push(s),u==="wt"&&d.push("-d ."),new Promise((P,E)=>{const O=$(process),T=t.spawn(i,d,{cwd:c,env:O,detached:!0});T.on("error",E),T.on("exit",()=>P())})}async runInTerminal(t,o,i,c,s){const u="windowsExec"in s&&s.windowsExec?s.windowsExec:l.getDefaultTerminalWindows(),d=await l.f();return new Promise((P,E)=>{const O=`"${o} - ${g}"`,T=`"${i.join('" "')}" & pause`,L=Object.assign({},$(process),c);Object.keys(L).filter(z=>L[z]===null).forEach(z=>delete L[z]);const R={cwd:o,env:L,windowsVerbatimArguments:!0};let M,B;D.$pc(u,".exe")==="wt"?(M=u,B=["-d",".",l.b,"/c",T]):d?(M=d,B=["-d",".",u,"/c",T]):(M=l.b,B=["/c","start",O,"/wait",u,"/c",`"${T}"`]),n.spawn(M,B,R).on("error",z=>{E(m(z))}),P(void 0)})}static getDefaultTerminalWindows(){if(!l.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");l.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return l.d}static async f(){try{const t=await a.win32.findExecutable("wt");return await b.Promises.exists(t)?t:void 0}catch{return}}}e.$hfc=l,Se([r.$0h],l,"f",null);class p extends w{static{this.b="/usr/bin/osascript"}openTerminal(t,o){return this.spawnTerminal(n,t,o)}runInTerminal(t,o,i,c,s){const u=s.osxExec||f.$w9b;return new Promise((d,P)=>{if(u===f.$w9b||u==="iTerm.app"){const E=u===f.$w9b?"TerminalHelper":"iTermHelper",T=[S.$Zg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`).fsPath,"-t",t||g,"-w",o];for(const M of i)T.push("-a"),T.push(M);if(c){const M=Object.assign({},$(process),c);for(const B in M){const C=M[B];C===null?(T.push("-u"),T.push(B)):(T.push("-e"),T.push(`${B}=${C}`))}}let L="";const R=n.spawn(p.b,T);R.on("error",M=>{P(m(M))}),R.stderr.on("data",M=>{L+=M.toString()}),R.on("exit",M=>{if(M===0)d(void 0);else if(L){const B=L.split(`
`,1);P(new Error(B[0]))}else P(new Error(h.localize(1,null,E,M)))})}else P(new Error(h.localize(2,null,u)))})}spawnTerminal(t,o,i){const c=o.osxExec||f.$w9b;return new Promise((s,u)=>{const d=["-a",c];i&&d.push(i);const P=$(process),E=t.spawn("/usr/bin/open",d,{cwd:i,env:P});E.on("error",u),E.on("exit",()=>s())})}}e.$ifc=p;class y extends w{static{this.b=h.localize(3,null)}openTerminal(t,o){return this.spawnTerminal(n,t,o)}runInTerminal(t,o,i,c,s){const u=s.linuxExec?Promise.resolve(s.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((d,P)=>{const E=[];u.then(O=>{O.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const T=`${v(i)}; echo; read -p "${y.b}" -n1;`;E.push(`''${T}''`);const L=Object.assign({},$(process),c);Object.keys(L).filter(C=>L[C]===null).forEach(C=>delete L[C]);const R={cwd:o,env:L};let M="";const B=n.spawn(O,E,R);B.on("error",C=>{P(m(C))}),B.stderr.on("data",C=>{M+=C.toString()}),B.on("exit",C=>{if(C===0)d(void 0);else if(M){const z=M.split(`
`,1);P(new Error(z[0]))}else P(new Error(h.localize(4,null,O,C)))})})})}static async getDefaultTerminalLinuxReady(){if(!y.d)if(!A.$k)y.d=Promise.resolve("xterm");else{const t=await b.Promises.exists("/etc/debian_version");y.d=new Promise(o=>{t?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm")})}return y.d}spawnTerminal(t,o,i){const c=o.linuxExec?Promise.resolve(o.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((s,u)=>{c.then(d=>{const P=$(process),E=t.spawn(d,[],{cwd:i,env:P});E.on("error",u),E.on("exit",()=>s())})})}}e.$jfc=y;function $(k){const t={...k.env};return(0,I.$km)(t),t}function m(k){return"errno"in k&&k.errno==="ENOENT"&&"path"in k&&typeof k.path=="string"?new Error(h.localize(5,null,k.path)):k}function v(k){let t="";for(const o of k)o.indexOf(" ")>=0?t+='"'+o+'"':t+=o,t+=" ";return t}}),define(oe[15],ae([0,1,61,9,26,12,7,181,6,4,13,65]),function(x,e,n,r,S,D,A,I,b,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=g,e.$bl=y,e.$cl=m,e.$dl=v,e.$el=k,e.$fl=t,e.$gl=o,e.$hl=i,e.$il=c,e.$jl=s,e.$kl=u,e.$ml=E,e.$nl=O,e.$ol=T,e.$pl=L,e.$ql=R,e.$tl=ne,e.$Fl=j,e.$Gl=U,e.$Il=le,e.$_k=(0,b.$Fi)("fileService");function g(G){return G.create===!0}var w;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var l;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var p;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(p||(e.FileChangeFilter=p={}));function y(G){const he=G;return!!he&&typeof he.onDidChange=="function"}var $;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function m(G){return!!(G.capabilities&$.FileReadWrite)}function v(G){return!!(G.capabilities&$.FileFolderCopy)}function k(G){return!!(G.capabilities&$.FileClone)}function t(G){return!!(G.capabilities&$.FileOpenReadWriteClose)}function o(G){return!!(G.capabilities&$.FileReadStream)}function i(G){return m(G)?!!(G.capabilities&$.FileAtomicRead):!1}function c(G){return m(G)?!!(G.capabilities&$.FileAtomicWrite):!1}function s(G){return!!(G.capabilities&$.FileAtomicDelete)}function u(G){return!!(G.capabilities&$.Readonly)}var d;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(d||(e.FileSystemProviderErrorCode=d={}));class P extends Error{static create(he,se){const _=new P(he.toString(),se);return T(_,se),_}constructor(he,se){super(he),this.code=se}}e.$ll=P;function E(G,he){return P.create(G,he)}function O(G){return G||E((0,I.localize)(0,null),d.Unknown)}function T(G,he){return G.name=he?`${he} (FileSystemError)`:"FileSystemError",G}function L(G){if(!G)return d.Unknown;if(G instanceof P)return G.code;const he=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!he)return d.Unknown;switch(he[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}function R(G){if(G instanceof Q)return G.fileOperationResult;switch(L(G)){case d.FileNotFound:return ee.FILE_NOT_FOUND;case d.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case d.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case d.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case d.NoPermissions:return ee.FILE_PERMISSION_DENIED;case d.FileExists:return ee.FILE_MOVE_CONFLICT;case d.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var M;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class B{constructor(he,se,_){this.resource=he,this.operation=se,this.target=_}isOperation(he){return this.operation===he}}e.$rl=B;var C;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(C||(e.FileChangeType=C={}));class z{static{this.a=null}constructor(he,se){this.c=se,this.b=void 0,this.d=new f.$X(()=>{const _=n.$Li.forUris(()=>this.c);return _.fill(this.rawAdded.map(F=>[F,!0])),_}),this.f=new f.$X(()=>{const _=n.$Li.forUris(()=>this.c);return _.fill(this.rawUpdated.map(F=>[F,!0])),_}),this.g=new f.$X(()=>{const _=n.$Li.forUris(()=>this.c);return _.fill(this.rawDeleted.map(F=>[F,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of he){switch(_.type){case C.ADDED:this.rawAdded.push(_.resource);break;case C.UPDATED:this.rawUpdated.push(_.resource);break;case C.DELETED:this.rawDeleted.push(_.resource);break}this.b!==z.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(he,...se){return this.h(he,{includeChildren:!1},...se)}affects(he,...se){return this.h(he,{includeChildren:!0},...se)}h(he,se,..._){if(!he)return!1;const F=_.length>0;return!!((!F||_.includes(C.ADDED))&&(this.d.value.get(he)||se.includeChildren&&this.d.value.findSuperstr(he))||(!F||_.includes(C.UPDATED))&&(this.f.value.get(he)||se.includeChildren&&this.f.value.findSuperstr(he))||(!F||_.includes(C.DELETED))&&(this.g.value.findSubstr(he)||se.includeChildren&&this.g.value.findSuperstr(he)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(he){return this.b===he}hasCorrelation(){return typeof this.b=="number"}}e.$sl=z;function ne(G,he,se){return!G||!he||G===he||he.length>G.length?!1:(he.charAt(he.length-1)!==r.sep&&(he+=r.sep),se?(0,S.$Hf)(G,he):G.indexOf(he)===0)}class Q extends Error{constructor(he,se,_){super(he),this.fileOperationResult=se,this.options=_}}e.$ul=Q;class ce extends Q{constructor(he,se,_,F){super(he,se,F),this.fileOperationResult=se,this.size=_}}e.$vl=ce;class K extends Q{constructor(he,se,_){super(he,ee.FILE_NOT_MODIFIED_SINCE,_),this.stat=se}}e.$wl=K;var ee;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var H;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$El="";function j(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function U(G,he){if(!he.hasProvider(A.URI.from({scheme:G.scheme})))return new Promise(se=>{const _=he.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===G.scheme&&F.added&&(_.dispose(),se())})})}class V{static{this.KB=1024}static{this.MB=V.KB*V.KB}static{this.GB=V.MB*V.KB}static{this.TB=V.GB*V.KB}static formatSize(he){return(0,D.$jg)(he)||(he=0),he<V.KB?(0,I.localize)(1,null,he.toFixed(0)):he<V.MB?(0,I.localize)(2,null,(he/V.KB).toFixed(2)):he<V.GB?(0,I.localize)(3,null,(he/V.MB).toFixed(2)):he<V.TB?(0,I.localize)(4,null,(he/V.GB).toFixed(2)):(0,I.localize)(5,null,(he/V.TB).toFixed(2))}}e.$Hl=V;function le(G){const he=typeof G=="string"||G?.scheme===h.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===h.Schemas.file?1024*V.MB:he?10*V.MB:a.$o?50*V.MB:1024*V.MB}}),define(oe[125],ae([0,1,17,16,182,15]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=A;async function A(h,f,g,w,l,p){let y;try{await I(h,f,g,w,l,p)}catch($){y=$}finally{y&&l.errorTransformer&&(y=l.errorTransformer(y)),typeof y<"u"&&g.error(y),g.end()}}async function I(h,f,g,w,l,p){b(p);const y=await h.open(f,{create:!1});try{b(p);let $=0,m=0,v=l&&typeof l.length=="number"?l.length:void 0,k=n.$Oe.alloc(Math.min(l.bufferSize,typeof v=="number"?v:l.bufferSize)),t=l&&typeof l.position=="number"?l.position:0,o=0;do m=await h.read(y,t,k.buffer,o,k.byteLength-o),t+=m,o+=m,$+=m,typeof v=="number"&&(v-=m),o===k.byteLength&&(await g.write(w(k)),k=n.$Oe.alloc(Math.min(l.bufferSize,typeof v=="number"?v:l.bufferSize)),o=0);while(m>0&&(typeof v!="number"||v>0)&&b(p)&&a($,l));if(o>0){let i=o;typeof v=="number"&&(i=Math.min(o,v)),g.write(w(k.slice(0,i)))}}catch($){throw(0,D.$nl)($)}finally{await h.close(y)}}function b(h){if(h.isCancellationRequested)throw(0,r.$8)();return!0}function a(h,f){if(typeof f?.limits?.size=="number"&&h>f.limits.size)throw(0,D.$ml)((0,S.localize)(0,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[62],ae([0,1,113,2,9,4,7,15]),function(x,e,n,r,S,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0,e.$1q=b,e.$2q=a,e.$6q=w,e.$7q=l,e.$8q=p,e.$9q=y,e.$0q=m,e.$$q=v;function b(k){return typeof k.correlationId=="number"}function a(k){return k.recursive===!0}class h extends r.$Wc{static{this.a=5}constructor(t,o,i,c){super(),this.h=t,this.j=o,this.m=i,this.n=c,this.c=this.B(new r.$Xc),this.f=void 0,this.g=0}s(){const t=new r.$Vc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(o=>this.h(o))),t.add(this.b.onDidLogMessage(o=>this.j(o))),t.add(this.b.onDidError(o=>this.t(o.error,o.request)))}t(t,o){this.u(t,o)?this.g<h.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,o){return!(!this.n.restartOnError||o||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$3q=h;class f extends h{constructor(t,o,i){super(t,o,i,{type:"node.js",restartOnError:!1})}}e.$4q=f;class g extends h{constructor(t,o,i){super(t,o,i,{type:"universal",restartOnError:!0})}}e.$5q=g;function w(k){return k.map(t=>({type:t.type,resource:A.URI.revive(t.resource),cId:t.cId}))}function l(k){const t=new $;for(const o of k)t.processEvent(o);return t.coalesce()}function p(k,t){return typeof t=="string"&&!t.startsWith(n.$vk)&&!(0,S.$kc)(t)?{base:k,pattern:t}:t}function y(k,t){const o=[];for(const i of t)o.push((0,n.$zk)(p(k,i)));return o}class ${constructor(){this.a=new Set,this.b=new Map}c(t){return D.$k?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const o=this.b.get(this.c(t));let i=!1;if(o){const c=o.type,s=t.type;o.resource.fsPath!==t.resource.fsPath&&(t.type===I.FileChangeType.DELETED||t.type===I.FileChangeType.ADDED)?i=!0:c===I.FileChangeType.ADDED&&s===I.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(o)):c===I.FileChangeType.DELETED&&s===I.FileChangeType.ADDED?o.type=I.FileChangeType.UPDATED:c===I.FileChangeType.ADDED&&s===I.FileChangeType.UPDATED||(o.type=s)}else i=!0;i&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],o=[];return Array.from(this.a).filter(i=>i.type!==I.FileChangeType.DELETED?(t.push(i),!1):!0).sort((i,c)=>i.resource.fsPath.length-c.resource.fsPath.length).filter(i=>o.some(c=>(0,I.$tl)(i.resource.fsPath,c,!D.$k))?!1:(o.push(i.resource.fsPath),!0)).concat(t)}}function m(k,t){if(typeof t=="number")switch(k.type){case I.FileChangeType.ADDED:return(t&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(t&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(t&I.FileChangeFilter.UPDATED)===0}return!1}function v(k){if(typeof k=="number"){const t=[];return k&I.FileChangeFilter.ADDED&&t.push("Added"),k&I.FileChangeFilter.DELETED&&t.push("Deleted"),k&I.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(oe[216],ae([0,1,17,53,16,3,2,67,33,15,62]),function(x,e,n,r,S,D,A,I,b,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Q=e.$9Q=void 0,e.$9Q="localFilesystem";class f extends A.$Wc{constructor(w,l){super(),this.a=w,this.b=l,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$me),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$me),this.onDidWatchError=this.g.event,this.h=(0,b.$2g)(),this.j()}get capabilities(){return this.c||(this.c=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=a.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=a.FileSystemProviderCapabilities.Trash)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,l){const{buffer:p}=await this.a.call("readFile",[w,l]);return p}readFileStream(w,l,p){const y=(0,I.$Ce)(m=>n.$Oe.concat(m.map(v=>n.$Oe.wrap(v))).buffer),$=new A.$Vc;return $.add(this.a.listen("readFileStream",[w,l])(m=>{if(m instanceof n.$Oe)y.write(m.buffer);else{if(m==="end")y.end();else{let v;if(m instanceof Error)v=m;else{const k=m;v=(0,a.$ml)(k.message??(0,r.$qj)(k),k.code??a.FileSystemProviderErrorCode.Unknown)}y.error(v),y.end()}$.dispose()}})),$.add(p.onCancellationRequested(()=>{y.error((0,S.$8)()),y.end(),$.dispose()})),y}writeFile(w,l,p){return this.a.call("writeFile",[w,n.$Oe.wrap(l),p])}open(w,l){return this.a.call("open",[w,l])}close(w){return this.a.call("close",[w])}async read(w,l,p,y,$){const[m,v]=await this.a.call("read",[w,l,$]);return p.set(m.buffer.slice(0,v),y),v}write(w,l,p,y,$){return this.a.call("write",[w,l,n.$Oe.wrap(p),y,$])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,l){return this.a.call("delete",[w,l])}rename(w,l,p){return this.a.call("rename",[w,l,p])}copy(w,l,p){return this.a.call("copy",[w,l,p])}cloneFile(w,l){return this.a.call("cloneFile",[w,l])}j(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const l=w;this.f.fire((0,h.$6q)(l))}else{const l=w;this.g.fire(l)}}))}watch(w,l){const p=(0,b.$2g)();return this.a.call("watch",[this.h,p,w,l]),(0,A.$Uc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$0Q=f}),define(oe[217],ae([0,1,47,2,62,3,15,7,8]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class a extends r.$Wc{constructor(){super(),this.a=this.B(new D.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$6c),this.m=new Set,this.n=this.B(new b.$Dh(this.y())),this.r=5007,this.s=new b.$3h,this.R=!1,this.B(this.f(f=>this.t(f)))}t(f){this.u(f)&&this.z(f)}u(f){return(0,S.$1q)(f)}async watch(f){this.s.isSettled||this.s.complete(),this.s=new b.$3h;try{this.h.clear(),this.g.clear();for(const g of f)this.u(g)?this.h.set(g.correlationId,g):this.g.add(g);for(const[g]of this.j)this.h.has(g)||(this.j.deleteAndDispose(g),this.m.delete(g));return await this.w(!1)}finally{this.s.complete()}}w(f){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(g=>!this.j.has(g.correlationId))]),f?this.y():0)}y(){return 800}isSuspended(f){return typeof f.correlationId!="number"?!1:this.m.has(f.correlationId)?"polling":this.j.has(f.correlationId)}async z(f){if(this.j.has(f.correlationId))return;const g=new r.$Vc;this.j.set(f.correlationId,g),await this.s.p,!g.isDisposed&&(this.D(f,g),this.w(!0))}C(f){this.j.deleteAndDispose(f.correlationId),this.m.delete(f.correlationId),this.w(!1)}D(f,g){this.F(f,g)?(this.P(`reusing an existing recursive watcher to monitor ${f.path}`),this.m.delete(f.correlationId)):(this.G(f,g),this.m.add(f.correlationId))}F(f,g){const w=this.O?.subscribe(f.path,(l,p)=>{g.isDisposed||(l?this.D(f,g):p?.type===A.FileChangeType.ADDED&&this.H(f))});return w?(g.add(w),!0):!1}G(f,g){let w=!1;const l=(p,y)=>{if(g.isDisposed)return;const $=this.I(p),m=this.I(y),v=w;w=$,!$&&(m||v)&&this.H(f)};this.P(`starting fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,n.watchFile)(f.path,{persistent:!1,interval:this.r},l)}catch(p){this.Q(`fs.watchFile() failed with error ${p} on path ${f.path} (correlationId: ${f.correlationId})`)}g.add((0,r.$Uc)(()=>{this.P(`stopping fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,n.unwatchFile)(f.path,l)}catch(p){this.Q(`fs.unwatchFile() failed with error ${p} on path ${f.path} (correlationId: ${f.correlationId})`)}}))}H(f){this.P(`detected ${f.path} exists again, resuming watcher (correlationId: ${f.correlationId})`);const g={resource:I.URI.file(f.path),type:A.FileChangeType.ADDED,cId:f.correlationId};this.a.fire([g]),this.J(g,f),this.C(f)}I(f){return f.ctimeMs===0&&f.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(f,g){if(this.R){const w=` >> normalized ${f.type===A.FileChangeType.ADDED?"[ADDED]":f.type===A.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`;this.L(w,g)}}L(f,g){this.R&&this.P(`${f}${typeof g.correlationId=="number"?` <${g.correlationId}> `:""}`)}M(f){return`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, filter: ${(0,S.$$q)(f.filter)}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`}async setVerboseLogging(f){this.R=f}}e.$hr=a}),define(oe[218],ae([0,1,47,8,23,31,2,77,9,4,19,7,114,21,15,62]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0,e.$nr=$;class y extends A.$Wc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(v,k,t,o,i,c){super(),this.s=v,this.t=k,this.u=t,this.w=o,this.y=i,this.z=c,this.c=this.B(new r.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new r.$Th(s=>this.M(s),y.b)),this.g=(0,p.$9q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,p.$9q)(this.s.path,this.s.includes):void 0,this.j=(0,p.$1q)(this.s)?this.s.filter:void 0,this.m=new S.$xe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const v=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const k=await w.Promises.stat(v);if(this.m.token.isCancellationRequested)return;this.B(await this.G(v,k.isDirectory()))}catch(v){v.code!=="ENOENT"?this.O(v):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${v})`),this.D()}}D(){this.r=!0,this.w?.()}async F(v){let k=v.path;try{k=await w.Promises.realpath(v.path),v.path===k&&(k=await(0,g.$jr)(v.path,this.m.token)??v.path),v.path!==k&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${k})`)}catch{}return k}async G(v,k){const t=new A.$Vc;return this.H(v,k,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(v,k,t)),t}H(v,k,t){if(k)return!1;const o=f.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(c,s)=>{if(!t.isDisposed)if(c){const u=await this.G(v,k);t.isDisposed?u.dispose():t.add(u)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:o,type:s.type,cId:this.s.correlationId},!0)});return i?(t.add(i),!0):!1}async I(v,k,t){if(a.$j&&(0,D.$Eg)(v,"/Volumes/",!0)){this.O(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new S.$xe(this.m.token);t.add((0,A.$Uc)(()=>o.dispose(!0)));const i=new A.$Vc;t.add(i);try{const c=f.URI.file(this.s.path),s=(0,b.$pc)(v),u=(0,n.watch)(v);i.add((0,A.$Uc)(()=>{u.removeAllListeners(),u.close()})),this.Q(`Started watching: '${v}'`);const d=new Set;if(k)try{for(const E of await w.Promises.readdir(v))d.add(E)}catch(E){this.O(E)}if(o.token.isCancellationRequested)return;const P=new Map;i.add((0,A.$Uc)(()=>{for(const[,E]of P)E.dispose();P.clear()})),u.on("error",(E,O)=>{o.token.isCancellationRequested||(this.O(`Failed to watch ${v} for changes using fs.watch() (${E}, ${O})`),this.D())}),u.on("change",(E,O)=>{if(o.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${E}"] ${O}`);let T="";if(O&&(T=O.toString(),a.$j&&(T=(0,I.$mm)(T))),!(!T||E!=="change"&&E!=="rename"))if(k)if(E==="rename"){P.get(T)?.dispose();const L=setTimeout(async()=>{if(P.delete(T),T===s&&!await w.Promises.exists(v)){this.J(c);return}if(o.token.isCancellationRequested)return;const R=await this.N((0,b.$lc)(v,T));if(o.token.isCancellationRequested)return;let M;R?d.has(T)?M=l.FileChangeType.UPDATED:(M=l.FileChangeType.ADDED,d.add(T)):(d.delete(T),M=l.FileChangeType.DELETED),this.L({resource:(0,h.$gh)(c,T),type:M,cId:this.s.correlationId})},y.a);P.set(T,(0,A.$Uc)(()=>clearTimeout(L)))}else{let L;d.has(T)?L=l.FileChangeType.UPDATED:(L=l.FileChangeType.ADDED,d.add(T)),this.L({resource:(0,h.$gh)(c,T),type:L,cId:this.s.correlationId})}else if(E==="rename"||T!==s){const L=setTimeout(async()=>{const R=await w.Promises.exists(v);o.token.isCancellationRequested||(R?(this.L({resource:c,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(v,!1))):this.J(c))},y.a);i.clear(),i.add((0,A.$Uc)(()=>clearTimeout(L)))}else this.L({resource:c,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(c){o.token.isCancellationRequested||this.O(`Failed to watch ${v} for changes using fs.watch() (${c.toString()})`),this.D()}}J(v){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:v,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(v,k=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${v.type===l.FileChangeType.ADDED?"[ADDED]":v.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`),!k&&this.g.some(t=>t(v.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${v.resource.fsPath}`):!k&&this.h&&this.h.length>0&&!this.h.some(t=>t(v.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${v.resource.fsPath}`):this.f.work(v))}M(v){const k=(0,p.$7q)(v),t=[];for(const i of k){if((0,p.$0q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}t.push(i)}if(t.length===0)return;if(this.z)for(const i of t)this.R(` >> normalized ${i.type===l.FileChangeType.ADDED?"[ADDED]":i.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(v){if(a.$k)return w.Promises.exists(v);try{const k=(0,b.$pc)(v);return(await w.Promises.readdir((0,b.$oc)(v))).some(o=>o===k)}catch(k){return this.Q(k),!1}}setVerboseLogging(v){this.z=v}O(v){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}P(v){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}Q(v){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}R(v){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${v}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$mr=y;async function $(m,v,k,t,o=512){const i=await w.Promises.open(m,"r"),c=Buffer.allocUnsafe(o),s=new S.$xe(t);let u,d=!1;const P={path:m,excludes:[],recursive:!1},E=new y(P,void 0,O=>{(async()=>{for(const{type:T}of O)if(T===l.FileChangeType.UPDATED){if(d)return;d=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:L}=await w.Promises.read(i,c,0,o,null);if(!L||s.token.isCancellationRequested)break;v(c.slice(0,L))}}catch(L){u=new Error(L),s.dispose(!0)}finally{d=!1}}})()});return await E.ready,k(),new Promise((O,T)=>{s.token.onCancellationRequested(async()=>{E.dispose();try{await w.Promises.close(i)}catch(L){u=new Error(L)}u?T(u):O()})})}}),define(oe[219],ae([0,1,3,113,217,4,218,31]),function(x,e,n,r,S,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class b extends S.$hr{constructor(h){super(),this.O=h,this.onDidError=n.Event.None,this.watchers=new Set}async N(h){h=this.Z(h);const f=[],g=new Set(Array.from(this.watchers));for(const w of h){const l=this.W(w);l&&(0,r.$Dk)(l.request.excludes,w.excludes)&&(0,r.$Dk)(l.request.includes,w.includes)?g.delete(l):f.push(w)}f.length&&this.P(`Request to start watching: ${f.map(w=>this.M(w)).join(",")}`),g.size&&this.P(`Request to stop watching: ${Array.from(g).map(w=>this.M(w.request)).join(",")}`);for(const w of g)this.Y(w);for(const w of f)this.X(w)}W(h){for(const f of this.watchers)if(typeof h.correlationId=="number"||typeof f.request.correlationId=="number"){if(f.request.correlationId===h.correlationId)return f}else if((0,I.$Dg)(f.request.path,h.path,!D.$k))return f}X(h){const f=new A.$mr(h,this.O,w=>this.a.fire(w),()=>this.c.fire(h),w=>this.b.fire(w),this.R),g={request:h,instance:f};this.watchers.add(g)}async stop(){await super.stop();for(const h of this.watchers)this.Y(h)}Y(h){this.P("stopping file watcher",h),this.watchers.delete(h),h.instance.dispose()}Z(h){const f=new Map;for(const g of h){const w=D.$k?g.path:g.path.toLowerCase();let l=f.get(g.correlationId);l||(l=new Map,f.set(g.correlationId,l)),l.has(w)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(g)}`),l.set(w,g)}return Array.from(f.values()).map(g=>Array.from(g.values())).flat()}async setVerboseLogging(h){super.setVerboseLogging(h);for(const f of this.watchers)f.instance.setVerboseLogging(h)}P(h,f){this.R&&this.b.fire({type:"trace",message:this.bb(h,f)})}Q(h){this.b.fire({type:"warn",message:this.bb(h)})}bb(h,f){return f?`[File Watcher (node.js)] ${h} (${this.M(f.request)})`:`[File Watcher (node.js)] ${h}`}}e.$or=b}),define(oe[220],ae([0,1,62,219]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class S extends n.$4q{constructor(A,I,b){super(A,I,b),this.s()}r(A){return A.add(new r.$or(void 0))}}e.$pr=S}),define(oe[221],ae([0,1,13,44,165,62]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class A extends D.$5q{constructor(b,a,h){super(b,a,h),this.s()}r(b){const a=b.add(new S.$fr(n.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(a.onDidProcessExit(({code:h,signal:f})=>this.t(`terminated by itself with code ${h}, signal: ${f} (ETERM)`))),r.ProxyChannel.toService((0,r.$mi)(a.getChannel("watcher")))}}e.$gr=A}),define(oe[99],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class n{constructor(...S){this.a=new Map;for(const[D,A]of S)this.set(D,A)}set(S,D){const A=this.a.get(S);return this.a.set(S,D),A}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$Di=n}),define(oe[222],ae([0,1,8,16,2,82,211,6,99,109]),function(x,e,n,r,S,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const h=!1;class f extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class g{constructor(y=new b.$Di,$=!1,m,v=h){this.i=y,this.j=$,this.k=m,this.l=v,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Ei,this),this._globalGraph=v?m?._globalGraph??new A.$sr(k=>k):void 0}dispose(){if(!this.f){this.f=!0,(0,S.$Rc)(this.h),this.h.clear();for(const y of this.g)(0,S.$Qc)(y)&&y.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(y,$){this.m();const m=this,v=new class extends g{dispose(){m.h.delete(v),super.dispose()}}(y,this.j,this,this.l);return this.h.add(v),$?.add(v),v}invokeFunction(y,...$){this.m();const m=l.traceInvocation(this.l,y);let v=!1;try{return y({get:t=>{if(v)throw(0,r.$0)("service accessor is only valid during the invocation of its target method");const o=this.s(t,m);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...$)}finally{v=!0,m.stop()}}createInstance(y,...$){this.m();let m,v;return y instanceof D.$Ci?(m=l.traceCreation(this.l,y.ctor),v=this.o(y.ctor,y.staticArguments.concat($),m)):(m=l.traceCreation(this.l,y),v=this.o(y,$,m)),m.stop(),v}o(y,$=[],m){const v=I._util.getServiceDependencies(y).sort((o,i)=>o.index-i.index),k=[];for(const o of v){const i=this.s(o.id,m);i||this.y(`[createInstance] ${y.name} depends on UNKNOWN service ${o.id}.`,!1),k.push(i)}const t=v.length>0?v[0].index:$.length;if($.length!==t){console.trace(`[createInstance] First service dependency of ${y.name} at position ${t+1} conflicts with ${$.length} static arguments`);const o=t-$.length;o>0?$=$.concat(new Array(o)):$=$.slice(0,t)}return Reflect.construct(y,$.concat(k))}q(y,$){if(this.i.get(y)instanceof D.$Ci)this.i.set(y,$);else if(this.k)this.k.q(y,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(y){const $=this.i.get(y);return!$&&this.k?this.k.r(y):$}s(y,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(y));const m=this.r(y);return m instanceof D.$Ci?this.u(y,m,$.branch(y,!0)):($.branch(y,!1),m)}u(y,$,m){if(this.t.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this.t.add(y);try{return this.v(y,$,m)}finally{this.t.delete(y)}}v(y,$,m){const v=new A.$sr(o=>o.id.toString());let k=0;const t=[{id:y,desc:$,_trace:m}];for(;t.length;){const o=t.pop();if(v.lookupOrInsertNode(o),k++>1e3)throw new f(v);for(const i of I._util.getServiceDependencies(o.desc.ctor)){const c=this.r(i.id);if(c||this.y(`[createInstance] ${y} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(o.id),String(i.id)),c instanceof D.$Ci){const s={id:i.id,desc:c,_trace:o._trace.branch(i.id,!0)};v.insertEdge(o,s),t.push(s)}}}for(;;){const o=v.roots();if(o.length===0){if(!v.isEmpty())throw new f(v);break}for(const{data:i}of o){if(this.r(i.id)instanceof D.$Ci){const s=this.w(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.q(i.id,s)}v.removeNode(i)}}return this.r(y)}w(y,$,m=[],v,k){if(this.i.get(y)instanceof D.$Ci)return this.x(y,$,m,v,k,this.g);if(this.k)return this.k.w(y,$,m,v,k);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(y,$,m=[],v,k,t){if(v){const o=new g(void 0,this.j,this,this.l);o.c=String(y);const i=new Map,c=new n.$Yh(()=>{const s=o.o($,m,k);for(const[u,d]of i){const P=s[u];if(typeof P=="function")for(const E of d)E.disposable=P.apply(s,E.listener)}return i.clear(),t.add(s),s});return new Proxy(Object.create(null),{get(s,u){if(!c.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let E=i.get(u);return E||(E=new a.$7c,i.set(u,E)),(T,L,R)=>{if(c.isInitialized)return c.value[u](T,L,R);{const M={listener:[T,L,R],disposable:void 0},B=E.push(M);return(0,S.$Uc)(()=>{B(),M.disposable?.dispose()})}}}if(u in s)return s[u];const d=c.value;let P=d[u];return typeof P!="function"||(P=P.bind(d),s[u]=P),P},set(s,u,d){return c.value[u]=d,!0},getPrototypeOf(s){return $.prototype}})}else{const o=this.o($,m,k);return t.add(o),o}}y(y,$){if($&&console.warn(y),this.j)throw new Error(y)}}e.$tr=g;var w;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(w||(w={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(y,$){return y?new l(w.Invocation,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(y,$){return y?new l(w.Creation,$.name):l.c}static{this.f=0}constructor(y,$){this.type=y,this.name=$,this.g=Date.now(),this.h=[]}branch(y,$){const m=new l(w.Branch,y.toString());return this.h.push([y,$,m]),m}stop(){const y=Date.now()-this.g;l.f+=y;let $=!1;function m(k,t){const o=[],i=new Array(k+1).join("	");for(const[c,s,u]of t.h)if(s&&u){$=!0,o.push(`${i}CREATES -> ${c}`);const d=m(k+1,u);d&&o.push(d)}else o.push(`${i}uses -> ${c}`);return o.join(`
`)}const v=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(y>2||$)&&l.all.add(v.join(`
`))}}e.$ur=l}),define(oe[223],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=e.IssueSource=e.IssueType=void 0;var r;(function(D){D[D.Bug=0]="Bug",D[D.PerformanceIssue=1]="PerformanceIssue",D[D.FeatureRequest=2]="FeatureRequest"})(r||(e.IssueType=r={}));var S;(function(D){D.VSCode="vscode",D.Extension="extension",D.Marketplace="marketplace"})(S||(e.IssueSource=S={})),e.$2$b=(0,n.$Fi)("issueService")}),define(oe[5],ae([0,1,186,53,3,46,2,32,4,19,12,7,123,6]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=p,e.log=$,e.$nk=P,e.$ok=E,e.$pk=O,e.$qk=T,n=Re(n),e.$_j=(0,w.$Fi)("logService"),e.$ak=(0,w.$Fi)("loggerService");function l(){return new Date().toISOString()}function p(L){return(0,h.$jg)(L)}var y;(function(L){L[L.Off=0]="Off",L[L.Trace=1]="Trace",L[L.Debug=2]="Debug",L[L.Info=3]="Info",L[L.Warning=4]="Warning",L[L.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$ck=y.Info;function $(L,R,M){switch(R){case y.Trace:L.trace(M);break;case y.Debug:L.debug(M);break;case y.Info:L.info(M);break;case y.Warning:L.warn(M);break;case y.Error:L.error(M);break;case y.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function m(L,R=!1){let M="";for(let B=0;B<L.length;B++){let C=L[B];if(C instanceof Error&&(C=(0,r.$qj)(C,R)),typeof C=="object")try{C=JSON.stringify(C)}catch{}M+=(B>0?" ":"")+C}return M}class v extends A.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new S.$me),this.onDidChangeLogLevel=this.c.event}setLevel(R){this.b!==R&&(this.b=R,this.c.fire(this.b))}getLevel(){return this.b}f(R){return this.b!==y.Off&&this.b<=R}}e.$ek=v;class k extends v{constructor(R){super(),this.h=R}f(R){return this.h||super.f(R)}trace(R,...M){this.f(y.Trace)&&this.g(y.Trace,m([R,...M],!0))}debug(R,...M){this.f(y.Debug)&&this.g(y.Debug,m([R,...M]))}info(R,...M){this.f(y.Info)&&this.g(y.Info,m([R,...M]))}warn(R,...M){this.f(y.Warning)&&this.g(y.Warning,m([R,...M]))}error(R,...M){if(this.f(y.Error))if(R instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=R.stack,this.g(y.Error,m(B))}else this.g(y.Error,m([R,...M]))}flush(){}}e.$fk=k;class t extends v{constructor(R=e.$ck){super(),this.setLevel(R),this.g=!b.$i}trace(R,...M){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,R,...M):console.log(`[main ${l()}]`,R,...M))}debug(R,...M){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,R,...M):console.log(`[main ${l()}]`,R,...M))}info(R,...M){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,R,...M):console.log(`[main ${l()}]`,R,...M))}warn(R,...M){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,R,...M):console.warn(`[main ${l()}]`,R,...M))}error(R,...M){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,R,...M):console.error(`[main ${l()}]`,R,...M))}flush(){}}e.$gk=t;class o extends v{constructor(R=e.$ck,M=!0){super(),this.g=M,this.setLevel(R)}trace(R,...M){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",R,...M):console.log(R,...M))}debug(R,...M){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",R,...M):console.log(R,...M))}info(R,...M){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",R,...M):console.log(R,...M))}warn(R,...M){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",R,...M):console.log(R,...M))}error(R,...M){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",R,...M):console.error(R,...M))}flush(){}}e.$hk=o;class i extends v{constructor(R,M=e.$ck){super(),this.g=R,this.setLevel(M)}trace(R,...M){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(R),...M])}debug(R,...M){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(R),...M])}info(R,...M){this.f(y.Info)&&this.g.log(y.Info,[this.h(R),...M])}warn(R,...M){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(R),...M])}error(R,...M){this.f(y.Error)&&this.g.log(y.Error,[this.h(R),...M])}h(R){return typeof R=="string"?R:(0,r.$qj)(R,this.f(y.Trace))}flush(){}}e.$ik=i;class c extends v{constructor(R){super(),this.g=R,R.length&&this.setLevel(R[0].getLevel())}setLevel(R){for(const M of this.g)M.setLevel(R);super.setLevel(R)}trace(R,...M){for(const B of this.g)B.trace(R,...M)}debug(R,...M){for(const B of this.g)B.debug(R,...M)}info(R,...M){for(const B of this.g)B.info(R,...M)}warn(R,...M){for(const B of this.g)B.warn(R,...M)}error(R,...M){for(const B of this.g)B.error(R,...M)}flush(){for(const R of this.g)R.flush()}dispose(){for(const R of this.g)R.dispose();super.dispose()}}e.$jk=c;class s extends A.$Wc{constructor(R,M,B){if(super(),this.h=R,this.j=M,this.b=new I.$Cc,this.c=this.B(new S.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new S.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new S.$me),this.onDidChangeVisibility=this.g.event,B)for(const C of B)this.b.set(C.resource,{logger:void 0,info:C})}m(R){return(0,h.$fg)(R)?[...this.b.values()].find(M=>M.info.id===R):this.b.get(R)}getLogger(R){return this.m(R)?.logger}createLogger(R,M){const B=this.n(R),C=(0,h.$fg)(R)?R:M?.id??(0,D.$tj)(B.toString()).toString(16);let z=this.b.get(B)?.logger;const ne=M?.logLevel==="always"?y.Trace:M?.logLevel;z||(z=this.s(B,ne??this.getLogLevel(B)??this.h,{...M,id:C}));const Q={logger:z,info:{resource:B,id:C,logLevel:ne,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(Q.info),this.b.set(B,Q),z}n(R){return(0,h.$fg)(R)?(0,a.$gh)(this.j,`${R}.log`):R}setLogLevel(R,M){if(f.URI.isUri(R)){const B=R,C=M,z=this.b.get(B);z&&C!==z.info.logLevel&&(z.info.logLevel=C===this.h?void 0:C,z.logger?.setLevel(C),this.b.set(z.info.resource,z),this.f.fire([B,C]))}else{this.h=R;for(const[B,C]of this.b.entries())this.b.get(B)?.info.logLevel===void 0&&C.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(R,M){const B=this.m(R);B&&M!==!B.info.hidden&&(B.info.hidden=!M,this.b.set(B.info.resource,B),this.g.fire([B.info.resource,M]))}getLogLevel(R){let M;return R&&(M=this.b.get(R)?.info.logLevel),M??this.h}registerLogger(R){const M=this.b.get(R.resource);M?M.info.hidden!==R.hidden&&this.setVisibility(R.resource,!R.hidden):(this.b.set(R.resource,{info:R,logger:void 0}),this.c.fire({added:[R],removed:[]}))}deregisterLogger(R){const M=this.b.get(R);M&&(M.logger&&M.logger.dispose(),this.b.delete(R),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const R of this.b.values())yield R.info}getRegisteredLogger(R){return this.b.get(R)?.info}dispose(){this.b.forEach(R=>R.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=s;class u{constructor(){this.onDidChangeLogLevel=new S.$me().event}setLevel(R){}getLevel(){return y.Info}trace(R,...M){}debug(R,...M){}info(R,...M){}warn(R,...M){}error(R,...M){}critical(R,...M){}dispose(){}flush(){}}e.$lk=u;class d extends u{}e.$mk=d;function P(L){if(L.verbose)return y.Trace;if(typeof L.logLevel=="string"){const R=T(L.logLevel.toLowerCase());if(R!==void 0)return R}return e.$ck}function E(L){switch(L){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}function O(L){switch(L){case y.Trace:return{original:"Trace",value:n.localize(0,null)};case y.Debug:return{original:"Debug",value:n.localize(1,null)};case y.Info:return{original:"Info",value:n.localize(2,null)};case y.Warning:return{original:"Warning",value:n.localize(3,null)};case y.Error:return{original:"Error",value:n.localize(4,null)};case y.Off:return{original:"Off",value:n.localize(5,null)}}}function T(L){switch(L){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$rk=new g.$Wj("logLevel",E(y.Info))});var re=this&&this.__param||function(x,e){return function(n,r){e(n,r,x)}};define(oe[224],ae([0,1,14,4,98,5]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;const A=n.safeStorage;let I=class{constructor(a){this.a=a,n.app.commandLine.getSwitchValue("password-store")===S.PasswordStoreCLIOption.basic&&A.setUsePlainTextEncryption?.(!0)}async encrypt(a){this.a.trace("[EncryptionMainService] Encrypting value.");try{const h=JSON.stringify(A.encryptString(a));return this.a.trace("[EncryptionMainService] Encrypted value."),h}catch(h){throw this.a.error(h),h}}async decrypt(a){let h;try{if(h=JSON.parse(a),!h.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${a}`);const f=Buffer.from(h.data);this.a.trace("[EncryptionMainService] Decrypting value.");const g=A.decryptString(f);return this.a.trace("[EncryptionMainService] Decrypted value."),g}catch(f){throw this.a.error(f),f}}isEncryptionAvailable(){return Promise.resolve(A.isEncryptionAvailable())}getKeyStorageProvider(){if(r.$i)return Promise.resolve(S.KnownStorageProvider.dplib);if(r.$j)return Promise.resolve(S.KnownStorageProvider.keychainAccess);if(A.getSelectedStorageBackend)try{const a=A.getSelectedStorageBackend();return Promise.resolve(a)}catch(a){this.a.error(a)}return Promise.resolve(S.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(r.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(r.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!A.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");A.setUsePlainTextEncryption(!0)}};e.$cfc=I,e.$cfc=I=Se([re(0,D.$_j)],I)}),define(oe[225],ae([0,1,22,8,16,3,31,2,9,62,5]),function(x,e,n,r,S,D,A,I,b,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class f extends I.$Wc{constructor(w,l){super(),this.a=w,this.b=l,this.c=this.B(new D.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Dh(0)),this.w=[],this.y=this.B(new r.$Dh(0))}watch(w,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(w,l):this.z(w,l)}n(w,l){const p={path:this.J(w),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},y=(0,n.$Vb)(this.j,p);return this.r(),(0,I.$Uc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,S.$3)(w))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,a.$6q)(l)),l=>this.G(l),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const l of this.j)(0,a.$2q)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const l of this.j)(0,a.$2q)(l)&&w.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,l){const p={path:this.J(w),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},y=(0,n.$Vb)(this.w,p);return this.C(),(0,I.$Uc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,S.$3)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,a.$6q)(w)),w=>this.G(w),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,b.$jc)(w.fsPath)}J(w){const l=this.I(w);return(0,A.$Hg)(l)}}e.$_q=f}),define(oe[226],ae([0,1,22,8,17,23,3,46,76,2,61,13,70,19,67,180,15,125,5,16]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m,v){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;let t=class extends a.$Wc{static{k=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new A.$me),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$me),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$me),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$me),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$me),this.Y=this.B(new A.$me),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$me),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Oh)}registerProvider(i,c){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${i}`);const s=new a.$Vc;return this.h.set(i,c),this.c.fire({added:!0,scheme:i,provider:c}),s.add(c.onDidChangeFile(u=>{const d=new y.$sl(u,!this.S(c));this.X.fire(d),d.hasCorrelation()||this.Y.fire(d)})),typeof c.onDidWatchError=="function"&&s.add(c.onDidWatchError(u=>this.Z.fire(new Error(u)))),s.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:i}))),(0,a.$Uc)(()=>{this.c.fire({added:!1,scheme:i,provider:c}),this.h.delete(i),(0,a.$Rc)(s)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const c=[];this.f.fire({scheme:i,join(s){c.push(s)}}),!this.h.has(i)&&await r.Promises.settled(c)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,c){const s=this.h.get(i.scheme);return!!(s&&s.capabilities&c)}listCapabilities(){return b.Iterable.map(this.h,([i,c])=>({scheme:i,capabilities:c.capabilities}))}async j(i){if(!(0,w.$kh)(i))throw new y.$ul((0,p.localize)(0,null,this.sb(i)),y.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const c=this.h.get(i.scheme);if(!c){const s=new v.$db;throw s.message=(0,p.localize)(1,null,i.toString()),s}return c}async m(i){const c=await this.j(i);if((0,y.$fl)(c)||(0,y.$cl)(c)||(0,y.$gl)(c))return c;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const c=await this.j(i);if((0,y.$fl)(c)||(0,y.$cl)(c))return c;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,c){try{return await this.s(i,c)}catch(s){throw(0,y.$pl)(s)===y.FileSystemProviderErrorCode.FileNotFound?new y.$ul((0,p.localize)(2,null,this.sb(i)),y.FileOperationResult.FILE_NOT_FOUND):(0,y.$nl)(s)}}async s(i,c){const s=await this.j(i),u=this.S(s),d=c?.resolveTo,P=c?.resolveSingleChildDescendants,E=c?.resolveMetadata,O=await s.stat(i);let T;return this.t(s,i,O,void 0,!!E,(L,R)=>(T||(T=h.$Li.forUris(()=>!u),T.set(i,!0),d&&T.fill(!0,d)),T.get(L.resource)||T.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&P?R===1:!1))}async t(i,c,s,u,d,P){const{providerExtUri:E}=this.R(i),O={resource:c,name:E.basename(c),isFile:(s.type&y.FileType.File)!==0,isDirectory:(s.type&y.FileType.Directory)!==0,isSymbolicLink:(s.type&y.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&y.FilePermission.Readonly)||!!(i.capabilities&y.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&y.FilePermission.Locked),etag:(0,y.$Fl)({mtime:s.mtime,size:s.size}),children:void 0};if(O.isDirectory&&P(O,u)){try{const T=await i.readdir(c),L=await r.Promises.settled(T.map(async([R,M])=>{try{const B=E.joinPath(c,R),C=d?await i.stat(B):{type:M};return await this.t(i,B,C,T.length,d,P)}catch(B){return this.b.trace(B),null}}));O.children=(0,n.$Jb)(L)}catch(T){this.b.trace(T),O.children=[]}return O}return O}async resolveAll(i){return r.Promises.settled(i.map(async c=>{try{return{stat:await this.s(c.resource,c.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(i){const c=await this.j(i),s=await c.stat(i);return this.t(c,i,s,void 0,!0,()=>!1)}async exists(i){const c=await this.j(i);try{return!!await c.stat(i)}catch{return!1}}async canCreateFile(i,c){try{await this.u(i,c)}catch(s){return s}return!0}async u(i,c){if(!c?.overwrite&&await this.exists(i))throw new y.$ul((0,p.localize)(3,null,this.sb(i)),y.FileOperationResult.FILE_MODIFIED_SINCE,c)}async createFile(i,c=S.$Oe.fromString(""),s){await this.u(i,s);const u=await this.writeFile(i,c);return this.r.fire(new y.$rl(i,y.FileOperation.CREATE,u)),u}async writeFile(i,c,s){const u=this.qb(await this.n(i),i),{providerExtUri:d}=this.R(u);let P=s;if((0,y.$il)(u)&&!P?.atomic){const E=u.enforceAtomicWriteFile?.(i);E&&(P={...s,atomic:E})}try{await this.w(u,i,P)||await this.U(u,d.dirname(i));let O;if((0,y.$cl)(u)&&!(c instanceof S.$Oe))if((0,l.$Ae)(c)){const T=await(0,l.$He)(c,3);T.ended?O=S.$Oe.concat(T.buffer):O=T}else O=(0,l.$Ee)(c,T=>S.$Oe.concat(T),3);else O=c;!(0,y.$fl)(u)||(0,y.$cl)(u)&&O instanceof S.$Oe||(0,y.$cl)(u)&&(0,y.$il)(u)&&P?.atomic?await this.hb(u,i,P,O):await this.db(u,i,P,O instanceof S.$Oe?(0,S.$Ze)(O):O),this.r.fire(new y.$rl(i,y.FileOperation.WRITE))}catch(E){throw new y.$ul((0,p.localize)(4,null,this.sb(i),(0,y.$nl)(E).toString()),(0,y.$ql)(E),P)}return this.resolve(i,{resolveMetadata:!0})}async w(i,c,s){const u=!!s?.unlock;if(u&&!(i.capabilities&y.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,p.localize)(5,null,this.sb(c)));if(!!s?.atomic){if(!(i.capabilities&y.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,p.localize)(6,null,this.sb(c)));if(!(i.capabilities&y.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,p.localize)(7,null,this.sb(c)));if(u)throw new Error((0,p.localize)(8,null,this.sb(c)))}let P;try{P=await i.stat(c)}catch{return}if(P.type&y.FileType.Directory)throw new y.$ul((0,p.localize)(9,null,this.sb(c)),y.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(c,P),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==y.$El&&typeof P.mtime=="number"&&typeof P.size=="number"&&s.mtime<P.mtime&&s.etag!==(0,y.$Fl)({mtime:s.mtime,size:P.size}))throw new y.$ul((0,p.localize)(10,null),y.FileOperationResult.FILE_MODIFIED_SINCE,s);return P}async readFile(i,c,s){const u=await this.m(i);return c?.atomic?this.z(u,i,c,s):this.C(u,i,c,s)}async z(i,c,s,u){return new Promise((d,P)=>{this.cb.queueFor(c,async()=>{try{const E=await this.C(i,c,s,u);d(E)}catch(E){P(E)}},this.R(i).providerExtUri)})}async C(i,c,s,u){const d=await this.D(i,c,{...s,preferUnbuffered:!0},u);return{...d,value:await(0,S.$1e)(d.value)}}async readFileStream(i,c,s){const u=await this.m(i);return this.D(u,i,c,s)}async D(i,c,s,u){const d=new D.$xe(u);let P=s;(0,y.$hl)(i)&&i.enforceAtomicReadFile?.(c)&&(P={...s,atomic:!0});const E=this.J(c,P).then(T=>T,T=>{throw d.dispose(!0),T});let O;try{return typeof P?.etag=="string"&&P.etag!==y.$El&&await E,P?.atomic&&(0,y.$hl)(i)||!((0,y.$fl)(i)||(0,y.$gl)(i))||(0,y.$cl)(i)&&P?.preferUnbuffered?O=this.I(i,c,P):(0,y.$gl)(i)?O=this.G(i,c,d.token,P):O=this.H(i,c,d.token,P),O.on("end",()=>d.dispose()),O.on("error",()=>d.dispose()),{...await E,value:O}}catch(T){throw O&&await(0,l.$Fe)(O),this.F(T,c,P)}}F(i,c,s){const u=(0,p.localize)(11,null,this.sb(c),(0,y.$nl)(i).toString());return i instanceof y.$wl?new y.$wl(u,i.stat,s):i instanceof y.$vl?new y.$vl(u,i.fileOperationResult,i.size,i.options):new y.$ul(u,(0,y.$ql)(i),s)}G(i,c,s,u=Object.create(null)){const d=i.readFileStream(c,u,s);return(0,l.$Le)(d,{data:P=>P instanceof S.$Oe?P:S.$Oe.wrap(P),error:P=>this.F(P,c,u)},P=>S.$Oe.concat(P))}H(i,c,s,u=Object.create(null)){const d=(0,S.$5e)();return(0,$.$Yq)(i,c,d,P=>P,{...u,bufferSize:this.a,errorTransformer:P=>this.F(P,c,u)},s),d}I(i,c,s){const u=(0,l.$Ce)(d=>S.$Oe.concat(d));return(async()=>{try{let d;s?.atomic&&(0,y.$hl)(i)?d=await i.readFile(c,{atomic:!0}):d=await i.readFile(c),typeof s?.position=="number"&&(d=d.slice(s.position)),typeof s?.length=="number"&&(d=d.slice(0,s.length)),this.L(c,d.byteLength,s),u.end(S.$Oe.wrap(d))}catch(d){u.error(d),u.end()}})(),u}async J(i,c){const s=await this.resolve(i,{resolveMetadata:!0});if(s.isDirectory)throw new y.$ul((0,p.localize)(12,null,this.sb(i)),y.FileOperationResult.FILE_IS_DIRECTORY,c);if(typeof c?.etag=="string"&&c.etag!==y.$El&&c.etag===s.etag)throw new y.$wl((0,p.localize)(13,null),s,c);return this.L(i,s.size,c),s}L(i,c,s){if(typeof s?.limits?.size=="number"&&c>s.limits.size)throw new y.$vl((0,p.localize)(14,null,this.sb(i)),y.FileOperationResult.FILE_TOO_LARGE,c,s)}async canMove(i,c,s){return this.M(i,c,"move",s)}async canCopy(i,c,s){return this.M(i,c,"copy",s)}async M(i,c,s,u){if(i.toString()!==c.toString())try{const d=s==="move"?this.qb(await this.n(i),i):await this.m(i),P=this.qb(await this.n(c),c);await this.Q(d,i,P,c,s,u)}catch(d){return d}return!0}async move(i,c,s){const u=this.qb(await this.n(i),i),d=this.qb(await this.n(c),c),P=await this.N(u,i,d,c,"move",!!s),E=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new y.$rl(i,P==="move"?y.FileOperation.MOVE:y.FileOperation.COPY,E)),E}async copy(i,c,s){const u=await this.m(i),d=this.qb(await this.n(c),c),P=await this.N(u,i,d,c,"copy",!!s),E=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new y.$rl(i,P==="copy"?y.FileOperation.COPY:y.FileOperation.MOVE,E)),E}async N(i,c,s,u,d,P){if(c.toString()===u.toString())return d;const{exists:E,isSameResourceWithDifferentPathCase:O}=await this.Q(i,c,s,u,d,P);if(E&&!O&&P&&await this.del(u,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(u)),d==="copy"){if(i===s&&(0,y.$dl)(i))await i.copy(c,u,{overwrite:P});else{const T=await this.resolve(c);T.isDirectory?await this.P(i,T,s,u):await this.O(i,c,s,u)}return d}else return i===s?(await i.rename(c,u,{overwrite:P}),d):(await this.N(i,c,s,u,"copy",P),await this.del(c,{recursive:!0}),"copy")}async O(i,c,s,u){if((0,y.$fl)(i)&&(0,y.$fl)(s))return this.jb(i,c,s,u);if((0,y.$fl)(i)&&(0,y.$cl)(s))return this.pb(i,c,s,u);if((0,y.$cl)(i)&&(0,y.$fl)(s))return this.nb(i,c,s,u);if((0,y.$cl)(i)&&(0,y.$cl)(s))return this.lb(i,c,s,u)}async P(i,c,s,u){await s.mkdir(u),Array.isArray(c.children)&&await r.Promises.settled(c.children.map(async d=>{const P=this.R(s).providerExtUri.joinPath(u,d.name);return d.isDirectory?this.P(i,await this.resolve(d.resource),s,P):this.O(i,d.resource,s,P)}))}async Q(i,c,s,u,d,P){let E=!1;if(i===s){const{providerExtUri:T,isPathCaseSensitive:L}=this.R(i);if(L||(E=T.isEqual(c,u)),E&&d==="copy")throw new Error((0,p.localize)(15,null,this.sb(c),this.sb(u)));if(!E&&T.isEqualOrParent(u,c))throw new Error((0,p.localize)(16,null,this.sb(c),this.sb(u)))}const O=await this.exists(u);if(O&&!E){if(!P)throw new y.$ul((0,p.localize)(17,null,this.sb(c),this.sb(u)),y.FileOperationResult.FILE_MOVE_CONFLICT);if(i===s){const{providerExtUri:T}=this.R(i);if(T.isEqualOrParent(c,u))throw new Error((0,p.localize)(18,null,this.sb(c),this.sb(u)))}}return{exists:O,isSameResourceWithDifferentPathCase:E}}R(i){const c=this.S(i);return{providerExtUri:c?w.$9g:w.$$g,isPathCaseSensitive:c}}S(i){return!!(i.capabilities&y.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const c=this.qb(await this.j(i),i);await this.U(c,i);const s=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new y.$rl(i,y.FileOperation.CREATE,s)),s}async U(i,c){const s=[],{providerExtUri:u}=this.R(i);for(;!u.isEqual(c,u.dirname(c));)try{if(!((await i.stat(c)).type&y.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(c)));break}catch(d){if((0,y.$pl)(d)!==y.FileSystemProviderErrorCode.FileNotFound)throw d;s.push(u.basename(c)),c=u.dirname(c)}for(let d=s.length-1;d>=0;d--){c=u.joinPath(c,s[d]);try{await i.mkdir(c)}catch(P){if((0,y.$pl)(P)!==y.FileSystemProviderErrorCode.FileExists)throw P}}}async canDelete(i,c){try{await this.W(i,c)}catch(s){return s}return!0}async W(i,c){const s=this.qb(await this.j(i),i),u=!!c?.useTrash;if(u&&!(s.capabilities&y.FileSystemProviderCapabilities.Trash))throw new Error((0,p.localize)(20,null,this.sb(i)));const d=c?.atomic;if(d&&!(s.capabilities&y.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,p.localize)(21,null,this.sb(i)));if(u&&d)throw new Error((0,p.localize)(22,null,this.sb(i)));let P;try{P=await s.stat(i)}catch{}if(P)this.rb(i,P);else throw new y.$ul((0,p.localize)(23,null,this.sb(i)),y.FileOperationResult.FILE_NOT_FOUND);if(!!!c?.recursive){const O=await this.resolve(i);if(O.isDirectory&&Array.isArray(O.children)&&O.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(i)))}return s}async del(i,c){const s=await this.W(i,c);let u=c;if((0,y.$jl)(s)&&!u?.atomic){const O=s.enforceAtomicDelete?.(i);O&&(u={...c,atomic:O})}const d=!!u?.useTrash,P=!!u?.recursive,E=u?.atomic??!1;await s.delete(i,{recursive:P,useTrash:d,atomic:E}),this.r.fire(new y.$rl(i,y.FileOperation.DELETE))}async cloneFile(i,c){const s=await this.j(i),u=this.qb(await this.n(c),c);if(!(s===u&&this.R(s).providerExtUri.isEqual(i,c)))return s===u&&(0,y.$el)(s)?s.cloneFile(i,c):(await this.U(u,this.R(u).providerExtUri.dirname(c)),s===u&&(0,y.$dl)(s)?this.cb.queueFor(i,()=>s.copy(i,c,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(i,()=>this.O(s,i,u,c),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(i,c){return this.watch(i,{...c,correlationId:k.ab++})}watch(i,c={recursive:!1,excludes:[]}){const s=new a.$Vc;let u=!1,d=()=>{u=!0};s.add((0,a.$Uc)(()=>d())),(async()=>{try{const E=await this.bb(i,c);u?(0,a.$Rc)(E):d=()=>(0,a.$Rc)(E)}catch(E){this.b.error(E)}})();const P=c.correlationId;if(typeof P=="number"){const E=s.add(new A.$me);return s.add(this.X.event(T=>{T.correlates(P)&&E.fire(T)})),{onDidChange:E.event,dispose:()=>s.dispose()}}return s}async bb(i,c){const s=await this.j(i),u=(0,I.$tj)([this.R(s).providerExtUri.getComparisonKey(i),c]);let d=this.$.get(u);return d||(d={count:0,disposable:s.watch(i,c)},this.$.set(u,d)),d.count+=1,(0,a.$Uc)(()=>{d&&(d.count--,d.count===0&&((0,a.$Rc)(d.disposable),this.$.delete(u)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,a.$Rc)(i.disposable);this.$.clear()}async db(i,c,s,u){return this.cb.queueFor(c,async()=>{const d=await i.open(c,{create:!0,unlock:s?.unlock??!1});try{(0,l.$Ae)(u)||(0,l.$Be)(u)?await this.eb(i,d,u):await this.fb(i,d,u)}catch(P){throw(0,y.$nl)(P)}finally{await i.close(d)}},this.R(i).providerExtUri)}async eb(i,c,s){let u=0,d;if((0,l.$Be)(s)){if(s.buffer.length>0){const P=S.$Oe.concat(s.buffer);await this.gb(i,c,P,P.byteLength,u,0),u+=P.byteLength}if(s.ended)return;d=s.stream}else d=s;return new Promise((P,E)=>{(0,l.$Ge)(d,{onData:async O=>{d.pause();try{await this.gb(i,c,O,O.byteLength,u,0)}catch(T){return E(T)}u+=O.byteLength,setTimeout(()=>d.resume())},onError:O=>E(O),onEnd:()=>P()})})}async fb(i,c,s){let u=0,d;for(;(d=s.read())!==null;)await this.gb(i,c,d,d.byteLength,u,0),u+=d.byteLength}async gb(i,c,s,u,d,P){let E=0;for(;E<u;){const O=await i.write(c,d+E,s.buffer,P+E,u-E);E+=O}}async hb(i,c,s,u){return this.cb.queueFor(c,()=>this.ib(i,c,s,u),this.R(i).providerExtUri)}async ib(i,c,s,u){let d;u instanceof S.$Oe?d=u:(0,l.$Ae)(u)?d=await(0,S.$1e)(u):(0,l.$Be)(u)?d=await(0,S.$2e)(u):d=(0,S.$Ye)(u),await i.writeFile(c,d.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(i,c,s,u){return this.cb.queueFor(u,()=>this.kb(i,c,s,u),this.R(s).providerExtUri)}async kb(i,c,s,u){let d,P;try{d=await i.open(c,{create:!1}),P=await s.open(u,{create:!0,unlock:!1});const E=S.$Oe.alloc(this.a);let O=0,T=0,L=0;do L=await i.read(d,O,E.buffer,T,E.byteLength-T),await this.gb(s,P,E,L,O,T),O+=L,T+=L,T===E.byteLength&&(T=0);while(L>0)}catch(E){throw(0,y.$nl)(E)}finally{await r.Promises.settled([typeof d=="number"?i.close(d):Promise.resolve(),typeof P=="number"?s.close(P):Promise.resolve()])}}async lb(i,c,s,u){return this.cb.queueFor(u,()=>this.mb(i,c,s,u),this.R(s).providerExtUri)}async mb(i,c,s,u){return s.writeFile(u,await i.readFile(c),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,c,s,u){return this.cb.queueFor(u,()=>this.ob(i,c,s,u),this.R(s).providerExtUri)}async ob(i,c,s,u){const d=await s.open(u,{create:!0,unlock:!1});try{const P=await i.readFile(c);await this.gb(s,d,S.$Oe.wrap(P),P.byteLength,0,0)}catch(P){throw(0,y.$nl)(P)}finally{await s.close(d)}}async pb(i,c,s,u){const d=await(0,S.$1e)(this.H(i,c,D.CancellationToken.None));await this.hb(s,u,void 0,d)}qb(i,c){if(i.capabilities&y.FileSystemProviderCapabilities.Readonly)throw new y.$ul((0,p.localize)(25,null,this.sb(c)),y.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,c){if((c.permissions??0)&y.FilePermission.Readonly)throw new y.$ul((0,p.localize)(26,null,this.sb(i)),y.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===f.Schemas.file?i.fsPath:i.toString(!0)}};e.$Zq=t,e.$Zq=t=k=Se([re(0,m.$_j)],t)}),define(oe[100],ae([0,1,8,32,17,3,31,2,9,4,19,67,21,184,15,125,225,221,220]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class v extends y.$_q{static{this.L=!1}constructor(t,o){super(t,o),this.onDidChangeCapabilities=D.Event.None,this.P=new r.$Cc(i=>h.$0g.getComparisonKey(i)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=l.FileSystemProviderCapabilities.FileReadWrite|l.FileSystemProviderCapabilities.FileOpenReadWriteClose|l.FileSystemProviderCapabilities.FileReadStream|l.FileSystemProviderCapabilities.FileFolderCopy|l.FileSystemProviderCapabilities.FileWriteUnlock|l.FileSystemProviderCapabilities.FileAtomicRead|l.FileSystemProviderCapabilities.FileAtomicWrite|l.FileSystemProviderCapabilities.FileAtomicDelete|l.FileSystemProviderCapabilities.FileClone,a.$k&&(this.M|=l.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(t){try{const{stat:o,symbolicLink:i}=await g.SymlinkSupport.stat(this.I(t));return{type:this.O(o,i),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size,permissions:o.mode&128?void 0:l.FilePermission.Locked}}catch(o){throw this.hb(o)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const o=await g.Promises.readdir(this.I(t),{withFileTypes:!0}),i=[];return await Promise.all(o.map(async c=>{try{let s;c.isSymbolicLink()?s=(await this.stat((0,h.$gh)(t,c.name))).type:s=this.O(c),i.push([c.name,s])}catch(s){this.a.trace(s)}})),i}catch(o){throw this.hb(o)}}O(t,o){let i;return o?.dangling?i=l.FileType.Unknown:t.isFile()?i=l.FileType.File:t.isDirectory()?i=l.FileType.Directory:i=l.FileType.Unknown,o&&(i|=l.FileType.SymbolicLink),i}async Q(t){const o=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let i;for(;i=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await i.wait();const c=new n.$Eh;return this.P.set(t,c),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,I.$Uc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.P.get(t)===c&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),c.open()})}async readFile(t,o){let i;try{o?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),i=await this.Q(t));const c=this.I(t);return await g.Promises.readFile(c)}catch(c){throw this.hb(c)}finally{i?.dispose()}}R(t){v.L&&this.a.trace(t)}readFileStream(t,o,i){const c=(0,f.$Ce)(s=>S.$Oe.concat(s.map(u=>S.$Oe.wrap(u))).buffer);return(0,p.$Yq)(this,t,c,s=>s.buffer,{...o,bufferSize:256*1024},i),c}async writeFile(t,o,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.S(t)?this.U(t,(0,h.$gh)((0,h.$fh)(t),`${(0,h.$dh)(t)}${i.atomic.postfix}`),o,i):this.W(t,o,i)}async S(t){try{const o=this.I(t),{symbolicLink:i}=await g.SymlinkSupport.stat(o);if(i)return!1}catch{}return!0}async U(t,o,i,c){const s=new I.$Vc;try{s.add(await this.Q(t)),s.add(await this.Q(o)),await this.W(o,i,c,!0);try{await this.rename(o,t,{overwrite:!0})}catch(u){try{await this.delete(o,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw u}}finally{s.dispose()}}async W(t,o,i,c){let s;try{const u=this.I(t);if(!i.create||!i.overwrite){if(await g.Promises.exists(u)){if(!i.overwrite)throw(0,l.$ml)((0,w.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,l.$ml)((0,w.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(t,{create:!0,unlock:i.unlock},c),await this.write(s,0,o,0,o.byteLength)}catch(u){throw await this.ib(t,u)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(t){v.$=t}async open(t,o,i){const c=this.I(t);let s;(0,l.$al)(o)&&!i&&(s=await this.Q(t));let u;try{if((0,l.$al)(o)&&o.unlock)try{const{stat:P}=await g.SymlinkSupport.stat(c);P.mode&128||await g.Promises.chmod(c,P.mode|128)}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}let d;if((0,l.$al)(o)){if(a.$i)try{await g.Promises.truncate(c,0),d="r+"}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}d||(d="w")}else d="r";u=await g.Promises.open(c,d)}catch(d){throw s?.dispose(),(0,l.$al)(o)?await this.ib(t,d):this.hb(d)}if(this.X.set(u,0),(0,l.$al)(o)&&this.Z.set(u,t),s){const d=this.Y.get(u);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${c})`),this.Y.set(u,s),d&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${c})`),d.dispose())}return u}async close(t){const o=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&v.$)try{await g.Promises.fdatasync(t)}catch(i){v.configureFlushOnWrite(!1),this.a.error(i)}return await g.Promises.close(t)}catch(i){throw this.hb(i)}finally{o&&(this.Y.get(t)===o&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),o.dispose())}}async read(t,o,i,c,s){const u=this.ab(t,o);let d=null;try{d=(await g.Promises.read(t,i,c,s,u)).bytesRead}catch(P){throw this.hb(P)}finally{this.bb(t,u,d)}return d}ab(t,o){return o===this.X.get(t)?null:o}bb(t,o,i){const c=this.X.get(t);typeof c=="number"&&(typeof o=="number"||(typeof i=="number"?this.X.set(t,c+i):this.X.delete(t)))}async write(t,o,i,c,s){return(0,n.$Zh)(()=>this.cb(t,o,i,c,s),100,3)}async cb(t,o,i,c,s){const u=this.ab(t,o);let d=null;try{d=(await g.Promises.write(t,i,c,s,u)).bytesWritten}catch(P){throw await this.ib(this.Z.get(t),P)}finally{this.bb(t,u,d)}return d}async mkdir(t){try{await g.Promises.mkdir(this.I(t))}catch(o){throw this.hb(o)}}async delete(t,o){try{const i=this.I(t);if(o.recursive){let c;o?.atomic!==!1&&o.atomic.postfix&&(c=(0,b.$lc)((0,b.$oc)(i),`${(0,b.$pc)(i)}${o.atomic.postfix}`)),await g.Promises.rm(i,g.RimRafMode.MOVE,c)}else try{await g.Promises.unlink(i)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let s=!1;try{const{stat:u,symbolicLink:d}=await g.SymlinkSupport.stat(i);s=u.isDirectory()&&!d}catch{}if(s)await g.Promises.rmdir(i);else throw c}else throw c}}catch(i){throw this.hb(i)}}async rename(t,o,i){const c=this.I(t),s=this.I(o);if(c!==s)try{await this.db(t,o,"move",i.overwrite),await g.Promises.rename(c,s)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,w.localize)(2,null,(0,b.$pc)(c),(0,b.$pc)((0,b.$oc)(s)),u.toString()))),this.hb(u)}}async copy(t,o,i){const c=this.I(t),s=this.I(o);if(c!==s)try{await this.db(t,o,"copy",i.overwrite),await g.Promises.copy(c,s,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,w.localize)(3,null,(0,b.$pc)(c),(0,b.$pc)((0,b.$oc)(s)),u.toString()))),this.hb(u)}}async db(t,o,i,c){const s=this.I(t),u=this.I(o);let d=!1;if(!!(this.capabilities&l.FileSystemProviderCapabilities.PathCaseSensitive)||(d=(0,A.$Dg)(s,u,!0)),d){if(i==="copy")throw(0,l.$ml)((0,w.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const E=await this.N(t);if(!E)throw(0,l.$ml)((0,w.localize)(5,null),l.FileSystemProviderErrorCode.FileNotFound);const O=await this.N(o);if(O){if(!c)throw(0,l.$ml)((0,w.localize)(6,null),l.FileSystemProviderErrorCode.FileExists);E.type&l.FileType.File&&O.type&l.FileType.File||await this.delete(o,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,o){return this.eb(t,o,!1)}async eb(t,o,i){const c=this.I(t),s=this.I(o),u=!!(this.capabilities&l.FileSystemProviderCapabilities.PathCaseSensitive);if((0,A.$Dg)(c,s,!u))return;const d=new I.$Vc;try{d.add(await this.Q(t)),d.add(await this.Q(o)),i&&await g.Promises.mkdir((0,b.$oc)(s),{recursive:!0}),await g.Promises.copyFile(c,s)}catch(P){if(P.code==="ENOENT"&&!i)return this.eb(t,o,!0);throw this.hb(P)}finally{d.dispose()}}t(t,o,i){return new $.$gr(c=>t(c),c=>o(c),i)}F(t,o,i){return new m.$pr(c=>t(c),c=>o(c),i)}hb(t){if(t instanceof l.$ll)return t;let o=t,i;switch(t.code){case"ENOENT":i=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=l.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":o=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=l.FileSystemProviderErrorCode.Unknown;break;default:i=l.FileSystemProviderErrorCode.Unknown}return(0,l.$ml)(o,i)}async ib(t,o){let i=this.hb(o);if(t&&i.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await g.SymlinkSupport.stat(this.I(t));c.mode&128||(i=(0,l.$ml)(o,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return i}}e.$qr=v}),define(oe[227],ae([0,1,3,100,2,17,67,23]),function(x,e,n,r,S,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=void 0;class b extends S.$Wc{constructor(f,g){super(),this.a=f,this.b=g,this.F=new Map,this.G=new Map}call(f,g,w){const l=this.c(f);switch(g){case"stat":return this.g(l,w[0]);case"readdir":return this.h(l,w[0]);case"open":return this.r(l,w[0],w[1]);case"close":return this.s(w[0]);case"read":return this.t(w[0],w[1],w[2]);case"readFile":return this.j(l,w[0],w[1]);case"write":return this.u(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.n(l,w[0],w[1],w[2]);case"rename":return this.z(l,w[0],w[1],w[2]);case"copy":return this.C(l,w[0],w[1],w[2]);case"cloneFile":return this.D(l,w[0],w[1]);case"mkdir":return this.w(l,w[0]);case"delete":return this.y(l,w[0],w[1]);case"watch":return this.I(l,w[0],w[1],w[2],w[3]);case"unwatch":return this.J(w[0],w[1])}throw new Error(`IPC Command ${g} not found`)}listen(f,g,w){const l=this.c(f);switch(g){case"fileChange":return this.H(l,w[0]);case"readFileStream":return this.m(l,w[0],w[1])}throw new Error(`Unknown event ${g}`)}g(f,g){const w=this.f(f,g,!0);return this.a.stat(w)}h(f,g){const w=this.f(f,g);return this.a.readdir(w)}async j(f,g,w){const l=this.f(f,g,!0),p=await this.a.readFile(l,w);return D.$Oe.wrap(p)}m(f,g,w){const l=this.f(f,g,!0),p=new I.$xe,y=new n.$me({onDidRemoveLastListener:()=>{p.cancel()}}),$=this.a.readFileStream(l,w,p.token);return(0,A.$Ge)($,{onData:m=>y.fire(D.$Oe.wrap(m)),onError:m=>y.fire(m),onEnd:()=>{y.fire("end"),y.dispose(),p.dispose()}}),y.event}n(f,g,w,l){const p=this.f(f,g);return this.a.writeFile(p,w.buffer,l)}r(f,g,w){const l=this.f(f,g,!0);return this.a.open(l,w)}s(f){return this.a.close(f)}async t(f,g,w){const l=D.$Oe.alloc(w),y=await this.a.read(f,g,l.buffer,0,w);return[l,y]}u(f,g,w,l,p){return this.a.write(f,g,w.buffer,l,p)}w(f,g){const w=this.f(f,g);return this.a.mkdir(w)}y(f,g,w){const l=this.f(f,g);return this.a.delete(l,w)}z(f,g,w,l){const p=this.f(f,g),y=this.f(f,w);return this.a.rename(p,y,l)}C(f,g,w,l){const p=this.f(f,g),y=this.f(f,w);return this.a.copy(p,y,l)}D(f,g,w){const l=this.f(f,g),p=this.f(f,w);return this.a.cloneFile(l,p)}H(f,g){const w=new n.$me({onWillAddFirstListener:()=>{this.F.set(g,this.L(f,w))},onDidRemoveLastListener:()=>{(0,S.$Rc)(this.F.get(g)),this.F.delete(g)}});return w.event}async I(f,g,w,l,p){const y=this.F.get(g);if(y){const $=this.f(f,l),m=y.watch(w,$,p);this.G.set(g+w,m)}}async J(f,g){const w=f+g,l=this.G.get(w);l&&((0,S.$Rc)(l),this.G.delete(w))}dispose(){super.dispose();for(const[,f]of this.G)f.dispose();this.G.clear();for(const[,f]of this.F)f.dispose();this.F.clear()}}e.$1s=b;class a extends S.$Wc{constructor(f,g,w,l){super(),this.c=f,this.f=w,this.g=l,this.a=new Map,this.b=this.B(new r.$qr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(g)}h(f){const g=this.B(new n.$me);this.B(g.event(w=>{f.fire(w.map(l=>({resource:this.c.transformOutgoingURI(l.resource),type:l.type,cId:l.cId})))})),this.B(this.b.onDidChangeFile(w=>g.fire(w))),this.B(this.b.onDidWatchError(w=>f.fire(w)))}j(f){}m(f){}watch(f,g,w){const l=this.m(this.g);return Array.isArray(l)&&(w.excludes=[...w.excludes,...l]),this.a.set(f,this.b.watch(g,w)),(0,S.$Uc)(()=>{(0,S.$Rc)(this.a.get(f)),this.a.delete(f)})}dispose(){for(const[,f]of this.a)f.dispose();this.a.clear(),super.dispose()}}e.$2s=a}),define(oe[228],ae([0,1,14,183,4,7,15,9,227,160,53]),function(x,e,n,r,S,D,A,I,b,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;class f extends b.$1s{constructor(l,p,y){super(l,p),this.M=y}c(l){return a.$Mn}f(l,p){return D.URI.revive(p)}async y(l,p,y){if(!y.useTrash)return super.y(l,p,y);const $=this.f(l,p),m=(0,I.$jc)($.fsPath);try{await n.shell.trashItem(m)}catch(v){throw(0,A.$ml)(S.$i?(0,r.localize)(0,null,(0,I.$pc)(m),(0,h.$qj)(v)):(0,r.localize)(1,null,(0,I.$pc)(m),(0,h.$qj)(v)),A.FileSystemProviderErrorCode.Unknown)}}L(l,p){return new g(l,p,this.b,this.M)}}e.$kfc=f;class g extends b.$2s{watch(l,p,y){if(y.recursive)throw(0,A.$ml)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(l,p,y)}}}),define(oe[229],ae([0,1,5]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=void 0;class r extends n.$fk{constructor(D=n.$ck){super(),this.m=[],this.n=void 0,this.setLevel(D),this.B(this.onDidChangeLogLevel(A=>{this.n?.setLevel(A)}))}set logger(D){this.n=D;for(const{level:A,message:I}of this.m)(0,n.log)(D,A,I);this.m=[]}g(D,A){this.n?(0,n.log)(this.n,D,A):this.getLevel()<=D&&this.m.push({level:D,message:A})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$4bc=r}),define(oe[230],ae([0,1,7,3,5,2]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=void 0;class A extends S.$kk{constructor(f,g,w,l,p){super(g,w,l),this.r=f,this.t=p,this.B(p.listen("onDidChangeLogLevel",f)(y=>{(0,S.$bk)(y)?super.setLogLevel(y):super.setLogLevel(n.URI.revive(y[0]),y[1])})),this.B(p.listen("onDidChangeVisibility",f)(([y,$])=>super.setVisibility(n.URI.revive(y),$))),this.B(p.listen("onDidChangeLoggers",f)(({added:y,removed:$})=>{for(const m of y)super.registerLogger({...m,resource:n.URI.revive(m.resource)});for(const m of $)super.deregisterLogger(m.resource)}))}createConsoleMainLogger(){return new S.$ik({log:(f,g)=>{this.t.call("consoleLog",[f,g])}})}registerLogger(f){super.registerLogger(f),this.t.call("registerLogger",[f,this.r])}deregisterLogger(f){super.deregisterLogger(f),this.t.call("deregisterLogger",[f,this.r])}setLogLevel(f,g){super.setLogLevel(f,g),this.t.call("setLogLevel",[f,g])}setVisibility(f,g){super.setVisibility(f,g),this.t.call("setVisibility",[this.n(f),g])}s(f,g,w){return new I(this.t,f,g,w,this.r)}static setLogLevel(f,g,w){return f.call("setLogLevel",[g,w])}}e.$qs=A;class I extends S.$fk{constructor(f,g,w,l,p){super(l?.logLevel==="always"),this.r=f,this.s=g,this.m=!1,this.n=[],this.setLevel(w),this.r.call("createLogger",[g,l,p]).then(()=>{this.u(this.n),this.m=!0})}g(f,g){const w=[[f,g]];this.m?this.u(w):this.n.push(...w)}u(f){this.r.call("log",[this.s,f])}}class b{constructor(f,g){this.a=f,this.b=g}listen(f,g){const w=this.b(f);switch(g){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(p=>this.c(p,w)),removed:[...l.removed].map(p=>this.c(p,w))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,l=>[w.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,l=>(0,S.$bk)(l)?l:[w.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${g}`)}async call(f,g,w){const l=this.b(f);switch(g){case"setLogLevel":return(0,S.$bk)(w[0])?this.a.setLogLevel(w[0]):this.a.setLogLevel(n.URI.revive(l.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,l)))}throw new Error(`Call not found: ${g}`)}c(f,g){return{...f,resource:g.transformOutgoingURI(f.resource)}}}e.$rs=b;class a extends D.$Wc{constructor(f,g){super(),g.call("setLogLevel",[f.getLogLevel()]),this.B(f.onDidChangeLogLevel(w=>g.call("setLogLevel",[w]))),g.call("getRegisteredLoggers").then(w=>{for(const l of w)f.registerLogger({...l,resource:n.URI.revive(l.resource)})}),this.B(g.listen("onDidChangeVisibility")(([w,l])=>f.setVisibility(n.URI.revive(w),l))),this.B(g.listen("onDidChangeLoggers")(({added:w,removed:l})=>{for(const p of w)f.registerLogger({...p,resource:n.URI.revive(p.resource)});for(const p of l)f.deregisterLogger(p.resource)}))}}e.$ss=a}),define(oe[231],ae([0,1,2,5]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0;class S extends n.$Wc{constructor(A,I=[]){super(),this.a=new r.$jk([A,...I]),this.B(A.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...I){this.a.trace(A,...I)}debug(A,...I){this.a.debug(A,...I)}info(A,...I){this.a.info(A,...I)}warn(A,...I){this.a.warn(A,...I)}error(A,...I){this.a.error(A,...I)}flush(){this.a.flush()}}e.$oR=S}),define(oe[232],ae([0,1,32,7,5]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class D{constructor(I){this.b=I,this.a=new n.$Cc}listen(I,b,a){switch(b){case"onDidChangeLoggers":return a?this.b.getOnDidChangeLoggersEvent(a):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.b.getOnDidChangeLogLevelEvent(a):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.b.getOnDidChangeVisibilityEvent(a):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${b}`)}async call(I,b,a){switch(b){case"createLogger":this.c(r.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.e(r.URI.revive(a[0]),a[1]);case"consoleLog":return this.d(a[0],a[1]);case"setLogLevel":return(0,S.$bk)(a[0])?this.b.setLogLevel(a[0]):this.b.setLogLevel(r.URI.revive(a[0]),a[1]);case"setVisibility":return this.b.setVisibility(r.URI.revive(a[0]),a[1]);case"registerLogger":return this.b.registerLogger({...a[0],resource:r.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.b.deregisterLogger(r.URI.revive(a[0]))}throw new Error(`Call not found: ${b}`)}c(I,b,a){this.a.set(I,this.b.createLogger(I,b,a))}d(I,b){let a=console.log;switch(I){case S.LogLevel.Error:a=console.error;break;case S.LogLevel.Warning:a=console.warn;break;case S.LogLevel.Info:a=console.info;break}a.call(console,...b)}e(I,b){const a=this.a.get(I);if(!a)throw new Error("Create the logger before logging");for(const[h,f]of b)(0,S.log)(a,h,f)}}e.$hgc=D}),define(oe[233],ae([0,1,15,5]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=void 0;var S;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(S||(S={}));async function D(a,h,f,g,w){try{const l=await new Promise((y,$)=>{x(["@vscode/spdlog"],y,$)}).then(Re);l.setFlushOn(S.Trace);const p=await l.createAsyncRotatingLogger(a,h,f,g);return w?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(l){console.error(l)}return null}function A(a,h,f){switch(h){case r.LogLevel.Trace:a.trace(f);break;case r.LogLevel.Debug:a.debug(f);break;case r.LogLevel.Info:a.info(f);break;case r.LogLevel.Warning:a.warn(f);break;case r.LogLevel.Error:a.error(f);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${h}`)}}function I(a,h){switch(h){case r.LogLevel.Trace:a.setLevel(S.Trace);break;case r.LogLevel.Debug:a.setLevel(S.Debug);break;case r.LogLevel.Info:a.setLevel(S.Info);break;case r.LogLevel.Warning:a.setLevel(S.Warning);break;case r.LogLevel.Error:a.setLevel(S.Error);break;case r.LogLevel.Off:a.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${h}`)}}class b extends r.$fk{constructor(h,f,g,w,l){super(),this.m=[],this.setLevel(l),this.n=this.s(h,f,g,w),this.B(this.onDidChangeLogLevel(p=>{this.r&&I(this.r,p)}))}async s(h,f,g,w){const l=g?6:1,p=30/l*n.$Hl.MB,y=await D(h,f,p,l,w);if(y){this.r=y,I(this.r,this.getLevel());for(const{level:$,message:m}of this.m)A(this.r,$,m);this.m=[]}}g(h,f){this.r?A(this.r,h,f):this.getLevel()<=h&&this.m.push({level:h,message:f})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$dR=b}),define(oe[234],ae([0,1,33,5,233]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eR=void 0;class D extends r.$kk{s(I,b,a){return new S.$dR((0,n.$2g)(),I.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,b)}}e.$eR=D}),define(oe[71],ae([0,1,32,3,6,5,234]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=e.$Rec=void 0,e.$Rec=(0,S.$Gi)(D.$ak);class I extends A.$eR{constructor(){super(...arguments),this.u=new n.$Cc}createLogger(a,h,f){f!==void 0&&this.u.set(this.n(a),f);try{return super.createLogger(a,h)}catch(g){throw this.u.delete(this.n(a)),g}}registerLogger(a,h){h!==void 0&&this.u.set(a.resource,h),super.registerLogger(a)}deregisterLogger(a){this.u.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const h=[];for(const f of super.getRegisteredLoggers())a===this.u.get(f.resource)&&h.push(f);return h}getOnDidChangeLogLevelEvent(a){return r.Event.filter(this.onDidChangeLogLevel,h=>(0,D.$bk)(h)||this.w(h[0],a))}getOnDidChangeVisibilityEvent(a){return r.Event.filter(this.onDidChangeVisibility,([h])=>this.w(h,a))}getOnDidChangeLoggersEvent(a){return r.Event.filter(r.Event.map(this.onDidChangeLoggers,h=>({added:[...h.added].filter(g=>this.w(g.resource,a)),removed:[...h.removed].filter(g=>this.w(g.resource,a))})),h=>h.added.length>0||h.removed.length>0)}deregisterLoggers(a){for(const[h,f]of this.u)f===a&&this.deregisterLogger(h)}w(a,h){const f=this.u.get(a);return f===void 0||f===h}dispose(){super.dispose(),this.u.clear()}}e.$Sec=I}),define(oe[235],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=n,e.$yfc=r,e.$zfc=S,e.$Afc=D;function n(A){return A.submenu!==void 0}function r(A){return A.id==="vscode.menubar.separator"}function S(A){return A.uri!==void 0}function D(A){return!n(A)&&!r(A)&&!S(A)}}),define(oe[40],ae([0,1,3,76,2,6]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=void 0,e.$so=(0,D.$Fi)("policy");class A extends S.$Wc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$me),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const h=Object.keys(this.f).length;return this.f={...a,...this.f},h!==Object.keys(this.f).length&&await this.j(a),r.Iterable.reduce(this.g.entries(),(f,[g,w])=>({...f,[g]:w}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(a,[h,f])=>({...a,[h]:{definition:f,value:this.g.get(h)}}),{})}}e.$to=A;class I{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$uo=I}),define(oe[236],ae([0,1,8,3,76,12,15,5,40]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;function a(f,g){const w=[];for(const l of new Set(S.Iterable.concat(f.keys(),g.keys())))f.get(l)!==g.get(l)&&w.push(l);return w}let h=class extends b.$to{constructor(g,w,l){super(),this.m=g,this.n=w,this.s=l,this.c=this.B(new n.$Dh(500));const p=r.Event.filter(w.onDidFilesChange,y=>y.affects(g));this.B(w.watch(g)),this.B(p(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const g=new Map;try{const w=await this.n.readFile(this.m),l=JSON.parse(w.value.toString());if(!(0,D.$hg)(l))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(l))this.f[p]&&g.set(p,l[p])}catch(w){w.fileOperationResult!==A.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",w)}return g}async w(){const g=await this.u(),w=a(this.g,g);this.g=g,w.length>0&&this.h.fire(w)}};e.$Agc=h,e.$Agc=h=Se([re(1,A.$_k),re(2,I.$_j)],h)}),define(oe[237],ae([0,1,3,2,40]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=e.$9fc=void 0;class D{constructor(b){this.b=b,this.a=new r.$Vc}listen(b,a){switch(a){case"onDidChange":return n.Event.map(this.b.onDidChange,h=>h.reduce((f,g)=>({...f,[g]:this.b.getPolicyValue(g)??null}),{}),this.a)}throw new Error(`Event not found: ${a}`)}call(b,a,h){switch(a){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(h)}throw new Error(`Call not found: ${a}`)}dispose(){this.a.dispose()}}e.$9fc=D;class A extends S.$to{constructor(b,a){super(),this.a=a;for(const h in b){const{definition:f,value:g}=b[h];this.f[h]=f,g!==void 0&&this.g.set(h,g)}this.a.listen("onDidChange")(h=>{for(const f in h){const g=h[f];g===null?this.g.delete(f):this.g.set(f,g)}this.h.fire(Object.keys(h))})}async j(b){const a=await this.a.call("updatePolicyDefinitions",b);for(const h in a)this.g.set(h,a[h])}}e.$0fc=A}),define(oe[238],ae([0,1,40,8,2,5]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;let A=class extends n.$to{constructor(b,a){super(),this.m=b,this.n=a,this.a=new r.$zh,this.b=this.B(new S.$Xc)}async j(b){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(b).length} policy definitions`);const{createWatcher:a}=await new Promise((h,f)=>{x(["@vscode/policy-watcher"],h,f)}).then(Re);await this.a.queue(()=>new Promise((h,f)=>{try{this.b.value=a(this.n,b,g=>{this.t(g),h()})}catch(g){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),f(g)}}))}t(b){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(b)}`);for(const a in b){const h=b[a];h===void 0?this.g.delete(a):this.g.set(a,h)}this.h.fire(Object.keys(b))}};e.$zgc=A,e.$zgc=A=Se([re(0,D.$_j)],A)}),define(oe[84],ae([0,1,36]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const D=S.context.configuration();if(D)r=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:D.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(oe[28],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,n.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"}),define(oe[239],ae([0,1,8,5]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;let S=class{constructor(A,I,b){this.a=A,this.b=I,this.c=b}async inspect(A){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$Gh)(A);const b=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),b.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};e.$nfc=S,e.$nfc=S=Se([re(2,r.$_j)],S)}),define(oe[85],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0,e.$Aec=(0,n.$Fi)("protocolMainService")}),define(oe[45],ae([0,1,141,12]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,n=Re(n),r=Re(r);class S{constructor(){this.a=new Map}add(A,I){n.ok(r.$fg(A)),n.ok(r.$hg(I)),n.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,I)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$qo=new S}),define(oe[240],ae([0,1,3,45]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,r=Re(r),e.$ro={JSONContribution:"base.contributions.json"};function S(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class D{constructor(){this.b=new n.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,a){this.a[S(b)]=a,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const A=new D;r.$qo.add(e.$ro.JSONContribution,A)}),define(oe[54],ae([0,1,22,3,12,168,18,240,45]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.ConfigurationScope=e.$vo=e.EditPresentationTypes=void 0,e.$Go=p,e.$Ho=y,e.$Io=$,e.$Jo=v,e.$Ko=k,S=Re(S),D=Re(D);var a;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$vo={Configuration:"base.contributions.configuration"};var h;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(h||(e.ConfigurationScope=h={})),e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co="vscode://schemas/settings/resourceLanguage",e.$Do="vscode://schemas/settings/configurationDefaults";const f=b.$qo.as(I.$ro.JSONContribution);class g{constructor(){this.h=new Set,this.i=new r.$me,this.onDidSchemaChange=this.i.event,this.j=new r.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},f.registerSchema(e.$Co,this.g),this.v()}registerConfiguration(o,i=!0){this.registerConfigurations([o],i)}registerConfigurations(o,i=!0){const c=new Set;this.n(o,i,c),f.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(o){const i=new Set;this.o(o,i),f.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:o,remove:i}){const c=new Set;this.o(i,c),this.n(o,!1,c),f.registerSchema(e.$Co,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(o){const i=new Set;this.k(o,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(o,i){const c=[];for(const{overrides:s,source:u}of o)for(const d in s)if(i.add(d),e.$Fo.test(d)){const P=this.a.get(d),E=P?.valuesSources??new Map;if(u)for(const R of Object.keys(s[d]))E.set(R,u);const O={...P?.value||{},...s[d]};this.a.set(d,{source:u,value:O,valuesSources:E});const T=(0,A.$jj)(d),L={type:"object",default:O,description:D.localize(1,null,T),$ref:e.$Co,defaultDefaultValue:O,source:S.$fg(u)?void 0:u,defaultValueSource:u};c.push(...p(d)),this.d[d]=L,this.b.properties[d]=L}else{this.a.set(d,{value:s[d],source:u});const P=this.d[d];P&&(this.w(d,P),this.r(d,P))}this.m(c)}deregisterDefaultConfigurations(o){const i=new Set;this.l(o,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(o,i){for(const{overrides:c,source:s}of o)for(const u in c){const d=this.a.get(u),P=S.$fg(s)?s:s?.id,E=S.$fg(d?.source)?d?.source:d?.source?.id;if(P===E)if(i.add(u),this.a.delete(u),e.$Fo.test(u))delete this.d[u],delete this.b.properties[u];else{const O=this.d[u];O&&(this.w(u,O),this.r(u,O))}}this.u()}deltaConfiguration(o){let i=!1;const c=new Set;o.removedDefaults&&(this.l(o.removedDefaults,c),i=!0),o.addedDefaults&&(this.k(o.addedDefaults,c),i=!0),o.removedConfigurations&&this.o(o.removedConfigurations,c),o.addedConfigurations&&this.n(o.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...o){this.i.fire()}registerOverrideIdentifiers(o){this.m(o),this.i.fire()}m(o){for(const i of o)this.h.add(i);this.u()}n(o,i,c){o.forEach(s=>{this.p(s,i,s.extensionInfo,s.restrictedProperties,void 0,c),this.c.push(s),this.q(s)})}o(o,i){const c=s=>{if(s.properties)for(const u in s.properties){i.add(u);const d=this.d[u];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[u],this.s(u,s.properties[u])}s.allOf?.forEach(u=>c(u))};for(const s of o){c(s);const u=this.c.indexOf(s);u!==-1&&this.c.splice(u,1)}}p(o,i=!0,c,s,u=h.WINDOW,d){u=S.$og(o.scope)?u:o.scope;const P=o.properties;if(P)for(const O in P){const T=P[O];if(i&&v(O,T)){delete P[O];continue}if(T.source=c,T.defaultDefaultValue=P[O].default,this.w(O,T),e.$Fo.test(O)?T.scope=void 0:(T.scope=S.$og(T.scope)?u:T.scope,T.restricted=S.$og(T.restricted)?!!s?.includes(O):T.restricted),P[O].hasOwnProperty("included")&&!P[O].included){this.f[O]=P[O],delete P[O];continue}else this.d[O]=P[O],P[O].policy?.name&&this.e.set(P[O].policy.name,O);!P[O].deprecationMessage&&P[O].markdownDeprecationMessage&&(P[O].deprecationMessage=P[O].markdownDeprecationMessage),d.add(O)}const E=o.allOf;if(E)for(const O of E)this.p(O,i,c,s,u,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(o){const i=c=>{const s=c.properties;if(s)for(const d in s)this.r(d,s[d]);c.allOf?.forEach(i)};i(o)}r(o,i){switch(e.$wo.properties[o]=i,i.scope){case h.APPLICATION:e.$xo.properties[o]=i;break;case h.MACHINE:e.$yo.properties[o]=i;break;case h.MACHINE_OVERRIDABLE:e.$zo.properties[o]=i;break;case h.WINDOW:e.$Ao.properties[o]=i;break;case h.RESOURCE:e.$Bo.properties[o]=i;break;case h.LANGUAGE_OVERRIDABLE:e.$Bo.properties[o]=i,this.g.properties[o]=i;break}}s(o,i){switch(delete e.$wo.properties[o],i.scope){case h.APPLICATION:delete e.$xo.properties[o];break;case h.MACHINE:delete e.$yo.properties[o];break;case h.MACHINE_OVERRIDABLE:delete e.$zo.properties[o];break;case h.WINDOW:delete e.$Ao.properties[o];break;case h.RESOURCE:case h.LANGUAGE_OVERRIDABLE:delete e.$Bo.properties[o],delete this.g.properties[o];break}}u(){for(const o of this.h.values()){const i=`[${o}]`,c={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.$Co};this.w(i,c),e.$wo.properties[i]=c,e.$xo.properties[i]=c,e.$yo.properties[i]=c,e.$zo.properties[i]=c,e.$Ao.properties[i]=c,e.$Bo.properties[i]=c}}v(){const o={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.$Co};e.$wo.patternProperties[e.$Eo]=o,e.$xo.patternProperties[e.$Eo]=o,e.$yo.patternProperties[e.$Eo]=o,e.$zo.patternProperties[e.$Eo]=o,e.$Ao.patternProperties[e.$Eo]=o,e.$Bo.patternProperties[e.$Eo]=o,this.i.fire()}w(o,i){const c=this.a.get(o);let s=c?.value,u=c?.source;S.$mg(s)&&(s=i.defaultDefaultValue,u=void 0),S.$mg(s)&&(s=$(i.type)),i.default=s,i.defaultValueSource=u}}const w="\\[([^\\]]+)\\]",l=new RegExp(w,"g");e.$Eo=`^(${w})+$`,e.$Fo=new RegExp(e.$Eo);function p(t){const o=[];if(e.$Fo.test(t)){let i=l.exec(t);for(;i?.length;){const c=i[1].trim();c&&o.push(c),i=l.exec(t)}}return(0,n.$Ob)(o)}function y(t){return t.reduce((o,i)=>`${o}[${i}]`,"")}function $(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new g;b.$qo.add(e.$vo.Configuration,m);function v(t,o){return t.trim()?e.$Fo.test(t)?D.localize(7,null,t):m.getConfigurationProperties()[t]!==void 0?D.localize(8,null,t):o.policy?.name&&m.getPolicyConfigurations().get(o.policy?.name)!==void 0?D.localize(9,null,t,o.policy?.name,m.getPolicyConfigurations().get(o.policy?.name)):null:D.localize(6,null)}function k(){const t=[],o=m.getConfigurationProperties();for(const i of Object.keys(o))t.push([i,o[i].scope]);return t.push(["launch",h.RESOURCE]),t.push(["task",h.RESOURCE]),t}}),define(oe[126],ae([0,1,22,3,43,2,32,35,12,7,18,54,15,45]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=k,n=Re(n),S=Re(S),I=Re(I),b=Re(b);function l(c){return Object.isFrozen(c)?c:I.$eo(c)}class p{static createEmptyModel(s){return new p({},[],[],void 0,s)}constructor(s,u,d,P,E){this.b=s,this.c=u,this.d=d,this.raw=P,this.f=E,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(u=>{if(u instanceof p)return u;const d=new y("",this.f);return d.parseRaw(u),d.configurationModel});this.g=s.reduce((u,d)=>d===u?d:u.merge(d),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,h.$hj)(this.contents,s):this.contents}inspect(s,u){const d=this;return{get value(){return l(d.rawConfiguration.getValue(s))},get override(){return u?l(d.rawConfiguration.getOverrideValue(s,u)):void 0},get merged(){return l(u?d.rawConfiguration.override(u).getValue(s):d.rawConfiguration.getValue(s))},get overrides(){const P=[];for(const{contents:E,identifiers:O,keys:T}of d.rawConfiguration.overrides){const L=new p(E,T,[],void 0,d.f).getValue(s);L!==void 0&&P.push({identifiers:O,value:L})}return P.length?l(P):void 0}}}getOverrideValue(s,u){const d=this.j(u);return d?s?(0,h.$hj)(d,s):d:void 0}getKeysForOverrideIdentifier(s){const u=[];for(const d of this.overrides)d.identifiers.includes(s)&&u.push(...d.keys);return n.$Ob(u)}getAllOverrideIdentifiers(){const s=[];for(const u of this.overrides)s.push(...u.identifiers);return n.$Ob(s)}override(s){let u=this.a.get(s);return u||(u=this.h(s),this.a.set(s,u)),u}merge(...s){const u=I.$do(this.contents),d=I.$do(this.overrides),P=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const O of s)if(E.push(...O.raw?.length?O.raw:[O]),!O.isEmpty()){this.i(u,O.contents);for(const T of O.overrides){const[L]=d.filter(R=>n.$wb(R.identifiers,T.identifiers));L?(this.i(L.contents,T.contents),L.keys.push(...T.keys),L.keys=n.$Ob(L.keys)):d.push(I.$do(T))}for(const T of O.keys)P.indexOf(T)===-1&&P.push(T)}return new p(u,P,d,E.every(O=>O instanceof p)?void 0:E,this.f)}h(s){const u=this.j(s);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const d={};for(const P of n.$Ob([...Object.keys(this.contents),...Object.keys(u)])){let E=this.contents[P];const O=u[P];O&&(typeof E=="object"&&typeof O=="object"?(E=I.$do(E),this.i(E,O)):E=O),d[P]=E}return new p(d,this.keys,this.overrides,void 0,this.f)}i(s,u){for(const d of Object.keys(u)){if(d in s&&b.$hg(s[d])&&b.$hg(u[d])){this.i(s[d],u[d]);continue}s[d]=I.$do(u[d])}}j(s){let u=null,d=null;const P=E=>{E&&(d?this.i(d,E):d=I.$do(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===s?u=E.contents:E.identifiers.includes(s)&&P(E.contents);return P(u),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,u){this.k(s,u,!0)}setValue(s,u){this.k(s,u,!1)}removeValue(s){const u=this.keys.indexOf(s);u!==-1&&(this.keys.splice(u,1),(0,h.$gj)(this.contents,s),f.$Fo.test(s)&&this.overrides.splice(this.overrides.findIndex(d=>n.$wb(d.identifiers,(0,f.$Go)(s))),1))}k(s,u,d){(0,h.$fj)(this.contents,s,u,P=>this.f.error(P)),d=d||this.keys.indexOf(s)===-1,d&&this.keys.push(s),f.$Fo.test(s)&&this.overrides.push({identifiers:(0,f.$Go)(s),keys:Object.keys(this.contents[s]),contents:(0,h.$ej)(this.contents[s],P=>this.f.error(P))})}}e.$Lo=p;class y{constructor(s,u){this.f=s,this.g=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||p.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,u){if(!b.$og(s)){const d=this.h(s);this.parseRaw(d,u)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,u){this.a=s;const{contents:d,keys:P,overrides:E,restricted:O,hasExcludedProperties:T}=this.i(s,u);this.b=new p(d,P,E,T?[s]:void 0,this.g),this.c=O||[]}h(s){let u={},d=null,P=[];const E=[],O=[];function T(R){Array.isArray(P)?P.push(R):d!==null&&(P[d]=R)}const L={onObjectBegin:()=>{const R={};T(R),E.push(P),P=R,d=null},onObjectProperty:R=>{d=R},onObjectEnd:()=>{P=E.pop()},onArrayBegin:()=>{const R=[];T(R),E.push(P),P=R,d=null},onArrayEnd:()=>{P=E.pop()},onLiteralValue:T,onError:(R,M,B)=>{O.push({error:R,offset:M,length:B})}};if(s)try{S.$5n(s,L),u=P[0]||{}}catch(R){this.g.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return u}i(s,u){const d=w.$qo.as(f.$vo.Configuration).getConfigurationProperties(),P=this.j(s,d,!0,u);s=P.raw;const E=(0,h.$ej)(s,L=>this.g.error(`Conflict in settings file ${this.f}: ${L}`)),O=Object.keys(s),T=this.l(s,L=>this.g.error(`Conflict in settings file ${this.f}: ${L}`));return{contents:E,keys:O,overrides:T,restricted:P.restricted,hasExcludedProperties:P.hasExcludedProperties}}j(s,u,d,P){let E=!1;if(!P?.scopes&&!P?.skipRestricted&&!P?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:E};const O={},T=[];for(const L in s)if(f.$Fo.test(L)&&d){const R=this.j(s[L],u,!1,P);O[L]=R.raw,E=E||R.hasExcludedProperties,T.push(...R.restricted)}else{const R=u[L],M=R?typeof R.scope<"u"?R.scope:f.ConfigurationScope.WINDOW:void 0;R?.restricted&&T.push(L),!P.exclude?.includes(L)&&(P.include?.includes(L)||(M===void 0||P.scopes===void 0||P.scopes.includes(M))&&!(P.skipRestricted&&R?.restricted))?O[L]=s[L]:E=!0}return{raw:O,restricted:T,hasExcludedProperties:E}}l(s,u){const d=[];for(const P of Object.keys(s))if(f.$Fo.test(P)){const E={};for(const O in s[P])E[O]=s[P][O];d.push({identifiers:(0,f.$Go)(P),keys:Object.keys(E),contents:(0,h.$ej)(E,u)})}return d}}e.$Mo=y;class $ extends D.$Wc{constructor(s,u,d,P,E){super(),this.c=s,this.f=u,this.g=P,this.h=E,this.b=this.B(new r.$me),this.onDidChange=this.b.event,this.a=new y(this.c.toString(),E),this.B(this.g.watch(d.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,O=>O.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,O=>(O.isOperation(g.FileOperation.CREATE)||O.isOperation(g.FileOperation.COPY)||O.isOperation(g.FileOperation.DELETE)||O.isOperation(g.FileOperation.WRITE))&&d.isEqual(O.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return p.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=$;class m{constructor(s,u,d,P,E,O,T,L,R,M,B,C,z){this.a=s,this.b=u,this.c=d,this.overrideIdentifiers=P,this.d=E,this.f=O,this.g=T,this.h=L,this.i=R,this.j=M,this.k=B,this.l=C,this.m=z}get value(){return l(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class v{constructor(s,u,d,P,E,O,T,L,R,M){this.j=s,this.l=u,this.m=d,this.n=P,this.p=E,this.q=O,this.r=T,this.s=L,this.t=R,this.u=M,this.h=null,this.i=new A.$Cc,this.v=null}getValue(s,u,d){return this.w(s,u,d).getValue(s)}updateValue(s,u,d={}){let P;d.resource?(P=this.t.get(d.resource),P||(P=p.createEmptyModel(this.u),this.t.set(d.resource,P))):P=this.s,u===void 0?P.removeValue(s):P.setValue(s,u),d.resource||(this.h=null)}inspect(s,u,d){const P=this.w(s,u,d),E=this.A(u.resource,d),O=u.resource?this.t.get(u.resource)||this.s:this.s,T=new Set;for(const L of P.overrides)for(const R of L.identifiers)P.getOverrideValue(s,R)!==void 0&&T.add(R);return new m(s,u,P.getValue(s),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,d?this.q:void 0,E||void 0,O)}keys(s){const u=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,u){this.r.set(s,u),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,u){const d=[];if(!u){const{added:P,updated:E,removed:O}=o(this.j,s);u=[...P,...E,...O]}for(const P of u)for(const E of(0,f.$Go)(P)){const O=this.j.getKeysForOverrideIdentifier(E),T=s.getKeysForOverrideIdentifier(E),L=[...T.filter(R=>O.indexOf(R)===-1),...O.filter(R=>T.indexOf(R)===-1),...O.filter(R=>!I.$ho(this.j.override(E).getValue(R),s.override(E).getValue(R)))];d.push([E,L])}return this.updateDefaultConfiguration(s),{keys:u,overrides:d}}compareAndUpdatePolicyConfiguration(s){const{added:u,updated:d,removed:P}=o(this.l,s),E=[...u,...d,...P];return E.length&&this.updatePolicyConfiguration(s),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:u,updated:d,removed:P,overrides:E}=o(this.applicationConfiguration,s),O=[...u,...d,...P];return O.length&&this.updateApplicationConfiguration(s),{keys:O,overrides:E}}compareAndUpdateLocalUserConfiguration(s){const{added:u,updated:d,removed:P,overrides:E}=o(this.localUserConfiguration,s),O=[...u,...d,...P];return O.length&&this.updateLocalUserConfiguration(s),{keys:O,overrides:E}}compareAndUpdateRemoteUserConfiguration(s){const{added:u,updated:d,removed:P,overrides:E}=o(this.remoteUserConfiguration,s),O=[...u,...d,...P];return O.length&&this.updateRemoteUserConfiguration(s),{keys:O,overrides:E}}compareAndUpdateWorkspaceConfiguration(s){const{added:u,updated:d,removed:P,overrides:E}=o(this.workspaceConfiguration,s),O=[...u,...d,...P];return O.length&&this.updateWorkspaceConfiguration(s),{keys:O,overrides:E}}compareAndUpdateFolderConfiguration(s,u){const d=this.folderConfigurations.get(s),{added:P,updated:E,removed:O,overrides:T}=o(d,u),L=[...P,...E,...O];return(L.length||!d)&&this.updateFolderConfiguration(s,u),{keys:L,overrides:T}}compareAndDeleteFolderConfiguration(s){const u=this.folderConfigurations.get(s);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:d,updated:P,removed:E,overrides:O}=o(u,void 0);return{keys:[...d,...P,...E],overrides:O}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,u,d){let P=this.x(u,d);return u.overrideIdentifier&&(P=P.override(u.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(P=P.merge(this.l)),P}x({resource:s},u){let d=this.y();if(u&&s){const P=u.getFolder(s);P&&(d=this.z(P.uri)||d);const E=this.t.get(s);E&&(d=d.merge(E))}return d}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let u=this.i.get(s);if(!u){const d=this.y(),P=this.r.get(s);P?(u=d.merge(P),this.i.set(s,u)):u=d}return u}A(s,u){if(u&&s){const d=u.getFolder(s);if(d)return this.r.get(d.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,u)=>{const{contents:d,overrides:P,keys:E}=this.r.get(u);return s.push([u,{contents:d,overrides:P,keys:E}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(u=>s.add(u)),this.userConfiguration.keys.forEach(u=>s.add(u)),this.q.keys.forEach(u=>s.add(u)),this.r.forEach(u=>u.keys.forEach(d=>s.add(d))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(u=>s.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>s.add(u)),this.q.getAllOverrideIdentifiers().forEach(u=>s.add(u)),this.r.forEach(u=>u.getAllOverrideIdentifiers().forEach(d=>s.add(d))),[...s.values()]}D(s){const u=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(d=>u.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(d=>u.add(d)),this.q.getKeysForOverrideIdentifier(s).forEach(d=>u.add(d)),this.r.forEach(d=>d.getKeysForOverrideIdentifier(s).forEach(P=>u.add(P))),[...u.values()]}static parse(s,u){const d=this.E(s.defaults,u),P=this.E(s.policy,u),E=this.E(s.application,u),O=this.E(s.user,u),T=this.E(s.workspace,u),L=s.folders.reduce((R,M)=>(R.set(a.URI.revive(M[0]),this.E(M[1],u)),R),new A.$Cc);return new v(d,P,E,O,p.createEmptyModel(u),T,L,p.createEmptyModel(u),new A.$Cc,u)}static E(s,u){return new p(s.contents,s.keys,s.overrides,void 0,u)}}e.$Oo=v;function k(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const s=new Set,u=new Map;for(const P of c)P.keys.forEach(E=>s.add(E)),P.overrides.forEach(([E,O])=>{const T=(0,A.$zc)(u,E,new Set);O.forEach(L=>T.add(L))});const d=[];return u.forEach((P,E)=>d.push([E,[...P.values()]])),{keys:[...s.values()],overrides:d}}class t{constructor(s,u,d,P,E){this.change=s,this.f=u,this.g=d,this.h=P,this.i=E,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const O of s.keys)this.affectedKeys.add(O);for(const[,O]of s.overrides)for(const T of O)this.affectedKeys.add(T);this.d=this.a;for(const O of this.affectedKeys)this.d+=O+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=v.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,u){const d=this.a+s,P=this.d.indexOf(d);if(P<0)return!1;const E=P+d.length;if(E>=this.d.length)return!1;const O=this.d.charCodeAt(E);if(O!==this.b&&O!==this.c)return!1;if(u){const T=this.previousConfiguration?this.previousConfiguration.getValue(s,u,this.f?.workspace):void 0,L=this.g.getValue(s,u,this.h);return!I.$ho(T,L)}return!0}}e.$Qo=t;function o(c,s){const{added:u,removed:d,updated:P}=i(s?.rawConfiguration,c?.rawConfiguration),E=[],O=c?.getAllOverrideIdentifiers()||[],T=s?.getAllOverrideIdentifiers()||[];if(s){const L=T.filter(R=>!O.includes(R));for(const R of L)E.push([R,s.getKeysForOverrideIdentifier(R)])}if(c){const L=O.filter(R=>!T.includes(R));for(const R of L)E.push([R,c.getKeysForOverrideIdentifier(R)])}if(s&&c){for(const L of O)if(T.includes(L)){const R=i({contents:c.getOverrideValue(void 0,L)||{},keys:c.getKeysForOverrideIdentifier(L)},{contents:s.getOverrideValue(void 0,L)||{},keys:s.getKeysForOverrideIdentifier(L)});E.push([L,[...R.added,...R.removed,...R.updated]])}}return{added:u,removed:d,updated:P,overrides:E}}function i(c,s){const u=c?s?c.keys.filter(E=>s.keys.indexOf(E)===-1):[...c.keys]:[],d=s?c?s.keys.filter(E=>c.keys.indexOf(E)===-1):[...s.keys]:[],P=[];if(c&&s){for(const E of s.keys)if(c.keys.indexOf(E)!==-1){const O=(0,h.$hj)(s.contents,E),T=(0,h.$hj)(c.contents,E);I.$ho(O,T)||P.push(E)}}return{added:u,removed:d,updated:P}}}),define(oe[241],ae([0,1,22,3,2,35,12,126,54,5,40,45]),function(x,e,n,r,S,D,A,I,b,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.$Ro=void 0;class g extends S.$Wc{get configurationModel(){return this.b}constructor(y){super(),this.c=y,this.a=this.B(new r.$me),this.onDidChangeConfiguration=this.a.event,this.b=I.$Lo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(f.$qo.as(b.$vo.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:$})=>this.f(Array.from(y),$))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(y,$){this.j(y,f.$qo.as(b.$vo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:y})}g(){return{}}h(){this.b=I.$Lo.createEmptyModel(this.c);const y=f.$qo.as(b.$vo.Configuration).getConfigurationProperties();this.j(Object.keys(y),y)}j(y,$){const m=this.g();for(const v of y){const k=m[v],t=$[v];k!==void 0?this.b.addValue(v,k):t?this.b.addValue(v,t.default):this.b.removeValue(v)}}}e.$Ro=g;class w{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=I.$Lo.createEmptyModel(new a.$mk)}async initialize(){return this.configurationModel}}e.$So=w;let l=class extends S.$Wc{get configurationModel(){return this.b}constructor(y,$,m){super(),this.c=y,this.f=$,this.g=m,this.a=this.B(new r.$me),this.onDidChangeConfiguration=this.a.event,this.b=I.$Lo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(y=>this.j(y))),this.B(this.c.onDidChangeConfiguration(async({properties:y})=>this.m(await this.h(y),!0))),this.b}async h(y){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",y);const $={},m=[],v=f.$qo.as(b.$vo.Configuration).getConfigurationProperties();for(const k of y){const t=v[k];if(!t){m.push(k);continue}if(t.policy){if(t.type!=="string"&&t.type!=="number"){this.g.warn(`Policy ${t.policy.name} has unsupported type ${t.type}`);continue}m.push(k),$[t.policy.name]={type:t.type}}}return(0,A.$sg)($)||await this.f.updatePolicyDefinitions($),m}j(y){this.g.trace("PolicyConfiguration#onDidChangePolicies",y);const $=f.$qo.as(b.$vo.Configuration).getPolicyConfigurations(),m=(0,n.$Jb)(y.map(v=>$.get(v)));this.m(m,!0)}m(y,$){this.g.trace("PolicyConfiguration#update",y);const m=f.$qo.as(b.$vo.Configuration).getConfigurationProperties(),v=[],k=this.b.isEmpty();for(const t of y){const o=m[t]?.policy?.name;if(o){const i=this.f.getPolicyValue(o);(k?i!==void 0:!(0,D.$ho)(this.b.getValue(t),i))&&v.push([t,i])}else this.b.getValue(t)!==void 0&&v.push([t,void 0])}if(v.length){this.g.trace("PolicyConfiguration#changed",v);const t=this.b;this.b=I.$Lo.createEmptyModel(this.g);for(const o of t.keys)this.b.setValue(o,t.getValue(o));for(const[o,i]of v)i===void 0?this.b.removeValue(o):this.b.setValue(o,i);$&&this.a.fire(this.b)}}};e.$To=l,e.$To=l=Se([re(1,h.$so),re(2,a.$_j)],l)}),define(oe[242],ae([0,1,22,8,17,3,43,108,2,32,35,4,19,18,126,54,241,15,40]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=void 0;class v extends b.$Wc{constructor(o,i,c,s){super(),this.m=o,this.n=s,this.h=this.B(new D.$me),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new y.$Ro(s)),this.c=c instanceof m.$uo?new y.$So:this.B(new y.$To(this.b,c,s)),this.f=this.B(new l.$No(this.m,{},g.$0g,i,s)),this.a=new l.$Oo(this.b.configurationModel,this.c.configurationModel,l.$Lo.createEmptyModel(s),l.$Lo.createEmptyModel(s),l.$Lo.createEmptyModel(s),l.$Lo.createEmptyModel(s),new a.$Cc,l.$Lo.createEmptyModel(s),new a.$Cc,s),this.j=new k(o,i,this),this.g=this.B(new r.$Rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:u,properties:d})=>this.s(u,d))),this.B(this.c.onDidChangeConfiguration(u=>this.t(u))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[o,i,c]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$Oo(o,i,l.$Lo.createEmptyModel(this.n),c,l.$Lo.createEmptyModel(this.n),l.$Lo.createEmptyModel(this.n),new a.$Cc,l.$Lo.createEmptyModel(this.n),new a.$Cc,this.n)}getConfigurationData(){return this.a.toData()}getValue(o,i){const c=typeof o=="string"?o:void 0,s=(0,w.$aj)(o)?o:(0,w.$aj)(i)?i:{};return this.a.getValue(c,s,void 0)}async updateValue(o,i,c,s,u){const d=(0,w.$bj)(c)?c:(0,w.$aj)(c)?{resource:c.resource,overrideIdentifiers:c.overrideIdentifier?[c.overrideIdentifier]:void 0}:void 0,P=d?s:c;if(P!==void 0&&P!==w.ConfigurationTarget.USER_LOCAL&&P!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${o} to target ${P}.`);d?.overrideIdentifiers&&(d.overrideIdentifiers=(0,n.$Ob)(d.overrideIdentifiers),d.overrideIdentifiers=d.overrideIdentifiers.length?d.overrideIdentifiers:void 0);const E=this.inspect(o,{resource:d?.resource,overrideIdentifier:d?.overrideIdentifiers?d.overrideIdentifiers[0]:void 0});if(E.policyValue!==void 0)throw new Error(`Unable to write ${o} because it is configured in system policy.`);if((0,h.$ho)(i,E.defaultValue)&&(i=void 0),d?.overrideIdentifiers?.length&&d.overrideIdentifiers.length>1){const T=d.overrideIdentifiers.sort(),L=this.a.localUserConfiguration.overrides.find(R=>(0,n.$wb)([...R.identifiers].sort(),T));L&&(d.overrideIdentifiers=L.identifiers)}const O=d?.overrideIdentifiers?.length?[(0,p.$Ho)(d.overrideIdentifiers),o]:[o];await this.j.write(O,i),await this.reloadConfiguration()}inspect(o,i={}){return this.a.inspect(o,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const o=await this.f.loadConfiguration();this.r(o)}r(o){const i=this.a.toData(),c=this.a.compareAndUpdateLocalUserConfiguration(o);this.u(c,i,w.ConfigurationTarget.USER)}s(o,i){const c=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(o,i);this.u(s,c,w.ConfigurationTarget.DEFAULT)}t(o){const i=this.a.toData(),c=this.a.compareAndUpdatePolicyConfiguration(o);this.u(c,i,w.ConfigurationTarget.DEFAULT)}u(o,i,c){const s=new l.$Qo(o,{data:i},this.a,void 0,this.n);s.source=c,this.h.fire(s)}}e.$Uo=v;class k{constructor(o,i,c){this.b=o,this.c=i,this.d=c,this.a=new r.$Mh}write(o,i){return this.a.queue(()=>this.e(o,i))}async e(o,i){let c;try{c=(await this.c.readFile(this.b)).value.toString()}catch(d){if(d.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND)c="{}";else throw d}const s=[];if((0,A.$Xn)(c,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const u=this.f(c,o,i);c=(0,I.$co)(c,u),await this.c.writeFile(this.b,S.$Oe.fromString(c))}f(o,i,c){const{tabSize:s,insertSpaces:u,eol:d}=this.h;if(!i.length){const P=JSON.stringify(c,null,u?" ".repeat(s):"	");return[{content:P,length:P.length,offset:0}]}return(0,I.$_n)(o,i,c,{tabSize:s,insertSpaces:u,eol:d})}get h(){if(!this.g){let o=f.OS===f.OperatingSystem.Linux||f.OS===f.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(o=i),this.g={eol:o,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(oe[243],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=e.$mgc=void 0,e.$mgc="request",e.$ngc="remoteResourceHandler";class n{async routeCall(S,D,A){if(D!==e.$mgc)throw new Error(`Call not found: ${D}`);const I=A[0];if(I?.authority){const b=S.connections.find(a=>a.ctx===I.authority);if(b)return b}throw new Error("Caller not found")}routeEvent(S,D){throw new Error(`Event not found: ${D}`)}}e.$ogc=n}),define(oe[244],ae([0,1,16,6]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=a,e.$Ql=(0,r.$Fi)("remoteAuthorityResolverService");var S;(function(h){h[h.WebSocket=0]="WebSocket",h[h.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class D{constructor(f){this.id=f,this.type=S.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=D;class A{constructor(f,g){this.host=f,this.port=g,this.type=S.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=A;var I;(function(h){h.Unknown="Unknown",h.NotAvailable="NotAvailable",h.TemporarilyNotAvailable="TemporarilyNotAvailable",h.NoResolverFound="NoResolverFound",h.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class b extends n.$db{static isNotAvailable(f){return f instanceof b&&f._code===I.NotAvailable}static isTemporarilyNotAvailable(f){return f instanceof b&&f._code===I.TemporarilyNotAvailable}static isNoResolverFound(f){return f instanceof b&&f._code===I.NoResolverFound}static isInvalidAuthority(f){return f instanceof b&&f._code===I.InvalidAuthority}static isHandled(f){return f instanceof b&&f.isHandled}constructor(f,g=I.Unknown,w){super(f),this._message=f,this._code=g,this._detail=w,this.isHandled=g===I.NotAvailable&&w===!0,Object.setPrototypeOf(this,b.prototype)}}e.$Tl=b;function a(h){const f=h.indexOf("+");return f===-1?h:h.substring(0,f)}}),define(oe[245],ae([0,1,8,17,23,16,3,2,13,70,66,33,118,244]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Zl=E,e.$1l=O,e.$2l=L,a=Re(a);const l=30*1e3;var p;(function(se){se[se.Management=1]="Management",se[se.ExtensionHost=2]="ExtensionHost",se[se.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function y(se){switch(se){case p.Management:return"Management";case p.ExtensionHost:return"ExtensionHost";case p.Tunnel:return"Tunnel"}}function $(se){const _=new S.$xe;return setTimeout(()=>_.cancel(),se),_.token}function m(se,_){if(se.isCancellationRequested||_.isCancellationRequested)return S.CancellationToken.Cancelled;const F=new S.$xe;return se.onCancellationRequested(()=>F.cancel()),_.onCancellationRequested(()=>F.cancel()),F.token}class v{get didTimeout(){return this.c==="timedout"}constructor(_){this.c="pending",this.d=new I.$Vc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$yh)(),_.isCancellationRequested?this.h():this.d.add(_.onCancellationRequested(()=>this.h()))}registerDisposable(_){this.c==="pending"?this.d.add(_):_.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const _=new Error("Time limit reached");return _.code="ETIMEDOUT",_.syscall="connect",_}resolve(_){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(_))}reject(_){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(_))}}function k(se,_){const F=new v(_);return F.registerDisposable(se.onControlMessage(N=>{const W=JSON.parse(N.toString()),q=j(W);q?F.reject(q):F.resolve(W)})),F.promise}function t(se,_,F,N,W,q,Y,X){const Z=new v(X),ie=h.$ge.create(!1);return se.info(`Creating a socket (${Y})...`),a.mark(`code/willCreateSocket/${q}`),_.connect(F,N,W,Y).then(de=>{Z.didTimeout?(a.mark(`code/didCreateSocketError/${q}`),se.info(`Creating a socket (${Y}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(a.mark(`code/didCreateSocketOK/${q}`),se.info(`Creating a socket (${Y}) was successful after ${ie.elapsed()} ms.`),Z.resolve(de))},de=>{a.mark(`code/didCreateSocketError/${q}`),se.info(`Creating a socket (${Y}) returned an error after ${ie.elapsed()} ms.`),se.error(de),Z.reject(de)}),Z.promise}function o(se,_){const F=new v(_);return se.then(N=>{F.didTimeout||F.resolve(N)},N=>{F.didTimeout||F.reject(N)}),F.promise}async function i(se,_,F,N){const W=G(se,_);se.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let q;try{q=await t(se.logService,se.remoteSocketFactoryService,se.connectTo,b.$Sg.getServerRootPath(),`reconnectionToken=${se.reconnectionToken}&reconnection=${se.reconnectionProtocol?"true":"false"}`,y(_),`renderer-${y(_)}-${se.reconnectionToken}`,N)}catch(de){throw se.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),se.logService.error(de),de}se.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let Y,X;se.reconnectionProtocol?(se.reconnectionProtocol.beginAcceptReconnection(q,null),Y=se.reconnectionProtocol,X=!1):(Y=new g.$ti({socket:q}),X=!0),se.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const Z=await o(se.signService.createNewMessage((0,f.$2g)()),N),ie={type:"auth",auth:se.connectionToken||"00000000000000000000",data:Z.data};Y.sendControl(r.$Oe.fromString(JSON.stringify(ie)));try{const de=await k(Y,m(N,$(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(se.logService.trace(`${W} 4/6. received SignRequest control message.`),!await o(se.signService.validate(Z,de.signedData),N)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const we=await o(se.signService.sign(de.data),N),Ie={type:"connectionType",commit:se.commit,signedData:we,desiredConnectionType:_};return F&&(Ie.args=F),se.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(r.$Oe.fromString(JSON.stringify(Ie))),{protocol:Y,ownsProtocol:X}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(se.logService.error(`${W} the handshake timed out. Error:`),se.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(se.logService.error(`${W} received error control message when negotiating connection. Error:`),se.logService.error(de)),X&&H(Y),de}}async function c(se,_,F,N){const W=Date.now(),q=G(se,_),{protocol:Y,ownsProtocol:X}=await i(se,_,F,N),Z=new v(N);return Z.registerDisposable(Y.onControlMessage(ie=>{const de=JSON.parse(ie.toString()),me=j(de);me?(se.logService.error(`${q} received error control message when negotiating connection. Error:`),se.logService.error(me),X&&H(Y),Z.reject(me)):(se.reconnectionProtocol?.endAcceptReconnection(),se.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${he(W)}!`),Z.resolve({protocol:Y,firstMessage:de}))})),Z.promise}async function s(se,_){const{protocol:F}=await c(se,p.Management,void 0,_);return{protocol:F}}async function u(se,_,F){const{protocol:N,firstMessage:W}=await c(se,p.ExtensionHost,_,F),q=W&&W.debugPort;return{protocol:N,debugPort:q}}async function d(se,_,F){const N=Date.now(),W=G(se,p.Tunnel),{protocol:q}=await i(se,p.Tunnel,_,F);return se.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${he(N)}!`),q}async function P(se,_,F){const{connectTo:N,connectionToken:W}=await se.addressProvider.getAddress();return{commit:se.commit,quality:se.quality,connectTo:N,connectionToken:W,reconnectionToken:_,reconnectionProtocol:F,remoteSocketFactoryService:se.remoteSocketFactoryService,signService:se.signService,logService:se.logService}}async function E(se,_,F){return T(se,async N=>{const{protocol:W}=await s(N,S.CancellationToken.None);return new K(se,_,F,N.reconnectionToken,W)})}async function O(se,_){return T(se,async F=>{const{protocol:N,debugPort:W}=await u(F,_,S.CancellationToken.None);return new ee(se,_,F.reconnectionToken,N,W)})}async function T(se,_){for(let N=1;;N++)try{const W=(0,f.$2g)(),q=await P(se,W,null);return await _(q)}catch(W){if(N<5)se.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),se.logService.error(W);else throw se.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),se.logService.error(W),ce.triggerPermanentFailure(0,0,w.$Tl.isHandled(W)),W}}async function L(se,_,F){const N=await P(se,(0,f.$2g)(),null);return await d(N,{host:_,port:F},S.CancellationToken.None)}function R(se){return(0,n.$sh)(_=>new Promise((F,N)=>{const W=setTimeout(F,se*1e3);_.onCancellationRequested(()=>{clearTimeout(W),F()})}))}var M;(function(se){se[se.ConnectionLost=0]="ConnectionLost",se[se.ReconnectionWait=1]="ReconnectionWait",se[se.ReconnectionRunning=2]="ReconnectionRunning",se[se.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",se[se.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class B{constructor(_,F){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.type=M.ConnectionLost}}e.$3l=B;class C{constructor(_,F,N,W){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.durationSeconds=N,this.c=W,this.type=M.ReconnectionWait}skipWait(){this.c.cancel()}}e.$4l=C;class z{constructor(_,F,N){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.attempt=N,this.type=M.ReconnectionRunning}}e.$5l=z;class ne{constructor(_,F,N){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.attempt=N,this.type=M.ConnectionGain}}e.$6l=ne;class Q{constructor(_,F,N,W){this.reconnectionToken=_,this.millisSinceLastIncomingData=F,this.attempt=N,this.handled=W,this.type=M.ReconnectionPermanentFailure}}e.$7l=Q;class ce extends I.$Wc{static triggerPermanentFailure(_,F,N){this._permanentFailure=!0,this.f=_,this.g=F,this.h=N,this.j.forEach(W=>W.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(_=>_.y())}static debugPauseSocketWriting(){this.j.forEach(_=>_.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ce._permanentFailure}constructor(_,F,N,W,q){super(),this.t=_,this.u=F,this.reconnectionToken=N,this.protocol=W,this.w=q,this.m=this.B(new A.$me),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ne(this.reconnectionToken,0,0)),this.B(W.onSocketClose(Y=>{const X=le(this.t,this.reconnectionToken,!0);Y?Y.type===g.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${X} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this.u.logService.error(Y.error)):(this.u.logService.info(`${X} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this.u.logService.error(Y.event)):this.u.logService.info(`${X} received socket close event.`),this.y()})),this.B(W.onSocketTimeout(Y=>{const X=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${X} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this.y()})),ce.j.push(this),this.B((0,I.$Uc)(()=>{const Y=ce.j.indexOf(this);Y>=0&&ce.j.splice(Y,1)})),this.n&&this.D(ce.f,ce.g,ce.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const _=le(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const W=N<F.length?F[N]:F[F.length-1];try{if(W>0){const Y=R(W);this.m.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,Y)),this.u.logService.info(`${_} waiting for ${W} seconds before reconnecting...`);try{await Y}catch{}}if(this.n){this.u.logService.error(`${_} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this.u.logService.info(`${_} resolving connection...`);const q=await P(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${_} connecting to ${q.connectTo}...`),await this.G(q,$(l)),this.u.logService.info(`${_} reconnected!`),this.m.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${_} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this.u.logService.error(`${_} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(w.$Tl.isTemporarilyNotAvailable(q)){this.u.logService.info(`${_} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this.u.logService.info(`${_} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if((0,D.$6)(q)){this.u.logService.info(`${_} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if(q instanceof w.$Tl){this.u.logService.error(`${_} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,w.$Tl.isHandled(q));break}this.u.logService.error(`${_} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this.n&&!this.s)}C(_,F,N){this.w?ce.triggerPermanentFailure(_,F,N):this.D(_,F,N)}D(_,F,N){this.m.fire(new Q(this.reconnectionToken,_,F,N)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$8l=ce;class K extends ce{constructor(_,F,N,W,q){super(p.Management,_,W,q,!0),this.client=this.B(new g.$ri(q,{remoteAuthority:F,clientId:N},_.ipcLogger))}async G(_,F){await s(_,F)}}e.$9l=K;class ee extends ce{constructor(_,F,N,W,q){super(p.ExtensionHost,_,N,W,!1),this.H=F,this.debugPort=q}async G(_,F){await u(_,this.H,F)}}e.$0l=ee;function H(se){try{se.acceptDisconnect();const _=se.getSocket();se.dispose(),_.dispose()}catch(_){(0,D.$3)(_)}}function j(se){if(se&&se.type==="error"){const _=new Error(`Connection error: ${se.reason}`);return _.code="VSCODE_CONNECTION_ERROR",_}return null}function U(se,_){for(;se.length<_;)se+=" ";return se}function V(se,_){return`[remote-connection][${U(y(se),13)}][${_.substr(0,5)}\u2026]`}function le(se,_,F){return`${V(se,_)}[${F?"reconnect":"initial"}]`}function G(se,_){return`${le(_,se.reconnectionToken,!!se.reconnectionProtocol)}[${se.connectTo}]`}function he(se){return`${Date.now()-se} ms`}}),define(oe[72],ae([0,1,13]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=r,e.$hn=S,e.$in=D,e.$jn=A;function r(b){return b.scheme===n.Schemas.vscodeRemote?b.authority:void 0}function S(b){if(!b)return;const a=b.indexOf("+");return a<0?b:b.substr(0,a)}function D(b){const{host:a,port:h}=I(b);if(typeof h>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:h}}function A(b,a){let{host:h,port:f}=I(b);return typeof f>"u"&&(f=a),{host:h,port:f}}function I(b){const a=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const h=b.match(/^(\[[0-9a-z:]+\])$/);if(h)return{host:h[1],port:void 0};const f=b.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:b,port:void 0}}}),define(oe[86],ae([0,1,26,6,72]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=D,e.$tn=f,e.$un=g,e.$vn=w,e.$wn=l,e.$xn=p,e.$yn=y,n=Re(n),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function D($){if(typeof $=="object"&&$!==null&&$.supported!==!0)return $.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function($){$[$.System=0]="System",$[$.User=1]="User"})(A||(e.ExtensionType=A={}));var I;(function($){$.WIN32_X64="win32-x64",$.WIN32_ARM64="win32-arm64",$.LINUX_X64="linux-x64",$.LINUX_ARM64="linux-arm64",$.LINUX_ARMHF="linux-armhf",$.ALPINE_X64="alpine-x64",$.ALPINE_ARM64="alpine-arm64",$.DARWIN_X64="darwin-x64",$.DARWIN_ARM64="darwin-arm64",$.WEB="web",$.UNIVERSAL="universal",$.UNKNOWN="unknown",$.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class b{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,v){if(typeof m>"u"||m===null)return typeof v>"u"||v===null;if(typeof v>"u"||v===null)return!1;if(typeof m=="string"||typeof v=="string"){const k=typeof m=="string"?m:m.value,t=typeof v=="string"?v:v.value;return n.$Gf(k,t)}return m._lower===v._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$qn=b;class a{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const v of m)this.add(v)}add(m){this.c.add(b.toKey(m))}delete(m){return this.c.delete(b.toKey(m))}has(m){return this.c.has(b.toKey(m))}}e.$rn=a;class h{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(b.toKey(m))}get(m){return this.c.get(b.toKey(m))}has(m){return this.c.has(b.toKey(m))}set(m,v){this.c.set(b.toKey(m),v)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=h;function f($){return g($)}function g($){return $.contributes&&$.contributes.localizations?$.contributes.localizations.length>0:!1}function w($){return $.contributes&&$.contributes.authentication?$.contributes.authentication.length>0:!1}function l($,m){if(m){const v=`onResolveRemoteAuthority:${(0,S.$hn)(m)}`;return!!$.activationEvents?.includes(v)}return!1}function p($){return $.map(m=>{const[v,k]=m.split("@");return{proposalName:v,version:k?parseInt(k):void 0}})}function y($){return $.map(m=>m.split("@")[0])}e.$zn=(0,r.$Fi)("IBuiltinExtensionsScannerService")}),define(oe[127],ae([0,1,4,175,86,6]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=I,e.$dp=b,e.$ep=a,e.$fp=h,e.$gp=f,e.$hp=g,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function I(t){switch(t){case S.TargetPlatform.WIN32_X64:return"Windows 64 bit";case S.TargetPlatform.WIN32_ARM64:return"Windows ARM";case S.TargetPlatform.LINUX_X64:return"Linux 64 bit";case S.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case S.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case S.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case S.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case S.TargetPlatform.DARWIN_X64:return"Mac";case S.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case S.TargetPlatform.WEB:return"Web";case S.TargetPlatform.UNIVERSAL:return S.TargetPlatform.UNIVERSAL;case S.TargetPlatform.UNKNOWN:return S.TargetPlatform.UNKNOWN;case S.TargetPlatform.UNDEFINED:return S.TargetPlatform.UNDEFINED}}function b(t){switch(t){case S.TargetPlatform.WIN32_X64:return S.TargetPlatform.WIN32_X64;case S.TargetPlatform.WIN32_ARM64:return S.TargetPlatform.WIN32_ARM64;case S.TargetPlatform.LINUX_X64:return S.TargetPlatform.LINUX_X64;case S.TargetPlatform.LINUX_ARM64:return S.TargetPlatform.LINUX_ARM64;case S.TargetPlatform.LINUX_ARMHF:return S.TargetPlatform.LINUX_ARMHF;case S.TargetPlatform.ALPINE_X64:return S.TargetPlatform.ALPINE_X64;case S.TargetPlatform.ALPINE_ARM64:return S.TargetPlatform.ALPINE_ARM64;case S.TargetPlatform.DARWIN_X64:return S.TargetPlatform.DARWIN_X64;case S.TargetPlatform.DARWIN_ARM64:return S.TargetPlatform.DARWIN_ARM64;case S.TargetPlatform.WEB:return S.TargetPlatform.WEB;case S.TargetPlatform.UNIVERSAL:return S.TargetPlatform.UNIVERSAL;default:return S.TargetPlatform.UNKNOWN}}function a(t,o){switch(t){case n.Platform.Windows:return o==="x64"?S.TargetPlatform.WIN32_X64:o==="arm64"?S.TargetPlatform.WIN32_ARM64:S.TargetPlatform.UNKNOWN;case n.Platform.Linux:return o==="x64"?S.TargetPlatform.LINUX_X64:o==="arm64"?S.TargetPlatform.LINUX_ARM64:o==="arm"?S.TargetPlatform.LINUX_ARMHF:S.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?S.TargetPlatform.ALPINE_X64:o==="arm64"?S.TargetPlatform.ALPINE_ARM64:S.TargetPlatform.UNKNOWN;case n.Platform.Mac:return o==="x64"?S.TargetPlatform.DARWIN_X64:o==="arm64"?S.TargetPlatform.DARWIN_ARM64:S.TargetPlatform.UNKNOWN;case n.Platform.Web:return S.TargetPlatform.WEB}}function h(t,o){return o===S.TargetPlatform.WEB&&!t.includes(S.TargetPlatform.WEB)}function f(t,o,i){return h(o,i)?!1:t===S.TargetPlatform.UNDEFINED||t===S.TargetPlatform.UNIVERSAL?!0:t===S.TargetPlatform.UNKNOWN?!1:t===i}function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var w;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var l;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var p;(function(t){t.Install="install",t.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var y;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$ip=(0,D.$Fi)("extensionGalleryService");var $;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})($||(e.ExtensionGalleryErrorCode=$={}));class m extends Error{constructor(o,i){super(o),this.code=i,this.name=i}}e.$jp=m;var v;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));class k extends Error{constructor(o,i){super(o),this.code=i,this.name=i}}e.$kp=k,e.$lp=(0,D.$Fi)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,D.$Fi)("IGlobalExtensionEnablementService"),e.$pp=(0,D.$Fi)("IExtensionTipsService"),e.$qp=(0,r.localize2)(0,"Extensions"),e.$rp=(0,r.localize2)(1,"Preferences")});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[246],ae([0,1,19,79,178,247,86,209]),function(x,e,n,r,S,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=h,e.$Xp=f,e.$Yp=g,e.$Zp=w,e.$1p=l,e.$2p=p,e.$3p=y,e.$4p=$,r=et(r),S=Re(S),D=Re(D);const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function h(k){return k=k.trim(),k==="*"||b.test(k)}function f(k){if(!h(k))return null;if(k=k.trim(),k==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=k.match(b);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function g(k){if(!k)return null;const t=k.majorBase,o=k.majorMustEqual,i=k.minorBase;let c=k.minorMustEqual;const s=k.patchBase;let u=k.patchMustEqual;k.hasCaret&&(t===0||(c=!1),u=!1);let d=0;if(k.preRelease){const P=a.exec(k.preRelease);if(P){const[,E,O,T]=P;d=Date.UTC(Number(E),Number(O)-1,Number(T))}}return{majorBase:t,majorMustEqual:o,minorBase:i,minorMustEqual:c,patchBase:s,patchMustEqual:u,isMinimum:k.hasGreaterEquals,notBefore:d}}function w(k,t,o){let i;typeof k=="string"?i=g(f(k)):i=k;let c;t instanceof Date?c=t.getTime():typeof t=="string"&&(c=new Date(t).getTime());let s;if(typeof o=="string"?s=g(f(o)):s=o,!i||!s)return!1;const u=i.majorBase,d=i.minorBase,P=i.patchBase;let E=s.majorBase,O=s.minorBase,T=s.patchBase;const L=s.notBefore;let R=s.majorMustEqual,M=s.minorMustEqual,B=s.patchMustEqual;return s.isMinimum?u>E?!0:u<E?!1:d>O?!0:d<O||c&&c<L?!1:P>=T:(u===1&&E===0&&(!R||!M||!B)&&(E=1,O=0,T=0,R=!0,M=!1,B=!1),u<E?!1:u>E?!R:d<O?!1:d>O?!M:P<T?!1:P>T?!B:!(c&&c<L))}function l(k,t,o,i,c){const s=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return s.push([r.default.Error,S.localize(0,null)]),s;if(typeof i.name!="string")return s.push([r.default.Error,S.localize(1,null,"name")]),s;if(typeof i.version!="string")return s.push([r.default.Error,S.localize(2,null,"version")]),s;if(!i.engines)return s.push([r.default.Error,S.localize(3,null,"engines")]),s;if(typeof i.engines.vscode!="string")return s.push([r.default.Error,S.localize(4,null,"engines.vscode")]),s;if(typeof i.extensionDependencies<"u"&&!v(i.extensionDependencies))return s.push([r.default.Error,S.localize(5,null,"extensionDependencies")]),s;if(typeof i.activationEvents<"u"){if(!v(i.activationEvents))return s.push([r.default.Error,S.localize(6,null,"activationEvents")]),s;if(typeof i.main>"u"&&typeof i.browser>"u")return s.push([r.default.Error,S.localize(7,null,"activationEvents","main","browser")]),s}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&s.push([r.default.Warning,S.localize(8,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return s.push([r.default.Error,S.localize(9,null,"main")]),s;{const P=(0,n.$gh)(o,i.main);(0,n.$ah)(P,o)||s.push([r.default.Warning,S.localize(10,null,P.path,o.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return s.push([r.default.Error,S.localize(11,null,"browser")]),s;{const P=(0,n.$gh)(o,i.browser);(0,n.$ah)(P,o)||s.push([r.default.Warning,S.localize(12,null,P.path,o.path)])}}if(!D.valid(i.version))return s.push([r.default.Error,S.localize(13,null)]),s;const u=[];if(!p(k,t,i,c,u))for(const P of u)s.push([r.default.Error,P]);if(i.enabledApiProposals?.length){const P=[];if(!$([...i.enabledApiProposals],P))for(const E of P)s.push([r.default.Error,E])}return s}function p(k,t,o,i,c){return i||typeof o.main>"u"&&typeof o.browser>"u"?!0:m(k,t,o.engines.vscode,c)}function y(k,t,o){return k==="*"||m(t,o,k)}function $(k,t){if(k.length===0)return!0;const o=Array.isArray(t)?t:void 0,i=(o?void 0:t)??I.allApiProposals,c=[],s=(0,A.$xn)(k);for(const{proposalName:u,version:d}of s){const P=i[u];P&&d&&P.version!==d&&(P.version?c.push(S.localize(14,null,u,d,P.version)):c.push(S.localize(15,null,u,d)))}return o?.push(...c),c.length===0}function m(k,t,o,i=[]){const c=g(f(o));if(!c)return i.push(S.localize(16,null,o)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return i.push(S.localize(17,null,o)),!1}else if(!c.majorMustEqual)return i.push(S.localize(18,null,o)),!1;return w(k,t,c)?!0:(i.push(S.localize(19,null,k,o)),!1)}function v(k){if(!Array.isArray(k))return!1;for(let t=0,o=k.length;t<o;t++)if(typeof k[t]!="string")return!1;return!0}}),define(oe[248],ae([0,1,2,6]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl=(0,r.$Fi)("remoteSocketFactoryService");class S{constructor(){this.a={}}register(A,I){return this.a[A]??=[],this.a[A].push(I),(0,n.$Uc)(()=>{const b=this.a[A]?.indexOf(I);typeof b=="number"&&b>=0&&this.a[A]?.splice(b,1)})}b(A){return(this.a[A.type]||[]).find(b=>b.supports(A))}connect(A,I,b,a){const h=this.b(A);if(!h)throw new Error(`No socket factory found for ${A}`);return h.connect(A,I,b,a)}}e.$Wl=S}),define(oe[249],ae([0,1,27,49,21,122]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=I,n=Re(n),r=Re(r),D=Re(D);let A;async function I(w=!1){return(A===void 0||w)&&(A=b()),A}async function b(){const w=a();if(w===void 0)return!1;if(w>=22e3){const l=f();if(l)return new Promise(p=>{r.execFile(l,["--status"],y=>p(!y))})}else{const l=g();if(l)try{if((await S.Promises.stat(l)).isFile())return!0}catch{}}return!1}function a(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(w)return parseInt(w[3])}function h(w){const l=process.env.SystemRoot;if(l){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return D.join(l,p?"Sysnative":"System32",w)}}function f(){return h("wsl.exe")}function g(){return h("lxss\\LxssManager.dll")}}),define(oe[55],ae([0,1,17,16,2,189,54,6,5,45]),function(x,e,n,r,S,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=g,e.$8p=w,e.$9p=l,e.$0p=p,e.$$p=y,e.$_p=$,e.$5p=(0,I.$Fi)("requestService");class h{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const o in this.b)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.b[o];this.a=t}return this.a}}class f extends S.$Wc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,D.localize)(0,null),when:b.$rk.isEqualTo((0,b.$ok)(b.LogLevel.Trace)).serialize()})}async c(t,o,i){const c=`${t} #${++this.b}: ${o.url}`;this.a.trace(`${c} - begin`,o.type,new h(o.headers??{}));try{const s=await i();return this.a.trace(`${c} - end`,o.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${c} - error`,o.type,(0,r.$_)(s)),s}}}e.$6p=f;function g(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}function w(k){return k.res.statusCode===204}async function l(k){return w(k)?null:(await(0,n.$1e)(k.stream)).toString()}async function p(k){if(!g(k))throw new Error("Server returned "+k.res.statusCode);return l(k)}async function y(k){if(!g(k))throw new Error("Server returned "+k.res.statusCode);if(w(k))return null;const o=(await(0,n.$1e)(k.stream)).toString();try{return JSON.parse(o)}catch(i){throw i.message+=`:
`+o,i}}function $(k){v(k)}let m;function v(k){const t=a.$qo.as(A.$vo.Configuration),o=m;m={id:"http",order:15,title:(0,D.localize)(1,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(6,null),(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null)],default:"override",description:(0,D.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(12,null),restricted:!0}}},t.updateConfigurations({add:[m],remove:o?[o]:[]})}v(A.ConfigurationScope.APPLICATION)}),define(oe[250],ae([0,1,17,23]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=void 0;class S{constructor(I){this.a=I}listen(I,b){throw new Error("Invalid listen")}call(I,b,a,h=r.CancellationToken.None){switch(b){case"request":return this.a.request(a[0],h).then(async({res:f,stream:g})=>{const w=await(0,n.$1e)(g);return[{statusCode:f.statusCode,headers:f.headers},w]});case"resolveProxy":return this.a.resolveProxy(a[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$_r=S;class D{constructor(I){this.a=I}async request(I,b){const[a,h]=await this.a.call("request",[I],b);return{res:a,stream:(0,n.$3e)(h)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$as=D}),define(oe[251],ae([0,1,252,12]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=D;function S(A,I){return A.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:A.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function D(A,I,b={}){const a=(0,n.parse)(A),h=b.proxyUrl||S(a,I);if(!h)return null;const f=(0,n.parse)(h);if(!/^https?:$/.test(f.protocol||""))return null;const g={host:f.hostname||"",port:(f.port?+f.port:0)||(f.protocol==="https"?443:80),auth:f.auth,rejectUnauthorized:(0,r.$lg)(b.strictSSL)?b.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((w,l)=>{x(["http-proxy-agent"],w,l)}).then(Re)).HttpProxyAgent(h,g):new(await new Promise((w,l)=>{x(["https-proxy-agent"],w,l)}).then(Re)).HttpsProxyAgent(h,g)}}),define(oe[253],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=e.$Hfc=e.$Gfc=void 0,e.$Gfc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Hfc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Ifc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[101],ae([0,1,49,9,190,23,53,16,4,33,117,68,8,143]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=p;let l;async function p($,m,v,k){return v["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.$i?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,f.$Jm)(k)&&!v["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,f.$Jm)(k)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),l||(l=g.Promises.withAsyncBody(async(t,o)=>{const i=new D.$xe;let c=1e4;const s=$.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(c=(0,w.$Km)(s,1,120)*1e3);const u=setTimeout(()=>{i.dispose(!0),o(new Error((0,S.localize)(0,null)))},c);try{t(await y(m,i.token))}catch(d){!(0,I.$6)(d)&&!i.token.isCancellationRequested?o(new Error((0,S.localize)(1,null,(0,A.$qj)(d)))):t({})}finally{clearTimeout(u),i.dispose()}})),l)}async function y($,m){const v=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",v);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",k);const t=(0,a.$2g)().replace(/-/g,"").substr(0,12),o=new RegExp(t+"({.*})"+t),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",i);const c=await(0,h.$zm)(b.OS,i);return $.trace("getUnixShellEnvironment#shell",c),new Promise((s,u)=>{if(m.isCancellationRequested)return u(new I.$7);const d=(0,r.$pc)(c);let P,E;const O="";/^pwsh(-preview)?$/.test(d)?(P=`& '${process.execPath}' ${O} -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,E=["-Login","-Command"]):d==="nu"?(P=`^'${process.execPath}' ${O} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,E=["-i","-l","-c"]):d==="xonsh"?(P=`import os, json; print("${t}", json.dumps(dict(os.environ)), "${t}")`,E=["-i","-l","-c"]):(P=`'${process.execPath}' ${O} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,d==="tcsh"||d==="csh"?E=["-ic"]:E=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),P);const T=(0,n.spawn)(c,[...E,P],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});m.onCancellationRequested(()=>(T.kill(),u(new I.$7))),T.on("error",M=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,A.$qj)(M)),u(M)});const L=[];T.stdout.on("data",M=>L.push(M));const R=[];T.stderr.on("data",M=>R.push(M)),T.on("close",(M,B)=>{const C=Buffer.concat(L).toString("utf8");$.trace("getUnixShellEnvironment#raw",C);const z=Buffer.concat(R).toString("utf8");if(z.trim()&&$.trace("getUnixShellEnvironment#stderr",z),M||B)return u(new Error((0,S.localize)(2,null,M,B)));const ne=o.exec(C),Q=ne?ne[1]:"{}";try{const ce=JSON.parse(Q);v?ce.ELECTRON_RUN_AS_NODE=v:delete ce.ELECTRON_RUN_AS_NODE,k?ce.ELECTRON_NO_ATTACH_CONSOLE=k:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",ce),s(ce)}catch(ce){$.error("getUnixShellEnvironment#errorCaught",(0,A.$qj)(ce)),u(ce)}})})}}),define(oe[254],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(S){try{const D=await this.c();if(D){const A=String(n.a++);return this.b.set(A,D),{id:A,data:D.createNewMessage(S)}}}catch{}return{id:"",data:S}}async validate(S,D){if(!S.id)return!0;const A=this.b.get(S.id);if(!A)return!1;this.b.delete(S.id);try{return A.validate(D)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(S){try{return await this.d(S)}catch{}return S}}e.$tbc=n}),define(oe[102],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl="signService",e.$Yl=(0,n.$Fi)(e.$Xl)}),define(oe[255],ae([0,1,254]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=void 0;class r extends n.$tbc{c(){return this.h().then(D=>new D.validator)}d(D){return this.h().then(A=>new A.signer().sign(D))}h(){return new Promise((D,A)=>x(["vsda"],D,A))}}e.$ygc=r}),define(oe[34],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gR=e.$fR=void 0,e.$fR=(0,n.$Fi)("stateReadService"),e.$gR=(0,n.$Fi)("stateService")}),define(oe[128],ae([0,1,8,17,2,12,38,15,5]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jR=e.$iR=e.$hR=e.SaveStrategy=void 0;var a;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class h extends S.$Wc{constructor(l,p,y,$){super(),this.h=l,this.j=p,this.m=y,this.n=$,this.a=Object.create(null),this.b="",this.c=this.B(new n.$Dh(this.j===a.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(l){l.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(l)}}getItem(l,p){const y=this.a[l];return(0,D.$og)(y)?p:y}setItem(l,p){this.setItems([{key:l,data:p}])}setItems(l){let p=!1;for(const{key:y,data:$}of l)this.a[y]!==$&&((0,D.$og)($)?(0,D.$mg)(this.a[y])||(this.a[y]=void 0,p=!0):(this.a[y]=$,p=!0));p&&this.s()}removeItem(l){(0,D.$mg)(this.a[l])||(this.a[l]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const l=JSON.stringify(this.a,null,4);if(l!==this.b)try{await this.n.writeFile(this.h,r.$Oe.fromString(l),{atomic:{postfix:".vsctmp"}}),this.b=l}catch(p){this.m.error(p)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$hR=h;let f=class extends S.$Wc{constructor(l,p,y,$){super(),this.a=this.B(new h(p.stateResource,l,y,$))}async init(){await this.a.init()}getItem(l,p){return this.a.getItem(l,p)}};e.$iR=f,e.$iR=f=Se([re(1,A.$Mi),re(2,b.$_j),re(3,I.$_k)],f);class g extends f{setItem(l,p){this.a.setItem(l,p)}setItems(l){this.a.setItems(l)}removeItem(l){this.a.removeItem(l)}close(){return this.a.close()}}e.$jR=g}),define(oe[129],ae([0,1,4,36,33]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=A,e.$tp=I;function D(b){if(n.$u===n.Platform.Linux&&/^penguin(\.|$)/i.test(b))return"chromebook"}function A(b,a,h,f,g,w,l,p,y,$){const m=Object.create(null);m["common.machineId"]=w,m["common.sqmId"]=l,m["common.devDeviceId"]=p,m.sessionID=(0,S.$2g)()+Date.now(),m.commitHash=f,m.version=g,m["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,n.$h)(n.$u),m["common.nodePlatform"]=r.$fc,m["common.nodeArch"]=h,m["common.product"]=$||"desktop",y&&(m["common.msftInternal"]=y);let v=0;const k=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-k,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),n.$l&&(m["common.snap"]="true");const t=D(a);return t&&(m["common.platformDetail"]=t),m}function I(b){const a=r.env.USERDNSDOMAIN;if(!a)return!1;const h=a.toLowerCase();return b.some(f=>h===f)}}),define(oe[24],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,n.$Fi)("telemetryService"),e.$_l=(0,n.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var r;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var S;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(oe[256],ae([0,1,27,8,43,13,9,4,66,7,94,21,116,97,15,28,24]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0,e.$Vs=m,e.$Ws=k,e.$Xs=t,n=Re(n);const $=new Map;async function m(i,c){const s=`${i}::${c.join(":")}`,u=$.get(s);if(u)return u;const d=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],P=new Map,E=new Map,O=2e4;function T(R,M,B,C){const z=M.substring(R.length+1);return r.Promises.withAsyncBody(async ne=>{let Q;C.readdirCount++;try{Q=await f.Promises.readdir(M,{withFileTypes:!0})}catch{ne();return}if(C.count>=O){C.count+=Q.length,C.maxReached=!0,ne();return}let ce=Q.length;if(ce===0){ne();return}let K=Q;C.count+Q.length>O&&(C.maxReached=!0,ce=O-C.count,K=Q.slice(0,ce)),C.count+=Q.length;for(const ee of K)if(ee.isDirectory()){if(B.includes(ee.name)||await T(R,(0,A.$lc)(M,ee.name),B,C),--ce===0){ne();return}}else{const H=ee.name.lastIndexOf(".");if(H>=0){const j=ee.name.substring(H+1);j&&P.set(j,(P.get(j)??0)+1)}for(const j of d)j.relativePathPattern?.test(z)!==!1&&j.filePattern.test(ee.name)&&E.set(j.tag,(E.get(j.tag)??0)+1);if(--ce===0){ne();return}}})}const L=r.Promises.withAsyncBody(async R=>{const M={count:0,maxReached:!1,readdirCount:0},B=new b.$ge(!0);await T(i,i,c,M);const C=await t(i);R({configFiles:v(E),fileTypes:v(P),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:C,totalScanTime:B.elapsed(),totalReaddirCount:M.readdirCount})});return $.set(s,L),L}function v(i){return Array.from(i.entries(),([c,s])=>({name:c,count:s})).sort((c,s)=>s.count-c.count)}function k(){const i={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/l.$Hl.GB).toFixed(2)}GB (${(n.freemem()/l.$Hl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.$Rn.value()*100)}%`},c=n.cpus();return c&&c.length>0&&(i.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),i}async function t(i){try{const c=new Map,s=(0,A.$lc)(i,".vscode","launch.json"),u=await f.Promises.readFile(s),d=[],P=(0,S.$Xn)(u.toString(),d);if(d.length)return console.log(`Unable to parse ${s}`),[];if((0,S.$6n)(P)==="object"&&P.configurations)for(const E of P.configurations){const O=E.type;O&&(c.has(O)?c.set(O,c.get(O)+1):c.set(O,1))}return v(c)}catch{return[]}}let o=class{constructor(c,s){this.c=c,this.d=s}f(c){const s=[];return s.push(`OS Version:       ${c.os}`),s.push(`CPUs:             ${c.cpus}`),s.push(`Memory (System):  ${c.memory}`),s.push(`VM:               ${c.vmHint}`),s.join(`
`)}g(c){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const u=n.cpus();return u&&u.length>0&&s.push(`CPUs:             ${u[0].model} (${u.length} x ${u[0].speed})`),s.push(`Memory (System):  ${(n.totalmem()/l.$Hl.GB).toFixed(2)}GB (${(n.freemem()/l.$Hl.GB).toFixed(2)}GB free)`),I.$i||s.push(`Load (avg):       ${n.loadavg().map(d=>Math.round(d)).join(", ")}`),s.push(`VM:               ${Math.round(h.$Rn.value()*100)}%`),s.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${c.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(c,s){return Promise.all([(0,g.$Us)(c.mainPID),this.k(c)]).then(async u=>{let[d,P]=u,E=this.m(c,d);return s.forEach(O=>{if((0,w.$Tm)(O))E+=`
${O.errorMessage}`,P+=`
${O.errorMessage}`;else if(E+=`

Remote: ${O.hostName}`,O.processes&&(E+=`
${this.m(c,O.processes)}`),O.workspaceMetadata){P+=`
|  Remote: ${O.hostName}`;for(const T of Object.keys(O.workspaceMetadata)){const L=O.workspaceMetadata[T];let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),P+=`|    Folder (${T}): ${R}`,P+=this.h(L)}}}),{processInfo:E,workspaceInfo:P}})}async getSystemInfo(c,s){const{memory:u,vmHint:d,os:P,cpus:E}=k(),O={os:P,memory:u,cpus:E,vmHint:d,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:s};return I.$i||(O.load=`${n.loadavg().map(T=>Math.round(T)).join(", ")}`),I.$k&&(O.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(O)}async getDiagnostics(c,s){const u=[];return(0,g.$Us)(c.mainPID).then(async d=>(u.push(""),u.push(this.g(c)),u.push(""),u.push(this.m(c,d)),c.windows.some(P=>P.folderURIs&&P.folderURIs.length>0&&!P.remoteAuthority)&&(u.push(""),u.push("Workspace Stats: "),u.push(await this.k(c))),s.forEach(P=>{if((0,w.$Tm)(P))u.push(`
${P.errorMessage}`);else if(u.push(`

`),u.push(`Remote:           ${P.hostName}`),u.push(this.f(P.machineInfo)),P.processes&&u.push(this.m(c,P.processes)),P.workspaceMetadata)for(const E of Object.keys(P.workspaceMetadata)){const O=P.workspaceMetadata[E];let T=`${O.fileCount} files`;O.maxFilesReached&&(T=`more than ${T}`),u.push(`Folder (${E}): ${T}`),u.push(this.h(O))}}),u.push(""),u.push(""),u.join(`
`)))}h(c){const s=[];let d=0;const P=(L,R)=>{const M=` ${L}(${R})`;d+M.length>60?(s.push(E),E="|                 ",d=E.length):d+=M.length,E+=M};let E="|      File types:";const O=10,T=c.fileTypes.length>O?O:c.fileTypes.length;for(let L=0;L<T;L++){const R=c.fileTypes[L];P(R.name,R.count)}if(s.push(E),c.configFiles.length>=0&&(E="|      Conf files:",d=0,c.configFiles.forEach(L=>{P(L.name,L.count)}),s.push(E)),c.launchConfigFiles.length>0){let L="|      Launch Configs:";c.launchConfigFiles.forEach(R=>{const M=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`;L+=M}),s.push(L)}return s.join(`
`)}j(c){const s=Math.max(...Object.keys(c).map(u=>u.length));return Object.keys(c).map(u=>`${u}:  ${" ".repeat(s-u.length)}  ${c[u]}`).join(`
                  `)}k(c){const s=[],u=[];return c.windows.forEach(d=>{d.folderURIs.length===0||d.remoteAuthority||(s.push(`|  Window (${d.title})`),d.folderURIs.forEach(P=>{const E=a.URI.revive(P);if(E.scheme===D.Schemas.file){const O=E.fsPath;u.push(m(O,["node_modules",".git"]).then(T=>{let L=`${T.fileCount} files`;T.maxFilesReached&&(L=`more than ${L}`),s.push(`|    Folder (${(0,A.$pc)(O)}): ${L}`),s.push(this.h(T))}).catch(T=>{s.push(`|      Error: Unable to collect workspace stats for folder ${O} (${T.toString()})`)}))}else s.push(`|    Folder (${E.toString()}): Workspace stats not available.`)}))}),Promise.all(u).then(d=>s.join(`
`)).catch(d=>`Unable to collect workspace stats: ${d}`)}m(c,s){const u=new Map;c.windows.forEach(P=>u.set(P.pid,`window [${P.id}] (${P.title})`)),c.pidToNames.forEach(({pid:P,name:E})=>u.set(P,E));const d=[];return d.push("CPU %	Mem MB	   PID	Process"),s&&this.n(c.mainPID,u,d,s,0),d.join(`
`)}n(c,s,u,d,P){const E=P===0;let O;E?O=d.pid===c?`${this.d.applicationName} main`:"remote agent":s.has(d.pid)?O=s.get(d.pid):O=`${"  ".repeat(P)} ${d.name}`;const T=process.platform==="win32"?d.mem:n.totalmem()*(d.mem/100);u.push(`${d.load.toFixed(0).padStart(5," ")}	${(T/l.$Hl.MB).toFixed(0).padStart(6," ")}	${d.pid.toFixed(0).padStart(6," ")}	${O}`),Array.isArray(d.children)&&d.children.forEach(L=>this.n(c,s,u,L,P+1))}async getWorkspaceFileExtensions(c){const s=new Set;for(const{uri:u}of c.folders){const d=a.URI.revive(u);if(d.scheme!==D.Schemas.file)continue;const P=d.fsPath;try{(await m(P,["node_modules",".git"])).fileTypes.forEach(O=>s.add(O.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(c){for(const{uri:s}of c.folders){const u=a.URI.revive(s);if(u.scheme!==D.Schemas.file)continue;const d=u.fsPath;try{const P=await m(d,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),P.fileTypes.forEach(E=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:E.name,count:E.count})}),P.launchConfigFiles.forEach(E=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:E.name,count:E.count})}),P.configFiles.forEach(E=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:E.name,count:E.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:P.totalScanTime,reachedLimit:P.maxFilesReached,fileCount:P.fileCount,readdirCount:P.totalReaddirCount})}catch{}}}};e.$Ys=o,e.$Ys=o=Se([re(0,y.$$l),re(1,p.$sk)],o)}),define(oe[257],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=e.$Lfc=void 0;class n{constructor(D){this.b=D}listen(D,A){throw new Error(`Event not found: ${A}`)}call(D,A,{eventName:I,data:b}){return this.b.forEach(a=>a.log(I,b)),Promise.resolve(null)}}e.$Lfc=n;class r{constructor(D){this.b=D}log(D,A){return this.b.call("log",{eventName:D,data:A}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Mfc=r}),define(oe[56],ae([0,1,35,12,72,129,24]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=h,e.$Cp=f,e.$Dp=g,e.$Ep=w,e.$Fp=p,e.$Gp=$,e.$Hp=m,e.$Ip=t;class I{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$up=I;class b{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=b,e.$wp=new b;class a{async publicLog(i,c,s){}async publicLogError(i,c,s){}}e.$xp=a,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function h(o,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!o.enableTelemetry)}function f(o,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function g(o){const i=o.getValue(A.$hm),c=o.getValue(A.$im);if(o.getValue(A.$jm)===!1||c===!1)return A.TelemetryLevel.NONE;switch(i??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function w(o){const i={},c={},s={};y(o,s);for(let u in s){u=u.length>150?u.substr(u.length-149):u;const d=s[u];typeof d=="number"?c[u]=d:typeof d=="boolean"?c[u]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${d.length}`),i[u]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(i[u]=d)}return{properties:i,measurements:c}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(o){if(!o)return"none";const i=(0,S.$hn)(o);return l.has(i)?i:"other"}function y(o,i,c=0,s){if(o)for(const u of Object.getOwnPropertyNames(o)){const d=o[u],P=s?s+u:u;Array.isArray(d)?i[P]=(0,n.$io)(d):d instanceof Date?i[P]=d.toISOString():(0,r.$hg)(d)?c<2?y(d,i,c+1,P+"."):i[P]=(0,n.$io)(d):i[P]=d}}function $(o,i){const c=o.msftInternalDomains||[],s=i.getValue("telemetry.internalTesting");return(0,D.$tp)(c)||s}function m(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function v(o,i){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let c=o;const s=[];for(const E of i)for(;;){const O=E.exec(o);if(!O)break;s.push([O.index,E.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(c="";;){const E=d.exec(o);if(!E)break;const O=s.some(([T,L])=>E.index<L&&T<d.lastIndex);!u.test(E[0])&&!O&&(c+=o.substring(P,E.index)+"<REDACTED: user-file-path>",P=d.lastIndex)}return P<o.length&&(c+=o.substr(P)),c}function k(o){if(!o)return o;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of i)if(c.regex.test(o))return`<REDACTED: ${c.label}>`;return o}function t(o,i){return(0,n.$fo)(o,c=>{if(c instanceof I||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let s=c.replaceAll("%20"," ");s=v(s,i);for(const u of i)s=s.replace(u,"");return s=k(s),s}})}}),define(oe[130],ae([0,1,26,127,86,4,7,16,36,56]),function(x,e,n,r,S,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=h,e.$Lp=l,e.$Mp=p,e.$Np=y,e.$Op=$,e.$Pp=m,e.$Qp=v,e.$Rp=k,e.$Tp=t,e.$Up=i;function h(c,s){return c.uuid&&s.uuid?c.uuid===s.uuid:c.id===s.id?!0:(0,n.$Bf)(c.id,s.id)===0}const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(s){const u=s.manifest?s.manifest.version:s.version,d=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new g(s.identifier,u,d)}static parse(s){const u=f.exec(s);return u&&u[1]&&u[2]?new g({id:u[1]},u[2],u[4]||void 0):null}constructor(s,u,d=S.TargetPlatform.UNDEFINED){this.identifier=s,this.version=u,this.targetPlatform=d,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==S.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof g?h(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Kp=g;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(c){const s=w.exec(c);return s&&s[1]?[y(s[1]),s[2]]:[y(c),void 0]}function p(c,s){return`${c}.${s}`}function y(c){return c.toLowerCase()}function $(c,s){return y(p(c??S.$mn,s))}function m(c,s){const u=[],d=P=>{for(const E of u)if(E.some(O=>h(s(O),s(P))))return E;return null};for(const P of c){const E=d(P);E?E.push(P):u.push([P])}return u}function v(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function k(c){return{id:new a.$up(c.identifier.id),name:new a.$up(c.name),version:c.version,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$Sp=new S.$qn("pprice.better-merge");function t(c,s){const u=[],d=s.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const P=d.shift();if(P&&u.every(E=>!h(E.identifier,{id:P}))){const E=c.filter(O=>h(O.identifier,{id:P}));E.length===1&&(u.push(E[0]),d.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}async function o(c,s){if(!D.$k)return!1;let u;try{u=(await c.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await c.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(P){s.debug("Error while getting the os-release file.",(0,I.$_)(P))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(c,s){const u=await o(c,s),d=(0,r.$ep)(u?"alpine":D.$u,b.$gc);return s.debug("ComputeTargetPlatform:",d),d}});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[258],ae([0,1,2,35,4,26,191,18,54,84,28,45,24,56]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,a=et(a);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,m,v){this.k=m,this.l=v,this.d={},this.i=new n.$Vc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=g.TelemetryLevel.USAGE,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,D.$if)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$if)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration(g.$hm)||k.affectsConfiguration(g.$jm)||k.affectsConfiguration(g.$im))&&this.m()}))}setExperimentProperty($,m){this.d[$]=m}m(){let $=(0,w.$Dp)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const v=m.usage?g.TelemetryLevel.USAGE:m.error?g.TelemetryLevel.ERROR:g.TelemetryLevel.NONE;$=Math.min($,v)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,m,v){this.g<m||(v=(0,r.$go)(v,this.d),v=(0,w.$Ip)(v,this.j),v=(0,r.$go)(v,this.c),this.b.forEach(k=>k.log($,v)))}publicLog($,m){this.n($,g.TelemetryLevel.USAGE,m)}publicLog2($,m){this.publicLog($,m)}publicLogError($,m){this.h&&this.n($,g.TelemetryLevel.ERROR,m)}publicLogError2($,m){this.publicLogError($,m)}};e.$es=l,e.$es=l=Se([re(1,I.$_i),re(2,h.$sk)],l);function p(){const y=(0,A.localize)(0,null,a.default.nameLong),$=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=S.$o?"":(0,A.localize)(3,null),v=(0,A.localize)(4,null),k=(0,A.localize)(5,null),t=(0,A.localize)(6,null),o=(0,A.localize)(7,null),i=`
|       | ${v} | ${k} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,c=(0,A.localize)(8,null);return`
${y} ${$} ${m}

&nbsp;

${o}
${i}

&nbsp;

${c}
`}f.$qo.as(b.$vo.Configuration).registerConfiguration({id:g.$gm,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[g.$hm]:{type:"string",enum:[g.TelemetryConfiguration.ON,g.TelemetryConfiguration.ERROR,g.TelemetryConfiguration.CRASH,g.TelemetryConfiguration.OFF],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:p(),default:g.TelemetryConfiguration.ON,restricted:!0,scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),f.$qo.as(b.$vo.Configuration).registerConfiguration({id:g.$gm,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[g.$jm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${g.$hm}#\``),scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[259],ae([0,1,4,94,24]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=D,e.$cgc=A,e.$dgc=I;async function D(b,a){let h=b.getItem(S.$dm);return(typeof h!="string"||n.$j&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,r.$Sn)(a.error.bind(a))),h}async function A(b,a){let h=b.getItem(S.$em);return typeof h!="string"&&(h=await(0,r.$Tn)(a.error.bind(a))),h}async function I(b,a){let h=b.getItem(S.$fm);return typeof h!="string"&&(h=await(0,r.$Un)(a.error.bind(a))),h}}),define(oe[260],ae([0,1,24,259]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=S,e.$fgc=D,e.$ggc=A;async function S(I,b){const a=await(0,r.$bgc)(I,b);return I.setItem(n.$dm,a),a}async function D(I,b){const a=await(0,r.$cgc)(I,b);return I.setItem(n.$em,a),a}async function A(I,b){const a=await(0,r.$dgc)(I,b);return I.setItem(n.$fm,a),a}}),define(oe[131],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(oe[261],ae([0,1,4,131]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0;const S=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(h){this.collections=h,this.a=new Map,this.b=new Map,h.forEach((f,g)=>{this.d(f,g);const w=f.map.entries();let l=w.next();for(;!l.done;){const p=l.value[1],y=l.value[0];let $=this.a.get(y);if($||($=[],this.a.set(y,$)),$.length>0&&$[0].type===r.EnvironmentVariableMutatorType.Replace){l=w.next();continue}const m={extensionIdentifier:g,value:p.value,type:p.type,scope:p.scope,variable:p.variable,options:p.options};m.scope||delete m.scope,$.unshift(m),l=w.next()}})}async applyToProcessEnvironment(h,f,g){let w;n.$i&&(w={},Object.keys(h).forEach(l=>w[l.toLowerCase()]=l));for(const[l,p]of this.getVariableMap(f)){const y=n.$i&&w[l.toLowerCase()]||l;for(const $ of p){const m=g?await g($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case r.EnvironmentVariableMutatorType.Append:h[y]=(h[y]||"")+m;break;case r.EnvironmentVariableMutatorType.Prepend:h[y]=m+(h[y]||"");break;case r.EnvironmentVariableMutatorType.Replace:h[y]=m;break}if($.options?.applyAtShellIntegration??!1){const v=`VSCODE_ENV_${S.get($.type)}`;h[v]=(h[v]?h[v]+":":"")+l+"="+this.c(m)}}}}c(h){return h.replaceAll(":","\\x3a")}diff(h,f){const g=new Map,w=new Map,l=new Map;if(h.getVariableMap(f).forEach((p,y)=>{const $=this.getVariableMap(f).get(y),m=I(p,$);m&&g.set(y,m)}),this.getVariableMap(f).forEach((p,y)=>{const $=h.getVariableMap(f).get(y),m=I(p,$);m&&l.set(y,m)}),this.getVariableMap(f).forEach((p,y)=>{const $=h.getVariableMap(f).get(y),m=b(p,$);m&&w.set(y,m)}),!(g.size===0&&w.size===0&&l.size===0))return{added:g,changed:w,removed:l}}getVariableMap(h){const f=new Map;for(const g of this.a.values()){const w=g.filter(l=>A(l,h));w.length>0&&f.set(w[0].variable,w)}return f}getDescriptionMap(h){const f=new Map;for(const g of this.b.values()){const w=g.filter(l=>A(l,h,!0));for(const l of w)f.set(l.extensionIdentifier,l.description)}return f}d(h,f){if(!h.descriptionMap)return;const g=h.descriptionMap.entries();let w=g.next();for(;!w.done;){const l=w.value[1],p=w.value[0];let y=this.b.get(p);y||(y=[],this.b.set(p,y));const $={extensionIdentifier:f,scope:l.scope,description:l.description};$.scope||delete $.scope,y.push($),w=g.next()}}}e.$Is=D;function A(a,h,f=!1){return a.scope?!!(a.scope.workspaceFolder&&h?.workspaceFolder&&a.scope.workspaceFolder.index===h.workspaceFolder.index):f?h===a.scope:!0}function I(a,h){if(!h)return a;const f=new Set;h.forEach(w=>f.add(w.extensionIdentifier));const g=[];return a.forEach(w=>{f.has(w.extensionIdentifier)||g.push(w)}),g.length===0?void 0:g}function b(a,h){if(!h)return;const f=new Map;h.forEach(w=>f.set(w.extensionIdentifier,w));const g=[];return a.forEach(w=>{const l=f.get(w.extensionIdentifier);l&&(w.type!==l.type||w.value!==l.value||w.scope?.workspaceFolder?.index!==l.scope?.workspaceFolder?.index)&&g.push(l)}),g.length===0?void 0:g}}),define(oe[262],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=n,e.$Ds=r,e.$Es=S,e.$Fs=D,e.$Gs=A,e.$Hs=I;function n(b){return[...b.entries()]}function r(b){return b?[...b.entries()]:[]}function S(b){return new Map(b)}function D(b){return new Map(b??[])}function A(b){return Array.from(b.entries()).map(a=>[a[0],n(a[1].map),r(a[1].descriptionMap)])}function I(b){return new Map(b.map(a=>[a[0],{map:S(a[1]),descriptionMap:D(a[2])}]))}}),define(oe[263],ae([0,1,8,23,3,2,5]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=void 0;let I=class extends D.$Wc{constructor(a,h){super(),this.h=h,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$me),this.onCreateRequest=this.g.event,this.b=a===void 0?15e3:a,this.B((0,D.$Uc)(()=>{for(const f of this.f.values())(0,D.$Rc)(f)}))}createRequest(a){return new Promise((h,f)=>{const g=++this.a;this.c.set(g,h),this.g.fire({requestId:g,...a});const w=new r.$xe;(0,n.$Gh)(this.b,w.token).then(()=>f(`Request ${g} timed out (${this.b}ms)`)),this.f.set(g,[(0,D.$Uc)(()=>w.cancel())])})}acceptReply(a,h){const f=this.c.get(a);f?(this.c.delete(a),(0,D.$Rc)(this.f.get(a)||[]),this.f.delete(a),f(h)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.$ts=I,e.$ts=I=Se([re(1,A.$_j)],I)}),define(oe[73],ae([0,1,6,123,45]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ms=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ls=void 0,e.$ls=new r.$Wj("terminalTabFocusMode",!1,!0);var D;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var I;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(I||(e.PosixShellType=I={}));var b;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(b||(e.WindowsShellType=b={}));var a;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var h;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(h||(e.TerminalIpcChannels=h={}));var f;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(f||(e.ProcessPropertyType=f={})),e.$ms=(0,n.$Fi)("ptyService");var g;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(g||(e.HeartbeatConstants=g={}));var w;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var l;(function(t){t.TerminalView="view",t.Editor="editor"})(l||(e.TerminalLocationString=l={}));var p;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(p||(e.LocalReconnectConstants=p={}));var y;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(y||(e.FlowControlConstants=y={}));var $;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var m;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(m||(e.ShellIntegrationStatus=m={}));var v;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(v||(e.TerminalExitReason=v={})),e.$ns={Backend:"workbench.contributions.terminal.processBackend"};class k{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(o){const i=this.b(o.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,o)}getTerminalBackend(o){return this.a.get(this.b(o))}b(o){return o?.toLowerCase()??""}}S.$qo.add(e.$ns.Backend,new k),e.$os=(0,n.$Fi)("localPtyService"),e.$ps=(0,n.$Fi)("terminalLogService")}),define(oe[264],ae([0,1,78,7,193,111]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=A,e.$vs=a,e.$ws=h,e.$xs=f;function A(g,w){const l=[{name:null,description:(0,S.localize)(0,null)}];return l.push(...g.map(p=>({name:p.profileName,description:I(p)}))),w&&l.push(...w.map(p=>({name:p.title,description:b(p)}))),{values:l.map(p=>p.name),markdownDescriptions:l.map(p=>p.description)}}function I(g){let w=`$(${D.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:n.$5j.terminal.id}) ${g.profileName}
- path: ${g.path}`;return g.args&&(typeof g.args=="string"?w+=`
- args: "${g.args}"`:w+=`
- args: [${g.args.length===0?"":`'${g.args.join("','")}'`}]`),g.overrideName!==void 0&&(w+=`
- overrideName: ${g.overrideName}`),g.color&&(w+=`
- color: ${g.color}`),g.env&&(w+=`
- env: ${JSON.stringify(g.env)}`),w}function b(g){return`$(${D.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:n.$5j.terminal.id}) ${g.title}
- extensionIdentifier: ${g.extensionIdentifier}`}function a(g,w){if(!g&&!w)return!0;if(typeof g=="string"&&typeof w=="string")return g===w;if(Array.isArray(g)&&Array.isArray(w)){if(g.length!==w.length)return!1;for(let l=0;l<g.length;l++)if(g[l]!==w[l])return!1;return!0}return!1}function h(g,w){if(!g&&!w)return!0;if(!g||!w)return!1;if(D.ThemeIcon.isThemeIcon(g)&&D.ThemeIcon.isThemeIcon(w))return g.id===w.id&&g.color===w.color;if(typeof g=="object"&&"light"in g&&"dark"in g&&typeof w=="object"&&"light"in w&&"dark"in w){const l=g,p=w;if((r.URI.isUri(l.light)||f(l.light))&&(r.URI.isUri(l.dark)||f(l.dark))&&(r.URI.isUri(p.light)||f(p.light))&&(r.URI.isUri(p.dark)||f(p.dark)))return l.light.path===p.light.path&&l.dark.path===p.dark.path}if(r.URI.isUri(g)&&r.URI.isUri(w)||f(g)||f(w)){const l=g,p=w;return l.path===p.path&&l.scheme===p.scheme}return!1}function f(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}}),define(oe[265],ae([0,1,78,4,192,54,45,73,264]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=e.$ys=void 0,e.$As=l,e.$Bs=y,e.$ys={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$zs={type:"string",enum:Array.from((0,n.$3j)(),$=>$.id),markdownEnumDescriptions:Array.from((0,n.$3j)(),$=>`$(${$.id})`)};const a={args:{description:(0,S.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,S.localize)(1,null),type:"boolean"},icon:{description:(0,S.localize)(2,null),...e.$zs},color:{description:(0,S.localize)(3,null),...e.$ys},env:{markdownDescription:(0,S.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},h={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(5,null),type:["string","array"],items:{type:"string"}},...a}},f={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(6,null),type:["string"],items:{type:"string"}},...a}};function g($){const m=$===r.Platform.Linux?"linux":$===r.Platform.Mac?"osx":"windows";return(0,S.localize)(7,null,(0,r.$h)($),'```json\n"terminal.integrated.profile.'+m+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,S.localize)(8,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,S.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,S.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,S.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},f],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:g(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,S.localize)(12,null),enum:["PowerShell","Git Bash"]},...a}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(13,null),type:"string"},id:{description:(0,S.localize)(14,null),type:"string"},title:{description:(0,S.localize)(15,null),type:"string"},...a}},{type:"null"},h]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:g(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(16,null),type:"string"},id:{description:(0,S.localize)(17,null),type:"string"},title:{description:(0,S.localize)(18,null),type:"string"},...a}},{type:"null"},h]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:g(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(19,null),type:"string"},id:{description:(0,S.localize)(20,null),type:"string"},title:{description:(0,S.localize)(21,null),type:"string"},...a}},{type:"null"},h]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,S.localize)(22,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:D.ConfigurationScope.APPLICATION,description:(0,S.localize)(23,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:D.ConfigurationScope.APPLICATION,markdownDescription:(0,S.localize)(24,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:D.ConfigurationScope.APPLICATION,description:(0,S.localize)(25,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,S.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){A.$qo.as(D.$vo.Configuration).registerConfiguration(w),y()}let p;function y($,m){const v=A.$qo.as(D.$vo.Configuration);let k;$&&(k=(0,b.$us)($?.profiles,m));const t=p;p={id:"terminal",order:100,title:(0,S.localize)(27,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,S.localize)(28,null),type:["string","null"],default:null,enum:$?.os===r.OperatingSystem.Linux?k?.values:void 0,markdownEnumDescriptions:$?.os===r.OperatingSystem.Linux?k?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,S.localize)(29,null),type:["string","null"],default:null,enum:$?.os===r.OperatingSystem.Macintosh?k?.values:void 0,markdownEnumDescriptions:$?.os===r.OperatingSystem.Macintosh?k?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,S.localize)(30,null),type:["string","null"],default:null,enum:$?.os===r.OperatingSystem.Windows?k?.values:void 0,markdownEnumDescriptions:$?.os===r.OperatingSystem.Windows?k?.markdownDescriptions:void 0}}},v.updateConfigurations({add:[p],remove:t?[t]:[]})}}),define(oe[266],ae([0,1,27,13,35,9,4,36,26,12,21,131,262,261]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=l,e.$Ks=p,e.$Ls=y,n=Re(n),D=Re(D),I=Re(I),h=Re(h);function l(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let P=0;return d&&d.length===4&&(P=parseInt(d[3])),P}async function p(d,P,E,O=I.env,T=h.Promises.exists){if(D.$kc(d))return await T(d)?d:void 0;if(P===void 0&&(P=I.cwd()),D.$oc(d)!=="."){const B=D.$lc(P,d);return await T(B)?B:void 0}const R=(0,S.$ko)(O,"PATH");if(E===void 0&&(0,a.$fg)(R)&&(E=R.split(D.$vc)),E===void 0||E.length===0){const B=D.$lc(P,d);return await T(B)?B:void 0}for(const B of E){let C;if(D.$kc(B)?C=D.$lc(B,d):C=D.$lc(P,B,d),await T(C))return C;if(A.$i){let z=C+".com";if(await T(z)||(z=C+".exe",await T(z)))return z}}const M=D.$lc(P,d);return await T(M)?M:void 0}function y(d,P,E,O,T){const L=A.$i&&(!P.windowsEnableConpty||l()<18309);if(!P.shellIntegration.enabled||!d.executable||d.isFeatureTerminal&&!d.forceShellIntegration||d.ignoreShellIntegration||L)return;const R=d.args,M=I.$fc==="win32"?D.$pc(d.executable).toLowerCase():D.$pc(d.executable),B=D.$oc(r.$Zg.asFileUri("").fsPath);let C;const z={VSCODE_INJECTION:"1"};if(P.shellIntegration.nonce&&(z.VSCODE_NONCE=P.shellIntegration.nonce),A.$i){if(M==="pwsh.exe"||M==="powershell.exe")return!R||s(R)?C=v.get(m.WindowsPwsh):c(R)&&(C=v.get(m.WindowsPwshLogin)),C?(C=[...C],C[C.length-1]=(0,b.$ef)(C[C.length-1],B,""),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",P.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),{newArgs:C,envMixin:z}):void 0;if(M==="bash.exe")return!R||R.length===0?C=v.get(m.Bash):u(R)&&(z.VSCODE_SHELL_LOGIN="1",$(P,z),C=v.get(m.Bash)),C?(C=[...C],C[C.length-1]=(0,b.$ef)(C[C.length-1],B),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:C,envMixin:z}):void 0;O.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args);return}switch(M){case"bash":return!R||R.length===0?C=v.get(m.Bash):u(R)&&(z.VSCODE_SHELL_LOGIN="1",$(P,z),C=v.get(m.Bash)),C?(C=[...C],C[C.length-1]=(0,b.$ef)(C[C.length-1],B),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:C,envMixin:z}):void 0;case"fish":{const ne=E?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Q=D.$lc(B,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${ne}:${Q}`,$(P,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!R||s(R)?C=v.get(m.Pwsh):c(R)&&(C=v.get(m.PwshLogin)),C?(P.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),C=[...C],C[C.length-1]=(0,b.$ef)(C[C.length-1],B,""),z.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:C,envMixin:z}):void 0;case"zsh":{if(!R||R.length===0?C=v.get(m.Zsh):u(R)?(C=v.get(m.ZshLogin),$(P,z)):(R===v.get(m.Zsh)||R===v.get(m.ZshLogin))&&(C=R),!C)return;C=[...C],C[C.length-1]=(0,b.$ef)(C[C.length-1],B);let ne;try{ne=n.userInfo().username}catch{ne="unknown"}const Q=D.$lc(n.tmpdir(),`${ne}-${T.applicationName}-zsh`);z.ZDOTDIR=Q;const ce=E?.ZDOTDIR??n.homedir()??"~";z.USER_ZDOTDIR=ce;const K=[];return K.push({source:D.$lc(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$lc(Q,".zshrc")}),K.push({source:D.$lc(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$lc(Q,".zprofile")}),K.push({source:D.$lc(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$lc(Q,".zshenv")}),K.push({source:D.$lc(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$lc(Q,".zlogin")}),{newArgs:C,envMixin:z,filesToCopy:K}}}O.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args)}function $(d,P){if(A.$j&&d.environmentVariableCollections){const E=(0,g.$Hs)(d.environmentVariableCollections),T=new w.$Is(E).getVariableMap({workspaceFolder:d.workspaceFolder}).get("PATH"),L=[];if(T)for(const R of T)R.type===f.EnvironmentVariableMutatorType.Prepend&&L.push(R.value);L.length>0&&(P.VSCODE_PATH_PREFIX=L.join(""))}}var m;(function(d){d.WindowsPwsh="windows-pwsh",d.WindowsPwshLogin="windows-pwsh-login",d.Pwsh="pwsh",d.PwshLogin="pwsh-login",d.Zsh="zsh",d.ZshLogin="zsh-login",d.Bash="bash"})(m||(m={}));const v=new Map;v.set(m.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(m.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(m.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),v.set(m.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),v.set(m.Zsh,["-i"]),v.set(m.ZshLogin,["-il"]),v.set(m.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],t=["--login","-l"],o=["-i","--interactive"],i=["-nol","-nologo"];function c(d){return typeof d=="string"?k.includes(d.toLowerCase()):d.length===1&&k.includes(d[0].toLowerCase())||d.length===2&&(k.includes(d[0].toLowerCase())||k.includes(d[1].toLowerCase()))&&(i.includes(d[0].toLowerCase())||i.includes(d[1].toLowerCase()))}function s(d){return typeof d=="string"?i.includes(d.toLowerCase()):d.length===0||d?.length===1&&i.includes(d[0].toLowerCase())}function u(d){return typeof d!="string"&&(d=d.filter(P=>!o.includes(P.toLowerCase()))),d==="string"&&t.includes(d.toLowerCase())||typeof d!="string"&&d.length===1&&t.includes(d[0].toLowerCase())}}),define(oe[267],ae([0,1,49,78,9,4,12,21,115,73,266,122]),function(x,e,n,r,S,D,A,I,b,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=p,n=Re(n),I=Re(I);var g;(function(P){P.UnixShellsPath="/etc/shells"})(g||(g={}));let w,l=!0;function p(P,E,O,T,L=process.env,R,M,B,C){return R=R||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},D.$i?y(O,R,L,M,T.getValue(a.TerminalSettingId.UseWslProfiles)!==!1,P&&typeof P=="object"?{...P}:T.getValue(a.TerminalSettingId.ProfilesWindows),typeof E=="string"?E:T.getValue(a.TerminalSettingId.DefaultProfileWindows),C,B):s(R,M,O,P&&typeof P=="object"?{...P}:T.getValue(D.$k?a.TerminalSettingId.ProfilesLinux:a.TerminalSettingId.ProfilesMacOs),typeof E=="string"?E:T.getValue(D.$k?a.TerminalSettingId.DefaultProfileLinux:a.TerminalSettingId.DefaultProfileMacOs),C,B,L)}async function y(P,E,O,T,L,R,M,B,C){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ne=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let Q=!1;(0,h.$Js)()>=16299&&(Q=!0),await k(B);const ce=new Map;if(P){ce.set("PowerShell",{source:a.ProfileSource.Pwsh,icon:r.$5j.terminalPowershell,isAutoDetected:!0}),ce.set("Windows PowerShell",{path:`${ne}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:r.$5j.terminalPowershell,isAutoDetected:!0}),ce.set("Git Bash",{source:a.ProfileSource.GitBash,isAutoDetected:!0}),ce.set("Command Prompt",{path:`${ne}\\cmd.exe`,icon:r.$5j.terminalCmd,isAutoDetected:!0}),ce.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ce.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:r.$5j.terminalBash,isAutoDetected:!0});const ee=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ce.set("Cmder",{path:`${ne}\\cmd.exe`,args:["/K",ee],requiresPath:process.env.CMDER_ROOT?ee:{path:ee,isUnsafe:!0},isAutoDetected:!0})}u(R,ce);const K=await $(ce.entries(),M,E,O,T,C);if(P&&L)try{const ee=await i(`${ne}\\${Q?"wsl":"bash"}.exe`,M);for(const H of ee)(!R||!(H.profileName in R))&&K.push(H)}catch{l&&(T?.trace("WSL is not installed, so could not detect WSL profiles"),l=!1)}return K}async function $(P,E,O,T=process.env,L,R){const M=[];for(const[B,C]of P)M.push(m(B,C,E,O,T,L,R));return(await Promise.all(M)).filter(B=>!!B)}async function m(P,E,O,T,L=process.env,R,M){if(E===null)return;let B,C,z;if("source"in E&&!("path"in E)){const K=w?.get(E.source);if(!K)return;B=K.paths,C=E.args||K.args,E.icon?z=v(E.icon):K.icon&&(z=K.icon)}else B=Array.isArray(E.path)?E.path:[E.path],C=D.$i||Array.isArray(E.args)?E.args:void 0,z=v(E.icon);let ne;if(M){const K=B.map(H=>typeof H=="string"?H:H.path),ee=await M(K);ne=new Array(B.length);for(let H=0;H<B.length;H++)typeof B[H]=="string"?ne[H]=ee[H]:ne[H]={path:ee[H],isUnsafe:!0}}else ne=B.slice();let Q;if(E.requiresPath){let K;if((0,A.$fg)(E.requiresPath)?K=E.requiresPath:(K=E.requiresPath.path,E.requiresPath.isUnsafe&&(Q=K)),!await T.existsFile(K))return}const ce=await d(P,O,ne,T,L,C,E.env,E.overrideName,E.isAutoDetected,Q);if(!ce){R?.debug("Terminal profile not validated",P,B);return}return ce.isAutoDetected=E.isAutoDetected,ce.icon=z,ce.color=E.color,ce}function v(P){return typeof P=="string"?{id:P}:P}async function k(P){if(w&&!P)return;const[E,O]=await Promise.all([t(),P||o()]);w=new Map,w.set(a.ProfileSource.GitBash,{profileName:"Git Bash",paths:E,args:["--login","-i"]}),w.set(a.ProfileSource.Pwsh,{profileName:"PowerShell",paths:O,icon:r.$5j.terminalPowershell})}async function t(){const P=new Set,E=await(0,h.$Ks)("git.exe");if(E){const L=(0,f.dirname)(E);P.add((0,f.resolve)(L,"../.."))}function O(L,R){R&&L.add(R)}O(P,process.env.ProgramW6432),O(P,process.env.ProgramFiles),O(P,process.env["ProgramFiles(X86)"]),O(P,`${process.env.LocalAppData}\\Program`);const T=[];for(const L of P)T.push(`${L}\\Git\\bin\\bash.exe`,`${L}\\Git\\usr\\bin\\bash.exe`,`${L}\\usr\\bin\\bash.exe`);return T.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),T.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),T}async function o(){const P=[];for await(const E of(0,b.$vm)())P.push(E.exePath);return P}async function i(P,E){const O=[],T=await new Promise((M,B)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(C,z)=>{if(C)return B("Problem occurred when getting wsl distros");M(z)})});if(!T)return[];const L=new RegExp(/[\r?\n]/),R=T.split(L).filter(M=>M.trim().length>0&&M!=="");for(const M of R){if(M===""||M.startsWith("docker-desktop"))continue;const B=`${M} (WSL)`,C={profileName:B,path:P,args:["-d",`${M}`],isDefault:B===E,icon:c(M),isAutoDetected:!1};O.push(C)}return O}function c(P){return P.includes("Ubuntu")?r.$5j.terminalUbuntu:P.includes("Debian")?r.$5j.terminalDebian:r.$5j.terminalLinux}async function s(P,E,O,T,L,R,M,B){const C=new Map;if(O&&await P.existsFile(g.UnixShellsPath)){const z=(await P.readFile(g.UnixShellsPath)).toString(),ne=(R||z.split(`
`)).map(ce=>{const K=ce.indexOf("#");return K===-1?ce:ce.substring(0,K)}).filter(ce=>ce.trim().length>0),Q=new Map;for(const ce of ne){let K=(0,S.$pc)(ce),ee=Q.get(K)||0;ee++,ee>1&&(K=`${K} (${ee})`),Q.set(K,ee),C.set(K,{path:ce,isAutoDetected:!0})}}return u(T,C),await $(C.entries(),L,P,B,E,M)}function u(P,E){if(P)for(const[O,T]of Object.entries(P))T===null||typeof T!="object"||!("path"in T)&&!("source"in T)?E.delete(O):(T.icon=T.icon||E.get(O)?.icon,E.set(O,T))}async function d(P,E,O,T,L,R,M,B,C,z){if(O.length===0)return Promise.resolve(void 0);const ne=O.shift();if(ne==="")return d(P,E,O,T,L,R,M,B,C);const Q=typeof ne!="string"&&ne.isUnsafe,ce=typeof ne=="string"?ne:ne.path,K={profileName:P,path:ce,args:R,env:M,overrideName:B,isAutoDetected:C,isDefault:P===E,isUnsafePath:Q,requiresUnsafePath:z};if((0,S.$pc)(ce)===ce){const H=L.PATH?L.PATH.split(S.$vc):void 0,j=await(0,h.$Ks)(ce,void 0,H,void 0,T.existsFile);return j?(K.path=j,K.isFromPath=!0,K):d(P,E,O,T,L,R)}return await T.existsFile((0,S.$jc)(ce))?K:d(P,E,O,T,L,R,M,B,C)}}),define(oe[268],ae([0,1,3,2,4,44,18,5,230,101,263,73,265,267,117,66]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0;var y;(function(m){m[m.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let $=class extends r.$Wc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(v,k,t,o){super(),this.M=v,this.N=k,this.O=t,this.P=o,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$me),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$me),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$me),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$me),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$me),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$me),this.onProcessData=this.D.event,this.F=this.B(new n.$me),this.onProcessReady=this.F.event,this.G=this.B(new n.$me),this.onProcessReplay=this.G.event,this.H=this.B(new n.$me),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$me),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$me),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$me),this.onProcessExit=this.L.event,(0,g.$As)(),this.B(this.M),this.B((0,r.$Uc)(()=>this.W())),this.j=this.B(new h.$ts(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(n.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(f.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(S.$i)return process.env;try{return await(0,a.$Qm)(this.N,this.O,{_:[]},process.env)}catch(v){return this.O.error("ptyHost was unable to resolve shell environment",v),{}}}U(){const v=this.M.start(),k=v.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService(k.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(v.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=y.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const o=D.ProxyChannel.toService(k.getChannel(f.TerminalIpcChannels.PtyHost));return this.B(o.onProcessData(i=>this.D.fire(i))),this.B(o.onProcessReady(i=>this.F.fire(i))),this.B(o.onProcessExit(i=>this.L.fire(i))),this.B(o.onDidChangeProperty(i=>this.J.fire(i))),this.B(o.onProcessReplay(i=>this.G.fire(i))),this.B(o.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(o.onDidRequestDetach(i=>this.I.fire(i))),this.B(new b.$ss(this.P,k.getChannel(f.TerminalIpcChannels.Logger))),this.a=v,this.b=o,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration(f.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[v,o]}async createProcess(v,k,t,o,i,c,s,u,d,P,E){const O=setTimeout(()=>this.$(),f.HeartbeatConstants.CreateProcessTimeout),T=await this.f.createProcess(v,k,t,o,i,c,s,u,d,P,E);return clearTimeout(O),T}updateTitle(v,k,t){return this.f.updateTitle(v,k,t)}updateIcon(v,k,t,o){return this.f.updateIcon(v,k,t,o)}attachToProcess(v){return this.f.attachToProcess(v)}detachFromProcess(v,k){return this.f.detachFromProcess(v,k)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(v){return this.f.start(v)}shutdown(v,k){return this.f.shutdown(v,k)}input(v,k){return this.f.input(v,k)}processBinary(v,k){return this.f.processBinary(v,k)}resize(v,k,t){return this.f.resize(v,k,t)}clearBuffer(v){return this.f.clearBuffer(v)}acknowledgeDataEvent(v,k){return this.f.acknowledgeDataEvent(v,k)}setUnicodeVersion(v,k){return this.f.setUnicodeVersion(v,k)}getInitialCwd(v){return this.f.getInitialCwd(v)}getCwd(v){return this.f.getCwd(v)}async getLatency(){const v=new p.$ge,k=await this.f.getLatency();return v.stop(),[{label:"ptyhostservice<->ptyhost",latency:v.elapsed()},...k]}orphanQuestionReply(v){return this.f.orphanQuestionReply(v)}installAutoReply(v,k){return this.f.installAutoReply(v,k)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(v){return this.f.uninstallAutoReply(v)}getDefaultSystemShell(v){return this.g?.getDefaultSystemShell(v)??(0,l.$zm)(v??S.OS,process.env)}async getProfiles(v,k,t,o=!1){const i=await this.S();return(0,w.$Ms)(k,t,o,this.N,i,void 0,this.O,this.bb.bind(this,v))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(v,k){return this.f.getWslPath(v,k)}getRevivedPtyNewId(v,k){return this.f.getRevivedPtyNewId(v,k)}setTerminalLayoutInfo(v){return this.f.setTerminalLayoutInfo(v)}async getTerminalLayoutInfo(v){return this.g?.getTerminalLayoutInfo(v)}async requestDetachInstance(v,k){return this.f.requestDetachInstance(v,k)}async acceptDetachInstanceReply(v,k){return this.f.acceptDetachInstanceReply(v,k)}async freePortKillProcess(v){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(v)}async serializeTerminalState(v){return this.f.serializeTerminalState(v)}async reviveTerminalProcesses(v,k,t){return this.f.reviveTerminalProcesses(v,k,t)}async refreshProperty(v,k){return this.f.refreshProperty(v,k)}async updateProperty(v,k,t){return this.f.updateProperty(v,k,t)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(v){this.ab(),this.s=setTimeout(()=>this.Y(),v?f.HeartbeatConstants.ConnectingBeatInterval:f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(v,k){return this.j.createRequest({workspaceId:v,originalText:k})}async acceptPtyHostResolvedVariables(v,k){this.j.acceptReply(v,k)}};e.$Ns=$,e.$Ns=$=Se([re(1,A.$_i),re(2,I.$_j),re(3,I.$ak)],$)}),define(oe[74],ae([0,1,14,3,2,4,18,6,34]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=e.$Bec=void 0;const a="#FFFFFF",h="#1E1E1E",f="#000000",g="#FFFFFF",w="theme",l="themeBackground",p="windowSplash";var y;(function(m){m.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",m.SYSTEM_COLOR_THEME="window.systemColorTheme"})(y||(y={})),e.$Bec=(0,I.$Fi)("themeMainService");let $=class extends S.$Wc{constructor(v,k){super(),this.b=v,this.c=k,this.a=this.B(new r.$me),this.onDidChangeColorScheme=this.a.event,D.$k||this.B(this.c.onDidChangeConfiguration(t=>{(t.affectsConfiguration(y.SYSTEM_COLOR_THEME)||t.affectsConfiguration(y.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(r.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(D.$k||this.c.getValue(y.DETECT_COLOR_SCHEME))n.nativeTheme.themeSource="system";else switch(this.c.getValue(y.SYSTEM_COLOR_THEME)){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(D.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(D.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(D.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return v.dark?f:g;let k=this.b.getItem(l,null);if(!k)switch(this.g()){case"vs":k=a;break;case"hc-black":k=f;break;case"hc-light":k=g;break;default:k=h}return D.$j&&k.toUpperCase()===h&&(k="#171717"),k}g(){switch(this.b.getItem(w,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(v,k){this.b.setItems([{key:w,data:k.baseTheme},{key:l,data:k.colorInfo.background},{key:p,data:k}]),typeof v=="number"&&this.h(v,k),this.f()}h(v,k){for(const t of n.BrowserWindow.getAllWindows())if(t.id===v){t.setBackgroundColor(k.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(p)}};e.$Cec=$,e.$Cec=$=Se([re(0,b.$gR),re(1,A.$_i)],$)}),define(oe[132],ae([0,1,3,2,4,7,18,6,5]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lw=e.$Kw=e.$Hw=e.$Fw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bw=e.$Aw=void 0,e.$Cw=f,e.$Dw=w,e.$Ew=l,e.$Gw=p,e.$Iw=y,e.$Jw=$,e.$Aw=(0,I.$Fi)("tunnelService"),e.$Bw=(0,I.$Fi)("sharedTunnelsService");var a;(function(k){k.Http="http",k.Https="https"})(a||(e.TunnelProtocol=a={}));var h;(function(k){k.ConstantPrivate="constantPrivate",k.Private="private",k.Public="public"})(h||(e.TunnelPrivacyId=h={}));function f(k){return!!k.forwardPort}var g;(function(k){k[k.Notify=1]="Notify",k[k.OpenBrowser=2]="OpenBrowser",k[k.OpenPreview=3]="OpenPreview",k[k.Silent=4]="Silent",k[k.Ignore=5]="Ignore",k[k.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function w(k){if(k.scheme!=="http"&&k.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(k.authority);if(t)return{address:t[1],port:+t[2]}}function l(k){if(k.scheme!=="http"&&k.scheme!=="https"||!k.query)return;const t=k.query.split("&");for(const o of t){const i=o.split("=")[1];if(/^https?:/.exec(i)){const c=w(D.URI.parse(i));if(c)return c}}}e.$Fw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(k){return e.$Fw.indexOf(k)>=0}e.$Hw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(k){return e.$Hw.indexOf(k)>=0}function $(k,t,o,i){if(o===S.OperatingSystem.Windows)return!1;if(o===S.OperatingSystem.Macintosh&&y(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(c?.length===4&&parseInt(c[1])>=18)return!1}return k<1024}class m{constructor(t,o,i){this.remoteAddress=t,this.localAddress=o,this.b=i,this.a=new n.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Kw=m;let v=class extends r.$Wc{constructor(t,o){super(),this.r=t,this.s=o,this.a=new n.$me,this.onTunnelOpened=this.a.event,this.b=new n.$me,this.onTunnelClosed=this.b.event,this.c=new n.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],o=Array.from(this.f.values());for(const i of o){const c=Array.from(i.values());for(const s of c){const u=await s.value;u&&typeof u!="string"&&t.push(u)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:o}of t.values())await o.then(i=>typeof i!="string"?i?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,o,i,c,s){this.z(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:i,privacy:c,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(y(t)||p(t))&&(t=e.$Fw[0]);const i=this.D(t,o);if(i)return++i.refcount,i.value}openTunnel(t,o,i,c,s,u=!1,d,P){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${i} on local port ${s}.`);const E=this.g??t;if(!E)return;if(o||(o="localhost"),c||(c=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const O=this.F(E,o,i,c,s,u,d,P);return O?O.then(T=>{if(T){if(typeof T=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(o,i),T}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(o,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const L=this.w(T);return(T.tunnelRemoteHost!==o||T.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),d&&T.privacy!==d&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(L),L}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),O)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this.f.get(t.tunnelRemoteHost);if(o){const i=o.get(t.tunnelRemotePort);i&&(i.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,i))}}}}async y(t,o,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const c=i.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this.b.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(o),c}}async closeTunnel(t,o){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const i=this.f.get(t);if(i&&i.has(o)){const c=i.get(o);c.refcount=0,await this.y(t,o,c)}}z(t,o,i){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(o,{refcount:1,value:i})}async C(t,o){const i=this.f.get(t);if(i){const c=i.get(o),s=c?await c.value:void 0;(!s||typeof s=="string")&&i.delete(o),i.size===0&&this.f.delete(t)}}D(t,o){const i=[t];p(t)?(i.push(...e.$Fw),i.push(...e.$Hw)):y(t)&&i.push(...e.$Hw);const c=i.map(s=>this.f.get(s));for(const s of c){const u=s?.get(o);if(u)return u}}canTunnel(t){return!!w(t)}G(t,o,i,c,s,u,d){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${i} on local port ${c}.`);const P=i;this.n.add(P);const E=c===void 0?i:c,O={elevationRequired:s?this.isPortPrivileged(E):!1},T={remoteAddress:{host:o,port:i},localAddressPort:c,privacy:u,public:u?u!==h.Private:void 0,protocol:d},L=t.forwardPort(T,O);return L?(this.z(o,i,L),L.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(P)})):this.n.delete(P),L}};e.$Lw=v,e.$Lw=v=Se([re(0,b.$_j),re(1,A.$_i)],v)}),define(oe[50],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DY=e.$CY=e.DisablementReason=e.UpdateType=e.StateType=void 0;var r;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.Disabled="disabled",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(r||(e.StateType=r={}));var S;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap"})(S||(e.UpdateType=S={}));var D;(function(A){A[A.NotBuilt=0]="NotBuilt",A[A.DisabledByEnvironment=1]="DisabledByEnvironment",A[A.ManuallyDisabled=2]="ManuallyDisabled",A[A.MissingConfiguration=3]="MissingConfiguration",A[A.InvalidConfiguration=4]="InvalidConfiguration",A[A.RunningAsAdmin=5]="RunningAsAdmin"})(D||(e.DisablementReason=D={})),e.$CY={Uninitialized:{type:r.Uninitialized},Disabled:A=>({type:r.Disabled,reason:A}),Idle:(A,I)=>({type:r.Idle,updateType:A,error:I}),CheckingForUpdates:A=>({type:r.CheckingForUpdates,explicit:A}),AvailableForDownload:A=>({type:r.AvailableForDownload,update:A}),Downloading:{type:r.Downloading},Downloaded:A=>({type:r.Downloaded,update:A}),Updating:A=>({type:r.Updating,update:A}),Ready:A=>({type:r.Ready,update:A})},e.$DY=(0,n.$Fi)("updateService")}),define(oe[269],ae([0,1,4,194,54,45]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.$qo.as(S.$vo.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:S.ConfigurationScope.APPLICATION,description:(0,r.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(2,null),(0,r.localize)(3,null),(0,r.localize)(4,null),(0,r.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:S.ConfigurationScope.APPLICATION,description:(0,r.localize)(6,null),deprecationMessage:(0,r.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:S.ConfigurationScope.APPLICATION,title:(0,r.localize)(8,null),description:(0,r.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:S.ConfigurationScope.APPLICATION,description:(0,r.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(oe[270],ae([0,1,3,50]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=e.$Nfc=void 0;class S{constructor(I){this.a=I}listen(I,b){switch(b){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${b}`)}call(I,b,a){switch(b){case"checkForUpdates":return this.a.checkForUpdates(a);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(a)}throw new Error(`Call not found: ${b}`)}}e.$Nfc=S;class D{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new n.$me,this.onStateChange=this.a.event,this.b=r.$CY.Uninitialized,this.c.listen("onStateChange")(b=>this.state=b),this.c.call("_getInitialState").then(b=>this.state=b)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$Ofc=D}),define(oe[41],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,n.$Fi)("IUriIdentityService")}),define(oe[271],ae([0,1,41,210,15,19,144,3,2]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class a{static{this._clock=0}constructor(g){this.uri=g,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let h=class{constructor(g){this.g=g,this.c=new b.$Vc,this.f=2**16;const w=new Map,l=p=>{let y=w.get(p.scheme);return y===void 0&&(y=g.hasProvider(p)&&!this.g.hasCapability(p,S.FileSystemProviderCapabilities.PathCaseSensitive),w.set(p.scheme,y)),y};this.c.add(I.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(p=>{w.delete(p.scheme)})),this.extUri=new D.$8g(l),this.d=new A.$Qs((p,y)=>this.extUri.compare(p,y,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,D.$hh)(g));const w=this.d.get(g);return w?w.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new a(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((l,p)=>l[1].time<p[1].time?1:l[1].time>p[1].time?-1:0);a._clock=0,this.d.clear();const w=this.f*.5;for(let l=0;l<w;l++)this.d.set(g[l][0],g[l][1].touch())}};e.$Rs=h,e.$Rs=h=Se([re(0,S.$_k)],h),(0,r.$Os)(n.$Jl,h,r.InstantiationType.Delayed)}),define(oe[133],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tY=void 0,e.$tY=(0,n.$Fi)("urlService")}),define(oe[272],ae([0,1,7]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=e.$Vfc=void 0;class r{constructor(I){this.a=I}listen(I,b){throw new Error(`Event not found: ${b}`)}call(I,b,a){switch(b){case"handleURL":return this.a.handleURL(n.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${b}`)}}e.$Vfc=r;class S{constructor(I){this.a=I}handleURL(I,b){return this.a.call("handleURL",[I.toJSON(),b])}}e.$Wfc=S;class D{constructor(I,b){this.a=I,this.b=b}async routeCall(I,b,a,h){if(b!=="handleURL")throw new Error(`Call not found: ${b}`);if(Array.isArray(a)&&a.length>0){const f=n.URI.revive(a[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",f.toString(!0)),f.query){const g=/\bwindowId=(\d+)/.exec(f.query);if(g){const w=g[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${w}"`,f.toString(!0));const l=new RegExp(`window:${w}`),p=I.connections.find(y=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",y.ctx),l.test(y.ctx)));if(p)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",f.toString(!0)),p;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",f.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",f.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,b,a,h)}routeEvent(I,b){throw new Error(`Event not found: ${b}`)}}e.$Xfc=D}),define(oe[273],ae([0,1,8,2,7,28]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vY=e.$uY=void 0;class A extends r.$Wc{constructor(){super(...arguments),this.a=new Set}open(a,h){const f=[...this.a.values()];return(0,n.$Jh)(f.map(g=>()=>g.handleURL(a,h)),void 0,!1).then(g=>g||!1)}registerHandler(a){return this.a.add(a),(0,r.$Uc)(()=>this.a.delete(a))}}e.$uY=A;let I=class extends A{constructor(a){super(),this.b=a}create(a){let{authority:h,path:f,query:g,fragment:w}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return h&&f&&f.indexOf("/")!==0&&(f=`/${f}`),S.URI.from({scheme:this.b.urlProtocol,authority:h,path:f,query:g,fragment:w})}};e.$vY=I,e.$vY=I=Se([re(0,D.$sk)],I)}),define(oe[274],ae([0,1,14,8,3,2,4,7]),function(x,e,n,r,S,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=void 0;class b extends D.$Wc{constructor(h,f,g,w,l,p){if(super(),this.c=f,this.f=p,this.a=[],this.b=0,h&&(p.trace("ElectronURLListener initialUrisToHandle:",h.map(m=>m.originalUrl)),this.a=h),A.$i){const m=w.isBuilt?[]:[`"${w.appRoot}"`];m.push("--open-url","--"),n.app.setAsDefaultProtocolClient(l.urlProtocol,process.execPath,m)}const y=S.Event.map(S.Event.fromNodeEventEmitter(n.app,"open-url",(m,v)=>({event:m,url:v})),({event:m,url:v})=>(m.preventDefault(),v));this.B(y(m=>{const v=this.g(m);v&&this.c.open(v,{originalUrl:m})})),g.getWindows().filter(m=>m.isReady).length>0?(p.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(p.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(S.Event.once(g.onDidSignalReadyWindow)(()=>this.h())))}g(h){try{return I.URI.parse(h)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const h=[];for(const f of this.a)await this.c.open(f.uri,{originalUrl:f.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",f.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",f.originalUrl),h.push(f));h.length!==0&&(this.a=h,(0,r.$Hh)(()=>this.h(),500,this.q))}}e.$Yfc=b}),define(oe[275],ae([0,1,3,2,15,61,32]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;class I extends r.$Wc{constructor(a,h,f,g,w,l){super(),this.f=a,this.g=h,this.h=f,this.j=g,this.m=w,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$me),this.onDidChangeFile=this.a.event,this.b=D.$Li.forUris(()=>!(this.capabilities&S.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new A.$Dc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(g.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,h){return this.g.open(this.t(a),h)}close(a){return this.g.close(a)}read(a,h,f,g,w){return this.g.read(a,h,f,g,w)}write(a,h,f,g,w){return this.g.write(a,h,f,g,w)}watch(a,h){this.b.set(a,a);const f=this.g.watch(this.t(a),h);return(0,r.$Uc)(()=>{this.b.delete(a),f.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,h,f){return this.g.rename(this.t(a),this.t(h),f)}readFile(a,h){return this.g.readFile(this.t(a),h)}readFileStream(a,h,f){return this.g.readFileStream(this.t(a),h,f)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,h,f){return this.g.writeFile(this.t(a),h,f)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,h){return this.g.delete(this.t(a),h)}copy(a,h,f){if((0,S.$dl)(this.g))return this.g.copy(this.t(a),this.t(h),f);throw new Error("copy not supported")}cloneFile(a,h){if((0,S.$el)(this.g))return this.g.cloneFile(this.t(a),this.t(h));throw new Error("clone not supported")}s(a){const h=[];for(const f of a){if(f.resource.scheme!==this.f)continue;const g=this.u(f.resource);this.b.findSubstr(g)&&h.push({resource:g,type:f.type,cId:f.cId})}h.length&&(this.n.debug("User data changed"),this.a.fire(h))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Bgc=I}),define(oe[276],ae([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0,e.$igc="utilityProcessWorker"}),define(oe[277],ae([0,1,6]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=void 0,e.$Zfc=(0,n.$Fi)("webviewManagerService")}),define(oe[278],ae([0,1,14,2,13,7]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;class A extends r.$Wc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const b=this.b.bind(this);n.protocol.registerFileProtocol(S.Schemas.vscodeWebview,b)}b(b,a){try{const h=D.URI.parse(b.url),f=A.a.get(h.path);if(typeof f=="string"){const g=`vs/workbench/contrib/webview/browser/pre/${f}`,w=S.$Zg.asFileUri(g);return a({path:w.fsPath,headers:{...S.COI.getHeadersFromQuery(b.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.$1fc=A}),define(oe[57],ae([0,1,4]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7D=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$XD=void 0,e.$YD=r,e.$ZD=S,e.$1D=D,e.$2D=A,e.$3D=I,e.$4D=f,e.$5D=g,e.$6D=w,e.$8D=l,e.$9D=p,e.$0D=y,e.$XD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function r($){return typeof $.parentId=="number"}function S($){return!!$.workspaceUri}function D($){return!!$.folderUri}function A($){return!!$.fileUri}function I($){const m=g($),v=$.getValue("window.menuBarVisibility");return v==="default"||m&&v==="compact"||n.$j&&n.$m?"classic":v}var b;(function($){$.TITLE_BAR_STYLE="window.titleBarStyle",$.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(b||(e.TitleBarSetting=b={}));var a;(function($){$.NATIVE="native",$.CUSTOM="custom"})(a||(e.TitlebarStyle=a={}));var h;(function($){$.AUTO="auto",$.WINDOWED="windowed",$.NEVER="never"})(h||(e.CustomTitleBarVisibility=h={}));function f($,m){return!0}function g($,m){return m||(m=w($)),m===a.NATIVE}function w($){if(n.$o)return a.CUSTOM;const m=$.getValue("window");if(m){if(n.$j&&m.nativeTabs===!0||n.$j&&m.nativeFullScreen===!1)return a.NATIVE;const t=m.titleBarStyle;if(t===a.NATIVE||t===a.CUSTOM)return t}return n.$k?a.NATIVE:a.CUSTOM}e.$7D=35;function l($){return!(!n.$i||n.$o||g($))}function p($){const m=$.getValue("window");return!m||typeof m.nativeFullScreen!="boolean"||m.nativeTabs?!0:m.nativeFullScreen!==!1}function y($=0){return Math.pow(1.2,$)}}),define(oe[51],ae([0,1,14]),function(x,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$rec=e.$qec=e.UnloadReason=e.LoadReason=void 0;var r;(function(a){a[a.INITIAL=1]="INITIAL",a[a.LOAD=2]="LOAD",a[a.RELOAD=3]="RELOAD"})(r||(e.LoadReason=r={}));var S;(function(a){a[a.CLOSE=1]="CLOSE",a[a.QUIT=2]="QUIT",a[a.RELOAD=3]="RELOAD",a[a.LOAD=4]="LOAD"})(S||(e.UnloadReason=S={}));const D=function(a=I.Normal){return{width:1024,height:768,mode:a}};e.$qec=D;const A=function(){const f=n.screen.getPrimaryDisplay().workArea,g=Math.max(f.x+f.width/2-800/2,0),w=Math.max(f.y+f.height/2-600/2,0);return{x:g,y:w,width:800,height:600,mode:I.Normal}};e.$rec=A;var I;(function(a){a[a.Maximized=0]="Maximized",a[a.Normal=1]="Normal",a[a.Minimized=2]="Minimized",a[a.Fullscreen=3]="Fullscreen"})(I||(e.WindowMode=I={}));var b;(function(a){a[a.UNRESPONSIVE=1]="UNRESPONSIVE",a[a.PROCESS_GONE=2]="PROCESS_GONE",a[a.LOAD=3]="LOAD"})(b||(e.WindowError=b={}))}),define(oe[279],ae([0,1,8,3,2]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class D extends S.$Wc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:b,getActiveWindowId:a}){super(),this.a=this.B(new S.$Vc),r.Event.latch(r.Event.any(I,b))(this.f,this,this.a),this.b=(0,n.$sh)(()=>a()),(async()=>{try{const f=await this.b;this.c=typeof this.c=="number"?this.c:f}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$7fc=D}),define(oe[30],ae([0,1,198,9,61,19,7,6,13]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=a,e.$Qi=h,e.$Ti=f,e.$Ui=g,e.$Vi=w,e.$Wi=p,e.$Xi=y,e.$1i=v,e.$6i=k,e.$7i=t,e.$9i=o,e.$0i=i,e.$$i=c,e.$Oi=(0,I.$Fi)("contextService");function a(s){const u=s;return typeof u?.id=="string"&&A.URI.isUri(u.uri)}function h(s){return typeof s?.id=="string"&&!a(s)&&!g(s)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function f(s,u){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,r.$pc)(s)}:u?e.$Ri:e.$Si;const d=s;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}function g(s){const u=s;return typeof u?.id=="string"&&A.URI.isUri(u.configPath)}function w(s){const u=s;if(u?.uri)return{id:u.id,uri:A.URI.revive(u.uri)};const d=s;if(d?.configPath)return{id:d.id,configPath:A.URI.revive(d.configPath)};if(s?.id)return{id:s.id}}var l;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function p(s){const u=s;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}function y(s){const u=s;return!!(u&&typeof u=="object"&&A.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}class ${constructor(u,d,P,E,O){this.h=u,this.j=P,this.k=E,this.l=O,this.c=S.$Li.forUris(this.l,()=>!0),this.folders=d}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=S.$Li.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=$;class m{constructor(u,d){this.raw=d,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,D.$gh)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=m;function v(s){return new m({uri:s,index:0,name:(0,D.$ch)(s)},{uri:s.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,n.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function k(s,u){return D.$0g.isEqualOrParent(s,u.untitledWorkspacesHome)}function t(s){let u;return A.URI.isUri(s)?u=s:u=s.configuration,u?.scheme===b.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(s){return s.id===e.$8i}function i(s,u){return!k(s,u)&&!t(s)}function c(s){return(typeof s=="string"?(0,r.$qc)(s):(0,D.$eh)(s))===e.$3i}}),define(oe[58],ae([0,1,14,8,46,48,2,77,4,21,172,124,6,5,28,30]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=e.$yec=void 0,e.$yec=(0,g.$Fi)("dialogMainService");let y=class{constructor(m,v){this.d=m,this.e=v,this.a=new Map,this.b=new Map,this.c=new r.$Mh}pickFileFolder(m,v){return this.f({...m,pickFolders:!0,pickFiles:!0,title:(0,h.localize)(0,null)},v)}pickFolder(m,v){return this.f({...m,pickFolders:!0,title:(0,h.localize)(1,null)},v)}pickFile(m,v){return this.f({...m,pickFiles:!0,title:(0,h.localize)(2,null)},v)}pickWorkspace(m,v){const k=(0,h.localize)(3,null),t=(0,D.$3w)((0,h.localize)(4,null)),o=p.$4i;return this.f({...m,pickFiles:!0,title:k,filters:o,buttonLabel:t},v)}async f(m,v){const k={title:m.title,buttonLabel:m.buttonLabel,filters:m.filters,defaultPath:m.defaultPath};(typeof m.pickFiles=="boolean"||typeof m.pickFolders=="boolean")&&(k.properties=void 0,m.pickFiles&&m.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",m.pickFolders?"openDirectory":"openFile","createDirectory"]),b.$j&&k.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(k,(v||n.BrowserWindow.getFocusedWindow())??void 0);if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(m){if(m){let v=this.b.get(m.id);return v||(v=new r.$Mh,this.b.set(m.id,v)),v}else return this.c}showMessageBox(m,v){return this.g(v).queue(async()=>{const{options:k,buttonIndeces:t}=(0,f.$0w)(m,this.e);let o;return v?o=await n.dialog.showMessageBox(v,k):o=await n.dialog.showMessageBox(k),{response:t[o.response],checkboxChecked:o.checkboxChecked}})}async showSaveDialog(m,v){const k=this.j(m,v);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(v).queue(async()=>{let t;return v?t=await n.dialog.showSaveDialog(v,m):t=await n.dialog.showSaveDialog(m),t.filePath=this.h(t.filePath),t})}finally{(0,A.$Rc)(k)}}h(m){return m&&b.$j&&(m=(0,I.$mm)(m)),m}i(m){return m.map(v=>this.h(v))}async showOpenDialog(m,v){m.defaultPath&&(await a.Promises.exists(m.defaultPath)||(m.defaultPath=void 0));const k=this.j(m,v);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(v).queue(async()=>{let t;return v?t=await n.dialog.showOpenDialog(v,m):t=await n.dialog.showOpenDialog(m),t.filePaths=this.i(t.filePaths),t})}finally{(0,A.$Rc)(k)}}j(m,v){if(!v)return A.$Wc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",m);let k=this.a.get(v.id);k||(k=new Set,this.a.set(v.id,k));const t=(0,S.$tj)(m);if(!k.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",m),k.add(t),(0,A.$Uc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",m),k?.delete(t),k?.size===0&&this.a.delete(v.id)})}};e.$zec=y,e.$zec=y=Se([re(0,w.$_j),re(1,l.$sk)],y)}),define(oe[280],ae([0,1,3,2,81,30]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;class A extends r.$Wc{static{this.a=100}constructor(b,a){super(),this.f=b,this.g=a,this.b=this.B(new n.$me),this.c=new Map,this.h(a.applicationStorage,this.b)}h(b,a){this.B(n.Event.debounce(b.onDidChangeStorage,(h,f)=>(h?h.push(f):h=[f],h),A.a)(h=>{h.length&&a.fire(this.j(h,b))}))}j(b,a){const h=new Map,f=new Set;return b.forEach(g=>{const w=a.get(g.key);typeof w=="string"?h.set(g.key,w):f.add(g.key)}),{changed:Array.from(h.entries()),deleted:Array.from(f.values())}}listen(b,a,h){switch(a){case"onDidChangeStorage":{const f=h.profile?(0,S.$ci)(h.profile):void 0;if(!f)return this.b.event;let g=this.c.get(f.id);return g||(g=this.B(new n.$me),this.h(this.g.profileStorage(f),g),this.c.set(f.id,g)),g.event}}throw new Error(`Event not found: ${a}`)}async call(b,a,h){const f=h.profile?(0,S.$ci)(h.profile):void 0,g=(0,D.$Vi)(h.workspace),w=await this.m(f,g);switch(a){case"getItems":return Array.from(w.items.entries());case"updateItems":{const l=h;if(l.insert)for(const[p,y]of l.insert)w.set(p,y);l.delete?.forEach(p=>w.delete(p));break}case"optimize":return w.optimize();case"isUsed":{const l=h.payload;if(typeof l=="string")return this.g.isUsed(l)}default:throw new Error(`Call not found: ${a}`)}}async m(b,a){let h;a?h=this.g.workspaceStorage(a):b?h=this.g.profileStorage(b):h=this.g.applicationStorage;try{await h.init()}catch(f){this.f.error(`StorageIPC#init: Unable to init ${a?"workspace":b?"profile":"application"} storage due to ${f}`)}return h}}e.$Kfc=A}),define(oe[42],ae([0,1,46,3,2,19,7,195,38,15,6,5,30,32,41,8,33,26,12]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=k,e.$Ml=t,e.$Nl=o;var v;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(v||(e.ProfileResourceType=v={}));function k(s){const u=s;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&A.URI.isUri(u.location)&&A.URI.isUri(u.globalStorageHome)&&A.URI.isUri(u.settingsResource)&&A.URI.isUri(u.keybindingsResource)&&A.URI.isUri(u.tasksResource)&&A.URI.isUri(u.snippetsHome)&&A.URI.isUri(u.extensionsResource))}e.$Ll=(0,h.$Fi)("IUserDataProfilesService");function t(s,u){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:A.URI.revive(s.location).with({scheme:u}),globalStorageHome:A.URI.revive(s.globalStorageHome).with({scheme:u}),settingsResource:A.URI.revive(s.settingsResource).with({scheme:u}),keybindingsResource:A.URI.revive(s.keybindingsResource).with({scheme:u}),tasksResource:A.URI.revive(s.tasksResource).with({scheme:u}),snippetsHome:A.URI.revive(s.snippetsHome).with({scheme:u}),extensionsResource:A.URI.revive(s.extensionsResource).with({scheme:u}),cacheHome:A.URI.revive(s.cacheHome).with({scheme:u}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function o(s,u,d,P,E,O){return{id:s,name:u,location:d,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:O&&E?.useDefaultFlags?.globalState?O.globalStorageHome:(0,D.$gh)(d,"globalStorage"),settingsResource:O&&E?.useDefaultFlags?.settings?O.settingsResource:(0,D.$gh)(d,"settings.json"),keybindingsResource:O&&E?.useDefaultFlags?.keybindings?O.keybindingsResource:(0,D.$gh)(d,"keybindings.json"),tasksResource:O&&E?.useDefaultFlags?.tasks?O.tasksResource:(0,D.$gh)(d,"tasks.json"),snippetsHome:O&&E?.useDefaultFlags?.snippets?O.snippetsHome:(0,D.$gh)(d,"snippets"),extensionsResource:O&&E?.useDefaultFlags?.extensions?O.extensionsResource:(0,D.$gh)(d,"extensions.json"),cacheHome:(0,D.$gh)(P,s),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}let i=class extends S.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,d,P,E){super(),this.t=u,this.u=d,this.w=P,this.y=E,this.f=!0,this.h=this.B(new r.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$Cc,workspaces:new w.$Cc,emptyWindows:new Map},this.profilesHome=(0,D.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),d=[u];if(this.f)try{for(const O of this.O()){if(!O.name||!(0,m.$fg)(O.name)||!O.location){this.y.warn("Skipping the invalid stored profile",O.location||O.name);continue}d.push(o((0,D.$dh)(O.location),O.name,O.location,this.g,{shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags},u))}}catch(O){this.y.error(O)}const P=new w.$Cc,E=new Map;if(d.length)try{const O=this.Q();if(O.workspaces)for(const[T,L]of Object.entries(O.workspaces)){const R=A.URI.parse(T),M=d.find(B=>B.id===L);M&&P.set(R,M)}if(O.emptyWindows)for(const[T,L]of Object.entries(O.emptyWindows)){const R=d.find(M=>M.id===L);R&&E.set(T,R)}}catch(O){this.y.error(O)}this.z={profiles:d,workspaces:P,emptyWindows:E}}return this.z}D(){const u=o("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const d="Temp",P=new RegExp(`${(0,$.$if)(d)}\\s(\\d+)`);let E=0;for(const T of this.profiles){const L=P.exec(T.name),R=L?parseInt(L[1]):0;E=R>E?R:E}const O=`${d} ${E+1}`;return this.createProfile((0,n.$tj)((0,y.$2g)()).toString(16),O,{transient:!0},u)}async createNamedProfile(u,d,P){return this.createProfile((0,n.$tj)((0,y.$2g)()).toString(16),u,d,P)}async createProfile(u,d,P,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const O=await this.F(u,d,P);return E&&await this.setProfileForWorkspace(E,O),O}async F(u,d,P){if(!(0,m.$fg)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(d);return E||(E=(async()=>{try{if(this.profiles.find(R=>R.name===d||R.id===u))throw new Error(`Profile with ${d} name already exists`);const T=o(u,d,(0,D.$gh)(this.profilesHome,u),this.g,P,this.defaultProfile);await this.u.createFolder(T.location);const L=[];return this.j.fire({profile:T,join(R){L.push(R)}}),await p.Promises.settled(L),this.I([T],[],[]),T}finally{this.r.delete(d)}})(),this.r.set(d,E)),E}async updateProfile(u,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let P=this.profiles.find(E=>E.id===u.id);if(!P)throw new Error(`Profile '${u.name}' does not exist`);return P=o(P.id,d.name??P.name,P.location,this.g,{shortName:d.shortName??P.shortName,icon:d.icon===null?void 0:d.icon??P.icon,transient:d.transient??P.isTransient,useDefaultFlags:d.useDefaultFlags??P.useDefaultFlags},this.defaultProfile),this.I([],[],[P]),P}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(E=>E.id===u.id);if(!d)throw new Error(`Profile '${u.name}' does not exist`);const P=[];this.m.fire({profile:d,join(E){P.push(E)}});try{await Promise.allSettled(P)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])d.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])d.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[d],[]);try{await this.u.del(d.cacheHome,{recursive:!0})}catch(E){(0,a.$ql)(E)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(E)}}async setProfileForWorkspace(u,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const P=this.profiles.find(E=>E.id===d.id);if(!P)throw new Error(`Profile '${d.name}' does not exist`);this.L(u,P)}unsetWorkspace(u,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,d)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(d=>d.isDirectory&&this.profiles.every(P=>!this.w.extUri.isEqual(P.location,d.resource))).map(d=>this.u.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(d=>!this.H(d));await Promise.allSettled(u.map(d=>this.removeProfile(d)))}getProfileForWorkspace(u){const d=this.G(u),P=A.URI.isUri(d)?this.C.workspaces.get(d):this.C.emptyWindows.get(d);return P||((0,g.$Pi)(u)?this.s.folders.get(u.uri):(0,g.$Ui)(u)?this.s.workspaces.get(u.configPath):this.s.emptyWindows.get(u.id))}G(u){return(0,g.$Pi)(u)?u.uri:(0,g.$Ui)(u)?u.configPath:u.id}H(u){return!!([...this.C.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.C.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.s.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.s.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.s.folders.values()].some(d=>this.w.extUri.isEqual(d.location,u.location)))}I(u,d,P){const E=[...this.profiles,...u],O=[],T=this.s.profiles;this.s.profiles=[];for(let L of E){if(L.isDefault||d.some(M=>L.id===M.id))continue;L=P.find(M=>L.id===M.id)??L;const R=T.find(M=>L.id===M.id);if(L.isTransient)this.s.profiles.push(L);else{if(R){for(const[M,B]of this.s.emptyWindows.entries())if(L.id===B.id){this.L({id:M},L);break}for(const[M,B]of this.s.workspaces.entries())if(L.id===B.id){this.L({id:"",configPath:M},L);break}for(const[M,B]of this.s.folders.entries())if(L.id===B.id){this.L({id:"",uri:M},L);break}}O.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags})}}this.P(O),this.z=void 0,this.J(u,d,P)}J(u,d,P){this.h.fire({added:u,removed:d,updated:P,all:this.profiles})}L(u,d,P){if(P=d?.isTransient?!0:P,P)(0,g.$Pi)(u)?(this.s.folders.delete(u.uri),d&&this.s.folders.set(u.uri,d)):(0,g.$Ui)(u)?(this.s.workspaces.delete(u.configPath),d&&this.s.workspaces.set(u.configPath,d)):(this.s.emptyWindows.delete(u.id),d&&this.s.emptyWindows.set(u.id,d));else{this.L(u,void 0,!0);const E=this.G(u);A.URI.isUri(E)?(this.C.workspaces.delete(E),d&&this.C.workspaces.set(E,d)):(this.C.emptyWindows.delete(E),d&&this.C.emptyWindows.set(E,d)),this.M()}}M(){const u={};for(const[P,E]of this.C.workspaces.entries())u[P.toString()]=E.id;const d={};for(const[P,E]of this.C.emptyWindows.entries())d[P.toString()]=E.id;this.R({workspaces:u,emptyWindows:d}),this.z=void 0}N(u){const d={},P=this.D();if(u.workspaces)for(const[O,T]of Object.entries(u.workspaces)){const L=A.URI.parse(T);d[O]=this.w.extUri.isEqual(L,P.location)?P.id:this.w.extUri.basename(L)}const E={};if(u.emptyWindows)for(const[O,T]of Object.entries(u.emptyWindows)){const L=A.URI.parse(T);E[O]=this.w.extUri.isEqual(L,P.location)?P.id:this.w.extUri.basename(L)}return{workspaces:d,emptyWindows:E}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$Ol=i,e.$Ol=i=Se([re(0,b.$Mi),re(1,a.$_k),re(2,l.$Jl),re(3,f.$_j)],i);class c extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$Pl=c}),define(oe[87],ae([0,1,8,17,2,3,32,7,127,130,15,6,5,42,41,12,16,24]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m||(e.ExtensionsProfileScanningErrorCode=m={}));class v extends Error{constructor(c,s){super(c),this.code=s}}e.$Fq=v,e.$Gq=(0,f.$Fi)("IExtensionsProfileScannerService");let k=class extends S.$Wc{constructor(c,s,u,d,P,E){super(),this.j=c,this.m=s,this.n=u,this.r=d,this.s=P,this.t=E,this.b=this.B(new D.$me),this.onAddExtensions=this.b.event,this.c=this.B(new D.$me),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$me),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$me),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Cc}scanProfileExtensions(c,s){return this.u(c,void 0,s)}async addExtensionsToProfile(c,s,u){const d=[],P=[];try{return await this.u(s,E=>{const O=[];if(u)O.push(...E);else for(const T of E)c.some(([L])=>(0,a.$Jp)(L.identifier,T.identifier)&&L.manifest.version!==T.version)?d.push(T):O.push(T);for(const[T,L]of c){const R=O.findIndex(B=>(0,a.$Jp)(B.identifier,T.identifier)&&B.version===T.manifest.version),M={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:L};R===-1?(P.push(M),O.push(M)):O.splice(R,1,M)}return P.length&&this.b.fire({extensions:P,profileLocation:s}),d.length&&this.f.fire({extensions:d,profileLocation:s}),O}),P.length&&this.c.fire({extensions:P,profileLocation:s}),d.length&&this.g.fire({extensions:d,profileLocation:s}),P}catch(E){throw P.length&&this.c.fire({extensions:P,error:E,profileLocation:s}),d.length&&this.g.fire({extensions:d,error:E,profileLocation:s}),E}}async updateMetadata(c,s){const u=[];return await this.u(s,d=>{const P=[];for(const E of d){const O=c.find(([T])=>(0,a.$Jp)(T.identifier,E.identifier)&&T.manifest.version===E.version);O&&(E.metadata={...E.metadata,...O[1]},u.push(E)),P.push(E)}return P}),u}async removeExtensionFromProfile(c,s){const u=[];try{await this.u(s,d=>{const P=[];for(const E of d)(0,a.$Jp)(E.identifier,c.identifier)?u.push(E):P.push(E);return u.length&&this.f.fire({extensions:u,profileLocation:s}),P}),u.length&&this.g.fire({extensions:u,profileLocation:s})}catch(d){throw u.length&&this.g.fire({extensions:u,error:d,profileLocation:s}),d}}async u(c,s,u){return this.F(c).queue(async()=>{let d=[],P;try{const E=await this.m.readFile(c);P=JSON.parse(E.value.toString().trim()||"[]")}catch(E){if((0,h.$ql)(E)!==h.FileOperationResult.FILE_NOT_FOUND)throw E;if(this.r.extUri.isEqual(c,this.n.defaultProfile.extensionsResource)&&(P=await this.D()),!P&&u?.bailOutWhenFileNotFound)throw new v((0,y.$_)(E),m.ERROR_PROFILE_NOT_FOUND)}if(P){Array.isArray(P)||this.w(c);let E=!1;for(const O of P){t(O)||this.w(c);let T;if((0,p.$fg)(O.relativeLocation)&&O.relativeLocation)T=this.z(O.relativeLocation);else if((0,p.$fg)(O.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${O.location}`);continue}else{T=I.URI.revive(O.location);const L=this.y(T);L&&(E=!0,O.relativeLocation=L)}(0,p.$mg)(O.metadata?.hasPreReleaseVersion)&&O.metadata?.preRelease&&(E=!0,O.metadata.hasPreReleaseVersion=!0),d.push({identifier:O.identifier,location:T,version:O.version,metadata:O.metadata})}E&&await this.m.writeFile(c,r.$Oe.fromString(JSON.stringify(P)))}if(s){d=s(d);const E=d.map(O=>({identifier:O.identifier,version:O.version,location:O.location.toJSON(),relativeLocation:this.y(O.location),metadata:O.metadata}));await this.m.writeFile(c,r.$Oe.fromString(JSON.stringify(E)))}return d})}w(c){const s=new v(`Invalid extensions content in ${c.toString()}`,m.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(c){return this.r.extUri.isEqual(this.r.extUri.dirname(c),this.j)?this.r.extUri.basename(c):void 0}z(c){return this.r.extUri.joinPath(this.j,c)}async D(){return this.C||(this.C=(async()=>{const c=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let u;try{u=(await this.m.readFile(c)).value.toString()}catch(P){if((0,h.$ql)(P)===h.FileOperationResult.FILE_NOT_FOUND)return;throw P}this.t.info("Migrating extensions from old default profile location",c.toString());let d;try{const P=JSON.parse(u);Array.isArray(P)&&P.every(E=>t(E))?d=P:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",P)}catch(P){this.t.error(P)}if(d)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Oe.fromString(JSON.stringify(d)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",c.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(P){if((0,h.$ql)(P)===h.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",c.toString(),this.n.defaultProfile.extensionsResource.toString());else throw P}try{await this.m.del(c)}catch(P){(0,h.$ql)(P)!==h.FileOperationResult.FILE_NOT_FOUND&&this.t.error(P)}try{await this.m.del(s)}catch(P){(0,h.$ql)(P)!==h.FileOperationResult.FILE_NOT_FOUND&&this.t.error(P)}return d})()),this.C}F(c){let s=this.h.get(c);return s||(s=new n.$Mh,this.h.set(c,s)),s}};e.$Hq=k,e.$Hq=k=Se([re(1,h.$_k),re(2,w.$Ll),re(3,l.$Jl),re(4,$.$$l),re(5,g.$_j)],k);function t(i){return(0,p.$hg)(i)&&(0,b.$hp)(i.identifier)&&(o(i.location)||(0,p.$fg)(i.location)&&i.location)&&((0,p.$mg)(i.relativeLocation)||(0,p.$fg)(i.relativeLocation))&&i.version&&(0,p.$fg)(i.version)}function o(i){return i?(0,p.$fg)(i.path)&&(0,p.$fg)(i.scheme):!1}});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[134],ae([0,1,22,8,35,17,16,43,157,2,13,9,4,19,247,79,12,7,177,38,130,86,246,15,6,5,28,3,81,87,42,41,208]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m,v,k,t,o,i,c,s,u,d,P,E,O,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Mq=e.$Lq=e.$Kq=e.Translations=void 0,e.$Nq=ne,S=Re(S),f=Re(f),g=Re(g),l=Re(l),p=et(p);var R;(function(ce){function K(ee,H){if(ee===H)return!0;const j=Object.keys(ee),U=new Set;for(const V of Object.keys(H))U.add(V);if(j.length!==U.size)return!1;for(const V of j){if(ee[V]!==H[V])return!1;U.delete(V)}return U.size===0}ce.equals=K})(R||(e.Translations=R={})),e.$Kq=(0,c.$Fi)("IExtensionsScannerService");let M=class extends a.$Wc{constructor(K,ee,H,j,U,V,le,G,he,se,_,F){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=ee,this.r=H,this.s=j,this.t=U,this.u=V,this.w=le,this.y=G,this.z=he,this.C=se,this.D=_,this.F=F,this.g=this.B(new d.$me),this.onDidChangeCache=this.g.event,this.h=(0,w.$gh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(z,this.s,this.h)),this.m=this.B(this.F.createInstance(z,this.s,this.h)),this.n=this.B(this.F.createInstance(C,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(t.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(t.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,k.$Up)(this.w,this.y)),this.G}async scanAllExtensions(K,ee,H){const[j,U]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(ee)]),V=H?await this.scanExtensionsUnderDevelopment(K,[...j,...U]):[];return this.L(j,U,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const ee=[];ee.push(this.M(!!K.useCache,K.language)),ee.push(this.N(K.language,!!K.checkControlFile));const[H,j]=await Promise.all(ee);return this.J([...H,...j],t.ExtensionType.System,K,!1)}async scanUserExtensions(K){const ee=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ee);const H=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.P(ee,!!K.profileLocation,t.ExtensionType.User,!K.includeUninstalled,K.language,!0,H,K.productVersion??this.R()),U=K.useCache&&!j.devMode&&j.excludeObsolete?this.m:this.n;let V;try{V=await U.scanExtensions(j)}catch(le){if(le instanceof E.$Fq&&le.code===E.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),V=await U.scanExtensions(j);else throw le}return V=await this.J(V,t.ExtensionType.User,K,!0),this.y.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(K,ee){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(j=>j.scheme===h.Schemas.file).map(async j=>{const U=await this.P(j,!1,t.ExtensionType.User,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(U)).map(le=>(le.type=ee.find(G=>(0,k.$Jp)(G.identifier,le.identifier))?.type??le.type,this.n.validate(le,U)))}))).flat();return this.J(H,"development",K,!0)}return[]}async scanExistingExtension(K,ee,H){const j=await this.P(K,!1,ee,!0,H.language,!0,void 0,H.productVersion??this.R()),U=await this.n.scanExtension(j);return!U||!H.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(K,ee,H){const j=await this.P(K,!1,ee,!0,H.language,!0,void 0,H.productVersion??this.R()),U=await this.n.scanOneOrMultipleExtensions(j);return this.J(U,ee,H,!0)}async scanMultipleExtensions(K,ee,H){const j=[];return await Promise.all(K.map(async U=>{const V=await this.scanOneOrMultipleExtensions(U,ee,H);j.push(...V)})),this.J(j,ee,H,!0)}async scanMetadata(K){const ee=(0,w.$gh)(K,"package.json"),H=(await this.w.readFile(ee)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(K,ee){const H=(0,w.$gh)(K,"package.json"),j=(await this.w.readFile(H)).value.toString(),U=JSON.parse(j);ee.isMachineScoped===!1&&delete ee.isMachineScoped,ee.isBuiltin===!1&&delete ee.isBuiltin,U.__metadata={...U.__metadata,...ee},await this.w.writeFile((0,w.$gh)(K,"package.json"),D.$Oe.fromString(JSON.stringify(U,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof E.$Fq&&K.code===E.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(ee=>[ee,ee.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$Oe.fromString(JSON.stringify([])))}catch(ee){(0,i.$ql)(ee)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$_)(ee))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,ee,H,j){return H.includeAllVersions||(K=this.L(ee===t.ExtensionType.System?K:void 0,ee===t.ExtensionType.User?K:void 0,ee==="development"?K:void 0,await this.getTargetPlatform(),j)),H.includeInvalid||(K=K.filter(U=>U.isValid)),K.sort((U,V)=>{const le=f.$pc(U.location.fsPath),G=f.$pc(V.location.fsPath);return le<G?-1:le>G?1:0})}L(K,ee,H,j,U){const V=(G,he,se)=>{if(G.isValid&&!he.isValid)return!1;if(G.isValid===he.isValid){if(U&&l.gt(G.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(l.eq(G.manifest.version,he.manifest.version)){if(G.type===t.ExtensionType.System)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===j)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return se?this.y.warn(`Overwriting user extension ${G.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${G.location.path} with ${he.location.path}.`),!0},le=new t.$sn;return K?.forEach(G=>{const he=le.get(G.identifier.id);(!he||V(he,G,!1))&&le.set(G.identifier.id,G)}),ee?.forEach(G=>{const he=le.get(G.identifier.id);if(!he&&K&&G.type===t.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!he||V(he,G,!1))&&le.set(G.identifier.id,G)}),H?.forEach(G=>{const he=le.get(G.identifier.id);(!he||V(he,G,!0))&&le.set(G.identifier.id,G),le.set(G.identifier.id,G)}),[...le.values()]}async M(K,ee){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,t.ExtensionType.System,!0,ee,!0,void 0,this.R()),U=await(K&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",U.length),U}async N(K,ee){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const j=ee?await this.O():{},U=[],V=$.URI.file(f.$jc(f.$lc(h.$Zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of H){const he=j[G.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":U.push((0,w.$gh)(V,G.name));break;default:U.push($.URI.file(he));break}}const le=await Promise.all(U.map(async G=>this.n.scanExtension(await this.P(G,!1,t.ExtensionType.System,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",le.length),(0,n.$Jb)(le)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,ee,H,j,U,V,le,G){const he=await this.f(U??g.$w),se=await this.Q(K),_=ee&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,F=_?await this.Q(_):void 0;return new B(K,se,_,F,ee,le,H,j,V,G.version,G.date,this.C.commit,!this.z.isBuilt,U,he)}async Q(K){try{const ee=await this.w.stat(K);if(typeof ee.mtime=="number")return ee.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Lq=M,e.$Lq=M=Se([re(4,O.$Ll),re(5,E.$Gq),re(6,i.$_k),re(7,s.$_j),re(8,v.$Mi),re(9,u.$sk),re(10,T.$Jl),re(11,c.$Ei)],M);class B{constructor(K,ee,H,j,U,V,le,G,he,se,_,F,N,W,q){this.location=K,this.mtime=ee,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=j,this.profile=U,this.profileScanOptions=V,this.type=le,this.excludeObsolete=G,this.validate=he,this.productVersion=se,this.productDate=_,this.productCommit=F,this.devMode=N,this.language=W,this.translations=q}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,ee){return(0,w.$_g)(K.location,ee.location)&&K.mtime===ee.mtime&&(0,w.$_g)(K.applicationExtensionslocation,ee.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===ee.applicationExtensionslocationMtime&&K.profile===ee.profile&&S.$ho(K.profileScanOptions,ee.profileScanOptions)&&K.type===ee.type&&K.excludeObsolete===ee.excludeObsolete&&K.validate===ee.validate&&K.productVersion===ee.productVersion&&K.productDate===ee.productDate&&K.productCommit===ee.productCommit&&K.devMode===ee.devMode&&K.language===ee.language&&R.equals(K.translations,ee.translations)}}e.$Mq=B;let C=class extends a.$Wc{constructor(K,ee,H,j,U){super(),this.f=K,this.g=ee,this.h=H,this.j=j,this.m=U}async scanExtensions(K){const ee=K.profile?await this.r(K):await this.n(K);let H={};if(K.excludeObsolete&&K.type===t.ExtensionType.User)try{const j=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(j)}catch{}return(0,y.$sg)(H)?ee:ee.filter(j=>!H[k.$Kp.create(j).toString()])}async n(K){const ee=await this.j.resolve(K.location);if(!ee.children?.length)return[];const H=await Promise.all(ee.children.map(async j=>{if(!j.isDirectory||K.type===t.ExtensionType.User&&(0,w.$dh)(j.resource).indexOf(".")===0)return null;const U=new B(j.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(U)}));return(0,n.$Jb)(H).sort((j,U)=>j.location.path<U.location.path?-1:1)}async r(K){let ee=await this.s(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){ee=ee.filter(j=>!j.metadata?.isApplicationScoped);const H=await this.s(K.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,K);ee.push(...H)}return ee}async s(K,ee,H){const j=await this.g.scanProfileExtensions(K,H.profileScanOptions);if(!j.length)return[];const U=await Promise.all(j.map(async V=>{if(ee(V)){const le=new B(V.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(le,V.metadata)}return null}));return(0,n.$Jb)(U)}async scanOneOrMultipleExtensions(K){try{if(await this.j.exists((0,w.$gh)(K.location,"package.json"))){const ee=await this.scanExtension(K);return ee?[ee]:[]}else return await this.scanExtensions(K)}catch(ee){return this.m.error(`Error scanning extensions at ${K.location.path}:`,(0,A.$_)(ee)),[]}}async scanExtension(K,ee){try{let H=await this.scanExtensionManifest(K.location);if(H){H.publisher||(H.publisher=t.$mn),ee=ee??H.__metadata,delete H.__metadata;const j=(0,k.$Op)(H.publisher,H.name),U=ee?.id?{id:j,uuid:ee.id}:{id:j},V=ee?.isSystem?t.ExtensionType.System:K.type,le=V===t.ExtensionType.System||!!ee?.isBuiltin;H=await this.t(K.location,H,B.createNlsConfiguration(K));const G={type:V,identifier:U,manifest:H,location:K.location,isBuiltin:le,targetPlatform:ee?.targetPlatform??t.TargetPlatform.UNDEFINED,publisherDisplayName:ee?.publisherDisplayName,metadata:ee,isValid:!0,validations:[]};return K.validate?this.validate(G,K):G}}catch(H){K.type!==t.ExtensionType.System&&this.m.error(H)}return null}validate(K,ee){let H=!0;const j=(0,o.$1p)(ee.productVersion,ee.productDate,ee.location,K.manifest,K.isBuiltin);for(const[U,V]of j)U===p.default.Error&&(H=!1,this.m.error(this.z(ee.location,V)));return K.isValid=H,K.validations=j,K}async scanExtensionManifest(K){const ee=(0,w.$gh)(K,"package.json");let H;try{H=(await this.j.readFile(ee)).value.toString()}catch(U){return(0,i.$ql)(U)!==i.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(K,(0,m.localize)(0,null,ee.path,U.message))),null}let j;try{j=JSON.parse(H)}catch{const V=[];(0,I.$Xn)(H,V);for(const le of V)this.m.error(this.z(K,(0,m.localize)(1,null,ee.path,le.offset,le.length,(0,b.$Iq)(le.error))));return null}return(0,I.$6n)(j)!=="object"?(this.m.error(this.z(K,(0,m.localize)(2,null,ee.path))),null):j}async t(K,ee,H){const j=await this.u(K,ee,H);if(j)try{const U=[],V=await this.w(j.default,U);if(U.length>0)return U.forEach(G=>{this.m.error(this.z(K,(0,m.localize)(3,null,j.default?.path,(0,b.$Iq)(G.error))))}),ee;if((0,I.$6n)(j)!=="object")return this.m.error(this.z(K,(0,m.localize)(4,null,j.default?.path))),ee;const le=j.values||Object.create(null);return(0,L.$Jq)(this.m,ee,le,V)}catch{}return ee}async u(K,ee,H){const j=(0,w.$gh)(K,"package.nls.json"),U=(he,se)=>{se.forEach(_=>{this.m.error(this.z(K,(0,m.localize)(5,null,he?.path,(0,b.$Iq)(_.error))))})},V=he=>{this.m.error(this.z(K,(0,m.localize)(6,null,he?.path)))},le=`${ee.publisher}.${ee.name}`,G=H.translations[le];if(G)try{const he=$.URI.file(G),se=(await this.j.readFile(he)).value.toString(),_=[],F=(0,I.$Xn)(se,_);return _.length>0?(U(he,_),{values:void 0,default:j}):(0,I.$6n)(F)!=="object"?(V(he),{values:void 0,default:j}):{values:F.contents?F.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.j.exists(j))return;let se;try{se=await this.y(K,H)}catch{return}if(!se.localized)return{values:void 0,default:se.original};try{const _=(await this.j.readFile(se.localized)).value.toString(),F=[],N=(0,I.$Xn)(_,F);return F.length>0?(U(se.localized,F),{values:void 0,default:se.original}):(0,I.$6n)(N)!=="object"?(V(se.localized),{values:void 0,default:se.original}):{values:N,default:se.original}}catch{return{values:void 0,default:se.original}}}}async w(K,ee){if(K)try{const H=(await this.j.readFile(K)).value.toString();return(0,I.$Xn)(H,ee)}catch{}}y(K,ee){return new Promise((H,j)=>{const U=V=>{const le=(0,w.$gh)(K,`package.nls.${V}.json`);this.j.exists(le).then(G=>{G&&H({localized:le,original:(0,w.$gh)(K,"package.nls.json")});const he=V.lastIndexOf("-");he===-1?H({localized:(0,w.$gh)(K,"package.nls.json"),original:null}):(V=V.substring(0,he),U(V))})};if(ee.devMode||ee.pseudo||!ee.language)return H({localized:(0,w.$gh)(K,"package.nls.json"),original:null});U(ee.language)})}z(K,ee){return`[${K.path}]: ${ee}`}};C=Se([re(1,E.$Gq),re(2,T.$Jl),re(3,i.$_k),re(4,s.$_j)],C);let z=class extends C{constructor(K,ee,H,j,U,V,le){super(ee,j,U,V,le),this.G=K,this.H=H,this.D=this.B(new r.$Dh(3e3)),this.F=this.B(new d.$me),this.onDidChangeCache=this.F.event}async scanExtensions(K){const ee=this.M(K),H=await this.I(ee);if(this.C=K,H&&H.input&&B.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",K.type===t.ExtensionType.System?"system":"user",K.location.toString()),this.D.trigger(()=>this.L()),H.result.map(U=>(U.location=$.URI.revive(U.location),U));const j=await super.scanExtensions(K);return await this.J(ee,{input:K,result:j}),j}async I(K){try{const ee=await this.j.readFile(K),H=JSON.parse(ee.value.toString());return{result:H.result,input:(0,P.$ci)(H.input)}}catch(ee){this.m.debug("Error while reading the extension cache file:",K.path,(0,A.$_)(ee))}return null}async J(K,ee){try{await this.j.writeFile(K,D.$Oe.fromString(JSON.stringify(ee)))}catch(H){this.m.debug("Error while writing the extension cache file:",K.path,(0,A.$_)(H))}}async L(){if(!this.C)return;const K=this.M(this.C),ee=await this.I(K);if(!ee)return;const H=ee.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!S.$ho(j,H))try{this.m.info("Invalidating Cache",H,j),await this.j.del(K),this.F.fire()}catch(U){this.m.error(U)}}M(K){const ee=this.N(K);return this.h.extUri.joinPath(ee.cacheHome,K.type===t.ExtensionType.System?t.$ln:t.$kn)}N(K){return K.type===t.ExtensionType.System?this.H.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.G.extensionsResource)?this.G:this.H.profiles.find(ee=>this.h.extUri.isEqual(K.location,ee.extensionsResource))??this.G:this.H.defaultProfile}};z=Se([re(2,O.$Ll),re(3,E.$Gq),re(4,T.$Jl),re(5,i.$_k),re(6,s.$_j)],z);function ne(ce,K){const ee=(0,k.$Mp)(ce.manifest.publisher,ce.manifest.name);return{id:ee,identifier:new t.$qn(ee),isBuiltin:ce.type===t.ExtensionType.System,isUserBuiltin:ce.type===t.ExtensionType.User&&ce.isBuiltin,isUnderDevelopment:K,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,publisherDisplayName:ce.publisherDisplayName,...ce.manifest,enabledApiProposals:ce.manifest.enabledApiProposals?(0,t.$yn)([...ce.manifest.enabledApiProposals]):void 0}}class Q extends M{constructor(K,ee,H,j,U,V,le,G,he,se,_,F){super(K,ee,(0,w.$gh)(H,".vscode-oss-dev","extensions","control.json"),j,U,V,le,G,he,se,_,F),this.S=(async()=>{if(g.$z)try{const N=await this.w.readFile($.URI.file(g.$z));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$Oq=Q}),define(oe[281],ae([0,1,5,42,41,24,87,15,38,7]),function(x,e,n,r,S,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=void 0;let h=class extends A.$Hq{constructor(g,w,l,p,y,$){super(a.URI.file(g.extensionsPath),w,l,p,y,$)}};e.$nR=h,e.$nR=h=Se([re(0,b.$Ni),re(1,I.$_k),re(2,r.$Ll),re(3,S.$Jl),re(4,D.$$l),re(5,n.$_j)],h)}),define(oe[282],ae([0,1,7,38,87,134,15,6,5,28,41,42]),function(x,e,n,r,S,D,A,I,b,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;let g=class extends D.$Oq{constructor(l,p,y,$,m,v,k,t){super(n.URI.file(m.builtinExtensionsPath),n.URI.file(m.extensionsPath),m.userHome,l.defaultProfile,l,p,y,$,m,v,k,t)}};e.$$fc=g,e.$$fc=g=Se([re(0,f.$Ll),re(1,S.$Gq),re(2,A.$_k),re(3,b.$_j),re(4,r.$Ni),re(5,a.$sk),re(6,h.$Jl),re(7,I.$Ei)],g)}),define(oe[283],ae([0,1,14,2,13,9,4,61,7,33,37,38,5,42]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;let l=class extends r.$Wc{constructor(y,$,m){super(),this.c=y,this.f=m,this.a=I.$Li.forPaths(!A.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(y.appRoot),this.addValidFileRoot(y.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:S.Schemas.file}).fsPath),this.addValidFileRoot(y.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:y}=n.session;y.protocol.registerFileProtocol(S.Schemas.vscodeFileResource,($,m)=>this.j($,m)),y.protocol.interceptFileProtocol(S.Schemas.file,($,m)=>this.h($,m)),this.B((0,r.$Uc)(()=>{y.protocol.unregisterProtocol(S.Schemas.vscodeFileResource),y.protocol.uninterceptProtocol(S.Schemas.file)}))}addValidFileRoot(y){const $=(0,D.$jc)(y);return this.a.get($)?r.$Wc.None:(this.a.set($,!0),(0,r.$Uc)(()=>this.a.delete($)))}h(y,$){const m=b.URI.parse(y.url);return this.f.error(`Refused to load resource ${m.fsPath} from ${S.Schemas.file}: protocol (original URL: ${y.url})`),$({error:-3})}j(y,$){const m=this.m(y);let v;return this.c.crossOriginIsolated&&((0,D.$pc)(m)==="workbench.html"||(0,D.$pc)(m)==="workbench-dev.html"?v=S.COI.CoopAndCoep:v=S.COI.getHeadersFromQuery(y.url)),this.a.findSubstr(m)?$({path:m,headers:v}):this.b.has((0,D.$qc)(m).toLowerCase())?$({path:m}):(this.f.error(`${S.Schemas.vscodeFileResource}: Refused to load resource ${m} from ${S.Schemas.vscodeFileResource}: protocol (original URL: ${y.url})`),$({error:-3}))}m(y){const $=b.URI.parse(y.url),m=S.$Zg.uriToFileUri($);return(0,D.$jc)(m.fsPath)}createIPCObjectUrl(){let y;const $=b.URI.from({scheme:"vscode",path:(0,a.$2g)()}),m=$.toString(),v=async()=>y;return h.$EX.handle(m,v),this.f.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:$,update:k=>y=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${m}.`),h.$EX.removeHandler(m)}}}};e.$sgc=l,e.$sgc=l=Se([re(0,f.$Ni),re(1,w.$Ll),re(2,g.$_j)],l)}),define(oe[63],ae([0,1,8,3,2,70,12,120,6,42]),function(x,e,n,r,S,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=w,e.$iq=p,e.$kq=$,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,b.$Fi)("storageService");var h;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(h||(e.WillSaveStateReason=h={}));var f;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(f||(e.StorageScope=f={}));var g;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function w(m){const v=m.get(e.$eq);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}class l extends S.$Wc{static{this.a=60*1e3}constructor(v={flushInterval:l.a}){super(),this.m=v,this.b=this.B(new r.$pe),this.c=this.B(new r.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$me),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new S.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(v,k,t){return r.Event.filter(this.b.event,o=>o.scope===v&&(k===void 0||o.key===k),t)}n(){this.j.value=(0,n.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,S.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(v,k){const{key:t,external:o}=k;if(t===e.$eq){switch(v){case f.APPLICATION:this.H=void 0;break;case f.PROFILE:this.F=void 0;break;case f.WORKSPACE:this.C=void 0;break}this.c.fire({scope:v})}else this.b.fire({scope:v,key:t,target:this.J(v)[t],external:o})}w(v){this.f.fire({reason:v})}get(v,k,t){return this.P(k)?.get(v,t)}getBoolean(v,k,t){return this.P(k)?.getBoolean(v,t)}getNumber(v,k,t){return this.P(k)?.getNumber(v,t)}getObject(v,k,t){return this.P(k)?.getObject(v,t)}storeAll(v,k){this.y(()=>{for(const t of v)this.store(t.key,t.value,t.scope,t.target,k)})}store(v,k,t,o,i=!1){if((0,A.$og)(k)){this.remove(v,t,i);return}this.y(()=>{this.z(v,t,o),this.P(t)?.set(v,k,i)})}remove(v,k,t=!1){this.y(()=>{this.z(v,k,void 0),this.P(k)?.delete(v,t)})}y(v){this.b.pause(),this.c.pause();try{v()}finally{this.b.resume(),this.c.resume()}}keys(v,k){const t=[],o=this.J(v);for(const i of Object.keys(o))o[i]===k&&t.push(i);return t}z(v,k,t,o=!1){const i=this.J(k);typeof t=="number"?i[v]!==t&&(i[v]=t,this.P(k)?.set(e.$eq,JSON.stringify(i),o)):typeof i[v]=="number"&&(delete i[v],this.P(k)?.set(e.$eq,JSON.stringify(i),o))}get D(){return this.C||(this.C=this.L(f.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(f.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(f.APPLICATION)),this.H}J(v){switch(v){case f.APPLICATION:return this.I;case f.PROFILE:return this.G;default:return this.D}}L(v){const k=this.P(v);return k?w(k):Object.create(null)}isNew(v){return this.getBoolean(e.$dq,v)===!0}async flush(v=h.NONE){this.f.fire({reason:v});const k=this.P(f.APPLICATION),t=this.P(f.PROFILE),o=this.P(f.WORKSPACE);switch(v){case h.NONE:await n.Promises.settled([k?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case h.SHUTDOWN:await n.Promises.settled([k?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.P(f.APPLICATION)?.items??new Map,k=this.P(f.PROFILE)?.items??new Map,t=this.P(f.WORKSPACE)?.items??new Map;return $(v,k,t,this.Q(f.APPLICATION)??"",this.Q(f.PROFILE)??"",this.Q(f.WORKSPACE)??"")}async optimize(v){return await this.flush(),this.P(v)?.optimize()}async switch(v,k){return this.w(h.NONE),(0,a.$Kl)(v)?this.R(v,k):this.S(v,k)}M(v,k){return!(v.id===k.id||p(k)&&p(v))}N(v,k,t){this.y(()=>{const o=new Set;for(const[i,c]of v)o.add(i),k.get(i)!==c&&this.u(t,{key:i,external:!0});for(const[i]of k.items)o.has(i)||this.u(t,{key:i,external:!0})})}}e.$hq=l;function p(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class y extends l{constructor(){super(),this.U=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(v=>this.u(f.WORKSPACE,v))),this.B(this.W.onDidChangeStorage(v=>this.u(f.PROFILE,v))),this.B(this.U.onDidChangeStorage(v=>this.u(f.APPLICATION,v)))}P(v){switch(v){case f.APPLICATION:return this.U;case f.PROFILE:return this.W;default:return this.X}}Q(v){switch(v){case f.APPLICATION:return"inMemory (application)";case f.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(v){return!1}}e.$jq=y;async function $(m,v,k,t,o,i){const c=R=>{try{return JSON.parse(R)}catch{return R}},s=new Map,u=new Map;m.forEach((R,M)=>{s.set(M,R),u.set(M,c(R))});const d=new Map,P=new Map;v.forEach((R,M)=>{d.set(M,R),P.set(M,c(R))});const E=new Map,O=new Map;k.forEach((R,M)=>{E.set(M,R),O.set(M,c(R))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const T=[];if(s.forEach((R,M)=>{T.push({key:M,value:R})}),console.table(T),console.groupEnd(),console.log(u),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const R=[];d.forEach((M,B)=>{R.push({key:B,value:M})}),console.table(R),console.groupEnd(),console.log(P)}console.group(`Storage: Workspace (path: ${i})`);const L=[];E.forEach((R,M)=>{L.push({key:M,value:R})}),console.table(L),console.groupEnd(),console.log(O)}}),define(oe[284],ae([0,1,17,33,63]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=D;async function D(A,I,b){let a=b&&b.get("storage.serviceMachineId",S.StorageScope.APPLICATION)||null;if(a)return a;try{const f=(await I.readFile(A.serviceMachineIdResource)).value.toString();a=(0,r.$1g)(f)?f:null}catch{a=null}if(!a){a=(0,r.$2g)();try{await I.writeFile(A.serviceMachineIdResource,n.$Oe.fromString(a))}catch{}}return b?.store("storage.serviceMachineId",a,S.StorageScope.APPLICATION,S.StorageTarget.MACHINE),a}}),define(oe[285],ae([0,1,284,24,56]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=D;async function D(A,I,b,a,h,f,g){const w={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${I.nameShort})`};if((0,S.$Bp)(I,b)&&(0,S.$Dp)(a)===r.TelemetryLevel.USAGE){const l=await(0,n.$lq)(b,h,f);w["X-Market-User-Id"]=l,w["VSCode-SessionId"]=g.machineId||l}return w}}),define(oe[286],ae([0,1,22,8,3,2,9,66,7,21,120,166,5,63,24,30,13]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=e.$1ec=e.$Zec=e.$Yec=void 0;class $ extends D.$Wc{static{this.a=2e3}get storage(){return this.f}constructor(c,s){super(),this.m=c,this.n=s,this.b=this.B(new S.$me),this.onDidChangeStorage=this.b.event,this.c=this.B(new S.$me),this.onDidCloseStorage=this.c.event,this.f=this.B(new h.$bq(new h.$cq,{hint:h.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new r.$3h,this.whenInit=this.h.p,this.j=h.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===h.StorageState.None)try{const c=this.B(await this.t());this.f.dispose(),this.f=c,this.B(c.onDidChangeStorage(u=>this.b.fire(u))),await this.s(c);const s=c.getBoolean(w.$dq);s===void 0?c.set(w.$dq,!0):s&&c.set(w.$dq,!1)}catch(c){this.m.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.j=h.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===g.LogLevel.Trace?c=>this.m.trace(c):void 0,logError:c=>this.m.error(c)}}s(c){return c.init()}get items(){return this.f.items}get(c,s){return this.f.get(c,s)}set(c,s){return this.f.set(c,s)}delete(c){return this.f.delete(c)}optimize(){return this.f.optimize()}async close(){const c=new I.$ge(!1);await this.w(),c.stop(),c.elapsed()>$.a&&await this.u(c),this.c.fire()}async u(c){if(this.path)try{const s=(0,n.top)(Array.from(this.f.items.entries()).map(([d,P])=>({key:d,length:P.length})),(d,P)=>P.length-d.length,5).map(d=>`${d.key}:${d.length}`).join(", "),u=(await this.n.stat(b.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${u}b, Large Keys: ${s}`)}catch(s){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",s)}}async w(){this.g&&await this.g,this.j=h.StorageState.Closed,await this.f.close()}}class m extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,A.$lc)(this.z.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,m.y)}constructor(c,s,u,d){super(u,d),this.z=c,this.C=s}async t(){return new h.$bq(new f.$0X(this.path??f.$0X.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:h.StorageHint.STORAGE_IN_MEMORY})}}class v extends m{constructor(c,s,u,d){super(c,s,u,d)}}e.$Yec=v;class k extends m{constructor(c,s,u,d){super(s.defaultProfile,c,u,d)}async s(c){await super.s(c),this.G(c)}G(c){c.get(l.$bm,void 0)===void 0&&c.set(l.$bm,new Date().toUTCString());const u=c.get(l.$am,void 0),d=new Date().toUTCString();c.set(l.$cm,typeof u>"u"?null:u),c.set(l.$am,d)}}e.$Zec=k;class t extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,A.$lc)(this.F.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,this.C.id,t.y)}constructor(c,s,u,d,P){super(u,P),this.C=c,this.D=s,this.F=d}async t(){const{storageFilePath:c,wasCreated:s}=await this.H();return new h.$bq(new f.$0X(c,{logging:this.r()}),{hint:this.D.useInMemoryStorage?h.StorageHint.STORAGE_IN_MEMORY:s?h.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:f.$0X.IN_MEMORY_PATH,wasCreated:!0};const c=(0,A.$lc)(this.F.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,this.C.id),s=(0,A.$lc)(c,t.y);return await a.Promises.exists(c)?{storageFilePath:s,wasCreated:!1}:(await a.Promises.mkdir(c,{recursive:!0}),this.I(c),{storageFilePath:s,wasCreated:!0})}async I(c){let s;if((0,p.$Pi)(this.C)?s={folder:this.C.uri.toString()}:(0,p.$Ui)(this.C)&&(s={workspace:this.C.configPath.toString()}),s)try{const u=(0,A.$lc)(c,t.z);await a.Promises.exists(u)||await a.Promises.writeFile(u,JSON.stringify(s,void 0,2))}catch(u){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.$1ec=t;class o extends ${get path(){}async t(){return new h.$bq(new h.$cq,{hint:h.StorageHint.STORAGE_IN_MEMORY})}}e.$2ec=o}),define(oe[287],ae([0,1,3,2,63]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;class D extends r.$Wc{constructor(I,b,a){super(),this.b=I,this.c=b,this.f=a;const h=this.B(new r.$Xc);this.a=this.B(new n.$me({onWillAddFirstListener:()=>h.value=this.g(),onDidRemoveLastListener:()=>h.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new r.$Vc;return I.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(b,a)=>(b?b.push(a.key):b=[a.key],b),100)(b=>this.h(b))),I.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(b,a)=>{b||(b=new Map);let h=b.get(a.profile.id);return h||b.set(a.profile.id,h={profile:a.profile,keys:[],storage:a.storage}),h.keys.push(a.key),b},100)(b=>this.j(b))),I}h(I){const b=I.includes(S.$eq)?[this.c.defaultProfile]:[],a=[];if(I=I.filter(h=>h!==S.$eq),I.length){const h=(0,S.$gq)(this.b.applicationStorage.storage);a.push({profile:this.c.defaultProfile,changes:I.map(f=>({key:f,scope:S.StorageScope.PROFILE,target:h[f]}))})}this.m(b,a)}j(I){const b=[],a=new Map;for(const[h,f]of I.entries()){f.keys.includes(S.$eq)&&b.push(f.profile);const g=f.keys.filter(w=>w!==S.$eq);if(g.length){const w=(0,S.$gq)(f.storage.storage);a.set(h,{profile:f.profile,changes:g.map(l=>({key:l,scope:S.StorageScope.PROFILE,target:w[l]}))})}}this.m(b,[...a.values()])}m(I,b){(I.length||b.length)&&this.a.fire({valueChanges:b,targetChanges:I})}listen(I,b,a){switch(b){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${b}`)}async call(I,b){throw new Error(`Call not found: ${b}`)}}e.$agc=D}),define(oe[288],ae([0,1,7,38,15,5,34,41,42,12,128]),function(x,e,n,r,S,D,A,I,b,a,h){"use strict";var f,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$mR=e.$lR=e.$kR=void 0;let w=class extends b.$Ol{static{f=this}static{this.a="profileAssociationsMigration"}constructor($,m,v,k,t){super(v,k,m,t),this.U=$,this.W=v}O(){return this.U.getItem(f.b,[]).map(m=>({...m,location:(0,a.$fg)(m.location)?this.w.extUri.joinPath(this.profilesHome,m.location):n.URI.revive(m.location)}))}Q(){const $=this.U.getItem(f.c,{});return this.U.getItem(f.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$kR=w,e.$kR=w=f=Se([re(0,A.$fR),re(1,I.$Jl),re(2,r.$Ni),re(3,S.$_k),re(4,D.$_j)],w);let l=g=class extends w{constructor($,m,v,k,t){super($,m,v,k,t),this.$=$}P($){$.length?this.$.setItem(g.b,$.map(m=>({...m,location:this.w.extUri.basename(m.location)}))):this.$.removeItem(g.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(g.c,$):this.$.removeItem(g.c)}Q(){const $="workspaceAndProfileInfo",m=this.$.getItem($,void 0);if(m){this.$.removeItem($);const k=m.reduce((t,{workspace:o,profile:i})=>(t[n.URI.revive(o).toString()]=n.URI.revive(i).toString(),t),{});this.$.setItem(g.c,{workspaces:k})}const v=super.Q();return this.$.getItem(g.a,!1)||(this.R(v),this.$.setItem(g.a,!0)),v}};e.$lR=l,e.$lR=l=g=Se([re(0,A.$gR),re(1,I.$Jl),re(2,r.$Ni),re(3,S.$_k),re(4,D.$_j)],l);let p=class extends l{constructor($,m,v,k){super(new h.$jR(h.SaveStrategy.IMMEDIATE,m,k,v),$,m,v,k)}async init(){return await this.$.init(),super.init()}};e.$mR=p,e.$mR=p=Se([re(0,I.$Jl),re(1,r.$Ni),re(2,S.$_k),re(3,D.$_j)],p)}),define(oe[59],ae([0,1,38,15,6,5,41,42,288,34]),function(x,e,n,r,S,D,A,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=e.$Gec=void 0,e.$Gec=(0,S.$Gi)(I.$Ll);let h=class extends b.$lR{constructor(g,w,l,p,y){super(g,w,l,p,y)}getAssociatedEmptyWindows(){const g=[];for(const w of this.C.emptyWindows.keys())g.push({id:w});return g}};e.$Hec=h,e.$Hec=h=Se([re(0,a.$gR),re(1,A.$Jl),re(2,n.$Ni),re(3,r.$_k),re(4,D.$_j)],h)}),define(oe[135],ae([0,1,19,7,30]),function(x,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=D,e.$Jec=A,e.$Kec=I;async function D(b,a,h){for(const g of b){const w=g.openedWorkspace;if((0,S.$Ui)(w)){const l=await h(w);if(l){if(l.folders.some(p=>n.$0g.isEqualOrParent(a,p.uri)))return g}else if(n.$0g.isEqualOrParent(a,w.configPath))return g}}const f=b.filter(g=>(0,S.$Pi)(g.openedWorkspace)&&n.$0g.isEqualOrParent(a,g.openedWorkspace.uri));if(f.length)return f.sort((g,w)=>-(g.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}function A(b,a){for(const h of b)if((0,S.$Ui)(h.openedWorkspace)&&n.$0g.isEqual(h.openedWorkspace.configPath,a)||(0,S.$Pi)(h.openedWorkspace)&&n.$0g.isEqual(h.openedWorkspace.uri,a))return h}function I(b,a){const h=f=>a.some(g=>n.$0g.isEqual(r.URI.file(g),r.URI.file(f)));for(const f of b)if(f.config?.extensionDevelopmentPath?.some(g=>h(g)))return f}}),define(oe[103],ae([0,1,31,43,108,48,13,9,4,19,7,6,72,30]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihb=void 0,e.$Jhb=l,e.$Khb=p,e.$Lhb=y,e.$Mhb=$,e.$Nhb=k,e.$Ohb=o,e.$Phb=i,e.$Qhb=P,e.$Rhb=E,r=Re(r),S=Re(S),e.$Ihb=(0,f.$Fi)("workspacesService");function l(O){return O.hasOwnProperty("workspace")}function p(O){return O.hasOwnProperty("folderUri")}function y(O){return O.hasOwnProperty("fileUri")}function $(O){return m(O)||v(O)}function m(O){const T=O;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function v(O){const T=O;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function k(O,T,L,R,M){if(O.scheme!==R.scheme)return{name:L,uri:O.toString(!0)};let B=T?void 0:M.relativePath(R,O);if(B!==void 0)B.length===0?B=".":b.$i&&(B=t(B));else if(O.scheme===A.Schemas.file)B=O.fsPath,b.$i&&(B=t(B));else if(M.isEqualAuthority(O.authority,R.authority))B=O.path;else return{name:L,uri:O.toString(!0)};return{name:L,path:B}}function t(O){return O=(0,D.$Ww)(O),(0,n.$Bg)(O)||(O=(0,n.$yg)(O)),O}function o(O,T,L){const R=[],M=new Set,B=L.dirname(T);for(const C of O){let z;if(m(C))C.path&&(z=L.resolvePath(B,C.path));else if(v(C))try{z=h.URI.parse(C.uri),z.path[0]!==I.$ic.sep&&(z=z.with({path:I.$ic.sep+z.path}))}catch(ne){console.warn(ne)}if(z){const ne=L.getComparisonKey(z);if(!M.has(ne)){M.add(ne);const Q=C.name||L.basenameOrAuthority(z);R.push(new w.$Zi({uri:z,name:Q,index:R.length},C))}}}return R}function i(O,T,L,R,M){const B=c(T,O),C=M.dirname(T),z=M.dirname(R),ne=[];for(const ee of B.folders){const H=m(ee)?M.resolvePath(C,ee.path):h.URI.parse(ee.uri);let j;L?j=!1:j=!m(ee)||(0,I.$kc)(ee.path),ne.push(k(H,j,ee.name,z,M))}const Q={insertSpaces:!1,tabSize:4,eol:b.$k||b.$j?`
`:`\r
`},ce=S.$_n(O,["folders"],ne,Q);let K=S.$co(O,ce);return(0,a.$lh)(B.remoteAuthority,(0,g.$gn)(R))&&(K=S.$co(K,S.$$n(K,["remoteAuthority"],Q))),K}function c(O,T){const L=r.$Xn(T);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(R=>$(R));else throw new Error(`${O} looks like an invalid workspace file.`);return L}function s(O){return O.workspace&&typeof O.workspace=="object"&&typeof O.workspace.id=="string"&&typeof O.workspace.configPath=="string"}function u(O){return typeof O.folderUri=="string"}function d(O){return typeof O.fileUri=="string"}function P(O,T){const L={workspaces:[],files:[]};if(O){const R=function(B,C){for(let z=0;z<B.length;z++)try{C(B[z],z)}catch(ne){T.warn(`Error restoring recent entry ${JSON.stringify(B[z])}: ${ne.toString()}. Skip entry.`)}},M=O;Array.isArray(M.entries)&&R(M.entries,B=>{const C=B.label,z=B.remoteAuthority;s(B)?L.workspaces.push({label:C,remoteAuthority:z,workspace:{id:B.workspace.id,configPath:h.URI.parse(B.workspace.configPath)}}):u(B)?L.workspaces.push({label:C,remoteAuthority:z,folderUri:h.URI.parse(B.folderUri)}):d(B)&&L.files.push({label:C,remoteAuthority:z,fileUri:h.URI.parse(B.fileUri)})})}return L}function E(O){const T={entries:[]};for(const L of O.workspaces)p(L)?T.entries.push({folderUri:L.folderUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority}):T.entries.push({workspace:{id:L.workspace.id,configPath:L.workspace.configPath.toString()},label:L.label,remoteAuthority:L.remoteAuthority});for(const L of O.files)T.entries.push({fileUri:L.fileUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority});return T}}),define(oe[104],ae([0,1,92,13,4,19]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0,e.$Mec=A,e.$Nec=I,e.$Oec=b,e.$Lec=128/4;function A(a){function h(){let f=a.scheme===r.Schemas.file?(0,D.$7g)(a):a.toString();return S.$k||(f=f.toLowerCase()),(0,n.createHash)("md5").update(f).digest("hex")}return{id:h(),configPath:a}}function I(a,h){function f(){if(a.scheme!==r.Schemas.file)return(0,n.createHash)("md5").update(a.toString()).digest("hex");if(!h)return;let w;return S.$k?w=h.ino:S.$j?w=h.birthtime.getTime():S.$i&&(typeof h.birthtimeMs=="number"?w=Math.floor(h.birthtimeMs):w=h.birthtime.getTime()),(0,n.createHash)("md5").update(a.fsPath).update(w?String(w):"").digest("hex")}const g=f();if(typeof g=="string")return{id:g,uri:a}}function b(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(oe[105],ae([0,1,92,93,27,289,17,16,3,2,9,4,33,44,118]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$wi=e.$vi=e.$ui=void 0,e.$xi=s,e.$yi=u,e.$Ai=E,e.$Bi=O;const p=3e4;class y{traceSocketEvent(L,R){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,R)}constructor(L,R=""){this.f=!0,this.debugLabel=R,this.socket=L,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=B=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:B?.code,message:B?.message}),B){if(B.code==="EPIPE")return;(0,I.$3)(B)}},this.socket.on("error",this.a);let M;this.b=B=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:B}),this.f=!1,M&&clearTimeout(M)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,M=setTimeout(()=>L.destroy(),p)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(L){const R=M=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,M),L(A.$Oe.wrap(M))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(L){const R=M=>{L({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:M,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(L){const R=()=>{L()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(L){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,L),this.socket.write(L.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,I.$3)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,I.$3)(R)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((L,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),L();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),L()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$ui=y;var $;(function(T){T[T.MinHeaderByteSize=2]="MinHeaderByteSize",T[T.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var m;(function(T){T[T.PeekHeader=1]="PeekHeader",T[T.ReadHeader=2]="ReadHeader",T[T.ReadBody=3]="ReadBody",T[T.Fin=4]="Fin"})(m||(m={}));class v extends a.$Wc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(L,R){this.socket.traceSocketEvent(L,R)}constructor(L,R,M,B){super(),this.f=this.B(new b.$me),this.g=this.B(new b.$me),this.h=!1,this.j={state:m.PeekHeader,readLen:$.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=L,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:M?.byteLength||0,recordInflateBytes:B}),this.a=this.B(new k(this,R,M,B,this.f,(C,z)=>this.m(C,z))),this.B(this.a.onError(C=>{console.error(C),(0,I.$3)(C),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:C})})),this.b=new l.$pi,this.B(this.socket.onData(C=>this.n(C))),this.B(this.socket.onClose(async C=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(C)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this.f.event(L)}onClose(L){return this.g.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){let R=0;for(;R<L.byteLength;)this.a.writeMessage(L.slice(R,Math.min(R+$.MaxWebSocketMessageLength,L.byteLength)),{compressed:!0,opcode:2}),R+=$.MaxWebSocketMessageLength}m(L,{compressed:R,opcode:M}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,L);let B=$.MinHeaderByteSize;L.byteLength<126?B+=0:L.byteLength<2**16?B+=2:B+=8;const C=A.$Oe.alloc(B),z=R?64:0,ne=M&15;if(C.writeUInt8(128|z|ne,0),L.byteLength<126)C.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){C.writeUInt8(126,1);let Q=1;C.writeUInt8(L.byteLength>>>8&255,++Q),C.writeUInt8(L.byteLength>>>0&255,++Q)}else{C.writeUInt8(127,1);let Q=1;C.writeUInt8(0,++Q),C.writeUInt8(0,++Q),C.writeUInt8(0,++Q),C.writeUInt8(0,++Q),C.writeUInt8(L.byteLength>>>24&255,++Q),C.writeUInt8(L.byteLength>>>16&255,++Q),C.writeUInt8(L.byteLength>>>8&255,++Q),C.writeUInt8(L.byteLength>>>0&255,++Q)}this.socket.write(A.$Oe.concat([C,L]))}end(){this.h=!0,this.socket.end()}n(L){if(L.byteLength!==0){for(this.b.acceptChunk(L);this.b.byteLength>=this.j.readLen;)if(this.j.state===m.PeekHeader){const R=this.b.peek(this.j.readLen),M=R.readUInt8(0),B=(M&128)>>>7,C=(M&64)>>>6,z=M&15,ne=R.readUInt8(1),Q=(ne&128)>>>7,ce=ne&127;this.j.state=m.ReadHeader,this.j.readLen=$.MinHeaderByteSize+(Q?4:0)+(ce===126?2:0)+(ce===127?8:0),this.j.fin=B,this.j.firstFrameOfMessage&&(this.j.compressed=!!C),this.j.firstFrameOfMessage=!!B,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===m.ReadHeader){const R=this.b.read(this.j.readLen),M=R.readUInt8(1),B=(M&128)>>>7;let C=M&127,z=1;C===126?C=R.readUInt8(++z)*2**8+R.readUInt8(++z):C===127&&(C=R.readUInt8(++z)*0+R.readUInt8(++z)*0+R.readUInt8(++z)*0+R.readUInt8(++z)*0+R.readUInt8(++z)*2**24+R.readUInt8(++z)*2**16+R.readUInt8(++z)*2**8+R.readUInt8(++z));let ne=0;B&&(ne=R.readUInt8(++z)*2**24+R.readUInt8(++z)*2**16+R.readUInt8(++z)*2**8+R.readUInt8(++z)),this.j.state=m.ReadBody,this.j.readLen=C,this.j.mask=ne,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===m.ReadBody){const R=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,R),i(R,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,R),this.j.state=m.PeekHeader,this.j.readLen=$.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(R,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(R,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$vi=v;class k extends a.$Wc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$Oe.alloc(0)}constructor(L,R,M,B,C,z){super(),this.n=L,this.r=C,this.s=z,this.a=this.B(new b.$me),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$me),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$me),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,R?(this.b=this.B(new t(this.n,B,M,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(ne=>this.a.fire(ne))),this.B(this.f.onError(ne=>this.a.fire(ne)))):(this.b=null,this.f=null)}writeMessage(L,R){this.g.push({data:L,options:R}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:L,options:R}=this.g.shift();if(this.f&&R.compressed){const M=await this.w(this.f,L);this.s(M,R)}else this.s(L,{...R,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(L,R){return new Promise((M,B)=>{L.write(R),L.flush(C=>M(C))})}acceptFrame(L,R,M){this.h.push({data:L,isCompressed:R,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const L=this.h.shift();if(this.b&&L.isCompressed){const R=await this.C(this.b,L.data,L.isLastFrameOfMessage);this.r.fire(R)}else this.r.fire(L.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(L,R,M){return new Promise((B,C)=>{L.write(R),M&&L.write(A.$Oe.fromByteArray([0,0,255,255])),L.flush(z=>B(z))})}}class t extends a.$Wc{get recordedInflateBytes(){return this.j?A.$Oe.concat(this.f):A.$Oe.alloc(0)}constructor(L,R,M,B){super(),this.h=L,this.j=R,this.a=this.B(new b.$me),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(B),this.b.on("error",C=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,C),this.g.push(A.$Oe.wrap(C))}),M&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(L){this.j&&this.f.push(L.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,L),this.b.write(L.buffer)}flush(L){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const R=A.$Oe.concat(this.g);this.g.length=0,L(R)})}}class o extends a.$Wc{constructor(L,R){super(),this.g=L,this.a=this.B(new b.$me),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,M),this.f.push(A.$Oe.wrap(M))})}write(L){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,L.buffer),this.b.write(L.buffer)}flush(L){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let R=A.$Oe.concat(this.f);this.f.length=0,R=R.slice(0,R.byteLength-4),L(R)})}}function i(T,L){if(L===0)return;const R=T.byteLength>>>2;for(let Q=0;Q<R;Q++){const ce=T.readUInt32BE(Q*4);T.writeUInt32BE(ce^L,Q*4)}const M=R*4,B=T.byteLength-M,C=L>>>24&255,z=L>>>16&255,ne=L>>>8&255;B>=1&&T.writeUInt8(T.readUInt8(M)^C,M),B>=2&&T.writeUInt8(T.readUInt8(M+1)^z,M+1),B>=3&&T.writeUInt8(T.readUInt8(M+2)^ne,M+2)}e.$wi=process.env.XDG_RUNTIME_DIR;const c={[f.Platform.Linux]:107,[f.Platform.Mac]:103};function s(){const T=(0,g.$2g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${T}-sock`;const L=process.platform!=="darwin"&&e.$wi?e.$wi:(0,S.tmpdir)(),R=(0,h.$lc)(L,`vscode-ipc-${T}.sock`);return d(R),R}function u(T,L,R){const B=(0,n.createHash)("sha256").update(T).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${B}-${R}-${L}-sock`;const C=R.substr(0,4),z=L.substr(0,6);let ne;return process.platform!=="darwin"&&e.$wi&&!process.env.VSCODE_PORTABLE?ne=(0,h.$lc)(e.$wi,`vscode-${B}-${C}-${z}.sock`):ne=(0,h.$lc)(T,`${C}-${z}.sock`),d(ne),ne}function d(T){const L=c[f.$u];typeof L=="number"&&T.length>=L&&console.warn(`WARNING: IPC handle "${T}" is longer than ${L} chars, try a shorter --user-data-dir`)}class P extends w.$ji{static b(L){const R=b.Event.fromNodeEventEmitter(L,"connection");return b.Event.map(R,M=>({protocol:new l.$qi(new y(M,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(M,"close"))}))}constructor(L){super(P.b(L)),this.d=L}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$zi=P;function E(T){return new Promise((L,R)=>{const M=(0,r.createServer)();M.on("error",R),M.listen(T,()=>{M.removeListener("error",R),L(new P(M))})})}function O(T,L){return new Promise((R,M)=>{const B=(0,r.createConnection)(T,()=>{B.removeListener("error",M),R(l.$ri.fromSocket(new y(B,`ipc-client${L}`),L))});B.once("error",M)})}}),define(oe[25],ae([0,1,52,9,4,105,38,96,6]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=e.$sec=void 0,e.$sec=(0,b.$Gi)(A.$Mi);class a extends I.$8m{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,r.$lc)(this.userDataPath,"clp")}get backupHome(){return(0,r.$lc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,D.$yi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,r.$lc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(S.$k){for(const f in process.env)if(f.endsWith("_VSCODE_SNAP_ORIG")){const g=f.slice(0,-17);if(this.d[g])continue;process.env[g]&&(this.d[g]=process.env[g]),process.env[f]?process.env[g]=process.env[f]:delete process.env[g]}}}restoreSnapExportedVariables(){if(S.$k)for(const f in this.d)process.env[f]=this.d[f],delete this.d[f]}}e.$tec=a,Se([n.$0h],a.prototype,"cachedLanguagesPath",null),Se([n.$0h],a.prototype,"backupHome",null),Se([n.$0h],a.prototype,"mainIPCHandle",null),Se([n.$0h],a.prototype,"mainLockfile",null),Se([n.$0h],a.prototype,"disableUpdates",null),Se([n.$0h],a.prototype,"crossOriginIsolated",null),Se([n.$0h],a.prototype,"codeCachePath",null),Se([n.$0h],a.prototype,"useCodeCache",null)}),define(oe[290],ae([0,1,92,31,13,9,4,19,21,202,18,25,34,15,5,201,30,104]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;let v=class{static{m=this}static{this.a="backupWorkspaces"}constructor(t,o,i,c){this.j=t,this.k=o,this.l=i,this.m=c,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$0g,this.i={isEqual:(s,u)=>(0,r.$Dg)(s,u,!A.$k)}}async initialize(){const t=this.m.getItem(m.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(t.emptyWindows),this.d=await this.u((0,a.$vec)(t)),this.e=await this.v((0,a.$wec)(t)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==w.$yl.OFF}q(){return this.s()===w.$yl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||w.$yl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(t,o){this.d.some(c=>t.workspace.id===c.workspace.id)||(this.d.push(t),this.C());const i=(0,D.$lc)(this.c,t.workspace.id);return o?this.t(i,o).then(()=>i):i}async t(t,o){if(await b.Promises.exists(t)&&await this.z(t),await b.Promises.exists(o))try{await b.Promises.rename(o,t,!1)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(t){return this.e.some(o=>this.h.isEqual(t.folderUri,o.folderUri))||(this.e.push(t),this.C()),(0,D.$lc)(this.c,this.D(t))}registerEmptyWindowBackup(t){return this.g.some(o=>!!o.backupFolder&&this.i.isEqual(o.backupFolder,t.backupFolder))||(this.g.push(t),this.C()),(0,D.$lc)(this.c,t.backupFolder)}async u(t){if(!Array.isArray(t))return[];const o=new Set,i=[];for(const c of t){const s=c.workspace;if(!(0,y.$Ui)(s))return[];if(!o.has(s.id)){o.add(s.id);const u=(0,D.$lc)(this.c,s.id);await this.B(u)?s.configPath.scheme!==S.Schemas.file||await b.Promises.exists(s.configPath.fsPath)?i.push(c):await this.z(u):await this.x(u)}}return i}async v(t){if(!Array.isArray(t))return[];const o=[],i=new Set;for(const c of t){const s=c.folderUri,u=this.h.getComparisonKey(s);if(!i.has(u)){i.add(u);const d=(0,D.$lc)(this.c,this.D(c));await this.B(d)?s.scheme!==S.Schemas.file||await b.Promises.exists(s.fsPath)?o.push(c):await this.z(d):await this.x(d)}}return o}async w(t){if(!Array.isArray(t))return[];const o=[],i=new Set;for(const c of t){const s=c.backupFolder;if(typeof s!="string")return[];if(!i.has(s)){i.add(s);const u=(0,D.$lc)(this.c,s);await this.B(u)?o.push(c):await this.x(u)}}return o}async x(t){try{await b.Promises.rm(t,b.RimRafMode.MOVE)}catch(o){this.l.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}y(){let t=(0,$.$Oec)();for(;this.g.some(o=>!!o.backupFolder&&this.i.isEqual(o.backupFolder,t.id));)t=(0,$.$Oec)();return{backupFolder:t.id}}async z(t){const o=this.y(),i=(0,D.$lc)(this.c,o.backupFolder);try{await b.Promises.rename(t,i,!1)}catch(c){return this.l.error(`Backup: Could not rename backup folder: ${c.toString()}`),!1}return this.g.push(o),!0}async getDirtyWorkspaces(){const t=[];for(const o of this.d)await this.A(o)&&t.push(o);for(const o of this.e)await this.A(o)&&t.push(o);return t}A(t){let o;return(0,a.$uec)(t)?o=(0,D.$lc)(this.c,t.backupFolder):(0,p.$Ghb)(t)?o=(0,D.$lc)(this.c,this.D(t)):o=(0,D.$lc)(this.c,t.workspace.id),this.B(o)}async B(t){try{const o=await b.Promises.readdir(t);for(const i of o)try{if((await b.Promises.readdir((0,D.$lc)(t,i))).length>0)return!0}catch{}}catch{}return!1}C(){const t={workspaces:this.d.map(({workspace:o,remoteAuthority:i})=>{const c={id:o.id,configURIPath:o.configPath.toString()};return i&&(c.remoteAuthority=i),c}),folders:this.e.map(({folderUri:o,remoteAuthority:i})=>{const c={folderUri:o.toString()};return i&&(c.remoteAuthority=i),c}),emptyWindows:this.g.map(({backupFolder:o,remoteAuthority:i})=>{const c={backupFolder:o};return i&&(c.remoteAuthority=i),c})};this.m.setItem(m.a,t)}D(t){const o=t.folderUri;let i;return o.scheme===S.Schemas.file?i=A.$k?o.fsPath:o.fsPath.toLowerCase():i=o.toString().toLowerCase(),(0,n.createHash)("md5").update(i).digest("hex")}};e.$8ec=v,e.$8ec=v=m=Se([re(0,f.$sec),re(1,h.$_i),re(2,l.$_j),re(3,g.$gR)],v)}),define(oe[20],ae([0,1,14,37,8,3,2,4,36,12,6,5,34,51,25]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=e.LifecycleMainPhase=e.ShutdownReason=e.$Wec=void 0,e.$Wec=(0,h.$Fi)("lifecycleMainService");var y;(function(v){v[v.QUIT=1]="QUIT",v[v.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var $;(function(v){v[v.Starting=1]="Starting",v[v.Ready=2]="Ready",v[v.AfterWindowOpen=3]="AfterWindowOpen",v[v.Eventually=4]="Eventually"})($||(e.LifecycleMainPhase=$={}));let m=class extends A.$Wc{static{p=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(k,t,o){super(),this.F=k,this.G=t,this.H=o,this.c=this.B(new D.$me),this.onBeforeShutdown=this.c.event,this.f=this.B(new D.$me),this.onWillShutdown=this.f.event,this.g=this.B(new D.$me),this.onWillLoadWindow=this.g.event,this.h=this.B(new D.$me),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=$.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when($.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(p.b),this.m&&this.G.removeItem(p.b)}J(){const k=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$j&&this.t===0&&this.L(y.QUIT))};n.app.addListener("before-quit",k);const t=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$j)&&n.app.quit()};n.app.addListener("window-all-closed",t),n.app.once("will-quit",o=>{this.S("Lifecycle#app.on(will-quit) - begin"),o.preventDefault(),this.L(y.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",k),n.app.removeListener("window-all-closed",t),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(k){if(this.y)return this.y;const t=this.F;this.S("Lifecycle#onWillShutdown.fire()");const o=[];return this.f.fire({reason:k,join(i,c){t.trace(`Lifecycle#onWillShutdown - begin '${i}'`),o.push(c.finally(()=>{t.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await S.Promises.settled(o)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(k){if(k<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===k)return;this.S(`lifecycle (main): phase changed (value: ${k})`),this.n=k;const t=this.C.get(this.n);t&&(t.open(),this.C.delete(this.n))}async when(k){if(k<=this.n)return;let t=this.C.get(k);t||(t=new S.$Eh,this.C.set(k,t)),await t.wait()}registerWindow(k){const t=new A.$Vc;this.t++,t.add(k.onWillLoad(i=>this.g.fire({window:k,workspace:i.workspace,reason:i.reason})));const o=(0,a.$qg)(k.win);t.add(D.Event.fromNodeEventEmitter(o,"close")(i=>{const c=k.id;if(this.r.has(c)){this.r.delete(c);return}this.S(`Lifecycle#window.on('close') - window ID ${k.id}`),i.preventDefault(),this.unload(k,w.UnloadReason.CLOSE).then(s=>{if(s){this.r.delete(c);return}this.r.add(c),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this.h.fire(k),k.close()})})),t.add(D.Event.fromNodeEventEmitter(o,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${k.id}`),this.t--,t.dispose(),this.t===0&&(!I.$j||this.j)&&this.L(y.QUIT)}))}registerAuxWindow(k){const t=(0,a.$qg)(k.win),o=new A.$Vc;o.add(D.Event.fromNodeEventEmitter(t,"close")(i=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${k.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),i.preventDefault())})),o.add(D.Event.fromNodeEventEmitter(t,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${k.id}`),o.dispose()}))}async reload(k,t){await this.unload(k,w.UnloadReason.RELOAD)||k.reload(t)}unload(k,t){const o=this.z.get(k.id);if(o)return o;const i=this.M(k,t).finally(()=>{this.z.delete(k.id)});return this.z.set(k.id,i),i}async M(k,t){if(!k.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${k.id}`);const o=this.j?w.UnloadReason.QUIT:t,i=await this.P(k,o);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${k.id})`),this.N(i)):(await this.Q(k,o),!1)}N(k){return k?(this.O(!0),this.j=!1,!0):!1}O(k){this.w&&(this.w(k),this.w=void 0,this.u=void 0)}P(k,t){return new Promise(o=>{const i=this.s++,c=`vscode:ok${i}`,s=`vscode:cancel${i}`;r.$EX.once(c,()=>{o(!1)}),r.$EX.once(s,()=>{o(!0)}),k.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:s,reason:t})})}Q(k,t){return new Promise(o=>{const c=`vscode:reply${this.s++}`;r.$EX.once(c,()=>o()),k.send("vscode:onWillUnload",{replyChannel:c,reason:t})})}quit(k){return this.R(k).then(t=>{if(!t&&k)try{if(I.$i){const o=(0,b.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.F.error(o)}return t})}R(k){return this.S(`Lifecycle#quit() - begin (willRestart: ${k})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(k&&this.G.setItem(p.b,!0),this.u=new Promise(t=>{this.w=t,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(k){this.H.args["enable-smoke-test-driver"]?this.F.info(k):this.F.trace(k)}setRelaunchHandler(k){this.D=k}async relaunch(k){this.S("Lifecycle#relaunch()");const t=process.argv.slice(1);if(k?.addArgs&&t.push(...k.addArgs),k?.removeArgs)for(const c of k.removeArgs){const s=t.indexOf(c);s>=0&&t.splice(s,1)}const o=()=>{this.D?.handleRelaunch(k)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:t}))};n.app.once("quit",o),await this.quit(!0)&&n.app.removeListener("quit",o)}async kill(k){this.S("Lifecycle#kill()"),await this.L(y.KILL),await Promise.race([(0,S.$Gh)(1e3),(async()=>{for(const t of n.BrowserWindow.getAllWindows())if(t&&!t.isDestroyed()){let o;t.webContents&&!t.webContents.isDestroyed()?o=new Promise(i=>t.once("closed",i)):o=Promise.resolve(),t.destroy(),await o}})()]),n.app.exit(k)}};e.$Xec=m,e.$Xec=m=p=Se([re(0,f.$_j),re(1,g.$gR),re(2,l.$sec)],m)}),define(oe[291],ae([0,1,4,3,2,6,20]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=void 0,n=Re(n),e.$sfc=(0,D.$Fi)("keyboardLayoutMainService");let I=class extends S.$Wc{constructor(h){super(),this.a=this.B(new r.$me),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,h.when(A.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const h=await new Promise((f,g)=>{x(["native-keymap"],f,g)}).then(Re);this.c=b(h),n.$t||h.onDidChangeKeyboardLayout(()=>{this.c=b(h),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$tfc=I,e.$tfc=I=Se([re(0,A.$Wec)],I);function b(a){const h=a.getKeyMap(),f=a.getCurrentKeyboardLayout();return{keyboardMapping:h,keyboardLayoutInfo:f}}}),define(oe[292],ae([0,1,252,8,17,16,12,18,38,101,5,55,251,289]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0,e.$ds=y;let l=class extends f.$6p{constructor(m,v,k,t){super(t),this.m=m,this.n=v,this.r=k,this.s(),this.B(m.onDidChangeConfiguration(o=>{o.affectsConfiguration("http")&&this.s()}))}s(){const m=this.m.getValue("http");this.f=m?.proxy,this.g=!!m?.proxyStrictSSL,this.h=m?.proxyAuthorization}async request(m,v){const{f:k,g:t}=this;let o;try{o=await(0,a.$Qm)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$_)(s)))}const i={...process.env,...o},c=m.agent?m.agent:await(0,g.$bs)(m.url||"",i,{proxyUrl:k,strictSSL:t});return m.agent=c,m.strictSSL=t,this.h&&(m.headers={...m.headers||{},"Proxy-Authorization":this.h}),this.c(m.isChromiumNetwork?"electron":"node",m,()=>y(m,v))}async resolveProxy(m){}async loadCertificates(){return(await new Promise((v,k)=>{x(["@vscode/proxy-agent"],v,k)}).then(Re)).loadSystemCertificates({log:this.r})}};e.$cs=l,e.$cs=l=Se([re(0,I.$_i),re(1,b.$Ni),re(2,h.$_j),re(3,h.$ak)],l);async function p($){return((0,n.parse)($.url).protocol==="https:"?await new Promise((k,t)=>{x(["https"],k,t)}).then(Re):await new Promise((k,t)=>{x(["http"],k,t)}).then(Re)).request}async function y($,m){return r.Promises.withAsyncBody(async(v,k)=>{const t=(0,n.parse)($.url),o=$.getRawRequest?$.getRawRequest($):await p($),i={hostname:t.hostname,port:t.port?parseInt(t.port):t.protocol==="https:"?443:80,protocol:t.protocol,path:t.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,A.$lg)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(i.auth=$.user+":"+$.password);const c=o(i,s=>{const u=(0,A.$jg)($.followRedirects)?$.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&u>0&&s.headers.location)y({...$,url:s.headers.location,followRedirects:u-1},m).then(v,k);else{let d=s;!$.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(d=s.pipe((0,w.createGunzip)())),v({res:s,stream:(0,S.$4e)(d)})}});c.on("error",k),$.timeout&&c.setTimeout($.timeout),$.isChromiumNetwork&&c.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&c.write($.data),c.end(),m.onCancellationRequested(()=>{c.abort(),k(new D.$7)})})}}),define(oe[293],ae([0,1,14,292]),function(x,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;function S(A){return n.net.request}class D extends r.$cs{request(I,b){return super.request({...I||{},getRawRequest:S,isChromiumNetwork:!0},b)}}e.$xgc=D}),define(oe[88],ae([0,1,7,3,2,38,15,6,20,5,63,286,42,59,41,13]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=e.$5ec=e.$4ec=e.$3ec=void 0,e.$3ec=(0,I.$Fi)("storageMainService");let y=class extends S.$Wc{constructor(v,k,t,o,i,c){super(),this.c=v,this.f=k,this.g=t,this.h=o,this.j=i,this.m=c,this.a=void 0,this.b=this.B(new r.$me),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(b.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(v=>{v.window.profile&&this.profileStorage(v.window.profile).init(),v.workspace&&this.workspaceStorage(v.workspace).init()})),this.B(this.h.onWillShutdown(v=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=v.reason,v.join("applicationStorage",this.applicationStorage.close());for(const[,k]of this.t)v.join("profileStorage",k.close());for(const[,k]of this.w)v.join("workspaceStorage",k.close())})),this.B(this.g.onWillCreateProfile(v=>{v.join((async()=>{await this.j.exists(v.profile.globalStorageHome)||await this.j.createFolder(v.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(v=>{const k=this.t.get(v.profile.id);k&&v.join(k.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const v=new f.$Zec(this.n(),this.g,this.c,this.j);return this.B(r.Event.once(v.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),v}profileStorage(v){if((0,h.$iq)(v))return this.applicationStorage;let k=this.t.get(v.id);if(!k){this.c.trace(`StorageMainService: creating profile storage (${v.name})`),k=this.B(this.u(v)),this.t.set(v.id,k);const t=this.B(k.onDidChangeStorage(o=>this.b.fire({...o,storage:k,profile:v})));this.B(r.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${v.name})`),this.t.delete(v.id),t.dispose()}))}return k}u(v){return this.a===b.ShutdownReason.KILL?new f.$2ec(this.c,this.j):new f.$Yec(v,this.n(),this.c,this.j)}workspaceStorage(v){let k=this.w.get(v.id);return k||(this.c.trace(`StorageMainService: creating workspace storage (${v.id})`),k=this.B(this.y(v)),this.w.set(v.id,k),this.B(r.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${v.id})`),this.w.delete(v.id)}))),k}y(v){return this.a===b.ShutdownReason.KILL?new f.$2ec(this.c,this.j):new f.$1ec(v,this.n(),this.c,this.f,this.j)}isUsed(v){const k=n.URI.file(v);for(const t of[this.applicationStorage,...this.t.values(),...this.w.values()])if(t.path&&this.m.extUri.isEqualOrParent(n.URI.file(t.path),k))return!0;return!1}};e.$4ec=y,e.$4ec=y=Se([re(0,a.$_j),re(1,D.$Mi),re(2,w.$Gec),re(3,b.$Wec),re(4,A.$_k),re(5,l.$Jl)],y),e.$5ec=(0,I.$Fi)("applicationStorageMainService");let $=class extends h.$hq{constructor(v,k){super(),this.s=v,this.U=k,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(v){if(v===h.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(v){if(v===h.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$6ec=$,e.$6ec=$=Se([re(0,g.$Ll),re(1,e.$3ec)],$)}),define(oe[294],ae([0,1,93,27,112,105,8,2,4,18,5,28,245,248,102,132,17]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=e.$vgc=e.$ugc=e.$tgc=void 0,n=Re(n),r=Re(r);async function $(o,i,c,s,u){let d;for(let P=3;P&&(d?.dispose(),d=await new m(o,i,c,s,u).waitForReady(),!(u&&S.$5g[u]||!S.$5g[d.tunnelLocalPort]));P--);return d}class m extends I.$Wc{constructor(i,c,s,u,d){super(),this.m=c,this.n=d,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=n.createServer(),this.c=new A.$Eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=P=>this.r(P),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=u,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(c=>{c()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,c=(0,p.$Iw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,S.$6g)(i,2,1e3,c),u=null;return this.b.listen(s,this.m),await this.c.wait(),u=this.b.address(),u||(s=0,this.b.listen(s,this.m),await this.c.wait(),u=this.b.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async r(i){i.pause();const c=(0,p.$Gw)(this.tunnelRemoteHost)||(0,p.$Iw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,g.$2l)(this.a,c,this.tunnelRemotePort),u=s.getSocket(),d=s.readEntireBuffer();s.dispose(),d.byteLength>0&&i.write(d.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),u.end()}),i.on("close",()=>u.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),u instanceof D.$ui?u.socket.destroy():u.end()}),u instanceof D.$ui?this.t(i,u):this.s(i,u),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),u.end()})}s(i,c){c.onClose(()=>i.destroy()),c.onEnd(()=>i.end()),c.onData(s=>i.write(s.buffer)),i.on("data",s=>c.write(y.$Oe.wrap(s))),i.resume()}t(i,c){const s=c.socket;s.on("end",()=>i.end()),s.on("close",()=>i.end()),s.on("error",()=>{i.destroy()}),s.pipe(i),i.pipe(s)}}e.$tgc=m;let v=class extends p.$Lw{constructor(i,c,s,u,d){super(c,d),this.H=i,this.I=s,this.J=u}isPortPrivileged(i){return(0,p.$Jw)(i,this.t,b.OS,r.release())}F(i,c,s,u,d,P,E,O){const T=this.D(c,s);if(T)return++T.refcount,T.value;if((0,p.$Cw)(i))return this.G(i,c,s,d,P,E,O);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${s} on local port ${d}.`);const L={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},R=$(L,u,c,s,d);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(c,s,R),R}}};e.$ugc=v,e.$ugc=v=Se([re(0,w.$Vl),re(1,h.$_j),re(2,l.$Yl),re(3,f.$sk),re(4,a.$_i)],v);let k=class extends v{constructor(i,c,s,u,d){super(i,c,s,u,d)}};e.$vgc=k,e.$vgc=k=Se([re(0,w.$Vl),re(1,h.$_j),re(2,l.$Yl),re(3,f.$sk),re(4,a.$_i)],k);let t=class extends I.$Wc{constructor(i,c,s,u,d){super(),this.b=i,this.c=c,this.f=s,this.g=u,this.h=d,this.a=new Map}async openTunnel(i,c,s,u,d,P,E,O,T){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${u} on local port ${P}.`),!this.a.has(i)){const L=new k(this.b,this.c,this.g,this.f,this.h);this.B(L),this.a.set(i,L),L.onTunnelClosed(async()=>{(await L.tunnels).length===0&&(L.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(c,s,u,d,P,E,O,T)}};e.$wgc=t,e.$wgc=t=Se([re(0,w.$Vl),re(1,h.$_j),re(2,f.$sk),re(3,l.$Yl),re(4,a.$_i)],t)}),define(oe[106],ae([0,1,8,23,3,18,25,20,5,28,55,50]),function(x,e,n,r,S,D,A,I,b,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0,e.$Pfc=g;function g(l,p,y){return`${y.updateUrl}/api/update/${l}/${p}/${y.commit}`}let w=class{get state(){return this.b}d(p){this.j.info("update#setState",p.type),this.b=p,this.c.fire(p)}constructor(p,y,$,m,v,k){this.f=p,this.g=y,this.h=$,this.i=m,this.j=v,this.k=k,this.b=f.$CY.Uninitialized,this.c=new S.$me,this.onStateChange=this.c.event,p.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(f.$CY.Disabled(f.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(f.$CY.Disabled(f.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(f.$CY.Disabled(f.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.g.getValue("update.mode"),y=this.m(p);if(!y){this.d(f.$CY.Disabled(f.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(y),!this.a){this.d(f.$CY.Disabled(f.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const $=new URL(this.a);$.searchParams.set("prss","true"),this.a=$.toString()}if(this.d(f.$CY.Idle(this.q())),p==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(p){return p==="none"?void 0:this.k.quality}n(p=60*60*1e3){return(0,n.$Gh)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(p){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===f.StateType.Idle&&this.t(p)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===f.StateType.AvailableForDownload&&await this.o(this.state)}async o(p){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===f.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==f.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},r.CancellationToken.None)).res.statusCode===204}catch(y){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(y);return}}async _applySpecificUpdate(p){}q(){return f.UpdateType.Archive}r(){}};e.$Qfc=w,e.$Qfc=w=Se([re(0,I.$Wec),re(1,D.$_i),re(2,A.$sec),re(3,h.$5p),re(4,b.$_j),re(5,a.$sk)],w)}),define(oe[295],ae([0,1,14,52,3,46,2,18,25,20,5,28,55,24,50,106]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0,n=Re(n);let y=class extends p.$Qfc{get v(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"error",(m,v)=>v)}get w(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(m,v,k,t)=>({version:k,productVersion:k,timestamp:t}))}constructor(m,v,k,t,o,i,c){super(m,v,t,o,i,c),this.z=k,this.u=new A.$Vc,m.setRelaunchHandler(this)}handleRelaunch(m){return m?.addArgs||m?.removeArgs||this.state.type!==l.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(m){this.z.publicLog2("update:error",{messageHash:String((0,D.$tj)(String(m)))}),this.j.error("UpdateService error:",m);const v=this.state.type===l.StateType.CheckingForUpdates&&this.state.explicit?m:void 0;this.d(l.$CY.Idle(l.UpdateType.Archive,v))}s(m){let v;this.k.darwinUniversalAssetId?v=this.k.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,p.$Pfc)(v,m,this.k);try{n.autoUpdater.setFeedURL({url:k})}catch(t){this.j.error("Failed to set update feed URL",t);return}return k}t(m){this.d(l.$CY.CheckingForUpdates(m)),n.autoUpdater.checkForUpdates()}E(){this.state.type===l.StateType.CheckingForUpdates&&this.d(l.$CY.Downloading)}F(m){this.state.type===l.StateType.Downloading&&(this.d(l.$CY.Downloaded(m)),this.z.publicLog2("update:downloaded",{version:m.version}),this.d(l.$CY.Ready(m)))}G(){this.state.type===l.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(l.$CY.Idle(l.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$Rfc=y,Se([r.$0h],y.prototype,"v",null),Se([r.$0h],y.prototype,"w",null),Se([r.$0h],y.prototype,"x",null),Se([r.$0h],y.prototype,"y",null),e.$Rfc=y=Se([re(0,a.$Wec),re(1,I.$_i),re(2,w.$$l),re(3,b.$sec),re(4,g.$5p),re(5,h.$_j),re(6,f.$sk)],y)}),define(oe[296],ae([0,1,49,47,8,3,9,25,20,5,24,50]),function(x,e,n,r,S,D,A,I,b,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=void 0,A=Re(A);let g=class{get state(){return this.a}d(p){this.g.info("update#setState",p.type),this.a=p,this.b.fire(p)}constructor(p,y,$){if(this.f=p,this.g=$,this.a=f.$CY.Uninitialized,this.b=new D.$me,this.onStateChange=this.b.event,y.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(f.$CY.Idle(this.k())),this.h(30*1e3).then(void 0,m=>this.g.error(m))}h(p=60*60*1e3){return(0,S.$Gh)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(p){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===f.StateType.Idle&&this.m(p)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===f.StateType.AvailableForDownload&&await this.i(this.state)}i(p){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===f.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==f.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return f.UpdateType.Snap}l(){}async _applySpecificUpdate(p){}};g=Se([re(0,b.$Wec),re(1,I.$sec),re(2,a.$_j)],g);let w=class extends g{constructor(p,y,$,m,v,k){super($,m,v),this.o=p,this.p=y,this.q=k;const t=(0,r.watch)(A.$oc(this.o)),o=D.Event.fromNodeEventEmitter(t,"change",(u,d)=>d),i=D.Event.filter(o,u=>u==="current"),s=D.Event.debounce(i,(u,d)=>d,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{s.dispose(),t.close()})}m(){this.d(f.$CY.CheckingForUpdates(!1)),this.u().then(p=>{p?this.d(f.$CY.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(f.$CY.Idle(f.UpdateType.Snap)))},p=>{this.g.error(p),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(f.$CY.Idle(f.UpdateType.Snap,p.message||p))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+A.$pc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const p=await new Promise(($,m)=>(0,r.realpath)(`${A.$oc(this.o)}/current`,(v,k)=>v?m(v):$(k))),y=A.$pc(p);return this.p!==y}isLatestVersion(){return this.u().then(void 0,p=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$Tfc=w,e.$Tfc=w=Se([re(2,b.$Wec),re(3,I.$sec),re(4,a.$_j),re(5,h.$$l)],w)}),define(oe[29],ae([0,1,14,4,6,51,57,74,28,18,25,9,140]),function(x,e,n,r,S,D,A,I,b,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Dec=void 0,e.$Eec=l,e.$Fec=p,e.$Dec=(0,S.$Fi)("windowsMainService");var w;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(w||(e.OpenContext=w={}));function l($,m,v){const k=$.get(I.$Bec),t=$.get(b.$sk),o=$.get(a.$_i),i=$.get(h.$sec),c=o.getValue("window"),s={backgroundColor:k.getBackgroundColor(),minWidth:A.$XD.WIDTH,minHeight:A.$XD.HEIGHT,title:t.nameLong,show:m.mode!==D.WindowMode.Maximized&&m.mode!==D.WindowMode.Fullscreen,x:m.x,y:m.y,width:m.width,height:m.height,webPreferences:{...v,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,A.$0D)(m.zoomLevel??c?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(r.$k?s.icon=(0,f.$lc)(i.appRoot,"resources/linux/code.png"):r.$i&&!i.isBuilt&&(s.icon=(0,f.$lc)(i.appRoot,"resources/win32/code_150x150.png")),r.$j&&(s.acceptFirstMouse=!0,c?.clickThroughInactive===!1&&(s.acceptFirstMouse=!1)),r.$j&&!(0,A.$9D)(o)&&(s.fullscreenable=!1),r.$j&&c?.nativeTabs===!0&&(s.tabbingIdentifier=t.nameShort),!(0,A.$5D)(o)&&(s.titleBarStyle="hidden",r.$j||(s.frame=!1),(0,A.$8D)(o))){const P=k.getWindowSplash()?.colorInfo.titleBarBackground??k.getBackgroundColor(),E=g.$ku.fromHex(P).isDarker()?"#FFFFFF":"#000000";s.titleBarOverlay={height:29,color:P,symbolColor:E}}return s}function p($){let m,v=Number.MIN_VALUE;for(const k of $)k.lastFocusTime>v&&(v=k.lastFocusTime,m=k);return m}var y;(function($){function m(k,t,o=n.screen.getAllDisplays()){if(k.trace(`window#validateWindowState: validating window state on ${o.length} display(s)`,t),typeof t.x!="number"||typeof t.y!="number"||typeof t.width!="number"||typeof t.height!="number"){k.trace("window#validateWindowState: unexpected type of state values");return}if(t.width<=0||t.height<=0){k.trace("window#validateWindowState: unexpected negative values");return}if(o.length===1){const s=v(o[0]);if(k.trace("window#validateWindowState: single monitor working area",s),s){let u=function(){!t||typeof t.x!="number"||typeof t.y!="number"||!s||(t.x<s.x&&(t.x=s.x),t.y<s.y&&(t.y=s.y))};u(),t.width>s.width&&(t.width=s.width),t.height>s.height&&(t.height=s.height),t.x>s.x+s.width-128&&(t.x=s.x+s.width-t.width),t.y>s.y+s.height-128&&(t.y=s.y+s.height-t.height),u()}return t}if(t.display&&t.mode===D.WindowMode.Fullscreen){const s=o.find(u=>u.id===t.display);if(s&&typeof s.bounds?.x=="number"&&typeof s.bounds?.y=="number"){k.trace("window#validateWindowState: restoring fullscreen to previous display");const u=(0,D.$qec)(D.WindowMode.Fullscreen);return u.x=s.bounds.x,u.y=s.bounds.y,u}}let i,c;try{i=n.screen.getDisplayMatching({x:t.x,y:t.y,width:t.width,height:t.height}),c=v(i),k.trace("window#validateWindowState: multi-monitor working area",c)}catch(s){k.error("window#validateWindowState: error finding display for window state",s)}if(i&&c&&t.x+t.width>c.x&&t.y+t.height>c.y&&t.x<c.x+c.width&&t.y<c.y+c.height)return t;k.trace("window#validateWindowState: state is outside of the multi-monitor working area")}$.validateWindowState=m;function v(k){if(k.workArea.width>0&&k.workArea.height>0)return k.workArea;if(k.bounds.width>0&&k.bounds.height>0)return k.bounds}})(y||(e.WindowStateValidator=y={}))}),define(oe[297],ae([0,1,14,23,3,46,2,33,98,5,63,88,29]),function(x,e,n,r,S,D,A,I,b,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;var w;(function(p){p[p.Initial=1]="Initial",p[p.StoredCredentialsUsed=2]="StoredCredentialsUsed",p[p.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let l=class extends A.$Wc{constructor(y,$,m,v){super(),this.g=y,this.h=$,this.j=m,this.m=v,this.a="proxy-credentials://",this.b=void 0,this.c=w.Initial,this.f=void 0,this.n()}n(){const y=S.Event.fromNodeEventEmitter(n.app,"login",($,m,v,k,t)=>({event:$,webContents:m,req:v,authInfo:k,callback:t}));this.B(y(this.r,this))}async r({event:y,authInfo:$,req:m,callback:v}){if(!$.isProxy)return;if(!this.b&&this.c===w.LoginDialogShown&&m.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let k;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),k=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s($);try{k=await this.b}finally{this.b=void 0}}v(k?.username,k?.password)}async s(y){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const $=await this.t(y);if($)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),$;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(y){this.g.trace("auth#doResolveProxyCredentials - enter",y);const $=String((0,D.$tj)({scheme:y.scheme,host:y.host,port:y.port}));let m,v;try{const i=this.m.get(this.a+$,h.StorageScope.APPLICATION);if(i){const c=JSON.parse(await this.j.decrypt(i));m=c.username,v=c.password}}catch(i){this.g.error(i)}if(this.c!==w.StoredCredentialsUsed&&typeof m=="string"&&typeof v=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=w.StoredCredentialsUsed,{username:m,password:v};const k=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!k){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${k.id} to handle proxy login`);const t={authInfo:y,username:this.f?.username??m,password:this.f?.password??v,replyChannel:`vscode:proxyAuthResponse:${(0,I.$2g)()}`};k.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,t),this.c=w.LoginDialogShown;const o=await new Promise(i=>{const c=async(s,u,d)=>{if(u===t.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${k.id}`),k.win?.webContents.off("ipc-message",c),d){const P={username:d.username,password:d.password};try{if(d.remember){const E=await this.j.encrypt(JSON.stringify(P));this.m.store(this.a+$,E,h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}else this.m.remove(this.a+$,h.StorageScope.APPLICATION)}catch(E){this.g.error(E)}i({username:P.username,password:P.password})}else i(void 0)};k.win?.webContents.on("ipc-message",c)});return this.f=o,o}};e.$7ec=l,e.$7ec=l=Se([re(0,a.$_j),re(1,g.$Dec),re(2,b.$nY),re(3,f.$5ec)],l)}),define(oe[298],ae([0,1,93,204,121,29]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class A extends r.$Wo{constructor(b){super(),this.f=b}call(b,a,h){return a==="openExtensionDevelopmentHostWindow"?this.g(h[0],h[1]):super.call(b,a,h)}async g(b,a){const h=(0,S.$Cm)(b,S.$Bm);h.debugRenderer=a;const f=h.extensionDevelopmentPath;if(!f)return{success:!1};const[g]=await this.f.openExtensionDevelopmentHostWindow(f,{context:D.OpenContext.API,cli:h,forceProfile:h.profile,forceTempProfile:h["profile-temp"]});if(!a)return{success:!0};const w=g.win;if(!w)return{success:!0};const l=w.webContents.debugger;let p=l.isAttached()?1/0:0;const y=(0,n.createServer)($=>{p++===0&&l.attach();let m=!1;const v=o=>{m||$.write(JSON.stringify(o)+"\0")},k=(o,i,c,s)=>v({method:i,params:c,sessionId:s});w.on("close",()=>{l.removeListener("message",k),$.end(),m=!0}),l.addListener("message",k);let t=Buffer.alloc(0);$.on("data",o=>{t=Buffer.concat([t,o]);for(let i=t.indexOf(0);i!==-1;i=t.indexOf(0)){let c;try{const s=t.slice(0,i).toString("utf8");t=t.slice(i+1),c=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}l.sendCommand(c.method,c.params,c.sessionId).then(s=>v({id:c.id,sessionId:c.sessionId,result:s})).catch(s=>v({id:c.id,sessionId:c.sessionId,error:{code:0,message:s.message}}))}}),$.on("error",o=>{console.error("error on cdp pipe:",o)}),$.on("close",()=>{m=!0,--p===0&&l.detach()})});return await new Promise($=>y.listen(0,$)),w.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.$9ec=A}),define(oe[299],ae([0,1,14,22,4,7,21,18,68,6,5,133,29]),function(x,e,n,r,S,D,A,I,b,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=e.$vfc=e.ID=void 0,e.ID="launchMainService",e.$vfc=(0,a.$Fi)(e.ID);let w=class{constructor(p,y,$,m){this.a=p,this.b=y,this.c=$,this.d=m}async start(p,y){this.a.trace("Received data from other instance: ",p,y),S.$j&&n.app.focus({steal:!0});const $=this.e(p);if($.length){let m=Promise.resolve();if(this.b.getWindowCount()===0){const v=(0,r.$Qb)(await this.b.openEmptyWindow({context:g.OpenContext.DESKTOP}));v&&(m=v.ready())}m.then(()=>{for(const{uri:v,originalUrl:k}of $)this.c.open(v,{originalUrl:k})})}else return this.f(p,y)}e(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,r.$Jb)(p._urls.map(y=>{try{return{uri:D.URI.parse(y),originalUrl:y}}catch{return null}})):[]}async f(p,y){const $=(0,b.$Jm)(y)?g.OpenContext.CLI:g.OpenContext.DESKTOP;let m=[];const v=p.wait&&p.waitMarkerFilePath?D.URI.file(p.waitMarkerFilePath):void 0,k=p.remote||void 0,t={context:$,cli:p,userEnv:p["preserve-env"]||$===g.OpenContext.CLI?y:void 0,waitMarkerFileURI:v,remoteAuthority:k,forceProfile:p.profile,forceTempProfile:p["profile-temp"]};if(p.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,t);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let o=!1;if(p["new-window"]||t.forceProfile||t.forceTempProfile)o=!0;else if(p["reuse-window"])o=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!S.$j}if(o)m=await this.b.open({...t,forceNewWindow:!0,forceEmpty:!0});else{const i=this.b.getLastActiveWindow();i?(this.b.openExistingWindow(i,t),m=[i]):m=await this.b.open({...t,forceEmpty:!0})}}else m=await this.b.open({...t,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(v&&m.length===1&&m[0])return Promise.race([m[0].whenClosedOrLoaded,(0,A.whenDeleted)(v.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$wfc=w,e.$wfc=w=Se([re(0,h.$_j),re(1,g.$Dec),re(2,f.$tY),re(3,I.$_i)],w)}),define(oe[300],ae([0,1,2,20,51,59,30,8,29]),function(x,e,n,r,S,D,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;let a=class extends n.$Wc{constructor(f,g,w){super(),this.a=g,this.b=w,this.B(f.onWillLoadWindow(l=>{l.reason===S.LoadReason.LOAD&&this.c(l.window)})),this.B(f.onBeforeCloseWindow(l=>this.c(l))),this.B(new I.$Rh(()=>this.g(),30*1e3)).schedule()}async c(f){const g=this.f(f),w=this.a.getProfileForWorkspace(g);w?.isTransient&&(this.a.unsetWorkspace(g,w.isTransient),w.isTransient&&await this.a.cleanUpTransientProfiles())}f(f){return f.openedWorkspace??(0,A.$Ti)(f.backupPath,f.isExtensionDevelopmentHost)}g(){const f=this.a.getAssociatedEmptyWindows();if(f.length===0)return;const g=this.b.getWindows().map(w=>this.f(w));for(const w of f)g.some(l=>l.id===w.id)||this.a.unsetWorkspace(w,!1)}};e.$_fc=a,e.$_fc=a=Se([re(0,r.$Wec),re(1,D.$Gec),re(2,b.$Dec)],a)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[64],ae([0,1,14,2,3,5,319,8,13,29,79,24,20,80,35,4,107]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=e.$0ec=void 0,h=et(h);function m(t){return typeof t.responseWindowId=="number"}let v=class extends r.$Wc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(o,i,c){super(),this.w=o,this.y=i,this.z=c,this.c=String(++$.a),this.f=this.B(new S.$me),this.onStdout=this.f.event,this.g=this.B(new S.$me),this.onStderr=this.g.event,this.h=this.B(new S.$me),this.onMessage=this.h.event,this.j=this.B(new S.$me),this.onSpawn=this.j.event,this.m=this.B(new S.$me),this.onExit=this.m.event,this.n=this.B(new S.$me),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(o,i){let c;switch(this.t?.correlationId?c=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${o}`:c=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${o}`,i){case h.default.Error:this.w.error(c);break;case h.default.Warning:this.w.warn(c);break;case h.default.Info:this.w.trace(c);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",h.default.Error),!1):!0}start(o){const i=this.F(o);return i&&o.payload&&this.postMessage(o.payload)&&this.C("payload sent via postMessage()",h.default.Info),i}F(o){if(!this.D())return!1;this.t=o;const i=`${this.t.type}-${this.c}`,c=b.$Zg.asFileUri("bootstrap-fork.js").fsPath,s=this.t.args??[],u=this.t.execArgv??[],d=this.t.allowLoadingUnsignedLibraries,P=this.t.forceAllocationsToV8Sandbox,E="pipe",O=this.G(o);return this.C("creating new...",h.default.Info),this.r=n.utilityProcess.fork(c,s,{serviceName:i,env:O,execArgv:u,allowLoadingUnsignedLibraries:d,forceAllocationsToV8Sandbox:P,stdio:E}),this.H(this.r,this.t,i),!0}G(o){const i=o.env?{...o.env}:{...(0,l.$do)(process.env)};i.VSCODE_AMD_ENTRYPOINT=o.entryPoint,typeof o.parentLifecycleBound=="number"&&(i.VSCODE_PARENT_PID=String(o.parentLifecycleBound)),i.VSCODE_CRASH_REPORTER_PROCESS_TYPE=o.type,p.$i&&((0,y.isUNCAccessRestrictionsDisabled)()?i.NODE_DISABLE_UNC_ACCESS_CHECKS="1":i.NODE_UNC_HOST_ALLOWLIST=(0,y.getUNCHostAllowlist)().join("\\")),(0,w.$lm)(i);for(const c of Object.keys(i))i[c]=String(i[c]);return i}H(o,i,c){if(o.stdout){const s=new A.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(o.stdout,"data")(u=>this.f.fire(typeof u=="string"?u:s.write(u))))}if(o.stderr){const s=new A.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(o.stderr,"data")(u=>this.g.fire(typeof u=="string"?u:s.write(u))))}this.B(S.Event.fromNodeEventEmitter(o,"message")(s=>this.h.fire(s))),this.B(S.Event.fromNodeEventEmitter(o,"spawn")(()=>{this.s=o.pid,typeof o.pid=="number"&&$.b.set(o.pid,{pid:o.pid,name:m(i)?`${i.type} [${i.responseWindowId}]`:i.type}),this.C("successfully created",h.default.Info),this.j.fire(o.pid)})),this.B(S.Event.fromNodeEventEmitter(o,"exit")(s=>{const u=this.I(s)?0:s;this.C(`received exit event with code ${u}`,h.default.Info),this.m.fire({pid:this.s,code:u,signal:"unknown"}),this.J()})),this.B(S.Event.fromNodeEventEmitter(n.app,"child-process-gone",(s,u)=>({event:s,details:u}))(({details:s})=>{s.type==="Utility"&&s.name===c&&!this.I(s.exitCode)&&(this.C(`crashed with code ${s.exitCode} and reason '${s.reason}'`,h.default.Error),this.y.publicLog2("utilityprocesscrash",{type:i.type,reason:s.reason,code:s.exitCode}),this.n.fire({pid:this.s,code:s.exitCode,reason:s.reason}),this.J())}))}once(o,i){const c=this.B(this.h.event(s=>{s===o&&(c.dispose(),i())}))}postMessage(o,i){return this.r?(this.r.postMessage(o,i),!0):!1}connect(o){const{port1:i,port2:c}=new n.MessageChannelMain;return this.postMessage(o,[c]),i}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",h.default.Info);const o=process;return typeof o._debugProcess=="function"?(o._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",h.default.Info),this.r.kill()?(this.C("successfully killed the process",h.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",h.default.Warning)}I(o){return o===0?!0:this.u&&o===15}J(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(o){this.r&&(this.C("waiting to exit...",h.default.Info),await Promise.race([S.Event.toPromise(this.onExit),(0,I.$Gh)(o)]),this.r&&(this.C(`did not exit within ${o}ms, will kill it now...`,h.default.Info),this.kill()))}};e.$0ec=v,e.$0ec=v=$=Se([re(0,D.$_j),re(1,f.$$l),re(2,g.$Wec)],v);let k=class extends v{constructor(o,i,c,s){super(o,c,s),this.L=i}start(o){const i=this.L.getWindowById(o.responseWindowId);if(!i?.win||i.win.isDestroyed()||i.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",h.default.Error),!0;if(!super.F(o))return!1;this.M(i.win,o);const s=this.connect(o.payload);return i.win.webContents.postMessage(o.responseChannel,o.responseNonce,[s]),!0}M(o,i){i.windowLifecycleBound&&(this.B(S.Event.filter(this.z.onWillLoadWindow,c=>c.window.win===o)(()=>this.kill())),this.B(S.Event.fromNodeEventEmitter(o,"closed")(()=>this.kill())))}};e.$$ec=k,e.$$ec=k=Se([re(0,D.$_j),re(1,a.$Dec),re(2,f.$$l),re(3,g.$Wec)],k)}),define(oe[301],ae([0,1,8,16,3,2,20,5,24,64,29]),function(x,e,n,r,S,D,A,I,b,a,h){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;let g=class extends D.$Wc{static{f=this}static{this.a=0}constructor(l,p,y,$){super(),this.f=l,this.g=p,this.h=y,this.j=$,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown(m=>{this.c=!0,m.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(l){const p=this.b.get(l);if(!p)throw new Error("Unknown extension host!");return p}onDynamicStdout(l){return this.m(l).onStdout}onDynamicStderr(l){return this.m(l).onStderr}onDynamicMessage(l){return this.m(l).onMessage}onDynamicExit(l){return this.m(l).onExit}async createExtensionHost(){if(this.c)throw(0,r.$8)();const l=String(++f.a),p=new a.$$ec(this.f,this.h,this.j,this.g);this.b.set(l,p);const y=p.onExit(({pid:$,code:m,signal:v})=>{y.dispose(),this.f.info(`Extension host with pid ${$} exited with code: ${m}, signal: ${v}.`),setTimeout(()=>{p.dispose(),this.b.delete(l)}),setTimeout(()=>{try{process.kill($,0),this.f.error(`Extension host with pid ${$} still exists, forcefully killing it...`),process.kill($)}catch{}},1e3)});return{id:l}}async start(l,p){if(this.c)throw(0,r.$8)();const y=this.m(l);return y.start({...p,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:p.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:l}),{pid:await S.Event.toPromise(y.onSpawn)}}async enableInspectPort(l){if(this.c)throw(0,r.$8)();const p=this.b.get(l);return p?p.enableInspectPort():!1}async kill(l){if(this.c)throw(0,r.$8)();const p=this.b.get(l);p&&p.kill()}async _killAllNow(){for(const[,l]of this.b)l.kill()}async _waitForAllExit(l){const p=[];for(const[,y]of this.b)p.push(y.waitForExit(l));return n.Promises.settled(p).then(()=>{})}};e.$ffc=g,e.$ffc=g=f=Se([re(0,I.$_j),re(1,A.$Wec),re(2,h.$Dec),re(3,b.$$l)],g)}),define(oe[302],ae([0,1,37,8,2,25,20,5,42,40,71,64,56,96,12,253,3]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;let $=class extends S.$Wc{constructor(v,k,t,o,i,c,s,u,d){super(),this.g=v,this.h=k,this.j=t,this.m=o,this.n=i,this.r=c,this.s=s,this.t=u,this.u=d,this.a=new r.$Eh,this.b=void 0,this.c=void 0,this.f=this.B(new y.$me),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){n.$EX.on(p.$Hfc.request,(v,k)=>this.y(v,k,p.$Hfc.response)),n.$EX.on(p.$Ifc.request,(v,k)=>this.y(v,k,p.$Ifc.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(v,k,t){this.s.trace(`[SharedProcess] onWindowConnection for: ${t}`),this.a.isOpen()||this.a.open(),await this.whenReady();const o=await this.connect(t);if(v.sender.isDestroyed())return o.close();v.sender.postMessage(t,k,[o])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(p.$Gfc.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const v=new r.$3h;this.b?.once(p.$Gfc.initDone,()=>v.complete()),await v.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const v=new r.$3h;this.b?.once(p.$Gfc.ipcReady,()=>v.complete()),await v.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new f.$0ec(this.s,g.$wp,this.r)),this.c=this.b.onMessage(t=>{typeof t.warning=="string"?this.s.warn(t.warning):typeof t.error=="string"&&this.s.error(t.error)});const v=(0,w.$0m)(this.m.args,this.m.isBuilt);let k;v.port&&(k=["--nolazy"],v.break?k.push(`--inspect-brk=${v.port}`):k.push(`--inspect=${v.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:k}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(v){return await this.F,(0,l.$qg)(this.b).connect(v)}};e.$Jfc=$,e.$Jfc=$=Se([re(3,D.$sec),re(4,b.$Ll),re(5,A.$Wec),re(6,I.$_j),re(7,h.$Rec),re(8,a.$so)],$)}),define(oe[303],ae([0,1,25,96,20,5,56,73,64,119,37,2,3,35,18,13]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;let y=class extends f.$Wc{constructor(m,v,k,t,o){super(),this.f=m,this.g=v,this.h=k,this.j=t,this.m=o,this.a=void 0,this.b=new g.$me,this.onRequestConnection=this.b.event,this.c=new g.$me,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),h.$EX.on("vscode:createPtyHostMessageChannel",(i,c)=>this.r(i,c)),this.B((0,f.$Uc)(()=>{h.$EX.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new b.$0ec(this.m,A.$wp,this.j);const m=(0,r.$9m)(this.h.args,this.h.isBuilt),v=m.port?["--nolazy",`--inspect${m.break?"-brk":""}=${m.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:v,args:["--logsPath",this.h.logsHome.with({scheme:p.Schemas.file}).fsPath],env:this.n()});const k=this.a.connect(),t=new a.$MX(k,"ptyHost"),o=new f.$Vc;return o.add(t),o.add((0,f.$Uc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:t,store:o,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const m={...(0,w.$do)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},v=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);v&&typeof v=="number"&&(m.VSCODE_LATENCY=String(v));const k=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return k&&typeof k=="number"&&(m.VSCODE_STARTUP_DELAY=String(k)),this.h.restoreSnapExportedVariables(),m}r(m,v){this.b.fire();const k=this.a.connect();if(m.sender.isDestroyed()){k.close();return}m.sender.postMessage("vscode:createPtyHostMessageChannelResult",v,[k])}};e.$lgc=y,e.$lgc=y=Se([re(1,l.$_i),re(2,n.$sec),re(3,S.$Wec),re(4,D.$_j)],y)}),define(oe[304],ae([0,1,2,6,5,29,64,24,46,3,8,20]),function(x,e,n,r,S,D,A,I,b,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=e.$jgc=void 0,e.$jgc=(0,r.$Fi)("utilityProcessWorker");let g=class extends n.$Wc{constructor(p,y,$,m){super(),this.b=p,this.c=y,this.f=$,this.g=m,this.a=new Map}async createWorker(p){const y=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${y})`);const $=this.h(p);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${y})`),this.disposeWorker(p));const m=new w(this.b,this.c,this.f,this.g,p);if(!m.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,m);const v=new h.$3h;return a.Event.once(m.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete($),v.complete({reason:k})}),v.p}h(p){return(0,b.$tj)({moduleId:p.process.moduleId,windowId:p.reply.windowId})}async disposeWorker(p){const y=this.h(p),$=this.a.get(y);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),$.kill(),$.dispose(),this.a.delete(y))}};e.$kgc=g,e.$kgc=g=Se([re(0,S.$_j),re(1,D.$Dec),re(2,I.$$l),re(3,f.$Wec)],g);let w=class extends n.$Wc{constructor(p,y,$,m,v){super(),this.c=p,this.f=y,this.g=$,this.h=m,this.j=v,this.a=this.B(new a.$me),this.onDidTerminate=this.a.event,this.b=this.B(new A.$$ec(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(p=>this.a.fire({code:p.code,signal:p.signal}))),this.B(this.b.onCrash(p=>this.a.fire({code:p.code,signal:"ECRASH"})))}spawn(){const y=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:y,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};w=Se([re(0,S.$_j),re(1,D.$Dec),re(2,I.$$l),re(3,f.$Wec)],w)}),define(oe[305],ae([0,1,14,3,2,278,29]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0;let I=class extends S.$Wc{constructor(a){super(),this.b=a,this.a=this.B(new r.$me),this.onFoundInFrame=this.a.event,this.B(new D.$1fc)}async setIgnoreMenuShortcuts(a,h){let f;if(typeof a.windowId=="number"){const{windowId:g}=a,w=this.b.getWindowById(g);if(!w?.win)throw new Error(`Invalid windowId: ${g}`);f=w.win.webContents}else{const{webContentsId:g}=a;if(f=n.webContents.fromId(g),!f)throw new Error(`Invalid webContentsId: ${g}`)}f.isDestroyed()||f.setIgnoreMenuShortcuts(h)}async findInFrame(a,h,f,g){const l=this.c(a,h);if(typeof l.findInFrame=="function"){l.findInFrame(f,{findNext:g.findNext,forward:g.forward});const p=(y,$)=>{$.finalUpdate&&(this.a.fire($),l.removeListener("found-in-frame",p))};l.on("found-in-frame",p)}}async stopFindInFrame(a,h,f){const w=this.c(a,h);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(f.keepSelection?"keepSelection":"clearSelection")}c(a,h){const f=this.b.getWindowById(a.windowId);if(!f?.win)throw new Error(`Invalid windowId: ${a}`);const g=f.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===h);if(!g)throw new Error(`Unknown frame: ${h}`);return g}};e.$2fc=I,e.$2fc=I=Se([re(0,A.$Dec)],I)}),define(oe[306],ae([0,1,14,2,4,19,7,18,20,5,34,29,51,30]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0,e.$4fc=y,e.$5fc=m;let p=class extends r.$Wc{static{l=this}static{this.a="windowsState"}get state(){return this.b}constructor(t,o,i,c,s){super(),this.g=t,this.h=o,this.j=i,this.m=c,this.n=s,this.b=y(this.h.getItem(l.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(t=>this.u(t))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(t=>{t.newCount-t.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(t=>this.u(t)))}s(){this.f=!0,this.t()}t(){const t=new Set,o={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!o.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(u=>!u.isExtensionDevelopmentHost)),s&&(o.lastActiveWindow=this.w(s),o.lastActiveWindow.uiState.mode===g.WindowMode.Fullscreen&&t.add(o.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);i&&(o.lastPluginDevelopmentHostWindow=this.w(i),o.lastPluginDevelopmentHostWindow.uiState.mode===g.WindowMode.Fullscreen&&(t.has(o.lastPluginDevelopmentHostWindow.uiState.display)?S.$j&&!i.win?.isSimpleFullScreen()&&(o.lastPluginDevelopmentHostWindow.uiState.mode=g.WindowMode.Normal):t.add(o.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(o.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const u=this.w(s);return u.uiState.mode===g.WindowMode.Fullscreen&&(t.has(u.uiState.display)?S.$j&&u.windowId!==o.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(u.uiState.mode=g.WindowMode.Normal):t.add(u.uiState.display)),u}));const c=m(o);this.h.setItem(l.a,c),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",c)}u(t){if(this.j.quitRequested)return;const o=this.w(t);t.isExtensionDevelopmentHost&&!t.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=o:!t.isExtensionDevelopmentHost&&t.openedWorkspace&&this.b.openedWindows.forEach(i=>{const c=(0,w.$Ui)(t.openedWorkspace)&&i.workspace?.id===t.openedWorkspace.id,s=(0,w.$Pi)(t.openedWorkspace)&&i.folderUri&&D.$0g.isEqual(i.folderUri,t.openedWorkspace.uri);(c||s)&&(i.uiState=o.uiState)}),this.g.getWindowCount()===1&&(this.c=o)}w(t){return{windowId:t.id,workspace:(0,w.$Ui)(t.openedWorkspace)?t.openedWorkspace:void 0,folderUri:(0,w.$Pi)(t.openedWorkspace)?t.openedWorkspace.uri:void 0,backupPath:t.backupPath,remoteAuthority:t.remoteAuthority,uiState:t.serializeWindowState()}}getNewWindowState(t){const o=this.z(t),i=this.n.getValue("window");if(o.mode===g.WindowMode.Fullscreen){let c;o.hasDefaultState?c=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):c=!!(this.j.wasRestarted||i?.restoreFullscreen),c||(o.mode=g.WindowMode.Normal)}return o}z(t){const o=this.g.getLastActiveWindow();if(!t.extensionTestsPath){if(t.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const P=t.workspace;if((0,w.$Ui)(P)){const O=this.state.openedWindows.filter(T=>T.workspace&&T.workspace.id===P.id).map(T=>T.uiState);if(O.length)return O[0]}if((0,w.$Pi)(P)){const O=this.state.openedWindows.filter(T=>T.folderUri&&D.$0g.isEqual(T.folderUri,P.uri)).map(T=>T.uiState);if(O.length)return O[0]}else if(t.backupPath){const O=this.state.openedWindows.filter(T=>T.backupPath===t.backupPath).map(T=>T.uiState);if(O.length)return O[0]}const E=this.c||this.state.lastActiveWindow;if(!o&&E)return E.uiState}let i;const c=n.screen.getAllDisplays();if(c.length===1)i=c[0];else{if(S.$j){const P=n.screen.getCursorScreenPoint();i=n.screen.getDisplayNearestPoint(P)}!i&&o&&(i=n.screen.getDisplayMatching(o.getBounds())),i||(i=n.screen.getPrimaryDisplay()||c[0])}let s=(0,g.$qec)();s.x=Math.round(i.bounds.x+i.bounds.width/2-s.width/2),s.y=Math.round(i.bounds.y+i.bounds.height/2-s.height/2);const u=this.n.getValue("window");let d=!0;if(u?.newWindowDimensions){if(u.newWindowDimensions==="maximized")s.mode=g.WindowMode.Maximized,d=!1;else if(u.newWindowDimensions==="fullscreen")s.mode=g.WindowMode.Fullscreen,d=!1;else if((u.newWindowDimensions==="inherit"||u.newWindowDimensions==="offset")&&o){const P=o.serializeWindowState();P.mode===g.WindowMode.Fullscreen?s.mode=g.WindowMode.Fullscreen:s={...P,zoomLevel:void 0},d=s.mode!==g.WindowMode.Fullscreen&&u.newWindowDimensions==="offset"}}return d&&(s=this.C(s)),s.hasDefaultState=!0,s}C(t){if(this.g.getWindows().length===0)return t;t.x=typeof t.x=="number"?t.x:0,t.y=typeof t.y=="number"?t.y:0;const o=this.g.getWindows().map(i=>i.getBounds());for(;o.some(i=>i.x===t.x||i.y===t.y);)t.x+=30,t.y+=30;return t}};e.$3fc=p,e.$3fc=p=l=Se([re(0,f.$Dec),re(1,h.$gR),re(2,b.$Wec),re(3,a.$_j),re(4,I.$_i)],p);function y(k){const t={openedWindows:[]},o=k||{openedWindows:[]};return o.lastActiveWindow&&(t.lastActiveWindow=$(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(t.lastPluginDevelopmentHostWindow=$(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(t.openedWindows=o.openedWindows.map(i=>$(i))),t}function $(k){const t={uiState:k.uiState};return k.backupPath&&(t.backupPath=k.backupPath),k.remoteAuthority&&(t.remoteAuthority=k.remoteAuthority),k.folder&&(t.folderUri=A.URI.parse(k.folder)),k.workspaceIdentifier&&(t.workspace={id:k.workspaceIdentifier.id,configPath:A.URI.parse(k.workspaceIdentifier.configURIPath)}),t}function m(k){return{lastActiveWindow:k.lastActiveWindow&&v(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&v(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(t=>v(t))}}function v(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(oe[60],ae([0,1,14,3,43,2,13,9,19,21,200,69,58,25,6,5,59,135,30,103,104]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=e.$Pec=void 0,e.$Pec=(0,l.$Fi)("workspacesManagementMainService");let t=class extends D.$Wc{constructor(i,c,s,u,d){super(),this.g=i,this.h=c,this.j=s,this.m=u,this.n=d,this.a=this.B(new r.$me),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new r.$me),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const i=(await a.Promises.readdir(this.c.with({scheme:A.Schemas.file}).fsPath)).map(c=>(0,b.$gh)(this.c,c,m.$5i));for(const c of i){const s=(0,k.$Mec)(c),u=await this.resolveLocalWorkspace(c);u?this.f.push({workspace:s,remoteAuthority:u.remoteAuthority}):await this.deleteUntitledWorkspace(s)}}catch(i){i.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${i}).`)}}resolveLocalWorkspace(i){return this.r(i,c=>a.Promises.readFile(c,"utf8"))}r(i,c){if(this.s(i)&&i.scheme===A.Schemas.file)try{const s=c(i.fsPath);return s instanceof Promise?s.then(u=>this.t(i,u),u=>{}):this.t(i,s)}catch{return}}s(i){return(0,m.$6i)(i,this.g)||(0,m.$$i)(i)}t(i,c){try{const s=this.u(i,c),u=(0,k.$Mec)(i);return{id:u.id,configPath:u.configPath,folders:(0,v.$Ohb)(s.folders,u.configPath,b.$0g),remoteAuthority:s.remoteAuthority,transient:s.transient}}catch(s){this.h.warn(s.toString())}}u(i,c){const s=(0,S.$Xn)(c);if(s&&Array.isArray(s.folders))s.folders=s.folders.filter(u=>(0,v.$Mhb)(u));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return s}async createUntitledWorkspace(i,c){const{workspace:s,storedWorkspace:u}=this.w(i,c),d=s.configPath.fsPath;return await a.Promises.mkdir((0,I.$oc)(d),{recursive:!0}),await a.Promises.writeFile(d,JSON.stringify(u,null,"	")),this.f.push({workspace:s,remoteAuthority:c}),s}w(i=[],c){const s=(Date.now()+Math.round(Math.random()*1e3)).toString(),u=(0,b.$gh)(this.c,s),d=(0,b.$gh)(u,m.$5i),P=[];for(const E of i)P.push((0,v.$Nhb)(E.uri,!0,E.name,u,b.$0g));return{workspace:(0,k.$Mec)(d),storedWorkspace:{folders:P,remoteAuthority:c}}}async getWorkspaceIdentifier(i){return(0,k.$Mec)(i)}isUntitledWorkspace(i){return(0,m.$6i)(i.configPath,this.g)}async deleteUntitledWorkspace(i){this.isUntitledWorkspace(i)&&(await this.y(i),this.j.isEnabled()&&this.j.unsetWorkspace(i),this.a.fire(i))}async y(i){const c=(0,b.$7g)(i.configPath);try{await a.Promises.rm((0,I.$oc)(c));const s=(0,I.$lc)(this.g.workspaceStorageHome.with({scheme:A.Schemas.file}).fsPath,i.id);await a.Promises.exists(s)&&await a.Promises.writeFile((0,I.$lc)(s,"obsolete"),""),this.f=this.f.filter(u=>u.workspace.id!==i.id)}catch(s){this.h.warn(`Unable to delete untitled workspace ${c} (${s}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(i,c,s){if(!i||!i.win||!i.isReady||!await this.z(i,c,s))return;const d=await this.C(i,(0,k.$Mec)(s));if(d)return this.b.fire({window:i,workspace:d.workspace}),d}async z(i,c,s){return s?(0,m.$Ui)(i.openedWorkspace)&&b.$0g.isEqual(i.openedWorkspace.configPath,s)?!1:(0,$.$Jec)(c,s)?(await this.n.showMessageBox({type:"info",buttons:[(0,h.localize)(0,null)],message:(0,h.localize)(1,null,(0,b.$dh)(s)),detail:(0,h.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(i,c){if(!i.config)return;i.focus();let s;return i.config.extensionDevelopmentPath||(i.config.backupPath?s=await this.m.registerWorkspaceBackup({workspace:c,remoteAuthority:i.remoteAuthority},i.config.backupPath):s=this.m.registerWorkspaceBackup({workspace:c,remoteAuthority:i.remoteAuthority})),(0,m.$Ui)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=c,i.config.backupPath=s,{workspace:c,backupPath:s}}};e.$Qec=t,e.$Qec=t=Se([re(0,w.$sec),re(1,p.$_j),re(2,y.$Gec),re(3,f.$xec),re(4,g.$yec)],t)}),define(oe[136],ae([0,1,14,37,23,6,29,30,60,12,5,64]),function(x,e,n,r,S,D,A,I,b,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=e.ID=void 0,e.ID="diagnosticsMainService",e.$afc=(0,D.$Fi)(e.ID);let g=class{constructor(l,p,y){this.a=l,this.b=p,this.c=y}async getRemoteDiagnostics(l){const p=this.a.getWindows();return(await Promise.all(p.map(async $=>{const m=$.remoteAuthority;if(!m)return;const v=`vscode:getDiagnosticInfoResponse${$.id}`,k={includeProcesses:l.includeProcesses,folders:l.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(t=>{$.sendWhenReady("vscode:getDiagnosticInfo",S.CancellationToken.None,{replyChannel:v,args:k}),r.$EX.once(v,(o,i)=>{i||t({hostName:m,errorMessage:`Unable to resolve connection to '${m}'.`}),t(i)}),setTimeout(()=>{t({hostName:m,errorMessage:`Connection to '${m}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const l=[];for(const y of n.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(y.id);$?l.push(await this.d($)):l.push(this.e(y))}const p=[];for(const{pid:y,name:$}of f.$0ec.getAll())p.push({pid:y,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:l,pidToNames:p,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(l){const p=await this.f(l),y=(0,a.$qg)(l.win);return this.e(y,p,l.remoteAuthority)}e(l,p=[],y){return{id:l.id,pid:l.webContents.getOSProcessId(),title:l.getTitle(),folderURIs:p,remoteAuthority:y}}async f(l){const p=[],y=l.openedWorkspace;if((0,I.$Pi)(y))p.push(y.uri);else if((0,I.$Ui)(y)){const $=await this.b.resolveLocalWorkspace(y.configPath);$&&$.folders.forEach(v=>{p.push(v.uri)})}return p}};e.$bfc=g,e.$bfc=g=Se([re(0,A.$Dec),re(1,b.$Pec),re(2,h.$_j)],g)}),define(oe[75],ae([0,1,49,14,27,161,52,3,2,13,9,4,7,114,94,21,112,188,58,25,6,20,5,28,74,29,30,60,17,249,239,83,16]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m,v,k,t,o,i,c,s,u,d,P,E,O,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=e.$pfc=void 0,e.$pfc=(0,k.$Fi)("nativeHostMainService");let R=class extends b.$Wc{constructor(B,C,z,ne,Q,ce,K,ee,H){super(),this.a=B,this.b=C,this.c=z,this.f=ne,this.g=Q,this.h=ce,this.j=K,this.m=ee,this.n=H,this.onDidOpenMainWindow=I.Event.map(this.a.onDidOpenWindow,j=>j.id),this.onDidTriggerWindowSystemContextMenu=I.Event.any(I.Event.map(this.a.onDidTriggerSystemContextMenu,({window:j,x:U,y:V})=>({windowId:j.id,x:U,y:V})),I.Event.map(this.b.onDidTriggerSystemContextMenu,({window:j,x:U,y:V})=>({windowId:j.id,x:U,y:V}))),this.onDidMaximizeWindow=I.Event.any(I.Event.map(this.a.onDidMaximizeWindow,j=>j.id),I.Event.map(this.b.onDidMaximizeWindow,j=>j.id)),this.onDidUnmaximizeWindow=I.Event.any(I.Event.map(this.a.onDidUnmaximizeWindow,j=>j.id),I.Event.map(this.b.onDidUnmaximizeWindow,j=>j.id)),this.onDidChangeWindowFullScreen=I.Event.any(I.Event.map(this.a.onDidChangeFullScreen,j=>({windowId:j.window.id,fullscreen:j.fullscreen})),I.Event.map(this.b.onDidChangeFullScreen,j=>({windowId:j.window.id,fullscreen:j.fullscreen}))),this.onDidBlurMainWindow=I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-blur",(j,U)=>U.id),j=>!!this.a.getWindowById(j)),this.onDidFocusMainWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),j=>!!j),j=>j.id),I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-focus",(j,U)=>U.id),j=>!!this.a.getWindowById(j))),this.onDidBlurMainOrAuxiliaryWindow=I.Event.any(this.onDidBlurMainWindow,I.Event.map(I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-blur",(j,U)=>this.b.getWindowByWebContents(U.webContents)),j=>!!j),j=>j.id)),this.onDidFocusMainOrAuxiliaryWindow=I.Event.any(this.onDidFocusMainWindow,I.Event.map(I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-focus",(j,U)=>this.b.getWindowByWebContents(U.webContents)),j=>!!j),j=>j.id)),this.onDidResumeOS=I.Event.fromNodeEventEmitter(r.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new I.$me),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(r.screen,"display-metrics-changed",(j,U,V)=>V),j=>!(Array.isArray(j)&&j.length===1&&j[0]==="workArea")),I.Event.fromNodeEventEmitter(r.screen,"display-added"),I.Event.fromNodeEventEmitter(r.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(B,C){const z=this.a.getWindows().map(Q=>({id:Q.id,workspace:Q.openedWorkspace??(0,u.$Ti)(Q.backupPath,Q.isExtensionDevelopmentHost),title:Q.win?.getTitle()??"",filename:Q.getRepresentedFilename(),dirty:Q.isDocumentEdited()})),ne=[];return C.includeAuxiliaryWindows&&ne.push(...this.b.getWindows().map(Q=>({id:Q.id,parentId:Q.parentId,title:Q.win?.getTitle()??"",filename:Q.getRepresentedFilename()}))),[...z,...ne]}async getWindowCount(B){return this.a.getWindowCount()}async getActiveWindowId(B){const C=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(C)return C.id}openWindow(B,C,z){return Array.isArray(C)?this.s(B,C,z):this.t(B,C)}async s(B,C,z=Object.create(null)){C.length>0&&await this.a.open({context:s.OpenContext.API,contextWindowId:B,urisToOpen:C,cli:this.g.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async t(B,C){await this.a.openEmptyWindow({context:s.OpenContext.API,contextWindowId:B},C)}async isFullScreen(B,C){return this.C(C?.targetWindowId,B)?.isFullScreen??!1}async toggleFullScreen(B,C){this.C(C?.targetWindowId,B)?.toggleFullScreen()}async handleTitleDoubleClick(B,C){this.C(C?.targetWindowId,B)?.handleTitleDoubleClick()}async getCursorScreenPoint(B){const C=r.screen.getCursorScreenPoint(),z=r.screen.getDisplayNearestPoint(C);return{point:C,display:z.bounds}}async isMaximized(B,C){return this.C(C?.targetWindowId,B)?.win?.isMaximized()??!1}async maximizeWindow(B,C){this.C(C?.targetWindowId,B)?.win?.maximize()}async unmaximizeWindow(B,C){this.C(C?.targetWindowId,B)?.win?.unmaximize()}async minimizeWindow(B,C){this.C(C?.targetWindowId,B)?.win?.minimize()}async moveWindowTop(B,C){this.C(C?.targetWindowId,B)?.win?.moveTop()}async positionWindow(B,C,z){const ne=this.C(z?.targetWindowId,B);if(ne?.win){if(ne.win.isFullScreen()){const Q=I.Event.toPromise(I.Event.once(I.Event.fromNodeEventEmitter(ne.win,"leave-full-screen")));ne.win.setFullScreen(!1),await Q}ne.win.setBounds(C)}}async updateWindowControls(B,C){this.C(C?.targetWindowId,B)?.updateWindowControls(C)}async focusWindow(B,C){this.C(C?.targetWindowId,B)?.focus({force:C?.force??!1})}async setMinimumSize(B,C,z){const ne=this.D(B);if(ne?.win){const[Q,ce]=ne.win.getSize(),[K,ee]=ne.win.getMinimumSize(),[H,j]=[C??K,z??ee],[U,V]=[Math.max(Q,H),Math.max(ce,j)];(K!==H||ee!==j)&&ne.win.setMinimumSize(H,j),(Q!==U||ce!==V)&&ne.win.setSize(U,V)}}async saveWindowSplash(B,C){this.m.saveWindowSplash(B,C)}async installShellCommand(B){const{source:C,target:z}=await this.u();try{const{symbolicLink:ne}=await p.SymlinkSupport.stat(C);if(ne&&!ne.dangling){const Q=await(0,w.$kr)(C);if(z===Q)return}await p.Promises.unlink(C)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await p.Promises.symlink(z,C)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:Q}=await this.showMessageBox(B,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(Q===1)throw new L.$7;try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${C}'\\" with administrator privileges"`;await(0,D.promisify)(n.exec)(ce)}catch{throw new Error((0,$.localize)(3,null,C))}}}async uninstallShellCommand(B){const{source:C}=await this.u();try{await p.Promises.unlink(C)}catch(z){switch(z.code){case"EACCES":{const{response:ne}=await this.showMessageBox(B,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(ne===1)throw new L.$7;try{const Q=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await(0,D.promisify)(n.exec)(Q)}catch{throw new Error((0,$.localize)(7,null,C))}break}case"ENOENT":break;default:throw z}}}async u(){const B=(0,h.$mc)(this.g.appRoot,"bin","code"),C=`/usr/local/bin/${this.j.applicationName}`;if(!await p.Promises.exists(B))throw new Error((0,$.localize)(8,null,B));return{source:C,target:B}}async showMessageBox(B,C){const z=this.C(C?.targetWindowId,B);return this.c.showMessageBox(C,z?.win??void 0)}async showSaveDialog(B,C){const z=this.C(C?.targetWindowId,B);return this.c.showSaveDialog(C,z?.win??void 0)}async showOpenDialog(B,C){const z=this.C(C?.targetWindowId,B);return this.c.showOpenDialog(C,z?.win??void 0)}async pickFileFolderAndOpen(B,C){const z=await this.c.pickFileFolder(C);z&&await this.w(await Promise.all(z.map(async ne=>await p.SymlinkSupport.existsDirectory(ne)?{folderUri:g.URI.file(ne)}:{fileUri:g.URI.file(ne)})),C,B)}async pickFolderAndOpen(B,C){const z=await this.c.pickFolder(C);z&&await this.w(z.map(ne=>({folderUri:g.URI.file(ne)})),C,B)}async pickFileAndOpen(B,C){const z=await this.c.pickFile(C);z&&await this.w(z.map(ne=>({fileUri:g.URI.file(ne)})),C,B)}async pickWorkspaceAndOpen(B,C){const z=await this.c.pickWorkspace(C);z&&await this.w(z.map(ne=>({workspaceUri:g.URI.file(ne)})),C,B)}async w(B,C,z){await this.a.open({context:s.OpenContext.DIALOG,contextWindowId:z,cli:this.g.args,urisToOpen:B,forceNewWindow:C.forceNewWindow})}async showItemInFolder(B,C){r.shell.showItemInFolder(C)}async setRepresentedFilename(B,C,z){this.C(z?.targetWindowId,B)?.setRepresentedFilename(C)}async setDocumentEdited(B,C,z){this.C(z?.targetWindowId,B)?.setDocumentEdited(C)}async openExternal(B,C){return this.g.unsetSnapExportedVariables(),r.shell.openExternal(C),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(B,C){return r.shell.trashItem(C)}async isAdmin(){let B;return f.$i?B=(await new Promise((C,z)=>{x(["native-is-elevated"],C,z)}).then(Re)).default():B=process.getuid?.()===0,B}async writeElevated(B,C,z,ne){const Q=await new Promise((ce,K)=>{x(["@vscode/sudo-prompt"],ce,K)}).then(Re);return new Promise((ce,K)=>{const ee=[`"${this.z}"`];ne?.unlock&&ee.push("--file-chmod"),ee.push("--file-write",`"${C.fsPath}"`,`"${z.fsPath}"`);const H={name:this.j.nameLong.replace("-",""),icns:f.$j&&this.g.isBuilt?(0,h.$lc)((0,h.$oc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};Q.exec(ee.join(" "),H,(j,U,V)=>{U&&this.h.trace(`[sudo-prompt] received stdout: ${U}`),V&&this.h.trace(`[sudo-prompt] received stderr: ${V}`),j?K(j):ce(void 0)})})}async isRunningUnderARM64Translation(){return f.$k||f.$i?!1:r.app.runningUnderARM64Translation}get z(){return f.$i?this.g.isBuilt?(0,h.$lc)((0,h.$oc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,h.$lc)(this.g.appRoot,"scripts","code-cli.bat"):f.$k?this.g.isBuilt?(0,h.$lc)((0,h.$oc)(process.execPath),"bin",`${this.j.applicationName}`):(0,h.$lc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,h.$lc)(this.g.appRoot,"bin","code"):(0,h.$lc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,S.totalmem)(),freemem:(0,S.freemem)(),loadavg:(0,S.loadavg)()}}async getOSProperties(){return{arch:(0,S.arch)(),platform:(0,S.platform)(),release:(0,S.release)(),type:(0,S.type)(),cpus:(0,S.cpus)()}}async getOSVirtualMachineHint(){return l.$Rn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return f.$i&&(0,E.$mfc)()}async getProcessId(B){return this.C(void 0,B)?.win?.webContents.getOSProcessId()}async killProcess(B,C,z){process.kill(C,z)}async readClipboardText(B,C){return r.clipboard.readText(C)}async writeClipboardText(B,C,z){return r.clipboard.writeText(C,z)}async readClipboardFindText(B){return r.clipboard.readFindText()}async writeClipboardFindText(B,C){return r.clipboard.writeFindText(C)}async writeClipboardBuffer(B,C,z,ne){return r.clipboard.writeBuffer(C,Buffer.from(z.buffer),ne)}async readClipboardBuffer(B,C){return P.$Oe.wrap(r.clipboard.readBuffer(C))}async hasClipboard(B,C,z){return r.clipboard.has(C,z)}async newWindowTab(){await this.a.open({context:s.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){r.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){r.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){r.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){r.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){r.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(B,C){this.D(B)?.updateTouchBar(C)}async notifyReady(B){this.D(B)?.setReady()}async relaunch(B,C){return this.f.relaunch(C)}async reload(B,C){const z=this.D(B);if(z){if((0,u.$Ui)(z.openedWorkspace)){const ne=z.openedWorkspace.configPath;if(ne.scheme===a.Schemas.file&&(await this.n.resolveLocalWorkspace(ne))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.f.reload(z,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(B,C){return this.C(C?.targetWindowId,B)?.win?.close()}async quit(B){const C=this.a.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&C.win?C.win.close():this.f.quit()}async exit(B,C){await this.f.kill(C)}async resolveProxy(B,C){return this.D(B)?.win?.webContents?.session?.resolveProxy(C)}async loadCertificates(B){return(await new Promise((z,ne)=>{x(["@vscode/proxy-agent"],z,ne)}).then(Re)).loadSystemCertificates({log:this.h})}findFreePort(B,C,z,ne,Q=1){return(0,y.$4g)(C,z,ne,Q)}async openDevTools(B,C){this.C(C?.targetWindowId,B)?.win?.webContents.openDevTools(C?.mode?{mode:C.mode,activate:C.activate}:void 0)}async toggleDevTools(B,C){this.C(C?.targetWindowId,B)?.win?.webContents.toggleDevTools()}async profileRenderer(B,C,z){const ne=this.D(B);if(!ne||!ne.win)throw new Error;return await new O.$nfc(ne.win,C,this.h).inspect(z)}async windowsGetStringRegKey(B,C,z,ne){if(!f.$i)return;const Q=await new Promise((ce,K)=>{x(["@vscode/windows-registry"],ce,K)}).then(Re);try{return Q.GetStringRegKey(C,z,ne)}catch{return}}C(B,C){return this.D(B)??this.F(B)??this.D(C)}D(B){if(typeof B=="number")return this.a.getWindowById(B)}F(B){if(typeof B!="number")return;const C=r.webContents.fromId(B);if(C)return this.b.getWindowByWebContents(C)}};e.$qfc=R,Se([A.$0h],R.prototype,"z",null),e.$qfc=R=Se([re(0,s.$Dec),re(1,T.$ofc),re(2,m.$yec),re(3,t.$Wec),re(4,v.$sec),re(5,o.$_j),re(6,i.$sk),re(7,c.$Bec),re(8,d.$Pec)],R)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[307],ae([0,1,14,27,8,23,31,2,13,4,116,37,185,97,136,58,25,5,75,84,28,85,34,64,57,29]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m,v,k,t,o,i,c,s){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0,v=et(v);const d="issue.processExplorerWindowState";let P=class{static{u=this}static{this.a="#1E1E1E"}constructor(T,L,R,M,B,C,z,ne,Q,ce,K){this.g=T,this.h=L,this.i=R,this.j=M,this.k=B,this.l=C,this.m=z,this.n=ne,this.o=Q,this.p=ce,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){f.$EX.on("vscode:listProcesses",async T=>{const L=[];try{L.push({name:(0,g.localize)(0,null),rootProcess:await(0,h.$Us)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(M=>{(0,w.$Tm)(M)?L.push({name:M.hostName,rootProcess:M}):M.processes&&L.push({name:M.hostName,rootProcess:M.processes})})}catch(R){this.i.error(`Listing processes failed: ${R}`)}this.t(T,"vscode:listProcessesResponse",L)}),f.$EX.on("vscode:workbenchCommand",(T,L)=>{const{id:R,from:M,args:B}=L;let C;switch(M){case"processExplorer":C=this.f;break;default:throw new Error(`Unexpected command source: ${M}`)}C?.webContents.send("vscode:runAction",{id:R,from:M,args:B})}),f.$EX.on("vscode:closeProcessExplorer",T=>{this.d?.close()}),f.$EX.on("vscode:pidToNameRequest",async T=>{const L=await this.k.getMainDiagnostics(),R=[];for(const M of L.windows)R.push([M.pid,`window [${M.id}] (${M.title})`]);for(const{pid:M,name:B}of i.$0ec.getAll())R.push([M,B]);this.t(T,"vscode:pidToNameResponse",R)})}async openReporter(T){if(this.b)this.b&&this.s(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const L=new I.$Vc,R=L.add(this.n.createIPCObjectUrl()),M=this.v(this.c,700,800);this.b=this.u(M,R,{backgroundColor:T.styles.backgroundColor,title:(0,g.localize)(1,null),zoomLevel:T.zoomLevel,alwaysOnTop:!1},"issue-reporter"),R.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:T,disableExtensions:!!this.h.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:v.default}),this.b.loadURL(b.$Zg.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,L.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,L.dispose())})}}async openProcessExplorer(T){if(!this.d&&(this.f=n.BrowserWindow.getFocusedWindow(),this.f)){const L=new I.$Vc,R=L.add(this.n.createIPCObjectUrl()),M=this.p.getItem(d,void 0),B=E(M)?M:this.v(this.f,800,500);this.d=this.u(B,R,{backgroundColor:T.styles.backgroundColor,title:(0,g.localize)(2,null),zoomLevel:T.zoomLevel,alwaysOnTop:!0},"process-explorer"),R.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:T,product:v.default}),this.d.loadURL(b.$Zg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,L.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,L.dispose())});const C=()=>{if(!this.d)return;const z=this.d.getSize(),ne=this.d.getPosition();if(!z||!ne)return;const Q={width:z[0],height:z[1],x:ne[0],y:ne[1]};this.p.setItem(d,Q)};this.d.on("moved",C),this.d.on("resized",C)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const T=await n.contentTracing.stopRecording(`${(0,A.$Ng)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null,T),buttons:[(0,g.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,T)}async getSystemStatus(){const[T,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(T,L)}async $getSystemInfo(){const[T,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(T,L)}async $getPerformanceInfo(){try{const[T,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(T,L)}catch(T){throw this.i.warn("issueService#getPerformanceInfo ",T.message),T}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(T){this.i.error(T)}}async $showConfirmCloseDialog(){if(this.b){const{response:T}=await this.l.showMessageBox({type:"warning",message:(0,g.localize)(6,null),buttons:[(0,g.localize)(7,null),(0,g.localize)(8,null)]},this.b);T===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:T}=await this.l.showMessageBox({type:"warning",message:(0,g.localize)(9,null),buttons:[(0,g.localize)(10,null),(0,g.localize)(11,null)]},this.b);return T===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const T=this.q.getWindowById(this.c.id);if(!T)throw new Error("Window not found");return T}async $sendReporterMenu(T,L){const R=this.issueReporterWindowCheck(),M="vscode:triggerReporterMenu",B=new D.$xe;return R.sendWhenReady(M,B.token,{replyChannel:M,extensionId:T,extensionName:L}),await(0,S.$wh)(new Promise(z=>f.$EX.once(`vscode:triggerReporterMenuResponse:${T}`,(ne,Q)=>z(Q))),5e3,()=>{this.i.error(`Error: Extension ${T} timed out waiting for menu response`),B.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(T){T.isMinimized()&&T.restore(),T.focus()}t(T,L,...R){T.sender.isDestroyed()||T.sender.send(L,...R)}u(T,L,R,M){const B=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:T.width,height:T.height,minWidth:300,minHeight:200,x:T.x,y:T.y,title:R.title,backgroundColor:R.backgroundColor||u.a,webPreferences:{preload:b.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${L.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.$0D)(R.zoomLevel),sandbox:!0},alwaysOnTop:R.alwaysOnTop,experimentalDarkMode:!0});return B.setMenuBarVisibility(!1),B}v(T,L,R){let M;const B=n.screen.getAllDisplays();if(B.length===1)M=B[0];else{if(a.$j){const ne=n.screen.getCursorScreenPoint();M=n.screen.getDisplayNearestPoint(ne)}!M&&T&&(M=n.screen.getDisplayMatching(T.getBounds())),M||(M=n.screen.getPrimaryDisplay()||B[0])}const C=M.bounds,z={width:L,height:R,x:C.x+C.width/2-L/2,y:C.y+C.height/2-R/2};return C.width>0&&C.height>0&&(z.x<C.x&&(z.x=C.x),z.y<C.y&&(z.y=C.y),z.x>C.x+C.width&&(z.x=C.x),z.y>C.y+C.height&&(z.y=C.y),z.width>C.width&&(z.width=C.width),z.height>C.height&&(z.height=C.height)),z}};e.$rfc=P,e.$rfc=P=u=Se([re(1,y.$sec),re(2,$.$_j),re(3,w.$Sm),re(4,l.$afc),re(5,p.$yec),re(6,m.$pfc),re(7,t.$Aec),re(8,k.$sk),re(9,o.$gR),re(10,s.$Dec)],P);function E(O){return typeof O!="object"||O===null?!1:"x"in O&&"y"in O&&"width"in O&&"height"in O}}),define(oe[308],ae([0,1,23,18,25,20,5,75,28,55,24,50,106]),function(x,e,n,r,S,D,A,I,b,a,h,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;let w=class extends g.$Qfc{constructor(p,y,$,m,v,k,t,o){super(p,y,m,v,k,o),this.e=$,this.u=t}s(p){return(0,g.$Pfc)(`linux-${process.arch}`,p,this.k)}t(p){this.a&&(this.d(f.$CY.CheckingForUpdates(p)),this.i.request({url:this.a},n.CancellationToken.None).then(a.$$p).then(y=>{!y||!y.url||!y.version||!y.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!p}),this.d(f.$CY.Idle(f.UpdateType.Archive))):this.d(f.$CY.AvailableForDownload(y))}).then(void 0,y=>{this.j.error(y);const $=p?y.message||y:void 0;this.d(f.$CY.Idle(f.UpdateType.Archive,$))}))}async o(p){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):p.update.url&&this.u.openExternal(void 0,p.update.url),this.d(f.$CY.Idle(f.UpdateType.Archive))}};e.$Sfc=w,e.$Sfc=w=Se([re(0,D.$Wec),re(1,r.$_i),re(2,h.$$l),re(3,S.$sec),re(4,a.$5p),re(5,A.$_j),re(6,I.$pfc),re(7,b.$sk)],w)}),define(oe[309],ae([0,1,49,47,27,8,23,52,46,9,7,149,21,18,25,15,20,5,75,28,55,24,50,106]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m,v,k,t,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=void 0,r=Re(r),a=Re(a),g=Re(g);async function c(P,E=1e3){for(;!P();)await(0,D.$Gh)(E)}let s;function u(){return typeof s>"u"&&(s=r.existsSync(a.$lc(a.$oc(process.execPath),"unins000.exe"))?o.UpdateType.Setup:o.UpdateType.Archive),s}let d=class extends i.$Qfc{get cachePath(){const E=a.$lc((0,S.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return g.Promises.mkdir(E,{recursive:!0}).then(()=>E)}constructor(E,O,T,L,R,M,B,C,z){super(E,O,L,R,M,z),this.u=T,this.v=B,this.w=C,E.setRelaunchHandler(this)}handleRelaunch(E){return E?.addArgs||E?.removeArgs||this.state.type!==o.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(o.$CY.Disabled(o.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(E){let O=`win32-${process.arch}`;return u()===o.UpdateType.Archive?O+="-archive":this.k.target==="user"&&(O+="-user"),(0,i.$Pfc)(O,E,this.k)}t(E){this.a&&(this.d(o.$CY.CheckingForUpdates(E)),this.i.request({url:this.a},A.CancellationToken.None).then(k.$$p).then(O=>{const T=u();return!O||!O.url||!O.version||!O.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!E}),this.d(o.$CY.Idle(T)),Promise.resolve(null)):T===o.UpdateType.Archive?(this.d(o.$CY.AvailableForDownload(O)),Promise.resolve(null)):(this.d(o.$CY.Downloading),this.C(O.version).then(()=>this.B(O.version).then(L=>g.Promises.exists(L).then(R=>{if(R)return Promise.resolve(L);const M=`${L}.tmp`;return this.i.request({url:O.url},A.CancellationToken.None).then(B=>this.v.writeFile(h.URI.file(M),B.stream)).then(O.sha256hash?()=>(0,f.$xX)(M,O.sha256hash):()=>{}).then(()=>g.Promises.rename(M,L,!1)).then(()=>L)})).then(L=>{this.e={packagePath:L},this.d(o.$CY.Downloaded(O)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(o.$CY.Ready(O))})))}).then(void 0,O=>{this.u.publicLog2("update:error",{messageHash:String((0,b.$tj)(String(O)))}),this.j.error(O);const T=E?O.message||O:void 0;this.d(o.$CY.Idle(u(),T))}))}async o(E){E.update.url&&this.w.openExternal(void 0,E.update.url),this.d(o.$CY.Idle(u()))}async B(E){const O=await this.cachePath;return a.$lc(O,`CodeSetup-${this.k.quality}-${E}.exe`)}async C(E=null){const O=E?M=>!new RegExp(`${this.k.quality}-${E}\\.exe$`).test(M):()=>!0,T=await this.cachePath,R=(await g.Promises.readdir(T)).filter(O).map(async M=>{try{await g.Promises.unlink(a.$lc(T,M))}catch{}});await Promise.all(R)}async p(){if(this.state.type!==o.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const E=this.state.update;this.d(o.$CY.Updating(E));const O=await this.cachePath;this.e.updateFilePath=a.$lc(O,`CodeSetup-${this.k.quality}-${E.version}.flag`),await g.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(o.$CY.Idle(u()))});const L=`${this.k.win32MutexName}-ready`,R=await new Promise((M,B)=>{x(["@vscode/windows-mutex"],M,B)}).then(Re);c(()=>R.isActive(L)).then(()=>this.d(o.$CY.Ready(E)))}r(){this.state.type!==o.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?r.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return u()}async _applySpecificUpdate(E){if(this.state.type!==o.StateType.Idle)return;const O=this.g.getValue("update.enableWindowsBackgroundUpdates"),T={version:"unknown",productVersion:"unknown"};this.d(o.$CY.Downloading),this.e={packagePath:E},this.d(o.$CY.Downloaded(T)),O?this.k.target==="user"&&this.p():this.d(o.$CY.Ready(T))}};e.$Ufc=d,Se([I.$0h],d.prototype,"cachePath",null),e.$Ufc=d=Se([re(0,y.$Wec),re(1,w.$_i),re(2,t.$$l),re(3,l.$sec),re(4,k.$5p),re(5,$.$_j),re(6,p.$_k),re(7,m.$pfc),re(8,v.$sk)],d)}),define(oe[137],ae([0,1,14,8,23,53,3,2,13,70,4,7,196,27,69,18,58,25,68,15,20,5,28,85,285,88,24,111,74,57,29,30,60,51,40,34,59,71,22,6]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m,v,k,t,o,i,c,s,u,d,P,E,O,T,L,R,M,B,C,z,ne,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=e.$Tec=void 0;var ce;(function(H){H[H.NONE=0]="NONE",H[H.NAVIGATING=1]="NAVIGATING",H[H.READY=2]="READY"})(ce||(ce={}));class K extends I.$Wc{get lastFocusTime(){return this.j}get win(){return this.m}n(j){this.m=j,this.B(A.Event.fromNodeEventEmitter(j,"maximize")(()=>this.b.fire())),this.B(A.Event.fromNodeEventEmitter(j,"unmaximize")(()=>this.c.fire())),this.B(A.Event.fromNodeEventEmitter(j,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(A.Event.fromNodeEventEmitter(j,"focus")(()=>{this.j=Date.now()})),this.B(A.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(A.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const U=!(0,E.$5D)(this.r);if(h.$j&&U&&j.setSheetOffset((0,h.$J)((0,w.release)())?28:22),U&&(h.$i&&(0,E.$8D)(this.r)||h.$j)){const V=this.s.getItem(K.D);V?this.updateWindowControls({height:V}):this.updateWindowControls({height:E.$7D})}h.$i&&U&&j.hookWindowMessage(278,()=>{const[le,G]=j.getPosition(),he=n.screen.getCursorScreenPoint(),se=he.x-le,_=he.y-G;return!(se>30&&_>=0&&_<=Math.max(j.getBounds().height*.15,35))||(j.setEnabled(!1),j.setEnabled(!0),this.f.fire({x:se,y:_})),0}),this.t.args["open-devtools"]===!0&&j.webContents.openDevTools(),h.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(j,U,V,le){super(),this.r=j,this.s=U,this.t=V,this.u=le,this.a=this.B(new A.$me),this.onDidClose=this.a.event,this.b=this.B(new A.$me),this.onDidMaximize=this.b.event,this.c=this.B(new A.$me),this.onDidUnmaximize=this.c.event,this.f=this.B(new A.$me),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new A.$me),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new A.$me),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,E.$8D)(this.r),this.G=void 0,this.H=void 0}w(j,U=n.screen.getAllDisplays().length>0){const V=this.r.getValue("window"),le=h.$j&&V?.nativeTabs===!0;(h.$j||h.$i)&&U&&(!le||n.BrowserWindow.getAllWindows().length===1)&&[j.width,j.height,j.x,j.y].every(G=>typeof G=="number")&&this.m?.setBounds({width:j.width,height:j.height,x:j.x,y:j.y}),(j.mode===R.WindowMode.Maximized||j.mode===R.WindowMode.Fullscreen)&&(this.m?.maximize(),j.mode===R.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(j){h.$j?this.win?.setRepresentedFilename(j):this.z=j}getRepresentedFilename(){return h.$j?this.win?.getRepresentedFilename():this.z}setDocumentEdited(j){h.$j&&this.win?.setDocumentEdited(j),this.C=j}isDocumentEdited(){return h.$j?!!this.win?.isDocumentEdited():!!this.C}focus(j){h.$j&&j?.force&&n.app.focus({steal:!0});const U=this.win;U&&(U.isMinimized()&&U.restore(),U.focus())}handleTitleDoubleClick(){const j=this.win;if(j)if(h.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":j.minimize();break;case"None":break;case"Maximize":default:j.isMaximized()?j.unmaximize():j.maximize()}else j.isMaximized()?j.unmaximize():j.maximize()}static{this.D="windowControlHeight"}updateWindowControls(j){const U=this.win;if(U){if(j.height&&this.s.setItem(ee.D,j.height),h.$i&&this.F)U.setTitleBarOverlay({color:j.backgroundColor?.trim()===""?void 0:j.backgroundColor,symbolColor:j.foregroundColor?.trim()===""?void 0:j.foregroundColor,height:j.height?j.height-1:void 0});else if(h.$j&&j.height!==void 0){const V=(j.height-15)/2;V?U.setWindowButtonPosition({x:V,y:V}):U.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(j,U){(0,E.$9D)(this.r)?this.J(j,U):this.M(j)}get isFullScreen(){if(h.$j&&typeof this.G=="boolean")return this.G;const j=this.win,U=j?.isFullScreen(),V=j?.isSimpleFullScreen();return!!(U||V)}J(j,U){const V=this.win;V?.isSimpleFullScreen()&&V?.setSimpleFullScreen(!1),this.L(j,U)}L(j,U){if(h.$j){this.G=j;const le=this.H=new r.$3h;(async()=>{const G=await Promise.race([le.p,(0,r.$Gh)(1e4).then(()=>!1)]);this.H===le&&(this.G=void 0,this.H=void 0,!G&&j&&U&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(j)}M(j){const U=this.win;U?.isFullScreen()&&this.L(!1,!1),U?.setSimpleFullScreen(j),U?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$Tec=K;let ee=class extends K{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const j=this.hb.profiles.find(U=>U.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&j?j:this.hb.getProfileForWorkspace(this.config.workspace??(0,T.$Ti)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(j,U,V,le,G,he,se,_,F,N,W,q,Y,X,Z,ie,de,me,we,Ie,ke){super(N,Ie,le,U),this.fb=V,this.gb=G,this.hb=he,this.ib=se,this.jb=_,this.kb=F,this.lb=W,this.mb=q,this.nb=Y,this.ob=X,this.pb=Z,this.qb=ie,this.rb=de,this.sb=me,this.tb=we,this.N=this.B(new A.$me),this.onWillLoad=this.N.event,this.O=this.B(new A.$me),this.onDidSignalReady=this.O.event,this.P=this.B(new A.$me),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=ce.NONE;{const[Pe,De]=this.Eb(j.state);this.U=Pe,this.u.trace("window#ctor: using window state",Pe);const $e=ke.invokeFunction(O.$Eec,this.U,{preload:b.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,a.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow($e),(0,a.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,De),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=ce.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.X.push(j)})}get isReady(){return this.ub===ce.READY}get whenClosedOrLoaded(){return new Promise(j=>{function U(){V.dispose(),le.dispose(),j()}const V=this.onDidClose(()=>U()),le=this.onWillLoad(()=>U())})}vb(){this.B(A.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(R.WindowError.UNRESPONSIVE))),this.B(A.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(U,V)=>V)(U=>this.yb(R.WindowError.PROCESS_GONE,{...U}))),this.B(A.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(U,V,le)=>({exitCode:V,reason:le}))(({exitCode:U,reason:V})=>this.yb(R.WindowError.LOAD,{reason:V,exitCode:U}))),this.B(A.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(U=>U.preventDefault())),this.B(A.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",S.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",S.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(U=>this.Bb(U))),this.B(this.mb.onDidDeleteUntitledWorkspace(U=>this.Ab(U)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(U,V)=>{const le=await this.xb();V({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,le)})})}xb(){return this.wb||(this.wb=(0,c.$mq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(j,U){switch(j){case R.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break;case R.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case R.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:j,reason:U?.reason,code:U?.exitCode}),j){case R.WindowError.UNRESPONSIVE:case R.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(j===R.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:le}=await this.pb.showMessageBox({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null),(0,g.localize)(2,null)],message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null),checkboxLabel:this.S?.workspace?(0,g.localize)(5,null):void 0},this.m);if(V!==2){const G=V===0;await this.zb(G,le)}}else if(j===R.WindowError.PROCESS_GONE){let V;U?V=(0,g.localize)(7,null,U.reason,U.exitCode??"<unknown>"):V=(0,g.localize)(6,null);const{response:le,checkboxChecked:G}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,g.localize)(8,null):(0,g.localize)(9,null),(0,g.localize)(10,null)],message:V,detail:this.S?.workspace?(0,g.localize)(11,null):(0,g.localize)(12,null),checkboxLabel:this.S?.workspace?(0,g.localize)(13,null):void 0},this.m),he=le===0;await this.zb(he,G)}break}}async zb(j,U){const V=this.S?.workspace;if(U&&V)try{const le=this.kb.workspaceStorage(V);await le.init(),le.delete("memento/workbench.parts.editor"),await le.close()}catch(le){this.u.error(le)}this.P.fire();try{if(j&&this.S){let le,G;(0,T.$Pi)(V)?le={folderUri:V.uri}:(0,T.$Ui)(V)?le={workspaceUri:V.configPath}:G=!0,(0,ne.$Qb)(await this.tb.open({context:O.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:le?[le]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(j){this.S?.workspace?.id===j.id&&(this.S.workspace=void 0)}Bb(j){if(!j||j.affectsConfiguration("window.menuBarVisibility")){const U=this.Gb();U!==this.W&&(this.W=U,this.Hb(U))}if(!j||j.affectsConfiguration("http.proxy")){let U=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.Z||V!==this.$)){this.Z=U,this.$=V;const le=U||"",G=V?`${V},<local>`:"<local>";this.u.trace(`Setting proxy to '${le}', bypassing '${G}'`),this.m.webContents.session.setProxy({proxyRules:le,proxyBypassRules:G,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:le,proxyBypassRules:G,pacScript:""})}}}addTabbedWindow(j){h.$j&&j.win&&this.m.addTabbedWindow(j.win)}load(j,U=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!U.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),U.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(j,U),this.ub===ce.NONE?this.S=j:this.db=j,this.ub=ce.NAVIGATING,this.m.loadURL(b.$Zg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new r.$Rh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:j.workspace,reason:U.isReload?R.LoadReason.RELOAD:V?R.LoadReason.LOAD:R.LoadReason.INITIAL})}Cb(j,U){const V=(this.S??this.db)?.userEnv;if(V){const le=(0,m.$Jm)(V)&&!(0,m.$Jm)(j.userEnv),G=this.isExtensionDevelopmentHost;(le||G)&&(j.userEnv={...V,...j.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),U.disableExtensions!==void 0&&(j["disable-extensions"]=U.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this.m.isMaximized(),j.partsSplash=this.lb.getWindowSplash(),j.zoomLevel=this.Jb(),j.isCustomZoomLevel=typeof this.ab=="number",j.isCustomZoomLevel&&j.partsSplash&&(j.partsSplash.zoomLevel=j.zoomLevel),(0,a.mark)("code/willOpenNewWindow"),j.perfMarks=(0,a.getMarks)(),this.bb.update(j)}async reload(j){const U=Object.assign({},this.S);U.workspace=await this.Db(U),delete U.filesToOpenOrCreate,delete U.filesToDiff,delete U.filesToMerge,delete U.filesToWait,this.isExtensionDevelopmentHost&&j&&(U.verbose=j.verbose,U.debugId=j.debugId,U.extensionEnvironment=j.extensionEnvironment,U["inspect-extensions"]=j["inspect-extensions"],U["inspect-brk-extensions"]=j["inspect-brk-extensions"],U["extensions-dir"]=j["extensions-dir"]),U.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),U.isInitialStartup=!1,U.policiesData=this.gb.serialize(),U.continueOn=this.t.continueOn,U.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},U.logLevel=this.fb.getLogLevel(),U.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(U,{isReload:!0,disableExtensions:j?.["disable-extensions"]})}async Db(j){if((0,T.$Ui)(j.workspace)){const U=j.workspace.configPath;if(U.scheme===b.Schemas.file&&!await this.ib.exists(U))return}else if((0,T.$Pi)(j.workspace)){const U=j.workspace.uri;if(U.scheme===b.Schemas.file&&!await this.ib.exists(U))return}return j.workspace}serializeWindowState(){if(!this.m)return(0,R.$qec)();if(this.isFullScreen){let V;try{V=n.screen.getDisplayMatching(this.getBounds())}catch{}const le=(0,R.$qec)();return{mode:R.WindowMode.Fullscreen,display:V?V.id:void 0,width:this.U.width||le.width,height:this.U.height||le.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const j=Object.create(null);let U;if(!h.$j&&this.m.isMaximized()?U=R.WindowMode.Maximized:U=R.WindowMode.Normal,U===R.WindowMode.Maximized?j.mode=R.WindowMode.Maximized:j.mode=R.WindowMode.Normal,U===R.WindowMode.Normal||U===R.WindowMode.Maximized){let V;U===R.WindowMode.Normal?V=this.getBounds():V=this.m.getNormalBounds(),j.x=V.x,j.y=V.y,j.width=V.width,j.height=V.height}return j.zoomLevel=this.ab,j}Eb(j){(0,a.mark)("code/willRestoreCodeWindowState");let U=!1;if(j){this.ab=j.zoomLevel;try{const V=n.screen.getAllDisplays();U=V.length>1,j=O.WindowStateValidator.validateWindowState(this.u,j,V)}catch(V){this.u.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}}return(0,a.mark)("code/didRestoreCodeWindowState"),[j||(0,R.$qec)(),U]}getBounds(){const[j,U]=this.m.getPosition(),[V,le]=this.m.getSize();return{x:j,y:U,width:V,height:le}}I(j,U){super.I(j,U),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",S.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let j=(0,E.$3D)(this.r);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}Hb(j,U=!0){h.$j||(j==="toggle"&&U&&this.send("vscode:showInfoMessage",(0,g.localize)(14,null)),j==="hidden"?setTimeout(()=>{this.Ib(j)}):this.Ib(j))}Ib(j){const U=this.isFullScreen;switch(j){case"classic":this.m.setMenuBarVisibility(!U),this.m.autoHideMenuBar=U;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(j){this.ab=j}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(j,U,...V){this.isReady?this.send(j,...V):this.ready().then(()=>{U.isCancellationRequested||this.send(j,...V)})}send(j,...U){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${j}' for window that is destroyed`);return}try{this.m.webContents.send(j,...U)}catch(V){this.u.warn(`Error sending IPC message to channel '${j}' of window ${this.Q}: ${(0,D.$qj)(V)}`)}}}updateTouchBar(j){h.$j&&this.Y.forEach((U,V)=>{const le=j[V];U.segments=this.Mb(le)})}Kb(){if(h.$j){for(let j=0;j<10;j++){const U=this.Lb();this.Y.push(U)}this.m.setTouchBar(new n.TouchBar({items:this.Y}))}}Lb(j=[]){const U=this.Mb(j),V=new n.TouchBar.TouchBarSegmentedControl({segments:U,mode:"buttons",segmentStyle:"automatic",change:le=>{this.sendWhenReady("vscode:runAction",S.CancellationToken.None,{id:V.segments[le].id,from:"touchbar"})}});return V}Mb(j=[]){return j.map(V=>{let le;V.icon&&!d.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===b.Schemas.file&&(le=n.nativeImage.createFromPath(f.URI.revive(V.icon.dark).fsPath),le.isEmpty()&&(le=void 0));let G;return typeof V.title=="string"?G=V.title:G=V.title.value,{id:V.id,label:le?void 0:G,icon:le}})}matches(j){return this.m?.webContents.id===j.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$Uec=ee,e.$Uec=ee=Se([re(1,t.$_j),re(2,z.$Rec),re(3,$.$sec),re(4,M.$so),re(5,C.$Gec),re(6,v.$_k),re(7,s.$5ec),re(8,s.$3ec),re(9,p.$_i),re(10,P.$Bec),re(11,L.$Pec),re(12,l.$xec),re(13,u.$$l),re(14,y.$yec),re(15,k.$Wec),re(16,o.$sk),re(17,i.$Aec),re(18,O.$Dec),re(19,B.$gR),re(20,Q.$Ei)],ee)}),define(oe[310],ae([0,1,14,4,18,25,20,5,34,57,51,137]),function(x,e,n,r,S,D,A,I,b,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;let g=class extends f.$Tec{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(l,p,y,$,m,v){super($,m,p,y),this.O=l,this.P=v,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(l){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),l&&!this.N&&(this.N=!0,this.w({x:l.x,y:l.y,width:l.width,height:l.height,mode:l.show===!1?h.WindowMode.Maximized:h.WindowMode.Normal})))}Q(){if(this.m)return;const l=n.BrowserWindow.fromWebContents(this.O);l&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(l),l.setMenu(null),(r.$i||r.$k)&&(0,a.$5D)(this.r)&&l.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(l){return this.O.id===l.id}};e.$Vec=g,e.$Vec=g=Se([re(1,D.$sec),re(2,I.$_j),re(3,S.$_i),re(4,b.$gR),re(5,A.$Wec)],g)}),define(oe[311],ae([0,1,14,3,2,13,37,310,6,5,51,29]),function(x,e,n,r,S,D,A,I,b,a,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;let g=class extends S.$Wc{constructor(l,p){super(),this.h=l,this.j=p,this.a=this.B(new r.$me),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new r.$me),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new r.$me),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new r.$me),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(l,p)=>{const y=this.getWindowByWebContents(p.webContents);if(y)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),y.tryClaimWindow();else{const $=new S.$Vc;$.add(r.Event.fromNodeEventEmitter(p.webContents,"did-create-window",(m,v)=>({browserWindow:m,details:v}))(({browserWindow:m,details:v})=>{const k=this.getWindowByWebContents(m.webContents);k&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),k.tryClaimWindow(v.options))})),$.add(r.Event.fromNodeEventEmitter(p,"closed")(()=>$.dispose()))}}),A.$EX.handle("vscode:registerAuxiliaryWindow",async(l,p)=>{const y=this.getWindowByWebContents(l.sender);return y&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),y.parentId=p),l.sender.id})}createWindow(l){return this.h.invokeFunction(f.$Eec,this.n(l),{preload:D.$Zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(l){const p={},y=l.features.split(",");for(const m of y){const[v,k]=m.split("=");switch(v){case"width":p.width=parseInt(k,10);break;case"height":p.height=parseInt(k,10);break;case"left":p.x=parseInt(k,10);break;case"top":p.y=parseInt(k,10);break;case"window-maximized":p.mode=h.WindowMode.Maximized;break;case"window-fullscreen":p.mode=h.WindowMode.Fullscreen;break}}const $=f.WindowStateValidator.validateWindowState(this.j,p)??(0,h.$rec)();return this.j.trace("[aux window] using window state",$),$}registerWindow(l){const p=new S.$Vc,y=this.h.createInstance(I.$Vec,l);this.g.set(y.id,y),p.add((0,S.$Uc)(()=>this.g.delete(y.id))),p.add(y.onDidMaximize(()=>this.a.fire(y))),p.add(y.onDidUnmaximize(()=>this.b.fire(y))),p.add(y.onDidEnterFullScreen(()=>this.c.fire({window:y,fullscreen:!0}))),p.add(y.onDidLeaveFullScreen(()=>this.c.fire({window:y,fullscreen:!1}))),p.add(y.onDidTriggerSystemContextMenu(({x:$,y:m})=>this.f.fire({window:y,x:$,y:m}))),r.Event.once(y.onDidClose)(()=>p.dispose())}getWindowByWebContents(l){const p=this.g.get(l.id);return p?.matches(l)?p:void 0}getFocusedWindow(){const l=n.BrowserWindow.getFocusedWindow();if(l)return this.getWindowByWebContents(l.webContents)}getLastActiveWindow(){return(0,f.$Fec)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$pgc=g,e.$pgc=g=Se([re(0,b.$Ei),re(1,a.$_j)],g)}),define(oe[89],ae([0,1,14,22,8,3,48,2,13,4,19,7,21,199,6,20,5,63,88,103,30,60,32,58]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m,v,k,t,o,i){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=e.$Bfc=void 0,e.$Bfc=(0,l.$Fi)("workspacesHistoryMainService");let s=class extends I.$Wc{static{c=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(d,P,E,O,T){super(),this.f=d,this.g=P,this.h=E,this.j=O,this.m=T,this.c=this.B(new D.$me),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new S.$Dh(800)),this.n()}n(){this.h.when(p.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(d=>this.addRecentlyOpened([{workspace:d.workspace,remoteAuthority:d.window.remoteAuthority}])))}async addRecentlyOpened(d){let P=[],E=[];for(const T of d)if((0,v.$Jhb)(T))!this.g.isUntitledWorkspace(T.workspace)&&!this.w(P,T.workspace)&&P.push(T);else if((0,v.$Khb)(T))this.y(P,T.folderUri)||P.push(T);else{const L=this.z(E,T.fileUri),R=T.fileUri.scheme===b.Schemas.file&&c.G.indexOf((0,h.$dh)(T.fileUri))>=0;!L&&!R&&(E.push(T),a.$i&&T.fileUri.scheme===b.Schemas.file&&n.app.addRecentDocument(T.fileUri.fsPath))}const O=await this.r({workspaces:P,files:E});P=O.workspaces,E=O.files,P.length>c.a&&(P.length=c.a),E.length>c.a&&(E.length=c.a),await this.t({workspaces:P,files:E}),this.c.fire(),a.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(d){const P=L=>{const R=this.u(L);for(const M of d)if(h.$0g.isEqual(M,R))return!1;return!0},E=await this.getRecentlyOpened(),O=E.workspaces.filter(P),T=E.files.filter(P);(O.length!==E.workspaces.length||T.length!==E.files.length)&&(await this.t({files:T,workspaces:O}),this.c.fire(),a.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(d){if(d?.confirm){const{response:P}=await this.m.showMessageBox({type:"warning",buttons:[(0,w.localize)(0,null),(0,w.localize)(1,null)],message:(0,w.localize)(2,null),detail:(0,w.localize)(3,null),cancelId:1});if(P!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(d){const P=new o.$Cc(T=>h.$0g.getComparisonKey(T));if(d?.workspaces)for(const T of d.workspaces)P.set(this.u(T),T);const E=new o.$Cc(T=>h.$0g.getComparisonKey(T));if(d?.files)for(const T of d.files)E.set(this.u(T),T);const O=await this.s();for(const T of O.workspaces){const L=P.get(this.u(T));L?L.label=L.label??T.label:P.set(this.u(T),T)}for(const T of O.files){const L=E.get(this.u(T));L?L.label=L.label??T.label:E.set(this.u(T),T)}return{workspaces:[...P.values()],files:[...E.values()]}}async s(){await this.j.whenReady;let d;const P=this.j.get(c.b,$.StorageScope.APPLICATION);if(typeof P=="string")try{d=JSON.parse(P)}catch(E){this.f.error("Unexpected error parsing opened paths list",E)}return(0,v.$Qhb)(d,this.f)}async t(d){await this.j.whenReady,this.j.store(c.b,JSON.stringify((0,v.$Rhb)(d)),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE)}u(d){return(0,v.$Khb)(d)?d.folderUri:(0,v.$Lhb)(d)?d.fileUri:d.workspace.configPath}w(d,P){return!!d.find(E=>(0,v.$Jhb)(E)&&E.workspace.id===P.id)}y(d,P){return!!d.find(E=>(0,v.$Khb)(E)&&h.$0g.isEqual(E.folderUri,P))}z(d,P){return!!d.find(E=>h.$0g.isEqual(E.fileUri,P))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){a.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!a.$i)return;const d=[];if(d.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(4,null),description:(0,w.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const P=[];for(const T of n.app.getJumpListSettings().removedItems){const L=T.args;if(L){const R=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(L);R&&P.push(f.URI.parse(R[2]))}}await this.removeRecentlyOpened(P);let E=!1;const O=(0,r.$Jb)((await this.getRecentlyOpened()).workspaces.slice(0,c.F).map(T=>{const L=(0,v.$Jhb)(T)?T.workspace:T.folderUri,{title:R,description:M}=this.L(L,T.label);let B;return f.URI.isUri(L)?B=`--folder-uri "${L.toString()}"`:(E=!0,B=`--file-uri "${L.configPath.toString()}"`),{type:"task",title:R.substr(0,255),description:M.substr(0,255),program:process.execPath,args:B,iconPath:"explorer.exe",iconIndex:0}}));O.length>0&&d.push({type:"custom",name:E?(0,w.localize)(6,null):(0,w.localize)(7,null),items:O})}d.push({type:"recent"});try{const P=n.app.setJumpList(d);P&&P!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${P}`)}catch(P){this.f.warn("updateWindowsJumpList#setJumpList",P)}}L(d,P){if(P)return{title:(0,A.$5w)(P).name,description:P};if(f.URI.isUri(d))return{title:(0,h.$dh)(d),description:this.M(d)};if(this.g.isUntitledWorkspace(d))return{title:(0,w.localize)(8,null),description:""};let E=(0,h.$dh)(d.configPath);return E.endsWith(k.$2i)&&(E=E.substr(0,E.length-k.$2i.length-1)),{title:(0,w.localize)(9,null,E),description:this.M(d.configPath)}}M(d){return d.scheme==="file"?(0,A.$Ww)(d.fsPath):d.toString()}async N(){if(!a.$j)return;n.app.clearRecentDocuments();const d=await this.getRecentlyOpened(),P=[];let E=0;for(let T=0;T<d.workspaces.length&&E<c.C;T++){const L=this.u(d.workspaces[T]);if(L.scheme===b.Schemas.file){const R=(0,h.$7g)(L);await g.Promises.exists(R)&&(P.push(R),E++)}}const O=[];for(let T=0;T<d.files.length&&E<c.D;T++){const L=this.u(d.files[T]);if(L.scheme===b.Schemas.file){const R=(0,h.$7g)(L);if(c.G.includes((0,h.$dh)(L))||P.includes(R))continue;await g.Promises.exists(R)&&(O.push(R),E++)}}O.reverse().forEach(T=>n.app.addRecentDocument(T)),P.reverse().forEach(T=>n.app.addRecentDocument(T))}};e.$Cfc=s,e.$Cfc=s=c=Se([re(0,y.$_j),re(1,t.$Pec),re(2,p.$Wec),re(3,m.$5ec),re(4,i.$yec)],s)}),define(oe[312],ae([0,1,14,8,23,48,4,7,187,83,18,25,20,5,235,75,28,34,24,50,57,29,89,2]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m,v,k,t,o,i){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0,b=Re(b);const s="menu";let u=class extends i.$Wc{static{c=this}static{this.a="lastKnownMenubarData"}constructor(E,O,T,L,R,M,B,C,z,ne,Q,ce){super(),this.t=E,this.u=O,this.w=T,this.y=L,this.z=R,this.C=M,this.D=B,this.F=C,this.G=z,this.H=ne,this.I=Q,this.J=ce,this.s=Object.create(null),this.h=new r.$Rh(()=>this.R(),0),this.j=new r.$Rh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(A.$j||(0,k.$5D)(O))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const E=this.D.getItem(c.a);E&&(E.menus&&(this.n=E.menus),E.keybindings&&(this.r=E.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(M,B,C)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:B?.id})},this.s["workbench.action.newWindow"]=(M,B,C)=>this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:B?.id}),this.s["workbench.action.files.openFileFolder"]=(M,B,C)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.files.openFolder"]=(M,B,C)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.openWorkspace"]=(M,B,C)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const E=this.I.youTubeUrl;E&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(E,"openYouTubeUrl"));const O=this.I.requestFeatureUrl;O&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(O,"openUserVoiceUrl"));const T=this.I.reportIssueUrl;T&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(T,"openReportIssues"));const L=this.I.licenseUrl;L&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(A.$w){const M=L.indexOf("?")>0?"&":"?";this.ob(`${L}${M}lang=${A.$w}`,"openLicenseUrl")}else this.ob(L,"openLicenseUrl")});const R=this.I.privacyStatementUrl;R&&L&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(R,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(E=>this.S(E))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const E=this.u.getValue("window.enableMenuBarMnemonics");return typeof E!="boolean"?!0:E}get P(){if(!A.$j)return!1;const E=this.u.getValue("window.nativeTabs");return typeof E!="boolean"?!1:E}updateMenu(E,O){this.n=E.menus,this.r=E.keybindings,this.D.setItem(c.a,E),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(E){A.$j&&(E.oldCount===0&&E.newCount>0||E.oldCount>0&&E.newCount===0)&&(this.f=E.newCount===0,this.Q())}U(){if(!A.$j)return;const E=n.BrowserWindow.getFocusedWindow();this.g=!E||!!this.J.getWindowByWebContents(E.webContents),this.Q()}W(){const E=n.Menu.getApplicationMenu();if(E&&this.m.push(E),Object.keys(this.n).length===0){this.X(A.$j?new n.Menu:null);return}const O=new n.Menu;let T;if(A.$j){const R=new n.Menu;T=new n.MenuItem({label:this.I.nameShort,submenu:R}),this.Y(R),O.append(T)}if(A.$j&&!this.c){this.c=!0;const R=new n.Menu;R.append(new n.MenuItem({label:this.qb(b.localize(0,null)),click:()=>this.w.openEmptyWindow({context:t.OpenContext.DOCK})})),n.app.dock.setMenu(R)}if(this.$("File")){const R=new n.Menu,M=new n.MenuItem({label:this.qb(b.localize(1,null)),submenu:R});this.bb(R,"File"),O.append(M)}if(this.$("Edit")){const R=new n.Menu,M=new n.MenuItem({label:this.qb(b.localize(2,null)),submenu:R});this.bb(R,"Edit"),O.append(M)}if(this.$("Selection")){const R=new n.Menu,M=new n.MenuItem({label:this.qb(b.localize(3,null)),submenu:R});this.bb(R,"Selection"),O.append(M)}if(this.$("View")){const R=new n.Menu,M=new n.MenuItem({label:this.qb(b.localize(4,null)),submenu:R});this.bb(R,"View"),O.append(M)}if(this.$("Go")){const R=new n.Menu,M=new n.MenuItem({label:this.qb(b.localize(5,null)),submenu:R});this.bb(R,"Go"),O.append(M)}if(this.$("Run")){const R=new n.Menu,M=new n.MenuItem({label:this.qb(b.localize(6,null)),submenu:R});this.bb(R,"Run"),O.append(M)}if(this.$("Terminal")){const R=new n.Menu,M=new n.MenuItem({label:this.qb(b.localize(7,null)),submenu:R});this.bb(R,"Terminal"),O.append(M)}let L;if(this.$("Window")){const R=new n.Menu;L=new n.MenuItem({label:this.qb(b.localize(8,null)),submenu:R,role:"window"}),this.hb(R)}if(L&&O.append(L),this.$("Help")){const R=new n.Menu,M=new n.MenuItem({label:this.qb(b.localize(9,null)),submenu:R,role:"help"});this.bb(R,"Help"),O.append(M)}O.items&&O.items.length>0?this.X(O):this.X(null),this.j.schedule()}X(E){if(n.Menu.setApplicationMenu(E),E)for(const O of this.J.getWindows())O.win?.setMenu(null)}Y(E){const O=this.jb(b.localize(10,null,this.I.nameLong),"workbench.action.showAboutDialog"),T=this.ib();let L;if(this.$("Preferences")){const ce=new n.Menu;this.bb(ce,"Preferences"),L=new n.MenuItem({label:this.qb(b.localize(11,null)),submenu:ce})}const R=new n.Menu,M=new n.MenuItem({label:b.localize(12,null),role:"services",submenu:R}),B=new n.MenuItem({label:b.localize(13,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),C=new n.MenuItem({label:b.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new n.MenuItem({label:b.localize(15,null),role:"unhide"}),ne=new n.MenuItem(this.nb("workbench.action.quit",{label:b.localize(16,null,this.I.nameLong),click:async(ce,K,ee)=>{const H=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||H?.win?.isMinimized())&&await this.Z(ee)&&this.H.quit(void 0)}})),Q=[O];Q.push(...T),L&&Q.push(d(),L),Q.push(d(),M,d(),B,C,z,d(),ne),Q.forEach(ce=>E.append(ce))}async Z(E){if(this.w.getWindowCount()===0)return!0;const O=this.u.getValue("window.confirmBeforeClose");if(O==="always"||O==="keyboardOnly"&&this.fb(E)){const{response:T}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[b.localize(17,null),b.localize(18,null)],message:b.localize(19,null)});return T===0}return!0}$(E){if(!A.$j&&!(0,k.$5D)(this.u))return!1;switch(E){case"File":case"Help":if(A.$j)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[E];case"Window":if(A.$j)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[E]}}ab(E,O){O.forEach(T=>{if((0,l.$yfc)(T))E.append(d());else if((0,l.$xfc)(T)){const L=new n.Menu,R=new n.MenuItem({label:this.qb(T.label),submenu:L});this.ab(L,T.submenu.items),E.append(R)}else(0,l.$zfc)(T)?E.append(this.db(T)):(0,l.$Afc)(T)&&(T.id==="workbench.action.showAboutDialog"&&this.cb(E),A.$j?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[T.id]?E.append(new n.MenuItem(this.nb(T.id,{label:this.qb(T.label),click:this.s[T.id]}))):E.append(this.jb(T.label,T.id,!1,T.checked)):E.append(this.jb(T.label,T.id,T.enabled!==!1,!!T.checked)):E.append(this.jb(T.label,T.id,T.enabled!==!1,!!T.checked)))})}bb(E,O){this.n&&this.n[O]&&this.ab(E,this.n[O].items)}cb(E){const O=this.ib();O.length&&(O.forEach(T=>E.append(T)),E.append(d()))}db(E){const O=I.URI.revive(E.uri),T=E.id,L=T==="openRecentFile"?{fileUri:O}:T==="openRecentWorkspace"?{workspaceUri:O}:{folderUri:O};return new n.MenuItem(this.nb(T,{label:E.label,click:async(R,M,B)=>{const C=this.eb(B);(await this.w.open({context:t.OpenContext.MENU,cli:this.y.args,urisToOpen:[L],forceNewWindow:C,gotoLineMode:!1,remoteAuthority:E.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([O])}},!1))}eb(E){return!!(E&&(!A.$j&&(E.ctrlKey||E.shiftKey)||A.$j&&(E.metaKey||E.altKey)))}fb(E){return!!(E.triggeredByAccelerator||E.altKey||E.ctrlKey||E.metaKey||E.shiftKey)}gb(E,O,T){const L={label:this.qb(E),role:T,enabled:!0};return new n.MenuItem(this.mb(O,L))}hb(E){const O=new n.MenuItem({label:b.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),T=new n.MenuItem({label:b.localize(21,null),role:"zoom",enabled:this.w.getWindowCount()>0}),L=new n.MenuItem({label:b.localize(22,null),role:"front",enabled:this.w.getWindowCount()>0}),R=this.jb(b.localize(23,null),"workbench.action.switchWindow"),M=[];this.P&&(M.push(d()),M.push(this.jb(b.localize(24,null),"workbench.action.newWindowTab")),M.push(this.gb(b.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.gb(b.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.gb(b.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.gb(b.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[O,T,d(),R,...M,d(),L].forEach(B=>E.append(B))}ib(){switch(this.t.state.type){case v.StateType.Idle:return[new n.MenuItem({label:this.qb(b.localize(29,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case v.StateType.CheckingForUpdates:return[new n.MenuItem({label:b.localize(30,null),enabled:!1})];case v.StateType.AvailableForDownload:return[new n.MenuItem({label:this.qb(b.localize(31,null)),click:()=>{this.t.downloadUpdate()}})];case v.StateType.Downloading:return[new n.MenuItem({label:b.localize(32,null),enabled:!1})];case v.StateType.Downloaded:return A.$j?[]:[new n.MenuItem({label:this.qb(b.localize(33,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case v.StateType.Updating:return[new n.MenuItem({label:b.localize(34,null),enabled:!1})];case v.StateType.Ready:return[new n.MenuItem({label:this.qb(b.localize(35,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(E,O,T,L){const R=this.qb(E),M=typeof O=="function"?O:(Q,ce,K)=>{const ee=Q?Q.userSettingsLabel:null;let H=O;Array.isArray(O)&&(H=this.eb(K)?O[1]:O[0]),ee&&K.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:ee}):this.lb({type:"commandId",commandId:H})},B=typeof T=="boolean"?T:this.w.getWindowCount()>0,C=typeof L=="boolean"?L:!1,z={label:R,click:M,enabled:B};C&&(z.type="checkbox",z.checked=C);let ne;return typeof O=="string"?ne=O:Array.isArray(O)&&(ne=O[0]),A.$j&&(ne==="editor.action.clipboardCutAction"?z.role="cut":ne==="editor.action.clipboardCopyAction"?z.role="copy":ne==="editor.action.clipboardPasteAction"&&(z.role="paste"),ne==="undo"?z.click=this.kb(M,{inDevTools:Q=>Q.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):ne==="redo"?z.click=this.kb(M,{inDevTools:Q=>Q.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):ne==="editor.action.selectAll"&&(z.click=this.kb(M,{inDevTools:Q=>Q.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.mb(ne,z))}kb(E,O){return(T,L,R)=>{const M=n.BrowserWindow.getFocusedWindow();if(!M)return O.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return O.inDevTools(M.webContents.devToolsWebContents);E(T,L||M,R)}}lb(E){let O=n.BrowserWindow.getFocusedWindow();if(O){const L=this.J.getWindowByWebContents(O.webContents);L&&(O=this.w.getWindowById(L.parentId)?.win??null)}if(!O){const L=this.w.getLastActiveWindow();L?.win?.isMinimized()&&(O=L.win)}const T=O?this.w.getWindowById(O.id):void 0;if(T){if(this.G.trace("menubar#runActionInRenderer",E),A.$j&&!this.y.isBuilt&&!T.isReady&&(E.type==="commandId"&&E.commandId==="workbench.action.toggleDevTools"||E.type!=="commandId"&&E.userSettingsLabel==="alt+cmd+i"))return!1;if(E.type==="commandId"){const L={id:E.commandId,from:"menu"};T.sendWhenReady("vscode:runAction",S.CancellationToken.None,L)}else{const L={userSettingsLabel:E.userSettingsLabel};T.sendWhenReady("vscode:runKeybinding",S.CancellationToken.None,L)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",E),!1}mb(E,O){const T=typeof E=="string"?this.r[E]:void 0;if(T?.label){if(T.isNative!==!1)O.accelerator=T.label,O.userSettingsLabel=T.userSettingsLabel;else if(typeof O.label=="string"){const L=O.label.indexOf("[");L>=0?O.label=`${O.label.substr(0,L)} [${T.label}]`:O.label=`${O.label} [${T.label}]`}}else O.accelerator=void 0;return O}nb(E,O,T=!O.accelerator){T&&(O=this.mb(E,O));const L=O.click;return O.click=(R,M,B)=>{this.pb(E),L?.(R,M,B)},O}ob(E,O){this.H.openExternal(void 0,E),this.pb(O)}pb(E){this.z.publicLog2("workbenchActionExecuted",{id:E,from:s})}qb(E){return(0,D.$2w)(E,!this.O)}};e.$Dfc=u,e.$Dfc=u=c=Se([re(0,v.$DY),re(1,h.$_i),re(2,t.$Dec),re(3,f.$sec),re(4,m.$$l),re(5,o.$Bfc),re(6,$.$gR),re(7,g.$Wec),re(8,w.$_j),re(9,p.$pfc),re(10,y.$sk),re(11,a.$ofc)],u);function d(){return new n.MenuItem({type:"separator"})}}),define(oe[313],ae([0,1,6,20,5,312,2]),function(x,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=e.$Efc=void 0,e.$Efc=(0,n.$Fi)("menubarMainService");let I=class extends A.$Wc{constructor(a,h,f){super(),this.b=a,this.c=h,this.f=f,this.a=this.g()}async g(){return await this.c.when(r.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(D.$Dfc))}async updateMenubar(a,h){this.f.trace("menubarService#updateMenubar",a),(await this.a).updateMenu(h,a)}};e.$Ffc=I,e.$Ffc=I=Se([re(0,n.$Ei),re(1,r.$Wec),re(2,S.$_j)],I)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[314],ae([0,1,14,21,107,27,22,23,39,3,31,48,2,13,9,70,4,36,19,12,7,197,69,18,58,25,15,6,20,5,84,85,72,34,57,137,29,135,306,30,104,89,60,51,74,40,59,71,83]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m,v,k,t,o,i,c,s,u,d,P,E,O,T,L,R,M,B,C,z,ne,Q,ce,K,ee,H,j,U,V,le,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0,O=et(O);function he(F){return(0,Q.$Ui)(F?.workspace)}function se(F){return(0,Q.$Pi)(F?.workspace)}let _=class extends g.$Wc{constructor(N,W,q,Y,X,Z,ie,de,me,we,Ie,ke,Pe,De,$e,J,ue,fe,be,Ae,We){super(),this.s=N,this.t=W,this.u=q,this.w=Y,this.z=X,this.C=Z,this.D=ie,this.F=de,this.G=me,this.H=we,this.I=Ie,this.J=ke,this.L=Pe,this.M=De,this.N=$e,this.O=J,this.P=ue,this.Q=fe,this.R=be,this.S=Ae,this.U=We,this.a=this.B(new a.$me),this.onDidOpenWindow=this.a.event,this.b=this.B(new a.$me),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new a.$me),this.onDidDestroyWindow=this.c.event,this.f=this.B(new a.$me),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new a.$me),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new a.$me),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new a.$me),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new a.$me),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new ne.$3fc(this,this.D,this.I,this.z,this.L)),this.W()}W(){this.B(this.N.onDidEnterWorkspace(N=>this.b.fire(N.window))),this.B(this.onDidSignalReadyWindow(N=>{if(N.config?.extensionDevelopmentPath||N.config?.extensionTestsPath){const W=new g.$Vc;if(W.add(a.Event.any(N.onDidClose,N.onDidDestroy)(()=>W.dispose())),N.config.extensionDevelopmentPath)for(const q of N.config.extensionDevelopmentPath)W.add(this.R.addValidFileRoot(q));N.config.extensionTestsPath&&W.add(this.R.addValidFileRoot(N.config.extensionTestsPath))}}))}openEmptyWindow(N,W){const q=this.G.args,Y=W?.remoteAuthority||void 0,X=!0,Z=W?.forceReuseWindow,ie=!Z;return this.open({...N,cli:q,forceEmpty:X,forceNewWindow:ie,forceReuseWindow:Z,remoteAuthority:Y,forceTempProfile:W?.forceTempProfile,forceProfile:W?.forceProfile})}openExistingWindow(N,W){N.focus(),this.X(W,[N])}async open(N){this.z.trace("windowsManager#open"),N.addMode&&(N.initialStartup||!this.getLastActiveWindow())&&(N.addMode=!1);const W=[],q=[],Y=[],X=[],Z=[];let ie,de=0;const me=await this.db(N);this.z.trace("windowsManager#open pathsToOpen",me);for(const De of me)se(De)?N.addMode?W.push(De):q.push(De):he(De)?Y.push(De):De.fileUri?(ie||(ie={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),ie.filesToOpenOrCreate.push(De)):De.backupPath?Z.push({backupFolder:(0,l.$pc)(De.backupPath),remoteAuthority:De.remoteAuthority}):de++;N.diffMode&&ie&&ie.filesToOpenOrCreate.length>=2&&(ie.filesToDiff=ie.filesToOpenOrCreate.slice(0,2),ie.filesToOpenOrCreate=[]),N.mergeMode&&ie&&ie.filesToOpenOrCreate.length===4&&(ie.filesToMerge=ie.filesToOpenOrCreate.slice(0,4),ie.filesToOpenOrCreate=[],ie.filesToDiff=[]),ie&&N.waitMarkerFileURI&&(ie.filesToWait={paths:(0,A.$Jb)([...ie.filesToDiff,ie.filesToMerge[3],...ie.filesToOpenOrCreate]),waitMarkerFileUri:N.waitMarkerFileURI}),N.initialStartup?(X.push(...this.N.getUntitledWorkspaces()),Y.push(...X),Z.push(...this.J.getEmptyWindowBackups())):Z.length=0;const{windows:we,filesOpenedInWindow:Ie}=await this.Y(N,Y,q,Z,de,ie,W);if(this.z.trace(`windowsManager#open used window count ${we.length} (workspacesToOpen: ${Y.length}, foldersToOpen: ${q.length}, emptyToRestore: ${Z.length}, emptyToOpen: ${de})`),we.length>1)if(Ie)Ie.focus();else{const De=this.r.state.lastActiveWindow&&!N.forceEmpty&&!N.cli._.length&&!N.cli["file-uri"]&&!N.cli["folder-uri"]&&!(N.urisToOpen&&N.urisToOpen.length);let $e=!0,J=!0;if(De){const ue=we.filter(fe=>this.r.state.lastActiveWindow&&fe.backupPath===this.r.state.lastActiveWindow.backupPath);ue.length&&(ue[0].focus(),$e=!1,J=!1)}if($e)for(let ue=we.length-1;ue>=0;ue--){const fe=we[ue];if(!(fe.openedWorkspace&&X.some(be=>fe.openedWorkspace&&be.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&Z.some(be=>fe.backupPath&&be.backupFolder===(0,l.$pc)(fe.backupPath)))){fe.focus(),J=!1;break}}J&&we[we.length-1].focus()}const ke=ie&&ie.filesToDiff.length>0,Pe=ie&&ie.filesToMerge.length>0;if(!we.some(De=>De.isExtensionDevelopmentHost)&&!ke&&!Pe&&!N.noRecentEntry){const De=[];for(const $e of me)he($e)&&!$e.transient?De.push({label:$e.label,workspace:$e.workspace,remoteAuthority:$e.remoteAuthority}):se($e)?De.push({label:$e.label,folderUri:$e.workspace.uri,remoteAuthority:$e.remoteAuthority}):$e.fileUri&&De.push({label:$e.label,fileUri:$e.fileUri,remoteAuthority:$e.remoteAuthority});this.M.addRecentlyOpened(De)}return this.X(N,we),we}X(N,W){const q=N.waitMarkerFileURI;N.context===C.OpenContext.CLI&&q&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.Q.del(q)}catch{}})()}async Y(N,W,q,Y,X,Z,ie){const de=[];let me;function we(ue,fe){de.push(ue),fe&&(me=ue,Z=void 0)}let{openFolderInNewWindow:Ie,openFilesInNewWindow:ke}=this.pb(N);if(!N.initialStartup&&ie.length>0){const ue=ie[0].remoteAuthority,fe=this.vb(ue);fe&&we(this.ab(fe,ie.map(be=>be.workspace.uri)))}const Pe=q.length+W.length+Y.length;if(Z&&Pe===0){const ue=Z.filesToOpenOrCreate[0]||Z.filesToDiff[0]||Z.filesToMerge[3],fe=this.getWindows().filter(Ae=>Z&&(0,m.$lh)(Ae.remoteAuthority,Z.remoteAuthority));let be;ue?.fileUri&&!ke&&((N.context===C.OpenContext.DESKTOP||N.context===C.OpenContext.CLI||N.context===C.OpenContext.DOCK)&&(be=await(0,z.$Iec)(fe,ue.fileUri,async Ae=>Ae.configPath.scheme===w.Schemas.file?this.N.resolveLocalWorkspace(Ae.configPath):void 0)),be||(be=this.wb(fe))),be?(0,Q.$Ui)(be.openedWorkspace)?W.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,Q.$Pi)(be.openedWorkspace)?q.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):we(this.Z(N,be,Z),!0):we(await this.qb({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,filesToOpen:Z,forceNewWindow:!0,remoteAuthority:Z.remoteAuthority,forceNewTabbedWindow:N.forceNewTabbedWindow,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile}),!0)}const De=(0,A.$Ob)(W,ue=>ue.workspace.id);if(De.length>0){const ue=(0,A.$Jb)(De.map(fe=>(0,z.$Jec)(this.getWindows(),fe.workspace.configPath)));if(ue.length>0){const fe=ue[0],be=(0,m.$lh)(Z?.remoteAuthority,fe.remoteAuthority)?Z:void 0;we(this.Z(N,fe,be),!!be),Ie=!0}for(const fe of De){if(ue.some(We=>We.openedWorkspace&&We.openedWorkspace.id===fe.workspace.id))continue;const be=fe.remoteAuthority,Ae=(0,m.$lh)(Z?.remoteAuthority,be)?Z:void 0;we(await this.cb(N,fe,Ie,Ae),!!Ae),Ie=!0}}const $e=(0,A.$Ob)(q,ue=>m.$0g.getComparisonKey(ue.workspace.uri));if($e.length>0){const ue=(0,A.$Jb)($e.map(fe=>(0,z.$Jec)(this.getWindows(),fe.workspace.uri)));if(ue.length>0){const fe=ue[0],be=(0,m.$lh)(Z?.remoteAuthority,fe.remoteAuthority)?Z:void 0;we(this.Z(N,fe,be),!!be),Ie=!0}for(const fe of $e){if(ue.some(We=>(0,Q.$Pi)(We.openedWorkspace)&&m.$0g.isEqual(We.openedWorkspace.uri,fe.workspace.uri)))continue;const be=fe.remoteAuthority,Ae=(0,m.$lh)(Z?.remoteAuthority,be)?Z:void 0;we(await this.cb(N,fe,Ie,Ae),!!Ae),Ie=!0}}const J=(0,A.$Ob)(Y,ue=>ue.backupFolder);if(J.length>0)for(const ue of J){const fe=ue.remoteAuthority,be=(0,m.$lh)(Z?.remoteAuthority,fe)?Z:void 0;we(await this.bb(N,!0,fe,be,ue),!!be),Ie=!0}if(de.length===0||Z){Z&&!X&&X++;const ue=Z?Z.remoteAuthority:N.remoteAuthority;for(let fe=0;fe<X;fe++)we(await this.bb(N,Ie,ue,Z),!!Z),Ie=!0}return{windows:(0,A.$Ob)(de),filesOpenedInWindow:me}}Z(N,W,q){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:q}),this.$(W);const Y={filesToOpenOrCreate:q?.filesToOpenOrCreate,filesToDiff:q?.filesToDiff,filesToMerge:q?.filesToMerge,filesToWait:q?.filesToWait,termProgram:N?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",I.CancellationToken.None,Y),W}$(N){let W=N;const q=n.BrowserWindow.getFocusedWindow();if(q&&q.id!==N.id){const Y=this.U.getWindowByWebContents(q.webContents);Y&&Y.parentId===N.id&&(W=Y)}W.focus()}ab(N,W){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),N.focus();const q={foldersToAdd:W};return N.sendWhenReady("vscode:addFolders",I.CancellationToken.None,q),N}bb(N,W,q,Y,X){this.z.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:q,filesToOpen:Y,forceNewWindow:W});let Z;return!W&&typeof N.contextWindowId=="number"&&(Z=this.getWindowById(N.contextWindowId)),this.qb({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:q,forceNewWindow:W,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:Y,windowToUse:Z,emptyWindowBackupInfo:X,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}cb(N,W,q,Y,X){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:Y}),!q&&!X&&typeof N.contextWindowId=="number"&&(X=this.getWindowById(N.contextWindowId)),this.qb({workspace:W.workspace,userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:q,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:Y,windowToUse:X,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}async db(N){let W,q=!1,Y=!1;if(N.urisToOpen&&N.urisToOpen.length>0?(W=await this.eb(N),q=!0):N.forceEmpty?W=[Object.create(null)]:N.cli._.length||N.cli["folder-uri"]||N.cli["file-uri"]?(W=await this.fb(N.cli),W.length===0&&W.push(Object.create(null)),q=!0):(W=await this.hb(),W.length===0&&W.push(Object.create(null)),Y=!0),!N.addMode&&q){const X=W.filter(Z=>se(Z));if(X.length>1){const Z=X[0].remoteAuthority;if(X.every(ie=>(0,m.$lh)(ie.remoteAuthority,Z))){const ie=await this.N.createUntitledWorkspace(X.map(de=>({uri:de.workspace.uri})));W.push({workspace:ie,remoteAuthority:Z}),W=W.filter(de=>!se(de))}}}if(N.initialStartup&&!Y&&this.L.getValue("window")?.restoreWindows==="preserve"){const X=await this.hb();W.unshift(...X.filter(Z=>he(Z)||se(Z)||Z.backupPath))}return W}async eb(N){const W={gotoLineMode:N.gotoLineMode,remoteAuthority:N.remoteAuthority},q=await Promise.all((0,A.$Jb)(N.urisToOpen||[]).map(async Y=>{const X=await this.jb(Y,W);if(X)return X.label=Y.label,X;const Z=this.lb(Y);this.P.showMessageBox({type:"info",buttons:[(0,t.localize)(0,null)],message:Z.scheme===w.Schemas.file?(0,t.localize)(1,null):(0,t.localize)(2,null),detail:Z.scheme===w.Schemas.file?(0,t.localize)(3,null,(0,f.$Vw)(Z,{os:y.OS,tildify:this.G})):(0,t.localize)(4,null,Z.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,A.$Jb)(q)}async fb(N){const W=[],q={ignoreFileNotFound:!0,gotoLineMode:N.goto,remoteAuthority:N.remote||void 0,forceOpenWorkspaceAsFile:N.diff&&N._.length===2||N.merge&&N._.length===4},Y=N["folder-uri"];if(Y){const ie=await Promise.all(Y.map(de=>{const me=this.gb(de);if(me)return this.jb({folderUri:me},q)}));W.push(...(0,A.$Jb)(ie))}const X=N["file-uri"];if(X){const ie=await Promise.all(X.map(de=>{const me=this.gb(de);if(me)return this.jb((0,Q.$$i)(de)?{workspaceUri:me}:{fileUri:me},q)}));W.push(...(0,A.$Jb)(ie))}const Z=await Promise.all(N._.map(ie=>q.remoteAuthority?this.ob(ie,q):this.mb(ie,q)));return W.push(...(0,A.$Jb)(Z)),W}gb(N){try{const W=k.URI.parse(N);if(!W.scheme){this.z.error(`Invalid URI input string, scheme missing: ${N}`);return}return W.path?W:W.with({path:"/"})}catch(W){this.z.error(`Invalid URI input string: ${N}, ${W.message}`)}}async hb(){const N=this.ib();switch(N){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];N!=="one"&&W.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&W.push(this.r.state.lastActiveWindow);const q=await Promise.all(W.map(async Y=>{if(Y.workspace){const X=await this.jb({workspaceUri:Y.workspace.configPath},{remoteAuthority:Y.remoteAuthority,rejectTransientWorkspaces:!0});if(he(X))return X}else if(Y.folderUri){const X=await this.jb({folderUri:Y.folderUri},{remoteAuthority:Y.remoteAuthority});if(se(X))return X}else if(N!=="folders"&&Y.backupPath)return{backupPath:Y.backupPath,remoteAuthority:Y.remoteAuthority}}));return(0,A.$Jb)(q)}}}ib(){let N;return this.I.wasRestarted?N="all":(N=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(N)||(N="all")),N}async jb(N,W=Object.create(null)){const q=this.lb(N);return q.scheme===w.Schemas.file?((0,M.$2D)(N)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.mb(q.fsPath,W)):this.kb(N,W)}kb(N,W){let q=this.lb(N);const Y=(0,L.$gn)(q)||W.remoteAuthority;if(q=(0,m.$nh)((0,m.$hh)(q)),(0,M.$2D)(N)){if(W.gotoLineMode){const{path:X,line:Z,column:ie}=(0,h.$Mg)(q.path);return{fileUri:q.with({path:X}),options:{selection:Z?{startLineNumber:Z,startColumn:ie||1}:void 0},remoteAuthority:Y}}return{fileUri:q,remoteAuthority:Y}}else if((0,M.$ZD)(N))return{workspace:(0,ce.$Mec)(q),remoteAuthority:Y};return{workspace:(0,ce.$Nec)(q),remoteAuthority:Y}}lb(N){return(0,M.$ZD)(N)?N.workspaceUri:(0,M.$1D)(N)?N.folderUri:N.fileUri}async mb(N,W,q){let Y,X;W.gotoLineMode&&({path:N,line:Y,column:X}=(0,h.$Mg)(N)),N=(0,h.$Gg)((0,l.$jc)(N),(0,$.cwd)());try{const Z=await r.Promises.stat(N);if(Z.isFile()){if(!W.forceOpenWorkspaceAsFile){const ie=await this.N.resolveLocalWorkspace(k.URI.file(N));if(ie)return ie.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:ie.id,configPath:ie.configPath},type:u.FileType.File,exists:!0,remoteAuthority:ie.remoteAuthority,transient:ie.transient}}return{fileUri:k.URI.file(N),type:u.FileType.File,exists:!0,options:{selection:Y?{startLineNumber:Y,startColumn:X||1}:void 0}}}else{if(Z.isDirectory())return{workspace:(0,ce.$Nec)(k.URI.file(N),Z),type:u.FileType.Directory,exists:!0};if(!y.$i&&N==="/dev/null")return{fileUri:k.URI.file(N),type:u.FileType.File,exists:!0}}}catch(Z){if(Z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!q)return this.nb(N,W);const ie=k.URI.file(N);if(this.M.removeRecentlyOpened([ie]),W.ignoreFileNotFound)return{fileUri:ie,type:u.FileType.File,exists:!1}}}async nb(N,W){const q=k.URI.file(N),{response:Y,checkboxChecked:X}=await this.P.showMessageBox({type:"warning",buttons:[(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],message:(0,t.localize)(8,null,q.authority),detail:(0,t.localize)(9,null,(0,f.$Vw)(q,{os:y.OS,tildify:this.G})),checkboxLabel:(0,t.localize)(10,null,q.authority),cancelId:1});if(Y===0){if((0,S.addUNCHostToAllowlist)(q.authority),X){const Z={channel:"vscode:configureAllowedUNCHost",args:q.authority};this.sendToFocused(Z.channel,Z.args),this.sendToOpeningWindow(Z.channel,Z.args)}return this.mb(N,W,!0)}if(Y===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.nb(N,W)}ob(N,W){const q=N.charCodeAt(0),Y=W.remoteAuthority;let X,Z;W.gotoLineMode&&({path:N,line:X,column:Z}=(0,h.$Mg)(N)),q!==b.CharCode.Slash&&((0,h.$Fg)(q)&&N.charCodeAt(N.charCodeAt(1))===b.CharCode.Colon&&(N=(0,h.$yg)(N)),N=`/${N}`);const ie=k.URI.from({scheme:w.Schemas.vscodeRemote,authority:Y,path:N});if(N.charCodeAt(N.length-1)!==b.CharCode.Slash){if((0,Q.$$i)(N))return W.forceOpenWorkspaceAsFile?{fileUri:ie,options:{selection:X?{startLineNumber:X,startColumn:Z||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,ce.$Mec)(ie),remoteAuthority:Y};if(W.gotoLineMode||l.$ic.basename(N).indexOf(".")!==-1)return{fileUri:ie,options:{selection:X?{startLineNumber:X,startColumn:Z||1}:void 0},remoteAuthority:Y}}return{workspace:(0,ce.$Nec)(ie),remoteAuthority:Y}}pb(N){const W=this.L.getValue("window"),q=W?.openFoldersInNewWindow||"default",Y=W?.openFilesInNewWindow||"off";let X=(N.preferNewWindow||N.forceNewWindow)&&!N.forceReuseWindow;!N.forceNewWindow&&!N.forceReuseWindow&&(q==="on"||q==="off")&&(X=q==="on");let Z=!1;return N.forceNewWindow||N.forceReuseWindow?Z=!!N.forceNewWindow&&!N.forceReuseWindow:(y.$j?N.context===C.OpenContext.DOCK&&(Z=!0):N.context!==C.OpenContext.DIALOG&&N.context!==C.OpenContext.MENU&&!(N.userEnv&&N.userEnv.TERM_PROGRAM==="vscode")&&(Z=!0),!N.cli.extensionDevelopmentPath&&(Y==="on"||Y==="off")&&(Z=Y==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:Z}}async openExtensionDevelopmentHostWindow(N,W){const q=(0,z.$Kec)(this.getWindows(),N);if(q)return this.I.reload(q,W.cli),q.focus(),[q];let Y=W.cli["folder-uri"]||[],X=W.cli["file-uri"]||[],Z=W.cli._;if(!Z.length&&!Y.length&&!X.length&&!W.cli.extensionTestsPath){const me=this.r.state.lastPluginDevelopmentHostWindow,we=me?.workspace??me?.folderUri;we&&(k.URI.isUri(we)?we.scheme===w.Schemas.file?Z=[we.fsPath]:Y=[we.toString()]:we.configPath.scheme===w.Schemas.file?Z=[(0,m.$7g)(we.configPath)]:X=[we.configPath.toString()])}let ie=W.remoteAuthority;for(const me of N)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const we=k.URI.parse(me),Ie=(0,L.$gn)(we);Ie&&(ie?(0,m.$lh)(Ie,ie)||this.z.error("more than one extension development path authority"):ie=Ie)}Z=Z.filter(me=>{const we=k.URI.file(me);return(0,z.$Jec)(this.getWindows(),we)?!1:(0,m.$lh)((0,L.$gn)(we),ie)}),Y=Y.filter(me=>{const we=this.gb(me);return we&&(0,z.$Jec)(this.getWindows(),we)?!1:we?(0,m.$lh)((0,L.$gn)(we),ie):!1}),X=X.filter(me=>{const we=this.gb(me);return we&&(0,z.$Jec)(this.getWindows(),we)?!1:we?(0,m.$lh)((0,L.$gn)(we),ie):!1}),W.cli._=Z,W.cli["folder-uri"]=Y,W.cli["file-uri"]=X;const de={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!Z.length&&!Y.length&&!X.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:ie,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile};return this.open(de)}async qb(N){const W=this.L.getValue("window"),q=this.getLastActiveWindow(),X=(W?.newWindowProfile?this.H.profiles.find(de=>de.name===W.newWindowProfile):void 0)??q?.profile??this.H.defaultProfile;let Z;!N.forceNewWindow&&!N.forceNewTabbedWindow&&(Z=N.windowToUse||q,Z&&Z.focus());const ie={...this.G.args,...N.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:N.emptyWindowBackupInfo?(0,l.$lc)(this.G.backupHome,N.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:X},homeDir:this.G.userHome.with({scheme:w.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:w.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:N.remoteAuthority,workspace:N.workspace,userEnv:{...this.w,...N.userEnv},filesToOpenOrCreate:N.filesToOpen?.filesToOpenOrCreate,filesToDiff:N.filesToOpen?.filesToDiff,filesToMerge:N.filesToOpen?.filesToMerge,filesToWait:N.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:w.Schemas.file}).fsPath,product:O.default,isInitialStartup:N.initialStartup,perfMarks:(0,p.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)(),arch:(0,D.arch)()},autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn};if(Z){const de=Z.config;!ie.extensionDevelopmentPath&&de?.extensionDevelopmentPath&&(ie.extensionDevelopmentPath=de.extensionDevelopmentPath,ie.extensionDevelopmentKind=de.extensionDevelopmentKind,ie["enable-proposed-api"]=de["enable-proposed-api"],ie.verbose=de.verbose,ie["inspect-extensions"]=de["inspect-extensions"],ie["inspect-brk-extensions"]=de["inspect-brk-extensions"],ie.debugId=de.debugId,ie.extensionEnvironment=de.extensionEnvironment,ie["extensions-dir"]=de["extensions-dir"],ie["disable-extensions"]=de["disable-extensions"]),ie.loggers={global:ie.loggers.global,window:de?.loggers.window??ie.loggers.window}}else{const de=this.r.getNewWindowState(ie);(0,p.mark)("code/willCreateCodeWindow");const me=Z=this.O.createInstance(B.$Uec,{state:de,extensionDevelopmentPath:ie.extensionDevelopmentPath,isExtensionTestHost:!!ie.extensionTestsPath});(0,p.mark)("code/didCreateCodeWindow"),N.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.n.set(me.id,me),this.a.fire(me),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const we=new g.$Vc;we.add(me.onDidSignalReady(()=>this.b.fire(me))),we.add(a.Event.once(me.onDidClose)(()=>this.tb(me,we))),we.add(a.Event.once(me.onDidDestroy)(()=>this.ub(me))),we.add(me.onDidMaximize(()=>this.g.fire(me))),we.add(me.onDidUnmaximize(()=>this.h.fire(me))),we.add(me.onDidEnterFullScreen(()=>this.j.fire({window:me,fullscreen:!0}))),we.add(me.onDidLeaveFullScreen(()=>this.j.fire({window:me,fullscreen:!1}))),we.add(me.onDidTriggerSystemContextMenu(({x:ke,y:Pe})=>this.m.fire({window:me,x:ke,y:Pe})));const Ie=(0,v.$qg)(me.win?.webContents);Ie.removeAllListeners("devtools-reload-page"),we.add(a.Event.fromNodeEventEmitter(Ie,"devtools-reload-page")(()=>this.I.reload(me))),this.I.registerWindow(me)}return ie.windowId=Z.id,Z.isReady?this.I.unload(Z,H.UnloadReason.LOAD).then(async de=>{de||await this.rb(Z,ie,N,X)}):await this.rb(Z,ie,N,X),Z}async rb(N,W,q,Y){if(W.extensionDevelopmentPath||((0,Q.$Ui)(W.workspace)?W.backupPath=this.J.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,Q.$Pi)(W.workspace)?W.backupPath=this.J.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.J.registerEmptyWindowBackup({backupFolder:q.emptyWindowBackupInfo?.backupFolder??(0,ce.$Oec)().id,remoteAuthority:W.remoteAuthority})),this.H.isEnabled()){const X=W.workspace??(0,Q.$Ti)(W.backupPath,!1),Z=this.sb(q,X,Y),ie=Z instanceof Promise?await Z:Z;W.profiles.profile=ie,W.extensionDevelopmentPath||await this.H.setProfileForWorkspace(X,ie)}N.load(W)}sb(N,W,q){return N.forceProfile?this.H.profiles.find(Y=>Y.name===N.forceProfile)??this.H.createNamedProfile(N.forceProfile):N.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(W)??q}tb(N,W){this.n.delete(N.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),W.dispose()}ub(N){this.n.delete(N.id),this.c.fire(N)}getFocusedWindow(){const N=n.BrowserWindow.getFocusedWindow();if(N)return this.getWindowById(N.id)}getLastActiveWindow(){return this.wb(this.getWindows())}vb(N){return this.wb(this.getWindows().filter(W=>(0,m.$lh)(W.remoteAuthority,N)))}wb(N){return(0,C.$Fec)(N)}sendToFocused(N,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(N,I.CancellationToken.None,...W)}sendToOpeningWindow(N,...W){this.B(a.Event.once(this.onDidSignalReadyWindow)(q=>{q.sendWhenReady(N,I.CancellationToken.None,...W)}))}sendToAll(N,W,q){for(const Y of this.getWindows())q&&q.indexOf(Y.id)>=0||Y.sendWhenReady(N,I.CancellationToken.None,W)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(N){return this.n.get(N)}getWindowByWebContents(N){const W=n.BrowserWindow.fromWebContents(N);if(!W)return;const q=this.getWindowById(W.id);return q?.matches(N)?q:void 0}};e.$6fc=_,e.$6fc=_=Se([re(4,E.$_j),re(5,le.$Rec),re(6,R.$gR),re(7,U.$so),re(8,s.$sec),re(9,V.$Gec),re(10,P.$Wec),re(11,o.$xec),re(12,i.$_i),re(13,K.$Bfc),re(14,ee.$Pec),re(15,d.$Ei),re(16,c.$yec),re(17,u.$_k),re(18,T.$Aec),re(19,j.$Bec),re(20,G.$ofc)],_)}),define(oe[315],ae([0,1,69,29,89,60]),function(x,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=void 0;let A=class{constructor(b,a,h,f){this.a=b,this.b=a,this.c=h,this.d=f,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(b,a){const h=this.b.getWindowById(b);if(h)return this.a.enterWorkspace(h,this.b.getWindows(),a)}createUntitledWorkspace(b,a,h){return this.a.createUntitledWorkspace(a,h)}deleteUntitledWorkspace(b,a){return this.a.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(b,a){return this.a.getWorkspaceIdentifier(a)}getRecentlyOpened(b){return this.c.getRecentlyOpened()}addRecentlyOpened(b,a){return this.c.addRecentlyOpened(a)}removeRecentlyOpened(b,a){return this.c.removeRecentlyOpened(a)}clearRecentlyOpened(b){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$8fc=A,e.$8fc=A=Se([re(0,D.$Pec),re(1,r.$Dec),re(2,S.$Bfc),re(3,n.$xec)],A)}),define(oe[316],ae([0,1,14,107,37,27,17,53,16,31,3,320,48,2,13,9,4,12,7,33,163,44,164,119,297,167,69,290,18,298,97,136,58,98,224,25,68,101,212,301,214,215,216,15,228,100,82,6,99,223,307,291,299,20,5,313,75,28,72,302,102,34,280,88,129,24,257,258,56,50,270,295,308,296,309,133,272,273,274,277,305,57,29,314,279,30,103,89,315,60,40,237,59,250,55,87,134,282,300,287,8,260,281,232,71,304,276,22,73,303,268,243,65,83,311,77]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m,v,k,t,o,i,c,s,u,d,P,E,O,T,L,R,M,B,C,z,ne,Q,ce,K,ee,H,j,U,V,le,G,he,se,_,F,N,W,q,Y,X,Z,ie,de,me,we,Ie,ke,Pe,De,$e,J,ue,fe,be,Ae,We,Fe,Oe,Ue,Ve,Je,qe,Ye,Xe,Ke,Ne,te,ge,pe,ye,Me,Be,Qe,lt,rt,at,tt,ut,ct,ft,gt,At,$t,pt,Ot,Lt,Tt,wt,jt,Et,dt,Mt,Ft,bt,Ct,St,Nt,kt){"use strict";var yt;Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;let vt=class extends w.$Wc{static{yt=this}static{this.a={[l.Schemas.file]:"security.promptForLocalFileProtocolHandling",[l.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Le,Te,je,ve,Ee,He,xe,Ge,Ce,Ze,ze,_e){super(),this.g=Le,this.h=Te,this.j=je,this.m=ve,this.n=Ee,this.s=He,this.t=xe,this.u=Ge,this.w=Ce,this.y=Ze,this.z=ze,this.C=_e,this.D(),this.F()}D(){const Le=Ce=>Ce?.startsWith(`${l.Schemas.vscodeWebview}://`),Te=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Ce,Ze,ze,_e)=>Le(_e.requestingUrl)?ze(Te.has(Ze)):ze(!1)),n.session.defaultSession.setPermissionCheckHandler((Ce,Ze,ze,_e)=>Le(_e.requestingUrl)?Te.has(Ze):!1);const je=new Set([l.Schemas.file,l.Schemas.vscodeFileResource,l.Schemas.vscodeRemoteResource,l.Schemas.vscodeManagedRemoteResource,"devtools"]),ve=Ce=>{for(let Ze=Ce;Ze;Ze=Ze.parent)if(Ze.url.startsWith(`${l.Schemas.vscodeWebview}://`))return!0;return!1},Ee=Ce=>Ce.resourceType==="xhr"||ve(Ce.frame),He=Ce=>{const Ze=Ce.frame;if(!Ze||!this.b)return!1;const ze=n.BrowserWindow.getAllWindows();for(const _e of ze)if(Ze.processId===_e.webContents.mainFrame.processId)return!0;return!1},xe=(Ce,Ze)=>{if(Ce.path!=="/index.html")return!0;const ze=Ze.frame;if(!ze||!this.b)return!1;for(const _e of this.b.getWindows())if(_e.win&&ze.processId===_e.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Ce,Ze)=>{const ze=m.URI.parse(Ce.url);return ze.scheme===l.Schemas.vscodeWebview&&!xe(ze,Ce)?(this.m.error("Blocked vscode-webview request",Ce.url),Ze({cancel:!0})):ze.scheme===l.Schemas.vscodeFileResource&&!He(Ce)?(this.m.error("Blocked vscode-file request",Ce.url),Ze({cancel:!0})):ze.path.endsWith(".svg")&&!je.has(ze.scheme)?Ze({cancel:!Ee(Ce)}):Ze({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Ce,Ze)=>{const ze=Ce.responseHeaders,_e=ze["content-type"]||ze["Content-Type"];if(_e&&Array.isArray(_e)){const it=m.URI.parse(Ce.url);if(it.path.endsWith(".svg")&&je.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],Ze({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(l.Schemas.vscodeRemoteResource)&&_e.some(ot=>ot.toLowerCase().includes("image/svg")))return Ze({cancel:!Ee(Ce)})}return Ze({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Ce,Ze)=>{if(Ce.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Ce.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],Ze({cancel:!1,responseHeaders:ze})}return Ze({cancel:!1})});const Ge=n.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,p.$lc)(this.s.codeCachePath,"chrome")),y.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,r.disableUNCAccessRestrictions)():(0,r.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,b.setUnexpectedErrorHandler)(je=>this.H(je)),process.on("uncaughtException",je=>{(0,b.$2)(je)||(0,b.$3)(je)}),process.on("unhandledRejection",je=>(0,b.$3)(je)),h.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,k.$FX)(),n.app.on("accessibility-support-changed",(je,ve)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",ve)}),n.app.on("activate",async(je,ve)=>{this.m.trace("app#activate"),ve||await this.b?.openEmptyWindow({context:Ke.OpenContext.DOCK})}),n.app.on("web-contents-created",(je,ve)=>{ve?.opener?.url.startsWith(`${l.Schemas.vscodeFileResource}://${l.$Yg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(ve)),ve.on("will-navigate",Ee=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ee.preventDefault()}),ve.setWindowOpenHandler(Ee=>Ee.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ee)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ee.url}}`),this.f?.openExternal(void 0,Ee.url),{action:"deny"}))});let Le=[],Te;n.app.on("open-file",(je,ve)=>{ve=(0,kt.$mm)(ve),this.m.trace("app#open-file: ",ve),je.preventDefault(),Le.push((0,ge.$$i)(ve)?{workspaceUri:m.URI.file(ve)}:{fileUri:m.URI.file(ve)}),Te!==void 0&&(clearTimeout(Te),Te=void 0),Te=setTimeout(async()=>{await this.b?.open({context:Ke.OpenContext.DOCK,cli:this.s.args,urisToOpen:Le,gotoLineMode:!1,preferNewWindow:!0}),Le=[],Te=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Ke.OpenContext.DESKTOP})}),S.$EX.handle("vscode:fetchShellEnv",je=>{const ve=this.b?.getWindowByWebContents(je.sender);let Ee,He;return ve?.config?(Ee=ve.config,He={...process.env,...ve.config.userEnv}):(Ee=this.s.args,He=process.env),this.X(Ee,He,!1)}),S.$EX.handle("vscode:writeNlsFile",(je,ve,Ee)=>{const He=this.G([ve]);if(!He||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(He,A.$Oe.fromString(Ee))}),S.$EX.handle("vscode:readNlsFile",async(je,...ve)=>{const Ee=this.G(ve);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ee)).value.toString()}),S.$EX.on("vscode:toggleDevTools",je=>je.sender.toggleDevTools()),S.$EX.on("vscode:openDevTools",je=>je.sender.openDevTools()),S.$EX.on("vscode:reloadWindow",je=>je.sender.reload()),S.$EX.handle("vscode:notifyZoomLevel",async(je,ve)=>{const Ee=this.b?.getWindowByWebContents(je.sender);Ee&&Ee.notifyZoomLevel(ve)})}G(Le){let Te;for(const je of Le)typeof je=="string"&&(typeof Te!="string"?Te=je:Te=(0,p.$lc)(Te,je));if(!(typeof Te!="string"||!(0,p.$kc)(Te)||!(0,a.$Eg)(Te,this.s.cachedLanguagesPath,!y.$k)))return m.URI.file(Te)}H(Le){if(Le){const Te={message:`[uncaught exception in main]: ${Le.message}`,stack:Le.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Te))}this.m.error(`[uncaught exception in main]: ${Le}`),Le.stack&&this.m.error(Le.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Le=this.z.win32AppUserModelId;y.$i&&Le&&n.app.setAppUserModelId(Le);try{y.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.m.error(ze)}const Te=new o.$LX;h.Event.once(this.t.onWillShutdown)(ze=>{ze.reason===N.ShutdownReason.KILL&&Te.dispose()}),this.m.trace("Resolving machine identifier...");const[je,ve,Ee]=await Promise.all([(0,pt.$egc)(this.w,this.m),(0,pt.$fgc)(this.w,this.m),(0,pt.$ggc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${je}`);const{sharedProcessReady:He,sharedProcessClient:xe}=this.P(je,ve,Ee),Ge=await this.Q(je,ve,Ee,He);this.B(Ge.createInstance(c.$7ec)),this.B(Ge.createInstance(gt.$_fc)),Ge.invokeFunction(ze=>this.R(ze,Te,xe));const Ce=await Ge.invokeFunction(ze=>this.I(ze,Te));this.J(Te),this.t.phase=N.LifecycleMainPhase.Ready,await Ge.invokeFunction(ze=>this.S(ze,Ce)),this.t.phase=N.LifecycleMainPhase.AfterWindowOpen,this.U(),this.B(new $t.$Rh(()=>{this.B((0,$t.$Vh)(()=>this.t.phase=N.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async I(Le,Te){const je=this.b=Le.get(Ke.$Dec),ve=Le.get(Oe.$tY),Ee=this.f=Le.get(Y.$pfc),He=Le.get(L.$yec),xe=this;ve.registerHandler({async handleURL(it,ot){return xe.O(je,He,ve,it,ot)}});const Ge=this.B(new te.$7fc({onDidOpenMainWindow:Ee.onDidOpenMainWindow,onDidFocusMainWindow:Ee.onDidFocusMainWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),Ce=new t.$ni(it=>Ge.getActiveClientId().then(ot=>it===ot)),Ze=new Ue.$Xfc(Ce,this.m),ze=Te.getChannel("urlHandler",Ze);ve.registerHandler(new Ue.$Wfc(ze));const _e=await this.L(je,He);return this.B(new Je.$Yfc(_e?.urls,ve,je,this.s,this.z,this.m)),_e}J(Le){const Te=()=>({statusCode:404,data:"Not found"}),je=new Ct.$X(()=>Le.getChannel(bt.$ngc,new bt.$ogc));n.protocol.registerBufferProtocol(l.Schemas.vscodeManagedRemoteResource,(ve,Ee)=>{const He=m.URI.parse(ve.url);if(!He.authority.startsWith("window:"))return Ee(Te());je.value.call(bt.$mgc,[He]).then(xe=>Ee({...xe,data:Buffer.from(xe.body,"base64")}),xe=>{this.m.warn("error dispatching remote resource call",xe),Ee({statusCode:500,data:String(xe)})})})}async L(Le,Te){const je=this.s.args["open-url"]?this.s.args._urls||[]:[];je.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",je);const ve=global.getOpenUrls()||[];if(ve.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",ve),je.length+ve.length===0)return;const Ee=[...je,...ve].map(Ge=>{try{return{uri:m.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),He=[],xe=[];for(const Ge of Ee){if(!Ge)continue;const Ce=this.N(Ge.uri);if(Ce)if(await this.M(Ce,Le,Te)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),Ce),He.push(Ce);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),xe.push(Ge)}return{urls:xe,openables:He}}async M(Le,Te,je){let ve,Ee;if((0,Xe.$ZD)(Le)?(ve=Le.workspaceUri,Ee=(0,s.localize)(0,null,ve.scheme===l.Schemas.file?(0,g.$Vw)(ve,{os:y.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(0,Xe.$1D)(Le)?(ve=Le.folderUri,Ee=(0,s.localize)(1,null,ve.scheme===l.Schemas.file?(0,g.$Vw)(ve,{os:y.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(ve=Le.fileUri,Ee=(0,s.localize)(2,null,ve.scheme===l.Schemas.file?(0,g.$Vw)(ve,{os:y.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)),ve.scheme!==l.Schemas.file&&ve.scheme!==l.Schemas.vscodeRemote||this.u.getValue(yt.a[ve.scheme])===!1)return!1;const{response:xe,checkboxChecked:Ge}=await je.showMessageBox({type:"warning",buttons:[(0,s.localize)(3,null),(0,s.localize)(4,null)],message:Ee,detail:(0,s.localize)(5,null),checkboxLabel:ve.scheme===l.Schemas.file?(0,s.localize)(6,null):(0,s.localize)(7,null),cancelId:1});if(xe!==0)return!0;if(Ge){const Ce={channel:"vscode:disablePromptForProtocolHandling",args:ve.scheme===l.Schemas.file?"local":"remote"};Te.sendToFocused(Ce.channel,Ce.args),Te.sendToOpeningWindow(Ce.channel,Ce.args)}return!1}N(Le){if(Le.path){if(Le.authority===l.Schemas.file){const Te=m.URI.file(Le.fsPath);return(0,ge.$$i)(Te)?{workspaceUri:Te}:{fileUri:Te}}else if(Le.authority===l.Schemas.vscodeRemote){const Te=Le.path.indexOf(p.$ic.sep,1);if(Te!==-1){const je=Le.path.substring(1,Te),ve=Le.path.substring(Te);let Ee=Le.query;const He=new URLSearchParams(Le.query);He.get("windowId")==="_blank"&&(He.delete("windowId"),Ee=He.toString());const xe=m.URI.from({scheme:l.Schemas.vscodeRemote,authority:je,path:ve,query:Ee,fragment:Le.fragment});return(0,ge.$$i)(ve)?{workspaceUri:xe}:/:[\d]+$/.test(ve)?{fileUri:xe}:{folderUri:xe}}}}}async O(Le,Te,je,ve,Ee){this.m.trace("app#handleProtocolUrl():",ve.toString(!0),Ee),ve.scheme===this.z.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:m.URI.parse(ve.query).path,query:""}));let He=!1;const xe=new URLSearchParams(ve.query);xe.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),xe.delete("windowId"),ve=ve.with({query:xe.toString()}),He=!0):y.$j&&Le.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),He=!0);const Ge=xe.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),xe.delete("continueOn"),ve=ve.with({query:xe.toString()}),this.s.continueOn=Ge??void 0);const Ce=this.N(ve);return Ce?await this.M(Ce,Le,Te)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ce,ve.toString(!0)),(0,Et.$Qb)(await Le.open({context:Ke.OpenContext.API,cli:{...this.s.args},urisToOpen:[Ce],forceNewWindow:He,gotoLineMode:!0}))?.focus(),!0):He?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0)),await(0,Et.$Qb)(await Le.open({context:Ke.OpenContext.API,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Z.$gn)(ve)}))?.ready(),je.open(ve,Ee)):(this.m.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),Ee),!1)}P(Le,Te,je){const ve=this.B(this.j.createInstance(ie.$Jfc,Le,Te,je));this.B(ve.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const Ee=(async()=>{this.m.trace("Main->SharedProcess#connect");const xe=await ve.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new i.$MX(xe,"main")})();return{sharedProcessReady:(async()=>(await ve.whenReady(),Ee))(),sharedProcessClient:Ee}}async Q(Le,Te,je,ve){const Ee=new G.$Di;switch(process.platform){case"win32":Ee.set(ue.$DY,new V.$Ci(Fe.$Ufc));break;case"linux":y.$l?Ee.set(ue.$DY,new V.$Ci(We.$Tfc,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(ue.$DY,new V.$Ci(Ae.$Sfc));break;case"darwin":Ee.set(ue.$DY,new V.$Ci(be.$Rfc));break}Ee.set(Ke.$Dec,new V.$Ci(Ne.$6fc,[Le,Te,je,this.h],!1)),Ee.set(St.$ofc,new V.$Ci(Nt.$pgc,void 0,!1));const He=new L.$zec(this.m,this.z);Ee.set(L.$yec,He),Ee.set(F.$vfc,new V.$Ci(F.$wfc,void 0,!1)),Ee.set(T.$afc,new V.$Ci(T.$bfc,void 0,!1)),Ee.set(O.$Sm,t.ProxyChannel.toService((0,t.$li)(ve.then(ze=>ze.getChannel("diagnostics"))))),Ee.set(he.$2$b,new V.$Ci(se.$rfc,[this.h])),Ee.set(R.$nY,new V.$Ci(M.$cfc)),Ee.set(_.$sfc,new V.$Ci(_.$tfc)),Ee.set(Y.$pfc,new V.$Ci(Y.$qfc,void 0,!1)),Ee.set(qe.$Zfc,new V.$Ci(Ye.$2fc)),Ee.set(q.$Efc,new V.$Ci(q.$Ffc)),Ee.set(ne.$dfc,new V.$Ci(Q.$ffc)),Ee.set(Ie.$3ec,new V.$Ci(Ie.$4ec)),Ee.set(Ie.$5ec,new V.$Ci(Ie.$6ec));const xe=new Mt.$lgc({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ge=new Ft.$Ns(xe,this.u,this.m,this.n);Ee.set(dt.$os,Ge),y.$i?Ee.set(ce.$gfc,new V.$Ci(K.$hfc)):y.$j?Ee.set(ce.$gfc,new V.$Ci(K.$ifc)):y.$k&&Ee.set(ce.$gfc,new V.$Ci(K.$jfc));const Ce=new d.$8ec(this.s,this.u,this.m,this.w);Ee.set(u.$xec,Ce);const Ze=new Be.$Qec(this.s,this.m,this.C,Ce,He);if(Ee.set(Be.$Pec,Ze),Ee.set(pe.$Ihb,new V.$Ci(Me.$8fc,void 0,!1)),Ee.set(ye.$Bfc,new V.$Ci(ye.$Cfc,void 0,!1)),Ee.set(Oe.$tY,new V.$Ci(Ve.$vY,void 0,!1)),(0,J.$Bp)(this.z,this.s)){const ze=(0,J.$Gp)(this.z,this.u),_e=(0,t.$li)(ve.then(mt=>mt.getChannel("telemetryAppender"))),it=new De.$Mfc(_e),ot=(0,ke.$sp)((0,D.release)(),(0,D.hostname)(),process.arch,this.z.commit,this.z.version,Le,Te,je,ze),nt=(0,J.$Hp)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};Ee.set(Pe.$$l,new V.$Ci($e.$es,[ht],!1))}else Ee.set(Pe.$$l,J.$wp);return Ee.set(ut.$Gq,new V.$Ci(Ot.$nR,void 0,!0)),Ee.set(ct.$Kq,new V.$Ci(ft.$$fc,void 0,!0)),Ee.set(wt.$jgc,new V.$Ci(wt.$kgc,void 0,!0)),await $t.Promises.settled([Ce.initialize(),Ze.initialize()]),this.j.createChild(Ee)}R(Le,Te,je){const ve=this.B(new w.$Vc),Ee=t.ProxyChannel.fromService(Le.get(F.$vfc),ve,{disableMarshalling:!0});this.g.registerChannel("launch",Ee);const He=t.ProxyChannel.fromService(Le.get(T.$afc),ve,{disableMarshalling:!0});this.g.registerChannel("diagnostics",He);const xe=ve.add(new lt.$9fc(Le.get(Qe.$so)));Te.registerChannel("policy",xe),je.then(st=>st.registerChannel("policy",xe));const Ge=this.y.getProvider(l.Schemas.file);(0,$.$pg)(Ge instanceof U.$qr);const Ce=ve.add(new j.$kfc(Ge,this.m,this.s));Te.registerChannel(ee.$9Q,Ce),je.then(st=>st.registerChannel(ee.$9Q,Ce));const Ze=t.ProxyChannel.fromService(Le.get(rt.$Gec),ve);Te.registerChannel("userDataProfiles",Ze),je.then(st=>st.registerChannel("userDataProfiles",Ze));const ze=new at.$_r(Le.get(tt.$5p));je.then(st=>st.registerChannel("request",ze));const _e=new fe.$Nfc(Le.get(ue.$DY));Te.registerChannel("update",_e);const it=t.ProxyChannel.fromService(Le.get(he.$2$b),ve);Te.registerChannel("issue",it);const ot=t.ProxyChannel.fromService(Le.get(R.$nY),ve);Te.registerChannel("encryption",ot);const nt=t.ProxyChannel.fromService(Le.get(de.$Yl),ve);Te.registerChannel("sign",nt);const ht=t.ProxyChannel.fromService(Le.get(_.$sfc),ve);Te.registerChannel("keyboardLayout",ht),this.f=Le.get(Y.$pfc);const mt=t.ProxyChannel.fromService(this.f,ve);Te.registerChannel("nativeHost",mt),je.then(st=>st.registerChannel("nativeHost",mt));const Wt=t.ProxyChannel.fromService(Le.get(pe.$Ihb),ve);Te.registerChannel("workspaces",Wt);const Ut=t.ProxyChannel.fromService(Le.get(q.$Efc),ve);Te.registerChannel("menubar",Ut);const Bt=t.ProxyChannel.fromService(Le.get(Oe.$tY),ve);Te.registerChannel("url",Bt);const zt=t.ProxyChannel.fromService(Le.get(qe.$Zfc),ve);Te.registerChannel("webview",zt);const Pt=ve.add(new we.$Kfc(this.m,Le.get(Ie.$3ec)));Te.registerChannel("storage",Pt),je.then(st=>st.registerChannel("storage",Pt));const qt=ve.add(new At.$agc(Le.get(Ie.$3ec),Le.get(rt.$Gec),this.m));je.then(st=>st.registerChannel("profileStorageListener",qt));const Ht=t.ProxyChannel.fromService(Le.get(dt.$os),ve);Te.registerChannel(dt.TerminalIpcChannels.LocalPty,Ht);const Zt=t.ProxyChannel.fromService(Le.get(ce.$gfc),ve);Te.registerChannel("externalTerminal",Zt);const It=new Lt.$hgc(Le.get(Tt.$Rec));Te.registerChannel("logger",It),je.then(st=>st.registerChannel("logger",It));const xt=new E.$9ec(Le.get(Ke.$Dec));Te.registerChannel("extensionhostdebugservice",xt);const Vt=t.ProxyChannel.fromService(Le.get(ne.$dfc),ve);Te.registerChannel(ne.$efc,Vt);const Gt=t.ProxyChannel.fromService(Le.get(wt.$jgc),ve);Te.registerChannel(jt.$igc,Gt)}async S(Le,Te){const je=this.b=Le.get(Ke.$Dec);this.c=Le.get(St.$ofc);const ve=(0,C.$Jm)(process.env)?Ke.OpenContext.CLI:Ke.OpenContext.DESKTOP,Ee=this.s.args;if(Te){if(Te.openables.length>0)return je.open({context:ve,cli:Ee,urisToOpen:Te.openables,gotoLineMode:!0,initialStartup:!0});if(Te.urls.length>0)for(const nt of Te.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),je.open({context:ve,cli:Ee,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const He=global.macOpenFiles,xe=Ee._.length,Ge=!!Ee["folder-uri"],Ce=!!Ee["file-uri"],Ze=Ee["skip-add-to-recently-opened"]===!0,ze=Ee.wait&&Ee.waitMarkerFilePath?m.URI.file(Ee.waitMarkerFilePath):void 0,_e=Ee.remote||void 0,it=Ee.profile,ot=Ee["profile-temp"];if(!xe&&!Ge&&!Ce){if(Ee["new-window"]||it||ot)return je.open({context:ve,cli:Ee,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ze,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:_e,forceProfile:it,forceTempProfile:ot});if(He.length)return je.open({context:Ke.OpenContext.DOCK,cli:Ee,urisToOpen:He.map(nt=>(nt=(0,kt.$mm)(nt),(0,ge.$$i)(nt)?{workspaceUri:m.URI.file(nt)}:{fileUri:m.URI.file(nt)})),noRecentEntry:Ze,waitMarkerFileURI:ze,initialStartup:!0})}return je.open({context:ve,cli:Ee,forceNewWindow:Ee["new-window"],diffMode:Ee.diff,mergeMode:Ee.merge,noRecentEntry:Ze,waitMarkerFileURI:ze,gotoLineMode:Ee.goto,initialStartup:!0,remoteAuthority:_e,forceProfile:it,forceTempProfile:ot})}U(){this.W(),n.protocol.registerHttpProtocol(l.Schemas.vscodeRemoteResource,(Le,Te)=>{Te({url:Le.url.replace(/^vscode-remote-resource:/,"http:"),method:Le.method})}),this.X(this.s.args,process.env,!0),this.Y(),y.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Le=this.z.win32MutexName;if(y.$i&&Le)try{const Te=await new Promise((ve,Ee)=>{x(["@vscode/windows-mutex"],ve,Ee)}).then(Re),je=new Te.Mutex(Le);h.Event.once(this.t.onWillShutdown)(()=>je.release())}catch(Te){this.m.error(Te)}}async X(Le,Te,je){try{return await(0,z.$Qm)(this.u,this.m,Le,Te)}catch(ve){const Ee=(0,I.$qj)(ve);je?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ee):this.m.error(Ee)}return{}}async Y(){try{const Te=(await this.y.readFile(this.s.argvResource)).value.toString(),je=(0,f.parse)(Te),Ee=(0,J.$Dp)(this.u)>=Pe.TelemetryLevel.CRASH;if(je["enable-crash-reporter"]===void 0){const He=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ee},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.$2g)()}"`,"}"],xe=Te.substring(0,Te.length-2).concat(`,
`,He.join(`
`));await this.y.writeFile(this.s.argvResource,A.$Oe.fromString(xe))}else{const He=Te.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ee},`);He!==Te&&await this.y.writeFile(this.s.argvResource,A.$Oe.fromString(He))}}catch(Le){this.m.error(Le),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$qgc=vt,e.$qgc=vt=yt=Se([re(2,le.$Ei),re(3,W.$_j),re(4,W.$ak),re(5,B.$sec),re(6,N.$Wec),re(7,P.$_i),re(8,me.$gR),re(9,H.$_k),re(10,X.$sk),re(11,rt.$Gec)],vt)});var et=this&&this.__importDefault||function(x){return x&&x.__esModule?x:{default:x}};define(oe[321],ae([0,1,14,47,7,22,8,53,16,31,3,48,13,9,70,4,36,26,21,44,105,316,10,18,242,256,25,68,207,15,226,100,82,222,99,20,229,5,84,28,85,283,132,294,55,293,102,255,34,56,74,59,40,238,236,2,41,271,71,231,124,128,275,107,269]),function(x,e,n,r,S,D,A,I,b,a,h,f,g,w,l,p,y,$,m,v,k,t,o,i,c,s,u,d,P,E,O,T,L,R,M,B,C,z,ne,Q,ce,K,ee,H,j,U,V,le,G,he,se,_,F,N,W,q,Y,X,Z,ie,de,me,we,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),ne=et(ne);class ke{main(){try{this.a()}catch($e){console.error($e.message),n.app.exit(1)}}async a(){(0,b.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[$e,J,ue,fe,be,Ae,We,Fe]=this.b();try{try{await this.d(ue,Fe,fe,be,We)}catch(Oe){throw this.g(ue,We,Oe),Oe}await $e.invokeFunction(async Oe=>{const Ue=Oe.get(z.$_j),Ve=Oe.get(B.$Wec),Je=Oe.get(E.$_k),qe=Oe.get(z.$ak),Ye=await this.f(Ue,ue,Ve,$e,We,!0);return m.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Xe=>{Ue.warn(`app#startup(): Error writing main lockfile: ${Xe.stack}`)}),Ae.logger=qe.createLogger("main",{name:(0,o.localize)(0,null)}),h.Event.once(Ve.onWillShutdown)(Xe=>{Je.dispose(),fe.dispose(),Xe.join("instanceLockfile",m.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),$e.createInstance(t.$qgc,Ye,J).startup()})}catch(Oe){$e.invokeFunction(this.j,Oe)}}b(){const $e=new M.$Di,J=new q.$Vc;process.once("exit",()=>J.dispose());const ue={_serviceBrand:void 0,...ne.default};$e.set(Q.$sk,ue);const fe=new u.$tec(this.k(),ue),be=this.c(fe);$e.set(u.$sec,fe);const Ae=new Z.$Sec((0,z.$nk)(fe),fe.logsHome);$e.set(Z.$Rec,Ae);const We=new C.$4bc(Ae.getLogLevel()),Fe=J.add(new ie.$oR(We,[new z.$gk(Ae.getLogLevel())]));$e.set(z.$_j,Fe);const Oe=new O.$Zq(Fe);$e.set(E.$_k,Oe);const Ue=new T.$qr(Fe);Oe.registerProvider(g.Schemas.file,Ue);const Ve=new X.$Rs(Oe);$e.set(Y.$Jl,Ve);const Je=new me.$jR(me.SaveStrategy.DELAYED,fe,Fe,Oe);$e.set(G.$fR,Je),$e.set(G.$gR,Je);const qe=new _.$Hec(Je,Ve,fe,Oe,Fe);$e.set(_.$Gec,qe),Oe.registerProvider(g.Schemas.vscodeUserData,new we.$Bgc(g.Schemas.file,Ue,g.Schemas.vscodeUserData,qe,Ve,Fe));const Ye=p.$i&&ue.win32RegValueName?J.add(new N.$zgc(Fe,ue.win32RegValueName)):fe.policyFile?J.add(new W.$Agc(fe.policyFile,Oe,Fe)):new F.$uo;$e.set(F.$so,Ye);const Xe=new c.$Uo(qe.defaultProfile.settingsResource,Oe,Ye,Fe);return $e.set(i.$_i,Xe),$e.set(B.$Wec,new L.$Ci(B.$Xec,void 0,!1)),$e.set(j.$5p,new L.$Ci(U.$xgc,void 0,!0)),$e.set(se.$Bec,new L.$Ci(se.$Cec)),$e.set(V.$Yl,new L.$Ci(le.$ygc,void 0,!1)),$e.set(ee.$Aw,new L.$Ci(H.$vgc)),$e.set(ce.$Aec,new K.$sgc(fe,qe,Fe)),[new R.$tr($e,!0),be,fe,Xe,Je,We,ue,qe]}c($e){const J={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const fe=process.env[ue];typeof fe=="string"&&(J[ue]=fe)}),Object.assign(process.env,J),J}async d($e,J,ue,fe,be){await A.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:g.Schemas.file}).fsPath,J.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:g.Schemas.file}).fsPath,$e.backupHome].map(Ae=>Ae?m.Promises.mkdir(Ae,{recursive:!0}):void 0)),fe.init(),ue.initialize()]),J.init()}e($e){if(p.$i){const J=(0,Ie.getUNCHost)($e);J&&(0,Ie.addUNCHostToAllowlist)(J)}return $e}async f($e,J,ue,fe,be,Ae){let We;try{(0,l.mark)("code/willStartMainServer"),We=await(0,k.$Ai)(J.mainIPCHandle),(0,l.mark)("code/didStartMainServer"),h.Event.once(ue.onWillShutdown)(()=>We.dispose())}catch(Fe){if(Fe.code!=="EADDRINUSE")throw this.g(J,be,Fe),Fe;let Oe;try{Oe=await(0,k.$Bi)(J.mainIPCHandle,"main")}catch(qe){if(!Ae||p.$i||qe.code!=="ECONNREFUSED")throw qe.code==="EPERM"&&this.h((0,o.localize)(1,null,be.nameShort),(0,o.localize)(2,null),be),qe;try{(0,r.unlinkSync)(J.mainIPCHandle)}catch(Ye){throw $e.warn("Could not delete obsolete instance handle",Ye),Ye}return this.f($e,J,ue,fe,be,!1)}if(J.extensionTestsLocationURI&&!J.debugExtensionHost.break){const qe=`Running extension tests from the command line is currently only supported if no other instance of ${be.nameShort} is running.`;throw $e.error(qe),Oe.dispose(),new Error(qe)}let Ue;!J.args.wait&&!J.args.status&&(Ue=setTimeout(()=>{this.h((0,o.localize)(3,null,be.nameShort),(0,o.localize)(4,null),be)},1e4));const Ve=v.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Je=v.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(J.args.status)return fe.invokeFunction(async()=>{const qe=new s.$Ys(he.$wp,be),Ye=await Je.getMainDiagnostics(),Xe=await Je.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ke=await qe.getDiagnostics(Ye,Xe);throw console.log(Ke),new b.$cb});throw p.$i&&await this.i(Ve,$e),$e.trace("Sending env to running instance..."),await Ve.start(J.args,process.env),Oe.dispose(),Ue&&clearTimeout(Ue),new b.$cb("Sent env to running instance. Terminating...")}if(J.args.status)throw console.log((0,o.localize)(5,null,be.nameShort)),new b.$cb("Terminating...");return process.env.VSCODE_PID=String(process.pid),We}g($e,J,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const fe=(0,D.$Jb)([$e.userDataPath,$e.extensionsPath,k.$wi]).map(be=>(0,f.$Vw)(S.URI.file(be),{os:p.OS,tildify:$e}));this.h((0,o.localize)(6,null),(0,o.localize)(7,null,(0,I.$qj)(ue),fe.join(`
`)),J)}}h($e,J,ue){n.dialog.showMessageBoxSync((0,de.$0w)({type:"warning",buttons:[(0,o.localize)(8,null)],message:$e,detail:J},ue).options)}async i($e,J){if(p.$i){const ue=await $e.getMainProcessId();J.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((fe,be)=>{x(["windows-foreground-love"],fe,be)}).then(Re)).allowSetForegroundWindow(ue)}catch(fe){J.error(fe)}}}j($e,J){const ue=$e.get(z.$_j),fe=$e.get(B.$Wec);let be=0;J&&(J.isExpected?J.message&&ue.trace(J.message):(be=1,J.stack?ue.error(J.stack):ue.error(`Startup error: ${J.toString()}`))),fe.kill(be)}k(){const $e=this.l((0,d.$Gm)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const J=(0,P.$rgc)($e.verbose);J&&((0,d.$Im)(process.argv,"--waitMarkerFilePath",J),$e.waitMarkerFilePath=J)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const J=this.m($e._,$e.goto);$e._=J}return $e}m($e,J){const ue=(0,y.cwd)(),fe=$e.map(We=>{let Fe=String(We),Oe;J&&(Oe=(0,a.$Mg)(Fe),Fe=Oe.path),Fe&&(Fe=this.n(ue,Fe));const Ue=(0,a.$Gg)(Fe,ue),Ve=(0,w.$pc)(Ue);return Ve&&!(0,a.$Cg)(Ve)?null:J&&Oe?(Oe.path=Ue,this.o(Oe)):Ue}),be=p.$i||p.$j,Ae=(0,D.$Ob)(fe,We=>We&&be?We.toLowerCase():We||"");return(0,D.$Jb)(Ae)}n($e,J){return p.$i&&(J=(0,$.$of)(J,'"')),J=(0,$.$mf)((0,$.$mf)(J," "),"	"),p.$i&&(J=(0,w.$mc)($e,J),J=(0,$.$of)(J,".")),J}o($e){const J=[$e.path];return typeof $e.line=="number"&&J.push(String($e.line)),typeof $e.column=="number"&&J.push(String($e.column)),J.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/6afc1c279374106ca4c60382c0d92ed661f4c7e4/core/vs/code/electron-main/main.js.map
