/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],ae=function(H){for(var t=[],E=0,P=H.length;E<P;E++)t[E]=oe[H[E]];return t};define(oe[74],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$W=t.LoaderEventType=t.$V=void 0,t.$V=!1;var E;(function(w){w[w.LoaderAvailable=1]="LoaderAvailable",w[w.BeginLoadingScript=10]="BeginLoadingScript",w[w.EndLoadingScriptOK=11]="EndLoadingScriptOK",w[w.EndLoadingScriptError=12]="EndLoadingScriptError",w[w.BeginInvokeFactory=21]="BeginInvokeFactory",w[w.EndInvokeFactory=22]="EndInvokeFactory",w[w.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",w[w.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",w[w.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",w[w.NodeEndNativeRequire=34]="NodeEndNativeRequire",w[w.CachedDataFound=60]="CachedDataFound",w[w.CachedDataMissed=61]="CachedDataMissed",w[w.CachedDataRejected=62]="CachedDataRejected",w[w.CachedDataCreated=63]="CachedDataCreated"})(E||(t.LoaderEventType=E={}));class P{static get(){const O=new Map,A=new Map,I=new Map,g=new Map;function l(p,R){p.has(R.detail)||p.set(R.detail,-R.timestamp)}function c(p,R){const v=p.get(R.detail);v&&(v>=0||p.set(R.detail,v+R.timestamp))}let h=[];typeof H=="function"&&typeof H.getStats=="function"&&(h=H.getStats().slice(0).sort((p,R)=>p.timestamp-R.timestamp));for(const p of h)switch(p.type){case E.BeginLoadingScript:l(O,p);break;case E.EndLoadingScriptOK:case E.EndLoadingScriptError:c(O,p);break;case E.BeginInvokeFactory:l(A,p);break;case E.EndInvokeFactory:c(A,p);break;case E.NodeBeginNativeRequire:l(I,p);break;case E.NodeEndNativeRequire:c(I,p);break;case E.NodeBeginEvaluatingScript:l(g,p);break;case E.NodeEndEvaluatingScript:c(g,p);break}let u=0;I.forEach(p=>u+=p);function $(p){const R=[];return p.forEach((v,d)=>R.push([d,v])),R}return{amdLoad:$(O),amdInvoke:$(A),nodeRequire:$(I),nodeEval:$(g),nodeRequireTotal:u}}static toMarkdownTable(O,A){let I="";const g=[];return O.forEach((l,c)=>{g[c]=l.length}),A.forEach(l=>{l.forEach((c,h)=>{typeof c>"u"&&(c=l[h]="-");const u=c.toString().length;g[h]=Math.max(u,g[h])})}),O.forEach((l,c)=>{I+=`| ${l+" ".repeat(g[c]-l.toString().length)} `}),I+=`|
`,O.forEach((l,c)=>{I+=`| ${"-".repeat(g[c])} `}),I+=`|
`,A.forEach(l=>{l.forEach((c,h)=>{typeof c<"u"&&(I+=`| ${c+" ".repeat(g[h]-c.toString().length)} `)}),I+=`|
`}),I}}t.$W=P}),define(oe[55],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0h=P,t.$$h=w,t.$_h=O;function E(A){return(I,g,l)=>{let c=null,h=null;if(typeof l.value=="function"?(c="value",h=l.value):typeof l.get=="function"&&(c="get",h=l.get),!h)throw new Error("not supported");l[c]=A(h,g)}}function P(A,I,g){let l=null,c=null;if(typeof g.value=="function"?(l="value",c=g.value,c.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(l="get",c=g.get),!c)throw new Error("not supported");const h=`$memoize$${I}`;g[l]=function(...u){return this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!1,enumerable:!1,writable:!1,value:c.apply(this,u)}),this[h]}}function w(A,I,g){return E((l,c)=>{const h=`$debounce$${c}`,u=`$debounce$result$${c}`;return function(...$){this[u]||(this[u]=g?g():void 0),clearTimeout(this[h]),I&&(this[u]=I(this[u],...$),$=[this[u]]),this[h]=setTimeout(()=>{l.apply(this,$),this[u]=g?g():void 0},A)}})}function O(A,I,g){return E((l,c)=>{const h=`$throttle$timer$${c}`,u=`$throttle$result$${c}`,$=`$throttle$lastRun$${c}`,p=`$throttle$pending$${c}`;return function(...R){if(this[u]||(this[u]=g?g():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),I&&(this[u]=I(this[u],...R)),this[p])return;const v=this[$]+A;v<=Date.now()?(this[$]=Date.now(),l.apply(this,[this[u]]),this[u]=g?g():void 0):(this[p]=!0,this[h]=setTimeout(()=>{this[p]=!1,this[$]=Date.now(),l.apply(this,[this[u]]),this[u]=g?g():void 0},v-Date.now()))}})}}),define(oe[75],ae([0,1,9]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=P,t.$gd=w,t.$hd=O,t.$id=A,t.$jd=I,t.$kd=g;function P(l,c){if(!l)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}function w(l,c="Unreachable"){throw new Error(c)}function O(l,c="unexpected state"){if(!l)throw new E.$eb(`Assertion Failed: ${c}`)}function A(l){l||(0,E.$3)(new E.$eb("Soft Assertion Failed"))}function I(l){if(!l()){debugger;l(),(0,E.$3)(new E.$eb("Assertion Failed"))}}function g(l,c){let h=0;for(;h<l.length-1;){const u=l[h],$=l[h+1];if(!c(u,$))return!1;h++}return!0}}),define(oe[34],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,t.$Vn=A,t.$Wn=h,t.$Xn=u,t.$Yn=$,t.$Zn=p,t.$1n=R,t.$2n=v,t.$3n=d,t.$4n=m,t.$5n=k,t.$6n=y;var E;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(E||(t.ScanError=E={}));var P;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(P||(t.SyntaxKind=P={}));var w;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(w||(t.ParseErrorCode=w={}));var O;(function(e){e.DEFAULT={allowTrailingComma:!0}})(O||(t.ParseOptions=O={}));function A(e,a=!1){let n=0;const r=e.length;let i="",s=0,o=P.Unknown,f=E.None;function b(Y){let se=0,le=0;for(;se<Y;){const ue=e.charCodeAt(n);if(ue>=c._0&&ue<=c._9)le=le*16+ue-c._0;else if(ue>=c.A&&ue<=c.F)le=le*16+ue-c.A+10;else if(ue>=c.a&&ue<=c.f)le=le*16+ue-c.a+10;else break;n++,se++}return se<Y&&(le=-1),le}function D(Y){n=Y,i="",s=0,o=P.Unknown,f=E.None}function T(){const Y=n;if(e.charCodeAt(n)===c._0)n++;else for(n++;n<e.length&&l(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===c.dot)if(n++,n<e.length&&l(e.charCodeAt(n)))for(n++;n<e.length&&l(e.charCodeAt(n));)n++;else return f=E.UnexpectedEndOfNumber,e.substring(Y,n);let se=n;if(n<e.length&&(e.charCodeAt(n)===c.E||e.charCodeAt(n)===c.e))if(n++,(n<e.length&&e.charCodeAt(n)===c.plus||e.charCodeAt(n)===c.minus)&&n++,n<e.length&&l(e.charCodeAt(n))){for(n++;n<e.length&&l(e.charCodeAt(n));)n++;se=n}else f=E.UnexpectedEndOfNumber;return e.substring(Y,se)}function N(){let Y="",se=n;for(;;){if(n>=r){Y+=e.substring(se,n),f=E.UnexpectedEndOfString;break}const le=e.charCodeAt(n);if(le===c.doubleQuote){Y+=e.substring(se,n),n++;break}if(le===c.backslash){if(Y+=e.substring(se,n),n++,n>=r){f=E.UnexpectedEndOfString;break}switch(e.charCodeAt(n++)){case c.doubleQuote:Y+='"';break;case c.backslash:Y+="\\";break;case c.slash:Y+="/";break;case c.b:Y+="\b";break;case c.f:Y+="\f";break;case c.n:Y+=`
`;break;case c.r:Y+="\r";break;case c.t:Y+="	";break;case c.u:{const fe=b(4);fe>=0?Y+=String.fromCharCode(fe):f=E.InvalidUnicode;break}default:f=E.InvalidEscapeCharacter}se=n;continue}if(le>=0&&le<=31)if(g(le)){Y+=e.substring(se,n),f=E.UnexpectedEndOfString;break}else f=E.InvalidCharacter;n++}return Y}function C(){if(i="",f=E.None,s=n,n>=r)return s=r,o=P.EOF;let Y=e.charCodeAt(n);if(I(Y)){do n++,i+=String.fromCharCode(Y),Y=e.charCodeAt(n);while(I(Y));return o=P.Trivia}if(g(Y))return n++,i+=String.fromCharCode(Y),Y===c.carriageReturn&&e.charCodeAt(n)===c.lineFeed&&(n++,i+=`
`),o=P.LineBreakTrivia;switch(Y){case c.openBrace:return n++,o=P.OpenBraceToken;case c.closeBrace:return n++,o=P.CloseBraceToken;case c.openBracket:return n++,o=P.OpenBracketToken;case c.closeBracket:return n++,o=P.CloseBracketToken;case c.colon:return n++,o=P.ColonToken;case c.comma:return n++,o=P.CommaToken;case c.doubleQuote:return n++,i=N(),o=P.StringLiteral;case c.slash:{const se=n-1;if(e.charCodeAt(n+1)===c.slash){for(n+=2;n<r&&!g(e.charCodeAt(n));)n++;return i=e.substring(se,n),o=P.LineCommentTrivia}if(e.charCodeAt(n+1)===c.asterisk){n+=2;const le=r-1;let ue=!1;for(;n<le;){if(e.charCodeAt(n)===c.asterisk&&e.charCodeAt(n+1)===c.slash){n+=2,ue=!0;break}n++}return ue||(n++,f=E.UnexpectedEndOfComment),i=e.substring(se,n),o=P.BlockCommentTrivia}return i+=String.fromCharCode(Y),n++,o=P.Unknown}case c.minus:if(i+=String.fromCharCode(Y),n++,n===r||!l(e.charCodeAt(n)))return o=P.Unknown;case c._0:case c._1:case c._2:case c._3:case c._4:case c._5:case c._6:case c._7:case c._8:case c._9:return i+=T(),o=P.NumericLiteral;default:for(;n<r&&z(Y);)n++,Y=e.charCodeAt(n);if(s!==n){switch(i=e.substring(s,n),i){case"true":return o=P.TrueKeyword;case"false":return o=P.FalseKeyword;case"null":return o=P.NullKeyword}return o=P.Unknown}return i+=String.fromCharCode(Y),n++,o=P.Unknown}}function z(Y){if(I(Y)||g(Y))return!1;switch(Y){case c.closeBrace:case c.closeBracket:case c.openBrace:case c.openBracket:case c.doubleQuote:case c.colon:case c.comma:case c.slash:return!1}return!0}function X(){let Y;do Y=C();while(Y>=P.LineCommentTrivia&&Y<=P.Trivia);return Y}return{setPosition:D,getPosition:()=>n,scan:a?X:C,getToken:()=>o,getTokenValue:()=>i,getTokenOffset:()=>s,getTokenLength:()=>n-s,getTokenError:()=>f}}function I(e){return e===c.space||e===c.tab||e===c.verticalTab||e===c.formFeed||e===c.nonBreakingSpace||e===c.ogham||e>=c.enQuad&&e<=c.zeroWidthSpace||e===c.narrowNoBreakSpace||e===c.mathematicalSpace||e===c.ideographicSpace||e===c.byteOrderMark}function g(e){return e===c.lineFeed||e===c.carriageReturn||e===c.lineSeparator||e===c.paragraphSeparator}function l(e){return e>=c._0&&e<=c._9}var c;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(c||(c={}));function h(e,a){const n=[],r=new Object;let i;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function f(b,D,T,N){s.value=b,s.offset=D,s.length=T,s.type=N,s.colonOffset=void 0,i=s}try{k(e,{onObjectBegin:(b,D)=>{if(a<=b)throw r;i=void 0,o=a>b,n.push("")},onObjectProperty:(b,D,T)=>{if(a<D||(f(b,D,T,"property"),n[n.length-1]=b,a<=D+T))throw r},onObjectEnd:(b,D)=>{if(a<=b)throw r;i=void 0,n.pop()},onArrayBegin:(b,D)=>{if(a<=b)throw r;i=void 0,n.push(0)},onArrayEnd:(b,D)=>{if(a<=b)throw r;i=void 0,n.pop()},onLiteralValue:(b,D,T)=>{if(a<D||(f(b,D,T,y(b)),a<=D+T))throw r},onSeparator:(b,D,T)=>{if(a<=D)throw r;if(b===":"&&i&&i.type==="property")i.colonOffset=D,o=!1,i=void 0;else if(b===","){const N=n[n.length-1];typeof N=="number"?n[n.length-1]=N+1:(o=!0,n[n.length-1]=""),i=void 0}}})}catch(b){if(b!==r)throw b}return{path:n,previousNode:i,isAtPropertyKey:o,matches:b=>{let D=0;for(let T=0;D<b.length&&T<n.length;T++)if(b[D]===n[T]||b[D]==="*")D++;else if(b[D]!=="**")return!1;return D===b.length}}}function u(e,a=[],n=O.DEFAULT){let r=null,i=[];const s=[];function o(b){Array.isArray(i)?i.push(b):r!==null&&(i[r]=b)}return k(e,{onObjectBegin:()=>{const b={};o(b),s.push(i),i=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{const b=[];o(b),s.push(i),i=b,r=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:o,onError:(b,D,T)=>{a.push({error:b,offset:D,length:T})}},n),i[0]}function $(e,a=[],n=O.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(b){r.type==="property"&&(r.length=b-r.offset,r=r.parent)}function s(b){return r.children.push(b),b}k(e,{onObjectBegin:b=>{r=s({type:"object",offset:b,length:-1,parent:r,children:[]})},onObjectProperty:(b,D,T)=>{r=s({type:"property",offset:D,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:b,offset:D,length:T,parent:r})},onObjectEnd:(b,D)=>{r.length=b+D-r.offset,r=r.parent,i(b+D)},onArrayBegin:(b,D)=>{r=s({type:"array",offset:b,length:-1,parent:r,children:[]})},onArrayEnd:(b,D)=>{r.length=b+D-r.offset,r=r.parent,i(b+D)},onLiteralValue:(b,D,T)=>{s({type:y(b),offset:D,length:T,parent:r,value:b}),i(D+T)},onSeparator:(b,D,T)=>{r.type==="property"&&(b===":"?r.colonOffset=D:b===","&&i(D))},onError:(b,D,T)=>{a.push({error:b,offset:D,length:T})}},n);const f=r.children[0];return f&&delete f.parent,f}function p(e,a){if(!e)return;let n=e;for(const r of a)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const s of n.children)if(Array.isArray(s.children)&&s.children[0].value===r){n=s.children[1],i=!0;break}if(!i)return}else{const i=r;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}function R(e){if(!e.parent||!e.parent.children)return[];const a=R(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;a.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&a.push(n)}return a}function v(e){switch(e.type){case"array":return e.children.map(v);case"object":{const a=Object.create(null);for(const n of e.children){const r=n.children[1];r&&(a[n.children[0].value]=v(r))}return a}case"null":case"string":case"number":case"boolean":return e.value;default:return}}function d(e,a,n=!1){return a>=e.offset&&a<e.offset+e.length||n&&a===e.offset+e.length}function m(e,a,n=!1){if(d(e,a,n)){const r=e.children;if(Array.isArray(r))for(let i=0;i<r.length&&r[i].offset<=a;i++){const s=m(r[i],a,n);if(s)return s}return e}}function k(e,a,n=O.DEFAULT){const r=A(e,!1);function i(Z){return Z?()=>Z(r.getTokenOffset(),r.getTokenLength()):()=>!0}function s(Z){return Z?te=>Z(te,r.getTokenOffset(),r.getTokenLength()):()=>!0}const o=i(a.onObjectBegin),f=s(a.onObjectProperty),b=i(a.onObjectEnd),D=i(a.onArrayBegin),T=i(a.onArrayEnd),N=s(a.onLiteralValue),C=s(a.onSeparator),z=i(a.onComment),X=s(a.onError),Y=n&&n.disallowComments,se=n&&n.allowTrailingComma;function le(){for(;;){const Z=r.scan();switch(r.getTokenError()){case E.InvalidUnicode:ue(w.InvalidUnicode);break;case E.InvalidEscapeCharacter:ue(w.InvalidEscapeCharacter);break;case E.UnexpectedEndOfNumber:ue(w.UnexpectedEndOfNumber);break;case E.UnexpectedEndOfComment:Y||ue(w.UnexpectedEndOfComment);break;case E.UnexpectedEndOfString:ue(w.UnexpectedEndOfString);break;case E.InvalidCharacter:ue(w.InvalidCharacter);break}switch(Z){case P.LineCommentTrivia:case P.BlockCommentTrivia:Y?ue(w.InvalidCommentToken):z();break;case P.Unknown:ue(w.InvalidSymbol);break;case P.Trivia:case P.LineBreakTrivia:break;default:return Z}}}function ue(Z,te=[],F=[]){if(X(Z),te.length+F.length>0){let M=r.getToken();for(;M!==P.EOF;){if(te.indexOf(M)!==-1){le();break}else if(F.indexOf(M)!==-1)break;M=le()}}}function fe(Z){const te=r.getTokenValue();return Z?N(te):f(te),le(),!0}function x(){switch(r.getToken()){case P.NumericLiteral:{let Z=0;try{Z=JSON.parse(r.getTokenValue()),typeof Z!="number"&&(ue(w.InvalidNumberFormat),Z=0)}catch{ue(w.InvalidNumberFormat)}N(Z);break}case P.NullKeyword:N(null);break;case P.TrueKeyword:N(!0);break;case P.FalseKeyword:N(!1);break;default:return!1}return le(),!0}function _(){return r.getToken()!==P.StringLiteral?(ue(w.PropertyNameExpected,[],[P.CloseBraceToken,P.CommaToken]),!1):(fe(!1),r.getToken()===P.ColonToken?(C(":"),le(),G()||ue(w.ValueExpected,[],[P.CloseBraceToken,P.CommaToken])):ue(w.ColonExpected,[],[P.CloseBraceToken,P.CommaToken]),!0)}function V(){o(),le();let Z=!1;for(;r.getToken()!==P.CloseBraceToken&&r.getToken()!==P.EOF;){if(r.getToken()===P.CommaToken){if(Z||ue(w.ValueExpected,[],[]),C(","),le(),r.getToken()===P.CloseBraceToken&&se)break}else Z&&ue(w.CommaExpected,[],[]);_()||ue(w.ValueExpected,[],[P.CloseBraceToken,P.CommaToken]),Z=!0}return b(),r.getToken()!==P.CloseBraceToken?ue(w.CloseBraceExpected,[P.CloseBraceToken],[]):le(),!0}function q(){D(),le();let Z=!1;for(;r.getToken()!==P.CloseBracketToken&&r.getToken()!==P.EOF;){if(r.getToken()===P.CommaToken){if(Z||ue(w.ValueExpected,[],[]),C(","),le(),r.getToken()===P.CloseBracketToken&&se)break}else Z&&ue(w.CommaExpected,[],[]);G()||ue(w.ValueExpected,[],[P.CloseBracketToken,P.CommaToken]),Z=!0}return T(),r.getToken()!==P.CloseBracketToken?ue(w.CloseBracketExpected,[P.CloseBracketToken],[]):le(),!0}function G(){switch(r.getToken()){case P.OpenBracketToken:return q();case P.OpenBraceToken:return V();case P.StringLiteral:return fe(!0);default:return x()}}return le(),r.getToken()===P.EOF?n.allowEmptyContent?!0:(ue(w.ValueExpected,[],[]),!1):G()?(r.getToken()!==P.EOF&&ue(w.EndOfFileExpected,[],[]),!0):(ue(w.ValueExpected,[],[]),!1)}function y(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}}),define(oe[76],ae([0,1,34]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7n=P,t.$8n=w,t.$9n=I,t.$0n=g;function P(l,c,h){let u,$,p,R,v;if(c){for(R=c.offset,v=R+c.length,p=R;p>0&&!g(l,p-1);)p--;let f=v;for(;f<l.length&&!g(l,f);)f++;$=l.substring(p,f),u=A($,h)}else $=l,u=0,p=0,R=0,v=l.length;const d=I(h,l);let m=!1,k=0,y;h.insertSpaces?y=O(" ",h.tabSize||4):y="	";const e=(0,E.$Vn)($,!1);let a=!1;function n(){return d+O(y,u+k)}function r(){let f=e.scan();for(m=!1;f===E.SyntaxKind.Trivia||f===E.SyntaxKind.LineBreakTrivia;)m=m||f===E.SyntaxKind.LineBreakTrivia,f=e.scan();return a=f===E.SyntaxKind.Unknown||e.getTokenError()!==E.ScanError.None,f}const i=[];function s(f,b,D){!a&&b<v&&D>R&&l.substring(b,D)!==f&&i.push({offset:b,length:D-b,content:f})}let o=r();if(o!==E.SyntaxKind.EOF){const f=e.getTokenOffset()+p,b=O(y,u);s(b,p,f)}for(;o!==E.SyntaxKind.EOF;){let f=e.getTokenOffset()+e.getTokenLength()+p,b=r(),D="";for(;!m&&(b===E.SyntaxKind.LineCommentTrivia||b===E.SyntaxKind.BlockCommentTrivia);){const N=e.getTokenOffset()+p;s(" ",f,N),f=e.getTokenOffset()+e.getTokenLength()+p,D=b===E.SyntaxKind.LineCommentTrivia?n():"",b=r()}if(b===E.SyntaxKind.CloseBraceToken)o!==E.SyntaxKind.OpenBraceToken&&(k--,D=n());else if(b===E.SyntaxKind.CloseBracketToken)o!==E.SyntaxKind.OpenBracketToken&&(k--,D=n());else{switch(o){case E.SyntaxKind.OpenBracketToken:case E.SyntaxKind.OpenBraceToken:k++,D=n();break;case E.SyntaxKind.CommaToken:case E.SyntaxKind.LineCommentTrivia:D=n();break;case E.SyntaxKind.BlockCommentTrivia:m?D=n():D=" ";break;case E.SyntaxKind.ColonToken:D=" ";break;case E.SyntaxKind.StringLiteral:if(b===E.SyntaxKind.ColonToken){D="";break}case E.SyntaxKind.NullKeyword:case E.SyntaxKind.TrueKeyword:case E.SyntaxKind.FalseKeyword:case E.SyntaxKind.NumericLiteral:case E.SyntaxKind.CloseBraceToken:case E.SyntaxKind.CloseBracketToken:b===E.SyntaxKind.LineCommentTrivia||b===E.SyntaxKind.BlockCommentTrivia?D=" ":b!==E.SyntaxKind.CommaToken&&b!==E.SyntaxKind.EOF&&(a=!0);break;case E.SyntaxKind.Unknown:a=!0;break}m&&(b===E.SyntaxKind.LineCommentTrivia||b===E.SyntaxKind.BlockCommentTrivia)&&(D=n())}const T=e.getTokenOffset()+p;s(D,f,T),o=b}return i}function w(l,c){const h=JSON.stringify(l,void 0,c.insertSpaces?c.tabSize||4:"	");return c.eol!==void 0?h.replace(/\r\n|\r|\n/g,c.eol):h}function O(l,c){let h="";for(let u=0;u<c;u++)h+=l;return h}function A(l,c){let h=0,u=0;const $=c.tabSize||4;for(;h<l.length;){const p=l.charAt(h);if(p===" ")u++;else if(p==="	")u+=$;else break;h++}return Math.floor(u/$)}function I(l,c){for(let h=0;h<c.length;h++){const u=c.charAt(h);if(u==="\r")return h+1<c.length&&c.charAt(h+1)===`
`?`\r
`:"\r";if(u===`
`)return`
`}return l&&l.eol||`
`}function g(l,c){return`\r
`.indexOf(l.charAt(c))!==-1}}),define(oe[77],ae([0,1,34,76]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$n=w,t.$_n=O,t.$ao=A,t.$bo=I,t.$co=g;function w(l,c,h){return O(l,c,void 0,h)}function O(l,c,h,u,$){const p=c.slice(),R=[],v=(0,E.$Yn)(l,R);let d,m;for(;p.length>0&&(m=p.pop(),d=(0,E.$Zn)(v,p),d===void 0&&h!==void 0);)typeof m=="string"?h={[m]:h}:h=[h];if(d)if(d.type==="object"&&typeof m=="string"&&Array.isArray(d.children)){const k=(0,E.$Zn)(d,[m]);if(k!==void 0)if(h===void 0){if(!k.parent)throw new Error("Malformed AST");const y=d.children.indexOf(k.parent);let e,a=k.parent.offset+k.parent.length;if(y>0){const n=d.children[y-1];e=n.offset+n.length}else e=d.offset+1,d.children.length>1&&(a=d.children[1].offset);return A(l,{offset:e,length:a-e,content:""},u)}else return A(l,{offset:k.offset,length:k.length,content:JSON.stringify(h)},u);else{if(h===void 0)return[];const y=`${JSON.stringify(m)}: ${JSON.stringify(h)}`,e=$?$(d.children.map(n=>n.children[0].value)):d.children.length;let a;if(e>0){const n=d.children[e-1];a={offset:n.offset+n.length,length:0,content:","+y}}else d.children.length===0?a={offset:d.offset+1,length:0,content:y}:a={offset:d.offset+1,length:0,content:y+","};return A(l,a,u)}}else if(d.type==="array"&&typeof m=="number"&&Array.isArray(d.children))if(h!==void 0){const k=`${JSON.stringify(h)}`;let y;if(d.children.length===0||m===0)y={offset:d.offset+1,length:0,content:d.children.length===0?k:k+","};else{const e=m===-1||m>d.children.length?d.children.length:m,a=d.children[e-1];y={offset:a.offset+a.length,length:0,content:","+k}}return A(l,y,u)}else{const k=m,y=d.children[k];let e;if(d.children.length===1)e={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===k){const a=d.children[k-1],n=a.offset+a.length,r=d.offset+d.length;e={offset:n,length:r-2-n,content:""}}else e={offset:y.offset,length:d.children[k+1].offset-y.offset,content:""};return A(l,e,u)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${d.type}`);else return h===void 0?[]:A(l,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(h)},u)}function A(l,c,h){let u=I(l,c),$=c.offset,p=c.offset+c.content.length;if(c.length===0||c.content.length===0){for(;$>0&&!(0,P.$0n)(u,$-1);)$--;for(;p<u.length&&!(0,P.$0n)(u,p);)p++}const R=(0,P.$7n)(u,{offset:$,length:p-$},h);for(let d=R.length-1;d>=0;d--){const m=R[d];u=I(u,m),$=Math.min($,m.offset),p=Math.max(p,m.offset+m.length),p+=m.content.length-m.length}const v=l.length-(u.length-p)-$;return[{offset:$,length:v,content:u.substring($,p)}]}function I(l,c){return l.substring(0,c.offset)+c.content+l.substring(c.offset+c.length)}function g(l,c){const h=c.slice(0).sort(($,p)=>{const R=$.offset-p.offset;return R===0?$.length-p.length:R});let u=l.length;for(let $=h.length-1;$>=0;$--){const p=h[$];if(p.offset+p.length<=u)l=I(l,p);else throw new Error("Overlapping edit");u=p.offset}return l}}),define(oe[78],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Om=t.$Nm=t.$Mm=void 0,t.$Km=E,t.rot=P,t.$Pm=I;function E(g,l,c){return Math.min(Math.max(g,l),c)}function P(g,l){return(l+g%l)%l}class w{constructor(){this.a=0}getNext(){return this.a++}}t.$Mm=w;class O{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Nm=O;class A{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const c=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Om=A;function I(g,l,c,h,u,$,p,R){const v=p-c,d=R-h,m=u-c,k=$-h,y=g-c,e=l-h,a=v*v+d*d,n=v*m+d*k,r=v*y+d*e,i=m*m+k*k,s=m*y+k*e,o=1/(a*i-n*n),f=(i*r-n*s)*o,b=(a*s-n*r)*o;return f>=0&&b>=0&&f+b<1}}),function(){function H(w){const O=[];typeof w=="number"&&O.push("code/timeOrigin",w);function A(g){O.push(g,Date.now())}function I(){const g=[];for(let l=0;l<O.length;l+=2)g.push({name:O[l],startTime:O[l+1]});return g}return{mark:A,getMarks:I}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(w+A.startTime)});return O}};if(typeof process=="object"){const w=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function E(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=t()),w.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=E(P))}(),function(H,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var E=t();for(var P in E)(typeof exports=="object"?exports:H)[P]=E[P]}}(typeof self<"u"?self:this,function(){return function(H){var t={};function E(P){if(t[P])return t[P].exports;var w=t[P]={i:P,l:!1,exports:{}};return H[P].call(w.exports,w,w.exports,E),w.l=!0,w.exports}return E.m=H,E.c=t,E.d=function(P,w,O){E.o(P,w)||Object.defineProperty(P,w,{enumerable:!0,get:O})},E.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},E.t=function(P,w){if(1&w&&(P=E(P)),8&w||4&w&&typeof P=="object"&&P&&P.__esModule)return P;var O=Object.create(null);if(E.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:P}),2&w&&typeof P!="string")for(var A in P)E.d(O,A,function(I){return P[I]}.bind(null,A));return O},E.n=function(P){var w=P&&P.__esModule?function(){return P.default}:function(){return P};return E.d(w,"a",w),w},E.o=function(P,w){return Object.prototype.hasOwnProperty.call(P,w)},E.p="",E(E.s=0)}([function(H,t,E){(function(P){var w;t=H.exports=M,w=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=t.re=[],g=t.src=[],l=0,c=l++;g[c]="0|[1-9]\\d*";var h=l++;g[h]="[0-9]+";var u=l++;g[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=l++;g[$]="("+g[c]+")\\.("+g[c]+")\\.("+g[c]+")";var p=l++;g[p]="("+g[h]+")\\.("+g[h]+")\\.("+g[h]+")";var R=l++;g[R]="(?:"+g[c]+"|"+g[u]+")";var v=l++;g[v]="(?:"+g[h]+"|"+g[u]+")";var d=l++;g[d]="(?:-("+g[R]+"(?:\\."+g[R]+")*))";var m=l++;g[m]="(?:-?("+g[v]+"(?:\\."+g[v]+")*))";var k=l++;g[k]="[0-9A-Za-z-]+";var y=l++;g[y]="(?:\\+("+g[k]+"(?:\\."+g[k]+")*))";var e=l++,a="v?"+g[$]+g[d]+"?"+g[y]+"?";g[e]="^"+a+"$";var n="[v=\\s]*"+g[p]+g[m]+"?"+g[y]+"?",r=l++;g[r]="^"+n+"$";var i=l++;g[i]="((?:<|>)?=?)";var s=l++;g[s]=g[h]+"|x|X|\\*";var o=l++;g[o]=g[c]+"|x|X|\\*";var f=l++;g[f]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[d]+")?"+g[y]+"?)?)?";var b=l++;g[b]="[v=\\s]*("+g[s]+")(?:\\.("+g[s]+")(?:\\.("+g[s]+")(?:"+g[m]+")?"+g[y]+"?)?)?";var D=l++;g[D]="^"+g[i]+"\\s*"+g[f]+"$";var T=l++;g[T]="^"+g[i]+"\\s*"+g[b]+"$";var N=l++;g[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=l++;g[C]="(?:~>?)";var z=l++;g[z]="(\\s*)"+g[C]+"\\s+",I[z]=new RegExp(g[z],"g");var X=l++;g[X]="^"+g[C]+g[f]+"$";var Y=l++;g[Y]="^"+g[C]+g[b]+"$";var se=l++;g[se]="(?:\\^)";var le=l++;g[le]="(\\s*)"+g[se]+"\\s+",I[le]=new RegExp(g[le],"g");var ue=l++;g[ue]="^"+g[se]+g[f]+"$";var fe=l++;g[fe]="^"+g[se]+g[b]+"$";var x=l++;g[x]="^"+g[i]+"\\s*("+n+")$|^$";var _=l++;g[_]="^"+g[i]+"\\s*("+a+")$|^$";var V=l++;g[V]="(\\s*)"+g[i]+"\\s*("+n+"|"+g[f]+")",I[V]=new RegExp(g[V],"g");var q=l++;g[q]="^\\s*("+g[f]+")\\s+-\\s+("+g[f]+")\\s*$";var G=l++;g[G]="^\\s*("+g[b]+")\\s+-\\s+("+g[b]+")\\s*$";var Z=l++;g[Z]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)w(te,g[te]),I[te]||(I[te]=new RegExp(g[te]));function F(W,ee){if(W instanceof M)return W;if(typeof W!="string"||W.length>O||!(ee?I[r]:I[e]).test(W))return null;try{return new M(W,ee)}catch{return null}}function M(W,ee){if(W instanceof M){if(W.loose===ee)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof M))return new M(W,ee);w("SemVer",W,ee),this.loose=ee;var ie=W.trim().match(ee?I[r]:I[e]);if(!ie)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+ie[1],this.minor=+ie[2],this.patch=+ie[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ie[4]?this.prerelease=ie[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var Ee=+ge;if(Ee>=0&&Ee<A)return Ee}return ge}):this.prerelease=[],this.build=ie[5]?ie[5].split("."):[],this.format()}t.parse=F,t.valid=function(W,ee){var ie=F(W,ee);return ie?ie.version:null},t.clean=function(W,ee){var ie=F(W.trim().replace(/^[=v]+/,""),ee);return ie?ie.version:null},t.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(W){return w("SemVer.compare",this.version,this.loose,W),W instanceof M||(W=new M(W,this.loose)),this.compareMain(W)||this.comparePre(W)},M.prototype.compareMain=function(W){return W instanceof M||(W=new M(W,this.loose)),B(this.major,W.major)||B(this.minor,W.minor)||B(this.patch,W.patch)},M.prototype.comparePre=function(W){if(W instanceof M||(W=new M(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var ee=0;do{var ie=this.prerelease[ee],ge=W.prerelease[ee];if(w("prerelease compare",ee,ie,ge),ie===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ie===void 0)return-1;if(ie!==ge)return B(ie,ge)}while(++ee)},M.prototype.inc=function(W,ee){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ie=this.prerelease.length;--ie>=0;)typeof this.prerelease[ie]=="number"&&(this.prerelease[ie]++,ie=-2);ie===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},t.inc=function(W,ee,ie,ge){typeof ie=="string"&&(ge=ie,ie=void 0);try{return new M(W,ie).inc(ee,ge).version}catch{return null}},t.diff=function(W,ee){if(L(W,ee))return null;var ie=F(W),ge=F(ee);if(ie.prerelease.length||ge.prerelease.length){for(var Ee in ie)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&ie[Ee]!==ge[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in ie)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&ie[Ee]!==ge[Ee])return Ee},t.compareIdentifiers=B;var J=/^[0-9]+$/;function B(W,ee){var ie=J.test(W),ge=J.test(ee);return ie&&ge&&(W=+W,ee=+ee),ie&&!ge?-1:ge&&!ie?1:W<ee?-1:W>ee?1:0}function S(W,ee,ie){return new M(W,ie).compare(new M(ee,ie))}function U(W,ee,ie){return S(W,ee,ie)>0}function j(W,ee,ie){return S(W,ee,ie)<0}function L(W,ee,ie){return S(W,ee,ie)===0}function K(W,ee,ie){return S(W,ee,ie)!==0}function Q(W,ee,ie){return S(W,ee,ie)>=0}function ne(W,ee,ie){return S(W,ee,ie)<=0}function ce(W,ee,ie,ge){var Ee;switch(ee){case"===":typeof W=="object"&&(W=W.version),typeof ie=="object"&&(ie=ie.version),Ee=W===ie;break;case"!==":typeof W=="object"&&(W=W.version),typeof ie=="object"&&(ie=ie.version),Ee=W!==ie;break;case"":case"=":case"==":Ee=L(W,ie,ge);break;case"!=":Ee=K(W,ie,ge);break;case">":Ee=U(W,ie,ge);break;case">=":Ee=Q(W,ie,ge);break;case"<":Ee=j(W,ie,ge);break;case"<=":Ee=ne(W,ie,ge);break;default:throw new TypeError("Invalid operator: "+ee)}return Ee}function de(W,ee){if(W instanceof de){if(W.loose===ee)return W;W=W.value}if(!(this instanceof de))return new de(W,ee);w("comparator",W,ee),this.loose=ee,this.parse(W),this.semver===me?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}t.rcompareIdentifiers=function(W,ee){return B(ee,W)},t.major=function(W,ee){return new M(W,ee).major},t.minor=function(W,ee){return new M(W,ee).minor},t.patch=function(W,ee){return new M(W,ee).patch},t.compare=S,t.compareLoose=function(W,ee){return S(W,ee,!0)},t.rcompare=function(W,ee,ie){return S(ee,W,ie)},t.sort=function(W,ee){return W.sort(function(ie,ge){return t.compare(ie,ge,ee)})},t.rsort=function(W,ee){return W.sort(function(ie,ge){return t.rcompare(ie,ge,ee)})},t.gt=U,t.lt=j,t.eq=L,t.neq=K,t.gte=Q,t.lte=ne,t.cmp=ce,t.Comparator=de;var me={};function $e(W,ee){if(W instanceof $e)return W.loose===ee?W:new $e(W.raw,ee);if(W instanceof de)return new $e(W.value,ee);if(!(this instanceof $e))return new $e(W,ee);if(this.loose=ee,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(ie){return this.parseRange(ie.trim())},this).filter(function(ie){return ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function we(W){return!W||W.toLowerCase()==="x"||W==="*"}function he(W,ee,ie,ge,Ee,Ae,ke,Le,Re,Ce,qe,Ne,Te){return((ee=we(ie)?"":we(ge)?">="+ie+".0.0":we(Ee)?">="+ie+"."+ge+".0":">="+ee)+" "+(Le=we(Re)?"":we(Ce)?"<"+(+Re+1)+".0.0":we(qe)?"<"+Re+"."+(+Ce+1)+".0":Ne?"<="+Re+"."+Ce+"."+qe+"-"+Ne:"<="+Le)).trim()}function pe(W,ee){for(var ie=0;ie<W.length;ie++)if(!W[ie].test(ee))return!1;if(ee.prerelease.length){for(ie=0;ie<W.length;ie++)if(w(W[ie].semver),W[ie].semver!==me&&W[ie].semver.prerelease.length>0){var ge=W[ie].semver;if(ge.major===ee.major&&ge.minor===ee.minor&&ge.patch===ee.patch)return!0}return!1}return!0}function ve(W,ee,ie){try{ee=new $e(ee,ie)}catch{return!1}return ee.test(W)}function Se(W,ee,ie,ge){var Ee,Ae,ke,Le,Re;switch(W=new M(W,ge),ee=new $e(ee,ge),ie){case">":Ee=U,Ae=ne,ke=j,Le=">",Re=">=";break;case"<":Ee=j,Ae=Q,ke=U,Le="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(W,ee,ge))return!1;for(var Ce=0;Ce<ee.set.length;++Ce){var qe=ee.set[Ce],Ne=null,Te=null;if(qe.forEach(function(Fe){Fe.semver===me&&(Fe=new de(">=0.0.0")),Ne=Ne||Fe,Te=Te||Fe,Ee(Fe.semver,Ne.semver,ge)?Ne=Fe:ke(Fe.semver,Te.semver,ge)&&(Te=Fe)}),Ne.operator===Le||Ne.operator===Re||(!Te.operator||Te.operator===Le)&&Ae(W,Te.semver)||Te.operator===Re&&ke(W,Te.semver))return!1}return!0}de.prototype.parse=function(W){var ee=this.loose?I[x]:I[_],ie=W.match(ee);if(!ie)throw new TypeError("Invalid comparator: "+W);this.operator=ie[1],this.operator==="="&&(this.operator=""),ie[2]?this.semver=new M(ie[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(W){return w("Comparator.test",W,this.loose),this.semver===me||(typeof W=="string"&&(W=new M(W,this.loose)),ce(W,this.operator,this.semver,this.loose))},de.prototype.intersects=function(W,ee){if(!(W instanceof de))throw new TypeError("a Comparator is required");var ie;if(this.operator==="")return ie=new $e(W.value,ee),ve(this.value,ie,ee);if(W.operator==="")return ie=new $e(this.value,ee),ve(W.semver,ie,ee);var ge=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Ae=this.semver.version===W.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Le=ce(this.semver,"<",W.semver,ee)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),Re=ce(this.semver,">",W.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return ge||Ee||Ae&&ke||Le||Re},t.Range=$e,$e.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},$e.prototype.toString=function(){return this.range},$e.prototype.parseRange=function(W){var ee=this.loose;W=W.trim(),w("range",W,ee);var ie=ee?I[G]:I[q];W=W.replace(ie,he),w("hyphen replace",W),W=W.replace(I[V],"$1$2$3"),w("comparator trim",W,I[V]),W=(W=(W=W.replace(I[z],"$1~")).replace(I[le],"$1^")).split(/\s+/).join(" ");var ge=ee?I[x]:I[_],Ee=W.split(" ").map(function(Ae){return function(ke,Le){return w("comp",ke),ke=function(Re,Ce){return Re.trim().split(/\s+/).map(function(qe){return function(Ne,Te){w("caret",Ne,Te);var Fe=Te?I[fe]:I[ue];return Ne.replace(Fe,function(Ue,Pe,Ie,Oe,De){var je;return w("caret",Ne,Ue,Pe,Ie,Oe,De),we(Pe)?je="":we(Ie)?je=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(Oe)?je=Pe==="0"?">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+".0 <"+(+Pe+1)+".0.0":De?(w("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),je=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Oe+De+" <"+Pe+"."+Ie+"."+(+Oe+1):">="+Pe+"."+Ie+"."+Oe+De+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Oe+De+" <"+(+Pe+1)+".0.0"):(w("no pr"),je=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+Ie+"."+(+Oe+1):">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Oe+" <"+(+Pe+1)+".0.0"),w("caret return",je),je})}(qe,Ce)}).join(" ")}(ke,Le),w("caret",ke),ke=function(Re,Ce){return Re.trim().split(/\s+/).map(function(qe){return function(Ne,Te){var Fe=Te?I[Y]:I[X];return Ne.replace(Fe,function(Ue,Pe,Ie,Oe,De){var je;return w("tilde",Ne,Ue,Pe,Ie,Oe,De),we(Pe)?je="":we(Ie)?je=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(Oe)?je=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":De?(w("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),je=">="+Pe+"."+Ie+"."+Oe+De+" <"+Pe+"."+(+Ie+1)+".0"):je=">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+(+Ie+1)+".0",w("tilde return",je),je})}(qe,Ce)}).join(" ")}(ke,Le),w("tildes",ke),ke=function(Re,Ce){return w("replaceXRanges",Re,Ce),Re.split(/\s+/).map(function(qe){return function(Ne,Te){Ne=Ne.trim();var Fe=Te?I[T]:I[D];return Ne.replace(Fe,function(Ue,Pe,Ie,Oe,De,je){w("xRange",Ne,Ue,Pe,Ie,Oe,De,je);var Ve=we(Ie),ze=Ve||we(Oe),Be=ze||we(De);return Pe==="="&&Be&&(Pe=""),Ve?Ue=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&Be?(ze&&(Oe=0),Be&&(De=0),Pe===">"?(Pe=">=",ze?(Ie=+Ie+1,Oe=0,De=0):Be&&(Oe=+Oe+1,De=0)):Pe==="<="&&(Pe="<",ze?Ie=+Ie+1:Oe=+Oe+1),Ue=Pe+Ie+"."+Oe+"."+De):ze?Ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Be&&(Ue=">="+Ie+"."+Oe+".0 <"+Ie+"."+(+Oe+1)+".0"),w("xRange return",Ue),Ue})}(qe,Ce)}).join(" ")}(ke,Le),w("xrange",ke),ke=function(Re,Ce){return w("replaceStars",Re,Ce),Re.trim().replace(I[Z],"")}(ke,Le),w("stars",ke),ke}(Ae,ee)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Ae){return!!Ae.match(ge)})),Ee=Ee.map(function(Ae){return new de(Ae,ee)})},$e.prototype.intersects=function(W,ee){if(!(W instanceof $e))throw new TypeError("a Range is required");return this.set.some(function(ie){return ie.every(function(ge){return W.set.some(function(Ee){return Ee.every(function(Ae){return ge.intersects(Ae,ee)})})})})},t.toComparators=function(W,ee){return new $e(W,ee).set.map(function(ie){return ie.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},$e.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new M(W,this.loose));for(var ee=0;ee<this.set.length;ee++)if(pe(this.set[ee],W))return!0;return!1},t.satisfies=ve,t.maxSatisfying=function(W,ee,ie){var ge=null,Ee=null;try{var Ae=new $e(ee,ie)}catch{return null}return W.forEach(function(ke){Ae.test(ke)&&(ge&&Ee.compare(ke)!==-1||(Ee=new M(ge=ke,ie)))}),ge},t.minSatisfying=function(W,ee,ie){var ge=null,Ee=null;try{var Ae=new $e(ee,ie)}catch{return null}return W.forEach(function(ke){Ae.test(ke)&&(ge&&Ee.compare(ke)!==1||(Ee=new M(ge=ke,ie)))}),ge},t.validRange=function(W,ee){try{return new $e(W,ee).range||"*"}catch{return null}},t.ltr=function(W,ee,ie){return Se(W,ee,"<",ie)},t.gtr=function(W,ee,ie){return Se(W,ee,">",ie)},t.outside=Se,t.prerelease=function(W,ee){var ie=F(W,ee);return ie&&ie.prerelease.length?ie.prerelease:null},t.intersects=function(W,ee,ie){return W=new $e(W,ie),ee=new $e(ee,ie),W.intersects(ee)},t.coerce=function(W){if(W instanceof M)return W;if(typeof W!="string")return null;var ee=W.match(I[N]);return ee==null?null:F((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,E(1))},function(H,t){var E,P,w=H.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(v){if(E===setTimeout)return setTimeout(v,0);if((E===O||!E)&&setTimeout)return E=setTimeout,setTimeout(v,0);try{return E(v,0)}catch{try{return E.call(null,v,0)}catch{return E.call(this,v,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:O}catch{E=O}try{P=typeof clearTimeout=="function"?clearTimeout:A}catch{P=A}})();var g,l=[],c=!1,h=-1;function u(){c&&g&&(c=!1,g.length?l=g.concat(l):h=-1,l.length&&$())}function $(){if(!c){var v=I(u);c=!0;for(var d=l.length;d;){for(g=l,l=[];++h<d;)g&&g[h].run();h=-1,d=l.length}g=null,c=!1,function(m){if(P===clearTimeout)return clearTimeout(m);if((P===A||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(m);try{P(m)}catch{try{return P.call(null,m)}catch{return P.call(this,m)}}}(v)}}function p(v,d){this.fun=v,this.array=d}function R(){}w.nextTick=function(v){var d=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)d[m-1]=arguments[m];l.push(new p(v,d)),l.length!==1||c||I($)},p.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=R,w.addListener=R,w.once=R,w.off=R,w.removeListener=R,w.removeAllListeners=R,w.emit=R,w.prependListener=R,w.prependOnceListener=R,w.listeners=function(v){return[]},w.binding=function(v){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(v){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(oe[79],ae([0,1]),function(H,t){"use strict";var E;Object.defineProperty(t,"__esModule",{value:!0}),t.$Qs=void 0;class P{constructor(I,g,l){this.level=I,this.key=g,this.value=l,this.forward=[]}}const w=void 0;class O{constructor(I,g=2**16){this.comparator=I,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new P(this.c,w,w)}get size(){return this.f}clear(){this.e=new P(this.c,w,w),this.f=0}has(I){return!!O.g(this,I,this.comparator)}get(I){return O.g(this,I,this.comparator)?.value}set(I,g){return O.h(this,I,g,this.comparator)&&(this.f+=1),this}delete(I){const g=O.k(this,I,this.comparator);return g&&(this.f-=1),g}forEach(I,g){let l=this.e.forward[0];for(;l;)I.call(g,l.value,l.key,this),l=l.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",g=this.e.forward[0];for(;g;)I+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return I}static g(I,g,l){let c=I.e;for(let h=I.d-1;h>=0;h--)for(;c.forward[h]&&l(c.forward[h].key,g)<0;)c=c.forward[h];if(c=c.forward[0],c&&l(c.key,g)===0)return c}static h(I,g,l,c){const h=[];let u=I.e;for(let $=I.d-1;$>=0;$--){for(;u.forward[$]&&c(u.forward[$].key,g)<0;)u=u.forward[$];h[$]=u}if(u=u.forward[0],u&&c(u.key,g)===0)return u.value=l,!1;{const $=O.j(I);if($>I.d){for(let p=I.d;p<$;p++)h[p]=I.e;I.d=$}u=new P($,g,l);for(let p=0;p<$;p++)u.forward[p]=h[p].forward[p],h[p].forward[p]=u;return!0}}static j(I,g=.5){let l=1;for(;Math.random()<g&&l<I.c;)l+=1;return l}static k(I,g,l){const c=[];let h=I.e;for(let u=I.d-1;u>=0;u--){for(;h.forward[u]&&l(h.forward[u].key,g)<0;)h=h.forward[u];c[u]=h}if(h=h.forward[0],!h||l(h.key,g)!==0)return!1;for(let u=0;u<I.d&&c[u].forward[u]===h;u++)c[u].forward[u]=h.forward[u];for(;I.d>0&&I.e.forward[I.d-1]===w;)I.d-=1;return!0}}t.$Qs=O}),define(oe[47],ae([0,1,9,2]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=w,t.$Ae=O,t.$Be=A,t.$Ce=I,t.$De=l,t.$Ee=c,t.$Fe=h,t.$Ge=u,t.$He=$,t.$Ie=p,t.$Je=R,t.$Ke=v,t.$Le=d,t.$Me=m,t.$Ne=k;function w(y){const e=y;return e?typeof e.read=="function":!1}function O(y){const e=y;return e?[e.on,e.pause,e.resume,e.destroy].every(a=>typeof a=="function"):!1}function A(y){const e=y;return e?O(e.stream)&&Array.isArray(e.buffer)&&typeof e.ended=="boolean":!1}function I(y,e){return new g(y,e)}class g{constructor(e,a){this.e=e,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(e){if(!this.a.destroyed){if(this.a.flowing)this.g(e);else if(this.b.data.push(e),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(e){this.a.destroyed||(this.a.flowing?this.h(e):this.b.error.push(e))}end(e){this.a.destroyed||(typeof e<"u"&&this.write(e),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(e){this.c.data.slice(0).forEach(a=>a(e))}h(e){this.c.error.length===0?(0,E.$3)(e):this.c.error.slice(0).forEach(a=>a(e))}i(){this.c.end.slice(0).forEach(e=>e())}on(e,a){if(!this.a.destroyed)switch(e){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(e,a){if(this.a.destroyed)return;let n;switch(e){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(a);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const e=this.e(this.b.data);this.g(e),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const e of this.b.error)this.h(e);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(y,e){const a=[];let n;for(;(n=y.read())!==null;)a.push(n);return e(a)}function c(y,e,a){const n=[];let r;for(;(r=y.read())!==null&&n.length<a;)n.push(r);return r===null&&n.length>0?e(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return y.read()}}}function h(y,e){return new Promise((a,n)=>{const r=[];u(y,{onData:i=>{e&&r.push(i)},onError:i=>{e?n(i):a(void 0)},onEnd:()=>{a(e?e(r):void 0)}})})}function u(y,e,a){y.on("error",n=>{a?.isCancellationRequested||e.onError(n)}),y.on("end",()=>{a?.isCancellationRequested||e.onEnd()}),y.on("data",n=>{a?.isCancellationRequested||e.onData(n)})}function $(y,e){return new Promise((a,n)=>{const r=new P.$Vc,i=[],s=b=>{if(i.push(b),i.length>e)return r.dispose(),y.pause(),a({stream:y,buffer:i,ended:!1})},o=b=>(r.dispose(),n(b)),f=()=>(r.dispose(),a({stream:y,buffer:i,ended:!0}));r.add((0,P.$Uc)(()=>y.removeListener("error",o))),y.on("error",o),r.add((0,P.$Uc)(()=>y.removeListener("end",f))),y.on("end",f),r.add((0,P.$Uc)(()=>y.removeListener("data",s))),y.on("data",s)})}function p(y,e){const a=I(e);return a.end(y),a}function R(){const y=I(()=>{throw new Error("not supported")});return y.end(),y}function v(y){let e=!1;return{read:()=>e?null:(e=!0,y)}}function d(y,e,a){const n=I(a);return u(y,{onData:r=>n.write(e.data(r)),onError:r=>n.error(e.error?e.error(r):r),onEnd:()=>n.end()}),n}function m(y,e,a){let n=!1;return{read:()=>{const r=e.read();return n?r:(n=!0,r!==null?a([y,r]):y)}}}function k(y,e,a){let n=!1;const r=I(a);return u(e,{onData:i=>n?r.write(i):(n=!0,r.write(a([y,i]))),onError:i=>r.error(i),onEnd:()=>{n||(n=!0,r.write(y)),r.end()}}),r}});var We=this&&this.__createBinding||(Object.create?function(H,t,E,P){P===void 0&&(P=E);var w=Object.getOwnPropertyDescriptor(t,E);(!w||("get"in w?!t.__esModule:w.writable||w.configurable))&&(w={enumerable:!0,get:function(){return t[E]}}),Object.defineProperty(H,P,w)}:function(H,t,E,P){P===void 0&&(P=E),H[P]=t[E]}),xe=this&&this.__setModuleDefault||(Object.create?function(H,t){Object.defineProperty(H,"default",{enumerable:!0,value:t})}:function(H,t){H.default=t}),be=this&&this.__importStar||function(H){if(H&&H.__esModule)return H;var t={};if(H!=null)for(var E in H)E!=="default"&&Object.prototype.hasOwnProperty.call(H,E)&&We(t,H,E);return xe(t,H),t};define(oe[14],ae([0,1,171,47]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oe=void 0,t.$Pe=l,t.$Qe=c,t.$Re=h,t.$Se=u,t.$Te=$,t.$Ue=p,t.$Ve=R,t.$We=v,t.$Xe=d,t.$Ye=m,t.$Ze=k,t.$1e=y,t.$2e=e,t.$3e=a,t.$4e=n,t.$5e=r,t.$6e=i,t.$7e=s,t.$8e=o,t.$9e=D,P=be(P);const w=typeof Buffer<"u",O=new E.$X(()=>new Uint8Array(256));let A,I;class g{static alloc(N){return w?new g(Buffer.allocUnsafe(N)):new g(new Uint8Array(N))}static wrap(N){return w&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new g(N)}static fromString(N,C){return!(C?.dontUseNodeBuffer||!1)&&w?new g(Buffer.from(N)):(A||(A=new TextEncoder),new g(A.encode(N)))}static fromByteArray(N){const C=g.alloc(N.length);for(let z=0,X=N.length;z<X;z++)C.buffer[z]=N[z];return C}static concat(N,C){if(typeof C>"u"){C=0;for(let Y=0,se=N.length;Y<se;Y++)C+=N[Y].byteLength}const z=g.alloc(C);let X=0;for(let Y=0,se=N.length;Y<se;Y++){const le=N[Y];z.set(le,X),X+=le.byteLength}return z}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=g.alloc(this.byteLength);return N.set(this),N}toString(){return w?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(N,C){return new g(this.buffer.subarray(N,C))}set(N,C){if(N instanceof g)this.buffer.set(N.buffer,C);else if(N instanceof Uint8Array)this.buffer.set(N,C);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),C);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return u(this.buffer,N)}writeUInt32BE(N,C){$(this.buffer,N,C)}readUInt32LE(N){return p(this.buffer,N)}writeUInt32LE(N,C){R(this.buffer,N,C)}readUInt8(N){return v(this.buffer,N)}writeUInt8(N,C){d(this.buffer,N,C)}indexOf(N,C=0){return l(this.buffer,N instanceof g?N.buffer:N,C)}}t.$Oe=g;function l(T,N,C=0){const z=N.byteLength,X=T.byteLength;if(z===0)return 0;if(z===1)return T.indexOf(N[0]);if(z>X-C)return-1;const Y=O.value;Y.fill(N.length);for(let fe=0;fe<N.length;fe++)Y[N[fe]]=N.length-fe-1;let se=C+N.length-1,le=se,ue=-1;for(;se<X;)if(T[se]===N[le]){if(le===0){ue=se;break}se--,le--}else se+=Math.max(N.length-le,Y[T[se]]),le=N.length-1;return ue}function c(T,N){return T[N+0]<<0>>>0|T[N+1]<<8>>>0}function h(T,N,C){T[C+0]=N&255,N=N>>>8,T[C+1]=N&255}function u(T,N){return T[N]*2**24+T[N+1]*2**16+T[N+2]*2**8+T[N+3]}function $(T,N,C){T[C+3]=N,N=N>>>8,T[C+2]=N,N=N>>>8,T[C+1]=N,N=N>>>8,T[C]=N}function p(T,N){return T[N+0]<<0>>>0|T[N+1]<<8>>>0|T[N+2]<<16>>>0|T[N+3]<<24>>>0}function R(T,N,C){T[C+0]=N&255,N=N>>>8,T[C+1]=N&255,N=N>>>8,T[C+2]=N&255,N=N>>>8,T[C+3]=N&255}function v(T,N){return T[N]}function d(T,N,C){T[C]=N}function m(T){return P.$De(T,N=>g.concat(N))}function k(T){return P.$Ke(T)}function y(T){return P.$Fe(T,N=>g.concat(N))}async function e(T){return T.ended?g.concat(T.buffer):g.concat([...T.buffer,await y(T.stream)])}function a(T){return P.$Ie(T,N=>g.concat(N))}function n(T){return P.$Le(T,{data:N=>typeof N=="string"?g.fromString(N):g.wrap(N)},N=>g.concat(N))}function r(T){return P.$Ce(N=>g.concat(N),T)}function i(T,N){return P.$Me(T,N,C=>g.concat(C))}function s(T,N){return P.$Ne(T,N,C=>g.concat(C))}function o(T){let N=0,C=0,z=0;const X=new Uint8Array(Math.floor(T.length/4*3)),Y=le=>{switch(C){case 3:X[z++]=N|le,C=0;break;case 2:X[z++]=N|le>>>2,N=le<<6,C=3;break;case 1:X[z++]=N|le>>>4,N=le<<4,C=2;break;default:N=le<<2,C=1}};for(let le=0;le<T.length;le++){const ue=T.charCodeAt(le);if(ue>=65&&ue<=90)Y(ue-65);else if(ue>=97&&ue<=122)Y(ue-97+26);else if(ue>=48&&ue<=57)Y(ue-48+52);else if(ue===43||ue===45)Y(62);else if(ue===47||ue===95)Y(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${T[le]}`)}}const se=z;for(;C>0;)Y(0);return g.wrap(X).slice(0,se)}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:T},N=!0,C=!1){const z=C?b:f;let X="";const Y=T.byteLength%3;let se=0;for(;se<T.byteLength-Y;se+=3){const le=T[se+0],ue=T[se+1],fe=T[se+2];X+=z[le>>>2],X+=z[(le<<4|ue>>>4)&63],X+=z[(ue<<2|fe>>>6)&63],X+=z[fe&63]}if(Y===1){const le=T[se+0];X+=z[le>>>2],X+=z[le<<4&63],N&&(X+="==")}else if(Y===2){const le=T[se+0],ue=T[se+1];X+=z[le>>>2],X+=z[(le<<4|ue>>>4)&63],X+=z[ue<<2&63],N&&(X+="=")}return X}}),define(oe[28],ae([0,1,3]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$do=P,t.$eo=w,t.$fo=A,t.$go=g,t.$ho=l,t.$io=c,t.$jo=h,t.$ko=u,t.$lo=$,t.$mo=p,t.$no=R,t.$oo=v,t.$po=d;function P(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const k=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([y,e])=>{k[y]=e&&typeof e=="object"?P(e):e}),k}function w(m){if(!m||typeof m!="object")return m;const k=[m];for(;k.length>0;){const y=k.shift();Object.freeze(y);for(const e in y)if(O.call(y,e)){const a=y[e];typeof a=="object"&&!Object.isFrozen(a)&&!(0,E.$ig)(a)&&k.push(a)}}return m}const O=Object.prototype.hasOwnProperty;function A(m,k){return I(m,k,new Set)}function I(m,k,y){if((0,E.$og)(m))return m;const e=k(m);if(typeof e<"u")return e;if(Array.isArray(m)){const a=[];for(const n of m)a.push(I(n,k,y));return a}if((0,E.$hg)(m)){if(y.has(m))throw new Error("Cannot clone recursive data-structure");y.add(m);const a={};for(const n in m)O.call(m,n)&&(a[n]=I(m[n],k,y));return y.delete(m),a}return m}function g(m,k,y=!0){return(0,E.$hg)(m)?((0,E.$hg)(k)&&Object.keys(k).forEach(e=>{e in m?y&&((0,E.$hg)(m[e])&&(0,E.$hg)(k[e])?g(m[e],k[e],y):m[e]=k[e]):m[e]=k[e]}),m):k}function l(m,k){if(m===k)return!0;if(m==null||k===null||k===void 0||typeof m!=typeof k||typeof m!="object"||Array.isArray(m)!==Array.isArray(k))return!1;let y,e;if(Array.isArray(m)){if(m.length!==k.length)return!1;for(y=0;y<m.length;y++)if(!l(m[y],k[y]))return!1}else{const a=[];for(e in m)a.push(e);a.sort();const n=[];for(e in k)n.push(e);if(n.sort(),!l(a,n))return!1;for(y=0;y<a.length;y++)if(!l(m[a[y]],k[a[y]]))return!1}return!0}function c(m){const k=new Set;return JSON.stringify(m,(y,e)=>{if((0,E.$hg)(e)||Array.isArray(e)){if(k.has(e))return"[Circular]";k.add(e)}return typeof e=="bigint"?`[BigInt ${e.toString()}]`:e})}function h(m,k){const y=Object.create(null);return!m||!k||Object.keys(k).forEach(a=>{const n=m[a],r=k[a];l(n,r)||(y[a]=r)}),y}function u(m,k){const y=k.toLowerCase(),e=Object.keys(m).find(a=>a.toLowerCase()===y);return e?m[e]:m[k]}function $(m,k){const y=Object.create(null);for(const[e,a]of Object.entries(m))k(e,a)&&(y[e]=a);return y}function p(m){let k=[];for(;Object.prototype!==m;)k=k.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return k}function R(m){const k=[];for(const y of p(m))typeof m[y]=="function"&&k.push(y);return k}function v(m,k){const y=a=>function(){const n=Array.prototype.slice.call(arguments,0);return k(a,n)},e={};for(const a of m)e[a]=y(a);return e}function d(m,k){const y={};for(const[e,a]of Object.entries(m))y[e]=k(a,e);return y}}),define(oe[43],ae([0,1,32]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zj=t.$xj=void 0,t.$tj=P,t.$uj=w,t.$vj=O,t.$wj=I,t.$yj=R,E=be(E);function P(d){return w(d,0)}function w(d,m){switch(typeof d){case"object":return d===null?O(349,m):Array.isArray(d)?g(d,m):l(d,m);case"string":return I(d,m);case"boolean":return A(d,m);case"number":return O(d,m);case"undefined":return O(937,m);default:return O(617,m)}}function O(d,m){return(m<<5)-m+d|0}function A(d,m){return O(d?433:863,m)}function I(d,m){m=O(149417,m);for(let k=0,y=d.length;k<y;k++)m=O(d.charCodeAt(k),m);return m}function g(d,m){return m=O(104579,m),d.reduce((k,y)=>w(y,k),m)}function l(d,m){return m=O(181387,m),Object.keys(d).sort().reduce((k,y)=>(k=I(y,k),w(d[y],k)),m)}class c{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=w(m,this.g),this.g}}t.$xj=c;var h;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(h||(h={}));function u(d,m,k=32){const y=k-m,e=~((1<<y)-1);return(d<<m|(e&d)>>>y)>>>0}function $(d,m=0,k=d.byteLength,y=0){for(let e=0;e<k;e++)d[m+e]=y}function p(d,m,k="0"){for(;d.length<m;)d=k+d;return d}function R(d,m=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(k=>k.toString(16).padStart(2,"0")).join(""):p((d>>>0).toString(16),m/4)}class v{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(h.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const k=m.length;if(k===0)return;const y=this.p;let e=this.r,a=this.u,n,r;for(a!==0?(n=a,r=-1,a=0):(n=m.charCodeAt(0),r=0);;){let i=n;if(E.$Kf(n))if(r+1<k){const s=m.charCodeAt(r+1);E.$Lf(s)?(r++,i=E.$Mf(n,s)):i=h.UNICODE_REPLACEMENT}else{a=n;break}else E.$Lf(n)&&(i=h.UNICODE_REPLACEMENT);if(e=this.w(y,e,i),r++,r<k)n=m.charCodeAt(r);else break}this.r=e,this.u=a}w(m,k,y){return y<128?m[k++]=y:y<2048?(m[k++]=192|(y&1984)>>>6,m[k++]=128|(y&63)>>>0):y<65536?(m[k++]=224|(y&61440)>>>12,m[k++]=128|(y&4032)>>>6,m[k++]=128|(y&63)>>>0):(m[k++]=240|(y&1835008)>>>18,m[k++]=128|(y&258048)>>>12,m[k++]=128|(y&4032)>>>6,m[k++]=128|(y&63)>>>0),k>=h.BLOCK_SIZE&&(this.y(),k-=h.BLOCK_SIZE,this.t+=h.BLOCK_SIZE,m[0]=m[h.BLOCK_SIZE+0],m[1]=m[h.BLOCK_SIZE+1],m[2]=m[h.BLOCK_SIZE+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,h.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),R(this.h)+R(this.l)+R(this.m)+R(this.n)+R(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=v.g,k=this.q;for(let f=0;f<64;f+=4)m.setUint32(f,k.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)m.setUint32(f,u(m.getUint32(f-12,!1)^m.getUint32(f-32,!1)^m.getUint32(f-56,!1)^m.getUint32(f-64,!1),1),!1);let y=this.h,e=this.l,a=this.m,n=this.n,r=this.o,i,s,o;for(let f=0;f<80;f++)f<20?(i=e&a|~e&n,s=1518500249):f<40?(i=e^a^n,s=1859775393):f<60?(i=e&a|e&n|a&n,s=2400959708):(i=e^a^n,s=3395469782),o=u(y,5)+i+r+s+m.getUint32(f*4,!1)&4294967295,r=n,n=a,a=u(e,30),e=y,y=o;this.h=this.h+y&4294967295,this.l=this.l+e&4294967295,this.m=this.m+a&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}t.$zj=v}),define(oe[56],ae([0,1,32]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),E=be(E);var P;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(P||(P={})),function(w){const O="error",A="warning",I="warn",g="info",l="ignore";function c(u){return u?E.$Gf(O,u)?w.Error:E.$Gf(A,u)||E.$Gf(I,u)?w.Warning:E.$Gf(g,u)?w.Info:w.Ignore:w.Ignore}w.fromValue=c;function h(u){switch(u){case w.Error:return O;case w.Warning:return A;case w.Info:return g;default:return l}}w.toString=h}(P||(P={})),t.default=P}),define(oe[29],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2g=void 0,t.$1g=P;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(w){return E.test(w)}t.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(I){for(let g=0;g<I.length;g++)I[g]=Math.floor(Math.random()*256);return I};const O=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){w(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let g=0,l="";return l+=A[O[g++]],l+=A[O[g++]],l+=A[O[g++]],l+=A[O[g++]],l+="-",l+=A[O[g++]],l+=A[O[g++]],l+="-",l+=A[O[g++]],l+=A[O[g++]],l+="-",l+=A[O[g++]],l+=A[O[g++]],l+="-",l+=A[O[g++]],l+=A[O[g++]],l+=A[O[g++]],l+=A[O[g++]],l+=A[O[g++]],l+=A[O[g++]],l}}()}),define(oe[80],ae([0,1,35]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qn=O;const P=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function w(A){const I=A.replace(/\-/g,":").toLowerCase();return!P.has(I)}function O(){const A=(0,E.networkInterfaces)();for(const I in A){const g=A[I];if(g){for(const{mac:l}of g)if(w(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(oe[81],ae([7,4]),function(H,t){return H.create("vs/base/common/date",t)}),define(oe[82],ae([0,1,81]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1m=l,t.$2m=c,t.$3m=h;const P=60,w=P*60,O=w*24,A=O*7,I=O*30,g=O*365;function l(u,$,p,R){typeof u!="number"&&(u=u.getTime());const v=Math.round((new Date().getTime()-u)/1e3);if(v<-30)return(0,E.localize)(0,null,l(new Date().getTime()+v*1e3,!1));if(!R&&v<30)return(0,E.localize)(1,null);let d;return v<P?(d=v,$?d===1?p?(0,E.localize)(2,null,d):(0,E.localize)(3,null,d):p?(0,E.localize)(4,null,d):(0,E.localize)(5,null,d):d===1?p?(0,E.localize)(6,null,d):(0,E.localize)(7,null,d):p?(0,E.localize)(8,null,d):(0,E.localize)(9,null,d)):v<w?(d=Math.floor(v/P),$?d===1?p?(0,E.localize)(10,null,d):(0,E.localize)(11,null,d):p?(0,E.localize)(12,null,d):(0,E.localize)(13,null,d):d===1?p?(0,E.localize)(14,null,d):(0,E.localize)(15,null,d):p?(0,E.localize)(16,null,d):(0,E.localize)(17,null,d)):v<O?(d=Math.floor(v/w),$?d===1?p?(0,E.localize)(18,null,d):(0,E.localize)(19,null,d):p?(0,E.localize)(20,null,d):(0,E.localize)(21,null,d):d===1?p?(0,E.localize)(22,null,d):(0,E.localize)(23,null,d):p?(0,E.localize)(24,null,d):(0,E.localize)(25,null,d)):v<A?(d=Math.floor(v/O),$?d===1?(0,E.localize)(26,null,d):(0,E.localize)(27,null,d):d===1?(0,E.localize)(28,null,d):(0,E.localize)(29,null,d)):v<I?(d=Math.floor(v/A),$?d===1?p?(0,E.localize)(30,null,d):(0,E.localize)(31,null,d):p?(0,E.localize)(32,null,d):(0,E.localize)(33,null,d):d===1?p?(0,E.localize)(34,null,d):(0,E.localize)(35,null,d):p?(0,E.localize)(36,null,d):(0,E.localize)(37,null,d)):v<g?(d=Math.floor(v/I),$?d===1?p?(0,E.localize)(38,null,d):(0,E.localize)(39,null,d):p?(0,E.localize)(40,null,d):(0,E.localize)(41,null,d):d===1?p?(0,E.localize)(42,null,d):(0,E.localize)(43,null,d):p?(0,E.localize)(44,null,d):(0,E.localize)(45,null,d)):(d=Math.floor(v/g),$?d===1?p?(0,E.localize)(46,null,d):(0,E.localize)(47,null,d):p?(0,E.localize)(48,null,d):(0,E.localize)(49,null,d):d===1?p?(0,E.localize)(50,null,d):(0,E.localize)(51,null,d):p?(0,E.localize)(52,null,d):(0,E.localize)(53,null,d))}function c(u,$){const p=Math.abs(u/1e3);return p<1?$?(0,E.localize)(54,null,u):(0,E.localize)(55,null,u):p<P?$?(0,E.localize)(56,null,Math.round(u)/1e3):(0,E.localize)(57,null,Math.round(u)/1e3):p<w?$?(0,E.localize)(58,null,Math.round(u/(1e3*P))):(0,E.localize)(59,null,Math.round(u/(1e3*P))):p<O?$?(0,E.localize)(60,null,Math.round(u/(1e3*w))):(0,E.localize)(61,null,Math.round(u/(1e3*w))):(0,E.localize)(62,null,Math.round(u/(1e3*O)))}function h(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(oe[83],ae([7,4]),function(H,t){return H.create("vs/base/common/errorMessage",t)}),define(oe[38],ae([0,1,20,3,83]),function(H,t,E,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qj=g,t.$rj=l,t.$sj=c,E=be(E),P=be(P),w=be(w);function O(h,u){return u&&(h.stack||h.stacktrace)?w.localize(0,null,I(h),A(h.stack)||A(h.stacktrace)):I(h)}function A(h){return Array.isArray(h)?h.join(`
`):h}function I(h){return h.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?w.localize(1,null,h.message):h.message||w.localize(2,null)}function g(h=null,u=!1){if(!h)return w.localize(3,null);if(Array.isArray(h)){const $=E.$Jb(h),p=g($[0],u);return $.length>1?w.localize(4,null,p,$.length):p}if(P.$fg(h))return h;if(h.detail){const $=h.detail;if($.error)return O($.error,u);if($.exception)return O($.exception,u)}return h.stack?O(h,u):h.message?h.message:w.localize(5,null)}function l(h){const u=h;return u instanceof Error&&Array.isArray(u.actions)}function c(h,u){let $;return typeof h=="string"?$=new Error(h):$=h,$.actions=u,$}}),define(oe[84],ae([7,4]),function(H,t){return H.create("vs/base/common/jsonErrorMessages",t)}),define(oe[85],ae([0,1,84,34]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Iq=w;function w(O){switch(O){case P.ParseErrorCode.InvalidSymbol:return(0,E.localize)(0,null);case P.ParseErrorCode.InvalidNumberFormat:return(0,E.localize)(1,null);case P.ParseErrorCode.PropertyNameExpected:return(0,E.localize)(2,null);case P.ParseErrorCode.ValueExpected:return(0,E.localize)(3,null);case P.ParseErrorCode.ColonExpected:return(0,E.localize)(4,null);case P.ParseErrorCode.CommaExpected:return(0,E.localize)(5,null);case P.ParseErrorCode.CloseBraceExpected:return(0,E.localize)(6,null);case P.ParseErrorCode.CloseBracketExpected:return(0,E.localize)(7,null);case P.ParseErrorCode.EndOfFileExpected:return(0,E.localize)(8,null);default:return""}}}),define(oe[57],ae([0,1,13]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminateResponseCode=t.Source=void 0,t.$km=O,t.$lm=A;var P;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(P||(t.Source=P={}));var w;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(w||(t.TerminateResponseCode=w={}));function O(I,...g){const l=g.reduce((u,$)=>(u[$]=!0,u),{}),c=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(u=>!l[u]).forEach(u=>{for(let $=0;$<c.length;$++)if(u.search(c[$])!==-1){delete I[u];break}})}function A(I){I&&(delete I.DEBUG,E.$j&&delete I.DYLD_LIBRARY_PATH,E.$k&&delete I.LD_PRELOAD)}}),define(oe[86],ae([0,1,12]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ar=P,t.$br=w,t.$cr=O,t.log=I;function P(l){const c=l;return c&&typeof c.type=="string"&&typeof c.severity=="string"}function w(l){const c=[];let h;try{const u=JSON.parse(l.arguments),$=u[u.length-1];$&&$.__$stack&&(u.pop(),h=$.__$stack),c.push(...u)}catch{c.push("Unable to log remote console arguments",l.arguments)}return{args:c,stack:h}}function O(l){if(typeof l!="string")return O(w(l).stack);const c=l;if(c){const h=A(c),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(h||"");if(u&&u.length===4)return{uri:E.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function A(l){if(!l)return l;const c=l.indexOf(`
`);return c===-1?l:l.substring(0,c)}function I(l,c){const{args:h,stack:u}=w(l),$=typeof h[0]=="string"&&h.length===1;let p=A(u);p&&(p=`(${p.trim()})`);let R=[];if(typeof h[0]=="string"?p&&$?R=[`%c[${c}] %c${h[0]} %c${p}`,g("blue"),g(""),g("grey")]:R=[`%c[${c}] %c${h[0]}`,g("blue"),g(""),...h.slice(1)]:R=[`%c[${c}]%`,g("blue"),...h],p&&!$&&R.push(p),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,R)}function g(l){return`color: ${l}`}}),define(oe[48],ae([0,1,14,12,172]),function(H,t,E,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ai=O,t.$bi=A,t.$ci=g;function O(l){return JSON.stringify(l,I)}function A(l){let c=JSON.parse(l);return c=g(c),c}function I(l,c){return c instanceof RegExp?{$mid:w.MarshalledId.Regexp,source:c.source,flags:c.flags}:c}function g(l,c=0){if(!l||c>200)return l;if(typeof l=="object"){switch(l.$mid){case w.MarshalledId.Uri:return P.URI.revive(l);case w.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case w.MarshalledId.Date:return new Date(l.source)}if(l instanceof E.$Oe||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let h=0;h<l.length;++h)l[h]=g(l[h],c+1);else for(const h in l)Object.hasOwnProperty.call(l,h)&&(l[h]=g(l[h],c+1))}return l}}),define(oe[87],ae([0,1,74,15,13,12]),function(H,t,E,P,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sE=c,w=be(w);class A{constructor(u,$,p){this.id=u,this.dependencies=$,this.callback=p}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,$,p)=>{typeof u!="string"&&(p=$,$=u,u=null),(typeof $!="object"||!Array.isArray($))&&(p=$,$=null),this.c.push(new A(u,$,p))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const $=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!$)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(u){return new Promise(($,p)=>{const R=document.createElement("script");R.setAttribute("async","async"),R.setAttribute("type","text/javascript");const v=()=>{R.removeEventListener("load",d),R.removeEventListener("error",m)},d=k=>{v(),$(this.c.pop())},m=k=>{v(),p(k)};R.addEventListener("load",d),R.addEventListener("error",m),this.f&&(u=this.f.createScriptURL(u)),R.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(R)})}i(u){return new Promise(($,p)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),$(this.c.pop())}catch(R){p(R)}})}async j(u){try{const $=globalThis._VSCODE_NODE_MODULES.fs,p=globalThis._VSCODE_NODE_MODULES.vm,R=globalThis._VSCODE_NODE_MODULES.module,v=O.URI.parse(u).fsPath,d=$.readFileSync(v).toString(),m=R.wrap(d.replace(/^#!.*/,""));return new p.Script(m).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const g=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function c(h,u,$){if(E.$V){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[h]&&(h=l[h]);const p=`${h}/${u}`;if(g.has(p))return g.get(p);let R;if(/^\w[\w\d+.-]*:\/\//.test(p))R=p;else{const k=`${$&&!w.$o?P.$Wg:P.$Vg}/${p}`;R=P.$Zg.asBrowserUri(k).toString(!0)}const v=I.INSTANCE.load(R);return g.set(p,v),v}else return await new Promise((p,R)=>{H([h],p,R)}).then(be)}}),define(oe[88],ae([0,1,35,49,29,80,13]),function(H,t,E,P,w,O,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rn=void 0,t.$Sn=g,t.$Tn=h,t.$Un=u,w=be(w),t.$Rn=new class{c($){return this.a||(this.a=P.$Li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,p=0;const R=(0,E.networkInterfaces)();for(const v in R){const d=R[v];if(d)for(const{mac:m,internal:k}of d)k||(p+=1,this.c(m.toUpperCase())&&($+=1))}this.b=p>0?$/p:0}return this.b}};let I;async function g($){return I||(I=(async()=>await l($)||w.$2g())()),I}async function l($){try{const p=await new Promise((v,d)=>{H(["crypto"],v,d)}).then(be),R=(0,O.$Qn)();return p.createHash("sha256").update(R,"utf8").digest("hex")}catch(p){$(p);return}}const c="Software\\Microsoft\\SQMClient";async function h($){if(A.$i){const p=await new Promise((R,v)=>{H(["@vscode/windows-registry"],R,v)}).then(be);try{return p.GetStringRegKey("HKEY_LOCAL_MACHINE",c,"MachineId")||""}catch(R){return $(R),""}}return""}async function u($){try{return await(await new Promise((v,d)=>{H(["@vscode/deviceid"],v,d)}).then(be)).getDeviceId()}catch(p){return $(p),""}}}),define(oe[89],ae([0,1,35,16,26]),function(H,t,E,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vm=m,t.$wm=k,E=be(E),P=be(P),w=be(w);const O=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var g;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(g||(g={}));let l;switch(process.arch){case"ia32":l=g.x86;break;case"arm":case"arm64":l=g.ARM;break;default:l=g.x64;break}let c;process.env.PROCESSOR_ARCHITEW6432?c=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?g.ARM:g.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?c=g.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?c=g.x86:c=g.x64;class h{constructor(e,a,n){this.exePath=e,this.displayName=a,this.a=n}async exists(){return this.a===void 0&&(this.a=await w.SymlinkSupport.existsFile(this.exePath)),this.a}}function u({useAlternateBitness:y=!1}={}){return y?l===g.x64?process.env["ProgramFiles(x86)"]||null:c===g.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:y=!1,findPreview:e=!1}={}){const a=u({useAlternateBitness:y});if(!a)return null;const n=P.$lc(a,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(n))return null;let r=-1,i=null;for(const f of await w.Promises.readdir(n)){let b=-1;if(e){const T=f.indexOf("-");if(T<0)continue;const N=f.substring(0,T);if(!O.test(N)||f.substring(T+1)!=="preview")continue;b=parseInt(N,10)}else{if(!O.test(f))continue;b=parseInt(f,10)}if(b<=r)continue;const D=P.$lc(n,f,"pwsh.exe");await w.SymlinkSupport.existsFile(D)&&(i=D,r=b)}if(!i)return null;const s=a.includes("x86")?" (x86)":"",o=e?" Preview":"";return new h(i,`PowerShell${o}${s}`,!0)}async function p({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const e=P.$lc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(e))return null;const{pwshMsixDirRegex:a,pwshMsixName:n}=y?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await w.Promises.readdir(e))if(a.test(r)){const i=P.$lc(e,r,"pwsh.exe");return new h(i,n)}return null}function R(){const y=P.$lc(E.homedir(),".dotnet","tools","pwsh.exe");return new h(y,".NET Core PowerShell Global Tool")}function v(){const y=P.$lc(process.env.windir,l===g.x86&&c!==g.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new h(y,"Windows PowerShell",!0)}async function*d(){let y=await $();y&&(yield y),y=await $({useAlternateBitness:!0}),y&&(yield y),y=await p(),y&&(yield y),y=R(),y&&(yield y),y=await $({findPreview:!0}),y&&(yield y),y=await p({findPreview:!0}),y&&(yield y),y=await $({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=v(),y&&(yield y)}async function*m(){for await(const y of d())await y.exists()&&(yield y)}async function k(){for await(const y of m())return y;return null}}),define(oe[58],ae([0,1,16,13,36,57,3,26]),function(H,t,E,P,w,O,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.TerminateResponseCode=t.Source=void 0,t.$xm=g,t.$ym=l,E=be(E),P=be(P),w=be(w),A=be(A),I=be(I),Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function g(h=w.env){return h.comspec||"cmd.exe"}function l(h){let u=[],$=!1;const p=function(R){if($){u.push(R);return}(!h.send(R,d=>{if(d&&console.error(d),$=!1,u.length>0){const m=u.slice(0);u=[],m.forEach(k=>p(k))}})||P.$i)&&($=!0)};return{send:p}}var c;(function(h){async function u($,p,R){if(E.$kc($))return $;if(p===void 0&&(p=w.cwd()),E.$oc($)!=="."||(R===void 0&&A.$fg(w.env.PATH)&&(R=w.env.PATH.split(E.$vc)),R===void 0||R.length===0))return E.$lc(p,$);async function d(m){if(await I.Promises.exists(m)){let k;try{k=await I.Promises.stat(m)}catch(y){y.message.startsWith("EACCES")&&(k=await I.Promises.lstat(m))}return k?!k.isDirectory():!1}return!1}for(const m of R){let k;if(E.$kc(m)?k=E.$lc(m,$):k=E.$lc(p,m,$),await d(k))return k;let y=k+".com";if(await d(y)||(y=k+".exe",await d(y)))return y}return E.$lc(p,$)}h.findExecutable=u})(c||(t.win32=c={}))}),define(oe[90],ae([0,1,35,13,89,58]),function(H,t,E,P,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zm=A,P=be(P),O=be(O);async function A(h,u){return h===P.OperatingSystem.Windows?P.$i?c():O.$xm(u):g(h,u)}let I=null;function g(h,u){if(P.$k&&h===P.OperatingSystem.Macintosh||P.$j&&h===P.OperatingSystem.Linux)return"/bin/bash";if(!I){let $;if(P.$i)$="/bin/bash";else{if($=u.SHELL,!$)try{$=(0,E.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}I=$}return I}let l=null;async function c(){return l||(l=(await(0,w.$wm)()).exePath),l}});var ye=this&&this.__decorate||function(H,t,E,P){var w=arguments.length,O=w<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,E):P,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(H,t,E,P);else for(var I=H.length-1;I>=0;I--)(A=H[I])&&(O=(w<3?A(O):w>3?A(t,E,O):A(t,E))||O);return w>3&&O&&Object.defineProperty(t,E,O),O};define(oe[59],ae([0,1,20,8,14,22,55,9,5,2,48,32,3]),function(H,t,E,P,w,O,A,I,g,l,c,h,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oi=t.ProxyChannel=t.$ni=t.$ki=t.$ji=t.$ii=t.RequestInitiator=t.$hi=t.$ei=t.$di=void 0,t.$fi=o,t.$gi=f,t.$li=z,t.$mi=X,h=be(h);var $;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})($||($={}));function p(V){switch(V){case $.Promise:return"req";case $.PromiseCancel:return"cancel";case $.EventListen:return"subscribe";case $.EventDispose:return"unsubscribe"}}var R;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(R||(R={}));function v(V){switch(V){case R.Initialize:return"init";case R.PromiseSuccess:return"reply:";case R.PromiseError:case R.PromiseErrorObj:return"replyErr:";case R.EventFire:return"event:"}}var d;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(d||(d={}));function m(V){let q=0;for(let G=0;;G+=7){const Z=V.read(1);if(q|=(Z.buffer[0]&127)<<G,!(Z.buffer[0]&128))return q}}const k=r(0);function y(V,q){if(q===0){V.write(k);return}let G=0;for(let te=q;te!==0;te=te>>>7)G++;const Z=w.$Oe.alloc(G);for(let te=0;q!==0;te++)Z.buffer[te]=q&127,q=q>>>7,q>0&&(Z.buffer[te]|=128);V.write(Z)}class e{constructor(q){this.b=q,this.a=0}read(q){const G=this.b.slice(this.a,this.a+q);return this.a+=G.byteLength,G}}t.$di=e;class a{constructor(){this.a=[]}get buffer(){return w.$Oe.concat(this.a)}write(q){this.a.push(q)}}t.$ei=a;var n;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(n||(n={}));function r(V){const q=w.$Oe.alloc(1);return q.writeUInt8(V,0),q}const i={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},s=typeof Buffer<"u";function o(V,q){if(typeof q>"u")V.write(i.Undefined);else if(typeof q=="string"){const G=w.$Oe.fromString(q);V.write(i.String),y(V,G.byteLength),V.write(G)}else if(s&&Buffer.isBuffer(q)){const G=w.$Oe.wrap(q);V.write(i.Buffer),y(V,G.byteLength),V.write(G)}else if(q instanceof w.$Oe)V.write(i.VSBuffer),y(V,q.byteLength),V.write(q);else if(Array.isArray(q)){V.write(i.Array),y(V,q.length);for(const G of q)o(V,G)}else if(typeof q=="number"&&(q|0)===q)V.write(i.Uint),y(V,q);else{const G=w.$Oe.fromString(JSON.stringify(q));V.write(i.Object),y(V,G.byteLength),V.write(G)}}function f(V){switch(V.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return V.read(m(V)).toString();case n.Buffer:return V.read(m(V)).buffer;case n.VSBuffer:return V.read(m(V));case n.Array:{const G=m(V),Z=[];for(let te=0;te<G;te++)Z.push(f(V));return Z}case n.Object:return JSON.parse(V.read(m(V)).toString());case n.Int:return m(V)}}class b{constructor(q,G,Z=null,te=1e3){this.h=q,this.j=G,this.k=Z,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(F=>this.q(F)),this.m({type:R.Initialize})}registerChannel(q,G){this.b.set(q,G),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case R.Initialize:{const G=this.o([q.type]);this.k?.logOutgoing(G,0,D.OtherSide,v(q.type));return}case R.PromiseSuccess:case R.PromiseError:case R.EventFire:case R.PromiseErrorObj:{const G=this.o([q.type,q.id],q.data);this.k?.logOutgoing(G,q.id,D.OtherSide,v(q.type),q.data);return}}}o(q,G=void 0){const Z=new a;return o(Z,q),o(Z,G),this.p(Z.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const G=new e(q),Z=f(G),te=f(G),F=Z[0];switch(F){case $.Promise:return this.k?.logIncoming(q.byteLength,Z[1],D.OtherSide,`${p(F)}: ${Z[2]}.${Z[3]}`,te),this.s({type:F,id:Z[1],channelName:Z[2],name:Z[3],arg:te});case $.EventListen:return this.k?.logIncoming(q.byteLength,Z[1],D.OtherSide,`${p(F)}: ${Z[2]}.${Z[3]}`,te),this.t({type:F,id:Z[1],channelName:Z[2],name:Z[3],arg:te});case $.PromiseCancel:return this.k?.logIncoming(q.byteLength,Z[1],D.OtherSide,`${p(F)}`),this.u({type:F,id:Z[1]});case $.EventDispose:return this.k?.logIncoming(q.byteLength,Z[1],D.OtherSide,`${p(F)}`),this.u({type:F,id:Z[1]})}}s(q){const G=this.b.get(q.channelName);if(!G){this.v(q);return}const Z=new O.$xe;let te;try{te=G.call(this.j,q.name,q.arg,Z.token)}catch(J){te=Promise.reject(J)}const F=q.id;te.then(J=>{this.m({id:F,data:J,type:R.PromiseSuccess})},J=>{J instanceof Error?this.m({id:F,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split(`
`):void 0},type:R.PromiseError}):this.m({id:F,data:J,type:R.PromiseErrorObj})}).finally(()=>{M.dispose(),this.d.delete(q.id)});const M=(0,l.$Uc)(()=>Z.cancel());this.d.set(q.id,M)}t(q){const G=this.b.get(q.channelName);if(!G){this.v(q);return}const Z=q.id,F=G.listen(this.j,q.name,q.arg)(M=>this.m({id:Z,data:M,type:R.EventFire}));this.d.set(q.id,F)}u(q){const G=this.d.get(q.id);G&&(G.dispose(),this.d.delete(q.id))}v(q){let G=this.g.get(q.channelName);G||(G=[],this.g.set(q.channelName,G));const Z=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===$.Promise&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:R.PromiseError})},this.l);G.push({request:q,timeoutTimer:Z})}w(q){const G=this.g.get(q);if(G){for(const Z of G)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case $.Promise:this.s(Z.request);break;case $.EventListen:this.t(Z.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Rc)(this.d.values()),this.d.clear()}}t.$hi=b;var D;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(D||(t.RequestInitiator=D={}));class T{constructor(q,G=null){this.l=q,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=G}getChannel(q){const G=this;return{call(Z,te,F){return G.a?Promise.reject(new I.$7):G.m(q,Z,te,F)},listen(Z,te){return G.a?g.Event.None:G.o(q,Z,te)}}}m(q,G,Z,te=O.CancellationToken.None){const F=this.g++,M=$.Promise,J={id:F,type:M,channelName:q,name:G,arg:Z};if(te.isCancellationRequested)return Promise.reject(new I.$7);let B;return new Promise((U,j)=>{if(te.isCancellationRequested)return j(new I.$7);const L=()=>{const ce=de=>{switch(de.type){case R.PromiseSuccess:this.f.delete(F),U(de.data);break;case R.PromiseError:{this.f.delete(F);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,j(me);break}case R.PromiseErrorObj:this.f.delete(F),j(de.data);break}};this.f.set(F,ce),this.p(J)};let K=null;this.b===d.Idle?L():(K=(0,P.$sh)(ce=>this.u()),K.then(()=>{K=null,L()}));const Q=()=>{K?(K.cancel(),K=null):this.p({id:F,type:$.PromiseCancel}),j(new I.$7)},ne=te.onCancellationRequested(Q);B=(0,l.$Tc)((0,l.$Uc)(Q),ne),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(q,G,Z){const te=this.g++,F=$.EventListen,M={id:te,type:F,channelName:q,name:G,arg:Z};let J=null;const B=new g.$me({onWillAddFirstListener:()=>{J=(0,P.$sh)(U=>this.u()),J.then(()=>{J=null,this.d.add(B),this.p(M)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(B),this.p({id:te,type:$.EventDispose}))}}),S=U=>B.fire(U.data);return this.f.set(te,S),B.event}p(q){switch(q.type){case $.Promise:case $.EventListen:{const G=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(G,q.id,D.LocalSide,`${p(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case $.PromiseCancel:case $.EventDispose:{const G=this.q([q.type,q.id]);this.j?.logOutgoing(G,q.id,D.LocalSide,p(q.type));return}}}q(q,G=void 0){const Z=new a;return o(Z,q),o(Z,G),this.r(Z.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const G=new e(q),Z=f(G),te=f(G),F=Z[0];switch(F){case R.Initialize:return this.j?.logIncoming(q.byteLength,0,D.LocalSide,v(F)),this.t({type:Z[0]});case R.PromiseSuccess:case R.PromiseError:case R.EventFire:case R.PromiseErrorObj:return this.j?.logIncoming(q.byteLength,Z[1],D.LocalSide,v(F),te),this.t({type:Z[0],id:Z[1],data:te})}}t(q){if(q.type===R.Initialize){this.b=d.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Rc)(this.d.values()),this.d.clear()}}t.$ii=T,ye([A.$0h],T.prototype,"onDidInitializePromise",null);class N{get connections(){const q=[];return this.f.forEach(G=>q.push(G)),q}constructor(q,G,Z){this.a=new Map,this.f=new Set,this.g=new g.$me,this.onDidAddConnection=this.g.event,this.h=new g.$me,this.onDidRemoveConnection=this.h.event,this.j=new l.$Vc,this.j.add(q(({protocol:te,onDidClientDisconnect:F})=>{const M=g.Event.once(te.onMessage);this.j.add(M(J=>{const B=new e(J),S=f(B),U=new b(te,S,G,Z),j=new T(te,G);this.a.forEach((K,Q)=>U.registerChannel(Q,K));const L={channelServer:U,channelClient:j,ctx:S};this.f.add(L),this.g.fire(L),this.j.add(F(()=>{U.dispose(),j.dispose(),this.f.delete(L),this.h.fire(L)}))}))}))}getChannel(q,G){const Z=this;return{call(te,F,M){let J;if((0,u.$tg)(G)){const S=(0,E.$5b)(Z.connections.filter(G));J=S?Promise.resolve(S):g.Event.toPromise(g.Event.filter(Z.onDidAddConnection,G))}else J=G.routeCall(Z,te,F);const B=J.then(S=>S.channelClient.getChannel(q));return z(B).call(te,F,M)},listen(te,F){if((0,u.$tg)(G))return Z.k(q,G,te,F);const M=G.routeEvent(Z,te,F).then(J=>J.channelClient.getChannel(q));return z(M).listen(te,F)}}}k(q,G,Z,te){const F=this;let M;const J=new g.$me({onWillAddFirstListener:()=>{M=new l.$Vc;const B=new g.$se,S=new Map,U=L=>{const Q=L.channelClient.getChannel(q).listen(Z,te),ne=B.add(Q);S.set(L,ne)},j=L=>{const K=S.get(L);K&&(K.dispose(),S.delete(L))};F.connections.filter(G).forEach(U),g.Event.filter(F.onDidAddConnection,G)(U,void 0,M),F.onDidRemoveConnection(j,void 0,M),B.event(J.fire,J,M),M.add(B)},onDidRemoveLastListener:()=>{M?.dispose(),M=void 0}});return J.event}registerChannel(q,G){this.a.set(q,G);for(const Z of this.f)Z.channelServer.registerChannel(q,G)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$ji=N;class C{constructor(q,G,Z=null){const te=new a;o(te,G),q.send(te.buffer),this.a=new T(q,Z),this.d=new b(q,G,Z)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,G){this.d.registerChannel(q,G)}dispose(){this.a.dispose(),this.d.dispose()}}t.$ki=C;function z(V){return{call(q,G,Z){return V.then(te=>te.call(q,G,Z))},listen(q,G){const Z=new g.$ve;return V.then(te=>Z.input=te.listen(q,G)),Z.event}}}function X(V){let q=!1;return{call(G,Z,te){return q?V.call(G,Z,te):(0,P.$Gh)(0).then(()=>q=!0).then(()=>V.call(G,Z,te))},listen(G,Z){if(q)return V.listen(G,Z);const te=new g.$ve;return(0,P.$Gh)(0).then(()=>q=!0).then(()=>te.input=V.listen(G,Z)),te.event}}}class Y{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const G of q.connections)if(await Promise.resolve(this.a(G.ctx)))return Promise.resolve(G);return await g.Event.toPromise(q.onDidAddConnection),await this.b(q)}}t.$ni=Y;var se;(function(V){function q(F,M,J){const B=F,S=J&&J.disableMarshalling,U=new Map;for(const j in B)Z(j)&&U.set(j,g.Event.buffer(B[j],!0,void 0,M));return new class{listen(j,L,K){const Q=U.get(L);if(Q)return Q;const ne=B[L];if(typeof ne=="function"){if(te(L))return ne.call(B,K);if(Z(L))return U.set(L,g.Event.buffer(B[L],!0,void 0,M)),U.get(L)}throw new I.$db(`Event not found: ${L}`)}call(j,L,K){const Q=B[L];if(typeof Q=="function"){if(!S&&Array.isArray(K))for(let ce=0;ce<K.length;ce++)K[ce]=(0,c.$ci)(K[ce]);let ne=Q.apply(B,K);return ne instanceof Promise||(ne=Promise.resolve(ne)),ne}throw new I.$db(`Method not found: ${L}`)}}}V.fromService=q;function G(F,M){const J=M&&M.disableMarshalling;return new Proxy({},{get(B,S){if(typeof S=="string")return M?.properties?.has(S)?M.properties.get(S):te(S)?function(U){return F.listen(S,U)}:Z(S)?F.listen(S):async function(...U){let j;M&&!(0,u.$og)(M.context)?j=[M.context,...U]:j=U;const L=await F.call(S,j);return J?L:(0,c.$ci)(L)};throw new I.$db(`Property not found: ${String(S)}`)}})}V.toService=G;function Z(F){return F[0]==="o"&&F[1]==="n"&&h.$Ff(F.charCodeAt(2))}function te(F){return/^onDynamic/.test(F)&&h.$Ff(F.charCodeAt(9))}})(se||(t.ProxyChannel=se={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const q=V.toString();if(q!=="[object Object]")return q}return V}function fe(V){return Array.isArray(V)?V.map(ue):ue(V)}function x(V,q,G,Z,te,F,M){M=fe(M);const J=le[te],B=J[Z%J.length];let S=[`%c[${V}]%c[${String(q).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(F)?(S=S.concat(M),S.push(")")):S.push(M),console.log.apply(console,S)}class _{constructor(q,G){this.d=q,this.f=G,this.a=0,this.b=0}logOutgoing(q,G,Z,te,F){this.b+=q,x(this.d,this.b,q,G,Z,te,F)}logIncoming(q,G,Z,te,F){this.a+=q,x(this.f,this.a,q,G,Z,te,F)}}t.$oi=_}),define(oe[91],ae([0,1,60,8,14,22,86,9,5,2,28,58,57,59]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fr=t.$er=void 0,I=be(I);class p extends $.$hi{constructor(d){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",m=>w.$Oe.wrap(Buffer.from(m,"base64")))},d),process.once("disconnect",()=>this.dispose())}}t.$er=p;class R{constructor(d,m){this.i=d,this.j=m,this.c=new Set,this.g=new Map,this.h=new g.$me,this.onDidProcessExit=this.h.event;const k=m&&m.timeout?m.timeout:6e4;this.b=new P.$Ch(k),this.d=null,this.f=null}getChannel(d){const m=this;return{call(k,y,e){return m.k(d,k,y,e)},listen(k,y){return m.l(d,k,y)}}}k(d,m,k,y=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(I.$8());this.b.cancel();const e=this.n(d),a=(0,P.$sh)(i=>e.call(m,k,i)),n=y.onCancellationRequested(()=>a.cancel()),r=(0,l.$Uc)(()=>a.cancel());return this.c.add(r),a.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),a}l(d,m,k){if(!this.b)return g.Event.None;this.b.cancel();let y;const e=new g.$me({onWillAddFirstListener:()=>{y=this.n(d).listen(m,k)(e.fire,e),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return e.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,c.$do)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,u.$lm)(m.env),this.d=(0,E.fork)(this.i,d,m);const k=new g.$me,e=g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,A.$ar)(o)){(0,A.log)(o,`IPC Library: ${this.j.serverName}`);return}k.fire(w.$Oe.wrap(Buffer.from(o,"base64")))}),a=this.j.useQueue?(0,h.$ym)(this.d):this.d,n=o=>this.d&&this.d.connected&&a.send(o.buffer.toString("base64")),r=k.event,i={send:n,onMessage:r};this.f=new $.$ii(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,f)=>{process.removeListener("exit",s),e.dispose(),this.c.forEach(b=>(0,l.$Rc)(b)),this.c.clear(),o!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+f),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:f})})}return this.f}n(d){let m=this.g.get(d);return m||(m=this.m.getChannel(d),this.g.set(d,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}t.$fr=R}),define(oe[92],ae([0,1,8,5,2,48,3]),function(H,t,E,P,w,O,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cq=t.$bq=t.StorageState=t.StorageHint=void 0,t.$aq=g;var I;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(t.StorageHint=I={}));function g(u){const $=u;return $?.changed instanceof Map||$?.deleted instanceof Set}var l;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(l||(t.StorageState=l={}));class c extends w.$Wc{static{this.a=100}constructor($,p=Object.create(null)){super(),this.r=$,this.s=p,this.b=this.B(new P.$pe),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new E.$Dh(c.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((p,R)=>this.w(R,p)),$.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w($,p){if(this.c===l.Closed)return;let R=!1;(0,A.$og)(p)?R=this.f.delete($):this.f.get($)!==p&&(this.f.set($,p),R=!0),R&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,p){const R=this.f.get($);return(0,A.$og)(R)?p:R}getBoolean($,p){const R=this.get($);return(0,A.$og)(R)?p:R==="true"}getNumber($,p){const R=this.get($);return(0,A.$og)(R)?p:parseInt(R,10)}getObject($,p){const R=this.get($);return(0,A.$og)(R)?p:(0,O.$bi)(R)}async set($,p,R=!1){if(this.c===l.Closed)return;if((0,A.$og)(p))return this.delete($,R);const v=(0,A.$hg)(p)||Array.isArray(p)?(0,O.$ai)(p):String(p);if(this.f.get($)!==v)return this.f.set($,v),this.j.set($,v),this.h.delete($),this.b.fire({key:$,external:R}),this.D()}async delete($,p=!1){if(!(this.c===l.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:p}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===l.Closed||this.m))return this.D($)}async D($){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}t.$bq=c;class h{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((p,R)=>this.a.set(R,p)),$.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}t.$cq=h}),define(oe[93],ae([7,4]),function(H,t){return H.create("vs/base/node/zip",t)}),define(oe[50],ae([0,1,94,8,16,3,26,93]),function(H,t,E,P,w,O,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yq=t.$xq=void 0,t.zip=v,t.$Aq=d,t.$Bq=k,w=be(w),I=be(I),t.$xq="end of central directory record signature not found";const g=new RegExp(t.$xq);class l extends Error{constructor(e,a){let n=a.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=e,this.cause=a}}t.$yq=l;function c(y){const e=y.externalFileAttributes>>16||33188;return[448,56,7].map(a=>e&a).reduce((a,n)=>a+n,e&61440)}function h(y){if(y instanceof l)return y;let e;return g.test(y.message)&&(e="CorruptZip"),new l(e,y)}function u(y,e,a,n,r,i){const s=w.$oc(e),o=w.$lc(n,s);if(!o.startsWith(n))return Promise.reject(new Error(I.localize(0,null,e)));const f=w.$lc(n,e);let b;return i.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((D,T)=>{if(!i.isCancellationRequested)try{b=(0,E.createWriteStream)(f,{mode:a}),b.once("close",()=>D()),b.once("error",T),y.once("error",T),y.pipe(b)}catch(N){T(N)}}))}function $(y,e,a,n){let r=(0,P.$sh)(()=>Promise.resolve()),i=0;const s=n.onCancellationRequested(()=>{r.cancel(),y.close()});return new Promise((o,f)=>{const b=new P.$Ah,D=T=>{T.isCancellationRequested||(i++,y.readEntry())};y.once("error",f),y.once("close",()=>r.then(()=>{n.isCancellationRequested||y.entryCount===i?o():f(new l("Incomplete",new Error(I.localize(1,null,i,y.entryCount))))},f)),y.readEntry(),y.on("entry",T=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(T.fileName)){D(n);return}const N=T.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(N)){const X=w.$lc(e,N);r=(0,P.$sh)(Y=>A.Promises.mkdir(X,{recursive:!0}).then(()=>D(Y)).then(void 0,f));return}const C=R(y,T),z=c(T);r=(0,P.$sh)(X=>b.queue(()=>C.then(Y=>u(Y,N,z,e,a,X).then(()=>D(X)))).then(null,f))})}).finally(()=>s.dispose())}async function p(y,e=!1){const{open:a}=await new Promise((n,r)=>{H(["yauzl"],n,r)}).then(be);return new Promise((n,r)=>{a(y,e?{lazyEntries:!0}:void 0,(i,s)=>{i?r(h(i)):n((0,O.$qg)(s))})})}function R(y,e){return new Promise((a,n)=>{y.openReadStream(e,(r,i)=>{r?n(h(r)):a((0,O.$qg)(i))})})}async function v(y,e){const{ZipFile:a}=await new Promise((n,r)=>{H(["yazl"],n,r)}).then(be);return new Promise((n,r)=>{const i=new a;e.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const s=(0,E.createWriteStream)(y);i.outputStream.pipe(s),i.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(y))})}function d(y,e,a={},n){const r=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let i=p(y,!0);return a.overwrite&&(i=i.then(s=>A.Promises.rm(e).then(()=>s))),i.then(s=>$(s,e,{sourcePathRegex:r},n))}function m(y,e){return p(y).then(a=>new Promise((n,r)=>{a.on("entry",i=>{i.fileName===e&&R(a,i).then(s=>n(s),s=>r(s))}),a.once("close",()=>r(new Error(I.localize(2,null,e))))}))}function k(y,e){return m(y,e).then(a=>new Promise((n,r)=>{const i=[];a.once("error",r),a.on("data",s=>i.push(s)),a.on("end",()=>n(Buffer.concat(i)))}))}}),define(oe[95],ae([7,4]),function(H,t){return H.create("vs/platform/configuration/common/configurationRegistry",t)}),define(oe[96],ae([7,4]),function(H,t){return H.create("vs/platform/contextkey/common/contextkey",t)}),define(oe[97],ae([7,4]),function(H,t){return H.create("vs/platform/contextkey/common/scanner",t)}),define(oe[98],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(oe[99],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(oe[100],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionManagementCLI",t)}),define(oe[101],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionNls",t)}),define(oe[102],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",t)}),define(oe[103],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(oe[104],ae([7,4]),function(H,t){return H.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(oe[105],ae([7,4]),function(H,t){return H.create("vs/platform/extensions/common/extensionValidator",t)}),define(oe[106],ae([7,4]),function(H,t){return H.create("vs/platform/files/common/fileService",t)}),define(oe[107],ae([7,4]),function(H,t){return H.create("vs/platform/files/common/io",t)}),define(oe[108],ae([7,4]),function(H,t){return H.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(oe[109],ae([7,4]),function(H,t){return H.create("vs/platform/languagePacks/common/languagePacks",t)}),define(oe[110],ae([7,4]),function(H,t){return H.create("vs/platform/log/common/log",t)}),define(oe[111],ae([7,4]),function(H,t){return H.create("vs/platform/request/common/request",t)}),define(oe[112],ae([7,4]),function(H,t){return H.create("vs/platform/shell/node/shellEnv",t)}),define(oe[113],ae([7,4]),function(H,t){return H.create("vs/platform/telemetry/common/telemetryService",t)}),define(oe[114],ae([7,4]),function(H,t){return H.create("vs/platform/userDataProfile/common/userDataProfile",t)}),define(oe[115],ae([7,4]),function(H,t){return H.create("vs/platform/workspace/common/workspace",t)}),define(oe[116],ae([0,1,117,9,97]),function(H,t,E,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Aj=t.TokenType=void 0;var O;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(O||(t.TokenType=O={}));function A(...c){switch(c.length){case 1:return(0,w.localize)(0,null,c[0]);case 2:return(0,w.localize)(1,null,c[0],c[1]);case 3:return(0,w.localize)(2,null,c[0],c[1],c[2]);default:return}}const I=(0,w.localize)(3,null),g=(0,w.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return h.isTripleEq?"===":"==";case O.NotEq:return h.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return h.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return h.lexeme;case O.QuotedStr:return h.lexeme;case O.Error:return h.lexeme;case O.EOF:return"EOF";default:throw(0,P.$0)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(h){return this.c=h,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case E.CharCode.OpenParen:this.k(O.LParen);break;case E.CharCode.CloseParen:this.k(O.RParen);break;case E.CharCode.ExclamationMark:if(this.h(E.CharCode.Equals)){const u=this.h(E.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:u})}else this.k(O.Neg);break;case E.CharCode.SingleQuote:this.o();break;case E.CharCode.Slash:this.q();break;case E.CharCode.Equals:if(this.h(E.CharCode.Equals)){const u=this.h(E.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:u})}else this.h(E.CharCode.Tilde)?this.k(O.RegexOp):this.l(A("==","=~"));break;case E.CharCode.LessThan:this.k(this.h(E.CharCode.Equals)?O.LtEq:O.Lt);break;case E.CharCode.GreaterThan:this.k(this.h(E.CharCode.Equals)?O.GtEq:O.Gt);break;case E.CharCode.Ampersand:this.h(E.CharCode.Ampersand)?this.k(O.And):this.l(A("&&"));break;case E.CharCode.Pipe:this.h(E.CharCode.Pipe)?this.k(O.Or):this.l(A("||"));break;case E.CharCode.Space:case E.CharCode.CarriageReturn:case E.CharCode.Tab:case E.CharCode.LineFeed:case E.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(h){return this.r()||this.c.charCodeAt(this.e)!==h?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?E.CharCode.Null:this.c.charCodeAt(this.e)}k(h){this.f.push({type:h,offset:this.d})}l(h){const u=this.d,$=this.c.substring(this.d,this.e),p={type:O.Error,offset:this.d,lexeme:$};this.g.push({offset:u,lexeme:$,additionalInfo:h}),this.f.push(p)}n(){this.m.lastIndex=this.d;const h=this.m.exec(this.c);if(h){this.e=this.d+h[0].length;const u=this.c.substring(this.d,this.e),$=l.b.get(u);$?this.k($):this.f.push({type:O.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==E.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let h=this.e,u=!1,$=!1;for(;;){if(h>=this.c.length){this.e=h,this.l(g);return}const R=this.c.charCodeAt(h);if(u)u=!1;else if(R===E.CharCode.Slash&&!$){h++;break}else R===E.CharCode.OpenSquareBracket?$=!0:R===E.CharCode.Backslash?u=!0:R===E.CharCode.CloseSquareBracket&&($=!1);h++}for(;h<this.c.length&&l.a.has(this.c.charCodeAt(h));)h++;this.e=h;const p=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}t.$Aj=l}),define(oe[118],ae([0,1,82,55,15,16,36,17,12]),function(H,t,E,P,w,O,A,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5m=t.$4m=void 0,t.$6m=c,t.$7m=h,t.$4m=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,O.$oc)(w.$Zg.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,O.$lc)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,I.$gh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:w.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$gh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,E.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$lc)(this.userDataPath,"logs",$)}return g.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$gh)(g.URI.file((0,O.$lc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$gh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$gh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$gh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=A.env.VSCODE_PORTABLE;return $?g.URI.file((0,O.$lc)($,"argv.json")):(0,I.$gh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,O.$lc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,O.$mc)($):(0,O.$jc)((0,O.$lc)(w.$Zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?g.URI.file((0,O.$mc)($)):g.URI.file((0,O.$lc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,O.$mc)($);const p=A.env.VSCODE_EXTENSIONS;if(p)return p;const R=A.env.VSCODE_PORTABLE;return R?(0,O.$lc)(R,"extensions"):(0,I.$gh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(p=>/^[^:/?#]+?:\/\//.test(p)?g.URI.parse(p):g.URI.file((0,O.$jc)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?g.URI.parse($):g.URI.file((0,O.$jc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return c(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!t.$4m.test($))}get extensionLogLevel(){const $=[];for(const p of this.args.log||[]){const R=t.$4m.exec(p);R&&R[1]&&R[2]&&$.push([R[1],R[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,I.$gh)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=A.env.VSCODE_PORTABLE;return $?g.URI.file((0,O.$lc)($,"policy.json")):(0,I.$gh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,p,R){this.a=$,this.b=p,this.c=R,this.editSessionId=this.args.editSessionId}}t.$5m=l,ye([P.$0h],l.prototype,"appRoot",null),ye([P.$0h],l.prototype,"userHome",null),ye([P.$0h],l.prototype,"userDataPath",null),ye([P.$0h],l.prototype,"appSettingsHome",null),ye([P.$0h],l.prototype,"tmpDir",null),ye([P.$0h],l.prototype,"cacheHome",null),ye([P.$0h],l.prototype,"stateResource",null),ye([P.$0h],l.prototype,"userRoamingDataHome",null),ye([P.$0h],l.prototype,"userDataSyncHome",null),ye([P.$0h],l.prototype,"sync",null),ye([P.$0h],l.prototype,"machineSettingsResource",null),ye([P.$0h],l.prototype,"workspaceStorageHome",null),ye([P.$0h],l.prototype,"localHistoryHome",null),ye([P.$0h],l.prototype,"keyboardLayoutResource",null),ye([P.$0h],l.prototype,"argvResource",null),ye([P.$0h],l.prototype,"isExtensionDevelopment",null),ye([P.$0h],l.prototype,"untitledWorkspacesHome",null),ye([P.$0h],l.prototype,"builtinExtensionsPath",null),ye([P.$0h],l.prototype,"extensionsPath",null),ye([P.$0h],l.prototype,"extensionDevelopmentLocationURI",null),ye([P.$0h],l.prototype,"extensionDevelopmentKind",null),ye([P.$0h],l.prototype,"extensionTestsLocationURI",null),ye([P.$0h],l.prototype,"debugExtensionHost",null),ye([P.$0h],l.prototype,"logLevel",null),ye([P.$0h],l.prototype,"extensionLogLevel",null),ye([P.$0h],l.prototype,"serviceMachineIdResource",null),ye([P.$0h],l.prototype,"disableTelemetry",null),ye([P.$0h],l.prototype,"disableWorkspaceTrust",null),ye([P.$0h],l.prototype,"useInMemorySecretStorage",null),ye([P.$0h],l.prototype,"policyFile",null);function c(u,$){return h(u["inspect-extensions"],u["inspect-brk-extensions"],5870,$,u.debugId,u.extensionEnvironment)}function h(u,$,p,R,v,d){const k=Number($||u)||(R?null:p),y=k?!!$:!1;let e;if(d)try{e=JSON.parse(d)}catch{}return{port:k,break:y,debugId:v,env:e}}}),function(){"use strict";function H(t,E,P){function w(A,I){const g=O(A,I),l=[g];return t.isAbsolute(g)||l.unshift(P),t.resolve(...l)}function O(A,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return t.join(g,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return t.join(l,I);const c=A["user-data-dir"];if(c)return c;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const h=process.env.USERPROFILE;if(typeof h!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=t.join(h,"AppData","Roaming")}break;case"darwin":l=t.join(E.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||t.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(l,I)}return{getUserDataPath:w}}if(typeof define=="function")define(oe[119],ae([173,35,36]),function(t,E,P){return H(t,E,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("path"),E=require("os");module.exports=H(t,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[120],ae([0,1,35,118,119]),function(H,t,E,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8m=void 0,t.$9m=A,t.$0m=I;class O extends P.$5m{constructor(l,c){super(l,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,w.getUserDataPath)(l,c.nameShort)},c)}}t.$8m=O;function A(g,l){return(0,P.$7m)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,l,g.extensionEnvironment)}function I(g,l){return(0,P.$7m)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,l,g.extensionEnvironment)}}),define(oe[121],ae([0,1,3,101]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jq=w;function w(A,I,g,l){try{O(A,I,g,l)}catch(c){A.error(c?.message??c)}return I}function O(A,I,g,l){const c=(h,u,$)=>{const p=h[u];if((0,E.$fg)(p)){const R=p,v=R.length;if(v>1&&R[0]==="%"&&R[v-1]==="%"){const d=R.substr(1,v-2);let m=g[d];m===void 0&&l&&(m=l[d]);const k=typeof m=="string"?m:m?.message,y=l?.[d],e=typeof y=="string"?y:y?.message;if(!k){e||A.warn(`[${I.name}]: ${(0,P.localize)(0,null,d)}`);return}if($&&(u==="title"||u==="category")&&e&&e!==k){const a={value:k,original:e};h[u]=a}else h[u]=k}}else if((0,E.$hg)(p))for(const R in p)p.hasOwnProperty(R)&&(R==="commands"?c(p,R,!0):c(p,R,$));else if(Array.isArray(p))for(let R=0;R<p.length;R++)c(p,R,$)};for(const h in I)I.hasOwnProperty(h)&&c(I,h)}}),define(oe[122],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.allApiProposals=void 0;const E={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTools.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts"},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};t.allApiProposals=Object.freeze(E)}),define(oe[51],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ci=void 0;class E{constructor(w,O=[],A=!1){this.ctor=w,this.staticArguments=O,this.supportsDelayedInstantiation=A}}t.$Ci=E}),define(oe[123],ae([0,1,51]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationType=void 0,t.$Os=O,t.$Ps=A;const P=[];var w;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(w||(t.InstantiationType=w={}));function O(I,g,l){g instanceof E.$Ci||(g=new E.$Ci(g,[],!!l)),P.push([I,g])}function A(){return P}}),define(oe[124],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sr=t.$rr=void 0;class E{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}t.$rr=E;class P{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const I=this.lookupOrInsertNode(O),g=this.lookupOrInsertNode(A);I.outgoing.set(g.key,g),g.incoming.set(I.key,I)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const I of this.a.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let I=this.a.get(A);return I||(I=new E(A,O),this.a.set(A,I)),I}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,I]of this.a)O.push(`${A}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const I=new Set([O]),g=this.c(A,I);if(g)return g}}c(O,A){for(const[I,g]of O.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const l=this.c(g,A);if(l)return l;A.delete(I)}}}t.$sr=P}),define(oe[30],ae([0,1,3,12,11]),function(H,t,E,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationTarget=t.$_i=void 0,t.$aj=O,t.$bj=A,t.$cj=g,t.$dj=l,t.$ej=c,t.$fj=h,t.$gj=u,t.$hj=p,t.$ij=R,t.$jj=v,E=be(E),t.$_i=(0,w.$Fi)("configurationService");function O(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof P.URI)}function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof P.URI)}var I;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(I||(t.ConfigurationTarget=I={}));function g(d){switch(d){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function l(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function c(d,m){const k=Object.create(null);for(const y in d)h(k,y,d[y],m);return k}function h(d,m,k,y){const e=m.split("."),a=e.pop();let n=d;for(let r=0;r<e.length;r++){const i=e[r];let s=n[i];switch(typeof s){case"undefined":s=n[i]=Object.create(null);break;case"object":if(s===null){y(`Ignoring ${m} as ${e.slice(0,r+1).join(".")} is null`);return}break;default:y(`Ignoring ${m} as ${e.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[a]=k}catch{y(`Ignoring ${m} as ${e.join(".")} is ${JSON.stringify(n)}`)}else y(`Ignoring ${m} as ${e.join(".")} is ${JSON.stringify(n)}`)}function u(d,m){const k=m.split(".");$(d,k)}function $(d,m){const k=m.shift();if(m.length===0){delete d[k];return}if(Object.keys(d).indexOf(k)!==-1){const y=d[k];typeof y=="object"&&!Array.isArray(y)&&($(y,m),Object.keys(y).length===0&&delete d[k])}}function p(d,m,k){function y(n,r){let i=n;for(const s of r){if(typeof i!="object"||i===null)return;i=i[s]}return i}const e=m.split("."),a=y(d,e);return typeof a>"u"?k:a}function R(d,m,k){Object.keys(m).forEach(y=>{y!=="__proto__"&&(y in d?E.$hg(d[y])&&E.$hg(m[y])?R(d[y],m[y],k):k&&(d[y]=m[y]):d[y]=m[y])})}function v(d){return d.replace(/[\[\]]/g,"")}}),define(oe[125],ae([0,1,117,13,32,116,11,96,9]),function(H,t,E,P,w,O,A,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xj=t.$Wj=t.$Vj=t.$Uj=t.$Tj=t.$Sj=t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Dj=t.$Cj=t.ContextKeyExprType=void 0,t.$Bj=c,t.$Ej=r,t.$Fj=i,t.$Yj=F;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",P.$j),l.set("isLinux",P.$k),l.set("isWindows",P.$i),l.set("isWeb",P.$o),l.set("isMacNative",P.$j&&!P.$o),l.set("isEdge",P.$H),l.set("isFirefox",P.$F),l.set("isChrome",P.$E),l.set("isSafari",P.$G);function c(B,S){if(l.get(B)!==void 0)throw(0,g.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(B,S)}const h=Object.prototype.hasOwnProperty;var u;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(u||(t.ContextKeyExprType=u={}));const $={regexParsingWithErrorRecovery:!0},p=(0,I.localize)(0,null),R=(0,I.localize)(1,null),v=(0,I.localize)(2,null),d=(0,I.localize)(3,null),m=(0,I.localize)(4,null),k=(0,I.localize)(5,null),y=(0,I.localize)(6,null),e=(0,I.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(S=$){this.k=S,this.d=new O.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(S){if(S===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:R});return}this.f=this.d.reset(S).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const j=this.D(),L=j.type===O.TokenType.Str?k:void 0;throw this.h.push({message:m,offset:j.offset,lexeme:O.$Aj.getLexeme(j),additionalInfo:L}),a.c}return U}catch(U){if(U!==a.c)throw U;return}}l(){return this.m()}m(){const S=[this.o()];for(;this.y(O.TokenType.Or);){const U=this.o();S.push(U)}return S.length===1?S[0]:n.or(...S)}o(){const S=[this.s()];for(;this.y(O.TokenType.And);){const U=this.s();S.push(U)}return S.length===1?S[0]:n.and(...S)}s(){if(this.y(O.TokenType.Neg)){const S=this.D();switch(S.type){case O.TokenType.True:return this.z(),o.INSTANCE;case O.TokenType.False:return this.z(),f.INSTANCE;case O.TokenType.LParen:{this.z();const U=this.l();return this.A(O.TokenType.RParen,d),U?.negate()}case O.TokenType.Str:return this.z(),z.create(S.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",S)}}return this.t()}t(){const S=this.D();switch(S.type){case O.TokenType.True:return this.z(),n.true();case O.TokenType.False:return this.z(),n.false();case O.TokenType.LParen:{this.z();const U=this.l();return this.A(O.TokenType.RParen,d),U}case O.TokenType.Str:{const U=S.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const L=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),L.type!==O.TokenType.RegexStr)throw this.B("REGEX",L);const K=L.lexeme,Q=K.lastIndexOf("/"),ne=Q===K.length-1?void 0:this.w(K.substring(Q+1));let ce;try{ce=new RegExp(K.substring(1,Q),ne)}catch{throw this.B("REGEX",L)}return fe.create(U,ce)}switch(L.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const K=[L.lexeme];this.z();let Q=this.D(),ne=0;for(let we=0;we<L.lexeme.length;we++)L.lexeme.charCodeAt(we)===E.CharCode.OpenParen?ne++:L.lexeme.charCodeAt(we)===E.CharCode.CloseParen&&ne--;for(;!this.E()&&Q.type!==O.TokenType.And&&Q.type!==O.TokenType.Or;){switch(Q.type){case O.TokenType.LParen:ne++;break;case O.TokenType.RParen:ne--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let we=0;we<Q.lexeme.length;we++)Q.lexeme.charCodeAt(we)===E.CharCode.OpenParen?ne++:L.lexeme.charCodeAt(we)===E.CharCode.CloseParen&&ne--}if(ne<0)break;K.push(O.$Aj.getLexeme(Q)),this.z(),Q=this.D()}const ce=K.join(""),de=ce.lastIndexOf("/"),me=de===ce.length-1?void 0:this.w(ce.substring(de+1));let $e;try{$e=new RegExp(ce.substring(1,de),me)}catch{throw this.B("REGEX",L)}return n.regex(U,$e)}case O.TokenType.QuotedStr:{const K=L.lexeme;this.z();let Q=null;if(!(0,w.$df)(K)){const ne=K.indexOf("/"),ce=K.lastIndexOf("/");if(ne!==ce&&ne>=0){const de=K.slice(ne+1,ce),me=K[ce+1]==="i"?"i":"";try{Q=new RegExp(de,me)}catch{throw this.B("REGEX",L)}}}if(Q===null)throw this.B("REGEX",L);return fe.create(U,Q)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,v);const L=this.u();return n.notIn(U,L)}switch(this.D().type){case O.TokenType.Eq:{this.z();const L=this.u();if(this.x().type===O.TokenType.QuotedStr)return n.equals(U,L);switch(L){case"true":return n.has(U);case"false":return n.not(U);default:return n.equals(U,L)}}case O.TokenType.NotEq:{this.z();const L=this.u();if(this.x().type===O.TokenType.QuotedStr)return n.notEquals(U,L);switch(L){case"true":return n.not(U);case"false":return n.has(U);default:return n.notEquals(U,L)}}case O.TokenType.Lt:return this.z(),le.create(U,this.u());case O.TokenType.LtEq:return this.z(),ue.create(U,this.u());case O.TokenType.Gt:return this.z(),Y.create(U,this.u());case O.TokenType.GtEq:return this.z(),se.create(U,this.u());case O.TokenType.In:return this.z(),n.in(U,this.u());default:return n.has(U)}}case O.TokenType.EOF:throw this.h.push({message:y,offset:S.offset,lexeme:"",additionalInfo:e}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const S=this.D();switch(S.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),S.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(S){return S.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(S){return this.C(S)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(S,U){if(this.C(S))return this.z();throw this.B(U,this.D())}B(S,U,j){const L=(0,I.localize)(8,null,S,O.$Aj.getLexeme(U)),K=U.offset,Q=O.$Aj.getLexeme(U);return this.h.push({message:L,offset:K,lexeme:Q,additionalInfo:j}),a.c}C(S){return this.D().type===S}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}t.$Cj=a;class n{static false(){return o.INSTANCE}static true(){return f.INSTANCE}static has(S){return b.create(S)}static equals(S,U){return D.create(S,U)}static notEquals(S,U){return C.create(S,U)}static regex(S,U){return fe.create(S,U)}static in(S,U){return T.create(S,U)}static notIn(S,U){return N.create(S,U)}static not(S){return z.create(S)}static and(...S){return V.create(S,null,!0)}static or(...S){return q.create(S,null,!0)}static greater(S,U){return Y.create(S,U)}static greaterEquals(S,U){return se.create(S,U)}static smaller(S,U){return le.create(S,U)}static smallerEquals(S,U){return ue.create(S,U)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(S){return S==null?void 0:this.c.parse(S)}}t.$Dj=n;function r(B){const S=new a({regexParsingWithErrorRecovery:!1});return B.map(U=>(S.parse(U),S.lexingErrors.length>0?S.lexingErrors.map(j=>({errorMessage:j.additionalInfo?(0,I.localize)(9,null,j.additionalInfo):(0,I.localize)(10,null),offset:j.offset,length:j.lexeme.length})):S.parsingErrors.length>0?S.parsingErrors.map(j=>({errorMessage:j.additionalInfo?`${j.message}. ${j.additionalInfo}`:j.message,offset:j.offset,length:j.lexeme.length})):[]))}function i(B,S){const U=B?B.substituteConstants():void 0,j=S?S.substituteConstants():void 0;return!U&&!j?!0:!U||!j?!1:U.equals(j)}function s(B,S){return B.cmp(S)}class o{static{this.INSTANCE=new o}constructor(){this.type=u.False}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!1}serialize(){return"false"}keys(){return[]}map(S){return this}negate(){return f.INSTANCE}}t.$Gj=o;class f{static{this.INSTANCE=new f}constructor(){this.type=u.True}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!0}serialize(){return"true"}keys(){return[]}map(S){return this}negate(){return o.INSTANCE}}t.$Hj=f;class b{static create(S,U=null){const j=l.get(S);return typeof j=="boolean"?j?f.INSTANCE:o.INSTANCE:new b(S,U)}constructor(S,U){this.key=S,this.c=U,this.type=u.Defined}cmp(S){return S.type!==this.type?this.type-S.type:Z(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=l.get(this.key);return typeof S=="boolean"?S?f.INSTANCE:o.INSTANCE:this}evaluate(S){return!!S.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(S){return S.mapDefined(this.key)}negate(){return this.c||(this.c=z.create(this.key,this)),this.c}}t.$Ij=b;class D{static create(S,U,j=null){if(typeof U=="boolean")return U?b.create(S,j):z.create(S,j);const L=l.get(S);return typeof L=="boolean"?U===(L?"true":"false")?f.INSTANCE:o.INSTANCE:new D(S,U,j)}constructor(S,U,j){this.c=S,this.d=U,this.f=j,this.type=u.Equals}cmp(S){return S.type!==this.type?this.type-S.type:te(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){const S=l.get(this.c);if(typeof S=="boolean"){const U=S?"true":"false";return this.d===U?f.INSTANCE:o.INSTANCE}return this}evaluate(S){return S.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(S){return S.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}t.$Jj=D;class T{static create(S,U){return new T(S,U)}constructor(S,U){this.d=S,this.f=U,this.type=u.In,this.c=null}cmp(S){return S.type!==this.type?this.type-S.type:te(this.d,this.f,S.d,S.f)}equals(S){return S.type===this.type?this.d===S.d&&this.f===S.f:!1}substituteConstants(){return this}evaluate(S){const U=S.getValue(this.f),j=S.getValue(this.d);return Array.isArray(U)?U.includes(j):typeof j=="string"&&typeof U=="object"&&U!==null?h.call(U,j):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(S){return S.mapIn(this.d,this.f)}negate(){return this.c||(this.c=N.create(this.d,this.f)),this.c}}t.$Kj=T;class N{static create(S,U){return new N(S,U)}constructor(S,U){this.d=S,this.f=U,this.type=u.NotIn,this.c=T.create(S,U)}cmp(S){return S.type!==this.type?this.type-S.type:this.c.cmp(S.c)}equals(S){return S.type===this.type?this.c.equals(S.c):!1}substituteConstants(){return this}evaluate(S){return!this.c.evaluate(S)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(S){return S.mapNotIn(this.d,this.f)}negate(){return this.c}}t.$Lj=N;class C{static create(S,U,j=null){if(typeof U=="boolean")return U?z.create(S,j):b.create(S,j);const L=l.get(S);return typeof L=="boolean"?U===(L?"true":"false")?o.INSTANCE:f.INSTANCE:new C(S,U,j)}constructor(S,U,j){this.c=S,this.d=U,this.f=j,this.type=u.NotEquals}cmp(S){return S.type!==this.type?this.type-S.type:te(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){const S=l.get(this.c);if(typeof S=="boolean"){const U=S?"true":"false";return this.d===U?o.INSTANCE:f.INSTANCE}return this}evaluate(S){return S.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(S){return S.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}t.$Mj=C;class z{static create(S,U=null){const j=l.get(S);return typeof j=="boolean"?j?o.INSTANCE:f.INSTANCE:new z(S,U)}constructor(S,U){this.c=S,this.d=U,this.type=u.Not}cmp(S){return S.type!==this.type?this.type-S.type:Z(this.c,S.c)}equals(S){return S.type===this.type?this.c===S.c:!1}substituteConstants(){const S=l.get(this.c);return typeof S=="boolean"?S?o.INSTANCE:f.INSTANCE:this}evaluate(S){return!S.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(S){return S.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}t.$Nj=z;function X(B,S){if(typeof B=="string"){const U=parseFloat(B);isNaN(U)||(B=U)}return typeof B=="string"||typeof B=="number"?S(B):o.INSTANCE}class Y{static create(S,U,j=null){return X(U,L=>new Y(S,L,j))}constructor(S,U,j){this.c=S,this.d=U,this.f=j,this.type=u.Greater}cmp(S){return S.type!==this.type?this.type-S.type:te(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(S){return S.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}t.$Oj=Y;class se{static create(S,U,j=null){return X(U,L=>new se(S,L,j))}constructor(S,U,j){this.c=S,this.d=U,this.f=j,this.type=u.GreaterEquals}cmp(S){return S.type!==this.type?this.type-S.type:te(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(S){return S.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}t.$Pj=se;class le{static create(S,U,j=null){return X(U,L=>new le(S,L,j))}constructor(S,U,j){this.c=S,this.d=U,this.f=j,this.type=u.Smaller}cmp(S){return S.type!==this.type?this.type-S.type:te(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(S){return S.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}t.$Qj=le;class ue{static create(S,U,j=null){return X(U,L=>new ue(S,L,j))}constructor(S,U,j){this.c=S,this.d=U,this.f=j,this.type=u.SmallerEquals}cmp(S){return S.type!==this.type?this.type-S.type:te(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(S){return S.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}t.$Rj=ue;class fe{static create(S,U){return new fe(S,U)}constructor(S,U){this.d=S,this.f=U,this.type=u.Regex,this.c=null}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.d<S.d)return-1;if(this.d>S.d)return 1;const U=this.f?this.f.source:"",j=S.f?S.f.source:"";return U<j?-1:U>j?1:0}equals(S){if(S.type===this.type){const U=this.f?this.f.source:"",j=S.f?S.f.source:"";return this.d===S.d&&U===j}return!1}substituteConstants(){return this}evaluate(S){const U=S.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const S=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${S}`}keys(){return[this.d]}map(S){return S.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}t.$Sj=fe;class x{static create(S){return new x(S)}constructor(S){this.c=S,this.type=u.NotRegex}cmp(S){return S.type!==this.type?this.type-S.type:this.c.cmp(S.c)}equals(S){return S.type===this.type?this.c.equals(S.c):!1}substituteConstants(){return this}evaluate(S){return!this.c.evaluate(S)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(S){return new x(this.c.map(S))}negate(){return this.c}}t.$Tj=x;function _(B){let S=null;for(let U=0,j=B.length;U<j;U++){const L=B[U].substituteConstants();if(B[U]!==L&&S===null){S=[];for(let K=0;K<U;K++)S[K]=B[K]}S!==null&&(S[U]=L)}return S===null?B:S}class V{static create(S,U,j){return V.d(S,U,j)}constructor(S,U){this.expr=S,this.c=U,this.type=u.And}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let U=0,j=this.expr.length;U<j;U++){const L=s(this.expr[U],S.expr[U]);if(L!==0)return L}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let U=0,j=this.expr.length;U<j;U++)if(!this.expr[U].equals(S.expr[U]))return!1;return!0}return!1}substituteConstants(){const S=_(this.expr);return S===this.expr?this:V.create(S,this.c,!1)}evaluate(S){for(let U=0,j=this.expr.length;U<j;U++)if(!this.expr[U].evaluate(S))return!1;return!0}static d(S,U,j){const L=[];let K=!1;for(const Q of S)if(Q){if(Q.type===u.True){K=!0;continue}if(Q.type===u.False)return o.INSTANCE;if(Q.type===u.And){L.push(...Q.expr);continue}L.push(Q)}if(L.length===0&&K)return f.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(s);for(let Q=1;Q<L.length;Q++)L[Q-1].equals(L[Q])&&(L.splice(Q,1),Q--);if(L.length===1)return L[0];for(;L.length>1;){const Q=L[L.length-1];if(Q.type!==u.Or)break;L.pop();const ne=L.pop(),ce=L.length===0,de=q.create(Q.expr.map(me=>V.create([me,ne],null,j)),null,ce);de&&(L.push(de),L.sort(s))}if(L.length===1)return L[0];if(j){for(let Q=0;Q<L.length;Q++)for(let ne=Q+1;ne<L.length;ne++)if(L[Q].negate().equals(L[ne]))return o.INSTANCE;if(L.length===1)return L[0]}return new V(L,U)}}serialize(){return this.expr.map(S=>S.serialize()).join(" && ")}keys(){const S=[];for(const U of this.expr)S.push(...U.keys());return S}map(S){return new V(this.expr.map(U=>U.map(S)),null)}negate(){if(!this.c){const S=[];for(const U of this.expr)S.push(U.negate());this.c=q.create(S,this,!0)}return this.c}}t.$Uj=V;class q{static create(S,U,j){return q.d(S,U,j)}constructor(S,U){this.expr=S,this.c=U,this.type=u.Or}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let U=0,j=this.expr.length;U<j;U++){const L=s(this.expr[U],S.expr[U]);if(L!==0)return L}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let U=0,j=this.expr.length;U<j;U++)if(!this.expr[U].equals(S.expr[U]))return!1;return!0}return!1}substituteConstants(){const S=_(this.expr);return S===this.expr?this:q.create(S,this.c,!1)}evaluate(S){for(let U=0,j=this.expr.length;U<j;U++)if(this.expr[U].evaluate(S))return!0;return!1}static d(S,U,j){let L=[],K=!1;if(S){for(let Q=0,ne=S.length;Q<ne;Q++){const ce=S[Q];if(ce){if(ce.type===u.False){K=!0;continue}if(ce.type===u.True)return f.INSTANCE;if(ce.type===u.Or){L=L.concat(ce.expr);continue}L.push(ce)}}if(L.length===0&&K)return o.INSTANCE;L.sort(s)}if(L.length!==0){if(L.length===1)return L[0];for(let Q=1;Q<L.length;Q++)L[Q-1].equals(L[Q])&&(L.splice(Q,1),Q--);if(L.length===1)return L[0];if(j){for(let Q=0;Q<L.length;Q++)for(let ne=Q+1;ne<L.length;ne++)if(L[Q].negate().equals(L[ne]))return f.INSTANCE;if(L.length===1)return L[0]}return new q(L,U)}}serialize(){return this.expr.map(S=>S.serialize()).join(" || ")}keys(){const S=[];for(const U of this.expr)S.push(...U.keys());return S}map(S){return new q(this.expr.map(U=>U.map(S)),null)}negate(){if(!this.c){const S=[];for(const U of this.expr)S.push(U.negate());for(;S.length>1;){const U=S.shift(),j=S.shift(),L=[];for(const K of J(U))for(const Q of J(j))L.push(V.create([K,Q],null,!1));S.unshift(q.create(L,null,!1))}this.c=q.create(S,this,!0)}return this.c}}t.$Vj=q;class G extends b{static{this.d=[]}static all(){return G.d.values()}constructor(S,U,j){super(S,null),this.f=U,typeof j=="object"?G.d.push({...j,key:S}):j!==!0&&G.d.push({key:S,description:j,type:U!=null?typeof U:void 0})}bindTo(S){return S.createKey(this.key,this.f)}getValue(S){return S.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(S){return D.create(this.key,S)}notEqualsTo(S){return C.create(this.key,S)}}t.$Wj=G,t.$Xj=(0,A.$Fi)("contextKeyService");function Z(B,S){return B<S?-1:B>S?1:0}function te(B,S,U,j){return B<U?-1:B>U?1:S<j?-1:S>j?1:0}function F(B,S){if(B.type===u.False||S.type===u.True)return!0;if(B.type===u.Or)return S.type===u.Or?M(B.expr,S.expr):!1;if(S.type===u.Or){for(const U of S.expr)if(F(B,U))return!0;return!1}if(B.type===u.And){if(S.type===u.And)return M(S.expr,B.expr);for(const U of B.expr)if(F(U,S))return!0;return!1}return B.equals(S)}function M(B,S){let U=0,j=0;for(;U<B.length&&j<S.length;){const L=B[U].cmp(S[j]);if(L<0)return!1;L===0&&U++,j++}return U===B.length}function J(B){return B.type===u.Or?B.expr:[B]}}),define(oe[61],ae([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yo=void 0,t.$Yo=(0,E.$Fi)("downloadService")}),define(oe[18],ae([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ni=t.$Mi=void 0,t.$Mi=(0,E.$Fi)("environmentService"),t.$Ni=(0,E.$Gi)(t.$Mi)}),define(oe[62],ae([0,1,14,9,107,10]),function(H,t,E,P,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yq=A;async function A(c,h,u,$,p,R){let v;try{await I(c,h,u,$,p,R)}catch(d){v=d}finally{v&&p.errorTransformer&&(v=p.errorTransformer(v)),typeof v<"u"&&u.error(v),u.end()}}async function I(c,h,u,$,p,R){g(R);const v=await c.open(h,{create:!1});try{g(R);let d=0,m=0,k=p&&typeof p.length=="number"?p.length:void 0,y=E.$Oe.alloc(Math.min(p.bufferSize,typeof k=="number"?k:p.bufferSize)),e=p&&typeof p.position=="number"?p.position:0,a=0;do m=await c.read(v,e,y.buffer,a,y.byteLength-a),e+=m,a+=m,d+=m,typeof k=="number"&&(k-=m),a===y.byteLength&&(await u.write($(y)),y=E.$Oe.alloc(Math.min(p.bufferSize,typeof k=="number"?k:p.bufferSize)),a=0);while(m>0&&(typeof k!="number"||k>0)&&g(R)&&l(d,p));if(a>0){let n=a;typeof k=="number"&&(n=Math.min(a,k)),u.write($(y.slice(0,n)))}}catch(d){throw(0,O.$nl)(d)}finally{await c.close(v)}}function g(c){if(c.isCancellationRequested)throw(0,P.$8)();return!0}function l(c,h){if(typeof h?.limits?.size=="number"&&c>h.limits.size)throw(0,O.$ml)((0,w.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[126],ae([0,1,94,2,52,5,10,12,8]),function(H,t,E,P,w,O,A,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hr=void 0;class l extends P.$Wc{constructor(){super(),this.a=this.B(new O.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new O.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new P.$6c),this.m=new Set,this.n=this.B(new g.$Dh(this.y())),this.r=5007,this.s=new g.$3h,this.R=!1,this.B(this.f(h=>this.t(h)))}t(h){this.u(h)&&this.z(h)}u(h){return(0,w.$1q)(h)}async watch(h){this.s.isSettled||this.s.complete(),this.s=new g.$3h;try{this.h.clear(),this.g.clear();for(const u of h)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(h){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),h?this.y():0)}y(){return 800}isSuspended(h){return typeof h.correlationId!="number"?!1:this.m.has(h.correlationId)?"polling":this.j.has(h.correlationId)}async z(h){if(this.j.has(h.correlationId))return;const u=new P.$Vc;this.j.set(h.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(h,u),this.w(!0))}C(h){this.j.deleteAndDispose(h.correlationId),this.m.delete(h.correlationId),this.w(!1)}D(h,u){this.F(h,u)?(this.P(`reusing an existing recursive watcher to monitor ${h.path}`),this.m.delete(h.correlationId)):(this.G(h,u),this.m.add(h.correlationId))}F(h,u){const $=this.O?.subscribe(h.path,(p,R)=>{u.isDisposed||(p?this.D(h,u):R?.type===A.FileChangeType.ADDED&&this.H(h))});return $?(u.add($),!0):!1}G(h,u){let $=!1;const p=(R,v)=>{if(u.isDisposed)return;const d=this.I(R),m=this.I(v),k=$;$=d,!d&&(m||k)&&this.H(h)};this.P(`starting fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,E.watchFile)(h.path,{persistent:!1,interval:this.r},p)}catch(R){this.Q(`fs.watchFile() failed with error ${R} on path ${h.path} (correlationId: ${h.correlationId})`)}u.add((0,P.$Uc)(()=>{this.P(`stopping fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,E.unwatchFile)(h.path,p)}catch(R){this.Q(`fs.unwatchFile() failed with error ${R} on path ${h.path} (correlationId: ${h.correlationId})`)}}))}H(h){this.P(`detected ${h.path} exists again, resuming watcher (correlationId: ${h.correlationId})`);const u={resource:I.URI.file(h.path),type:A.FileChangeType.ADDED,cId:h.correlationId};this.a.fire([u]),this.J(u,h),this.C(h)}I(h){return h.ctimeMs===0&&h.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(h,u){if(this.R){const $=` >> normalized ${h.type===A.FileChangeType.ADDED?"[ADDED]":h.type===A.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`;this.L($,u)}}L(h,u){this.R&&this.P(`${h}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(h){return`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, filter: ${(0,w.$$q)(h.filter)}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`}async setVerboseLogging(h){this.R=h}}t.$hr=l}),define(oe[127],ae([0,1,5,174,126,13,175,63]),function(H,t,E,P,w,O,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$or=void 0;class g extends w.$hr{constructor(c){super(),this.O=c,this.onDidError=E.Event.None,this.watchers=new Set}async N(c){c=this.Z(c);const h=[],u=new Set(Array.from(this.watchers));for(const $ of c){const p=this.W($);p&&(0,P.$Dk)(p.request.excludes,$.excludes)&&(0,P.$Dk)(p.request.includes,$.includes)?u.delete(p):h.push($)}h.length&&this.P(`Request to start watching: ${h.map($=>this.M($)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map($=>this.M($.request)).join(",")}`);for(const $ of u)this.Y($);for(const $ of h)this.X($)}W(c){for(const h of this.watchers)if(typeof c.correlationId=="number"||typeof h.request.correlationId=="number"){if(h.request.correlationId===c.correlationId)return h}else if((0,I.$Dg)(h.request.path,c.path,!O.$k))return h}X(c){const h=new A.$mr(c,this.O,$=>this.a.fire($),()=>this.c.fire(c),$=>this.b.fire($),this.R),u={request:c,instance:h};this.watchers.add(u)}async stop(){await super.stop();for(const c of this.watchers)this.Y(c)}Y(c){this.P("stopping file watcher",c),this.watchers.delete(c),c.instance.dispose()}Z(c){const h=new Map;for(const u of c){const $=O.$k?u.path:u.path.toLowerCase();let p=h.get(u.correlationId);p||(p=new Map,h.set(u.correlationId,p)),p.has($)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),p.set($,u)}return Array.from(h.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(c){super.setVerboseLogging(c);for(const h of this.watchers)h.instance.setVerboseLogging(c)}P(c,h){this.R&&this.b.fire({type:"trace",message:this.bb(c,h)})}Q(c){this.b.fire({type:"warn",message:this.bb(c)})}bb(c,h){return h?`[File Watcher (node.js)] ${c} (${this.M(h.request)})`:`[File Watcher (node.js)] ${c}`}}t.$or=g}),define(oe[128],ae([0,1,52,127]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pr=void 0;class w extends E.$4q{constructor(A,I,g){super(A,I,g),this.s()}r(A){return A.add(new P.$or(void 0))}}t.$pr=w}),define(oe[129],ae([0,1,15,59,91,52]),function(H,t,E,P,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gr=void 0;class A extends O.$5q{constructor(g,l,c){super(g,l,c),this.s()}r(g){const l=g.add(new w.$fr(E.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(l.onDidProcessExit(({code:c,signal:h})=>this.t(`terminated by itself with code ${c}, signal: ${h} (ETERM)`))),P.ProxyChannel.toService((0,P.$mi)(l.getChannel("watcher")))}}t.$gr=A}),define(oe[64],ae([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Di=void 0;class E{constructor(...w){this.a=new Map;for(const[O,A]of w)this.set(O,A)}set(w,O){const A=this.a.get(w);return this.a.set(w,O),A}has(w){return this.a.has(w)}get(w){return this.a.get(w)}}t.$Di=E}),define(oe[130],ae([0,1,8,9,2,51,124,11,64,176]),function(H,t,E,P,w,O,A,I,g,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ur=t.$tr=void 0;const c=!1;class h extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class u{constructor(v=new g.$Di,d=!1,m,k=c){this.i=v,this.j=d,this.k=m,this.l=k,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Ei,this),this._globalGraph=k?m?._globalGraph??new A.$sr(y=>y):void 0}dispose(){if(!this.f){this.f=!0,(0,w.$Rc)(this.h),this.h.clear();for(const v of this.g)(0,w.$Qc)(v)&&v.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(v,d){this.m();const m=this,k=new class extends u{dispose(){m.h.delete(k),super.dispose()}}(v,this.j,this,this.l);return this.h.add(k),d?.add(k),k}invokeFunction(v,...d){this.m();const m=p.traceInvocation(this.l,v);let k=!1;try{return v({get:e=>{if(k)throw(0,P.$0)("service accessor is only valid during the invocation of its target method");const a=this.s(e,m);if(!a)throw new Error(`[invokeFunction] unknown service '${e}'`);return a}},...d)}finally{k=!0,m.stop()}}createInstance(v,...d){this.m();let m,k;return v instanceof O.$Ci?(m=p.traceCreation(this.l,v.ctor),k=this.o(v.ctor,v.staticArguments.concat(d),m)):(m=p.traceCreation(this.l,v),k=this.o(v,d,m)),m.stop(),k}o(v,d=[],m){const k=I._util.getServiceDependencies(v).sort((a,n)=>a.index-n.index),y=[];for(const a of k){const n=this.s(a.id,m);n||this.y(`[createInstance] ${v.name} depends on UNKNOWN service ${a.id}.`,!1),y.push(n)}const e=k.length>0?k[0].index:d.length;if(d.length!==e){console.trace(`[createInstance] First service dependency of ${v.name} at position ${e+1} conflicts with ${d.length} static arguments`);const a=e-d.length;a>0?d=d.concat(new Array(a)):d=d.slice(0,e)}return Reflect.construct(v,d.concat(y))}q(v,d){if(this.i.get(v)instanceof O.$Ci)this.i.set(v,d);else if(this.k)this.k.q(v,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(v){const d=this.i.get(v);return!d&&this.k?this.k.r(v):d}s(v,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const m=this.r(v);return m instanceof O.$Ci?this.u(v,m,d.branch(v,!0)):(d.branch(v,!1),m)}u(v,d,m){if(this.t.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.t.add(v);try{return this.v(v,d,m)}finally{this.t.delete(v)}}v(v,d,m){const k=new A.$sr(a=>a.id.toString());let y=0;const e=[{id:v,desc:d,_trace:m}];for(;e.length;){const a=e.pop();if(k.lookupOrInsertNode(a),y++>1e3)throw new h(k);for(const n of I._util.getServiceDependencies(a.desc.ctor)){const r=this.r(n.id);if(r||this.y(`[createInstance] ${v} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(a.id),String(n.id)),r instanceof O.$Ci){const i={id:n.id,desc:r,_trace:a._trace.branch(n.id,!0)};k.insertEdge(a,i),e.push(i)}}}for(;;){const a=k.roots();if(a.length===0){if(!k.isEmpty())throw new h(k);break}for(const{data:n}of a){if(this.r(n.id)instanceof O.$Ci){const i=this.w(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.q(n.id,i)}k.removeNode(n)}}return this.r(v)}w(v,d,m=[],k,y){if(this.i.get(v)instanceof O.$Ci)return this.x(v,d,m,k,y,this.g);if(this.k)return this.k.w(v,d,m,k,y);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(v,d,m=[],k,y,e){if(k){const a=new u(void 0,this.j,this,this.l);a.c=String(v);const n=new Map,r=new E.$Yh(()=>{const i=a.o(d,m,y);for(const[s,o]of n){const f=i[s];if(typeof f=="function")for(const b of o)b.disposable=f.apply(i,b.listener)}return n.clear(),e.add(i),i});return new Proxy(Object.create(null),{get(i,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let b=n.get(s);return b||(b=new l.$7c,n.set(s,b)),(T,N,C)=>{if(r.isInitialized)return r.value[s](T,N,C);{const z={listener:[T,N,C],disposable:void 0},X=b.push(z);return(0,w.$Uc)(()=>{X(),z.disposable?.dispose()})}}}if(s in i)return i[s];const o=r.value;let f=o[s];return typeof f!="function"||(f=f.bind(o),i[s]=f),f},set(i,s,o){return r.value[s]=o,!0},getPrototypeOf(i){return d.prototype}})}else{const a=this.o(d,m,y);return e.add(a),a}}y(v,d){if(d&&console.warn(v),this.j)throw new Error(v)}}t.$tr=u;var $;(function(R){R[R.None=0]="None",R[R.Creation=1]="Creation",R[R.Invocation=2]="Invocation",R[R.Branch=3]="Branch"})($||($={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super($.None,null)}stop(){}branch(){return this}}}static traceInvocation(v,d){return v?new p($.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(v,d){return v?new p($.Creation,d.name):p.c}static{this.f=0}constructor(v,d){this.type=v,this.name=d,this.g=Date.now(),this.h=[]}branch(v,d){const m=new p($.Branch,v.toString());return this.h.push([v,d,m]),m}stop(){const v=Date.now()-this.g;p.f+=v;let d=!1;function m(y,e){const a=[],n=new Array(y+1).join("	");for(const[r,i,s]of e.h)if(i&&s){d=!0,a.push(`${n}CREATES -> ${r}`);const o=m(y+1,s);o&&a.push(o)}else a.push(`${n}uses -> ${r}`);return a.join(`
`)}const k=[`${this.type===$.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(v>2||d)&&p.all.add(k.join(`
`))}}t.$ur=p}),define(oe[6],ae([0,1,110,38,5,43,2,31,13,17,3,12,125,11]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rk=t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.$ck=t.LogLevel=t.$ak=t.$_j=void 0,t.$bk=R,t.log=d,t.$nk=f,t.$ok=b,t.$pk=D,t.$qk=T,E=be(E),t.$_j=(0,$.$Fi)("logService"),t.$ak=(0,$.$Fi)("loggerService");function p(){return new Date().toISOString()}function R(N){return(0,c.$jg)(N)}var v;(function(N){N[N.Off=0]="Off",N[N.Trace=1]="Trace",N[N.Debug=2]="Debug",N[N.Info=3]="Info",N[N.Warning=4]="Warning",N[N.Error=5]="Error"})(v||(t.LogLevel=v={})),t.$ck=v.Info;function d(N,C,z){switch(C){case v.Trace:N.trace(z);break;case v.Debug:N.debug(z);break;case v.Info:N.info(z);break;case v.Warning:N.warn(z);break;case v.Error:N.error(z);break;case v.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function m(N,C=!1){let z="";for(let X=0;X<N.length;X++){let Y=N[X];if(Y instanceof Error&&(Y=(0,P.$qj)(Y,C)),typeof Y=="object")try{Y=JSON.stringify(Y)}catch{}z+=(X>0?" ":"")+Y}return z}class k extends A.$Wc{constructor(){super(...arguments),this.b=t.$ck,this.c=this.B(new w.$me),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==v.Off&&this.b<=C}}t.$ek=k;class y extends k{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...z){this.f(v.Trace)&&this.g(v.Trace,m([C,...z],!0))}debug(C,...z){this.f(v.Debug)&&this.g(v.Debug,m([C,...z]))}info(C,...z){this.f(v.Info)&&this.g(v.Info,m([C,...z]))}warn(C,...z){this.f(v.Warning)&&this.g(v.Warning,m([C,...z]))}error(C,...z){if(this.f(v.Error))if(C instanceof Error){const X=Array.prototype.slice.call(arguments);X[0]=C.stack,this.g(v.Error,m(X))}else this.g(v.Error,m([C,...z]))}flush(){}}t.$fk=y;class e extends k{constructor(C=t.$ck){super(),this.setLevel(C),this.g=!g.$i}trace(C,...z){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,C,...z):console.log(`[main ${p()}]`,C,...z))}debug(C,...z){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,C,...z):console.log(`[main ${p()}]`,C,...z))}info(C,...z){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,C,...z):console.log(`[main ${p()}]`,C,...z))}warn(C,...z){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,C,...z):console.warn(`[main ${p()}]`,C,...z))}error(C,...z){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,C,...z):console.error(`[main ${p()}]`,C,...z))}flush(){}}t.$gk=e;class a extends k{constructor(C=t.$ck,z=!0){super(),this.g=z,this.setLevel(C)}trace(C,...z){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...z):console.log(C,...z))}debug(C,...z){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...z):console.log(C,...z))}info(C,...z){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...z):console.log(C,...z))}warn(C,...z){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...z):console.log(C,...z))}error(C,...z){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...z):console.error(C,...z))}flush(){}}t.$hk=a;class n extends k{constructor(C,z=t.$ck){super(),this.g=C,this.setLevel(z)}trace(C,...z){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(C),...z])}debug(C,...z){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(C),...z])}info(C,...z){this.f(v.Info)&&this.g.log(v.Info,[this.h(C),...z])}warn(C,...z){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(C),...z])}error(C,...z){this.f(v.Error)&&this.g.log(v.Error,[this.h(C),...z])}h(C){return typeof C=="string"?C:(0,P.$qj)(C,this.f(v.Trace))}flush(){}}t.$ik=n;class r extends k{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const z of this.g)z.setLevel(C);super.setLevel(C)}trace(C,...z){for(const X of this.g)X.trace(C,...z)}debug(C,...z){for(const X of this.g)X.debug(C,...z)}info(C,...z){for(const X of this.g)X.info(C,...z)}warn(C,...z){for(const X of this.g)X.warn(C,...z)}error(C,...z){for(const X of this.g)X.error(C,...z)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}t.$jk=r;class i extends A.$Wc{constructor(C,z,X){if(super(),this.h=C,this.j=z,this.b=new I.$Cc,this.c=this.B(new w.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new w.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new w.$me),this.onDidChangeVisibility=this.g.event,X)for(const Y of X)this.b.set(Y.resource,{logger:void 0,info:Y})}m(C){return(0,c.$fg)(C)?[...this.b.values()].find(z=>z.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,z){const X=this.n(C),Y=(0,c.$fg)(C)?C:z?.id??(0,O.$tj)(X.toString()).toString(16);let se=this.b.get(X)?.logger;const le=z?.logLevel==="always"?v.Trace:z?.logLevel;se||(se=this.s(X,le??this.getLogLevel(X)??this.h,{...z,id:Y}));const ue={logger:se,info:{resource:X,id:Y,logLevel:le,name:z?.name,hidden:z?.hidden,extensionId:z?.extensionId,when:z?.when}};return this.registerLogger(ue.info),this.b.set(X,ue),se}n(C){return(0,c.$fg)(C)?(0,l.$gh)(this.j,`${C}.log`):C}setLogLevel(C,z){if(h.URI.isUri(C)){const X=C,Y=z,se=this.b.get(X);se&&Y!==se.info.logLevel&&(se.info.logLevel=Y===this.h?void 0:Y,se.logger?.setLevel(Y),this.b.set(se.info.resource,se),this.f.fire([X,Y]))}else{this.h=C;for(const[X,Y]of this.b.entries())this.b.get(X)?.info.logLevel===void 0&&Y.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,z){const X=this.m(C);X&&z!==!X.info.hidden&&(X.info.hidden=!z,this.b.set(X.info.resource,X),this.g.fire([X.info.resource,z]))}getLogLevel(C){let z;return C&&(z=this.b.get(C)?.info.logLevel),z??this.h}registerLogger(C){const z=this.b.get(C.resource);z?z.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const z=this.b.get(C);z&&(z.logger&&z.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[z.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}t.$kk=i;class s{constructor(){this.onDidChangeLogLevel=new w.$me().event}setLevel(C){}getLevel(){return v.Info}trace(C,...z){}debug(C,...z){}info(C,...z){}warn(C,...z){}error(C,...z){}critical(C,...z){}dispose(){}flush(){}}t.$lk=s;class o extends s{}t.$mk=o;function f(N){if(N.verbose)return v.Trace;if(typeof N.logLevel=="string"){const C=T(N.logLevel.toLowerCase());if(C!==void 0)return C}return t.$ck}function b(N){switch(N){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}function D(N){switch(N){case v.Trace:return{original:"Trace",value:E.localize(0,null)};case v.Debug:return{original:"Debug",value:E.localize(1,null)};case v.Info:return{original:"Info",value:E.localize(2,null)};case v.Warning:return{original:"Warning",value:E.localize(3,null)};case v.Error:return{original:"Error",value:E.localize(4,null)};case v.Off:return{original:"Off",value:E.localize(5,null)}}}function T(N){switch(N){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}t.$rk=new u.$Wj("logLevel",b(v.Info))}),define(oe[131],ae([0,1,20,8,9,5,63,2,16,52,6]),function(H,t,E,P,w,O,A,I,g,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_q=void 0;class h extends I.$Wc{constructor($,p){super(),this.a=$,this.b=p,this.c=this.B(new O.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new P.$Dh(0)),this.w=[],this.y=this.B(new P.$Dh(0))}watch($,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n($,p):this.z($,p)}n($,p){const R={path:this.J($),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},v=(0,E.$Vb)(this.j,R);return this.r(),(0,I.$Uc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,w.$3)($))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,l.$6q)(p)),p=>this.G(p),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const p of this.j)(0,l.$2q)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const p of this.j)(0,l.$2q)(p)&&$.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,p){const R={path:this.J($),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},v=(0,E.$Vb)(this.w,R);return this.C(),(0,I.$Uc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,w.$3)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,l.$6q)($)),$=>this.G($),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,g.$jc)($.fsPath)}J($){const p=this.I($);return(0,A.$Hg)(p)}}t.$_q=h});var re=this&&this.__param||function(H,t){return function(E,P){t(E,P,H)}};define(oe[132],ae([0,1,20,8,14,22,5,43,65,2,49,15,133,17,47,106,10,62,6,9]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$,p,R,v,d,m,k){"use strict";var y;Object.defineProperty(t,"__esModule",{value:!0}),t.$Zq=void 0;let e=class extends l.$Wc{static{y=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new A.$me),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$me),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$me),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$me),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$me),this.Y=this.B(new A.$me),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$me),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new P.$Oh)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,u.mark)(`code/registerFilesystem/${n}`);const i=new l.$Vc;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),i.add(r.onDidChangeFile(s=>{const o=new v.$sl(s,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,l.$Uc)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,l.$Rc)(i)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(i){r.push(i)}}),!this.h.has(n)&&await P.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const i=this.h.get(n.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return g.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,$.$kh)(n))throw new v.$ul((0,R.localize)(0,null,this.sb(n)),v.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const i=new k.$db;throw i.message=(0,R.localize)(1,null,n.toString()),i}return r}async m(n){const r=await this.j(n);if((0,v.$fl)(r)||(0,v.$cl)(r)||(0,v.$gl)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const r=await this.j(n);if((0,v.$fl)(r)||(0,v.$cl)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.s(n,r)}catch(i){throw(0,v.$pl)(i)===v.FileSystemProviderErrorCode.FileNotFound?new v.$ul((0,R.localize)(2,null,this.sb(n)),v.FileOperationResult.FILE_NOT_FOUND):(0,v.$nl)(i)}}async s(n,r){const i=await this.j(n),s=this.S(i),o=r?.resolveTo,f=r?.resolveSingleChildDescendants,b=r?.resolveMetadata,D=await i.stat(n);let T;return this.t(i,n,D,void 0,!!b,(N,C)=>(T||(T=c.$Li.forUris(()=>!s),T.set(n,!0),o&&T.fill(!0,o)),T.get(N.resource)||T.findSuperstr(N.resource.with({query:null,fragment:null}))?!0:N.isDirectory&&f?C===1:!1))}async t(n,r,i,s,o,f){const{providerExtUri:b}=this.R(n),D={resource:r,name:b.basename(r),isFile:(i.type&v.FileType.File)!==0,isDirectory:(i.type&v.FileType.Directory)!==0,isSymbolicLink:(i.type&v.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&v.FilePermission.Readonly)||!!(n.capabilities&v.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&v.FilePermission.Locked),etag:(0,v.$Fl)({mtime:i.mtime,size:i.size}),children:void 0};if(D.isDirectory&&f(D,s)){try{const T=await n.readdir(r),N=await P.Promises.settled(T.map(async([C,z])=>{try{const X=b.joinPath(r,C),Y=o?await n.stat(X):{type:z};return await this.t(n,X,Y,T.length,o,f)}catch(X){return this.b.trace(X),null}}));D.children=(0,E.$Jb)(N)}catch(T){this.b.trace(T),D.children=[]}return D}return D}async resolveAll(n){return P.Promises.settled(n.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),i=await r.stat(n);return this.t(r,n,i,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.u(n,r)}catch(i){return i}return!0}async u(n,r){if(!r?.overwrite&&await this.exists(n))throw new v.$ul((0,R.localize)(3,null,this.sb(n)),v.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(n,r=w.$Oe.fromString(""),i){await this.u(n,i);const s=await this.writeFile(n,r);return this.r.fire(new v.$rl(n,v.FileOperation.CREATE,s)),s}async writeFile(n,r,i){const s=this.qb(await this.n(n),n),{providerExtUri:o}=this.R(s);let f=i;if((0,v.$il)(s)&&!f?.atomic){const b=s.enforceAtomicWriteFile?.(n);b&&(f={...i,atomic:b})}try{await this.w(s,n,f)||await this.U(s,o.dirname(n));let D;if((0,v.$cl)(s)&&!(r instanceof w.$Oe))if((0,p.$Ae)(r)){const T=await(0,p.$He)(r,3);T.ended?D=w.$Oe.concat(T.buffer):D=T}else D=(0,p.$Ee)(r,T=>w.$Oe.concat(T),3);else D=r;!(0,v.$fl)(s)||(0,v.$cl)(s)&&D instanceof w.$Oe||(0,v.$cl)(s)&&(0,v.$il)(s)&&f?.atomic?await this.hb(s,n,f,D):await this.db(s,n,f,D instanceof w.$Oe?(0,w.$Ze)(D):D),this.r.fire(new v.$rl(n,v.FileOperation.WRITE))}catch(b){throw new v.$ul((0,R.localize)(4,null,this.sb(n),(0,v.$nl)(b).toString()),(0,v.$ql)(b),f)}return this.resolve(n,{resolveMetadata:!0})}async w(n,r,i){const s=!!i?.unlock;if(s&&!(n.capabilities&v.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,R.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(n.capabilities&v.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,R.localize)(6,null,this.sb(r)));if(!(n.capabilities&v.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,R.localize)(7,null,this.sb(r)));if(s)throw new Error((0,R.localize)(8,null,this.sb(r)))}let f;try{f=await n.stat(r)}catch{return}if(f.type&v.FileType.Directory)throw new v.$ul((0,R.localize)(9,null,this.sb(r)),v.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.rb(r,f),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==v.$El&&typeof f.mtime=="number"&&typeof f.size=="number"&&i.mtime<f.mtime&&i.etag!==(0,v.$Fl)({mtime:i.mtime,size:f.size}))throw new v.$ul((0,R.localize)(10,null),v.FileOperationResult.FILE_MODIFIED_SINCE,i);return f}async readFile(n,r,i){const s=await this.m(n);return r?.atomic?this.z(s,n,r,i):this.C(s,n,r,i)}async z(n,r,i,s){return new Promise((o,f)=>{this.cb.queueFor(r,async()=>{try{const b=await this.C(n,r,i,s);o(b)}catch(b){f(b)}},this.R(n).providerExtUri)})}async C(n,r,i,s){const o=await this.D(n,r,{...i,preferUnbuffered:!0},s);return{...o,value:await(0,w.$1e)(o.value)}}async readFileStream(n,r,i){const s=await this.m(n);return this.D(s,n,r,i)}async D(n,r,i,s){const o=new O.$xe(s);let f=i;(0,v.$hl)(n)&&n.enforceAtomicReadFile?.(r)&&(f={...i,atomic:!0});const b=this.J(r,f).then(T=>T,T=>{throw o.dispose(!0),T});let D;try{return typeof f?.etag=="string"&&f.etag!==v.$El&&await b,f?.atomic&&(0,v.$hl)(n)||!((0,v.$fl)(n)||(0,v.$gl)(n))||(0,v.$cl)(n)&&f?.preferUnbuffered?D=this.I(n,r,f):(0,v.$gl)(n)?D=this.G(n,r,o.token,f):D=this.H(n,r,o.token,f),D.on("end",()=>o.dispose()),D.on("error",()=>o.dispose()),{...await b,value:D}}catch(T){throw D&&await(0,p.$Fe)(D),this.F(T,r,f)}}F(n,r,i){const s=(0,R.localize)(11,null,this.sb(r),(0,v.$nl)(n).toString());return n instanceof v.$wl?new v.$wl(s,n.stat,i):n instanceof v.$vl?new v.$vl(s,n.fileOperationResult,n.size,n.options):new v.$ul(s,(0,v.$ql)(n),i)}G(n,r,i,s=Object.create(null)){const o=n.readFileStream(r,s,i);return(0,p.$Le)(o,{data:f=>f instanceof w.$Oe?f:w.$Oe.wrap(f),error:f=>this.F(f,r,s)},f=>w.$Oe.concat(f))}H(n,r,i,s=Object.create(null)){const o=(0,w.$5e)();return(0,d.$Yq)(n,r,o,f=>f,{...s,bufferSize:this.a,errorTransformer:f=>this.F(f,r,s)},i),o}I(n,r,i){const s=(0,p.$Ce)(o=>w.$Oe.concat(o));return(async()=>{try{let o;i?.atomic&&(0,v.$hl)(n)?o=await n.readFile(r,{atomic:!0}):o=await n.readFile(r),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(r,o.byteLength,i),s.end(w.$Oe.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(n,r){const i=await this.resolve(n,{resolveMetadata:!0});if(i.isDirectory)throw new v.$ul((0,R.localize)(12,null,this.sb(n)),v.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==v.$El&&r.etag===i.etag)throw new v.$wl((0,R.localize)(13,null),i,r);return this.L(n,i.size,r),i}L(n,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new v.$vl((0,R.localize)(14,null,this.sb(n)),v.FileOperationResult.FILE_TOO_LARGE,r,i)}async canMove(n,r,i){return this.M(n,r,"move",i)}async canCopy(n,r,i){return this.M(n,r,"copy",i)}async M(n,r,i,s){if(n.toString()!==r.toString())try{const o=i==="move"?this.qb(await this.n(n),n):await this.m(n),f=this.qb(await this.n(r),r);await this.Q(o,n,f,r,i,s)}catch(o){return o}return!0}async move(n,r,i){const s=this.qb(await this.n(n),n),o=this.qb(await this.n(r),r),f=await this.N(s,n,o,r,"move",!!i),b=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new v.$rl(n,f==="move"?v.FileOperation.MOVE:v.FileOperation.COPY,b)),b}async copy(n,r,i){const s=await this.m(n),o=this.qb(await this.n(r),r),f=await this.N(s,n,o,r,"copy",!!i),b=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new v.$rl(n,f==="copy"?v.FileOperation.COPY:v.FileOperation.MOVE,b)),b}async N(n,r,i,s,o,f){if(r.toString()===s.toString())return o;const{exists:b,isSameResourceWithDifferentPathCase:D}=await this.Q(n,r,i,s,o,f);if(b&&!D&&f&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),o==="copy"){if(n===i&&(0,v.$dl)(n))await n.copy(r,s,{overwrite:f});else{const T=await this.resolve(r);T.isDirectory?await this.P(n,T,i,s):await this.O(n,r,i,s)}return o}else return n===i?(await n.rename(r,s,{overwrite:f}),o):(await this.N(n,r,i,s,"copy",f),await this.del(r,{recursive:!0}),"copy")}async O(n,r,i,s){if((0,v.$fl)(n)&&(0,v.$fl)(i))return this.jb(n,r,i,s);if((0,v.$fl)(n)&&(0,v.$cl)(i))return this.pb(n,r,i,s);if((0,v.$cl)(n)&&(0,v.$fl)(i))return this.nb(n,r,i,s);if((0,v.$cl)(n)&&(0,v.$cl)(i))return this.lb(n,r,i,s)}async P(n,r,i,s){await i.mkdir(s),Array.isArray(r.children)&&await P.Promises.settled(r.children.map(async o=>{const f=this.R(i).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(n,await this.resolve(o.resource),i,f):this.O(n,o.resource,i,f)}))}async Q(n,r,i,s,o,f){let b=!1;if(n===i){const{providerExtUri:T,isPathCaseSensitive:N}=this.R(n);if(N||(b=T.isEqual(r,s)),b&&o==="copy")throw new Error((0,R.localize)(15,null,this.sb(r),this.sb(s)));if(!b&&T.isEqualOrParent(s,r))throw new Error((0,R.localize)(16,null,this.sb(r),this.sb(s)))}const D=await this.exists(s);if(D&&!b){if(!f)throw new v.$ul((0,R.localize)(17,null,this.sb(r),this.sb(s)),v.FileOperationResult.FILE_MOVE_CONFLICT);if(n===i){const{providerExtUri:T}=this.R(n);if(T.isEqualOrParent(r,s))throw new Error((0,R.localize)(18,null,this.sb(r),this.sb(s)))}}return{exists:D,isSameResourceWithDifferentPathCase:b}}R(n){const r=this.S(n);return{providerExtUri:r?$.$9g:$.$$g,isPathCaseSensitive:r}}S(n){return!!(n.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const r=this.qb(await this.j(n),n);await this.U(r,n);const i=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new v.$rl(n,v.FileOperation.CREATE,i)),i}async U(n,r){const i=[],{providerExtUri:s}=this.R(n);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await n.stat(r)).type&v.FileType.Directory))throw new Error((0,R.localize)(19,null,this.sb(r)));break}catch(o){if((0,v.$pl)(o)!==v.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(s.basename(r)),r=s.dirname(r)}for(let o=i.length-1;o>=0;o--){r=s.joinPath(r,i[o]);try{await n.mkdir(r)}catch(f){if((0,v.$pl)(f)!==v.FileSystemProviderErrorCode.FileExists)throw f}}}async canDelete(n,r){try{await this.W(n,r)}catch(i){return i}return!0}async W(n,r){const i=this.qb(await this.j(n),n),s=!!r?.useTrash;if(s&&!(i.capabilities&v.FileSystemProviderCapabilities.Trash))throw new Error((0,R.localize)(20,null,this.sb(n)));const o=r?.atomic;if(o&&!(i.capabilities&v.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,R.localize)(21,null,this.sb(n)));if(s&&o)throw new Error((0,R.localize)(22,null,this.sb(n)));let f;try{f=await i.stat(n)}catch{}if(f)this.rb(n,f);else throw new v.$ul((0,R.localize)(23,null,this.sb(n)),v.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const D=await this.resolve(n);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,R.localize)(24,null,this.sb(n)))}return i}async del(n,r){const i=await this.W(n,r);let s=r;if((0,v.$jl)(i)&&!s?.atomic){const D=i.enforceAtomicDelete?.(n);D&&(s={...r,atomic:D})}const o=!!s?.useTrash,f=!!s?.recursive,b=s?.atomic??!1;await i.delete(n,{recursive:f,useTrash:o,atomic:b}),this.r.fire(new v.$rl(n,v.FileOperation.DELETE))}async cloneFile(n,r){const i=await this.j(n),s=this.qb(await this.n(r),r);if(!(i===s&&this.R(i).providerExtUri.isEqual(n,r)))return i===s&&(0,v.$el)(i)?i.cloneFile(n,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),i===s&&(0,v.$dl)(i)?this.cb.queueFor(n,()=>i.copy(n,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(n,()=>this.O(i,n,s,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(n,r){return this.watch(n,{...r,correlationId:y.ab++})}watch(n,r={recursive:!1,excludes:[]}){const i=new l.$Vc;let s=!1,o=()=>{s=!0};i.add((0,l.$Uc)(()=>o())),(async()=>{try{const b=await this.bb(n,r);s?(0,l.$Rc)(b):o=()=>(0,l.$Rc)(b)}catch(b){this.b.error(b)}})();const f=r.correlationId;if(typeof f=="number"){const b=i.add(new A.$me);return i.add(this.X.event(T=>{T.correlates(f)&&b.fire(T)})),{onDidChange:b.event,dispose:()=>i.dispose()}}return i}async bb(n,r){const i=await this.j(n),s=(0,I.$tj)([this.R(i).providerExtUri.getComparisonKey(n),r]);let o=this.$.get(s);return o||(o={count:0,disposable:i.watch(n,r)},this.$.set(s,o)),o.count+=1,(0,l.$Uc)(()=>{o&&(o.count--,o.count===0&&((0,l.$Rc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,l.$Rc)(n.disposable);this.$.clear()}async db(n,r,i,s){return this.cb.queueFor(r,async()=>{const o=await n.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,p.$Ae)(s)||(0,p.$Be)(s)?await this.eb(n,o,s):await this.fb(n,o,s)}catch(f){throw(0,v.$nl)(f)}finally{await n.close(o)}},this.R(n).providerExtUri)}async eb(n,r,i){let s=0,o;if((0,p.$Be)(i)){if(i.buffer.length>0){const f=w.$Oe.concat(i.buffer);await this.gb(n,r,f,f.byteLength,s,0),s+=f.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((f,b)=>{(0,p.$Ge)(o,{onData:async D=>{o.pause();try{await this.gb(n,r,D,D.byteLength,s,0)}catch(T){return b(T)}s+=D.byteLength,setTimeout(()=>o.resume())},onError:D=>b(D),onEnd:()=>f()})})}async fb(n,r,i){let s=0,o;for(;(o=i.read())!==null;)await this.gb(n,r,o,o.byteLength,s,0),s+=o.byteLength}async gb(n,r,i,s,o,f){let b=0;for(;b<s;){const D=await n.write(r,o+b,i.buffer,f+b,s-b);b+=D}}async hb(n,r,i,s){return this.cb.queueFor(r,()=>this.ib(n,r,i,s),this.R(n).providerExtUri)}async ib(n,r,i,s){let o;s instanceof w.$Oe?o=s:(0,p.$Ae)(s)?o=await(0,w.$1e)(s):(0,p.$Be)(s)?o=await(0,w.$2e)(s):o=(0,w.$Ye)(s),await n.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(n,r,i,s){return this.cb.queueFor(s,()=>this.kb(n,r,i,s),this.R(i).providerExtUri)}async kb(n,r,i,s){let o,f;try{o=await n.open(r,{create:!1}),f=await i.open(s,{create:!0,unlock:!1});const b=w.$Oe.alloc(this.a);let D=0,T=0,N=0;do N=await n.read(o,D,b.buffer,T,b.byteLength-T),await this.gb(i,f,b,N,D,T),D+=N,T+=N,T===b.byteLength&&(T=0);while(N>0)}catch(b){throw(0,v.$nl)(b)}finally{await P.Promises.settled([typeof o=="number"?n.close(o):Promise.resolve(),typeof f=="number"?i.close(f):Promise.resolve()])}}async lb(n,r,i,s){return this.cb.queueFor(s,()=>this.mb(n,r,i,s),this.R(i).providerExtUri)}async mb(n,r,i,s){return i.writeFile(s,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,r,i,s){return this.cb.queueFor(s,()=>this.ob(n,r,i,s),this.R(i).providerExtUri)}async ob(n,r,i,s){const o=await i.open(s,{create:!0,unlock:!1});try{const f=await n.readFile(r);await this.gb(i,o,w.$Oe.wrap(f),f.byteLength,0,0)}catch(f){throw(0,v.$nl)(f)}finally{await i.close(o)}}async pb(n,r,i,s){const o=await(0,w.$1e)(this.H(n,r,O.CancellationToken.None));await this.hb(i,s,void 0,o)}qb(n,r){if(n.capabilities&v.FileSystemProviderCapabilities.Readonly)throw new v.$ul((0,R.localize)(25,null,this.sb(r)),v.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,r){if((r.permissions??0)&v.FilePermission.Readonly)throw new v.$ul((0,R.localize)(26,null,this.sb(n)),v.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===h.Schemas.file?n.fsPath:n.toString(!0)}};t.$Zq=e,t.$Zq=e=y=ye([re(0,m.$_j)],e)}),define(oe[134],ae([0,1,8,31,14,5,63,2,16,13,17,47,26,108,10,62,131,129,128]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$,p,R,v,d,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qr=void 0;class k extends v.$_q{static{this.L=!1}constructor(e,a){super(e,a),this.onDidChangeCapabilities=O.Event.None,this.P=new P.$Cc(n=>c.$0g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=p.FileSystemProviderCapabilities.FileReadWrite|p.FileSystemProviderCapabilities.FileOpenReadWriteClose|p.FileSystemProviderCapabilities.FileReadStream|p.FileSystemProviderCapabilities.FileFolderCopy|p.FileSystemProviderCapabilities.FileWriteUnlock|p.FileSystemProviderCapabilities.FileAtomicRead|p.FileSystemProviderCapabilities.FileAtomicWrite|p.FileSystemProviderCapabilities.FileAtomicDelete|p.FileSystemProviderCapabilities.FileClone,l.$k&&(this.M|=p.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(e){try{const{stat:a,symbolicLink:n}=await u.SymlinkSupport.stat(this.I(e));return{type:this.O(a,n),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size,permissions:a.mode&128?void 0:p.FilePermission.Locked}}catch(a){throw this.hb(a)}}async N(e){try{return await this.stat(e)}catch{return}}async readdir(e){try{const a=await u.Promises.readdir(this.I(e),{withFileTypes:!0}),n=[];return await Promise.all(a.map(async r=>{try{let i;r.isSymbolicLink()?i=(await this.stat((0,c.$gh)(e,r.name))).type:i=this.O(r),n.push([r.name,i])}catch(i){this.a.trace(i)}})),n}catch(a){throw this.hb(a)}}O(e,a){let n;return a?.dangling?n=p.FileType.Unknown:e.isFile()?n=p.FileType.File:e.isDirectory()?n=p.FileType.Directory:n=p.FileType.Unknown,a&&(n|=p.FileType.SymbolicLink),n}async Q(e){const a=this.I(e);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let n;for(;n=this.P.get(e);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await n.wait();const r=new E.$Eh;return this.P.set(e,r),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,I.$Uc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.P.get(e)===r&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.P.delete(e)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),r.open()})}async readFile(e,a){let n;try{a?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(e)})`),n=await this.Q(e));const r=this.I(e);return await u.Promises.readFile(r)}catch(r){throw this.hb(r)}finally{n?.dispose()}}R(e){k.L&&this.a.trace(e)}readFileStream(e,a,n){const r=(0,h.$Ce)(i=>w.$Oe.concat(i.map(s=>w.$Oe.wrap(s))).buffer);return(0,R.$Yq)(this,e,r,i=>i.buffer,{...a,bufferSize:256*1024},n),r}async writeFile(e,a,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(e)?this.U(e,(0,c.$gh)((0,c.$fh)(e),`${(0,c.$dh)(e)}${n.atomic.postfix}`),a,n):this.W(e,a,n)}async S(e){try{const a=this.I(e),{symbolicLink:n}=await u.SymlinkSupport.stat(a);if(n)return!1}catch{}return!0}async U(e,a,n,r){const i=new I.$Vc;try{i.add(await this.Q(e)),i.add(await this.Q(a)),await this.W(a,n,r,!0);try{await this.rename(a,e,{overwrite:!0})}catch(s){try{await this.delete(a,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw s}}finally{i.dispose()}}async W(e,a,n,r){let i;try{const s=this.I(e);if(!n.create||!n.overwrite){if(await u.Promises.exists(s)){if(!n.overwrite)throw(0,p.$ml)((0,$.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,p.$ml)((0,$.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(e,{create:!0,unlock:n.unlock},r),await this.write(i,0,a,0,a.byteLength)}catch(s){throw await this.ib(e,s)}finally{typeof i=="number"&&await this.close(i)}}static{this.$=!0}static configureFlushOnWrite(e){k.$=e}async open(e,a,n){const r=this.I(e);let i;(0,p.$al)(a)&&!n&&(i=await this.Q(e));let s;try{if((0,p.$al)(a)&&a.unlock)try{const{stat:f}=await u.SymlinkSupport.stat(r);f.mode&128||await u.Promises.chmod(r,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let o;if((0,p.$al)(a)){if(l.$i)try{await u.Promises.truncate(r,0),o="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}o||(o="w")}else o="r";s=await u.Promises.open(r,o)}catch(o){throw i?.dispose(),(0,p.$al)(a)?await this.ib(e,o):this.hb(o)}if(this.X.set(s,0),(0,p.$al)(a)&&this.Z.set(s,e),i){const o=this.Y.get(s);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${r})`),this.Y.set(s,i),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${r})`),o.dispose())}return s}async close(e){const a=this.Y.get(e);try{if(this.X.delete(e),this.Z.delete(e)&&k.$)try{await u.Promises.fdatasync(e)}catch(n){k.configureFlushOnWrite(!1),this.a.error(n)}return await u.Promises.close(e)}catch(n){throw this.hb(n)}finally{a&&(this.Y.get(e)===a&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${e}`),this.Y.delete(e)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${e}`),a.dispose())}}async read(e,a,n,r,i){const s=this.ab(e,a);let o=null;try{o=(await u.Promises.read(e,n,r,i,s)).bytesRead}catch(f){throw this.hb(f)}finally{this.bb(e,s,o)}return o}ab(e,a){return a===this.X.get(e)?null:a}bb(e,a,n){const r=this.X.get(e);typeof r=="number"&&(typeof a=="number"||(typeof n=="number"?this.X.set(e,r+n):this.X.delete(e)))}async write(e,a,n,r,i){return(0,E.$Zh)(()=>this.cb(e,a,n,r,i),100,3)}async cb(e,a,n,r,i){const s=this.ab(e,a);let o=null;try{o=(await u.Promises.write(e,n,r,i,s)).bytesWritten}catch(f){throw await this.ib(this.Z.get(e),f)}finally{this.bb(e,s,o)}return o}async mkdir(e){try{await u.Promises.mkdir(this.I(e))}catch(a){throw this.hb(a)}}async delete(e,a){try{const n=this.I(e);if(a.recursive){let r;a?.atomic!==!1&&a.atomic.postfix&&(r=(0,g.$lc)((0,g.$oc)(n),`${(0,g.$pc)(n)}${a.atomic.postfix}`)),await u.Promises.rm(n,u.RimRafMode.MOVE,r)}else try{await u.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let i=!1;try{const{stat:s,symbolicLink:o}=await u.SymlinkSupport.stat(n);i=s.isDirectory()&&!o}catch{}if(i)await u.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.hb(n)}}async rename(e,a,n){const r=this.I(e),i=this.I(a);if(r!==i)try{await this.db(e,a,"move",n.overwrite),await u.Promises.rename(r,i)}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,$.localize)(2,null,(0,g.$pc)(r),(0,g.$pc)((0,g.$oc)(i)),s.toString()))),this.hb(s)}}async copy(e,a,n){const r=this.I(e),i=this.I(a);if(r!==i)try{await this.db(e,a,"copy",n.overwrite),await u.Promises.copy(r,i,{preserveSymlinks:!0})}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,$.localize)(3,null,(0,g.$pc)(r),(0,g.$pc)((0,g.$oc)(i)),s.toString()))),this.hb(s)}}async db(e,a,n,r){const i=this.I(e),s=this.I(a);let o=!1;if(!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,A.$Dg)(i,s,!0)),o){if(n==="copy")throw(0,p.$ml)((0,$.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const b=await this.N(e);if(!b)throw(0,p.$ml)((0,$.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const D=await this.N(a);if(D){if(!r)throw(0,p.$ml)((0,$.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);b.type&p.FileType.File&&D.type&p.FileType.File||await this.delete(a,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(e,a){return this.eb(e,a,!1)}async eb(e,a,n){const r=this.I(e),i=this.I(a),s=!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive);if((0,A.$Dg)(r,i,!s))return;const o=new I.$Vc;try{o.add(await this.Q(e)),o.add(await this.Q(a)),n&&await u.Promises.mkdir((0,g.$oc)(i),{recursive:!0}),await u.Promises.copyFile(r,i)}catch(f){if(f.code==="ENOENT"&&!n)return this.eb(e,a,!0);throw this.hb(f)}finally{o.dispose()}}t(e,a,n){return new d.$gr(r=>e(r),r=>a(r),n)}F(e,a,n){return new m.$pr(r=>e(r),r=>a(r),n)}hb(e){if(e instanceof p.$ll)return e;let a=e,n;switch(e.code){case"ENOENT":n=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":a=`${e.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=p.FileSystemProviderErrorCode.Unknown;break;default:n=p.FileSystemProviderErrorCode.Unknown}return(0,p.$ml)(a,n)}async ib(e,a){let n=this.hb(a);if(e&&n.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await u.SymlinkSupport.stat(this.I(e));r.mode&128||(n=(0,p.$ml)(a,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}t.$qr=k}),define(oe[135],ae([0,1,2,6]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oR=void 0;class w extends E.$Wc{constructor(A,I=[]){super(),this.a=new P.$jk([A,...I]),this.B(A.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...I){this.a.trace(A,...I)}debug(A,...I){this.a.debug(A,...I)}info(A,...I){this.a.info(A,...I)}warn(A,...I){this.a.warn(A,...I)}error(A,...I){this.a.error(A,...I)}flush(){this.a.flush()}}t.$oR=w}),define(oe[136],ae([0,1,10,6]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dR=void 0;var w;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(w||(w={}));async function O(l,c,h,u,$){try{const p=await new Promise((v,d)=>{H(["@vscode/spdlog"],v,d)}).then(be);p.setFlushOn(w.Trace);const R=await p.createAsyncRotatingLogger(l,c,h,u);return $?R.clearFormatters():R.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),R}catch(p){console.error(p)}return null}function A(l,c,h){switch(c){case P.LogLevel.Trace:l.trace(h);break;case P.LogLevel.Debug:l.debug(h);break;case P.LogLevel.Info:l.info(h);break;case P.LogLevel.Warning:l.warn(h);break;case P.LogLevel.Error:l.error(h);break;case P.LogLevel.Off:break;default:throw new Error(`Invalid log level ${c}`)}}function I(l,c){switch(c){case P.LogLevel.Trace:l.setLevel(w.Trace);break;case P.LogLevel.Debug:l.setLevel(w.Debug);break;case P.LogLevel.Info:l.setLevel(w.Info);break;case P.LogLevel.Warning:l.setLevel(w.Warning);break;case P.LogLevel.Error:l.setLevel(w.Error);break;case P.LogLevel.Off:l.setLevel(w.Off);break;default:throw new Error(`Invalid log level ${c}`)}}class g extends P.$fk{constructor(c,h,u,$,p){super(),this.m=[],this.setLevel(p),this.n=this.s(c,h,u,$),this.B(this.onDidChangeLogLevel(R=>{this.r&&I(this.r,R)}))}async s(c,h,u,$){const p=u?6:1,R=30/p*E.$Hl.MB,v=await O(c,h,R,p,$);if(v){this.r=v,I(this.r,this.getLevel());for(const{level:d,message:m}of this.m)A(this.r,d,m);this.m=[]}}g(c,h){this.r?A(this.r,c,h):this.getLevel()<=c&&this.m.push({level:c,message:h})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}t.$dR=g}),define(oe[137],ae([0,1,29,6,136]),function(H,t,E,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eR=void 0;class O extends P.$kk{s(I,g,l){return new w.$dR((0,E.$2g)(),I.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,g)}}t.$eR=O}),define(oe[39],ae([0,1,5,65,2,11]),function(H,t,E,P,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uo=t.$to=t.$so=void 0,t.$so=(0,O.$Fi)("policy");class A extends w.$Wc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.$me),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const c=Object.keys(this.f).length;return this.f={...l,...this.f},c!==Object.keys(this.f).length&&await this.j(l),P.Iterable.reduce(this.g.entries(),(h,[u,$])=>({...h,[u]:$}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return P.Iterable.reduce(Object.entries(this.f),(l,[c,h])=>({...l,[c]:{definition:h,value:this.g.get(c)}}),{})}}t.$to=A;class I{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}t.$uo=I}),define(oe[138],ae([0,1,8,5,65,3,10,6,39]),function(H,t,E,P,w,O,A,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Agc=void 0;function l(h,u){const $=[];for(const p of new Set(w.Iterable.concat(h.keys(),u.keys())))h.get(p)!==u.get(p)&&$.push(p);return $}let c=class extends g.$to{constructor(u,$,p){super(),this.m=u,this.n=$,this.s=p,this.c=this.B(new E.$Dh(500));const R=P.Event.filter($.onDidFilesChange,v=>v.affects(u));this.B($.watch(u)),this.B(R(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const u=new Map;try{const $=await this.n.readFile(this.m),p=JSON.parse($.value.toString());if(!(0,O.$hg)(p))throw new Error("Policy file isn't a JSON object");for(const R of Object.keys(p))this.f[R]&&u.set(R,p[R])}catch($){$.fileOperationResult!==A.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",$)}return u}async w(){const u=await this.u(),$=l(this.g,u);this.g=u,$.length>0&&this.h.fire($)}};t.$Agc=c,t.$Agc=c=ye([re(1,A.$_k),re(2,I.$_j)],c)}),define(oe[139],ae([0,1,39,8,2,6]),function(H,t,E,P,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zgc=void 0;let A=class extends E.$to{constructor(g,l){super(),this.m=g,this.n=l,this.a=new P.$zh,this.b=this.B(new w.$Xc)}async j(g){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(g).length} policy definitions`);const{createWatcher:l}=await new Promise((c,h)=>{H(["@vscode/policy-watcher"],c,h)}).then(be);await this.a.queue(()=>new Promise((c,h)=>{try{this.b.value=l(this.n,g,u=>{this.t(u),c()})}catch(u){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",u),h(u)}}))}t(g){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(g)}`);for(const l in g){const c=g[l];c===void 0?this.g.delete(l):this.g.set(l,c)}this.h.fire(Object.keys(g))}};t.$zgc=A,t.$zgc=A=ye([re(0,O.$_j)],A)}),define(oe[33],ae([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tk=t.$sk=void 0,t.$sk=(0,E.$Fi)("productService"),t.$tk="vscode://schemas/vscode-product"}),define(oe[37],ae([0,1,75,3]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qo=void 0,E=be(E),P=be(P);class w{constructor(){this.a=new Map}add(A,I){E.ok(P.$fg(A)),E.ok(P.$hg(I)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,I)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}t.$qo=new w}),define(oe[140],ae([0,1,5,37]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ro=void 0,P=be(P),t.$ro={JSONContribution:"base.contributions.json"};function w(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class O{constructor(){this.b=new E.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,l){this.a[w(g)]=l,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const A=new O;P.$qo.add(t.$ro.JSONContribution,A)}),define(oe[40],ae([0,1,20,5,3,95,30,140,37]),function(H,t,E,P,w,O,A,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fo=t.$Eo=t.$Do=t.$Co=t.$Bo=t.$Ao=t.$zo=t.$yo=t.$xo=t.$wo=t.ConfigurationScope=t.$vo=t.EditPresentationTypes=void 0,t.$Go=R,t.$Ho=v,t.$Io=d,t.$Jo=k,t.$Ko=y,w=be(w),O=be(O);var l;(function(e){e.Multiline="multilineText",e.Singleline="singlelineText"})(l||(t.EditPresentationTypes=l={})),t.$vo={Configuration:"base.contributions.configuration"};var c;(function(e){e[e.APPLICATION=1]="APPLICATION",e[e.MACHINE=2]="MACHINE",e[e.WINDOW=3]="WINDOW",e[e.RESOURCE=4]="RESOURCE",e[e.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",e[e.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(c||(t.ConfigurationScope=c={})),t.$wo={properties:{},patternProperties:{}},t.$xo={properties:{},patternProperties:{}},t.$yo={properties:{},patternProperties:{}},t.$zo={properties:{},patternProperties:{}},t.$Ao={properties:{},patternProperties:{}},t.$Bo={properties:{},patternProperties:{}},t.$Co="vscode://schemas/settings/resourceLanguage",t.$Do="vscode://schemas/settings/configurationDefaults";const h=g.$qo.as(I.$ro.JSONContribution);class u{constructor(){this.h=new Set,this.i=new P.$me,this.onDidSchemaChange=this.i.event,this.j=new P.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},h.registerSchema(t.$Co,this.g),this.v()}registerConfiguration(a,n=!0){this.registerConfigurations([a],n)}registerConfigurations(a,n=!0){const r=new Set;this.n(a,n,r),h.registerSchema(t.$Co,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(a){const n=new Set;this.o(a,n),h.registerSchema(t.$Co,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:a,remove:n}){const r=new Set;this.o(n,r),this.n(a,!1,r),h.registerSchema(t.$Co,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(a){const n=new Set;this.k(a,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(a,n){const r=[];for(const{overrides:i,source:s}of a)for(const o in i)if(n.add(o),t.$Fo.test(o)){const f=this.a.get(o),b=f?.valuesSources??new Map;if(s)for(const C of Object.keys(i[o]))b.set(C,s);const D={...f?.value||{},...i[o]};this.a.set(o,{source:s,value:D,valuesSources:b});const T=(0,A.$jj)(o),N={type:"object",default:D,description:O.localize(1,null,T),$ref:t.$Co,defaultDefaultValue:D,source:w.$fg(s)?void 0:s,defaultValueSource:s};r.push(...R(o)),this.d[o]=N,this.b.properties[o]=N}else{this.a.set(o,{value:i[o],source:s});const f=this.d[o];f&&(this.w(o,f),this.r(o,f))}this.m(r)}deregisterDefaultConfigurations(a){const n=new Set;this.l(a,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(a,n){for(const{overrides:r,source:i}of a)for(const s in r){const o=this.a.get(s),f=w.$fg(i)?i:i?.id,b=w.$fg(o?.source)?o?.source:o?.source?.id;if(f===b)if(n.add(s),this.a.delete(s),t.$Fo.test(s))delete this.d[s],delete this.b.properties[s];else{const D=this.d[s];D&&(this.w(s,D),this.r(s,D))}}this.u()}deltaConfiguration(a){let n=!1;const r=new Set;a.removedDefaults&&(this.l(a.removedDefaults,r),n=!0),a.addedDefaults&&(this.k(a.addedDefaults,r),n=!0),a.removedConfigurations&&this.o(a.removedConfigurations,r),a.addedConfigurations&&this.n(a.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...a){this.i.fire()}registerOverrideIdentifiers(a){this.m(a),this.i.fire()}m(a){for(const n of a)this.h.add(n);this.u()}n(a,n,r){a.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(a,n){const r=i=>{if(i.properties)for(const s in i.properties){n.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>r(s))};for(const i of a){r(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(a,n=!0,r,i,s=c.WINDOW,o){s=w.$og(a.scope)?s:a.scope;const f=a.properties;if(f)for(const D in f){const T=f[D];if(n&&k(D,T)){delete f[D];continue}if(T.source=r,T.defaultDefaultValue=f[D].default,this.w(D,T),t.$Fo.test(D)?T.scope=void 0:(T.scope=w.$og(T.scope)?s:T.scope,T.restricted=w.$og(T.restricted)?!!i?.includes(D):T.restricted),f[D].hasOwnProperty("included")&&!f[D].included){this.f[D]=f[D],delete f[D];continue}else this.d[D]=f[D],f[D].policy?.name&&this.e.set(f[D].policy.name,D);!f[D].deprecationMessage&&f[D].markdownDeprecationMessage&&(f[D].deprecationMessage=f[D].markdownDeprecationMessage),o.add(D)}const b=a.allOf;if(b)for(const D of b)this.p(D,n,r,i,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(a){const n=r=>{const i=r.properties;if(i)for(const o in i)this.r(o,i[o]);r.allOf?.forEach(n)};n(a)}r(a,n){switch(t.$wo.properties[a]=n,n.scope){case c.APPLICATION:t.$xo.properties[a]=n;break;case c.MACHINE:t.$yo.properties[a]=n;break;case c.MACHINE_OVERRIDABLE:t.$zo.properties[a]=n;break;case c.WINDOW:t.$Ao.properties[a]=n;break;case c.RESOURCE:t.$Bo.properties[a]=n;break;case c.LANGUAGE_OVERRIDABLE:t.$Bo.properties[a]=n,this.g.properties[a]=n;break}}s(a,n){switch(delete t.$wo.properties[a],n.scope){case c.APPLICATION:delete t.$xo.properties[a];break;case c.MACHINE:delete t.$yo.properties[a];break;case c.MACHINE_OVERRIDABLE:delete t.$zo.properties[a];break;case c.WINDOW:delete t.$Ao.properties[a];break;case c.RESOURCE:case c.LANGUAGE_OVERRIDABLE:delete t.$Bo.properties[a],delete this.g.properties[a];break}}u(){for(const a of this.h.values()){const n=`[${a}]`,r={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:t.$Co};this.w(n,r),t.$wo.properties[n]=r,t.$xo.properties[n]=r,t.$yo.properties[n]=r,t.$zo.properties[n]=r,t.$Ao.properties[n]=r,t.$Bo.properties[n]=r}}v(){const a={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:t.$Co};t.$wo.patternProperties[t.$Eo]=a,t.$xo.patternProperties[t.$Eo]=a,t.$yo.patternProperties[t.$Eo]=a,t.$zo.patternProperties[t.$Eo]=a,t.$Ao.patternProperties[t.$Eo]=a,t.$Bo.patternProperties[t.$Eo]=a,this.i.fire()}w(a,n){const r=this.a.get(a);let i=r?.value,s=r?.source;w.$mg(i)&&(i=n.defaultDefaultValue,s=void 0),w.$mg(i)&&(i=d(n.type)),n.default=i,n.defaultValueSource=s}}const $="\\[([^\\]]+)\\]",p=new RegExp($,"g");t.$Eo=`^(${$})+$`,t.$Fo=new RegExp(t.$Eo);function R(e){const a=[];if(t.$Fo.test(e)){let n=p.exec(e);for(;n?.length;){const r=n[1].trim();r&&a.push(r),n=p.exec(e)}}return(0,E.$Ob)(a)}function v(e){return e.reduce((a,n)=>`${a}[${n}]`,"")}function d(e){switch(Array.isArray(e)?e[0]:e){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new u;g.$qo.add(t.$vo.Configuration,m);function k(e,a){return e.trim()?t.$Fo.test(e)?O.localize(7,null,e):m.getConfigurationProperties()[e]!==void 0?O.localize(8,null,e):a.policy?.name&&m.getPolicyConfigurations().get(a.policy?.name)!==void 0?O.localize(9,null,e,a.policy?.name,m.getPolicyConfigurations().get(a.policy?.name)):null:O.localize(6,null)}function y(){const e=[],a=m.getConfigurationProperties();for(const n of Object.keys(a))e.push([n,a[n].scope]);return e.push(["launch",c.RESOURCE]),e.push(["task",c.RESOURCE]),e}}),define(oe[66],ae([0,1,20,5,34,2,31,28,3,12,30,40,10,37]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qo=t.$Oo=t.$No=t.$Mo=t.$Lo=void 0,t.$Po=y,E=be(E),w=be(w),I=be(I),g=be(g);function p(r){return Object.isFrozen(r)?r:I.$eo(r)}class R{static createEmptyModel(i){return new R({},[],[],void 0,i)}constructor(i,s,o,f,b){this.b=i,this.c=s,this.d=o,this.raw=f,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof R)return s;const o=new v("",this.f);return o.parseRaw(s),o.configurationModel});this.g=i.reduce((s,o)=>o===s?o:s.merge(o),i[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,c.$hj)(this.contents,i):this.contents}inspect(i,s){const o=this;return{get value(){return p(o.rawConfiguration.getValue(i))},get override(){return s?p(o.rawConfiguration.getOverrideValue(i,s)):void 0},get merged(){return p(s?o.rawConfiguration.override(s).getValue(i):o.rawConfiguration.getValue(i))},get overrides(){const f=[];for(const{contents:b,identifiers:D,keys:T}of o.rawConfiguration.overrides){const N=new R(b,T,[],void 0,o.f).getValue(i);N!==void 0&&f.push({identifiers:D,value:N})}return f.length?p(f):void 0}}}getOverrideValue(i,s){const o=this.j(s);return o?i?(0,c.$hj)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const o of this.overrides)o.identifiers.includes(i)&&s.push(...o.keys);return E.$Ob(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return E.$Ob(i)}override(i){let s=this.a.get(i);return s||(s=this.h(i),this.a.set(i,s)),s}merge(...i){const s=I.$do(this.contents),o=I.$do(this.overrides),f=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const D of i)if(b.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(s,D.contents);for(const T of D.overrides){const[N]=o.filter(C=>E.$wb(C.identifiers,T.identifiers));N?(this.i(N.contents,T.contents),N.keys.push(...T.keys),N.keys=E.$Ob(N.keys)):o.push(I.$do(T))}for(const T of D.keys)f.indexOf(T)===-1&&f.push(T)}return new R(s,f,o,b.every(D=>D instanceof R)?void 0:b,this.f)}h(i){const s=this.j(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const f of E.$Ob([...Object.keys(this.contents),...Object.keys(s)])){let b=this.contents[f];const D=s[f];D&&(typeof b=="object"&&typeof D=="object"?(b=I.$do(b),this.i(b,D)):b=D),o[f]=b}return new R(o,this.keys,this.overrides,void 0,this.f)}i(i,s){for(const o of Object.keys(s)){if(o in i&&g.$hg(i[o])&&g.$hg(s[o])){this.i(i[o],s[o]);continue}i[o]=I.$do(s[o])}}j(i){let s=null,o=null;const f=b=>{b&&(o?this.i(o,b):o=I.$do(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===i?s=b.contents:b.identifiers.includes(i)&&f(b.contents);return f(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.k(i,s,!0)}setValue(i,s){this.k(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,c.$gj)(this.contents,i),h.$Fo.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>E.$wb(o.identifiers,(0,h.$Go)(i))),1))}k(i,s,o){(0,c.$fj)(this.contents,i,s,f=>this.f.error(f)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),h.$Fo.test(i)&&this.overrides.push({identifiers:(0,h.$Go)(i),keys:Object.keys(this.contents[i]),contents:(0,c.$ej)(this.contents[i],f=>this.f.error(f))})}}t.$Lo=R;class v{constructor(i,s){this.f=i,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||R.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,s){if(!g.$og(i)){const o=this.h(i);this.parseRaw(o,s)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,s){this.a=i;const{contents:o,keys:f,overrides:b,restricted:D,hasExcludedProperties:T}=this.i(i,s);this.b=new R(o,f,b,T?[i]:void 0,this.g),this.c=D||[]}h(i){let s={},o=null,f=[];const b=[],D=[];function T(C){Array.isArray(f)?f.push(C):o!==null&&(f[o]=C)}const N={onObjectBegin:()=>{const C={};T(C),b.push(f),f=C,o=null},onObjectProperty:C=>{o=C},onObjectEnd:()=>{f=b.pop()},onArrayBegin:()=>{const C=[];T(C),b.push(f),f=C,o=null},onArrayEnd:()=>{f=b.pop()},onLiteralValue:T,onError:(C,z,X)=>{D.push({error:C,offset:z,length:X})}};if(i)try{w.$5n(i,N),s=f[0]||{}}catch(C){this.g.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return s}i(i,s){const o=$.$qo.as(h.$vo.Configuration).getConfigurationProperties(),f=this.j(i,o,!0,s);i=f.raw;const b=(0,c.$ej)(i,N=>this.g.error(`Conflict in settings file ${this.f}: ${N}`)),D=Object.keys(i),T=this.l(i,N=>this.g.error(`Conflict in settings file ${this.f}: ${N}`));return{contents:b,keys:D,overrides:T,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}j(i,s,o,f){let b=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:b};const D={},T=[];for(const N in i)if(h.$Fo.test(N)&&o){const C=this.j(i[N],s,!1,f);D[N]=C.raw,b=b||C.hasExcludedProperties,T.push(...C.restricted)}else{const C=s[N],z=C?typeof C.scope<"u"?C.scope:h.ConfigurationScope.WINDOW:void 0;C?.restricted&&T.push(N),!f.exclude?.includes(N)&&(f.include?.includes(N)||(z===void 0||f.scopes===void 0||f.scopes.includes(z))&&!(f.skipRestricted&&C?.restricted))?D[N]=i[N]:b=!0}return{raw:D,restricted:T,hasExcludedProperties:b}}l(i,s){const o=[];for(const f of Object.keys(i))if(h.$Fo.test(f)){const b={};for(const D in i[f])b[D]=i[f][D];o.push({identifiers:(0,h.$Go)(f),keys:Object.keys(b),contents:(0,c.$ej)(b,s)})}return o}}t.$Mo=v;class d extends O.$Wc{constructor(i,s,o,f,b){super(),this.c=i,this.f=s,this.g=f,this.h=b,this.b=this.B(new P.$me),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),b),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(P.Event.any(P.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),P.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(u.FileOperation.CREATE)||D.isOperation(u.FileOperation.COPY)||D.isOperation(u.FileOperation.DELETE)||D.isOperation(u.FileOperation.WRITE))&&o.isEqual(D.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return R.createEmptyModel(this.h)}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}t.$No=d;class m{constructor(i,s,o,f,b,D,T,N,C,z,X,Y,se){this.a=i,this.b=s,this.c=o,this.overrideIdentifiers=f,this.d=b,this.f=D,this.g=T,this.h=N,this.i=C,this.j=z,this.k=X,this.l=Y,this.m=se}get value(){return p(this.c)}n(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class k{constructor(i,s,o,f,b,D,T,N,C,z){this.j=i,this.l=s,this.m=o,this.n=f,this.p=b,this.q=D,this.r=T,this.s=N,this.t=C,this.u=z,this.h=null,this.i=new A.$Cc,this.v=null}getValue(i,s,o){return this.w(i,s,o).getValue(i)}updateValue(i,s,o={}){let f;o.resource?(f=this.t.get(o.resource),f||(f=R.createEmptyModel(this.u),this.t.set(o.resource,f))):f=this.s,s===void 0?f.removeValue(i):f.setValue(i,s),o.resource||(this.h=null)}inspect(i,s,o){const f=this.w(i,s,o),b=this.A(s.resource,o),D=s.resource?this.t.get(s.resource)||this.s:this.s,T=new Set;for(const N of f.overrides)for(const C of N.identifiers)f.getOverrideValue(i,C)!==void 0&&T.add(C);return new m(i,s,f.getValue(i),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,b||void 0,D)}keys(i){const s=this.A(void 0,i);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this.j=i,this.h=null,this.i.clear()}updatePolicyConfiguration(i){this.l=i}updateApplicationConfiguration(i){this.m=i,this.h=null,this.i.clear()}updateLocalUserConfiguration(i){this.n=i,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(i){this.p=i,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(i){this.q=i,this.h=null,this.i.clear()}updateFolderConfiguration(i,s){this.r.set(i,s),this.i.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.i.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const o=[];if(!s){const{added:f,updated:b,removed:D}=a(this.j,i);s=[...f,...b,...D]}for(const f of s)for(const b of(0,h.$Go)(f)){const D=this.j.getKeysForOverrideIdentifier(b),T=i.getKeysForOverrideIdentifier(b),N=[...T.filter(C=>D.indexOf(C)===-1),...D.filter(C=>T.indexOf(C)===-1),...D.filter(C=>!I.$ho(this.j.override(b).getValue(C),i.override(b).getValue(C)))];o.push([b,N])}return this.updateDefaultConfiguration(i),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:o,removed:f}=a(this.l,i),b=[...s,...o,...f];return b.length&&this.updatePolicyConfiguration(i),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:o,removed:f,overrides:b}=a(this.applicationConfiguration,i),D=[...s,...o,...f];return D.length&&this.updateApplicationConfiguration(i),{keys:D,overrides:b}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:o,removed:f,overrides:b}=a(this.localUserConfiguration,i),D=[...s,...o,...f];return D.length&&this.updateLocalUserConfiguration(i),{keys:D,overrides:b}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:o,removed:f,overrides:b}=a(this.remoteUserConfiguration,i),D=[...s,...o,...f];return D.length&&this.updateRemoteUserConfiguration(i),{keys:D,overrides:b}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:o,removed:f,overrides:b}=a(this.workspaceConfiguration,i),D=[...s,...o,...f];return D.length&&this.updateWorkspaceConfiguration(i),{keys:D,overrides:b}}compareAndUpdateFolderConfiguration(i,s){const o=this.folderConfigurations.get(i),{added:f,updated:b,removed:D,overrides:T}=a(o,s),N=[...f,...b,...D];return(N.length||!o)&&this.updateFolderConfiguration(i,s),{keys:N,overrides:T}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:f,removed:b,overrides:D}=a(s,void 0);return{keys:[...o,...f,...b],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(i,s,o){let f=this.x(s,o);return s.overrideIdentifier&&(f=f.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(i)!==void 0&&(f=f.merge(this.l)),f}x({resource:i},s){let o=this.y();if(s&&i){const f=s.getFolder(i);f&&(o=this.z(f.uri)||o);const b=this.t.get(i);b&&(o=o.merge(b))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(i){let s=this.i.get(i);if(!s){const o=this.y(),f=this.r.get(i);f?(s=o.merge(f),this.i.set(i,s)):s=o}return s}A(i,s){if(s&&i){const o=s.getFolder(i);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((i,s)=>{const{contents:o,overrides:f,keys:b}=this.r.get(s);return i.push([s,{contents:o,overrides:f,keys:b}]),i},[])}}allKeys(){const i=new Set;return this.j.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this.q.keys.forEach(s=>i.add(s)),this.r.forEach(s=>s.keys.forEach(o=>i.add(o))),[...i.values()]}B(){const i=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}D(i){const s=new Set;return this.j.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.q.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(f=>s.add(f))),[...s.values()]}static parse(i,s){const o=this.E(i.defaults,s),f=this.E(i.policy,s),b=this.E(i.application,s),D=this.E(i.user,s),T=this.E(i.workspace,s),N=i.folders.reduce((C,z)=>(C.set(l.URI.revive(z[0]),this.E(z[1],s)),C),new A.$Cc);return new k(o,f,b,D,R.createEmptyModel(s),T,N,R.createEmptyModel(s),new A.$Cc,s)}static E(i,s){return new R(i.contents,i.keys,i.overrides,void 0,s)}}t.$Oo=k;function y(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const i=new Set,s=new Map;for(const f of r)f.keys.forEach(b=>i.add(b)),f.overrides.forEach(([b,D])=>{const T=(0,A.$zc)(s,b,new Set);D.forEach(N=>T.add(N))});const o=[];return s.forEach((f,b)=>o.push([b,[...f.values()]])),{keys:[...i.values()],overrides:o}}class e{constructor(i,s,o,f,b){this.change=i,this.f=s,this.g=o,this.h=f,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of i.keys)this.affectedKeys.add(D);for(const[,D]of i.overrides)for(const T of D)this.affectedKeys.add(T);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=k.parse(this.f.data,this.i)),this.j}affectsConfiguration(i,s){const o=this.a+i,f=this.d.indexOf(o);if(f<0)return!1;const b=f+o.length;if(b>=this.d.length)return!1;const D=this.d.charCodeAt(b);if(D!==this.b&&D!==this.c)return!1;if(s){const T=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.f?.workspace):void 0,N=this.g.getValue(i,s,this.h);return!I.$ho(T,N)}return!0}}t.$Qo=e;function a(r,i){const{added:s,removed:o,updated:f}=n(i?.rawConfiguration,r?.rawConfiguration),b=[],D=r?.getAllOverrideIdentifiers()||[],T=i?.getAllOverrideIdentifiers()||[];if(i){const N=T.filter(C=>!D.includes(C));for(const C of N)b.push([C,i.getKeysForOverrideIdentifier(C)])}if(r){const N=D.filter(C=>!T.includes(C));for(const C of N)b.push([C,r.getKeysForOverrideIdentifier(C)])}if(i&&r){for(const N of D)if(T.includes(N)){const C=n({contents:r.getOverrideValue(void 0,N)||{},keys:r.getKeysForOverrideIdentifier(N)},{contents:i.getOverrideValue(void 0,N)||{},keys:i.getKeysForOverrideIdentifier(N)});b.push([N,[...C.added,...C.removed,...C.updated]])}}return{added:s,removed:o,updated:f,overrides:b}}function n(r,i){const s=r?i?r.keys.filter(b=>i.keys.indexOf(b)===-1):[...r.keys]:[],o=i?r?i.keys.filter(b=>r.keys.indexOf(b)===-1):[...i.keys]:[],f=[];if(r&&i){for(const b of i.keys)if(r.keys.indexOf(b)!==-1){const D=(0,c.$hj)(i.contents,b),T=(0,c.$hj)(r.contents,b);I.$ho(D,T)||f.push(b)}}return{added:s,removed:o,updated:f}}}),define(oe[141],ae([0,1,20,5,2,28,3,66,40,6,39,37]),function(H,t,E,P,w,O,A,I,g,l,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$To=t.$So=t.$Ro=void 0;class u extends w.$Wc{get configurationModel(){return this.b}constructor(v){super(),this.c=v,this.a=this.B(new P.$me),this.onDidChangeConfiguration=this.a.event,this.b=I.$Lo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(h.$qo.as(g.$vo.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:d})=>this.f(Array.from(v),d))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(v,d){this.j(v,h.$qo.as(g.$vo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:v})}g(){return{}}h(){this.b=I.$Lo.createEmptyModel(this.c);const v=h.$qo.as(g.$vo.Configuration).getConfigurationProperties();this.j(Object.keys(v),v)}j(v,d){const m=this.g();for(const k of v){const y=m[k],e=d[k];y!==void 0?this.b.addValue(k,y):e?this.b.addValue(k,e.default):this.b.removeValue(k)}}}t.$Ro=u;class ${constructor(){this.onDidChangeConfiguration=P.Event.None,this.configurationModel=I.$Lo.createEmptyModel(new l.$mk)}async initialize(){return this.configurationModel}}t.$So=$;let p=class extends w.$Wc{get configurationModel(){return this.b}constructor(v,d,m){super(),this.c=v,this.f=d,this.g=m,this.a=this.B(new P.$me),this.onDidChangeConfiguration=this.a.event,this.b=I.$Lo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.j(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.m(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const d={},m=[],k=h.$qo.as(g.$vo.Configuration).getConfigurationProperties();for(const y of v){const e=k[y];if(!e){m.push(y);continue}if(e.policy){if(e.type!=="string"&&e.type!=="number"){this.g.warn(`Policy ${e.policy.name} has unsupported type ${e.type}`);continue}m.push(y),d[e.policy.name]={type:e.type}}}return(0,A.$sg)(d)||await this.f.updatePolicyDefinitions(d),m}j(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const d=h.$qo.as(g.$vo.Configuration).getPolicyConfigurations(),m=(0,E.$Jb)(v.map(k=>d.get(k)));this.m(m,!0)}m(v,d){this.g.trace("PolicyConfiguration#update",v);const m=h.$qo.as(g.$vo.Configuration).getConfigurationProperties(),k=[],y=this.b.isEmpty();for(const e of v){const a=m[e]?.policy?.name;if(a){const n=this.f.getPolicyValue(a);(y?n!==void 0:!(0,O.$ho)(this.b.getValue(e),n))&&k.push([e,n])}else this.b.getValue(e)!==void 0&&k.push([e,void 0])}if(k.length){this.g.trace("PolicyConfiguration#changed",k);const e=this.b;this.b=I.$Lo.createEmptyModel(this.g);for(const a of e.keys)this.b.setValue(a,e.getValue(a));for(const[a,n]of k)n===void 0?this.b.removeValue(a):this.b.setValue(a,n);d&&this.a.fire(this.b)}}};t.$To=p,t.$To=p=ye([re(1,c.$so),re(2,l.$_j)],p)}),define(oe[142],ae([0,1,20,8,14,5,34,77,2,31,28,13,17,30,66,40,141,10,39]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$,p,R,v,d,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uo=void 0;class k extends g.$Wc{constructor(a,n,r,i){super(),this.m=a,this.n=i,this.h=this.B(new O.$me),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$Ro(i)),this.c=r instanceof m.$uo?new v.$So:this.B(new v.$To(this.b,r,i)),this.f=this.B(new p.$No(this.m,{},u.$0g,n,i)),this.a=new p.$Oo(this.b.configurationModel,this.c.configurationModel,p.$Lo.createEmptyModel(i),p.$Lo.createEmptyModel(i),p.$Lo.createEmptyModel(i),p.$Lo.createEmptyModel(i),new l.$Cc,p.$Lo.createEmptyModel(i),new l.$Cc,i),this.j=new y(a,n,this),this.g=this.B(new P.$Rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:o})=>this.s(s,o))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new p.$Oo(a,n,p.$Lo.createEmptyModel(this.n),r,p.$Lo.createEmptyModel(this.n),p.$Lo.createEmptyModel(this.n),new l.$Cc,p.$Lo.createEmptyModel(this.n),new l.$Cc,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,n){const r=typeof a=="string"?a:void 0,i=(0,$.$aj)(a)?a:(0,$.$aj)(n)?n:{};return this.a.getValue(r,i,void 0)}async updateValue(a,n,r,i,s){const o=(0,$.$bj)(r)?r:(0,$.$aj)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,f=o?i:r;if(f!==void 0&&f!==$.ConfigurationTarget.USER_LOCAL&&f!==$.ConfigurationTarget.USER)throw new Error(`Unable to write ${a} to target ${f}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,E.$Ob)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const b=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(b.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,c.$ho)(n,b.defaultValue)&&(n=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const T=o.overrideIdentifiers.sort(),N=this.a.localUserConfiguration.overrides.find(C=>(0,E.$wb)([...C.identifiers].sort(),T));N&&(o.overrideIdentifiers=N.identifiers)}const D=o?.overrideIdentifiers?.length?[(0,R.$Ho)(o.overrideIdentifiers),a]:[a];await this.j.write(D,n),await this.reloadConfiguration()}inspect(a,n={}){return this.a.inspect(a,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(r,n,$.ConfigurationTarget.USER)}s(a,n){const r=this.a.toData(),i=this.a.compareAndUpdateDefaultConfiguration(a,n);this.u(i,r,$.ConfigurationTarget.DEFAULT)}t(a){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(a);this.u(r,n,$.ConfigurationTarget.DEFAULT)}u(a,n,r){const i=new p.$Qo(a,{data:n},this.a,void 0,this.n);i.source=r,this.h.fire(i)}}t.$Uo=k;class y{constructor(a,n,r){this.b=a,this.c=n,this.d=r,this.a=new P.$Mh}write(a,n){return this.a.queue(()=>this.e(a,n))}async e(a,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const i=[];if((0,A.$Xn)(r,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,a,n);r=(0,I.$co)(r,s),await this.c.writeFile(this.b,w.$Oe.fromString(r))}f(a,n,r){const{tabSize:i,insertSpaces:s,eol:o}=this.h;if(!n.length){const f=JSON.stringify(r,null,s?" ".repeat(i):"	");return[{content:f,length:f.length,offset:0}]}return(0,I.$_n)(a,n,r,{tabSize:i,insertSpaces:s,eol:o})}get h(){if(!this.g){let a=h.OS===h.OperatingSystem.Linux||h.OS===h.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(a=n),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(oe[67],ae([0,1,15]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gn=P,t.$hn=w,t.$in=O,t.$jn=A;function P(g){return g.scheme===E.Schemas.vscodeRemote?g.authority:void 0}function w(g){if(!g)return;const l=g.indexOf("+");return l<0?g:g.substr(0,l)}function O(g){const{host:l,port:c}=I(g);if(typeof c>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:c}}function A(g,l){let{host:c,port:h}=I(g);return typeof h>"u"&&(h=l),{host:c,port:h}}function I(g){const l=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const c=g.match(/^(\[[0-9a-z:]+\])$/);if(c)return{host:c[1],port:void 0};const h=g.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:g,port:void 0}}}),define(oe[23],ae([0,1,32,11,67]),function(H,t,E,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zn=t.$sn=t.$rn=t.$qn=t.TargetPlatform=t.ExtensionType=t.$pn=t.$nn=t.$mn=t.$ln=t.$kn=void 0,t.$on=O,t.$tn=h,t.$un=u,t.$vn=$,t.$wn=p,t.$xn=R,t.$yn=v,E=be(E),t.$kn="extensions.user.cache",t.$ln="extensions.builtin.cache",t.$mn="undefined_publisher",t.$nn=["ui","workspace","web"];function O(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}t.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(A||(t.ExtensionType=A={}));var I;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(I||(t.TargetPlatform=I={}));class g{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,k){if(typeof m>"u"||m===null)return typeof k>"u"||k===null;if(typeof k>"u"||k===null)return!1;if(typeof m=="string"||typeof k=="string"){const y=typeof m=="string"?m:m.value,e=typeof k=="string"?k:k.value;return E.$Gf(y,e)}return m._lower===k._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}t.$qn=g;class l{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const k of m)this.add(k)}add(m){this.c.add(g.toKey(m))}delete(m){return this.c.delete(g.toKey(m))}has(m){return this.c.has(g.toKey(m))}}t.$rn=l;class c{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(g.toKey(m))}get(m){return this.c.get(g.toKey(m))}has(m){return this.c.has(g.toKey(m))}set(m,k){this.c.set(g.toKey(m),k)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}t.$sn=c;function h(d){return u(d)}function u(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function $(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function p(d,m){if(m){const k=`onResolveRemoteAuthority:${(0,w.$hn)(m)}`;return!!d.activationEvents?.includes(k)}return!1}function R(d){return d.map(m=>{const[k,y]=m.split("@");return{proposalName:k,version:y?parseInt(y):void 0}})}function v(d){return d.map(m=>m.split("@")[0])}t.$zn=(0,P.$Fi)("IBuiltinExtensionsScannerService")}),define(oe[21],ae([0,1,13,99,23,11]),function(H,t,E,P,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rp=t.$qp=t.$pp=t.$op=t.$np=t.$mp=t.$lp=t.$kp=t.ExtensionManagementErrorCode=t.$jp=t.ExtensionGalleryErrorCode=t.$ip=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.ExtensionInstallSource=t.$bp=t.$ap=t.$_o=t.$$o=t.$0o=t.$9o=t.$8o=void 0,t.$cp=I,t.$dp=g,t.$ep=l,t.$fp=c,t.$gp=h,t.$hp=u,t.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.$9o=new RegExp(t.$8o),t.$0o="__web_extension",t.$$o="skipWalkthrough",t.$_o="extensionInstallSource",t.$ap="dependecyOrPackExtensionInstall",t.$bp="clientTargetPlatform";var A;(function(e){e.COMMAND="command",e.SETTINGS_SYNC="settingsSync"})(A||(t.ExtensionInstallSource=A={}));function I(e){switch(e){case w.TargetPlatform.WIN32_X64:return"Windows 64 bit";case w.TargetPlatform.WIN32_ARM64:return"Windows ARM";case w.TargetPlatform.LINUX_X64:return"Linux 64 bit";case w.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case w.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case w.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case w.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case w.TargetPlatform.DARWIN_X64:return"Mac";case w.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case w.TargetPlatform.WEB:return"Web";case w.TargetPlatform.UNIVERSAL:return w.TargetPlatform.UNIVERSAL;case w.TargetPlatform.UNKNOWN:return w.TargetPlatform.UNKNOWN;case w.TargetPlatform.UNDEFINED:return w.TargetPlatform.UNDEFINED}}function g(e){switch(e){case w.TargetPlatform.WIN32_X64:return w.TargetPlatform.WIN32_X64;case w.TargetPlatform.WIN32_ARM64:return w.TargetPlatform.WIN32_ARM64;case w.TargetPlatform.LINUX_X64:return w.TargetPlatform.LINUX_X64;case w.TargetPlatform.LINUX_ARM64:return w.TargetPlatform.LINUX_ARM64;case w.TargetPlatform.LINUX_ARMHF:return w.TargetPlatform.LINUX_ARMHF;case w.TargetPlatform.ALPINE_X64:return w.TargetPlatform.ALPINE_X64;case w.TargetPlatform.ALPINE_ARM64:return w.TargetPlatform.ALPINE_ARM64;case w.TargetPlatform.DARWIN_X64:return w.TargetPlatform.DARWIN_X64;case w.TargetPlatform.DARWIN_ARM64:return w.TargetPlatform.DARWIN_ARM64;case w.TargetPlatform.WEB:return w.TargetPlatform.WEB;case w.TargetPlatform.UNIVERSAL:return w.TargetPlatform.UNIVERSAL;default:return w.TargetPlatform.UNKNOWN}}function l(e,a){switch(e){case E.Platform.Windows:return a==="x64"?w.TargetPlatform.WIN32_X64:a==="arm64"?w.TargetPlatform.WIN32_ARM64:w.TargetPlatform.UNKNOWN;case E.Platform.Linux:return a==="x64"?w.TargetPlatform.LINUX_X64:a==="arm64"?w.TargetPlatform.LINUX_ARM64:a==="arm"?w.TargetPlatform.LINUX_ARMHF:w.TargetPlatform.UNKNOWN;case"alpine":return a==="x64"?w.TargetPlatform.ALPINE_X64:a==="arm64"?w.TargetPlatform.ALPINE_ARM64:w.TargetPlatform.UNKNOWN;case E.Platform.Mac:return a==="x64"?w.TargetPlatform.DARWIN_X64:a==="arm64"?w.TargetPlatform.DARWIN_ARM64:w.TargetPlatform.UNKNOWN;case E.Platform.Web:return w.TargetPlatform.WEB}}function c(e,a){return a===w.TargetPlatform.WEB&&!e.includes(w.TargetPlatform.WEB)}function h(e,a,n){return c(a,n)?!1:e===w.TargetPlatform.UNDEFINED||e===w.TargetPlatform.UNIVERSAL?!0:e===w.TargetPlatform.UNKNOWN?!1:e===n}function u(e){return e&&typeof e=="object"&&typeof e.id=="string"&&(!e.uuid||typeof e.uuid=="string")}var $;(function(e){e[e.NoneOrRelevance=0]="NoneOrRelevance",e[e.LastUpdatedDate=1]="LastUpdatedDate",e[e.Title=2]="Title",e[e.PublisherName=3]="PublisherName",e[e.InstallCount=4]="InstallCount",e[e.PublishedDate=10]="PublishedDate",e[e.AverageRating=6]="AverageRating",e[e.WeightedRating=12]="WeightedRating"})($||(t.SortBy=$={}));var p;(function(e){e[e.Default=0]="Default",e[e.Ascending=1]="Ascending",e[e.Descending=2]="Descending"})(p||(t.SortOrder=p={}));var R;(function(e){e.Install="install",e.Uninstall="uninstall"})(R||(t.StatisticType=R={}));var v;(function(e){e[e.None=1]="None",e[e.Install=2]="Install",e[e.Update=3]="Update",e[e.Migrate=4]="Migrate"})(v||(t.InstallOperation=v={})),t.$ip=(0,O.$Fi)("extensionGalleryService");var d;(function(e){e.Timeout="Timeout",e.Cancelled="Cancelled",e.Failed="Failed",e.DownloadFailedWriting="DownloadFailedWriting"})(d||(t.ExtensionGalleryErrorCode=d={}));class m extends Error{constructor(a,n){super(a),this.code=n,this.name=n}}t.$jp=m;var k;(function(e){e.Unsupported="Unsupported",e.Deprecated="Deprecated",e.Malicious="Malicious",e.Incompatible="Incompatible",e.IncompatibleApi="IncompatibleApi",e.IncompatibleTargetPlatform="IncompatibleTargetPlatform",e.ReleaseVersionNotFound="ReleaseVersionNotFound",e.Invalid="Invalid",e.Download="Download",e.DownloadSignature="DownloadSignature",e.DownloadFailedWriting="DownloadFailedWriting",e.UpdateExistingMetadata="UpdateExistingMetadata",e.UpdateMetadata="UpdateMetadata",e.Extract="Extract",e.Scanning="Scanning",e.ScanningExtension="ScanningExtension",e.ReadUninstalled="ReadUninstalled",e.UnsetUninstalled="UnsetUninstalled",e.Delete="Delete",e.Rename="Rename",e.IntializeDefaultProfile="IntializeDefaultProfile",e.AddToProfile="AddToProfile",e.InstalledExtensionNotFound="InstalledExtensionNotFound",e.PostInstall="PostInstall",e.CorruptZip="CorruptZip",e.IncompleteZip="IncompleteZip",e.Signature="Signature",e.NotAllowed="NotAllowed",e.Gallery="Gallery",e.Cancelled="Cancelled",e.Unknown="Unknown",e.Internal="Internal"})(k||(t.ExtensionManagementErrorCode=k={}));class y extends Error{constructor(a,n){super(a),this.code=n,this.name=n}}t.$kp=y,t.$lp=(0,O.$Fi)("extensionManagementService"),t.$mp="extensionsIdentifiers/disabled",t.$np="extensionsIdentifiers/enabled",t.$op=(0,O.$Fi)("IGlobalExtensionEnablementService"),t.$pp=(0,O.$Fi)("IExtensionTipsService"),t.$qp=(0,P.localize2)(0,"Extensions"),t.$rp=(0,P.localize2)(1,"Preferences")}),define(oe[143],ae([0,1,2,23,10]),function(H,t,E,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tq=void 0;class O extends E.$Wc{constructor(I,g,l,c,h){super(),this.a=I,this.b=g,this.c=l,this.f=h,this.B(c.onDidInstallExtensions(u=>this.g(u))),this.B(c.onDidUninstallExtension(u=>this.h(u)))}g(I){for(const g of I)g.local&&this.invalidate(g.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const g of this.a.profiles)this.c.extUri.isEqual(g.extensionsResource,I)&&await this.j(g);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,P.$kn))}catch(g){(0,w.$ql)(g)!==w.FileOperationResult.FILE_NOT_FOUND&&this.f.error(g)}}}t.$Tq=O});var Me=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(oe[44],ae([0,1,17,56,105,45,23,122]),function(H,t,E,P,w,O,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wp=c,t.$Xp=h,t.$Yp=u,t.$Zp=$,t.$1p=p,t.$2p=R,t.$3p=v,t.$4p=d,P=Me(P),w=be(w),O=be(O);const g=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function c(y){return y=y.trim(),y==="*"||g.test(y)}function h(y){if(!c(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const e=y.match(g);return e?{hasCaret:e[1]==="^",hasGreaterEquals:e[1]===">=",majorBase:e[2]==="x"?0:parseInt(e[2],10),majorMustEqual:e[2]!=="x",minorBase:e[4]==="x"?0:parseInt(e[4],10),minorMustEqual:e[4]!=="x",patchBase:e[6]==="x"?0:parseInt(e[6],10),patchMustEqual:e[6]!=="x",preRelease:e[8]||null}:null}function u(y){if(!y)return null;const e=y.majorBase,a=y.majorMustEqual,n=y.minorBase;let r=y.minorMustEqual;const i=y.patchBase;let s=y.patchMustEqual;y.hasCaret&&(e===0||(r=!1),s=!1);let o=0;if(y.preRelease){const f=l.exec(y.preRelease);if(f){const[,b,D,T]=f;o=Date.UTC(Number(b),Number(D)-1,Number(T))}}return{majorBase:e,majorMustEqual:a,minorBase:n,minorMustEqual:r,patchBase:i,patchMustEqual:s,isMinimum:y.hasGreaterEquals,notBefore:o}}function $(y,e,a){let n;typeof y=="string"?n=u(h(y)):n=y;let r;e instanceof Date?r=e.getTime():typeof e=="string"&&(r=new Date(e).getTime());let i;if(typeof a=="string"?i=u(h(a)):i=a,!n||!i)return!1;const s=n.majorBase,o=n.minorBase,f=n.patchBase;let b=i.majorBase,D=i.minorBase,T=i.patchBase;const N=i.notBefore;let C=i.majorMustEqual,z=i.minorMustEqual,X=i.patchMustEqual;return i.isMinimum?s>b?!0:s<b?!1:o>D?!0:o<D||r&&r<N?!1:f>=T:(s===1&&b===0&&(!C||!z||!X)&&(b=1,D=0,T=0,C=!0,z=!1,X=!1),s<b?!1:s>b?!C:o<D?!1:o>D?!z:f<T?!1:f>T?!X:!(r&&r<N))}function p(y,e,a,n,r){const i=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return i.push([P.default.Error,w.localize(0,null)]),i;if(typeof n.name!="string")return i.push([P.default.Error,w.localize(1,null,"name")]),i;if(typeof n.version!="string")return i.push([P.default.Error,w.localize(2,null,"version")]),i;if(!n.engines)return i.push([P.default.Error,w.localize(3,null,"engines")]),i;if(typeof n.engines.vscode!="string")return i.push([P.default.Error,w.localize(4,null,"engines.vscode")]),i;if(typeof n.extensionDependencies<"u"&&!k(n.extensionDependencies))return i.push([P.default.Error,w.localize(5,null,"extensionDependencies")]),i;if(typeof n.activationEvents<"u"){if(!k(n.activationEvents))return i.push([P.default.Error,w.localize(6,null,"activationEvents")]),i;if(typeof n.main>"u"&&typeof n.browser>"u")return i.push([P.default.Error,w.localize(7,null,"activationEvents","main","browser")]),i}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&i.push([P.default.Warning,w.localize(8,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return i.push([P.default.Error,w.localize(9,null,"main")]),i;{const f=(0,E.$gh)(a,n.main);(0,E.$ah)(f,a)||i.push([P.default.Warning,w.localize(10,null,f.path,a.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return i.push([P.default.Error,w.localize(11,null,"browser")]),i;{const f=(0,E.$gh)(a,n.browser);(0,E.$ah)(f,a)||i.push([P.default.Warning,w.localize(12,null,f.path,a.path)])}}if(!O.valid(n.version))return i.push([P.default.Error,w.localize(13,null)]),i;const s=[];if(!R(y,e,n,r,s))for(const f of s)i.push([P.default.Error,f]);if(n.enabledApiProposals?.length){const f=[];if(!d([...n.enabledApiProposals],f))for(const b of f)i.push([P.default.Error,b])}return i}function R(y,e,a,n,r){return n||typeof a.main>"u"&&typeof a.browser>"u"?!0:m(y,e,a.engines.vscode,r)}function v(y,e,a){return y==="*"||m(e,a,y)}function d(y,e){if(y.length===0)return!0;const a=Array.isArray(e)?e:void 0,n=(a?void 0:e)??I.allApiProposals,r=[],i=(0,A.$xn)(y);for(const{proposalName:s,version:o}of i){const f=n[s];f&&o&&f.version!==o&&(f.version?r.push(w.localize(14,null,s,o,f.version)):r.push(w.localize(15,null,s,o)))}return a?.push(...r),r.length===0}function m(y,e,a,n=[]){const r=u(h(a));if(!r)return n.push(w.localize(16,null,a)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return n.push(w.localize(17,null,a)),!1}else if(!r.majorMustEqual)return n.push(w.localize(18,null,a)),!1;return $(y,e,r)?!0:(n.push(w.localize(19,null,y,a)),!1)}function k(y){if(!Array.isArray(y))return!1;for(let e=0,a=y.length;e<a;e++)if(typeof y[e]!="string")return!1;return!0}}),define(oe[68],ae([0,1,22,2,13,109,21,11]),function(H,t,E,P,w,O,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0r=t.$9r=void 0,t.$8r=g;function g(c){return c.tags.find(h=>h.startsWith("lp-"))?.split("lp-")[1]}t.$9r=(0,I.$Fi)("languagePackService");let l=class extends P.$Wc{constructor(h){super(),this.c=h}async getAvailableLanguages(){const h=new E.$xe;setTimeout(()=>h.cancel(),1e3);let u;try{u=await this.c.query({text:'category:"language packs"',pageSize:20},h.token)}catch{return[]}const p=u.firstPage.filter(R=>R.properties.localizedLanguages?.length&&R.tags.some(v=>v.startsWith("lp-"))).map(R=>{const v=R.properties.localizedLanguages?.[0],d=g(R);return{...this.f(d,v,R),extensionId:R.identifier.id,galleryExtension:R}});return p.push(this.f("en","English")),p}f(h,u,$){const p=u??h;let R;if(p!==h&&(R=`(${h})`),h.toLowerCase()===w.$w.toLowerCase()&&(R??="",R+=(0,O.localize)(0,null)),$?.installCount){R??="";const v=$.installCount;let d;v>1e6?d=`${Math.floor(v/1e5)/10}M`:v>1e3?d=`${Math.floor(v/1e3)}K`:d=String(v),R+=` $(cloud-download) ${d}`}return{id:h,label:p,description:R}}};t.$0r=l,t.$0r=l=ye([re(0,A.$ip)],l)}),define(oe[46],ae([0,1,14,9,2,111,40,11,6,37]),function(H,t,E,P,w,O,A,I,g,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6p=t.$5p=void 0,t.$7p=u,t.$8p=$,t.$9p=p,t.$0p=R,t.$$p=v,t.$_p=d,t.$5p=(0,I.$Fi)("requestService");class c{constructor(e){this.b=e}toJSON(){if(!this.a){const e=Object.create(null);for(const a in this.b)a.toLowerCase()==="authorization"||a.toLowerCase()==="proxy-authorization"?e[a]="*****":e[a]=this.b[a];this.a=e}return this.a}}class h extends w.$Wc{constructor(e){super(),this.b=0,this.a=e.createLogger("network",{name:(0,O.localize)(0,null),when:g.$rk.isEqualTo((0,g.$ok)(g.LogLevel.Trace)).serialize()})}async c(e,a,n){const r=`${e} #${++this.b}: ${a.url}`;this.a.trace(`${r} - begin`,a.type,new c(a.headers??{}));try{const i=await n();return this.a.trace(`${r} - end`,a.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,a.type,(0,P.$_)(i)),i}}}t.$6p=h;function u(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}function $(y){return y.res.statusCode===204}async function p(y){return $(y)?null:(await(0,E.$1e)(y.stream)).toString()}async function R(y){if(!u(y))throw new Error("Server returned "+y.res.statusCode);return p(y)}async function v(y){if(!u(y))throw new Error("Server returned "+y.res.statusCode);if($(y))return null;const a=(await(0,E.$1e)(y.stream)).toString();try{return JSON.parse(a)}catch(n){throw n.message+=`:
`+a,n}}function d(y){k(y)}let m;function k(y){const e=l.$qo.as(A.$vo.Configuration),a=m;m={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},e.updateConfigurations({add:[m],remove:a?[a]:[]})}k(A.ConfigurationScope.APPLICATION)}),define(oe[144],ae([0,1,22,15,10,46]),function(H,t,E,P,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DR=void 0;let A=class{constructor(g,l){this.a=g,this.b=l}async download(g,l,c=E.CancellationToken.None){if(g.scheme===P.Schemas.file||g.scheme===P.Schemas.vscodeRemote){await this.b.copy(g,l);return}const h={type:"GET",url:g.toString(!0)},u=await this.a.request(h,c);if(u.res.statusCode===200)await this.b.writeFile(l,u.stream);else{const $=await(0,O.$0p)(u);throw new Error(`Expected 200, got back ${u.res.statusCode} instead.

${$}`)}}};t.$DR=A,t.$DR=A=ye([re(0,O.$5p),re(1,w.$_k)],A)}),define(oe[145],ae([0,1,146,3]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bs=O;function w(A,I){return A.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:A.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function O(A,I,g={}){const l=(0,E.parse)(A),c=g.proxyUrl||w(l,I);if(!c)return null;const h=(0,E.parse)(c);if(!/^https?:$/.test(h.protocol||""))return null;const u={host:h.hostname||"",port:(h.port?+h.port:0)||(h.protocol==="https"?443:80),auth:h.auth,rejectUnauthorized:(0,P.$lg)(g.strictSSL)?g.strictSSL:!0};return l.protocol==="http:"?new(await new Promise(($,p)=>{H(["http-proxy-agent"],$,p)}).then(be)).HttpProxyAgent(c,u):new(await new Promise(($,p)=>{H(["https-proxy-agent"],$,p)}).then(be)).HttpsProxyAgent(c,u)}}),define(oe[147],ae([0,1,60,16,112,22,38,9,13,29,90,177,8,78]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qm=R;let p;async function R(d,m,k,y){return k["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.$i?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,h.$Jm)(y)&&!k["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,h.$Jm)(y)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=u.Promises.withAsyncBody(async(e,a)=>{const n=new O.$xe;let r=1e4;const i=d.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,$.$Km)(i,1,120)*1e3);const s=setTimeout(()=>{n.dispose(!0),a(new Error((0,w.localize)(0,null)))},r);try{e(await v(m,n.token))}catch(o){!(0,I.$6)(o)&&!n.token.isCancellationRequested?a(new Error((0,w.localize)(1,null,(0,A.$qj)(o)))):e({})}finally{clearTimeout(s),n.dispose()}})),p)}async function v(d,m){const k=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",k);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",y);const e=(0,l.$2g)().replace(/-/g,"").substr(0,12),a=new RegExp(e+"({.*})"+e),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",n);const r=await(0,c.$zm)(g.OS,n);return d.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(m.isCancellationRequested)return s(new I.$7);const o=(0,P.$pc)(r);let f,b;const D="";/^pwsh(-preview)?$/.test(o)?(f=`& '${process.execPath}' ${D} -p '''${e}'' + JSON.stringify(process.env) + ''${e}'''`,b=["-Login","-Command"]):o==="nu"?(f=`^'${process.execPath}' ${D} -p '"${e}" + JSON.stringify(process.env) + "${e}"'`,b=["-i","-l","-c"]):o==="xonsh"?(f=`import os, json; print("${e}", json.dumps(dict(os.environ)), "${e}")`,b=["-i","-l","-c"]):(f=`'${process.execPath}' ${D} -p '"${e}" + JSON.stringify(process.env) + "${e}"'`,o==="tcsh"||o==="csh"?b=["-ic"]:b=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(b),f);const T=(0,E.spawn)(r,[...b,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});m.onCancellationRequested(()=>(T.kill(),s(new I.$7))),T.on("error",z=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,A.$qj)(z)),s(z)});const N=[];T.stdout.on("data",z=>N.push(z));const C=[];T.stderr.on("data",z=>C.push(z)),T.on("close",(z,X)=>{const Y=Buffer.concat(N).toString("utf8");d.trace("getUnixShellEnvironment#raw",Y);const se=Buffer.concat(C).toString("utf8");if(se.trim()&&d.trace("getUnixShellEnvironment#stderr",se),z||X)return s(new Error((0,w.localize)(2,null,z,X)));const le=a.exec(Y),ue=le?le[1]:"{}";try{const fe=JSON.parse(ue);k?fe.ELECTRON_RUN_AS_NODE=k:delete fe.ELECTRON_RUN_AS_NODE,y?fe.ELECTRON_NO_ATTACH_CONSOLE=y:delete fe.ELECTRON_NO_ATTACH_CONSOLE,delete fe.VSCODE_RESOLVING_ENVIRONMENT,delete fe.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",fe),i(fe)}catch(fe){d.error("getUnixShellEnvironment#errorCaught",(0,A.$qj)(fe)),s(fe)}})})}}),define(oe[148],ae([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gR=t.$fR=void 0,t.$fR=(0,E.$Fi)("stateReadService"),t.$gR=(0,E.$Fi)("stateService")}),define(oe[69],ae([0,1,8,14,2,3,18,10,6]),function(H,t,E,P,w,O,A,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jR=t.$iR=t.$hR=t.SaveStrategy=void 0;var l;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(l||(t.SaveStrategy=l={}));class c extends w.$Wc{constructor(p,R,v,d){super(),this.h=p,this.j=R,this.m=v,this.n=d,this.a=Object.create(null),this.b="",this.c=this.B(new E.$Dh(this.j===l.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(p)}}getItem(p,R){const v=this.a[p];return(0,O.$og)(v)?R:v}setItem(p,R){this.setItems([{key:p,data:R}])}setItems(p){let R=!1;for(const{key:v,data:d}of p)this.a[v]!==d&&((0,O.$og)(d)?(0,O.$mg)(this.a[v])||(this.a[v]=void 0,R=!0):(this.a[v]=d,R=!0));R&&this.s()}removeItem(p){(0,O.$mg)(this.a[p])||(this.a[p]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.n.writeFile(this.h,P.$Oe.fromString(p),{atomic:{postfix:".vsctmp"}}),this.b=p}catch(R){this.m.error(R)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}t.$hR=c;let h=class extends w.$Wc{constructor(p,R,v,d){super(),this.a=this.B(new c(R.stateResource,p,v,d))}async init(){await this.a.init()}getItem(p,R){return this.a.getItem(p,R)}};t.$iR=h,t.$iR=h=ye([re(1,A.$Mi),re(2,g.$_j),re(3,I.$_k)],h);class u extends h{setItem(p,R){this.a.setItem(p,R)}setItems(p){this.a.setItems(p)}removeItem(p){this.a.removeItem(p)}close(){return this.a.close()}}t.$jR=u}),define(oe[70],ae([0,1,13,36,29]),function(H,t,E,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sp=A,t.$tp=I;function O(g){if(E.$u===E.Platform.Linux&&/^penguin(\.|$)/i.test(g))return"chromebook"}function A(g,l,c,h,u,$,p,R,v,d){const m=Object.create(null);m["common.machineId"]=$,m["common.sqmId"]=p,m["common.devDeviceId"]=R,m.sessionID=(0,w.$2g)()+Date.now(),m.commitHash=h,m.version=u,m["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,E.$h)(E.$u),m["common.nodePlatform"]=P.$fc,m["common.nodeArch"]=c,m["common.product"]=d||"desktop",v&&(m["common.msftInternal"]=v);let k=0;const y=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-y,enumerable:!0},"common.sequence":{get:()=>k++,enumerable:!0}}),E.$l&&(m["common.snap"]="true");const e=O(l);return e&&(m["common.platformDetail"]=e),m}function I(g){const l=P.env.USERDNSDOMAIN;if(!l)return!1;const c=l.toLowerCase();return g.some(h=>c===h)}}),define(oe[19],ae([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.$jm=t.$im=t.$hm=t.$gm=t.$fm=t.$em=t.$dm=t.$cm=t.$bm=t.$am=t.$_l=t.$$l=void 0,t.$$l=(0,E.$Fi)("telemetryService"),t.$_l=(0,E.$Fi)("customEndpointTelemetryService"),t.$am="telemetry.currentSessionDate",t.$bm="telemetry.firstSessionDate",t.$cm="telemetry.lastSessionDate",t.$dm="telemetry.machineId",t.$em="telemetry.sqmId",t.$fm="telemetry.devDeviceId",t.$gm="telemetry",t.$hm="telemetry.telemetryLevel",t.$im="telemetry.enableCrashReporter",t.$jm="telemetry.enableTelemetry";var P;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(P||(t.TelemetryLevel=P={}));var w;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(w||(t.TelemetryConfiguration=w={}))}),define(oe[71],ae([0,1,9,11,6,19]),function(H,t,E,P,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sq=t.$rq=t.ExtensionSignatureVerificationCode=t.$qq=void 0,t.$qq=(0,P.$Fi)("IExtensionSignatureVerificationService");var A;(function(l){l.Success="Success",l.RequiredArgumentMissing="RequiredArgumentMissing",l.InvalidArgument="InvalidArgument",l.PackageIsUnreadable="PackageIsUnreadable",l.UnhandledException="UnhandledException",l.SignatureManifestIsMissing="SignatureManifestIsMissing",l.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",l.SignatureIsMissing="SignatureIsMissing",l.SignatureIsUnreadable="SignatureIsUnreadable",l.CertificateIsUnreadable="CertificateIsUnreadable",l.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",l.FileAlreadyExists="FileAlreadyExists",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",l.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",l.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",l.SignatureIsInvalid="SignatureIsInvalid",l.SignatureManifestIsInvalid="SignatureManifestIsInvalid",l.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",l.EntryIsMissing="EntryIsMissing",l.EntryIsTampered="EntryIsTampered",l.Untrusted="Untrusted",l.CertificateRevoked="CertificateRevoked",l.SignatureIsNotValid="SignatureIsNotValid",l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(A||(t.ExtensionSignatureVerificationCode=A={}));class I extends Error{constructor(c){super(c),this.code=c}}t.$rq=I;let g=class{constructor(c,h){this.b=c,this.c=h}d(){return this.a||(this.a=new Promise((c,h)=>H(["@vscode/vsce-sign"],async u=>c(u),h))),this.a}async verify(c,h,u,$){let p;const R=c.identifier.id;try{p=await this.d()}catch(k){return this.b.error("Could not load vsce-sign module",(0,E.$_)(k)),this.b.info(`Extension signature verification is not done: ${R}`),!1}const v=new Date().getTime();let d;try{this.b.trace(`Verifying extension signature for ${R}...`),d=await p.verify(h,u,this.b.getLevel()===w.LogLevel.Trace)}catch(k){d={code:A.UnknownError,didExecute:!1,output:(0,E.$_)(k)}}const m=new Date().getTime()-v;if(this.b.info(`Extension signature verification result for ${R}: ${d.code}. Executed: ${d.didExecute}. Duration: ${m}ms.`),this.b.trace(`Extension signature verification output for ${R}:
${d.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:R,extensionVersion:c.version,code:d.code,internalCode:d.internalCode,duration:m,didExecute:d.didExecute,clientTargetPlatform:$}),d.code===A.Success)return!0;throw new I(d.code)}};t.$sq=g,t.$sq=g=ye([re(0,w.$_j),re(1,O.$$l)],g)}),define(oe[41],ae([0,1,28,3,67,70,19]),function(H,t,E,P,w,O,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ap=t.$zp=t.$yp=t.$xp=t.$wp=t.$vp=t.$up=void 0,t.$Bp=c,t.$Cp=h,t.$Dp=u,t.$Ep=$,t.$Fp=R,t.$Gp=d,t.$Hp=m,t.$Ip=e;class I{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}t.$up=I;class g{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}t.$vp=g,t.$wp=new g;class l{async publicLog(n,r,i){}async publicLogError(n,r,i){}}t.$xp=l,t.$yp="telemetry",t.$zp="extensionTelemetryLog",t.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function c(a,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!a.enableTelemetry)}function h(a,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}function u(a){const n=a.getValue(A.$hm),r=a.getValue(A.$im);if(a.getValue(A.$jm)===!1||r===!1)return A.TelemetryLevel.NONE;switch(n??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function $(a){const n={},r={},i={};v(a,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const o=i[s];typeof o=="number"?r[s]=o:typeof o=="boolean"?r[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),n[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[s]=o)}return{properties:n,measurements:r}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function R(a){if(!a)return"none";const n=(0,w.$hn)(a);return p.has(n)?n:"other"}function v(a,n,r=0,i){if(a)for(const s of Object.getOwnPropertyNames(a)){const o=a[s],f=i?i+s:s;Array.isArray(o)?n[f]=(0,E.$io)(o):o instanceof Date?n[f]=o.toISOString():(0,P.$hg)(o)?r<2?v(o,n,r+1,f+"."):n[f]=(0,E.$io)(o):n[f]=o}}function d(a,n){const r=a.msftInternalDomains||[],i=n.getValue("telemetry.internalTesting");return(0,O.$tp)(r)||i}function m(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}function k(a,n){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let r=a;const i=[];for(const b of n)for(;;){const D=b.exec(a);if(!D)break;i.push([D.index,b.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const b=o.exec(a);if(!b)break;const D=i.some(([T,N])=>b.index<N&&T<o.lastIndex);!s.test(b[0])&&!D&&(r+=a.substring(f,b.index)+"<REDACTED: user-file-path>",f=o.lastIndex)}return f<a.length&&(r+=a.substr(f)),r}function y(a){if(!a)return a;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(a))return`<REDACTED: ${r.label}>`;return a}function e(a,n){return(0,E.$fo)(a,r=>{if(r instanceof I||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=k(i,n);for(const s of n)i=i.replace(s,"");return i=y(i),i}})}}),define(oe[27],ae([0,1,32,21,23,13,12,9,36,41]),function(H,t,E,P,w,O,A,I,g,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sp=t.$Kp=void 0,t.$Jp=c,t.$Lp=p,t.$Mp=R,t.$Np=v,t.$Op=d,t.$Pp=m,t.$Qp=k,t.$Rp=y,t.$Tp=e,t.$Up=n;function c(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,E.$Bf)(r.id,i.id)===0}const h=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(i){const s=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new u(i.identifier,s,o)}static parse(i){const s=h.exec(i);return s&&s[1]&&s[2]?new u({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,o=w.TargetPlatform.UNDEFINED){this.identifier=i,this.version=s,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==w.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof u?c(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}t.$Kp=u;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const i=$.exec(r);return i&&i[1]?[v(i[1]),i[2]]:[v(r),void 0]}function R(r,i){return`${r}.${i}`}function v(r){return r.toLowerCase()}function d(r,i){return v(R(r??w.$mn,i))}function m(r,i){const s=[],o=f=>{for(const b of s)if(b.some(D=>c(i(D),i(f))))return b;return null};for(const f of r){const b=o(f);b?b.push(f):s.push([f])}return s}function k(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function y(r){return{id:new l.$up(r.identifier.id),name:new l.$up(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}t.$Sp=new w.$qn("pprice.better-merge");function e(r,i){const s=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const f=o.shift();if(f&&s.every(b=>!c(b.identifier,{id:f}))){const b=r.filter(D=>c(D.identifier,{id:f}));b.length===1&&(s.push(b[0]),o.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function a(r,i){if(!O.$k)return!1;let s;try{s=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){i.debug("Error while getting the os-release file.",(0,I.$_)(f))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,i){const s=await a(r,i),o=(0,P.$ep)(s?"alpine":O.$u,g.$gc);return i.debug("ComputeTargetPlatform:",o),o}}),define(oe[149],ae([0,1,22,9,15,17,45,12,100,21,27,23]),function(H,t,E,P,w,O,A,I,g,l,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tq=void 0;const u=R=>(0,g.localize)(0,null,R),$=(0,g.localize)(1,null,"ms-dotnettools.csharp");let p=class{constructor(v,d,m){this.a=v,this.b=d,this.d=m}get f(){}async listExtensions(v,d,m){let k=await this.b.getInstalled(h.ExtensionType.User,m);const y=h.$pn.map(a=>a.toLowerCase());if(d&&d!==""){if(y.indexOf(d.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}k=k.filter(a=>a.manifest.categories?a.manifest.categories.map(r=>r.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){this.a.info("Possible Categories: "),y.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,g.localize)(2,null,this.f)),k=k.sort((a,n)=>a.identifier.id.localeCompare(n.identifier.id));let e;for(const a of k)e!==a.identifier.id&&(e=a.identifier.id,this.a.info(v?`${e}@${a.manifest.version}`:e))}async installExtensions(v,d,m,k){const y=[];try{v.length&&this.a.info(this.f?(0,g.localize)(3,null,this.f):(0,g.localize)(4,null));const e=[],a=[],n=(i,s,o)=>{a.push({id:i,version:s!=="prerelease"?s:void 0,installOptions:{...m,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||m.installPreReleaseVersion}})};for(const i of v)if(i instanceof I.URI)e.push({vsix:i,installOptions:m});else{const[s,o]=(0,c.$Lp)(i);n(s,o,!1)}for(const i of d)if(i instanceof I.URI)e.push({vsix:i,installOptions:{...m,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,c.$Lp)(i);n(s,o,!0)}const r=await this.b.getInstalled(void 0,m.profileLocation);if(e.length&&await Promise.all(e.map(async({vsix:i,installOptions:s})=>{try{await this.h(i,s,k,r)}catch(o){this.a.error(o),y.push(i.toString())}})),a.length){const i=await this.g(a,r,k);y.push(...i)}}catch(e){throw this.a.error((0,g.localize)(5,null,(0,P.$_)(e))),e}if(y.length)throw new Error((0,g.localize)(6,null,y.join(", ")))}async updateExtensions(v){const d=await this.b.getInstalled(h.ExtensionType.User,v),m=[];for(const a of d)a.identifier.uuid&&m.push({...a.identifier,preRelease:a.preRelease});this.a.trace((0,g.localize)(7,null,m.length));const k=await this.d.getExtensions(m,{compatible:!0},E.CancellationToken.None),y=[];for(const a of k)for(const n of d)(0,c.$Jp)(n.identifier,a.identifier)&&(0,A.gt)(a.version,n.manifest.version)&&y.push({extension:a,options:{operation:l.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:v,isApplicationScoped:n.isApplicationScoped}});if(!y.length){this.a.info((0,g.localize)(8,null));return}this.a.info((0,g.localize)(9,null,y.map(a=>a.extension.identifier.id).join(", ")));const e=await this.b.installGalleryExtensions(y);for(const a of e)a.error?this.a.error((0,g.localize)(10,null,a.identifier.id,(0,P.$_)(a.error))):this.a.info((0,g.localize)(11,null,a.identifier.id,a.local?.manifest.version))}async g(v,d,m){if(v=v.filter(({id:a,version:n})=>{const r=d.find(i=>(0,c.$Jp)(i.identifier,{id:a}));if(r){if(!m&&(!n||n==="prerelease"&&r.preRelease))return this.a.info((0,g.localize)(12,null,a,r.manifest.version,a)),!1;if(n&&r.manifest.version===n)return this.a.info((0,g.localize)(13,null,`${a}@${n}`)),!1}return!0}),!v.length)return[];const k=[],y=[],e=await this.j(v);if(await Promise.all(v.map(async({id:a,version:n,installOptions:r})=>{const i=e.get(a.toLowerCase());if(!i){this.a.error(`${u(n?`${a}@${n}`:a)}
${$}`),k.push(a);return}try{const o=await this.d.getManifest(i,E.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),k.push(a);return}const s=d.find(o=>(0,c.$Jp)(o.identifier,i.identifier));if(s){if(i.version===s.manifest.version){this.a.info((0,g.localize)(14,null,n?`${a}@${n}`:a));return}this.a.info((0,g.localize)(15,null,a,i.version))}r.isBuiltin?this.a.info(n?(0,g.localize)(16,null,a,n):(0,g.localize)(17,null,a)):this.a.info(n?(0,g.localize)(18,null,a,n):(0,g.localize)(19,null,a)),y.push({extension:i,options:{...r,installGivenVersion:!!n,isApplicationScoped:s?.isApplicationScoped}})})),y.length){const a=await this.b.installGalleryExtensions(y);for(const n of a)n.error?(this.a.error((0,g.localize)(20,null,n.identifier.id,(0,P.$_)(n.error))),k.push(n.identifier.id)):this.a.info((0,g.localize)(21,null,n.identifier.id,n.local?.manifest.version))}return k}async h(v,d,m,k){const y=await this.b.getManifest(v);if(!y)throw new Error("Invalid vsix");if(await this.l(y,m,d.profileLocation,k))try{await this.b.install(v,d),this.a.info((0,g.localize)(22,null,(0,O.$dh)(v)))}catch(a){if((0,P.$6)(a))this.a.info((0,g.localize)(23,null,(0,O.$dh)(v)));else throw a}}async j(v){const d=new Map,m=v.some(e=>e.installOptions.installPreReleaseVersion),k=await this.b.getTargetPlatform(),y=[];for(const e of v)l.$9o.test(e.id)&&y.push({...e,preRelease:m});if(y.length){const e=await this.d.getExtensions(y,{targetPlatform:k},E.CancellationToken.None);for(const a of e)d.set(a.identifier.id.toLowerCase(),a)}return d}k(v){return!0}async l(v,d,m,k){if(!d){const y={id:(0,c.$Op)(v.publisher,v.name)},e=k.find(a=>(0,c.$Jp)(y,a.identifier)&&(0,A.gt)(a.manifest.version,v.version));if(e)return this.a.info((0,g.localize)(24,null,e.identifier.id,e.manifest.version,v.version)),!1}return this.k(v)}async uninstallExtensions(v,d,m){const k=async e=>{if(e instanceof I.URI){const a=await this.b.getManifest(e);return(0,c.$Mp)(a.publisher,a.name)}return e},y=[];for(const e of v){const a=await k(e),r=(await this.b.getInstalled(void 0,m)).filter(i=>(0,c.$Jp)(i.identifier,{id:a}));if(!r.length)throw new Error(`${this.m(a)}
${$}`);if(r.some(i=>i.type===h.ExtensionType.System)){this.a.info((0,g.localize)(25,null,a));return}if(!d&&r.some(i=>i.isBuiltin)){this.a.info((0,g.localize)(26,null,a));return}this.a.info((0,g.localize)(27,null,a));for(const i of r)await this.b.uninstall(i,{profileLocation:m}),y.push(i);this.f?this.a.info((0,g.localize)(28,null,a,this.f)):this.a.info((0,g.localize)(29,null,a))}}async locateExtension(v){const d=await this.b.getInstalled();v.forEach(m=>{d.forEach(k=>{if(k.identifier.id===m&&k.location.scheme===w.Schemas.file){this.a.info(k.location.fsPath);return}})})}m(v){return this.f?(0,g.localize)(30,null,v,this.f):(0,g.localize)(31,null,v)}};t.$tq=p,t.$tq=p=ye([re(1,l.$lp),re(2,l.$ip)],p)}),define(oe[150],ae([0,1,5,2,31,27,23,10]),function(H,t,E,P,w,O,A,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uq=void 0;class g extends P.$Wc{constructor(c,h,u,$,p,R,v){super(),this.f=c,this.g=h,this.h=u,this.j=$,this.m=p,this.n=R,this.r=v,this.a=this.B(new E.$me),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new P.$6c),this.s().then(null,d=>v.error(d))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(h=>(this.c.set(h.id,(0,P.$Tc)(this.n.watch(this.m.extUri.dirname(h.extensionsResource)),this.n.watch(h.extensionsResource))),this.G(h.extensionsResource))))}catch(h){throw this.r.error(h),h}}async w(c){for(const h of c.extensions)this.I(this.L(h.identifier,h.version),c.profileLocation)}async y(c){for(const h of c.extensions){const u=this.L(h.identifier,h.version);c.error?this.J(u,c.profileLocation):this.I(u,c.profileLocation)}}async z(c){for(const h of c.extensions)this.J(this.L(h.identifier,h.version),c.profileLocation)}async C(c){const h=[],u=[];for(const $ of c.extensions){const p=this.L($.identifier,$.version);c.error?this.I(p,c.profileLocation):(this.J(p,c.profileLocation),this.b.has(p)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),u.push(this.f.scanInstalledExtensionAtLocation($.location).then(R=>{R?h.push(R):this.r.info("Extension not found at the location",$.location.toString())},R=>this.r.error(R)))))}try{await Promise.all(u),h.length&&await this.H(h)}catch($){this.r.error($)}}D(c){for(const h of this.h.profiles)c.contains(h.extensionsResource,I.FileChangeType.UPDATED,I.FileChangeType.ADDED)&&this.F(h.extensionsResource)}async F(c){const h=[],u=[],$=await this.j.scanProfileExtensions(c),p=new Set,R=new Set;for(const[v,d]of this.b)d.has(c)&&R.add(v);for(const v of $){const d=this.L(v.identifier,v.version);p.add(d),R.has(d)||(h.push(v.identifier),this.I(d,c))}for(const v of R)if(!p.has(v)){const d=this.M(v);d&&(u.push(d.identifier),this.J(v,c))}(h.length||u.length)&&this.a.fire({added:h.length?{extensions:h,profileLocation:c}:void 0,removed:u.length?{extensions:u,profileLocation:c}:void 0})}async G(c){const h=await this.j.scanProfileExtensions(c);for(const u of h)this.I(this.L(u.identifier,u.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(u=>!this.b.has(this.L(u.identifier,u.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,h){let u=this.b.get(c);u||this.b.set(c,u=new w.$Dc($=>this.m.extUri.getComparisonKey($))),u.add(h)}J(c,h){const u=this.b.get(c);u&&u.delete(h),u?.size||this.b.delete(c)}L(c,h){return`${A.$qn.toKey(c.id)}@${h}`}M(c){const[h,u]=(0,O.$Lp)(c);return u?{identifier:{id:h},version:u}:void 0}}t.$Uq=g}),define(oe[151],ae([0,1,178,20,8,2,15,16,26,18,21,27,6,68,12]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$r=void 0;let R=class extends $.$0r{constructor(k,y,e,a){super(e),this.h=k,this.j=a,this.g=this.B(new v(y,a)),this.h.registerParticipant({postInstall:async n=>this.m(n),postUninstall:async n=>this.n(n)})}async getBuiltInExtensionTranslationsUri(k,y){const a=(await this.g.getLanguagePacks())[y];if(!a){this.j.warn(`No language pack found for ${y}`);return}const n=a.translations[k];return n?p.URI.file(n):void 0}async getInstalledLanguages(){const k=await this.g.getLanguagePacks(),y=Object.keys(k).map(e=>{const a=k[e];return{...this.f(e,a.label),extensionId:a.extensions[0].extensionIdentifier.id}});return y.push(this.f("en","English")),y.sort((e,a)=>e.label.localeCompare(a.label)),y}async m(k){k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",k.identifier.id),await this.update())}async n(k){const y=await this.g.getLanguagePacks();Object.keys(y).some(e=>y[e]&&y[e].extensions.some(a=>(0,h.$Jp)(a.extensionIdentifier,k.identifier)))&&(this.j.info("Removing language packs from the extension",k.identifier.id),await this.update())}async update(){const[k,y]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),e=await this.g.update(y);return!(0,P.$wb)(Object.keys(k),Object.keys(e))}};t.$$r=R,t.$$r=R=ye([re(0,c.$lp),re(1,l.$Ni),re(2,c.$ip),re(3,u.$_j)],R);let v=class extends O.$Wc{constructor(k,y){super(),this.j=y,this.c={},this.f=(0,I.$lc)(k.userDataPath,"languagepacks.json"),this.g=new w.$Mh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(k){return this.s(y=>{Object.keys(y).forEach(e=>delete y[e]),this.m(y,...k)}).then(()=>this.c)}m(k,...y){for(const e of y)e&&e.manifest&&e.manifest.contributes&&e.manifest.contributes.localizations&&e.manifest.contributes.localizations.length&&this.n(k,e);Object.keys(k).forEach(e=>this.r(k[e]))}n(k,y){const e=y.identifier,a=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const n of a)if(y.location.scheme===A.Schemas.file&&d(n)){let r=k[n.languageId];r||(r={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},k[n.languageId]=r);const i=r.extensions.filter(s=>(0,h.$Jp)(s.extensionIdentifier,e))[0];i?i.version=y.manifest.version:r.extensions.push({extensionIdentifier:e,version:y.manifest.version});for(const s of n.translations)r.translations[s.id]=(0,I.$lc)(y.location.fsPath,s.path)}}r(k){if(k){const y=(0,E.createHash)("md5");for(const e of k.extensions)y.update(e.extensionIdentifier.uuid||e.extensionIdentifier.id).update(e.version);k.hash=y.digest("hex")}}s(k=()=>null){return this.g.queue(()=>{let y=null;return g.Promises.readFile(this.f,"utf8").then(void 0,e=>e.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(e)).then(e=>{try{return JSON.parse(e)}catch{return{}}}).then(e=>(y=k(e),e)).then(e=>{for(const n of Object.keys(e))e[n]||delete e[n];this.c=e,this.h=!0;const a=JSON.stringify(this.c);return this.j.debug("Writing language packs",a),g.Promises.writeFile(this.f,a)}).then(()=>y,e=>this.j.error(e))})}};v=ye([re(0,l.$Ni),re(1,u.$_j)],v);function d(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const k of m.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(oe[152],ae([0,1,87,9,28,41]),function(H,t,E,P,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bR=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function g(c,h,u){const $=await(0,E.$sE)("@microsoft/1ds-core-js","dist/ms.core.js"),p=await(0,E.$sE)("@microsoft/1ds-post-js","dist/ms.post.js"),R=new $.AppInsightsCore,v=new p.PostChannel,d={instrumentationKey:c,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(u){d.extensionConfig={};const m={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:u};d.extensionConfig[v.identifier]=m}return R.initialize(d,[]),R.addTelemetryInitializer(m=>{m.ext=m.ext??{},m.ext.web=m.ext.web??{},m.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',h&&(m.ext.utc=m.ext.utc??{},m.ext.utc.flags=8462029)}),R}class l{constructor(h,u,$,p,R){this.e=h,this.f=u,this.g=$,this.h=R,this.c=A,this.d=I,this.g||(this.g={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}i(h){if(this.a){if(typeof this.a!="string"){h(this.a);return}this.b||(this.b=g(this.a,this.e,this.h)),this.b.then(u=>{h(u)},u=>{(0,P.$3)(u),console.error(u)})}}log(h,u){if(!this.a)return;u=(0,w.$go)(u,this.g),u=(0,O.$Ep)(u);const $=this.f+"/"+h;try{this.i(p=>{p.pluginVersionString=u?.properties.version??"Unknown",p.track({name:$,baseData:{name:$,properties:u?.properties,measurements:u?.measurements}})})}catch{}}flush(){return this.a?new Promise(h=>{this.i(u=>{u.unload(!0,()=>{this.a=void 0,h(void 0)})})}):Promise.resolve(void 0)}}t.$bR=l});var Me=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(oe[153],ae([0,1,2,28,13,32,113,30,40,154,33,37,19,41]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$es=void 0,l=Me(l);let p=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,m,k){this.k=m,this.l=k,this.d={},this.i=new E.$Vc,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=u.TelemetryLevel.USAGE,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,O.$if)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$if)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(u.$hm)||y.affectsConfiguration(u.$jm)||y.affectsConfiguration(u.$im))&&this.m()}))}setExperimentProperty(d,m){this.d[d]=m}m(){let d=(0,$.$Dp)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const k=m.usage?u.TelemetryLevel.USAGE:m.error?u.TelemetryLevel.ERROR:u.TelemetryLevel.NONE;d=Math.min(d,k)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,m,k){this.g<m||(k=(0,P.$go)(k,this.d),k=(0,$.$Ip)(k,this.j),k=(0,P.$go)(k,this.c),this.b.forEach(y=>y.log(d,k)))}publicLog(d,m){this.n(d,u.TelemetryLevel.USAGE,m)}publicLog2(d,m){this.publicLog(d,m)}publicLogError(d,m){this.h&&this.n(d,u.TelemetryLevel.ERROR,m)}publicLogError2(d,m){this.publicLogError(d,m)}};t.$es=p,t.$es=p=ye([re(1,I.$_i),re(2,c.$sk)],p);function R(){const v=(0,A.localize)(0,null,l.default.nameLong),d=l.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=w.$o?"":(0,A.localize)(3,null),k=(0,A.localize)(4,null),y=(0,A.localize)(5,null),e=(0,A.localize)(6,null),a=(0,A.localize)(7,null),n=`
|       | ${k} | ${y} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,A.localize)(8,null);return`
${v} ${d} ${m}

&nbsp;

${a}
${n}

&nbsp;

${r}
`}h.$qo.as(g.$vo.Configuration).registerConfiguration({id:u.$gm,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[u.$hm]:{type:"string",enum:[u.TelemetryConfiguration.ON,u.TelemetryConfiguration.ERROR,u.TelemetryConfiguration.CRASH,u.TelemetryConfiguration.OFF],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:R(),default:u.TelemetryConfiguration.ON,restricted:!0,scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),h.$qo.as(g.$vo.Configuration).registerConfiguration({id:u.$gm,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[u.$jm]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,A.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,A.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${u.$hm}#\``),scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[155],ae([0,1,14,22,179,152]),function(H,t,E,P,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cR=void 0,w=be(w);async function A(c,h){const u=await h.request(c,P.CancellationToken.None),$=(await(0,E.$1e)(u.stream)).toString(),p=u.res.statusCode??200;return{headers:u.res.headers,statusCode:p,responseData:$}}async function I(c){const h={method:c.type,headers:c.headers};return new Promise(($,p)=>{const R=w.request(c.url??"",h,v=>{v.on("data",function(d){$({headers:v.headers,statusCode:v.statusCode??200,responseData:d.toString()})}),v.on("error",function(d){p(d)})});R.write(c.data,v=>{v&&p(v)}),R.end()})}async function g(c,h,u){const $=typeof h.data=="string"?h.data:new TextDecoder().decode(h.data),p={type:"POST",headers:{...h.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(h.data).toString()},url:h.urlString,data:$};try{const R=c?await A(p,c):await I(p);u(R.statusCode,R.headers,R.responseData)}catch{u(0,{})}}class l extends O.$bR{constructor(h,u,$,p,R){const v={sendPOST:(d,m)=>{g(h,d,m)}};super(u,$,p,R,v)}}t.$cR=l}),define(oe[156],ae([0,1,16,26]),function(H,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rgc=w;async function w(O,A){const I=Object.create(null),g=(c,h)=>{const u=JSON.parse(c);I[h]=u};if(A){const c=[],h=await P.Promises.readdir(A);for(const $ of h)try{(await P.Promises.stat((0,E.$lc)(A,$))).isDirectory()&&c.push($)}catch{}const u=[];for(const $ of c)(await P.Promises.readdir((0,E.$lc)(A,$))).filter(R=>R==="telemetry.json").length===1&&u.push($);for(const $ of u){const p=(await P.Promises.readFile((0,E.$lc)(A,$,"telemetry.json"))).toString();g(p,$)}}let l=(await P.Promises.readFile((0,E.$lc)(O,"telemetry-core.json"))).toString();return g(l,"vscode-core"),l=(await P.Promises.readFile((0,E.$lc)(O,"telemetry-extensions.json"))).toString(),g(l,"vscode-extensions"),JSON.stringify(I,null,4)}}),define(oe[157],ae([0,1,13,88,19]),function(H,t,E,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bgc=O,t.$cgc=A,t.$dgc=I;async function O(g,l){let c=g.getItem(w.$dm);return(typeof c!="string"||E.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,P.$Sn)(l.error.bind(l))),c}async function A(g,l){let c=g.getItem(w.$em);return typeof c!="string"&&(c=await(0,P.$Tn)(l.error.bind(l))),c}async function I(g,l){let c=g.getItem(w.$fm);return typeof c!="string"&&(c=await(0,P.$Un)(l.error.bind(l))),c}}),define(oe[24],ae([0,1,11]),function(H,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jl=void 0,t.$Jl=(0,E.$Fi)("IUriIdentityService")}),define(oe[158],ae([0,1,24,123,10,17,79,5,2]),function(H,t,E,P,w,O,A,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rs=void 0;class l{static{this._clock=0}constructor(u){this.uri=u,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let c=class{constructor(u){this.g=u,this.c=new g.$Vc,this.f=2**16;const $=new Map,p=R=>{let v=$.get(R.scheme);return v===void 0&&(v=u.hasProvider(R)&&!this.g.hasCapability(R,w.FileSystemProviderCapabilities.PathCaseSensitive),$.set(R.scheme,v)),v};this.c.add(I.Event.any(u.onDidChangeFileSystemProviderRegistrations,u.onDidChangeFileSystemProviderCapabilities)(R=>{$.delete(R.scheme)})),this.extUri=new O.$8g(p),this.d=new A.$Qs((R,v)=>this.extUri.compare(R,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(u){this.g.hasProvider(u)&&(u=(0,O.$hh)(u));const $=this.d.get(u);return $?$.touch().uri.with({fragment:u.fragment}):(this.d.set(u,new l(u)),this.h(),u)}h(){if(this.d.size<this.f)return;const u=[...this.d.entries()].sort((p,R)=>p[1].time<R[1].time?1:p[1].time>R[1].time?-1:0);l._clock=0,this.d.clear();const $=this.f*.5;for(let p=0;p<$;p++)this.d.set(u[p][0],u[p][1].touch())}};t.$Rs=c,t.$Rs=c=ye([re(0,w.$_k)],c),(0,P.$Os)(E.$Jl,c,P.InstantiationType.Delayed)}),define(oe[159],ae([0,1,5,2,10,49,31]),function(H,t,E,P,w,O,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bgc=void 0;class I extends P.$Wc{constructor(l,c,h,u,$,p){super(),this.f=l,this.g=c,this.h=h,this.j=u,this.m=$,this.n=p,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new E.$me),this.onDidChangeFile=this.a.event,this.b=O.$Li.forUris(()=>!(this.capabilities&w.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new A.$Dc(R=>this.m.extUri.getComparisonKey(this.t(R))),this.r(),this.B(u.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(R=>this.s(R)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,c){return this.g.open(this.t(l),c)}close(l){return this.g.close(l)}read(l,c,h,u,$){return this.g.read(l,c,h,u,$)}write(l,c,h,u,$){return this.g.write(l,c,h,u,$)}watch(l,c){this.b.set(l,l);const h=this.g.watch(this.t(l),c);return(0,P.$Uc)(()=>{this.b.delete(l),h.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,c,h){return this.g.rename(this.t(l),this.t(c),h)}readFile(l,c){return this.g.readFile(this.t(l),c)}readFileStream(l,c,h){return this.g.readFileStream(this.t(l),c,h)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,c,h){return this.g.writeFile(this.t(l),c,h)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,c){return this.g.delete(this.t(l),c)}copy(l,c,h){if((0,w.$dl)(this.g))return this.g.copy(this.t(l),this.t(c),h);throw new Error("copy not supported")}cloneFile(l,c){if((0,w.$el)(this.g))return this.g.cloneFile(this.t(l),this.t(c));throw new Error("clone not supported")}s(l){const c=[];for(const h of l){if(h.resource.scheme!==this.f)continue;const u=this.u(h.resource);this.b.findSubstr(u)&&c.push({resource:u,type:h.type,cId:h.cId})}c.length&&(this.n.debug("User data changed"),this.a.fire(c))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}t.$Bgc=I}),define(oe[160],ae([0,1,115,16,49,17,12,11,15]),function(H,t,E,P,w,O,A,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8i=t.$5i=t.$4i=t.$3i=t.$2i=t.$Zi=t.$Yi=t.WorkbenchState=t.$Si=t.$Ri=t.$Oi=void 0,t.$Pi=l,t.$Qi=c,t.$Ti=h,t.$Ui=u,t.$Vi=$,t.$Wi=R,t.$Xi=v,t.$1i=k,t.$6i=y,t.$7i=e,t.$9i=a,t.$0i=n,t.$$i=r,t.$Oi=(0,I.$Fi)("contextService");function l(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}function c(i){return typeof i?.id=="string"&&!l(i)&&!u(i)}t.$Ri={id:"ext-dev"},t.$Si={id:"empty-window"};function h(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,P.$pc)(i)}:s?t.$Ri:t.$Si;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function u(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}function $(i){const s=i;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p||(t.WorkbenchState=p={}));function R(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function v(i){const s=i;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class d{constructor(s,o,f,b,D){this.h=s,this.j=f,this.k=b,this.l=D,this.c=w.$Li.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=w.$Li.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}t.$Yi=d;class m{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,O.$gh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.$Zi=m;function k(i){return new m({uri:i,index:0,name:(0,O.$ch)(i)},{uri:i.toString()})}t.$2i="code-workspace",t.$3i=`.${t.$2i}`,t.$4i=[{name:(0,E.localize)(0,null),extensions:[t.$2i]}],t.$5i="workspace.json";function y(i,s){return O.$0g.isEqualOrParent(i,s.untitledWorkspacesHome)}function e(i){let s;return A.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===g.Schemas.tmp}t.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function a(i){return i.id===t.$8i}function n(i,s){return!y(i,s)&&!e(i)}function r(i){return(typeof i=="string"?(0,P.$qc)(i):(0,O.$eh)(i))===t.$3i}}),define(oe[25],ae([0,1,43,5,2,17,12,114,18,10,11,6,160,31,24,8,29,32,3]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$,p,R,v,d,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pl=t.$Ol=t.$Ll=t.ProfileResourceType=void 0,t.$Kl=y,t.$Ml=e,t.$Nl=a;var k;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(k||(t.ProfileResourceType=k={}));function y(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}t.$Ll=(0,c.$Fi)("IUserDataProfilesService");function e(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:s}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function a(i,s,o,f,b,D){return{id:i,name:s,location:o,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:D&&b?.useDefaultFlags?.globalState?D.globalStorageHome:(0,O.$gh)(o,"globalStorage"),settingsResource:D&&b?.useDefaultFlags?.settings?D.settingsResource:(0,O.$gh)(o,"settings.json"),keybindingsResource:D&&b?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,O.$gh)(o,"keybindings.json"),tasksResource:D&&b?.useDefaultFlags?.tasks?D.tasksResource:(0,O.$gh)(o,"tasks.json"),snippetsHome:D&&b?.useDefaultFlags?.snippets?D.snippetsHome:(0,O.$gh)(o,"snippets"),extensionsResource:D&&b?.useDefaultFlags?.extensions?D.extensionsResource:(0,O.$gh)(o,"extensions.json"),cacheHome:(0,O.$gh)(f,i),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let n=class extends w.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,f,b){super(),this.t=s,this.u=o,this.w=f,this.y=b,this.f=!0,this.h=this.B(new P.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new P.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new P.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new P.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new $.$Cc,workspaces:new $.$Cc,emptyWindows:new Map},this.profilesHome=(0,O.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,m.$fg)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}o.push(a((0,O.$dh)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},s))}}catch(D){this.y.error(D)}const f=new $.$Cc,b=new Map;if(o.length)try{const D=this.Q();if(D.workspaces)for(const[T,N]of Object.entries(D.workspaces)){const C=A.URI.parse(T),z=o.find(X=>X.id===N);z&&f.set(C,z)}if(D.emptyWindows)for(const[T,N]of Object.entries(D.emptyWindows)){const C=o.find(z=>z.id===N);C&&b.set(T,C)}}catch(D){this.y.error(D)}this.z={profiles:o,workspaces:f,emptyWindows:b}}return this.z}D(){const s=a("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",f=new RegExp(`${(0,d.$if)(o)}\\s(\\d+)`);let b=0;for(const T of this.profiles){const N=f.exec(T.name),C=N?parseInt(N[1]):0;b=C>b?C:b}const D=`${o} ${b+1}`;return this.createProfile((0,E.$tj)((0,v.$2g)()).toString(16),D,{transient:!0},s)}async createNamedProfile(s,o,f){return this.createProfile((0,E.$tj)((0,v.$2g)()).toString(16),s,o,f)}async createProfile(s,o,f,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(s,o,f);return b&&await this.setProfileForWorkspace(b,D),D}async F(s,o,f){if(!(0,m.$fg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.r.get(o);return b||(b=(async()=>{try{if(this.profiles.find(C=>C.name===o||C.id===s))throw new Error(`Profile with ${o} name already exists`);const T=a(s,o,(0,O.$gh)(this.profilesHome,s),this.g,f,this.defaultProfile);await this.u.createFolder(T.location);const N=[];return this.j.fire({profile:T,join(C){N.push(C)}}),await R.Promises.settled(N),this.I([T],[],[]),T}finally{this.r.delete(o)}})(),this.r.set(o,b)),b}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(b=>b.id===s.id);if(!f)throw new Error(`Profile '${s.name}' does not exist`);return f=a(f.id,o.name??f.name,f.location,this.g,{shortName:o.shortName??f.shortName,icon:o.icon===null?void 0:o.icon??f.icon,transient:o.transient??f.isTransient,useDefaultFlags:o.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.I([],[],[f]),f}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(b=>b.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const f=[];this.m.fire({profile:o,join(b){f.push(b)}});try{await Promise.allSettled(f)}catch(b){this.y.error(b)}for(const b of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(b)?.id&&this.C.emptyWindows.delete(b);for(const b of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(b)?.id&&this.C.workspaces.delete(b);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(b){(0,l.$ql)(b)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(b)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(b=>b.id===o.id);if(!f)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,f)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(f=>!this.w.extUri.isEqual(f.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s),f=A.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return f||((0,u.$Pi)(s)?this.s.folders.get(s.uri):(0,u.$Ui)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,u.$Pi)(s)?s.uri:(0,u.$Ui)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,f){const b=[...this.profiles,...s],D=[],T=this.s.profiles;this.s.profiles=[];for(let N of b){if(N.isDefault||o.some(z=>N.id===z.id))continue;N=f.find(z=>N.id===z.id)??N;const C=T.find(z=>N.id===z.id);if(N.isTransient)this.s.profiles.push(N);else{if(C){for(const[z,X]of this.s.emptyWindows.entries())if(N.id===X.id){this.L({id:z},N);break}for(const[z,X]of this.s.workspaces.entries())if(N.id===X.id){this.L({id:"",configPath:z},N);break}for(const[z,X]of this.s.folders.entries())if(N.id===X.id){this.L({id:"",uri:z},N);break}}D.push({location:N.location,name:N.name,shortName:N.shortName,icon:N.icon,useDefaultFlags:N.useDefaultFlags})}}this.P(D),this.z=void 0,this.J(s,o,f)}J(s,o,f){this.h.fire({added:s,removed:o,updated:f,all:this.profiles})}L(s,o,f){if(f=o?.isTransient?!0:f,f)(0,u.$Pi)(s)?(this.s.folders.delete(s.uri),o&&this.s.folders.set(s.uri,o)):(0,u.$Ui)(s)?(this.s.workspaces.delete(s.configPath),o&&this.s.workspaces.set(s.configPath,o)):(this.s.emptyWindows.delete(s.id),o&&this.s.emptyWindows.set(s.id,o));else{this.L(s,void 0,!0);const b=this.G(s);A.URI.isUri(b)?(this.C.workspaces.delete(b),o&&this.C.workspaces.set(b,o)):(this.C.emptyWindows.delete(b),o&&this.C.emptyWindows.set(b,o)),this.M()}}M(){const s={};for(const[f,b]of this.C.workspaces.entries())s[f.toString()]=b.id;const o={};for(const[f,b]of this.C.emptyWindows.entries())o[f.toString()]=b.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},f=this.D();if(s.workspaces)for(const[D,T]of Object.entries(s.workspaces)){const N=A.URI.parse(T);o[D]=this.w.extUri.isEqual(N,f.location)?f.id:this.w.extUri.basename(N)}const b={};if(s.emptyWindows)for(const[D,T]of Object.entries(s.emptyWindows)){const N=A.URI.parse(T);b[D]=this.w.extUri.isEqual(N,f.location)?f.id:this.w.extUri.basename(N)}return{workspaces:o,emptyWindows:b}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};t.$Ol=n,t.$Ol=n=ye([re(0,g.$Mi),re(1,l.$_k),re(2,p.$Jl),re(3,h.$_j)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}t.$Pl=r}),define(oe[53],ae([0,1,20,8,22,9,5,2,13,3,12,98,21,27,23,44,6,33,19,24,25]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$,p,R,v,d,m,k,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Eq=t.$Cq=void 0,t.$Dq=a,h=be(h);let e=class extends I.$Wc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,f,b,D,T){super(),this.z=s,this.C=o,this.D=f,this.F=b,this.G=D,this.H=T,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$me),this.s=this.B(new A.$me),this.t=this.B(new A.$me),this.u=this.B(new A.$me),this.w=this.B(new A.$me),this.y=[],this.B((0,I.$Uc)(()=>{this.j.forEach(({task:N})=>N.cancel()),this.m.forEach(N=>N.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(f=>(0,u.$gp)(f,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const b=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:D})=>(0,$.$Jp)(D,s.identifier));if(b?.local)return b?.local;throw b?.error?b.error:new u.$kp(`Unknown error while installing extension ${s.identifier.id}`,u.ExtensionManagementErrorCode.Unknown)}catch(f){throw a(f)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new u.$kp(h.localize(0,null),u.ExtensionManagementErrorCode.NotAllowed);const o=[],f=[];return await Promise.allSettled(s.map(async({extension:b,options:D})=>{try{const T=await this.N(b,!!D?.installGivenVersion,!!D?.installPreReleaseVersion,D.productVersion??{version:this.G.version,date:this.G.date});f.push({...T,options:D})}catch(T){o.push({identifier:b.identifier,operation:u.InstallOperation.Install,source:b,error:T,profileLocation:D.profileLocation??this.X()})}})),f.length&&o.push(...await this.I(f)),o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,p.$tn)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let f=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(f=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const b of this.H.profiles){const D=(await this.getInstalled(p.ExtensionType.User,b.extensionsResource)).find(T=>(0,$.$Jp)(T.identifier,s.identifier));D?this.w.fire({local:D,profileLocation:b.extensionsResource}):this.u.fire({identifier:s.identifier,profileLocation:b.extensionsResource})}return f}else{const f=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:f.identifier,operation:u.InstallOperation.Install,local:f,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),f}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=new Map,f=new Map,b=[],D=(N,C)=>`${$.$Kp.create(N).toString()}-${C.toString()}`,T=(N,C,z,X)=>{const Y=this.Y(N,C,z),se=`${(0,$.$Op)(N.publisher,N.name)}-${z.profileLocation.toString()}`;f.set(se,{task:Y,root:X}),this.n.fire({identifier:Y.identifier,source:C,profileLocation:z.profileLocation}),this.F.info("Installing extension:",Y.identifier.id,z),c.URI.isUri(C)||this.j.set(D(C,z.profileLocation),{task:Y,waitingTasks:[]})};try{for(const{manifest:N,extension:C,options:z}of s){const X=z.isApplicationScoped||z.isBuiltin||(0,p.$tn)(N),Y={...z,installOnlyNewlyAddedFromExtensionPack:z.installOnlyNewlyAddedFromExtensionPack??!c.URI.isUri(C),isApplicationScoped:X,profileLocation:X?this.H.defaultProfile.extensionsResource:z.profileLocation??this.X(),productVersion:z.productVersion??{version:this.G.version,date:this.G.date}},se=c.URI.isUri(C)?void 0:this.j.get(D(C,Y.profileLocation));se?(this.F.info("Extension is already requested to install",se.task.identifier.id,Y.profileLocation.toString()),b.push(se.task.waitUntilTaskIsFinished())):T(N,C,Y,void 0)}return await Promise.all([...f.values()].map(async({task:N})=>{if(N.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const C=await this.M(N.identifier,N.manifest,!!N.options.installOnlyNewlyAddedFromExtensionPack,!!N.options.installPreReleaseVersion,N.options.profileLocation,N.options.productVersion),z=await this.getInstalled(void 0,N.options.profileLocation,N.options.productVersion),X={...N.options,context:{...N.options.context,[u.$ap]:!0}};for(const{gallery:Y,manifest:se}of(0,E.$Ob)(C,({gallery:le})=>le.identifier.id)){if(f.has(`${Y.identifier.id.toLowerCase()}-${X.profileLocation.toString()}`))continue;const le=this.j.get(D(Y,X.profileLocation));if(le){if(this.J(N,le.task)){const ue=le.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,N.identifier.id,X.profileLocation.toString()),le.waitingTasks.push(N),b.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,fe=>fe.some(x=>(0,$.$Jp)(x.identifier,ue)))).then(fe=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,N.identifier.id,X.profileLocation.toString()),!fe.find(_=>(0,$.$Jp)(_.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else z.some(({identifier:ue})=>(0,$.$Jp)(ue,Y.identifier))||T(se,Y,X,N)}}catch(C){if(c.URI.isUri(N.source))(0,E.$Nb)(N.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",N.identifier.id,C.message),(0,E.$Nb)(N.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",N.identifier.id,C.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),C}})),await this.L([...f.entries()].map(async([N,{task:C}])=>{const z=new Date().getTime();let X;try{X=await C.run(),await this.L(this.y.map(Y=>Y.postInstall(X,C.source,C.options,w.CancellationToken.None)),u.ExtensionManagementErrorCode.PostInstall)}catch(Y){const se=a(Y);throw c.URI.isUri(C.source)||n(this.C,C.operation===u.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Rp)(C.source),error:se,source:C.options.context?.[u.$_o]}),o.set(N,{error:se,identifier:C.identifier,operation:C.operation,source:C.source,context:C.options.context,profileLocation:C.options.profileLocation,applicationScoped:C.options.isApplicationScoped}),this.F.error("Error while installing the extension",C.identifier.id,(0,O.$_)(se),C.options.profileLocation.toString()),se}if(!c.URI.isUri(C.source)){const Y=C.operation===u.InstallOperation.Update,se=Y?void 0:(new Date().getTime()-C.source.lastUpdated)/1e3;if(n(this.C,Y?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Rp)(C.source),verificationStatus:C.verificationStatus,duration:new Date().getTime()-z,durationSinceUpdate:se,source:C.options.context?.[u.$_o]}),g.$o&&C.operation!==u.InstallOperation.Update)try{await this.z.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,u.StatisticType.Install)}catch{}}o.set(N,{local:X,identifier:C.identifier,operation:C.operation,source:C.source,context:C.options.context,profileLocation:C.options.profileLocation,applicationScoped:X.isApplicationScoped})})),b.length&&await this.L(b),[...o.values()]}catch(N){const C=(Y,se,le)=>{const ue=[];Y.manifest.extensionDependencies?.length&&ue.push(...Y.manifest.extensionDependencies),Y.manifest.extensionPack?.length&&ue.push(...Y.manifest.extensionPack);for(const fe of ue){if(le.includes(fe.toLowerCase()))continue;le.push(fe.toLowerCase());const x=o.get(`${fe.toLowerCase()}-${se.toString()}`);x?.local&&(le=C(x.local,se,le))}return le},z=Y=>({identifier:Y.identifier,operation:u.InstallOperation.Install,source:Y.source,context:Y.options.context,profileLocation:Y.options.profileLocation,error:N}),X=[];for(const[Y,{task:se,root:le}]of f){const ue=o.get(Y);ue?ue.local&&le&&!o.get(`${le.identifier.id.toLowerCase()}-${se.options.profileLocation.toString()}`)?.local&&(X.push(this.Z(ue.local,{versionOnly:!0,profileLocation:se.options.profileLocation})),o.set(Y,z(se))):(se.cancel(),o.set(Y,z(se)))}for(const[Y,{task:se}]of f){const le=o.get(Y);if(!le?.local||se.options.donotIncludePackAndDependencies)continue;C(le.local,se.options.profileLocation,[le.local.identifier.id.toLowerCase()]).slice(1).some(fe=>f.has(`${fe.toLowerCase()}-${se.options.profileLocation.toString()}`)&&!o.get(`${fe.toLowerCase()}-${se.options.profileLocation.toString()}`)?.local)&&(X.push(this.Z(le.local,{versionOnly:!0,profileLocation:se.options.profileLocation})),o.set(Y,z(se)))}throw X.length&&await Promise.allSettled(X.map(async Y=>{try{await Y.run(),this.F.info("Rollback: Uninstalled extension",Y.extension.identifier.id)}catch(se){this.F.warn("Rollback: Error while uninstalling extension",Y.extension.identifier.id,(0,O.$_)(se))}})),N}finally{for(const{task:N}of f.values())N.source&&!c.URI.isUri(N.source)&&this.j.delete(D(N.source,N.options.profileLocation));if(o.size){const N=[...o.values()];for(const C of N)C.local&&this.F.info("Extension installed successfully:",C.identifier.id,C.profileLocation.toString());this.s.fire(N)}}}J(s,o){for(const[,{task:f,waitingTasks:b}]of this.j.entries())if(f===s&&(b.includes(o)||b.some(D=>this.J(D,o)))||f===o&&b[0]&&!this.J(s,b[0]))return!1;return!0}async L(s,o){const f=[],b=[],D=await Promise.allSettled(s);for(const N of D)N.status==="fulfilled"?f.push(N.value):b.push(a(N.reason,o));if(!b.length)return f;if(b.length===1)throw b[0];let T=new u.$kp("",u.ExtensionManagementErrorCode.Unknown);for(const N of b)T=new u.$kp(T.message?`${T.message}, ${N.message}`:N.message,N.code!==u.ExtensionManagementErrorCode.Unknown&&N.code!==u.ExtensionManagementErrorCode.Internal?N.code:T.code);throw T}async M(s,o,f,b,D,T){if(!this.z.isEnabled())return[];const N=await this.getInstalled(void 0,D,T),C=[],z=[],X=async(Y,se)=>{C.push(Y);const le=se.extensionDependencies||[],ue=[...le];if(se.extensionPack){const fe=f?N.find(x=>(0,$.$Jp)(x.identifier,Y)):void 0;for(const x of se.extensionPack)fe&&fe.manifest.extensionPack&&fe.manifest.extensionPack.some(_=>(0,$.$Jp)({id:_},{id:x}))||ue.every(_=>!(0,$.$Jp)({id:_},{id:x}))&&ue.push(x)}if(ue.length){const fe=ue.filter(x=>C.every(_=>!(0,$.$Jp)(_,{id:x})));if(fe.length){const x=await this.z.getExtensions(fe.map(_=>({id:_,preRelease:b})),w.CancellationToken.None);for(const _ of x){if(C.find(G=>(0,$.$Jp)(G,_.identifier)))continue;const V=le.some(G=>(0,$.$Jp)({id:G},_.identifier));let q;try{q=await this.N(_,!1,b,T)}catch(G){if(V)throw G;this.F.info("Skipping the packed extension as it cannot be installed",_.identifier.id,(0,O.$_)(G));continue}z.push({gallery:q.extension,manifest:q.manifest}),await X(q.extension.identifier,q.manifest)}}}};return await X(s,o),z}async N(s,o,f,b){let D;const T=await this.getExtensionsControlManifest();if(T.malicious.some(z=>(0,$.$Jp)(s.identifier,z)))throw new u.$kp(h.localize(1,null,s.identifier.id),u.ExtensionManagementErrorCode.Malicious);const N=T.deprecated[s.identifier.id.toLowerCase()];if(N?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${N.extension.id}' extension instead.`),D=(await this.z.getExtensions([{id:N.extension.id,preRelease:N.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:b},w.CancellationToken.None))[0],!D)throw new u.$kp(h.localize(2,null,s.identifier.id,N.extension.id),u.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const z=await this.getTargetPlatform();throw new u.$kp(h.localize(3,null,s.identifier.id,this.G.nameLong,(0,u.$cp)(z)),u.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(D=await this.O(s,o,f,b),!D){const z=[];throw(0,R.$4p)(s.properties.enabledApiProposals??[],z)?!f&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],w.CancellationToken.None))[0]?new u.$kp(h.localize(5,null,s.displayName??s.identifier.id),u.ExtensionManagementErrorCode.ReleaseVersionNotFound):new u.$kp(h.localize(6,null,s.identifier.id,this.G.nameLong,this.G.version),u.ExtensionManagementErrorCode.Incompatible):new u.$kp(h.localize(4,null,s.displayName??s.identifier.id,z[0]),u.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",D.identifier.id);const C=await this.z.getManifest(D,w.CancellationToken.None);if(C===null)throw new u.$kp(`Missing manifest for extension ${D.identifier.id}`,u.ExtensionManagementErrorCode.Invalid);if(C.version!==D.version)throw new u.$kp(`Cannot install '${D.identifier.id}' extension because of version mismatch in Marketplace`,u.ExtensionManagementErrorCode.Invalid);return{extension:D,manifest:C}}async O(s,o,f,b){const D=await this.getTargetPlatform();let T=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==f&&(T=(await this.z.getExtensions([{...s.identifier,preRelease:f}],{targetPlatform:D,compatible:!0,productVersion:b},w.CancellationToken.None))[0]||null),!T&&await this.z.isExtensionCompatible(s,f,D,b)&&(T=s),T||(o?T=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:D,compatible:!0,productVersion:b},w.CancellationToken.None))[0]||null:T=await this.z.getCompatibleExtension(s,f,D,b)),T}async P(s,o){const f={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},b=X=>`${X.id.toLowerCase()}${f.versionOnly?`-${s.manifest.version}`:""}${f.profileLocation?`@${f.profileLocation.toString()}`:""}`,D=this.m.get(b(s.identifier));if(D)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),D.waitUntilTaskIsFinished();const T=X=>{const Y=this.Z(X,f);return this.m.set(b(Y.extension.identifier),Y),f.profileLocation?this.F.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,f.profileLocation.toString()):this.F.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this.t.fire({identifier:X.identifier,profileLocation:f.profileLocation,applicationScoped:X.isApplicationScoped}),Y},N=(X,Y)=>{Y?f.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,f.profileLocation.toString(),Y.message):this.F.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,Y.message):f.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,f.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),n(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$Qp)(X),error:Y}),this.u.fire({identifier:X.identifier,error:Y?.code,profileLocation:f.profileLocation,applicationScoped:X.isApplicationScoped})},C=[],z=[];try{C.push(T(s));const X=await this.getInstalled(p.ExtensionType.User,f.profileLocation);if(f.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const Y=this.S(s,X);for(const se of Y)this.m.has(b(se.identifier))?this.F.info("Extensions is already requested to uninstall",se.identifier.id):C.push(T(se))}f.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(C.map(Y=>Y.extension),X,s),await this.L(C.map(async Y=>{try{if(await Y.run(),await this.L(this.y.map(se=>se.postUninstall(Y.extension,f,w.CancellationToken.None))),Y.extension.identifier.uuid)try{await this.z.reportStatistic(Y.extension.manifest.publisher,Y.extension.manifest.name,Y.extension.manifest.version,u.StatisticType.Uninstall)}catch{}N(Y.extension)}catch(se){const le=a(se);throw N(Y.extension,le),le}finally{z.push(Y)}}))}catch(X){const Y=a(X);for(const se of C){try{se.cancel()}catch{}z.includes(se)||N(se.extension,Y)}throw Y}finally{for(const X of C)this.m.delete(b(X.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}Q(s,o,f){for(const b of s){const D=this.U(b,o);if(D.length){const T=D.filter(N=>!s.some(C=>(0,$.$Jp)(C.identifier,N.identifier)));if(T.length)throw new Error(this.R(b,T,f))}}}R(s,o,f){return f===s?o.length===1?h.localize(7,null,f.manifest.displayName||f.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?h.localize(8,null,f.manifest.displayName||f.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):h.localize(9,null,f.manifest.displayName||f.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?h.localize(10,null,f.manifest.displayName||f.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?h.localize(11,null,f.manifest.displayName||f.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):h.localize(12,null,f.manifest.displayName||f.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,f=[]){if(f.indexOf(s)!==-1)return[];f.push(s);const b=s.manifest.extensionPack?s.manifest.extensionPack:[];if(b.length){const D=o.filter(N=>!N.isBuiltin&&b.some(C=>(0,$.$Jp)({id:C},N.identifier))),T=[];for(const N of D)T.push(...this.S(N,o,f));return[...D,...T]}return[]}U(s,o){return o.filter(f=>f.manifest.extensionDependencies&&f.manifest.extensionDependencies.some(b=>(0,$.$Jp)({id:b},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,O.$_)(s)),{malicious:[],deprecated:{},search:[]}}}};t.$Cq=e,t.$Cq=e=ye([re(0,u.$ip),re(1,m.$$l),re(2,k.$Jl),re(3,v.$_j),re(4,d.$sk),re(5,y.$Ll)],e);function a(i,s){if(i instanceof u.$kp)return i;let o;return i instanceof u.$jp?o=new u.$kp(i.message,i.code===u.ExtensionGalleryErrorCode.DownloadFailedWriting?u.ExtensionManagementErrorCode.DownloadFailedWriting:u.ExtensionManagementErrorCode.Gallery):o=new u.$kp(i.message,(0,O.$6)(i)?u.ExtensionManagementErrorCode.Cancelled:s??u.ExtensionManagementErrorCode.Internal),o.stack=i.stack,o}function n(i,s,{extensionData:o,verificationStatus:f,duration:b,error:D,source:T,durationSinceUpdate:N}){let C,z;(0,l.$ng)(f)&&(f===!0?f="Verified":(f===!1||(C=u.ExtensionManagementErrorCode.Signature,z=f),f="Unverified")),D&&(C=D.code,D.code===u.ExtensionManagementErrorCode.Signature&&(z=D.message)),i.publicLog(s,{...o,verificationStatus:f,success:!D,duration:b,errorcode:C,errorcodeDetail:z,durationSinceUpdate:N,source:T})}class r{constructor(){this.d=new P.$Eh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,P.$sh)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,P.$sh)(s=>new Promise((o,f)=>{const b=s.onCancellationRequested(()=>{b.dispose(),f(new O.$7)})})),this.d.open()),this.g.cancel()}}t.$Eq=r}),define(oe[42],ae([0,1,8,14,2,5,31,12,21,27,10,11,6,25,24,3,9,19]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$,p,R,v,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hq=t.$Gq=t.$Fq=t.ExtensionsProfileScanningErrorCode=void 0;var m;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m||(t.ExtensionsProfileScanningErrorCode=m={}));class k extends Error{constructor(r,i){super(r),this.code=i}}t.$Fq=k,t.$Gq=(0,h.$Fi)("IExtensionsProfileScannerService");let y=class extends w.$Wc{constructor(r,i,s,o,f,b){super(),this.j=r,this.m=i,this.n=s,this.r=o,this.s=f,this.t=b,this.b=this.B(new O.$me),this.onAddExtensions=this.b.event,this.c=this.B(new O.$me),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$me),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$me),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Cc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i,s){const o=[],f=[];try{return await this.u(i,b=>{const D=[];if(s)D.push(...b);else for(const T of b)r.some(([N])=>(0,l.$Jp)(N.identifier,T.identifier)&&N.manifest.version!==T.version)?o.push(T):D.push(T);for(const[T,N]of r){const C=D.findIndex(X=>(0,l.$Jp)(X.identifier,T.identifier)&&X.version===T.manifest.version),z={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:N};C===-1?(f.push(z),D.push(z)):D.splice(C,1,z)}return f.length&&this.b.fire({extensions:f,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),D}),f.length&&this.c.fire({extensions:f,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),f}catch(b){throw f.length&&this.c.fire({extensions:f,error:b,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:b,profileLocation:i}),b}}async updateMetadata(r,i){const s=[];return await this.u(i,o=>{const f=[];for(const b of o){const D=r.find(([T])=>(0,l.$Jp)(T.identifier,b.identifier)&&T.manifest.version===b.version);D&&(b.metadata={...b.metadata,...D[1]},s.push(b)),f.push(b)}return f}),s}async removeExtensionFromProfile(r,i){const s=[];try{await this.u(i,o=>{const f=[];for(const b of o)(0,l.$Jp)(b.identifier,r.identifier)?s.push(b):f.push(b);return s.length&&this.f.fire({extensions:s,profileLocation:i}),f}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:i}),o}}async u(r,i,s){return this.F(r).queue(async()=>{let o=[],f;try{const b=await this.m.readFile(r);f=JSON.parse(b.value.toString().trim()||"[]")}catch(b){if((0,c.$ql)(b)!==c.FileOperationResult.FILE_NOT_FOUND)throw b;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(f=await this.D()),!f&&s?.bailOutWhenFileNotFound)throw new k((0,v.$_)(b),m.ERROR_PROFILE_NOT_FOUND)}if(f){Array.isArray(f)||this.w(r);let b=!1;for(const D of f){e(D)||this.w(r);let T;if((0,R.$fg)(D.relativeLocation)&&D.relativeLocation)T=this.z(D.relativeLocation);else if((0,R.$fg)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{T=I.URI.revive(D.location);const N=this.y(T);N&&(b=!0,D.relativeLocation=N)}(0,R.$mg)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(b=!0,D.metadata.hasPreReleaseVersion=!0),o.push({identifier:D.identifier,location:T,version:D.version,metadata:D.metadata})}b&&await this.m.writeFile(r,P.$Oe.fromString(JSON.stringify(f)))}if(i){o=i(o);const b=o.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(r,P.$Oe.fromString(JSON.stringify(b)))}return o})}w(r){const i=new k(`Invalid extensions content in ${r.toString()}`,m.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(f){if((0,c.$ql)(f)===c.FileOperationResult.FILE_NOT_FOUND)return;throw f}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const f=JSON.parse(s);Array.isArray(f)&&f.every(b=>e(b))?o=f:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",f)}catch(f){this.t.error(f)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,P.$Oe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(f){if((0,c.$ql)(f)===c.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw f}try{await this.m.del(r)}catch(f){(0,c.$ql)(f)!==c.FileOperationResult.FILE_NOT_FOUND&&this.t.error(f)}try{await this.m.del(i)}catch(f){(0,c.$ql)(f)!==c.FileOperationResult.FILE_NOT_FOUND&&this.t.error(f)}return o})()),this.C}F(r){let i=this.h.get(r);return i||(i=new E.$Mh,this.h.set(r,i)),i}};t.$Hq=y,t.$Hq=y=ye([re(1,c.$_k),re(2,$.$Ll),re(3,p.$Jl),re(4,d.$$l),re(5,u.$_j)],y);function e(n){return(0,R.$hg)(n)&&(0,g.$hp)(n.identifier)&&(a(n.location)||(0,R.$fg)(n.location)&&n.location)&&((0,R.$mg)(n.relativeLocation)||(0,R.$fg)(n.relativeLocation))&&n.version&&(0,R.$fg)(n.version)}function a(n){return n?(0,R.$fg)(n.path)&&(0,R.$fg)(n.scheme):!1}});var Me=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(oe[54],ae([0,1,20,8,28,14,9,34,85,2,15,16,13,17,45,56,3,12,102,18,27,23,44,10,11,6,33,5,48,42,25,24,121]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$,p,R,v,d,m,k,y,e,a,n,r,i,s,o,f,b,D,T,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oq=t.$Mq=t.$Lq=t.$Kq=t.Translations=void 0,t.$Nq=le,w=be(w),h=be(h),u=be(u),p=be(p),R=Me(R);var C;(function(fe){function x(_,V){if(_===V)return!0;const q=Object.keys(_),G=new Set;for(const Z of Object.keys(V))G.add(Z);if(q.length!==G.size)return!1;for(const Z of q){if(_[Z]!==V[Z])return!1;G.delete(Z)}return G.size===0}fe.equals=x})(C||(t.Translations=C={})),t.$Kq=(0,r.$Fi)("IExtensionsScannerService");let z=class extends l.$Wc{constructor(x,_,V,q,G,Z,te,F,M,J,B,S){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=_,this.r=V,this.s=q,this.t=G,this.u=Z,this.w=te,this.y=F,this.z=M,this.C=J,this.D=B,this.F=S,this.g=this.B(new o.$me),this.onDidChangeCache=this.g.event,this.h=(0,$.$gh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(se,this.s,this.h)),this.m=this.B(this.F.createInstance(se,this.s,this.h)),this.n=this.B(this.F.createInstance(Y,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(e.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(e.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,y.$Up)(this.w,this.y)),this.G}async scanAllExtensions(x,_,V){const[q,G]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(_)]),Z=V?await this.scanExtensionsUnderDevelopment(x,[...q,...G]):[];return this.L(q,G,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const _=[];_.push(this.M(!!x.useCache,x.language)),_.push(this.N(x.language,!!x.checkControlFile));const[V,q]=await Promise.all(_);return this.J([...V,...q],e.ExtensionType.System,x,!1)}async scanUserExtensions(x){const _=x.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const V=this.D.extUri.isEqual(x.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.P(_,!!x.profileLocation,e.ExtensionType.User,!x.includeUninstalled,x.language,!0,V,x.productVersion??this.R()),G=x.useCache&&!q.devMode&&q.excludeObsolete?this.m:this.n;let Z;try{Z=await G.scanExtensions(q)}catch(te){if(te instanceof b.$Fq&&te.code===b.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),Z=await G.scanExtensions(q);else throw te}return Z=await this.J(Z,e.ExtensionType.User,x,!0),this.y.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(x,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(q=>q.scheme===c.Schemas.file).map(async q=>{const G=await this.P(q,!1,e.ExtensionType.User,!0,x.language,!1,void 0,x.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(G)).map(te=>(te.type=_.find(F=>(0,y.$Jp)(F.identifier,te.identifier))?.type??te.type,this.n.validate(te,G)))}))).flat();return this.J(V,"development",x,!0)}return[]}async scanExistingExtension(x,_,V){const q=await this.P(x,!1,_,!0,V.language,!0,void 0,V.productVersion??this.R()),G=await this.n.scanExtension(q);return!G||!V.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(x,_,V){const q=await this.P(x,!1,_,!0,V.language,!0,void 0,V.productVersion??this.R()),G=await this.n.scanOneOrMultipleExtensions(q);return this.J(G,_,V,!0)}async scanMultipleExtensions(x,_,V){const q=[];return await Promise.all(x.map(async G=>{const Z=await this.scanOneOrMultipleExtensions(G,_,V);q.push(...Z)})),this.J(q,_,V,!0)}async scanMetadata(x){const _=(0,$.$gh)(x,"package.json"),V=(await this.w.readFile(_)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(x,_){const V=(0,$.$gh)(x,"package.json"),q=(await this.w.readFile(V)).value.toString(),G=JSON.parse(q);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,G.__metadata={...G.__metadata,..._},await this.w.writeFile((0,$.$gh)(x,"package.json"),O.$Oe.fromString(JSON.stringify(G,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof b.$Fq&&x.code===b.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw x}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.u.addExtensionsToProfile(x.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,O.$Oe.fromString(JSON.stringify([])))}catch(_){(0,n.$ql)(_)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$_)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.y.error(x)}finally{this.H=void 0}})()),this.H}async J(x,_,V,q){return V.includeAllVersions||(x=this.L(_===e.ExtensionType.System?x:void 0,_===e.ExtensionType.User?x:void 0,_==="development"?x:void 0,await this.getTargetPlatform(),q)),V.includeInvalid||(x=x.filter(G=>G.isValid)),x.sort((G,Z)=>{const te=h.$pc(G.location.fsPath),F=h.$pc(Z.location.fsPath);return te<F?-1:te>F?1:0})}L(x,_,V,q,G){const Z=(F,M,J)=>{if(F.isValid&&!M.isValid)return!1;if(F.isValid===M.isValid){if(G&&p.gt(F.manifest.version,M.manifest.version))return this.y.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${F.location.path} with version ${F.manifest.version}`),!1;if(p.eq(F.manifest.version,M.manifest.version)){if(F.type===e.ExtensionType.System)return this.y.debug(`Skipping extension ${M.location.path} in favour of system extension ${F.location.path} with same version`),!1;if(F.targetPlatform===q)return this.y.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return J?this.y.warn(`Overwriting user extension ${F.location.path} with ${M.location.path}.`):this.y.debug(`Overwriting user extension ${F.location.path} with ${M.location.path}.`),!0},te=new e.$sn;return x?.forEach(F=>{const M=te.get(F.identifier.id);(!M||Z(M,F,!1))&&te.set(F.identifier.id,F)}),_?.forEach(F=>{const M=te.get(F.identifier.id);if(!M&&x&&F.type===e.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${F.location.path}.`);return}(!M||Z(M,F,!1))&&te.set(F.identifier.id,F)}),V?.forEach(F=>{const M=te.get(F.identifier.id);(!M||Z(M,F,!0))&&te.set(F.identifier.id,F),te.set(F.identifier.id,F)}),[...te.values()]}async M(x,_){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,e.ExtensionType.System,!0,_,!0,void 0,this.R()),G=await(x&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",G.length),G}async N(x,_){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const q=_?await this.O():{},G=[],Z=d.URI.file(h.$jc(h.$lc(c.$Zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const F of V){const M=q[F.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":G.push((0,$.$gh)(Z,F.name));break;default:G.push(d.URI.file(M));break}}const te=await Promise.all(G.map(async F=>this.n.scanExtension(await this.P(F,!1,e.ExtensionType.System,!0,x,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",te.length),(0,E.$Jb)(te)}async O(){try{const x=await this.w.readFile(this.r);return JSON.parse(x.value.toString())}catch{return{}}}async P(x,_,V,q,G,Z,te,F){const M=await this.f(G??u.$w),J=await this.Q(x),B=_&&!this.D.extUri.isEqual(x,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,S=B?await this.Q(B):void 0;return new X(x,J,B,S,_,te,V,q,Z,F.version,F.date,this.C.commit,!this.z.isBuilt,G,M)}async Q(x){try{const _=await this.w.stat(x);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};t.$Lq=z,t.$Lq=z=ye([re(4,D.$Ll),re(5,b.$Gq),re(6,n.$_k),re(7,i.$_j),re(8,k.$Mi),re(9,s.$sk),re(10,T.$Jl),re(11,r.$Ei)],z);class X{constructor(x,_,V,q,G,Z,te,F,M,J,B,S,U,j,L){this.location=x,this.mtime=_,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=q,this.profile=G,this.profileScanOptions=Z,this.type=te,this.excludeObsolete=F,this.validate=M,this.productVersion=J,this.productDate=B,this.productCommit=S,this.devMode=U,this.language=j,this.translations=L}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,_){return(0,$.$_g)(x.location,_.location)&&x.mtime===_.mtime&&(0,$.$_g)(x.applicationExtensionslocation,_.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&x.profile===_.profile&&w.$ho(x.profileScanOptions,_.profileScanOptions)&&x.type===_.type&&x.excludeObsolete===_.excludeObsolete&&x.validate===_.validate&&x.productVersion===_.productVersion&&x.productDate===_.productDate&&x.productCommit===_.productCommit&&x.devMode===_.devMode&&x.language===_.language&&C.equals(x.translations,_.translations)}}t.$Mq=X;let Y=class extends l.$Wc{constructor(x,_,V,q,G){super(),this.f=x,this.g=_,this.h=V,this.j=q,this.m=G}async scanExtensions(x){const _=x.profile?await this.r(x):await this.n(x);let V={};if(x.excludeObsolete&&x.type===e.ExtensionType.User)try{const q=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(q)}catch{}return(0,v.$sg)(V)?_:_.filter(q=>!V[y.$Kp.create(q).toString()])}async n(x){const _=await this.j.resolve(x.location);if(!_.children?.length)return[];const V=await Promise.all(_.children.map(async q=>{if(!q.isDirectory||x.type===e.ExtensionType.User&&(0,$.$dh)(q.resource).indexOf(".")===0)return null;const G=new X(q.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(G)}));return(0,E.$Jb)(V).sort((q,G)=>q.location.path<G.location.path?-1:1)}async r(x){let _=await this.s(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.h.extUri.isEqual(x.location,x.applicationExtensionslocation)){_=_.filter(q=>!q.metadata?.isApplicationScoped);const V=await this.s(x.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,x);_.push(...V)}return _}async s(x,_,V){const q=await this.g.scanProfileExtensions(x,V.profileScanOptions);if(!q.length)return[];const G=await Promise.all(q.map(async Z=>{if(_(Z)){const te=new X(Z.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(te,Z.metadata)}return null}));return(0,E.$Jb)(G)}async scanOneOrMultipleExtensions(x){try{if(await this.j.exists((0,$.$gh)(x.location,"package.json"))){const _=await this.scanExtension(x);return _?[_]:[]}else return await this.scanExtensions(x)}catch(_){return this.m.error(`Error scanning extensions at ${x.location.path}:`,(0,A.$_)(_)),[]}}async scanExtension(x,_){try{let V=await this.scanExtensionManifest(x.location);if(V){V.publisher||(V.publisher=e.$mn),_=_??V.__metadata,delete V.__metadata;const q=(0,y.$Op)(V.publisher,V.name),G=_?.id?{id:q,uuid:_.id}:{id:q},Z=_?.isSystem?e.ExtensionType.System:x.type,te=Z===e.ExtensionType.System||!!_?.isBuiltin;V=await this.t(x.location,V,X.createNlsConfiguration(x));const F={type:Z,identifier:G,manifest:V,location:x.location,isBuiltin:te,targetPlatform:_?.targetPlatform??e.TargetPlatform.UNDEFINED,publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return x.validate?this.validate(F,x):F}}catch(V){x.type!==e.ExtensionType.System&&this.m.error(V)}return null}validate(x,_){let V=!0;const q=(0,a.$1p)(_.productVersion,_.productDate,_.location,x.manifest,x.isBuiltin);for(const[G,Z]of q)G===R.default.Error&&(V=!1,this.m.error(this.z(_.location,Z)));return x.isValid=V,x.validations=q,x}async scanExtensionManifest(x){const _=(0,$.$gh)(x,"package.json");let V;try{V=(await this.j.readFile(_)).value.toString()}catch(G){return(0,n.$ql)(G)!==n.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(x,(0,m.localize)(0,null,_.path,G.message))),null}let q;try{q=JSON.parse(V)}catch{const Z=[];(0,I.$Xn)(V,Z);for(const te of Z)this.m.error(this.z(x,(0,m.localize)(1,null,_.path,te.offset,te.length,(0,g.$Iq)(te.error))));return null}return(0,I.$6n)(q)!=="object"?(this.m.error(this.z(x,(0,m.localize)(2,null,_.path))),null):q}async t(x,_,V){const q=await this.u(x,_,V);if(q)try{const G=[],Z=await this.w(q.default,G);if(G.length>0)return G.forEach(F=>{this.m.error(this.z(x,(0,m.localize)(3,null,q.default?.path,(0,g.$Iq)(F.error))))}),_;if((0,I.$6n)(q)!=="object")return this.m.error(this.z(x,(0,m.localize)(4,null,q.default?.path))),_;const te=q.values||Object.create(null);return(0,N.$Jq)(this.m,_,te,Z)}catch{}return _}async u(x,_,V){const q=(0,$.$gh)(x,"package.nls.json"),G=(M,J)=>{J.forEach(B=>{this.m.error(this.z(x,(0,m.localize)(5,null,M?.path,(0,g.$Iq)(B.error))))})},Z=M=>{this.m.error(this.z(x,(0,m.localize)(6,null,M?.path)))},te=`${_.publisher}.${_.name}`,F=V.translations[te];if(F)try{const M=d.URI.file(F),J=(await this.j.readFile(M)).value.toString(),B=[],S=(0,I.$Xn)(J,B);return B.length>0?(G(M,B),{values:void 0,default:q}):(0,I.$6n)(S)!=="object"?(Z(M),{values:void 0,default:q}):{values:S.contents?S.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.j.exists(q))return;let J;try{J=await this.y(x,V)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const B=(await this.j.readFile(J.localized)).value.toString(),S=[],U=(0,I.$Xn)(B,S);return S.length>0?(G(J.localized,S),{values:void 0,default:J.original}):(0,I.$6n)(U)!=="object"?(Z(J.localized),{values:void 0,default:J.original}):{values:U,default:J.original}}catch{return{values:void 0,default:J.original}}}}async w(x,_){if(x)try{const V=(await this.j.readFile(x)).value.toString();return(0,I.$Xn)(V,_)}catch{}}y(x,_){return new Promise((V,q)=>{const G=Z=>{const te=(0,$.$gh)(x,`package.nls.${Z}.json`);this.j.exists(te).then(F=>{F&&V({localized:te,original:(0,$.$gh)(x,"package.nls.json")});const M=Z.lastIndexOf("-");M===-1?V({localized:(0,$.$gh)(x,"package.nls.json"),original:null}):(Z=Z.substring(0,M),G(Z))})};if(_.devMode||_.pseudo||!_.language)return V({localized:(0,$.$gh)(x,"package.nls.json"),original:null});G(_.language)})}z(x,_){return`[${x.path}]: ${_}`}};Y=ye([re(1,b.$Gq),re(2,T.$Jl),re(3,n.$_k),re(4,i.$_j)],Y);let se=class extends Y{constructor(x,_,V,q,G,Z,te){super(_,q,G,Z,te),this.G=x,this.H=V,this.D=this.B(new P.$Dh(3e3)),this.F=this.B(new o.$me),this.onDidChangeCache=this.F.event}async scanExtensions(x){const _=this.M(x),V=await this.I(_);if(this.C=x,V&&V.input&&X.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",x.type===e.ExtensionType.System?"system":"user",x.location.toString()),this.D.trigger(()=>this.L()),V.result.map(G=>(G.location=d.URI.revive(G.location),G));const q=await super.scanExtensions(x);return await this.J(_,{input:x,result:q}),q}async I(x){try{const _=await this.j.readFile(x),V=JSON.parse(_.value.toString());return{result:V.result,input:(0,f.$ci)(V.input)}}catch(_){this.m.debug("Error while reading the extension cache file:",x.path,(0,A.$_)(_))}return null}async J(x,_){try{await this.j.writeFile(x,O.$Oe.fromString(JSON.stringify(_)))}catch(V){this.m.debug("Error while writing the extension cache file:",x.path,(0,A.$_)(V))}}async L(){if(!this.C)return;const x=this.M(this.C),_=await this.I(x);if(!_)return;const V=_.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!w.$ho(q,V))try{this.m.info("Invalidating Cache",V,q),await this.j.del(x),this.F.fire()}catch(G){this.m.error(G)}}M(x){const _=this.N(x);return this.h.extUri.joinPath(_.cacheHome,x.type===e.ExtensionType.System?e.$ln:e.$kn)}N(x){return x.type===e.ExtensionType.System?this.H.defaultProfile:x.profile?this.h.extUri.isEqual(x.location,this.G.extensionsResource)?this.G:this.H.profiles.find(_=>this.h.extUri.isEqual(x.location,_.extensionsResource))??this.G:this.H.defaultProfile}};se=ye([re(2,D.$Ll),re(3,b.$Gq),re(4,T.$Jl),re(5,n.$_k),re(6,i.$_j)],se);function le(fe,x){const _=(0,y.$Mp)(fe.manifest.publisher,fe.manifest.name);return{id:_,identifier:new e.$qn(_),isBuiltin:fe.type===e.ExtensionType.System,isUserBuiltin:fe.type===e.ExtensionType.User&&fe.isBuiltin,isUnderDevelopment:x,extensionLocation:fe.location,uuid:fe.identifier.uuid,targetPlatform:fe.targetPlatform,publisherDisplayName:fe.publisherDisplayName,...fe.manifest,enabledApiProposals:fe.manifest.enabledApiProposals?(0,e.$yn)([...fe.manifest.enabledApiProposals]):void 0}}class ue extends z{constructor(x,_,V,q,G,Z,te,F,M,J,B,S){super(x,_,(0,$.$gh)(V,".vscode-oss-dev","extensions","control.json"),q,G,Z,te,F,M,J,B,S),this.S=(async()=>{if(u.$z)try{const U=await this.w.readFile(d.URI.file(u.$z));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}f(x){return this.S}}t.$Oq=ue}),define(oe[161],ae([0,1,60,8,38,5,2,15,16,26,6,25]),function(H,t,E,P,w,O,A,I,g,l,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sq=void 0;let u=class extends A.$Wc{constructor(p,R){super(),this.b=p,this.f=R,this.a=new P.$Lh(5)}async postUninstall(p){const R=this.g(p,"uninstall");R&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(R.script,"uninstall",R.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(v){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(v)}}));try{await l.Promises.rm(this.m(p))}catch(v){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(v)}}g(p,R){const v=`vscode:${R}`;if(p.location.scheme===I.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[v]=="string"){const d=p.manifest.scripts[v].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${v} should be a node script`),null):{script:(0,g.$lc)(p.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(p,R,v,d,m){return new Promise((k,y)=>{const e=this.j(p,R,v,m);let a;const n=r=>{a&&(clearTimeout(a),a=null),r?y(r):k(void 0)};e.on("error",r=>{n((0,w.$qj)(r)||"Unknown")}),e.on("exit",(r,i)=>{n(r?`post-${R} process exited with code ${r}`:void 0)}),d&&(a=setTimeout(()=>{a=null,e.kill(),y("timed out")},5e3))})}j(p,R,v,d){const m={silent:!0,execArgv:void 0},k=(0,E.fork)(p,[`--type=extension-post-${R}`,...v],m);k.stdout.setEncoding("utf8"),k.stderr.setEncoding("utf8");const y=O.Event.fromNodeEventEmitter(k.stdout,"data"),e=O.Event.fromNodeEventEmitter(k.stderr,"data");this.B(y(r=>this.f.info(d.identifier.id,d.manifest.version,`post-${R}`,r))),this.B(e(r=>this.f.error(d.identifier.id,d.manifest.version,`post-${R}`,r)));const a=O.Event.any(O.Event.map(y,r=>({data:`%c${r}`,format:[""]}),this.q),O.Event.map(e,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return O.Event.debounce(a,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(d.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),k}m(p){return(0,g.$lc)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};t.$Sq=u,t.$Sq=u=ye([re(0,h.$Ll),re(1,c.$_j)],u)}),define(oe[72],ae([0,1,50,104,53,21]),function(H,t,E,P,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pq=A,t.$Qq=I;function A(g){let l=O.ExtensionManagementErrorCode.Extract;return g instanceof E.$yq&&(g.type==="CorruptZip"?l=O.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(l=O.ExtensionManagementErrorCode.IncompleteZip)),(0,w.$Dq)(g,l)}async function I(g){let l;try{l=await(0,E.$Bq)(g,"extension/package.json")}catch(c){throw A(c)}try{return JSON.parse(l.toString("utf8"))}catch{throw new O.$kp((0,P.localize)(0,null),O.ExtensionManagementErrorCode.Invalid)}}}),define(oe[162],ae([0,1,8,9,2,15,17,45,3,29,26,50,30,18,53,21,27,72,71,10,6,19]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$,p,R,v,d,m,k,y,e){"use strict";var a;Object.defineProperty(t,"__esModule",{value:!0}),t.$Rq=void 0,I=be(I);let n=class extends w.$Wc{static{a=this}static{this.c=".sigzip"}constructor(i,s,o,f,b,D,T){super(),this.h=s,this.j=o,this.m=f,this.n=b,this.r=D,this.t=T,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(i,s,o,f){await this.g;const b=await this.w(i,s);let D=!1;if(o&&this.u(i)){let T;try{T=await this.y(i)}catch(N){try{await this.delete(b)}catch(C){this.t.error(C)}throw N}try{D=await this.n.verify(i,b.fsPath,T.fsPath,f)}catch(N){if(D=N.code,D===m.ExtensionSignatureVerificationCode.PackageIsInvalidZip||D===m.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(b)}catch(C){this.t.error(C)}throw new R.$kp(h.$xq,R.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(N){this.t.error(N)}}}return{location:b,verificationStatus:D}}u(i){if(!i.isSigned)return this.t.info(`Extension is not signed: ${i.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,g.$lg)(s)?s:!0}async w(i,s){try{const o=(0,A.$gh)(this.extensionsDownloadDir,this.G(i)),f=await this.C(i,"vsix",async()=>{await this.z(i,o,b=>this.j.download(i,b,s));try{await this.D(o.fsPath,"extension/package.json")}catch(b){try{await this.h.del(o)}catch(D){this.t.warn(`Error while deleting: ${o.path}`,(0,P.$_)(D))}throw b}},2);return f>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:i.identifier.id,attempts:f}),o}catch(o){throw(0,p.$Dq)(o,R.ExtensionManagementErrorCode.Download)}}async y(i){try{const s=(0,A.$gh)(this.extensionsDownloadDir,`.${(0,l.$2g)()}`),o=await this.C(i,"sigzip",async()=>{await this.j.downloadSignatureArchive(i,s);try{await this.D(s.fsPath,".signature.p7s")}catch(f){try{await this.h.del(s)}catch(b){this.t.warn(`Error while deleting: ${s.path}`,(0,P.$_)(b))}throw f}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:i.identifier.id,attempts:o}),s}catch(s){throw(0,p.$Dq)(s,R.ExtensionManagementErrorCode.DownloadSignature)}}async z(i,s,o){if(await this.h.exists(s))return;if(s.scheme!==O.Schemas.file){await o(s);return}const f=(0,A.$gh)(this.extensionsDownloadDir,`.${(0,l.$2g)()}`);try{await o(f)}catch(b){try{await this.h.del(f)}catch{}throw b}try{await c.Promises.rename(f.fsPath,s.fsPath,2*60*1e3)}catch(b){try{await this.h.del(f)}catch{}let D=!1;try{D=await this.h.exists(s)}catch{}if(D)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,P.$_)(b)}. Deleted the file from downloaded location`,f.path),b}}async C(i,s,o,f){let b=1;for(;;)try{return await o(),b}catch(D){if(b++>f)throw D;this.t.warn(`Failed downloading ${s}. ${(0,P.$_)(D)}. Retry again...`,i.identifier.id)}}async D(i,s){try{await(0,h.$Bq)(i,s)}catch(o){throw(0,d.$Pq)(o)}}async delete(i){await this.g,await this.h.del(i)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const s=[],o=[],f=[];for(const T of i.children)if(T.name.endsWith(a.c))f.push(T.resource);else{const N=v.$Kp.parse(T.name);N&&o.push([N,T])}const b=(0,v.$Pp)(o,([T])=>T),D=[];for(const T of b)T.sort((N,C)=>I.rcompare(N[0].version,C[0].version)),s.push(...T.slice(1).map(N=>N[1].resource)),D.push(T[0][1]);D.sort((T,N)=>T.mtime-N.mtime),s.push(...D.slice(0,Math.max(0,D.length-this.f)).map(T=>T.resource)),s.push(...f),await E.Promises.settled(s.map(T=>(this.t.trace("Deleting from cache",T.path),this.h.del(T))))}}catch(i){this.t.error(i)}}G(i){return this.f?v.$Kp.create(i).toString().toLowerCase():(0,l.$2g)()}};t.$Rq=n,t.$Rq=n=a=ye([re(0,$.$Ni),re(1,k.$_k),re(2,R.$ip),re(3,u.$_i),re(4,m.$qq),re(5,e.$$l),re(6,y.$_j)],n)}),define(oe[163],ae([0,1,8,14,22,38,9,5,43,2,31,15,16,17,45,3,12,29,26,50,103,61,18,53,21,27,42,54,162,161,72,143,150,23,44,10,11,6,33,19,24,25]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$,p,R,v,d,m,k,y,e,a,n,r,i,s,o,f,b,D,T,N,C,z,X,Y,se,le,ue,fe,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xq=t.$Wq=t.$Vq=void 0,u=be(u),p=be(p),m=be(m),y=be(y),t.$Vq=(0,Y.$Gi)(r.$lp);const _=".vsctmp";let V=class extends n.$Cq{constructor(F,M,J,B,S,U,j,L,K,Q,ne,ce){super(F,M,ne,J,Q,ce),this.eb=S,this.fb=U,this.gb=j,this.hb=L,this.ib=K,this.db=new Map,this.tb=new c.$Dc;const de=this.B(L.createInstance(b.$Sq));this.ab=this.B(L.createInstance(q,$e=>de.postUninstall($e))),this.bb=this.B(new T.$Tq(ce,K,ne,this,this.F)),this.cb=this.B(L.createInstance(f.$Rq));const me=this.B(new N.$Uq(this,this.eb,ce,U,ne,K,J));this.B(me.onDidChangeExtensionsByAnotherSource($e=>this.sb($e))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Up)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const M=await this.rb(F),J=await(0,k.zip)((0,$.$gh)(this.cb.extensionsDownloadDir,(0,d.$2g)()).fsPath,M);return v.URI.file(J)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:M,cleanup:J}=await this.lb(F),B=u.$mc(M.fsPath);try{return await(0,D.$Qq)(B)}finally{await J()}}getInstalled(F,M=this.H.defaultProfile.extensionsResource,J={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(F??null,M,J)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.ab.scanUserExtensionAtLocation(F)}async install(F,M={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:J,cleanup:B}=await this.lb(F);try{const S=await(0,D.$Qq)(u.$mc(J.fsPath)),U=(0,i.$Op)(S.publisher,S.name);if(S.engines&&S.engines.vscode&&!(0,z.$3p)(S.engines.vscode,this.G.version,this.G.date))throw new Error(y.localize(0,null,U,this.G.version));const L=(await this.I([{manifest:S,extension:J,options:M}])).find(({identifier:K})=>(0,i.$Jp)(K,{id:U}));if(L?.local)return L.local;throw L?.error?L.error:(0,n.$Dq)(new Error(`Unknown error while installing extension ${U}`))}finally{await B()}}async installFromLocation(F,M){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const J=await this.ab.scanUserExtensionAtLocation(F);if(!J||!J.manifest.name||!J.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.wb([[J,{source:"resource"}]],M),this.F.info("Successfully installed extension",J.identifier.id,M.toString()),J}async installExtensionsFromProfile(F,M,J){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,M.toString(),J.toString());const B=(await this.getInstalled(C.ExtensionType.User,M)).filter(S=>F.some(U=>(0,i.$Jp)(U,S.identifier)));if(B.length){const S=await Promise.all(B.map(U=>this.ab.scanMetadata(U,M)));await this.wb(B.map((U,j)=>[U,S[j]]),J),this.F.info("Successfully installed extensions",B.map(U=>U.identifier.id),J.toString())}return B}async updateMetadata(F,M,J){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),M.isPreReleaseVersion&&(M.preRelease=!0,M.hasPreReleaseVersion=!0),M.isMachineScoped===!1&&(M.isMachineScoped=void 0),M.isBuiltin===!1&&(M.isBuiltin=void 0),M.pinned===!1&&(M.pinned=void 0),F=await this.ab.updateMetadata(F,M,J),this.bb.invalidate(J),this.w.fire({local:F,profileLocation:J}),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(y.localize(1,null));const M=await this.getTargetPlatform(),[J]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:M,compatible:!0},w.CancellationToken.None);if(!J)throw new Error(y.localize(2,null));await this.ab.setUninstalled(F);try{await this.ab.removeUninstalledExtension(F)}catch(B){throw new Error(y.localize(3,null,(0,O.$qj)(B)))}return this.installFromGallery(J)}$(F,M,J,B){return this.ab.copyExtension(F,M,J,B)}copyExtensions(F,M){return this.ab.copyExtensions(F,M,{version:this.G.version,date:this.G.date})}markAsUninstalled(...F){return this.ab.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(F){this.F.error(F)}}async download(F,M,J){const{location:B}=await this.cb.download(F,M,!J);return B}async lb(F){if(F.scheme===h.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const M=(0,$.$gh)(this.cb.extensionsDownloadDir,(0,d.$2g)());return await this.gb.download(F,M),this.F.info("Downloaded extension to",M.toString()),{location:M,cleanup:async()=>{try{await this.ib.del(M)}catch(B){this.F.error(B)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(F,M,J){const B=M instanceof v.URI?new i.$Kp({id:(0,i.$Op)(F.publisher,F.name)},F.version):i.$Kp.create(M);return this.hb.createInstance(G,B,F,M,J,(S,U)=>{if(M instanceof v.URI)return this.qb(B,M,J,U);let j=this.db.get(B.toString());return j||(this.db.set(B.toString(),j=this.pb(B,M,S,J,U)),j.finally(()=>this.db.delete(B.toString()))),j},this.ab)}Z(F,M){return new Z(F,M.profileLocation,this.fb)}async pb(F,M,J,B,S){const{verificationStatus:U,location:j}=await this.cb.download(M,J,!B.donotVerifySignature,B.context?.[r.$bp]);try{if(S.isCancellationRequested)throw new A.$7;return await(0,D.$Qq)(j.fsPath),{local:await this.ab.extractUserExtension(F,j.fsPath,{id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName,targetPlatform:M.properties.targetPlatform,isApplicationScoped:B.isApplicationScoped,isMachineScoped:B.isMachineScoped,isBuiltin:B.isBuiltin,isPreReleaseVersion:M.properties.isPreReleaseVersion,hasPreReleaseVersion:M.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:B.installGivenVersion?!0:!!B.pinned,preRelease:(0,R.$lg)(B.preRelease)?B.preRelease:B.installPreReleaseVersion||M.properties.isPreReleaseVersion,source:"gallery"},!1,S),verificationStatus:U}}catch(L){try{await this.cb.delete(j)}catch(K){this.F.warn("Error while deleting the downloaded file",j.toString(),(0,A.$_)(K))}throw(0,n.$Dq)(L)}}async qb(F,M,J,B){return{local:await this.ab.extractUserExtension(F,u.$mc(M.fsPath),{isApplicationScoped:J.isApplicationScoped,isMachineScoped:J.isMachineScoped,isBuiltin:J.isBuiltin,installedTimestamp:Date.now(),pinned:J.installGivenVersion?!0:!!J.pinned,source:"vsix"},!0,B)}}async rb(F){const M=async B=>{let S=await m.Promises.readdir(B);S=S.map(L=>u.$lc(B,L));const U=await Promise.all(S.map(L=>m.Promises.stat(L)));let j=Promise.resolve([]);return U.forEach((L,K)=>{const Q=S[K];L.isFile()&&(j=j.then(ne=>[...ne,Q])),L.isDirectory()&&(j=j.then(ne=>M(Q).then(ce=>[...ne,...ce])))}),j};return(await M(F.location.fsPath)).map(B=>({path:`extension/${u.$nc(F.location.fsPath,B)}`,localPath:B}))}async sb({added:F,removed:M}){if(M){const J=F&&this.D.extUri.isEqual(M.profileLocation,F.profileLocation)?M.extensions.filter(B=>F.extensions.every(S=>!(0,i.$Jp)(S,B))):M.extensions;for(const B of J)this.F.info("Extensions removed from another source",B.id,M.profileLocation.toString()),this.u.fire({identifier:B,profileLocation:M.profileLocation})}if(F){const B=(await this.getInstalled(C.ExtensionType.User,F.profileLocation)).filter(S=>F.extensions.some(U=>(0,i.$Jp)(U,S.identifier)));this.s.fire(B.map(S=>(this.F.info("Extensions added from another source",S.identifier.id,F.profileLocation.toString()),{identifier:S.identifier,local:S,profileLocation:F.profileLocation,operation:r.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(M=>this.tb.add(M)));const F=await this.ib.resolve(this.eb.userExtensionsLocation);for(const M of F.children??[])M.isDirectory&&this.tb.add(M.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(M=>this.vb(M)))}async vb(F){if(!F.affects(this.eb.userExtensionsLocation,X.FileChangeType.ADDED))return;const M=[];for(const J of F.rawAdded){if(this.tb.has(J)||!this.D.extUri.isEqual(this.D.extUri.dirname(J),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(J,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(J).startsWith(".")||!(await this.ib.stat(J)).isDirectory)continue;const B=await this.ab.scanUserExtensionAtLocation(J);B&&B.installedTimestamp===void 0&&(this.tb.add(J),M.push(B))}M.length&&(await this.wb(M.map(J=>[J,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",M.map(J=>J.identifier.id)))}async wb(F,M){const J=F.map(B=>B[0]);await this.xb(J),await this.fb.addExtensionsToProfile(F,M),this.s.fire(J.map(B=>({local:B,identifier:B.identifier,operation:r.InstallOperation.None,profileLocation:M})))}async xb(F){const M=await this.ab.getUninstalledExtensions();for(const J of F){const B=i.$Kp.create(J);M[B.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",B.id),await this.ab.setInstalled(B),this.F.info("Removed the extension from uninstalled list:",B.id))}}};t.$Wq=V,t.$Wq=V=ye([re(0,r.$ip),re(1,ue.$$l),re(2,se.$_j),re(3,a.$Ni),re(4,o.$Kq),re(5,s.$Gq),re(6,e.$Yo),re(7,Y.$Ei),re(8,X.$_k),re(9,le.$sk),re(10,fe.$Jl),re(11,x.$Ll)],V);let q=class extends l.$Wc{constructor(F,M,J,B,S,U,j){super(),this.n=F,this.s=M,this.t=J,this.u=B,this.w=S,this.y=U,this.z=j,this.h=this.B(new I.$me),this.onExtract=this.h.event,this.j=new c.$Cc,this.m=new c.$Cc,this.c=(0,$.$gh)(this.t.userExtensionsLocation,".obsolete"),this.g=new E.$Mh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(F,M,J){try{const B={includeInvalid:!0,profileLocation:M,productVersion:J};let S=[];if(F===null||F===C.ExtensionType.System){let U=this.j.get(M);U||(U=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},B,!1).finally(()=>this.j.delete(M)),this.j.set(M,U)),S.push(...await U)}else if(F===C.ExtensionType.User){let U=this.m.get(M);U||(U=this.t.scanUserExtensions(B).finally(()=>this.m.delete(M)),this.m.set(M,U)),S.push(...await U)}return S=F!==null?S.filter(U=>U.type===F):S,await Promise.all(S.map(U=>this.H(U)))}catch(B){throw(0,n.$Dq)(B,r.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(F){try{const M=await this.t.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return await Promise.all(M.map(J=>this.H(J)))}catch(M){throw(0,n.$Dq)(M,r.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(F){try{const M=await this.t.scanExistingExtension(F,C.ExtensionType.User,{includeInvalid:!0});if(M)return await this.H(M)}catch(M){this.z.error(M)}return null}async extractUserExtension(F,M,J,B,S){const U=F.toString(),j=v.URI.file(u.$lc(this.t.userExtensionsLocation.fsPath,`.${(0,d.$2g)()}`)),L=v.URI.file(u.$lc(this.t.userExtensionsLocation.fsPath,U));let K=await this.s.exists(L);if(K&&B){try{await this.D(F.id,L,"removeExisting")}catch{throw new r.$kp(y.localize(4,null,L.fsPath,F.id),r.ExtensionManagementErrorCode.Delete)}K=!1}if(K)try{await this.t.updateMetadata(L,J)}catch(Q){throw this.y.publicLog2("extension:extract",{extensionId:F.id,code:Q.code}),(0,n.$Dq)(Q,r.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(S.isCancellationRequested)throw new A.$7;try{this.z.trace(`Started extracting the extension from ${M} to ${L.fsPath}`),await(0,k.$Aq)(M,j.fsPath,{sourcePath:"extension",overwrite:!0},S),this.z.info(`Extracted extension to ${L}:`,F.id)}catch(Q){throw(0,D.$Pq)(Q)}try{await this.t.updateMetadata(j,J)}catch(Q){throw this.y.publicLog2("extension:extract",{extensionId:F.id,code:Q.code}),(0,n.$Dq)(Q,r.ExtensionManagementErrorCode.UpdateMetadata)}if(S.isCancellationRequested)throw new A.$7;try{this.z.trace(`Started renaming the extension from ${j.fsPath} to ${L.fsPath}`),await this.G(j.fsPath,L.fsPath),this.z.info("Renamed to",L.fsPath)}catch(Q){if(Q.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);try{await this.s.del(j,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,A.$_)(Q)}. Deleted from extracted location`,j),Q}this.h.fire(L)}catch(Q){try{await this.s.del(j,{recursive:!0})}catch{}throw Q}return this.scanLocalExtension(L,C.ExtensionType.User)}async scanMetadata(F,M){return M?(await this.C(F,M))?.metadata:this.t.scanMetadata(F.location)}async C(F,M){return(await this.u.scanProfileExtensions(M)).find(B=>(0,i.$Jp)(B.identifier,F.identifier))}async updateMetadata(F,M,J){try{J?await this.u.updateMetadata([[F,M]],J):await this.t.updateMetadata(F.location,M)}catch(B){throw this.y.publicLog2("extension:extract",{extensionId:F.identifier.id,code:B.code}),(0,n.$Dq)(B,r.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(F.location,F.type,J)}async getUninstalledExtensions(){try{return await this.F()}catch(F){throw(0,n.$Dq)(F,r.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...F){const M=F.map(J=>i.$Kp.create(J));await this.F(J=>M.forEach(B=>{J[B.toString()]=!0,this.z.info("Marked extension as uninstalled",B.toString())}))}async setInstalled(F){try{await this.F(M=>delete M[F.toString()])}catch(M){throw(0,n.$Dq)(M,r.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(F,M){if(this.w.extUri.isEqualOrParent(F.location,this.t.userExtensionsLocation))return this.D(F.identifier.id,F.location,M)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.F(M=>delete M[i.$Kp.create(F).toString()])}async copyExtension(F,M,J,B){const S=await this.C(F,M),U=await this.C(F,J);if(B={...S?.metadata,...B},U)if(this.w.extUri.isEqual(U.location,F.location))await this.u.updateMetadata([[F,{...U.metadata,...B}]],J);else{const j=await this.scanLocalExtension(U.location,F.type,J);await this.u.removeExtensionFromProfile(j,J),await this.u.addExtensionsToProfile([[F,{...U.metadata,...B}]],J)}else await this.u.addExtensionsToProfile([[F,B]],J);return this.scanLocalExtension(F.location,F.type,J)}async copyExtensions(F,M,J){const B=await this.scanExtensions(C.ExtensionType.User,F,J),S=await Promise.all(B.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,F)]));await this.u.addExtensionsToProfile(S,M)}async D(F,M,J){this.z.trace(`Deleting ${J} extension from disk`,F,M.fsPath);const B=this.w.extUri.joinPath(this.w.extUri.dirname(M),`${this.w.extUri.basename(M)}.${(0,g.$tj)((0,d.$2g)()).toString(16)}${_}`);await this.G(M.fsPath,B.fsPath),await this.s.del(B,{recursive:!0}),this.z.info(`Deleted ${J} extension from disk`,F,M.fsPath)}F(F){return this.g.queue(async()=>{let M;try{M=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(B){if((0,X.$ql)(B)!==X.FileOperationResult.FILE_NOT_FOUND)throw B}let J={};if(M)try{J=JSON.parse(M)}catch{}return F&&(F(J),Object.keys(J).length?await this.s.writeFile(this.c,P.$Oe.fromString(JSON.stringify(J))):await this.s.del(this.c)),J})}async G(F,M){try{await m.Promises.rename(F,M,2*60*1e3)}catch(J){throw(0,n.$Dq)(J,r.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(F,M,J){try{if(J){const S=(await this.t.scanUserExtensions({profileLocation:J})).find(U=>this.w.extUri.isEqual(U.location,F));if(S)return await this.H(S)}else{const B=await this.t.scanExistingExtension(F,M,{includeInvalid:!0});if(B)return await this.H(B)}throw new r.$kp(y.localize(5,null,F.path),r.ExtensionManagementErrorCode.ScanningExtension)}catch(B){throw(0,n.$Dq)(B,r.ExtensionManagementErrorCode.ScanningExtension)}}async H(F){const M=await this.s.resolve(F.location);let J,B;return M.children&&(J=M.children.find(({name:S})=>/^readme(\.txt|\.md|)$/i.test(S))?.resource,B=M.children.find(({name:S})=>/^changelog(\.txt|\.md|)$/i.test(S))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:J,changelogUrl:B,publisherDisplayName:F.metadata?.publisherDisplayName,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned,isWorkspaceScoped:!1,source:F.metadata?.source??(F.identifier.uuid?"gallery":"vsix")}}async I(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(F));const M=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),J=new Set;for(const S of M)F[i.$Kp.create(S).toString()]||J.add(S.identifier.id.toLowerCase());try{const S=(0,i.$Pp)(M,U=>U.identifier);await E.Promises.settled(S.map(async U=>{const j=U.sort((L,K)=>p.rcompare(L.manifest.version,K.manifest.version))[0];J.has(j.identifier.id.toLowerCase())||await this.n(await this.H(j))}))}catch(S){this.z.error(S)}const B=M.filter(S=>S.metadata&&F[i.$Kp.create(S).toString()]);await Promise.allSettled(B.map(S=>this.removeUninstalledExtension(S)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.s.resolve(this.t.userExtensionsLocation)}catch(M){(0,X.$ql)(M)!==X.FileOperationResult.FILE_NOT_FOUND&&this.z.error(M);return}if(F?.children)try{await Promise.allSettled(F.children.map(async M=>{if(!(!M.isDirectory||!M.name.endsWith(_))){this.z.trace("Deleting the temporarily deleted folder",M.resource.toString());try{await this.s.del(M.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",M.resource.toString())}catch(J){(0,X.$ql)(J)!==X.FileOperationResult.FILE_NOT_FOUND&&this.z.error(J)}}}))}catch{}}};t.$Xq=q,t.$Xq=q=ye([re(1,X.$_k),re(2,o.$Kq),re(3,s.$Gq),re(4,fe.$Jl),re(5,ue.$$l),re(6,se.$_j)],q);let G=class extends n.$Eq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(F,M,J,B,S,U,j,L,K,Q,ne,ce){super(),this.l=F,this.manifest=M,this.source=J,this.options=B,this.m=S,this.n=U,this.o=j,this.p=L,this.q=K,this.s=Q,this.t=ne,this.u=ce,this.j=r.InstallOperation.Install,this.identifier=this.l.identifier}async h(F){const J=(await this.n.scanExtensions(C.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(j=>(0,i.$Jp)(j.identifier,this.identifier));J&&(this.j=r.InstallOperation.Update);const B={isApplicationScoped:this.options.isApplicationScoped||J?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||J?.isMachineScoped,isBuiltin:this.options.isBuiltin||J?.isBuiltin,isSystem:J?.type===C.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??J?.pinned,source:this.source instanceof v.URI?"vsix":"gallery"};let S;if(this.source instanceof v.URI)if(J){if(this.l.equals(new i.$Kp(J.identifier,J.manifest.version)))try{await this.n.removeExtension(J,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const j=await this.w(this.l);if(j)try{await this.n.removeExtension(j,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(B.id=this.source.identifier.uuid,B.publisherId=this.source.publisherId,B.publisherDisplayName=this.source.publisherDisplayName,B.targetPlatform=this.source.properties.targetPlatform,B.updated=!!J,B.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,B.hasPreReleaseVersion=J?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,B.preRelease=(0,R.$lg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||J?.preRelease,J&&J.type!==C.ExtensionType.System&&J.manifest.version===this.source.version)return this.n.updateMetadata(J,B,this.options.profileLocation);S=await this.w(this.l)}if(F.isCancellationRequested)throw(0,n.$Dq)(new A.$7);if(!S){const j=await this.m(this.operation,F);S=j.local,this.k=j.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(j){throw(0,n.$Dq)(j,r.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(F.isCancellationRequested)throw(0,n.$Dq)(new A.$7);try{await this.t.addExtensionsToProfile([[S,B]],this.options.profileLocation,!S.isValid)}catch(j){throw(0,n.$Dq)(j,r.ExtensionManagementErrorCode.AddToProfile)}const U=await this.n.scanLocalExtension(S.location,C.ExtensionType.User,this.options.profileLocation);if(!U)throw new r.$kp("Cannot find the installed extension",r.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof v.URI&&this.x(S,F),U}async w(F){return(await this.n.getUninstalledExtensions())[F.toString()]?(this.u.trace("Removing the extension from uninstalled list:",F.id),await this.n.setInstalled(F),this.u.info("Removed the extension from uninstalled list:",F.id),(await this.n.scanAllUserExtensions(!0)).find(B=>i.$Kp.create(B).equals(F))):void 0}async x(F,M){try{let[J]=await this.p.getExtensions([{id:F.identifier.id,version:F.manifest.version}],M);if(J||([J]=await this.p.getExtensions([{id:F.identifier.id}],M)),J){const B={id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId,isPreReleaseVersion:J.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||J.properties.isPreReleaseVersion,preRelease:J.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(F,B,this.options.profileLocation)}}catch{}}};G=ye([re(6,fe.$Jl),re(7,r.$ip),re(8,x.$Ll),re(9,o.$Kq),re(10,s.$Gq),re(11,se.$_j)],G);class Z extends n.$Eq{constructor(F,M,J){super(),this.extension=F,this.j=M,this.k=J}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[164],ae([0,1,6,25,24,19,42,10,18,12]),function(H,t,E,P,w,O,A,I,g,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nR=void 0;let c=class extends A.$Hq{constructor(u,$,p,R,v,d){super(l.URI.file(u.extensionsPath),$,p,R,v,d)}};t.$nR=c,t.$nR=c=ye([re(0,g.$Ni),re(1,I.$_k),re(2,P.$Ll),re(3,w.$Jl),re(4,O.$$l),re(5,E.$_j)],c)}),define(oe[165],ae([0,1,12,18,42,54,10,11,6,33,24,25]),function(H,t,E,P,w,O,A,I,g,l,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$fc=void 0;let u=class extends O.$Oq{constructor(p,R,v,d,m,k,y,e){super(E.URI.file(m.builtinExtensionsPath),E.URI.file(m.extensionsPath),m.userHome,p.defaultProfile,p,R,v,d,m,k,y,e)}};t.$$fc=u,t.$$fc=u=ye([re(0,h.$Ll),re(1,w.$Gq),re(2,A.$_k),re(3,g.$_j),re(4,P.$Ni),re(5,l.$sk),re(6,c.$Jl),re(7,I.$Ei)],u)}),define(oe[73],ae([0,1,8,5,2,133,3,92,11,25]),function(H,t,E,P,w,O,A,I,g,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jq=t.$hq=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.$fq=t.$eq=t.$dq=void 0,t.$gq=$,t.$iq=R,t.$kq=d,t.$dq="__$__isNewStorageMarker",t.$eq="__$__targetStorageMarker",t.$fq=(0,g.$Fi)("storageService");var c;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(c||(t.WillSaveStateReason=c={}));var h;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(h||(t.StorageScope=h={}));var u;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(u||(t.StorageTarget=u={}));function $(m){const k=m.get(t.$eq);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}class p extends w.$Wc{static{this.a=60*1e3}constructor(k={flushInterval:p.a}){super(),this.m=k,this.b=this.B(new P.$pe),this.c=this.B(new P.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new P.$me),this.onWillSaveState=this.f.event,this.h=this.B(new E.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new w.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(k,y,e){return P.Event.filter(this.b.event,a=>a.scope===k&&(y===void 0||a.key===y),e)}n(){this.j.value=(0,E.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,w.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(k,y){const{key:e,external:a}=y;if(e===t.$eq){switch(k){case h.APPLICATION:this.H=void 0;break;case h.PROFILE:this.F=void 0;break;case h.WORKSPACE:this.C=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:e,target:this.J(k)[e],external:a})}w(k){this.f.fire({reason:k})}get(k,y,e){return this.P(y)?.get(k,e)}getBoolean(k,y,e){return this.P(y)?.getBoolean(k,e)}getNumber(k,y,e){return this.P(y)?.getNumber(k,e)}getObject(k,y,e){return this.P(y)?.getObject(k,e)}storeAll(k,y){this.y(()=>{for(const e of k)this.store(e.key,e.value,e.scope,e.target,y)})}store(k,y,e,a,n=!1){if((0,A.$og)(y)){this.remove(k,e,n);return}this.y(()=>{this.z(k,e,a),this.P(e)?.set(k,y,n)})}remove(k,y,e=!1){this.y(()=>{this.z(k,y,void 0),this.P(y)?.delete(k,e)})}y(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,y){const e=[],a=this.J(k);for(const n of Object.keys(a))a[n]===y&&e.push(n);return e}z(k,y,e,a=!1){const n=this.J(y);typeof e=="number"?n[k]!==e&&(n[k]=e,this.P(y)?.set(t.$eq,JSON.stringify(n),a)):typeof n[k]=="number"&&(delete n[k],this.P(y)?.set(t.$eq,JSON.stringify(n),a))}get D(){return this.C||(this.C=this.L(h.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(h.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(h.APPLICATION)),this.H}J(k){switch(k){case h.APPLICATION:return this.I;case h.PROFILE:return this.G;default:return this.D}}L(k){const y=this.P(k);return y?$(y):Object.create(null)}isNew(k){return this.getBoolean(t.$dq,k)===!0}async flush(k=c.NONE){this.f.fire({reason:k});const y=this.P(h.APPLICATION),e=this.P(h.PROFILE),a=this.P(h.WORKSPACE);switch(k){case c.NONE:await E.Promises.settled([y?.whenFlushed()??Promise.resolve(),e?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case c.SHUTDOWN:await E.Promises.settled([y?.flush(0)??Promise.resolve(),e?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.P(h.APPLICATION)?.items??new Map,y=this.P(h.PROFILE)?.items??new Map,e=this.P(h.WORKSPACE)?.items??new Map;return d(k,y,e,this.Q(h.APPLICATION)??"",this.Q(h.PROFILE)??"",this.Q(h.WORKSPACE)??"")}async optimize(k){return await this.flush(),this.P(k)?.optimize()}async switch(k,y){return this.w(c.NONE),(0,l.$Kl)(k)?this.R(k,y):this.S(k,y)}M(k,y){return!(k.id===y.id||R(y)&&R(k))}N(k,y,e){this.y(()=>{const a=new Set;for(const[n,r]of k)a.add(n),y.get(n)!==r&&this.u(e,{key:n,external:!0});for(const[n]of y.items)a.has(n)||this.u(e,{key:n,external:!0})})}}t.$hq=p;function R(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class v extends p{constructor(){super(),this.U=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(k=>this.u(h.WORKSPACE,k))),this.B(this.W.onDidChangeStorage(k=>this.u(h.PROFILE,k))),this.B(this.U.onDidChangeStorage(k=>this.u(h.APPLICATION,k)))}P(k){switch(k){case h.APPLICATION:return this.U;case h.PROFILE:return this.W;default:return this.X}}Q(k){switch(k){case h.APPLICATION:return"inMemory (application)";case h.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(k){return!1}}t.$jq=v;async function d(m,k,y,e,a,n){const r=C=>{try{return JSON.parse(C)}catch{return C}},i=new Map,s=new Map;m.forEach((C,z)=>{i.set(z,C),s.set(z,r(C))});const o=new Map,f=new Map;k.forEach((C,z)=>{o.set(z,C),f.set(z,r(C))});const b=new Map,D=new Map;y.forEach((C,z)=>{b.set(z,C),D.set(z,r(C))}),console.group(e!==a?`Storage: Application (path: ${e})`:`Storage: Application & Profile (path: ${e}, default profile)`);const T=[];if(i.forEach((C,z)=>{T.push({key:z,value:C})}),console.table(T),console.groupEnd(),console.log(s),e!==a){console.group(`Storage: Profile (path: ${a}, profile specific)`);const C=[];o.forEach((z,X)=>{C.push({key:X,value:z})}),console.table(C),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${n})`);const N=[];b.forEach((C,z)=>{N.push({key:z,value:C})}),console.table(N),console.groupEnd(),console.log(D)}}),define(oe[166],ae([0,1,14,29,73]),function(H,t,E,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lq=O;async function O(A,I,g){let l=g&&g.get("storage.serviceMachineId",w.StorageScope.APPLICATION)||null;if(l)return l;try{const h=(await I.readFile(A.serviceMachineIdResource)).value.toString();l=(0,P.$1g)(h)?h:null}catch{l=null}if(!l){l=(0,P.$2g)();try{await I.writeFile(A.serviceMachineIdResource,E.$Oe.fromString(l))}catch{}}return g?.store("storage.serviceMachineId",l,w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),l}}),define(oe[167],ae([0,1,166,19,41]),function(H,t,E,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mq=O;async function O(A,I,g,l,c,h,u){const $={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${I.nameShort})`};if((0,w.$Bp)(I,g)&&(0,w.$Dp)(l)===P.TelemetryLevel.USAGE){const p=await(0,E.$lq)(g,c,h);$["X-Market-User-Id"]=p,$["VSCode-SessionId"]=u.machineId||p}return $}}),define(oe[168],ae([0,1,20,22,9,13,36,3,12,30,18,21,27,23,44,10,6,33,46,167,73,19,180]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$,p,R,v,d,m,k,y,e,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pq=t.$oq=void 0,t.$nq=F;const n=O.$o?$.TargetPlatform.WEB:(0,h.$ep)(O.$u,A.$gc),r="X-Market-Search-Activity-Id";var i;(function(j){j[j.None=0]="None",j[j.IncludeVersions=1]="IncludeVersions",j[j.IncludeFiles=2]="IncludeFiles",j[j.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",j[j.IncludeSharedAccounts=8]="IncludeSharedAccounts",j[j.IncludeVersionProperties=16]="IncludeVersionProperties",j[j.ExcludeNonValidated=32]="ExcludeNonValidated",j[j.IncludeInstallationTargets=64]="IncludeInstallationTargets",j[j.IncludeAssetUri=128]="IncludeAssetUri",j[j.IncludeStatistics=256]="IncludeStatistics",j[j.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",j[j.Unpublished=4096]="Unpublished",j[j.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function s(...j){return String(j.reduce((L,K)=>L|K,0))}var o;(function(j){j[j.Tag=1]="Tag",j[j.ExtensionId=4]="ExtensionId",j[j.Category=5]="Category",j[j.ExtensionName=7]="ExtensionName",j[j.Target=8]="Target",j[j.Featured=9]="Featured",j[j.SearchText=10]="SearchText",j[j.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const f={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},b={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},T={pageNumber:1,pageSize:10,sortBy:h.SortBy.NoneOrRelevance,sortOrder:h.SortOrder.Default,flags:i.None,criteria:[],assetTypes:[]};class N{constructor(L=T){this.d=L}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(L,K=this.d.pageSize){return new N({...this.d,pageNumber:L,pageSize:K})}withFilter(L,...K){const Q=[...this.d.criteria,...K.length?K.map(ne=>({filterType:L,value:ne})):[{filterType:L}]];return new N({...this.d,criteria:Q})}withSortBy(L){return new N({...this.d,sortBy:L})}withSortOrder(L){return new N({...this.d,sortOrder:L})}withFlags(...L){return new N({...this.d,flags:L.reduce((K,Q)=>K|Q,0)})}withAssetTypes(...L){return new N({...this.d,assetTypes:L})}withSource(L){return new N({...this.d,source:L})}get raw(){const{criteria:L,pageNumber:K,pageSize:Q,sortBy:ne,sortOrder:ce,flags:de,assetTypes:me}=this.d;return{filters:[{criteria:L,pageNumber:K,pageSize:Q,sortBy:ne,sortOrder:ce}],assetTypes:me,flags:de}}get searchText(){const L=this.d.criteria.filter(K=>K.filterType===o.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(L=>String(L.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function C(j,L){const K=(j||[]).filter(Q=>Q.statisticName===L)[0];return K?K.value:0}function z(j){const L="Microsoft.VisualStudio.Code.Translation.";return j.files.filter(Q=>Q.assetType.indexOf(L)===0).reduce((Q,ne)=>{const ce=se(j,ne.assetType);return ce&&Q.push([ne.assetType.substring(L.length),ce]),Q},[])}function X(j){if(j.properties){const L=j.properties.filter(ne=>ne.key===f.Repository),K=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=L.filter(ne=>K.test(ne.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return se(j,f.Repository)}function Y(j){return{uri:`${j.fallbackAssetUri}/${f.VSIX}?redirect=true${j.targetPlatform?`&targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${f.VSIX}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}}function se(j,L){return j.files.filter(Q=>Q.assetType===L)[0]?{uri:`${j.assetUri}/${L}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${L}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}:null}function le(j,L){const K=j.properties?j.properties.filter(ne=>ne.key===L):[],Q=K.length>0&&K[0].value;return Q?Q.split(",").map(ne=>(0,u.$Np)(ne)):[]}function ue(j){const L=j.properties?j.properties.filter(K=>K.key===b.Engine):[];return L.length>0&&L[0].value||""}function fe(j){const L=j.properties?j.properties.filter(K=>K.key===b.PreRelease):[];return L.length>0&&L[0].value==="true"}function x(j){const L=j.properties?j.properties.filter(Q=>Q.key===b.EnabledApiProposals):[],K=L.length>0&&L[0].value||"";return K?K.split(","):[]}function _(j){const L=j.properties?j.properties.filter(Q=>Q.key===b.LocalizedLanguages):[],K=L.length>0&&L[0].value||"";return K?K.split(","):[]}function V(j){return j.properties?.find(L=>L.key===b.SponsorLink)?.value}function q(j){return j.properties?.find(L=>L.key===b.SupportLink)?.value}function G(j){return j.indexOf("preview")!==-1}function Z(j){return j.targetPlatform?(0,h.$dp)(j.targetPlatform):$.TargetPlatform.UNDEFINED}function te(j){const L=(0,E.$Ob)(j.versions.map(Z)),K=!!j.tags?.includes(h.$0o),Q=L.indexOf($.TargetPlatform.WEB);return K?Q===-1&&L.push($.TargetPlatform.WEB):Q!==-1&&L.splice(Q,1),L}function F(j,L){for(let K=0;K<j.length;K++){const Q=j[K];if(Q.version===j[K-1]?.version){let ne=K;if(Z(Q)===L)for(;ne>0&&j[ne-1].version===Q.version;)ne--;ne!==K&&(j.splice(K,1),j.splice(ne,0,Q))}}return j}function M(j,L,K){j.telemetryData={index:L,querySource:K,queryActivityId:j.queryContext?.[r]}}function J(j,L,K,Q){const ne=j.versions[0],ce={manifest:se(L,f.Manifest),readme:se(L,f.Details),changelog:se(L,f.Changelog),license:se(L,f.License),repository:X(L),download:Y(L),icon:se(L,f.Icon),signature:se(L,f.Signature),coreTranslations:z(L)};return{type:"gallery",identifier:{id:(0,u.$Op)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},name:j.extensionName,version:L.version,displayName:j.displayName,publisherId:j.publisher.publisherId,publisher:j.publisher.publisherName,publisherDisplayName:j.publisher.displayName,publisherDomain:j.publisher.domain?{link:j.publisher.domain,verified:!!j.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(ne),description:j.shortDescription??"",installCount:C(j.statistics,"install"),rating:C(j.statistics,"averagerating"),ratingCount:C(j.statistics,"ratingcount"),categories:j.categories||[],tags:j.tags||[],releaseDate:Date.parse(j.releaseDate),lastUpdated:Date.parse(j.lastUpdated),allTargetPlatforms:K,assets:ce,properties:{dependencies:le(L,b.Dependency),extensionPack:le(L,b.ExtensionPack),engine:ue(L),enabledApiProposals:x(L),localizedLanguages:_(L),targetPlatform:Z(L),isPreReleaseVersion:fe(L)},hasPreReleaseVersion:fe(ne),hasReleaseVersion:!0,preview:G(j.flags),isSigned:!!ce.signature,queryContext:Q,supportLink:q(ne)}}let B=class{constructor(L,K,Q,ne,ce,de,me,$e){this.k=K,this.l=Q,this.n=ne,this.o=ce,this.q=de,this.u=me,this.w=$e;const we=me.extensionsGallery,he=we?.servicePPEUrl&&$e.getValue("_extensionsGallery.enablePPE");this.d=he?we.servicePPEUrl:we?.serviceUrl,this.g=he?void 0:we?.searchUrl,this.h=we?.controlUrl,this.j=(0,k.$mq)(me.version,me,this.n,this.w,this.q,L,this.o)}x(L=""){return`${this.d}${L}`}isEnabled(){return!!this.d}async getExtensions(L,K,Q){const ne=P.CancellationToken.isCancellationToken(K)?{}:K,ce=P.CancellationToken.isCancellationToken(K)?K:Q,de=[],me=[],$e=[],we=[];let he=!0;for(const Se of L){Se.uuid?me.push(Se.uuid):de.push(Se.id);const W=!!(Se.version||Se.preRelease);$e.push({id:Se.id,uuid:Se.uuid,includePreRelease:W}),Se.version&&we.push({id:Se.id,uuid:Se.uuid,version:Se.version}),he=he&&!!Se.hasPreRelease&&!W}if(!me.length&&!de.length)return[];let pe=new N().withPage(1,L.length);me.length&&(pe=pe.withFilter(o.ExtensionId,...me)),de.length&&(pe=pe.withFilter(o.ExtensionName,...de)),(ne.queryAllVersions||he)&&(pe=pe.withFlags(pe.flags,i.IncludeVersions)),ne.source&&(pe=pe.withSource(ne.source));const{extensions:ve}=await this.z(pe,{targetPlatform:ne.targetPlatform??n,includePreRelease:$e,versions:we,compatible:!!ne.compatible,productVersion:ne.productVersion??{version:this.u.version,date:this.u.date}},ce);return ne.source&&ve.forEach((Se,W)=>M(Se,W,ne.source)),ve}async getCompatibleExtension(L,K,Q,ne={version:this.u.version,date:this.u.date}){if((0,h.$fp)(L.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(L,K,Q))return L;const ce=new N().withFlags(i.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,L.identifier.uuid),{extensions:de}=await this.z(ce,{targetPlatform:Q,compatible:!0,includePreRelease:K,productVersion:ne},P.CancellationToken.None);return de[0]||null}async isExtensionCompatible(L,K,Q,ne={version:this.u.version,date:this.u.date}){if(!(0,h.$gp)(L.properties.targetPlatform,L.allTargetPlatforms,Q)||!K&&L.properties.isPreReleaseVersion)return!1;let ce=L.properties.engine;if(!ce){const de=await this.getManifest(L,P.CancellationToken.None);if(!de)throw new Error("Manifest was not found");ce=de.engines.vscode}return!(!(0,p.$3p)(ce,ne.version,ne.date)||!(0,p.$4p)(L.properties.enabledApiProposals??[]))}async y(L,K,Q,ne,ce,de,me={version:this.u.version,date:this.u.date}){if(!(0,h.$gp)(Z(K),ce,de)||Q!=="any"&&fe(K)!==(Q==="prerelease"))return!1;if(ne)try{const $e=await this.E(L,K);if(!(0,p.$3p)($e,me.version,me.date))return!1}catch($e){return this.l.error(`Error while getting the engine for the version ${K.version}.`,(0,w.$_)($e)),!1}return!0}async query(L,K){let Q=L.text||"";const ne=L.pageSize??50;let ce=new N().withPage(1,ne);Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,ve)=>(ce=ce.withFilter(o.Category,ve||pe),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,ve)=>(ce=ce.withFilter(o.Tag,ve||pe),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(ce=ce.withFilter(o.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),ce=ce.withFilter(o.SearchText,Q)),ce=ce.withSortBy(h.SortBy.NoneOrRelevance)):L.ids?ce=ce.withFilter(o.ExtensionId,...L.ids):L.names?ce=ce.withFilter(o.ExtensionName,...L.names):ce=ce.withSortBy(h.SortBy.InstallCount),typeof L.sortBy=="number"&&(ce=ce.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(ce=ce.withSortOrder(L.sortOrder)),L.source&&(ce=ce.withSource(L.source));const de=async(he,pe)=>{const{extensions:ve,total:Se}=await this.z(he,{targetPlatform:n,compatible:!1,includePreRelease:!!L.includePreRelease,productVersion:L.productVersion??{version:this.u.version,date:this.u.date}},pe);return ve.forEach((W,ee)=>M(W,(he.pageNumber-1)*he.pageSize+ee,L.source)),{extensions:ve,total:Se}},{extensions:me,total:$e}=await de(ce,K),we=async(he,pe)=>{if(pe.isCancellationRequested)throw new w.$7;const{extensions:ve}=await de(ce.withPage(he+1),pe);return ve};return{firstPage:me,total:$e,pageSize:ce.pageSize,getPage:we}}async z(L,K,Q){const ne=L.flags;L.flags&i.IncludeLatestVersionOnly&&L.flags&i.IncludeVersions&&(L=L.withFlags(L.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(L.flags&i.IncludeLatestVersionOnly)&&!(L.flags&i.IncludeVersions)&&(L=L.withFlags(L.flags,i.IncludeLatestVersionOnly)),K.versions?.length&&(L=L.withFlags(L.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),L=L.withFlags(L.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:ce,total:de,context:me}=await this.B(L,Q);if(!(L.flags&i.IncludeLatestVersionOnly)){const pe=[];for(const ve of ce){const Se=await this.A(ve,K,me);Se&&pe.push(Se)}return{extensions:pe,total:de}}const we=[],he=new Map;for(let pe=0;pe<ce.length;pe++){const ve=ce[pe],Se={id:(0,u.$Op)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},W=(0,I.$lg)(K.includePreRelease)?K.includePreRelease:!!K.includePreRelease.find(ie=>(0,u.$Jp)(ie,Se))?.includePreRelease;if(K.compatible&&(0,h.$fp)(te(ve),K.targetPlatform))continue;const ee=await this.A(ve,K,me);!ee||ee.properties.isPreReleaseVersion&&(!W||!ee.hasReleaseVersion)||!ee.properties.isPreReleaseVersion&&ee.properties.targetPlatform!==K.targetPlatform&&ee.hasPreReleaseVersion?he.set(ve.extensionId,pe):we.push([pe,ee])}if(he.size){const pe=new a.$ge,ve=new N().withFlags(ne&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,he.size).withFilter(o.ExtensionId,...he.keys()),{extensions:Se}=await this.z(ve,K,Q);this.o.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:he.size});for(const W of Se){const ee=he.get(W.identifier.uuid);we.push([ee,W])}}return{extensions:we.sort((pe,ve)=>pe[0]-ve[0]).map(([,pe])=>pe),total:de}}async A(L,K,Q){const ne={id:(0,u.$Op)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},ce=K.versions?.find(we=>(0,u.$Jp)(we,ne))?.version,de=(0,I.$lg)(K.includePreRelease)?K.includePreRelease:!!K.includePreRelease.find(we=>(0,u.$Jp)(we,ne))?.includePreRelease,me=te(L),$e=F(L.versions,K.targetPlatform);if(K.compatible&&(0,h.$fp)(me,K.targetPlatform))return null;for(let we=0;we<$e.length;we++){const he=$e[we];if(!(ce&&he.version!==ce)){if(await this.y((0,u.$Op)(L.publisher.publisherName,L.extensionName),he,de?"any":"release",K.compatible,me,K.targetPlatform,K.productVersion))return K.compatible&&!(0,p.$4p)(x(he))?null:J(L,he,me,Q);if(ce&&he.version===ce)return null}}return ce||K.compatible?null:J(L,L.versions[0],me)}async B(L,K){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,i.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,s(i.Unpublished));const Q=await this.j,ne=JSON.stringify(L.raw),ce={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ne.length)},de=new a.$ge;let me,$e,we=0;try{if(me=await this.k.request({type:"POST",url:this.g&&L.criteria.some(pe=>pe.filterType===o.SearchText)?this.g:this.x("/extensionquery"),data:ne,headers:ce},K),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:we};const he=await(0,m.$$p)(me);if(he){const pe=he.results[0],ve=pe.extensions,Se=pe.resultMetadata&&pe.resultMetadata.filter(W=>W.metadataType==="ResultCount")[0];return we=Se&&Se.metadataItems.filter(W=>W.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:we,context:{[r]:me.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(he){if((0,w.$6)(he))throw $e=h.ExtensionGalleryErrorCode.Cancelled,he;{const pe=(0,w.$_)(he);throw $e=pe.startsWith("XHR timeout")?h.ExtensionGalleryErrorCode.Timeout:h.ExtensionGalleryErrorCode.Failed,new h.$jp(pe,$e)}}finally{this.o.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String(ne.length),duration:de.elapsed(),success:!!me&&(0,m.$7p)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:$e,count:String(we)})}}async reportStatistic(L,K,Q,ne){if(!this.isEnabled())return;const ce=O.$o?this.x(`/itemName/${L}.${K}/version/${Q}/statType/${ne===h.StatisticType.Install?"1":"3"}/vscodewebextension`):this.x(`/publishers/${L}/extensions/${K}/${Q}/stats?statType=${ne}`),de=O.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",$e={...await this.j,Accept:de};try{await this.k.request({type:"POST",url:ce,headers:$e},P.CancellationToken.None)}catch{}}async download(L,K,Q){this.l.trace("ExtensionGalleryService#download",L.identifier.id);const ne=(0,u.$Rp)(L),ce=new Date().getTime(),de=Q===h.InstallOperation.Install?"install":Q===h.InstallOperation.Update?"update":"",me=de?{uri:`${L.assets.download.uri}${g.URI.parse(L.assets.download.uri).query?"&":"?"}${de}=true`,fallbackUri:`${L.assets.download.fallbackUri}${g.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${de}=true`}:L.assets.download,$e=L.queryContext?.[r]?{[r]:L.queryContext[r]}:void 0,we=await this.D(L.identifier.id,me,f.VSIX,$e?{headers:$e}:void 0);try{await this.q.writeFile(K,we.stream)}catch(he){try{await this.q.del(K)}catch(pe){this.l.warn(`Error while deleting the file ${K.toString()}`,(0,w.$_)(pe))}throw new h.$jp((0,w.$_)(he),h.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.o.publicLog("galleryService:downloadVSIX",{...ne,duration:new Date().getTime()-ce})}async downloadSignatureArchive(L,K){if(!L.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",L.identifier.id);const Q=await this.D(L.identifier.id,L.assets.signature,f.Signature);try{await this.q.writeFile(K,Q.stream)}catch(ne){try{await this.q.del(K)}catch(ce){this.l.warn(`Error while deleting the file ${K.toString()}`,(0,w.$_)(ce))}throw new h.$jp((0,w.$_)(ne),h.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(L,K){if(L.assets.readme){const Q=await this.D(L.identifier.id,L.assets.readme,f.Details,{},K);return await(0,m.$0p)(Q)||""}return""}async getManifest(L,K){if(L.assets.manifest){const Q=await this.D(L.identifier.id,L.assets.manifest,f.Manifest,{},K),ne=await(0,m.$0p)(Q);return ne?JSON.parse(ne):null}return null}async C(L,K,Q){const ne=se(K,f.Manifest);if(!ne)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},de=await this.D(L,ne,f.Manifest,{headers:ce});return await(0,m.$$p)(de)}async getCoreTranslation(L,K){const Q=L.assets.coreTranslations.filter(ne=>ne[0]===K.toUpperCase())[0];if(Q){const ne=await this.D(L.identifier.id,Q[1],Q[0]),ce=await(0,m.$0p)(ne);return ce?JSON.parse(ce):null}return null}async getChangelog(L,K){if(L.assets.changelog){const Q=await this.D(L.identifier.id,L.assets.changelog,f.Changelog,{},K);return await(0,m.$0p)(Q)||""}return""}async getAllCompatibleVersions(L,K,Q){let ne=new N().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?ne=ne.withFilter(o.ExtensionId,L.identifier.uuid):ne=ne.withFilter(o.ExtensionName,L.identifier.id);const{galleryExtensions:ce}=await this.B(ne,P.CancellationToken.None);if(!ce.length)return[];const de=te(ce[0]);if((0,h.$fp)(de,Q))return[];const me=[];await Promise.all(ce[0].versions.map(async he=>{try{await this.y(L.identifier.id,he,K?"any":"release",!0,de,Q)&&(0,p.$4p)(x(he))&&me.push(he)}catch{}}));const $e=[],we=new Set;for(const he of F(me,Q))we.has(he.version)||(we.add(he.version),$e.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:fe(he)}));return $e}async D(L,K,Q,ne={},ce=P.CancellationToken.None){const de=await this.j,me={type:"GET"},$e={...de,...ne.headers||{}};ne={...ne,...me,headers:$e};const we=K.uri,he=K.fallbackUri,pe={...ne,url:we};try{const ve=await this.k.request(pe,ce);if(ve.res.statusCode===200)return ve;const Se=await(0,m.$0p)(ve);throw new Error(`Expected 200, got back ${ve.res.statusCode} instead.

${Se}`)}catch(ve){if((0,w.$6)(ve))throw ve;const Se=(0,w.$_)(ve);this.o.publicLog2("galleryService:cdnFallback",{extension:L,assetType:Q,message:Se});const W={...ne,url:he};return this.k.request(W,ce)}}async E(L,K){let Q=ue(K);if(!Q){this.o.publicLog2("galleryService:engineFallback",{extension:L,version:K.version});const ne=await this.C(L,K,P.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");Q=ne.engines.vscode}return Q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const L=await this.k.request({type:"GET",url:this.h},P.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const K=await(0,m.$$p)(L),Q=[],ne={},ce=[];if(K){for(const de of K.malicious)Q.push({id:de});if(K.migrateToPreRelease)for(const[de,me]of Object.entries(K.migrateToPreRelease))(!me.engine||(0,p.$3p)(me.engine,this.u.version,this.u.date))&&(ne[de.toLowerCase()]={disallowInstall:!0,extension:{id:me.id,displayName:me.displayName,autoMigrate:{storage:!!me.migrateStorage},preRelease:!0}});if(K.deprecated)for(const[de,me]of Object.entries(K.deprecated))me&&(ne[de.toLowerCase()]=(0,I.$lg)(me)?{}:me);if(K.search)for(const de of K.search)ce.push(de)}return{malicious:Q,deprecated:ne,search:ce}}};B=ye([re(1,m.$5p),re(2,v.$_j),re(3,c.$Mi),re(4,e.$$l),re(5,R.$_k),re(6,d.$sk),re(7,l.$_i)],B);let S=class extends B{constructor(L,K,Q,ne,ce,de,me,$e){super(L,K,Q,ne,ce,de,me,$e)}};t.$oq=S,t.$oq=S=ye([re(0,y.$fq),re(1,m.$5p),re(2,v.$_j),re(3,c.$Mi),re(4,e.$$l),re(5,R.$_k),re(6,d.$sk),re(7,l.$_i)],S);let U=class extends B{constructor(L,K,Q,ne,ce,de,me){super(void 0,L,K,Q,ne,ce,de,me)}};t.$pq=U,t.$pq=U=ye([re(0,m.$5p),re(1,v.$_j),re(2,c.$Mi),re(3,e.$$l),re(4,R.$_k),re(5,d.$sk),re(6,l.$_i)],U)}),define(oe[169],ae([0,1,12,18,10,6,148,24,25,3,69]),function(H,t,E,P,w,O,A,I,g,l,c){"use strict";var h,u;Object.defineProperty(t,"__esModule",{value:!0}),t.$mR=t.$lR=t.$kR=void 0;let $=class extends g.$Ol{static{h=this}static{this.a="profileAssociationsMigration"}constructor(d,m,k,y,e){super(k,y,m,e),this.U=d,this.W=k}O(){return this.U.getItem(h.b,[]).map(m=>({...m,location:(0,l.$fg)(m.location)?this.w.extUri.joinPath(this.profilesHome,m.location):E.URI.revive(m.location)}))}Q(){const d=this.U.getItem(h.c,{});return this.U.getItem(h.a,!1)?d:this.N(d)}S(){return this.w.extUri.joinPath(E.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};t.$kR=$,t.$kR=$=h=ye([re(0,A.$fR),re(1,I.$Jl),re(2,P.$Ni),re(3,w.$_k),re(4,O.$_j)],$);let p=u=class extends ${constructor(d,m,k,y,e){super(d,m,k,y,e),this.$=d}P(d){d.length?this.$.setItem(u.b,d.map(m=>({...m,location:this.w.extUri.basename(m.location)}))):this.$.removeItem(u.b)}O(){const d=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(d),this.$.setItem("userDataProfilesMigration",!0)),d}R(d){d.emptyWindows||d.workspaces?this.$.setItem(u.c,d):this.$.removeItem(u.c)}Q(){const d="workspaceAndProfileInfo",m=this.$.getItem(d,void 0);if(m){this.$.removeItem(d);const y=m.reduce((e,{workspace:a,profile:n})=>(e[E.URI.revive(a).toString()]=E.URI.revive(n).toString(),e),{});this.$.setItem(u.c,{workspaces:y})}const k=super.Q();return this.$.getItem(u.a,!1)||(this.R(k),this.$.setItem(u.a,!0)),k}};t.$lR=p,t.$lR=p=u=ye([re(0,A.$gR),re(1,I.$Jl),re(2,P.$Ni),re(3,w.$_k),re(4,O.$_j)],p);let R=class extends p{constructor(d,m,k,y){super(new c.$jR(c.SaveStrategy.IMMEDIATE,m,y,k),d,m,k,y)}async init(){return await this.$.init(),super.init()}};t.$mR=R,t.$mR=R=ye([re(0,I.$Jl),re(1,P.$Ni),re(2,w.$_k),re(3,O.$_j)],R)}),define(oe[170],ae([0,1,146,8,14,9,3,30,18,147,6,46,145,181]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cs=void 0,t.$ds=v;let p=class extends h.$6p{constructor(m,k,y,e){super(e),this.m=m,this.n=k,this.r=y,this.s(),this.B(m.onDidChangeConfiguration(a=>{a.affectsConfiguration("http")&&this.s()}))}s(){const m=this.m.getValue("http");this.f=m?.proxy,this.g=!!m?.proxyStrictSSL,this.h=m?.proxyAuthorization}async request(m,k){const{f:y,g:e}=this;let a;try{a=await(0,l.$Qm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,O.$_)(i)))}const n={...process.env,...a},r=m.agent?m.agent:await(0,u.$bs)(m.url||"",n,{proxyUrl:y,strictSSL:e});return m.agent=r,m.strictSSL=e,this.h&&(m.headers={...m.headers||{},"Proxy-Authorization":this.h}),this.c(m.isChromiumNetwork?"electron":"node",m,()=>v(m,k))}async resolveProxy(m){}async loadCertificates(){return(await new Promise((k,y)=>{H(["@vscode/proxy-agent"],k,y)}).then(be)).loadSystemCertificates({log:this.r})}};t.$cs=p,t.$cs=p=ye([re(0,I.$_i),re(1,g.$Ni),re(2,c.$_j),re(3,c.$ak)],p);async function R(d){return((0,E.parse)(d.url).protocol==="https:"?await new Promise((y,e)=>{H(["https"],y,e)}).then(be):await new Promise((y,e)=>{H(["http"],y,e)}).then(be)).request}async function v(d,m){return P.Promises.withAsyncBody(async(k,y)=>{const e=(0,E.parse)(d.url),a=d.getRawRequest?d.getRawRequest(d):await R(d),n={hostname:e.hostname,port:e.port?parseInt(e.port):e.protocol==="https:"?443:80,protocol:e.protocol,path:e.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,A.$lg)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(n.auth=d.user+":"+d.password);const r=a(n,i=>{const s=(0,A.$jg)(d.followRedirects)?d.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)v({...d,url:i.headers.location,followRedirects:s-1},m).then(k,y);else{let o=i;!d.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,$.createGunzip)())),k({res:i,stream:(0,w.$4e)(o)})}});r.on("error",y),d.timeout&&r.setTimeout(d.timeout),d.isChromiumNetwork&&r.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&r.write(d.data),r.end(),m.onCancellationRequested(()=>{r.abort(),y(new O.$7)})})}});var Me=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(oe[182],ae([0,1,35,8,38,9,2,15,16,13,36,12,26,30,142,61,144,18,120,168,21,71,149,42,54,163,165,10,132,134,51,130,64,68,151,6,138,39,139,154,33,46,170,69,70,19,153,41,155,156,24,158,25,169,157,164,135,137,4,159,183]),function(H,t,E,P,w,O,A,I,g,l,c,h,u,$,p,R,v,d,m,k,y,e,a,n,r,i,s,o,f,b,D,T,N,C,z,X,Y,se,le,ue,fe,x,_,V,q,G,Z,te,F,M,J,B,S,U,j,L,K,Q,ne,ce,de){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=$e,ue=Me(ue);class me extends A.$Wc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,pe]=await this.f();return he.invokeFunction(async ve=>{const Se=ve.get(X.$_j),W=ve.get(o.$_k),ee=ve.get(d.$Ni),ie=ve.get(S.$Ll);Se.info("CLI main",this.b),this.h(Se),await this.j(ee,W,ie,he),await Promise.all(pe.map(ge=>{(0,P.$wh)(ge.flush(),1e3)}))})}async f(){const he=new N.$Di,pe={_serviceBrand:void 0,...ue.default};he.set(fe.$sk,pe);const ve=new m.$8m(this.b,pe);he.set(d.$Ni,ve),await Promise.all([this.g(ve.appSettingsHome.with({scheme:I.Schemas.file}).fsPath),this.g(ve.extensionsPath)].map(Ie=>Ie?u.Promises.mkdir(Ie,{recursive:!0}):void 0));const Se=new Q.$eR((0,X.$nk)(ve),ve.logsHome);he.set(X.$ak,Se);const W=this.B(Se.createLogger("cli",{name:(0,ne.localize)(0,null)})),ee=[];Se.getLogLevel()===X.LogLevel.Trace&&ee.push(new X.$hk(Se.getLogLevel()));const ie=this.B(new K.$oR(W,ee));he.set(X.$_j,ie);const ge=this.B(new f.$Zq(ie));he.set(o.$_k,ge);const Ee=this.B(new b.$qr(ie));ge.registerProvider(I.Schemas.file,Ee);const Ae=new B.$Rs(ge);he.set(J.$Jl,Ae);const ke=new V.$iR(V.SaveStrategy.DELAYED,ve,ie,ge),Le=new U.$kR(ke,Ae,ve,ge,ie);he.set(S.$Ll,Le),ge.registerProvider(I.Schemas.vscodeUserData,new ce.$Bgc(I.Schemas.file,Ee,I.Schemas.vscodeUserData,Le,Ae,ie));const Re=l.$i&&pe.win32RegValueName?this.B(new le.$zgc(ie,pe.win32RegValueName)):ve.policyFile?this.B(new Y.$Agc(ve.policyFile,ge,ie)):new se.$uo;he.set(se.$so,Re);const Ce=this.B(new p.$Uo(Le.defaultProfile.settingsResource,ge,Re,ie));he.set($.$_i,Ce),await Promise.all([ke.init(),Ce.initialize()]);let qe;try{qe=await(0,j.$bgc)(ke,ie)}catch(Ie){Ie.code!=="ENOENT"&&ie.error(Ie)}const Ne=await(0,j.$cgc)(ke,ie),Te=await(0,j.$dgc)(ke,ie);Le.init(),he.set(J.$Jl,new B.$Rs(ge));const Fe=new _.$cs(Ce,ve,ie,Se);he.set(x.$5p,Fe),he.set(R.$Yo,new D.$Ci(v.$DR,void 0,!0)),he.set(n.$Gq,new D.$Ci(L.$nR,void 0,!0)),he.set(r.$Kq,new D.$Ci(s.$$fc,void 0,!0)),he.set(e.$qq,new D.$Ci(e.$sq,void 0,!0)),he.set(i.$Vq,new D.$Ci(i.$Wq,void 0,!0)),he.set(y.$ip,new D.$Ci(k.$pq,void 0,!0)),he.set(C.$9r,new D.$Ci(z.$$r,void 0,!1));const Ue=[],Pe=(0,te.$Gp)(pe,Ce);if((0,te.$Bp)(pe,ve)){pe.aiConfig&&pe.aiConfig.ariaKey&&Ue.push(new F.$cR(Fe,Pe,"monacoworkbench",null,pe.aiConfig.ariaKey));const Ie={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,q.$sp)((0,E.release)(),(0,E.hostname)(),process.arch,pe.commit,pe.version,qe,Ne,Te,Pe),piiPaths:(0,te.$Hp)(ve)};he.set(G.$$l,new D.$Ci(Z.$es,[Ie],!1))}else he.set(G.$$l,te.$wp);return[new T.$tr(he),Ue]}g(he){if(l.$i){const pe=(0,de.getUNCHost)(he);pe&&(0,de.addUNCHostToAllowlist)(pe)}return he}h(he){(0,O.setUnexpectedErrorHandler)(pe=>{const ve=(0,w.$qj)(pe,!0);ve&&he.error(`[uncaught exception in CLI]: ${ve}`)}),process.on("uncaughtException",pe=>{(0,O.$2)(pe)||(0,O.$3)(pe)}),process.on("unhandledRejection",pe=>(0,O.$3)(pe))}async j(he,pe,ve,Se){let W;if(he.args.profile&&(W=ve.profiles.find(ie=>ie.name===he.args.profile),!W))throw new Error(`Profile '${he.args.profile}' not found.`);const ee=(W??ve.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(a.$tq,new X.$hk(X.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,ee);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ie={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:ee};return Se.createInstance(a.$tq,new X.$hk(X.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ie,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(a.$tq,new X.$hk(X.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,ee);if(this.b["update-extensions"])return Se.createInstance(a.$tq,new X.$hk(X.LogLevel.Info,!1)).updateExtensions(ee);if(this.b["locate-extension"])return Se.createInstance(a.$tq,new X.$hk(X.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,M.$Rgc)(he.appRoot,he.extensionsPath))}}m(he){return he.map(pe=>/\.vsix$/i.test(pe)?h.URI.file((0,g.$kc)(pe)?pe:(0,g.$lc)((0,c.cwd)(),pe)):pe)}}async function $e(we){const he=new me(we);try{await he.run()}finally{he.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/6afc1c279374106ca4c60382c0d92ed661f4c7e4/core/vs/code/node/cliProcessMain.js.map
